/**
 * vis-graph3d
 * https://visjs.github.io/vis-graph3d/
 *
 * Create interactive, animated 3d graphs. Surfaces, lines, dots and block styling out of the box.
 *
 * @version 6.0.3
 * @date    2023-03-21T17:16:02.802Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports):"function"==typeof define&&define.amd?define(["exports"],e):e((t="undefined"!=typeof globalThis?globalThis:t||self).vis=t.vis||{})}(this,(function(t){"use strict";var e="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function r(t){return t&&t.__esModule&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t}function n(t){if(t.__esModule)return t;var e=t.default;if("function"==typeof e){var r=function t(){if(this instanceof t){var r=[null];return r.push.apply(r,arguments),new(Function.bind.apply(e,r))}return e.apply(this,arguments)};r.prototype=e.prototype}else r={};return Object.defineProperty(r,"__esModule",{value:!0}),Object.keys(t).forEach((function(e){var n=Object.getOwnPropertyDescriptor(t,e);Object.defineProperty(r,e,n.get?n:{enumerable:!0,get:function(){return t[e]}})})),r}var i={},o={},a={get exports(){return o},set exports(t){o=t}},s=function(t){try{return!!t()}catch(t){return!0}},u=!s((function(){var t=function(){}.bind();return"function"!=typeof t||t.hasOwnProperty("prototype")})),l=u,c=Function.prototype,h=c.call,f=l&&c.bind.bind(h,h),p=l?f:function(t){return function(){return h.apply(t,arguments)}},d=Math.ceil,v=Math.floor,g=Math.trunc||function(t){var e=+t;return(e>0?v:d)(e)},y=function(t){var e=+t;return e!=e||0===e?0:g(e)},m=function(t){return t&&t.Math==Math&&t},b=m("object"==typeof globalThis&&globalThis)||m("object"==typeof window&&window)||m("object"==typeof self&&self)||m("object"==typeof e&&e)||function(){return this}()||Function("return this")(),x={},w={get exports(){return x},set exports(t){x=t}},_=b,k=Object.defineProperty,C=function(t,e){try{k(_,t,{value:e,configurable:!0,writable:!0})}catch(r){_[t]=e}return e},E="__core-js_shared__",S=b[E]||C(E,{}),T=S;(w.exports=function(t,e){return T[t]||(T[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.29.0",mode:"pure",copyright:"© 2014-2023 Denis Pushkarev (zloirock.ru)",license:"https://github.com/zloirock/core-js/blob/v3.29.0/LICENSE",source:"https://github.com/zloirock/core-js"});var O,P,A=function(t){return null==t},D=A,L=TypeError,R=function(t){if(D(t))throw L("Can't call method on "+t);return t},F=R,M=Object,j=function(t){return M(F(t))},I=j,z=p({}.hasOwnProperty),B=Object.hasOwn||function(t,e){return z(I(t),e)},N=p,W=0,G=Math.random(),Y=N(1..toString),V=function(t){return"Symbol("+(void 0===t?"":t)+")_"+Y(++W+G,36)},X="undefined"!=typeof navigator&&String(navigator.userAgent)||"",U=b,H=X,q=U.process,Z=U.Deno,$=q&&q.versions||Z&&Z.version,Q=$&&$.v8;Q&&(P=(O=Q.split("."))[0]>0&&O[0]<4?1:+(O[0]+O[1])),!P&&H&&(!(O=H.match(/Edge\/(\d+)/))||O[1]>=74)&&(O=H.match(/Chrome\/(\d+)/))&&(P=+O[1]);var K=P,J=K,tt=s,et=!!Object.getOwnPropertySymbols&&!tt((function(){var t=Symbol();return!String(t)||!(Object(t)instanceof Symbol)||!Symbol.sham&&J&&J<41})),rt=et&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,nt=x,it=B,ot=V,at=et,st=rt,ut=b.Symbol,lt=nt("wks"),ct=st?ut.for||ut:ut&&ut.withoutSetter||ot,ht=function(t){return it(lt,t)||(lt[t]=at&&it(ut,t)?ut[t]:ct("Symbol."+t)),lt[t]},ft={};ft[ht("toStringTag")]="z";var pt="[object z]"===String(ft),dt="object"==typeof document&&document.all,vt={all:dt,IS_HTMLDDA:void 0===dt&&void 0!==dt},gt=vt.all,yt=vt.IS_HTMLDDA?function(t){return"function"==typeof t||t===gt}:function(t){return"function"==typeof t},mt=p,bt=mt({}.toString),xt=mt("".slice),wt=function(t){return xt(bt(t),8,-1)},_t=pt,kt=yt,Ct=wt,Et=ht("toStringTag"),St=Object,Tt="Arguments"==Ct(function(){return arguments}()),Ot=_t?Ct:function(t){var e,r,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(r=function(t,e){try{return t[e]}catch(t){}}(e=St(t),Et))?r:Tt?Ct(e):"Object"==(n=Ct(e))&&kt(e.callee)?"Arguments":n},Pt=Ot,At=String,Dt=function(t){if("Symbol"===Pt(t))throw TypeError("Cannot convert a Symbol value to a string");return At(t)},Lt=p,Rt=y,Ft=Dt,Mt=R,jt=Lt("".charAt),It=Lt("".charCodeAt),zt=Lt("".slice),Bt=function(t){return function(e,r){var n,i,o=Ft(Mt(e)),a=Rt(r),s=o.length;return a<0||a>=s?t?"":void 0:(n=It(o,a))<55296||n>56319||a+1===s||(i=It(o,a+1))<56320||i>57343?t?jt(o,a):n:t?zt(o,a,a+2):i-56320+(n-55296<<10)+65536}},Nt={codeAt:Bt(!1),charAt:Bt(!0)},Wt=yt,Gt=b.WeakMap,Yt=Wt(Gt)&&/native code/.test(String(Gt)),Vt=yt,Xt=vt.all,Ut=vt.IS_HTMLDDA?function(t){return"object"==typeof t?null!==t:Vt(t)||t===Xt}:function(t){return"object"==typeof t?null!==t:Vt(t)},Ht=!s((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),qt={},Zt=Ut,$t=b.document,Qt=Zt($t)&&Zt($t.createElement),Kt=function(t){return Qt?$t.createElement(t):{}},Jt=Kt,te=!Ht&&!s((function(){return 7!=Object.defineProperty(Jt("div"),"a",{get:function(){return 7}}).a})),ee=Ht&&s((function(){return 42!=Object.defineProperty((function(){}),"prototype",{value:42,writable:!1}).prototype})),re=Ut,ne=String,ie=TypeError,oe=function(t){if(re(t))return t;throw ie(ne(t)+" is not an object")},ae=u,se=Function.prototype.call,ue=ae?se.bind(se):function(){return se.apply(se,arguments)},le={},ce=le,he=b,fe=yt,pe=function(t){return fe(t)?t:void 0},de=function(t,e){return arguments.length<2?pe(ce[t])||pe(he[t]):ce[t]&&ce[t][e]||he[t]&&he[t][e]},ve=p({}.isPrototypeOf),ge=de,ye=yt,me=ve,be=Object,xe=rt?function(t){return"symbol"==typeof t}:function(t){var e=ge("Symbol");return ye(e)&&me(e.prototype,be(t))},we=String,_e=function(t){try{return we(t)}catch(t){return"Object"}},ke=yt,Ce=_e,Ee=TypeError,Se=function(t){if(ke(t))return t;throw Ee(Ce(t)+" is not a function")},Te=Se,Oe=A,Pe=function(t,e){var r=t[e];return Oe(r)?void 0:Te(r)},Ae=ue,De=yt,Le=Ut,Re=TypeError,Fe=ue,Me=Ut,je=xe,Ie=Pe,ze=function(t,e){var r,n;if("string"===e&&De(r=t.toString)&&!Le(n=Ae(r,t)))return n;if(De(r=t.valueOf)&&!Le(n=Ae(r,t)))return n;if("string"!==e&&De(r=t.toString)&&!Le(n=Ae(r,t)))return n;throw Re("Can't convert object to primitive value")},Be=TypeError,Ne=ht("toPrimitive"),We=function(t,e){if(!Me(t)||je(t))return t;var r,n=Ie(t,Ne);if(n){if(void 0===e&&(e="default"),r=Fe(n,t,e),!Me(r)||je(r))return r;throw Be("Can't convert object to primitive value")}return void 0===e&&(e="number"),ze(t,e)},Ge=xe,Ye=function(t){var e=We(t,"string");return Ge(e)?e:e+""},Ve=Ht,Xe=te,Ue=ee,He=oe,qe=Ye,Ze=TypeError,$e=Object.defineProperty,Qe=Object.getOwnPropertyDescriptor,Ke="enumerable",Je="configurable",tr="writable";qt.f=Ve?Ue?function(t,e,r){if(He(t),e=qe(e),He(r),"function"==typeof t&&"prototype"===e&&"value"in r&&tr in r&&!r[tr]){var n=Qe(t,e);n&&n[tr]&&(t[e]=r.value,r={configurable:Je in r?r[Je]:n[Je],enumerable:Ke in r?r[Ke]:n[Ke],writable:!1})}return $e(t,e,r)}:$e:function(t,e,r){if(He(t),e=qe(e),He(r),Xe)try{return $e(t,e,r)}catch(t){}if("get"in r||"set"in r)throw Ze("Accessors not supported");return"value"in r&&(t[e]=r.value),t};var er,rr,nr,ir=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},or=qt,ar=ir,sr=Ht?function(t,e,r){return or.f(t,e,ar(1,r))}:function(t,e,r){return t[e]=r,t},ur=V,lr=x("keys"),cr=function(t){return lr[t]||(lr[t]=ur(t))},hr={},fr=Yt,pr=b,dr=Ut,vr=sr,gr=B,yr=S,mr=cr,br=hr,xr="Object already initialized",wr=pr.TypeError,_r=pr.WeakMap;if(fr||yr.state){var kr=yr.state||(yr.state=new _r);kr.get=kr.get,kr.has=kr.has,kr.set=kr.set,er=function(t,e){if(kr.has(t))throw wr(xr);return e.facade=t,kr.set(t,e),e},rr=function(t){return kr.get(t)||{}},nr=function(t){return kr.has(t)}}else{var Cr=mr("state");br[Cr]=!0,er=function(t,e){if(gr(t,Cr))throw wr(xr);return e.facade=t,vr(t,Cr,e),e},rr=function(t){return gr(t,Cr)?t[Cr]:{}},nr=function(t){return gr(t,Cr)}}var Er={set:er,get:rr,has:nr,enforce:function(t){return nr(t)?rr(t):er(t,{})},getterFor:function(t){return function(e){var r;if(!dr(e)||(r=rr(e)).type!==t)throw wr("Incompatible receiver, "+t+" required");return r}}},Sr=u,Tr=Function.prototype,Or=Tr.apply,Pr=Tr.call,Ar="object"==typeof Reflect&&Reflect.apply||(Sr?Pr.bind(Or):function(){return Pr.apply(Or,arguments)}),Dr=wt,Lr=p,Rr=function(t){if("Function"===Dr(t))return Lr(t)},Fr={},Mr={},jr={}.propertyIsEnumerable,Ir=Object.getOwnPropertyDescriptor,zr=Ir&&!jr.call({1:2},1);Mr.f=zr?function(t){var e=Ir(this,t);return!!e&&e.enumerable}:jr;var Br=s,Nr=wt,Wr=Object,Gr=p("".split),Yr=Br((function(){return!Wr("z").propertyIsEnumerable(0)}))?function(t){return"String"==Nr(t)?Gr(t,""):Wr(t)}:Wr,Vr=Yr,Xr=R,Ur=function(t){return Vr(Xr(t))},Hr=Ht,qr=ue,Zr=Mr,$r=ir,Qr=Ur,Kr=Ye,Jr=B,tn=te,en=Object.getOwnPropertyDescriptor;Fr.f=Hr?en:function(t,e){if(t=Qr(t),e=Kr(e),tn)try{return en(t,e)}catch(t){}if(Jr(t,e))return $r(!qr(Zr.f,t,e),t[e])};var rn=s,nn=yt,on=/#|\.prototype\./,an=function(t,e){var r=un[sn(t)];return r==cn||r!=ln&&(nn(e)?rn(e):!!e)},sn=an.normalize=function(t){return String(t).replace(on,".").toLowerCase()},un=an.data={},ln=an.NATIVE="N",cn=an.POLYFILL="P",hn=an,fn=Se,pn=u,dn=Rr(Rr.bind),vn=function(t,e){return fn(t),void 0===e?t:pn?dn(t,e):function(){return t.apply(e,arguments)}},gn=b,yn=Ar,mn=Rr,bn=yt,xn=Fr.f,wn=hn,_n=le,kn=vn,Cn=sr,En=B,Sn=function(t){var e=function(r,n,i){if(this instanceof e){switch(arguments.length){case 0:return new t;case 1:return new t(r);case 2:return new t(r,n)}return new t(r,n,i)}return yn(t,this,arguments)};return e.prototype=t.prototype,e},Tn=function(t,e){var r,n,i,o,a,s,u,l,c,h=t.target,f=t.global,p=t.stat,d=t.proto,v=f?gn:p?gn[h]:(gn[h]||{}).prototype,g=f?_n:_n[h]||Cn(_n,h,{})[h],y=g.prototype;for(o in e)n=!(r=wn(f?o:h+(p?".":"#")+o,t.forced))&&v&&En(v,o),s=g[o],n&&(u=t.dontCallGetSet?(c=xn(v,o))&&c.value:v[o]),a=n&&u?u:e[o],n&&typeof s==typeof a||(l=t.bind&&n?kn(a,gn):t.wrap&&n?Sn(a):d&&bn(a)?mn(a):a,(t.sham||a&&a.sham||s&&s.sham)&&Cn(l,"sham",!0),Cn(g,o,l),d&&(En(_n,i=h+"Prototype")||Cn(_n,i,{}),Cn(_n[i],o,a),t.real&&y&&(r||!y[o])&&Cn(y,o,a)))},On=Ht,Pn=B,An=Function.prototype,Dn=On&&Object.getOwnPropertyDescriptor,Ln=Pn(An,"name"),Rn={EXISTS:Ln,PROPER:Ln&&"something"===function(){}.name,CONFIGURABLE:Ln&&(!On||On&&Dn(An,"name").configurable)},Fn={},Mn=y,jn=Math.max,In=Math.min,zn=function(t,e){var r=Mn(t);return r<0?jn(r+e,0):In(r,e)},Bn=y,Nn=Math.min,Wn=function(t){return t>0?Nn(Bn(t),9007199254740991):0},Gn=function(t){return Wn(t.length)},Yn=Ur,Vn=zn,Xn=Gn,Un=function(t){return function(e,r,n){var i,o=Yn(e),a=Xn(o),s=Vn(n,a);if(t&&r!=r){for(;a>s;)if((i=o[s++])!=i)return!0}else for(;a>s;s++)if((t||s in o)&&o[s]===r)return t||s||0;return!t&&-1}},Hn={includes:Un(!0),indexOf:Un(!1)},qn=B,Zn=Ur,$n=Hn.indexOf,Qn=hr,Kn=p([].push),Jn=function(t,e){var r,n=Zn(t),i=0,o=[];for(r in n)!qn(Qn,r)&&qn(n,r)&&Kn(o,r);for(;e.length>i;)qn(n,r=e[i++])&&(~$n(o,r)||Kn(o,r));return o},ti=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],ei=Jn,ri=ti,ni=Object.keys||function(t){return ei(t,ri)},ii=Ht,oi=ee,ai=qt,si=oe,ui=Ur,li=ni;Fn.f=ii&&!oi?Object.defineProperties:function(t,e){si(t);for(var r,n=ui(e),i=li(e),o=i.length,a=0;o>a;)ai.f(t,r=i[a++],n[r]);return t};var ci,hi=de("document","documentElement"),fi=oe,pi=Fn,di=ti,vi=hr,gi=hi,yi=Kt,mi="prototype",bi="script",xi=cr("IE_PROTO"),wi=function(){},_i=function(t){return"<"+bi+">"+t+"</"+bi+">"},ki=function(t){t.write(_i("")),t.close();var e=t.parentWindow.Object;return t=null,e},Ci=function(){try{ci=new ActiveXObject("htmlfile")}catch(t){}var t,e,r;Ci="undefined"!=typeof document?document.domain&&ci?ki(ci):(e=yi("iframe"),r="java"+bi+":",e.style.display="none",gi.appendChild(e),e.src=String(r),(t=e.contentWindow.document).open(),t.write(_i("document.F=Object")),t.close(),t.F):ki(ci);for(var n=di.length;n--;)delete Ci[mi][di[n]];return Ci()};vi[xi]=!0;var Ei,Si,Ti,Oi=Object.create||function(t,e){var r;return null!==t?(wi[mi]=fi(t),r=new wi,wi[mi]=null,r[xi]=t):r=Ci(),void 0===e?r:pi.f(r,e)},Pi=!s((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),Ai=B,Di=yt,Li=j,Ri=Pi,Fi=cr("IE_PROTO"),Mi=Object,ji=Mi.prototype,Ii=Ri?Mi.getPrototypeOf:function(t){var e=Li(t);if(Ai(e,Fi))return e[Fi];var r=e.constructor;return Di(r)&&e instanceof r?r.prototype:e instanceof Mi?ji:null},zi=sr,Bi=function(t,e,r,n){return n&&n.enumerable?t[e]=r:zi(t,e,r),t},Ni=s,Wi=yt,Gi=Ut,Yi=Oi,Vi=Ii,Xi=Bi,Ui=ht("iterator"),Hi=!1;[].keys&&("next"in(Ti=[].keys())?(Si=Vi(Vi(Ti)))!==Object.prototype&&(Ei=Si):Hi=!0);var qi=!Gi(Ei)||Ni((function(){var t={};return Ei[Ui].call(t)!==t}));Wi((Ei=qi?{}:Yi(Ei))[Ui])||Xi(Ei,Ui,(function(){return this}));var Zi={IteratorPrototype:Ei,BUGGY_SAFARI_ITERATORS:Hi},$i=Ot,Qi=pt?{}.toString:function(){return"[object "+$i(this)+"]"},Ki=pt,Ji=qt.f,to=sr,eo=B,ro=Qi,no=ht("toStringTag"),io=function(t,e,r,n){if(t){var i=r?t:t.prototype;eo(i,no)||Ji(i,no,{configurable:!0,value:e}),n&&!Ki&&to(i,"toString",ro)}},oo={},ao=Zi.IteratorPrototype,so=Oi,uo=ir,lo=io,co=oo,ho=function(){return this},fo=p,po=Se,vo=yt,go=String,yo=TypeError,mo=function(t,e,r){try{return fo(po(Object.getOwnPropertyDescriptor(t,e)[r]))}catch(t){}},bo=oe,xo=function(t){if("object"==typeof t||vo(t))return t;throw yo("Can't set "+go(t)+" as a prototype")},wo=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,r={};try{(t=mo(Object.prototype,"__proto__","set"))(r,[]),e=r instanceof Array}catch(t){}return function(r,n){return bo(r),xo(n),e?t(r,n):r.__proto__=n,r}}():void 0),_o=Tn,ko=ue,Co=function(t,e,r,n){var i=e+" Iterator";return t.prototype=so(ao,{next:uo(+!n,r)}),lo(t,i,!1,!0),co[i]=ho,t},Eo=Ii,So=io,To=Bi,Oo=oo,Po=Rn.PROPER,Ao=Zi.BUGGY_SAFARI_ITERATORS,Do=ht("iterator"),Lo="keys",Ro="values",Fo="entries",Mo=function(){return this},jo=function(t,e,r,n,i,o,a){Co(r,e,n);var s,u,l,c=function(t){if(t===i&&v)return v;if(!Ao&&t in p)return p[t];switch(t){case Lo:case Ro:case Fo:return function(){return new r(this,t)}}return function(){return new r(this)}},h=e+" Iterator",f=!1,p=t.prototype,d=p[Do]||p["@@iterator"]||i&&p[i],v=!Ao&&d||c(i),g="Array"==e&&p.entries||d;if(g&&(s=Eo(g.call(new t)))!==Object.prototype&&s.next&&(So(s,h,!0,!0),Oo[h]=Mo),Po&&i==Ro&&d&&d.name!==Ro&&(f=!0,v=function(){return ko(d,this)}),i)if(u={values:c(Ro),keys:o?v:c(Lo),entries:c(Fo)},a)for(l in u)(Ao||f||!(l in p))&&To(p,l,u[l]);else _o({target:e,proto:!0,forced:Ao||f},u);return a&&p[Do]!==v&&To(p,Do,v,{name:i}),Oo[e]=v,u},Io=function(t,e){return{value:t,done:e}},zo=Nt.charAt,Bo=Dt,No=Er,Wo=jo,Go=Io,Yo="String Iterator",Vo=No.set,Xo=No.getterFor(Yo);Wo(String,"String",(function(t){Vo(this,{type:Yo,string:Bo(t),index:0})}),(function(){var t,e=Xo(this),r=e.string,n=e.index;return n>=r.length?Go(void 0,!0):(t=zo(r,n),e.index+=t.length,Go(t,!1))}));var Uo=ue,Ho=oe,qo=Pe,Zo=function(t,e,r){var n,i;Ho(t);try{if(!(n=qo(t,"return"))){if("throw"===e)throw r;return r}n=Uo(n,t)}catch(t){i=!0,n=t}if("throw"===e)throw r;if(i)throw n;return Ho(n),r},$o=oe,Qo=Zo,Ko=oo,Jo=ht("iterator"),ta=Array.prototype,ea=function(t){return void 0!==t&&(Ko.Array===t||ta[Jo]===t)},ra=yt,na=S,ia=p(Function.toString);ra(na.inspectSource)||(na.inspectSource=function(t){return ia(t)});var oa=na.inspectSource,aa=p,sa=s,ua=yt,la=Ot,ca=oa,ha=function(){},fa=[],pa=de("Reflect","construct"),da=/^\s*(?:class|function)\b/,va=aa(da.exec),ga=!da.exec(ha),ya=function(t){if(!ua(t))return!1;try{return pa(ha,fa,t),!0}catch(t){return!1}},ma=function(t){if(!ua(t))return!1;switch(la(t)){case"AsyncFunction":case"GeneratorFunction":case"AsyncGeneratorFunction":return!1}try{return ga||!!va(da,ca(t))}catch(t){return!0}};ma.sham=!0;var ba=!pa||sa((function(){var t;return ya(ya.call)||!ya(Object)||!ya((function(){t=!0}))||t}))?ma:ya,xa=Ye,wa=qt,_a=ir,ka=function(t,e,r){var n=xa(e);n in t?wa.f(t,n,_a(0,r)):t[n]=r},Ca=Ot,Ea=Pe,Sa=A,Ta=oo,Oa=ht("iterator"),Pa=function(t){if(!Sa(t))return Ea(t,Oa)||Ea(t,"@@iterator")||Ta[Ca(t)]},Aa=ue,Da=Se,La=oe,Ra=_e,Fa=Pa,Ma=TypeError,ja=function(t,e){var r=arguments.length<2?Fa(t):e;if(Da(r))return La(Aa(r,t));throw Ma(Ra(t)+" is not iterable")},Ia=vn,za=ue,Ba=j,Na=function(t,e,r,n){try{return n?e($o(r)[0],r[1]):e(r)}catch(e){Qo(t,"throw",e)}},Wa=ea,Ga=ba,Ya=Gn,Va=ka,Xa=ja,Ua=Pa,Ha=Array,qa=ht("iterator"),Za=!1;try{var $a=0,Qa={next:function(){return{done:!!$a++}},return:function(){Za=!0}};Qa[qa]=function(){return this},Array.from(Qa,(function(){throw 2}))}catch(t){}var Ka=function(t,e){if(!e&&!Za)return!1;var r=!1;try{var n={};n[qa]=function(){return{next:function(){return{done:r=!0}}}},t(n)}catch(t){}return r},Ja=function(t){var e=Ba(t),r=Ga(this),n=arguments.length,i=n>1?arguments[1]:void 0,o=void 0!==i;o&&(i=Ia(i,n>2?arguments[2]:void 0));var a,s,u,l,c,h,f=Ua(e),p=0;if(!f||this===Ha&&Wa(f))for(a=Ya(e),s=r?new this(a):Ha(a);a>p;p++)h=o?i(e[p],p):e[p],Va(s,p,h);else for(c=(l=Xa(e,f)).next,s=r?new this:[];!(u=za(c,l)).done;p++)h=o?Na(l,i,[u.value,p],!0):u.value,Va(s,p,h);return s.length=p,s};Tn({target:"Array",stat:!0,forced:!Ka((function(t){Array.from(t)}))},{from:Ja});var ts=le.Array.from;!function(t){t.exports=ts}(a);var es=r(o),rs={},ns={get exports(){return rs},set exports(t){rs=t}},is={},os={get exports(){return is},set exports(t){is=t}},as=Ur,ss=oo,us=Er;qt.f;var ls=jo,cs=Io,hs="Array Iterator",fs=us.set,ps=us.getterFor(hs);ls(Array,"Array",(function(t,e){fs(this,{type:hs,target:as(t),index:0,kind:e})}),(function(){var t=ps(this),e=t.target,r=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,cs(void 0,!0)):cs("keys"==r?n:"values"==r?e[n]:[n,e[n]],!1)}),"values"),ss.Arguments=ss.Array;var ds=Pa,vs={CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0},gs=b,ys=Ot,ms=sr,bs=oo,xs=ht("toStringTag");for(var ws in vs){var _s=gs[ws],ks=_s&&_s.prototype;ks&&ys(ks)!==xs&&ms(ks,xs,ws),bs[ws]=bs.Array}var Cs=ds;!function(t){t.exports=Cs}(os),function(t){t.exports=is}(ns);var Es=r(rs),Ss={},Ts={get exports(){return Ss},set exports(t){Ss=t}},Os={},Ps=Jn,As=ti.concat("length","prototype");Os.f=Object.getOwnPropertyNames||function(t){return Ps(t,As)};var Ds={},Ls=zn,Rs=Gn,Fs=ka,Ms=Array,js=Math.max,Is=function(t,e,r){for(var n=Rs(t),i=Ls(e,n),o=Ls(void 0===r?n:r,n),a=Ms(js(o-i,0)),s=0;i<o;i++,s++)Fs(a,s,t[i]);return a.length=s,a},zs=wt,Bs=Ur,Ns=Os.f,Ws=Is,Gs="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[];Ds.f=function(t){return Gs&&"Window"==zs(t)?function(t){try{return Ns(t)}catch(t){return Ws(Gs)}}(t):Ns(Bs(t))};var Ys={};Ys.f=Object.getOwnPropertySymbols;var Vs=qt,Xs=function(t,e,r){return Vs.f(t,e,r)},Us={},Hs=ht;Us.f=Hs;var qs=le,Zs=B,$s=Us,Qs=qt.f,Ks=function(t){var e=qs.Symbol||(qs.Symbol={});Zs(e,t)||Qs(e,t,{value:$s.f(t)})},Js=ue,tu=de,eu=ht,ru=Bi,nu=function(){var t=tu("Symbol"),e=t&&t.prototype,r=e&&e.valueOf,n=eu("toPrimitive");e&&!e[n]&&ru(e,n,(function(t){return Js(r,this)}),{arity:1})},iu=wt,ou=Array.isArray||function(t){return"Array"==iu(t)},au=ou,su=ba,uu=Ut,lu=ht("species"),cu=Array,hu=function(t){var e;return au(t)&&(e=t.constructor,(su(e)&&(e===cu||au(e.prototype))||uu(e)&&null===(e=e[lu]))&&(e=void 0)),void 0===e?cu:e},fu=function(t,e){return new(hu(t))(0===e?0:e)},pu=vn,du=Yr,vu=j,gu=Gn,yu=fu,mu=p([].push),bu=function(t){var e=1==t,r=2==t,n=3==t,i=4==t,o=6==t,a=7==t,s=5==t||o;return function(u,l,c,h){for(var f,p,d=vu(u),v=du(d),g=pu(l,c),y=gu(v),m=0,b=h||yu,x=e?b(u,y):r||a?b(u,0):void 0;y>m;m++)if((s||m in v)&&(p=g(f=v[m],m,d),t))if(e)x[m]=p;else if(p)switch(t){case 3:return!0;case 5:return f;case 6:return m;case 2:mu(x,f)}else switch(t){case 4:return!1;case 7:mu(x,f)}return o?-1:n||i?i:x}},xu={forEach:bu(0),map:bu(1),filter:bu(2),some:bu(3),every:bu(4),find:bu(5),findIndex:bu(6),filterReject:bu(7)},wu=Tn,_u=b,ku=ue,Cu=p,Eu=Ht,Su=et,Tu=s,Ou=B,Pu=ve,Au=oe,Du=Ur,Lu=Ye,Ru=Dt,Fu=ir,Mu=Oi,ju=ni,Iu=Os,zu=Ds,Bu=Ys,Nu=Fr,Wu=qt,Gu=Fn,Yu=Mr,Vu=Bi,Xu=Xs,Uu=x,Hu=hr,qu=V,Zu=ht,$u=Us,Qu=Ks,Ku=nu,Ju=io,tl=Er,el=xu.forEach,rl=cr("hidden"),nl="Symbol",il="prototype",ol=tl.set,al=tl.getterFor(nl),sl=Object[il],ul=_u.Symbol,ll=ul&&ul[il],cl=_u.TypeError,hl=_u.QObject,fl=Nu.f,pl=Wu.f,dl=zu.f,vl=Yu.f,gl=Cu([].push),yl=Uu("symbols"),ml=Uu("op-symbols"),bl=Uu("wks"),xl=!hl||!hl[il]||!hl[il].findChild,wl=Eu&&Tu((function(){return 7!=Mu(pl({},"a",{get:function(){return pl(this,"a",{value:7}).a}})).a}))?function(t,e,r){var n=fl(sl,e);n&&delete sl[e],pl(t,e,r),n&&t!==sl&&pl(sl,e,n)}:pl,_l=function(t,e){var r=yl[t]=Mu(ll);return ol(r,{type:nl,tag:t,description:e}),Eu||(r.description=e),r},kl=function(t,e,r){t===sl&&kl(ml,e,r),Au(t);var n=Lu(e);return Au(r),Ou(yl,n)?(r.enumerable?(Ou(t,rl)&&t[rl][n]&&(t[rl][n]=!1),r=Mu(r,{enumerable:Fu(0,!1)})):(Ou(t,rl)||pl(t,rl,Fu(1,{})),t[rl][n]=!0),wl(t,n,r)):pl(t,n,r)},Cl=function(t,e){Au(t);var r=Du(e),n=ju(r).concat(Ol(r));return el(n,(function(e){Eu&&!ku(El,r,e)||kl(t,e,r[e])})),t},El=function(t){var e=Lu(t),r=ku(vl,this,e);return!(this===sl&&Ou(yl,e)&&!Ou(ml,e))&&(!(r||!Ou(this,e)||!Ou(yl,e)||Ou(this,rl)&&this[rl][e])||r)},Sl=function(t,e){var r=Du(t),n=Lu(e);if(r!==sl||!Ou(yl,n)||Ou(ml,n)){var i=fl(r,n);return!i||!Ou(yl,n)||Ou(r,rl)&&r[rl][n]||(i.enumerable=!0),i}},Tl=function(t){var e=dl(Du(t)),r=[];return el(e,(function(t){Ou(yl,t)||Ou(Hu,t)||gl(r,t)})),r},Ol=function(t){var e=t===sl,r=dl(e?ml:Du(t)),n=[];return el(r,(function(t){!Ou(yl,t)||e&&!Ou(sl,t)||gl(n,yl[t])})),n};Su||(ul=function(){if(Pu(ll,this))throw cl("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?Ru(arguments[0]):void 0,e=qu(t),r=function(t){this===sl&&ku(r,ml,t),Ou(this,rl)&&Ou(this[rl],e)&&(this[rl][e]=!1),wl(this,e,Fu(1,t))};return Eu&&xl&&wl(sl,e,{configurable:!0,set:r}),_l(e,t)},Vu(ll=ul[il],"toString",(function(){return al(this).tag})),Vu(ul,"withoutSetter",(function(t){return _l(qu(t),t)})),Yu.f=El,Wu.f=kl,Gu.f=Cl,Nu.f=Sl,Iu.f=zu.f=Tl,Bu.f=Ol,$u.f=function(t){return _l(Zu(t),t)},Eu&&Xu(ll,"description",{configurable:!0,get:function(){return al(this).description}})),wu({global:!0,constructor:!0,wrap:!0,forced:!Su,sham:!Su},{Symbol:ul}),el(ju(bl),(function(t){Qu(t)})),wu({target:nl,stat:!0,forced:!Su},{useSetter:function(){xl=!0},useSimple:function(){xl=!1}}),wu({target:"Object",stat:!0,forced:!Su,sham:!Eu},{create:function(t,e){return void 0===e?Mu(t):Cl(Mu(t),e)},defineProperty:kl,defineProperties:Cl,getOwnPropertyDescriptor:Sl}),wu({target:"Object",stat:!0,forced:!Su},{getOwnPropertyNames:Tl}),Ku(),Ju(ul,nl),Hu[rl]=!0;var Pl=et&&!!Symbol.for&&!!Symbol.keyFor,Al=Tn,Dl=de,Ll=B,Rl=Dt,Fl=x,Ml=Pl,jl=Fl("string-to-symbol-registry"),Il=Fl("symbol-to-string-registry");Al({target:"Symbol",stat:!0,forced:!Ml},{for:function(t){var e=Rl(t);if(Ll(jl,e))return jl[e];var r=Dl("Symbol")(e);return jl[e]=r,Il[r]=e,r}});var zl=Tn,Bl=B,Nl=xe,Wl=_e,Gl=Pl,Yl=x("symbol-to-string-registry");zl({target:"Symbol",stat:!0,forced:!Gl},{keyFor:function(t){if(!Nl(t))throw TypeError(Wl(t)+" is not a symbol");if(Bl(Yl,t))return Yl[t]}});var Vl=p([].slice),Xl=ou,Ul=yt,Hl=wt,ql=Dt,Zl=p([].push),$l=Tn,Ql=de,Kl=Ar,Jl=ue,tc=p,ec=s,rc=yt,nc=xe,ic=Vl,oc=function(t){if(Ul(t))return t;if(Xl(t)){for(var e=t.length,r=[],n=0;n<e;n++){var i=t[n];"string"==typeof i?Zl(r,i):"number"!=typeof i&&"Number"!=Hl(i)&&"String"!=Hl(i)||Zl(r,ql(i))}var o=r.length,a=!0;return function(t,e){if(a)return a=!1,e;if(Xl(this))return e;for(var n=0;n<o;n++)if(r[n]===t)return e}}},ac=et,sc=String,uc=Ql("JSON","stringify"),lc=tc(/./.exec),cc=tc("".charAt),hc=tc("".charCodeAt),fc=tc("".replace),pc=tc(1..toString),dc=/[\uD800-\uDFFF]/g,vc=/^[\uD800-\uDBFF]$/,gc=/^[\uDC00-\uDFFF]$/,yc=!ac||ec((function(){var t=Ql("Symbol")();return"[null]"!=uc([t])||"{}"!=uc({a:t})||"{}"!=uc(Object(t))})),mc=ec((function(){return'"\\udf06\\ud834"'!==uc("\udf06\ud834")||'"\\udead"'!==uc("\udead")})),bc=function(t,e){var r=ic(arguments),n=oc(e);if(rc(n)||void 0!==t&&!nc(t))return r[1]=function(t,e){if(rc(n)&&(e=Jl(n,this,sc(t),e)),!nc(e))return e},Kl(uc,null,r)},xc=function(t,e,r){var n=cc(r,e-1),i=cc(r,e+1);return lc(vc,t)&&!lc(gc,i)||lc(gc,t)&&!lc(vc,n)?"\\u"+pc(hc(t,0),16):t};uc&&$l({target:"JSON",stat:!0,arity:3,forced:yc||mc},{stringify:function(t,e,r){var n=ic(arguments),i=Kl(yc?bc:uc,null,n);return mc&&"string"==typeof i?fc(i,dc,xc):i}});var wc=Ys,_c=j;Tn({target:"Object",stat:!0,forced:!et||s((function(){wc.f(1)}))},{getOwnPropertySymbols:function(t){var e=wc.f;return e?e(_c(t)):[]}});var kc=le.Object.getOwnPropertySymbols;!function(t){t.exports=kc}(Ts);var Cc=r(Ss),Ec={},Sc={get exports(){return Ec},set exports(t){Ec=t}},Tc={},Oc={get exports(){return Tc},set exports(t){Tc=t}},Pc=Tn,Ac=s,Dc=Ur,Lc=Fr.f,Rc=Ht;Pc({target:"Object",stat:!0,forced:!Rc||Ac((function(){Lc(1)})),sham:!Rc},{getOwnPropertyDescriptor:function(t,e){return Lc(Dc(t),e)}});var Fc=le.Object,Mc=Oc.exports=function(t,e){return Fc.getOwnPropertyDescriptor(t,e)};Fc.getOwnPropertyDescriptor.sham&&(Mc.sham=!0);var jc=Tc;!function(t){t.exports=jc}(Sc);var Ic=r(Ec),zc={},Bc={get exports(){return zc},set exports(t){zc=t}},Nc=de,Wc=Os,Gc=Ys,Yc=oe,Vc=p([].concat),Xc=Nc("Reflect","ownKeys")||function(t){var e=Wc.f(Yc(t)),r=Gc.f;return r?Vc(e,r(t)):e},Uc=Xc,Hc=Ur,qc=Fr,Zc=ka;Tn({target:"Object",stat:!0,sham:!Ht},{getOwnPropertyDescriptors:function(t){for(var e,r,n=Hc(t),i=qc.f,o=Uc(n),a={},s=0;o.length>s;)void 0!==(r=i(n,e=o[s++]))&&Zc(a,e,r);return a}});var $c=le.Object.getOwnPropertyDescriptors;!function(t){t.exports=$c}(Bc);var Qc=r(zc),Kc={},Jc={get exports(){return Kc},set exports(t){Kc=t}},th={},eh={get exports(){return th},set exports(t){th=t}},rh=Tn,nh=Ht,ih=Fn.f;rh({target:"Object",stat:!0,forced:Object.defineProperties!==ih,sham:!nh},{defineProperties:ih});var oh=le.Object,ah=eh.exports=function(t,e){return oh.defineProperties(t,e)};oh.defineProperties.sham&&(ah.sham=!0);var sh=th;!function(t){t.exports=sh}(Jc);var uh=r(Kc),lh={},ch={get exports(){return lh},set exports(t){lh=t}},hh={},fh={get exports(){return hh},set exports(t){hh=t}},ph=Tn,dh=Ht,vh=qt.f;ph({target:"Object",stat:!0,forced:Object.defineProperty!==vh,sham:!dh},{defineProperty:vh});var gh=le.Object,yh=fh.exports=function(t,e,r){return gh.defineProperty(t,e,r)};gh.defineProperty.sham&&(yh.sham=!0);var mh=hh;!function(t){t.exports=mh}(ch);var bh=r(lh);function xh(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}var wh={},_h={get exports(){return wh},set exports(t){wh=t}},kh={},Ch=mh;!function(t){t.exports=Ch}({get exports(){return kh},set exports(t){kh=t}}),function(t){t.exports=kh}(_h);var Eh=r(wh),Sh={},Th={get exports(){return Sh},set exports(t){Sh=t}},Oh={},Ph={get exports(){return Oh},set exports(t){Oh=t}},Ah=TypeError,Dh=function(t){if(t>9007199254740991)throw Ah("Maximum allowed index exceeded");return t},Lh=s,Rh=K,Fh=ht("species"),Mh=function(t){return Rh>=51||!Lh((function(){var e=[];return(e.constructor={})[Fh]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},jh=Tn,Ih=s,zh=ou,Bh=Ut,Nh=j,Wh=Gn,Gh=Dh,Yh=ka,Vh=fu,Xh=Mh,Uh=K,Hh=ht("isConcatSpreadable"),qh=Uh>=51||!Ih((function(){var t=[];return t[Hh]=!1,t.concat()[0]!==t})),Zh=function(t){if(!Bh(t))return!1;var e=t[Hh];return void 0!==e?!!e:zh(t)};jh({target:"Array",proto:!0,arity:1,forced:!qh||!Xh("concat")},{concat:function(t){var e,r,n,i,o,a=Nh(this),s=Vh(a,0),u=0;for(e=-1,n=arguments.length;e<n;e++)if(Zh(o=-1===e?a:arguments[e]))for(i=Wh(o),Gh(u+i),r=0;r<i;r++,u++)r in o&&Yh(s,u,o[r]);else Gh(u+1),Yh(s,u++,o);return s.length=u,s}}),Ks("asyncIterator"),Ks("hasInstance"),Ks("isConcatSpreadable"),Ks("iterator"),Ks("match"),Ks("matchAll"),Ks("replace"),Ks("search"),Ks("species"),Ks("split");var $h=nu;Ks("toPrimitive"),$h();var Qh=de,Kh=io;Ks("toStringTag"),Kh(Qh("Symbol"),"Symbol"),Ks("unscopables"),io(b.JSON,"JSON",!0);var Jh=le.Symbol;Ks("dispose");var tf=Jh;Ks("asyncDispose");var ef=Tn,rf=p,nf=de("Symbol"),of=nf.keyFor,af=rf(nf.prototype.valueOf);ef({target:"Symbol",stat:!0},{isRegistered:function(t){try{return void 0!==of(af(t))}catch(t){return!1}}});for(var sf=Tn,uf=x,lf=de,cf=p,hf=xe,ff=ht,pf=lf("Symbol"),df=pf.isWellKnown,vf=lf("Object","getOwnPropertyNames"),gf=cf(pf.prototype.valueOf),yf=uf("wks"),mf=0,bf=vf(pf),xf=bf.length;mf<xf;mf++)try{var wf=bf[mf];hf(pf[wf])&&ff(wf)}catch(t){}sf({target:"Symbol",stat:!0,forced:!0},{isWellKnown:function(t){if(df&&df(t))return!0;try{for(var e=gf(t),r=0,n=vf(yf),i=n.length;r<i;r++)if(yf[n[r]]==e)return!0}catch(t){}return!1}}),Ks("matcher"),Ks("metadataKey"),Ks("observable"),Ks("metadata"),Ks("patternMatch"),Ks("replaceAll");var _f=tf;!function(t){t.exports=_f}(Ph),function(t){t.exports=Oh}(Th);var kf=r(Sh),Cf={},Ef={get exports(){return Cf},set exports(t){Cf=t}},Sf={},Tf={get exports(){return Sf},set exports(t){Sf=t}},Of=Us.f("iterator"),Pf=Of;!function(t){t.exports=Pf}(Tf),function(t){t.exports=Sf}(Ef);var Af=r(Cf);function Df(t){return Df="function"==typeof kf&&"symbol"==typeof Af?function(t){return typeof t}:function(t){return t&&"function"==typeof kf&&t.constructor===kf&&t!==kf.prototype?"symbol":typeof t},Df(t)}var Lf={},Rf={get exports(){return Lf},set exports(t){Lf=t}},Ff={},Mf={get exports(){return Ff},set exports(t){Ff=t}},jf=Us.f("toPrimitive");!function(t){t.exports=jf}(Mf),function(t){t.exports=Ff}(Rf);var If=r(Lf);function zf(t){var e=function(t,e){if("object"!==Df(t)||null===t)return t;var r=t[If];if(void 0!==r){var n=r.call(t,e||"default");if("object"!==Df(n))return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===e?String:Number)(t)}(t,"string");return"symbol"===Df(e)?e:String(e)}function Bf(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Eh(t,zf(n.key),n)}}function Nf(t,e,r){return e&&Bf(t.prototype,e),r&&Bf(t,r),Eh(t,"prototype",{writable:!1}),t}function Wf(t,e,r){return(e=zf(e))in t?Eh(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t}var Gf={},Yf={get exports(){return Gf},set exports(t){Gf=t}},Vf={},Xf={get exports(){return Vf},set exports(t){Vf=t}};Tn({target:"Array",stat:!0},{isArray:ou});var Uf=le.Array.isArray,Hf=Uf;!function(t){t.exports=Hf}(Xf),function(t){t.exports=Vf}(Yf);var qf=r(Gf);var Zf={},$f={get exports(){return Zf},set exports(t){Zf=t}},Qf={},Kf={get exports(){return Qf},set exports(t){Qf=t}},Jf=Tn,tp=ou,ep=ba,rp=Ut,np=zn,ip=Gn,op=Ur,ap=ka,sp=ht,up=Vl,lp=Mh("slice"),cp=sp("species"),hp=Array,fp=Math.max;Jf({target:"Array",proto:!0,forced:!lp},{slice:function(t,e){var r,n,i,o=op(this),a=ip(o),s=np(t,a),u=np(void 0===e?a:e,a);if(tp(o)&&(r=o.constructor,(ep(r)&&(r===hp||tp(r.prototype))||rp(r)&&null===(r=r[cp]))&&(r=void 0),r===hp||void 0===r))return up(o,s,u);for(n=new(void 0===r?hp:r)(fp(u-s,0)),i=0;s<u;s++,i++)s in o&&ap(n,i,o[s]);return n.length=i,n}});var pp=le,dp=function(t){return pp[t+"Prototype"]},vp=dp("Array").slice,gp=ve,yp=vp,mp=Array.prototype,bp=function(t){var e=t.slice;return t===mp||gp(mp,t)&&e===mp.slice?yp:e},xp=bp;!function(t){t.exports=xp}(Kf),function(t){t.exports=Qf}($f);var wp=r(Zf),_p={},kp={get exports(){return _p},set exports(t){_p=t}},Cp={},Ep=ts;!function(t){t.exports=Ep}({get exports(){return Cp},set exports(t){Cp=t}}),function(t){t.exports=Cp}(kp);var Sp=r(_p);function Tp(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function Op(t,e){var r;if(t){if("string"==typeof t)return Tp(t,e);var n=wp(r=Object.prototype.toString.call(t)).call(r,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?Sp(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Tp(t,e):void 0}}function Pp(t,e){return function(t){if(qf(t))return t}(t)||function(t,e){var r=null==t?null:void 0!==kf&&Es(t)||t["@@iterator"];if(null!=r){var n,i,o,a,s=[],u=!0,l=!1;try{if(o=(r=r.call(t)).next,0===e){if(Object(r)!==r)return;u=!1}else for(;!(u=(n=o.call(r)).done)&&(s.push(n.value),s.length!==e);u=!0);}catch(t){l=!0,i=t}finally{try{if(!u&&null!=r.return&&(a=r.return(),Object(a)!==a))return}finally{if(l)throw i}}return s}}(t,e)||Op(t,e)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Ap(t){return function(t){if(qf(t))return Tp(t)}(t)||function(t){if(void 0!==kf&&null!=Es(t)||null!=t["@@iterator"])return Sp(t)}(t)||Op(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Dp={};!function(t){t.exports=Jh}({get exports(){return Dp},set exports(t){Dp=t}});var Lp=r(Dp),Rp={},Fp={get exports(){return Rp},set exports(t){Rp=t}},Mp=dp("Array").concat,jp=ve,Ip=Mp,zp=Array.prototype,Bp=function(t){var e=t.concat;return t===zp||jp(zp,t)&&e===zp.concat?Ip:e};!function(t){t.exports=Bp}(Fp);var Np=r(Rp),Wp={};!function(t){t.exports=bp}({get exports(){return Wp},set exports(t){Wp=t}});var Gp=r(Wp),Yp={},Vp={get exports(){return Yp},set exports(t){Yp=t}};Tn({target:"Reflect",stat:!0},{ownKeys:Xc});var Xp=le.Reflect.ownKeys;!function(t){t.exports=Xp}(Vp);var Up=r(Yp),Hp={};!function(t){t.exports=Uf}({get exports(){return Hp},set exports(t){Hp=t}});var qp=r(Hp),Zp={},$p={get exports(){return Zp},set exports(t){Zp=t}},Qp=xu.map;Tn({target:"Array",proto:!0,forced:!Mh("map")},{map:function(t){return Qp(this,t,arguments.length>1?arguments[1]:void 0)}});var Kp=dp("Array").map,Jp=ve,td=Kp,ed=Array.prototype,rd=function(t){var e=t.map;return t===ed||Jp(ed,t)&&e===ed.map?td:e};!function(t){t.exports=rd}($p);var nd=r(Zp),id={},od={get exports(){return id},set exports(t){id=t}},ad=j,sd=ni;Tn({target:"Object",stat:!0,forced:s((function(){sd(1)}))},{keys:function(t){return sd(ad(t))}});var ud=le.Object.keys;!function(t){t.exports=ud}(od);var ld=r(id),cd={},hd={get exports(){return cd},set exports(t){cd=t}},fd=Tn,pd=Date,dd=p(pd.prototype.getTime);fd({target:"Date",stat:!0},{now:function(){return dd(new pd)}});var vd=le.Date.now;!function(t){t.exports=vd}(hd);var gd=r(cd),yd={},md={get exports(){return yd},set exports(t){yd=t}},bd=p,xd=Se,wd=Ut,_d=B,kd=Vl,Cd=u,Ed=Function,Sd=bd([].concat),Td=bd([].join),Od={},Pd=function(t,e,r){if(!_d(Od,e)){for(var n=[],i=0;i<e;i++)n[i]="a["+i+"]";Od[e]=Ed("C,a","return new C("+Td(n,",")+")")}return Od[e](t,r)},Ad=Cd?Ed.bind:function(t){var e=xd(this),r=e.prototype,n=kd(arguments,1),i=function(){var r=Sd(n,kd(arguments));return this instanceof i?Pd(e,r.length,r):e.apply(t,r)};return wd(r)&&(i.prototype=r),i},Dd=Ad;Tn({target:"Function",proto:!0,forced:Function.bind!==Dd},{bind:Dd});var Ld=dp("Function").bind,Rd=ve,Fd=Ld,Md=Function.prototype,jd=function(t){var e=t.bind;return t===Md||Rd(Md,t)&&e===Md.bind?Fd:e};!function(t){t.exports=jd}(md);var Id=r(yd),zd={},Bd={get exports(){return zd},set exports(t){zd=t}},Nd=s,Wd=function(t,e){var r=[][t];return!!r&&Nd((function(){r.call(null,e||function(){return 1},1)}))},Gd=xu.forEach,Yd=Wd("forEach")?[].forEach:function(t){return Gd(this,t,arguments.length>1?arguments[1]:void 0)};Tn({target:"Array",proto:!0,forced:[].forEach!=Yd},{forEach:Yd});var Vd=dp("Array").forEach,Xd=Ot,Ud=B,Hd=ve,qd=Vd,Zd=Array.prototype,$d={DOMTokenList:!0,NodeList:!0},Qd=function(t){var e=t.forEach;return t===Zd||Hd(Zd,t)&&e===Zd.forEach||Ud($d,Xd(t))?qd:e};!function(t){t.exports=Qd}(Bd);var Kd=r(zd),Jd={},tv={get exports(){return Jd},set exports(t){Jd=t}},ev=Tn,rv=ou,nv=p([].reverse),iv=[1,2];ev({target:"Array",proto:!0,forced:String(iv)===String(iv.reverse())},{reverse:function(){return rv(this)&&(this.length=this.length),nv(this)}});var ov=dp("Array").reverse,av=ve,sv=ov,uv=Array.prototype,lv=function(t){var e=t.reverse;return t===uv||av(uv,t)&&e===uv.reverse?sv:e};!function(t){t.exports=lv}(tv);var cv=r(Jd),hv={},fv={get exports(){return hv},set exports(t){hv=t}},pv=Ht,dv=ou,vv=TypeError,gv=Object.getOwnPropertyDescriptor,yv=pv&&!function(){if(void 0!==this)return!0;try{Object.defineProperty([],"length",{writable:!1}).length=1}catch(t){return t instanceof TypeError}}(),mv=_e,bv=TypeError,xv=function(t,e){if(!delete t[e])throw bv("Cannot delete property "+mv(e)+" of "+mv(t))},wv=Tn,_v=j,kv=zn,Cv=y,Ev=Gn,Sv=yv?function(t,e){if(dv(t)&&!gv(t,"length").writable)throw vv("Cannot set read only .length");return t.length=e}:function(t,e){return t.length=e},Tv=Dh,Ov=fu,Pv=ka,Av=xv,Dv=Mh("splice"),Lv=Math.max,Rv=Math.min;wv({target:"Array",proto:!0,forced:!Dv},{splice:function(t,e){var r,n,i,o,a,s,u=_v(this),l=Ev(u),c=kv(t,l),h=arguments.length;for(0===h?r=n=0:1===h?(r=0,n=l-c):(r=h-2,n=Rv(Lv(Cv(e),0),l-c)),Tv(l+r-n),i=Ov(u,n),o=0;o<n;o++)(a=c+o)in u&&Pv(i,o,u[a]);if(i.length=n,r<n){for(o=c;o<l-n;o++)s=o+r,(a=o+n)in u?u[s]=u[a]:Av(u,s);for(o=l;o>l-n+r;o--)Av(u,o-1)}else if(r>n)for(o=l-n;o>c;o--)s=o+r-1,(a=o+n-1)in u?u[s]=u[a]:Av(u,s);for(o=0;o<r;o++)u[o+c]=arguments[o+2];return Sv(u,l-n+r),i}});var Fv=dp("Array").splice,Mv=ve,jv=Fv,Iv=Array.prototype,zv=function(t){var e=t.splice;return t===Iv||Mv(Iv,t)&&e===Iv.splice?jv:e};!function(t){t.exports=zv}(fv);var Bv=r(hv),Nv={},Wv={get exports(){return Nv},set exports(t){Nv=t}},Gv=Ht,Yv=p,Vv=ue,Xv=s,Uv=ni,Hv=Ys,qv=Mr,Zv=j,$v=Yr,Qv=Object.assign,Kv=Object.defineProperty,Jv=Yv([].concat),tg=!Qv||Xv((function(){if(Gv&&1!==Qv({b:1},Qv(Kv({},"a",{enumerable:!0,get:function(){Kv(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},r=Symbol(),n="abcdefghijklmnopqrst";return t[r]=7,n.split("").forEach((function(t){e[t]=t})),7!=Qv({},t)[r]||Uv(Qv({},e)).join("")!=n}))?function(t,e){for(var r=Zv(t),n=arguments.length,i=1,o=Hv.f,a=qv.f;n>i;)for(var s,u=$v(arguments[i++]),l=o?Jv(Uv(u),o(u)):Uv(u),c=l.length,h=0;c>h;)s=l[h++],Gv&&!Vv(a,u,s)||(r[s]=u[s]);return r}:Qv,eg=tg;Tn({target:"Object",stat:!0,arity:2,forced:Object.assign!==eg},{assign:eg});var rg=le.Object.assign;!function(t){t.exports=rg}(Wv);var ng=r(Nv),ig={},og={get exports(){return ig},set exports(t){ig=t}},ag=Hn.includes;Tn({target:"Array",proto:!0,forced:s((function(){return!Array(1).includes()}))},{includes:function(t){return ag(this,t,arguments.length>1?arguments[1]:void 0)}});var sg=dp("Array").includes,ug=Ut,lg=wt,cg=ht("match"),hg=function(t){var e;return ug(t)&&(void 0!==(e=t[cg])?!!e:"RegExp"==lg(t))},fg=TypeError,pg=ht("match"),dg=Tn,vg=function(t){if(hg(t))throw fg("The method doesn't accept regular expressions");return t},gg=R,yg=Dt,mg=function(t){var e=/./;try{"/./"[t](e)}catch(r){try{return e[pg]=!1,"/./"[t](e)}catch(t){}}return!1},bg=p("".indexOf);dg({target:"String",proto:!0,forced:!mg("includes")},{includes:function(t){return!!~bg(yg(gg(this)),yg(vg(t)),arguments.length>1?arguments[1]:void 0)}});var xg=dp("String").includes,wg=ve,_g=sg,kg=xg,Cg=Array.prototype,Eg=String.prototype,Sg=function(t){var e=t.includes;return t===Cg||wg(Cg,t)&&e===Cg.includes?_g:"string"==typeof t||t===Eg||wg(Eg,t)&&e===Eg.includes?kg:e};!function(t){t.exports=Sg}(og);var Tg=r(ig),Og={},Pg={get exports(){return Og},set exports(t){Og=t}},Ag=j,Dg=Ii,Lg=Pi;Tn({target:"Object",stat:!0,forced:s((function(){Dg(1)})),sham:!Lg},{getPrototypeOf:function(t){return Dg(Ag(t))}});var Rg=le.Object.getPrototypeOf;!function(t){t.exports=Rg}(Pg);var Fg=r(Og),Mg={},jg={get exports(){return Mg},set exports(t){Mg=t}},Ig=xu.filter;Tn({target:"Array",proto:!0,forced:!Mh("filter")},{filter:function(t){return Ig(this,t,arguments.length>1?arguments[1]:void 0)}});var zg=dp("Array").filter,Bg=ve,Ng=zg,Wg=Array.prototype,Gg=function(t){var e=t.filter;return t===Wg||Bg(Wg,t)&&e===Wg.filter?Ng:e};!function(t){t.exports=Gg}(jg);var Yg=r(Mg),Vg={},Xg={get exports(){return Vg},set exports(t){Vg=t}},Ug=Ht,Hg=p,qg=ni,Zg=Ur,$g=Hg(Mr.f),Qg=Hg([].push),Kg=function(t){return function(e){for(var r,n=Zg(e),i=qg(n),o=i.length,a=0,s=[];o>a;)r=i[a++],Ug&&!$g(n,r)||Qg(s,t?[r,n[r]]:n[r]);return s}},Jg={entries:Kg(!0),values:Kg(!1)}.values;Tn({target:"Object",stat:!0},{values:function(t){return Jg(t)}});var ty=le.Object.values;!function(t){t.exports=ty}(Xg);var ey=r(Vg),ry={},ny={get exports(){return ry},set exports(t){ry=t}},iy="\t\n\v\f\r                　\u2028\u2029\ufeff",oy=R,ay=Dt,sy=iy,uy=p("".replace),ly=RegExp("^["+sy+"]+"),cy=RegExp("(^|[^"+sy+"])["+sy+"]+$"),hy=function(t){return function(e){var r=ay(oy(e));return 1&t&&(r=uy(r,ly,"")),2&t&&(r=uy(r,cy,"$1")),r}},fy={start:hy(1),end:hy(2),trim:hy(3)},py=b,dy=s,vy=p,gy=Dt,yy=fy.trim,my=iy,by=py.parseInt,xy=py.Symbol,wy=xy&&xy.iterator,_y=/^[+-]?0x/i,ky=vy(_y.exec),Cy=8!==by(my+"08")||22!==by(my+"0x16")||wy&&!dy((function(){by(Object(wy))}))?function(t,e){var r=yy(gy(t));return by(r,e>>>0||(ky(_y,r)?16:10))}:by;Tn({global:!0,forced:parseInt!=Cy},{parseInt:Cy});var Ey=le.parseInt;!function(t){t.exports=Ey}(ny);var Sy=r(ry),Ty={},Oy={get exports(){return Ty},set exports(t){Ty=t}},Py=Tn,Ay=Hn.indexOf,Dy=Wd,Ly=Rr([].indexOf),Ry=!!Ly&&1/Ly([1],1,-0)<0;Py({target:"Array",proto:!0,forced:Ry||!Dy("indexOf")},{indexOf:function(t){var e=arguments.length>1?arguments[1]:void 0;return Ry?Ly(this,t,e)||0:Ay(this,t,e)}});var Fy=dp("Array").indexOf,My=ve,jy=Fy,Iy=Array.prototype,zy=function(t){var e=t.indexOf;return t===Iy||My(Iy,t)&&e===Iy.indexOf?jy:e};!function(t){t.exports=zy}(Oy);var By=r(Ty),Ny={},Wy={get exports(){return Ny},set exports(t){Ny=t}},Gy=Rn.PROPER,Yy=s,Vy=iy,Xy=fy.trim;Tn({target:"String",proto:!0,forced:function(t){return Yy((function(){return!!Vy[t]()||"​᠎"!=="​᠎"[t]()||Gy&&Vy[t].name!==t}))}("trim")},{trim:function(){return Xy(this)}});var Uy=dp("String").trim,Hy=ve,qy=Uy,Zy=String.prototype,$y=function(t){var e=t.trim;return"string"==typeof t||t===Zy||Hy(Zy,t)&&e===Zy.trim?qy:e};!function(t){t.exports=$y}(Wy);var Qy=r(Ny),Ky={},Jy={get exports(){return Ky},set exports(t){Ky=t}};Tn({target:"Object",stat:!0,sham:!Ht},{create:Oi});var tm=le.Object,em=function(t,e){return tm.create(t,e)};!function(t){t.exports=em}(Jy);var rm=r(Ky),nm={},im={get exports(){return nm},set exports(t){nm=t}},om=le,am=Ar;om.JSON||(om.JSON={stringify:JSON.stringify});var sm=function(t,e,r){return am(om.JSON.stringify,null,arguments)},um=sm;!function(t){t.exports=um}(im);var lm=r(nm),cm={},hm={get exports(){return cm},set exports(t){cm=t}},fm="function"==typeof Bun&&Bun&&"string"==typeof Bun.version,pm=TypeError,dm=function(t,e){if(t<e)throw pm("Not enough arguments");return t},vm=b,gm=Ar,ym=yt,mm=fm,bm=X,xm=Vl,wm=dm,_m=vm.Function,km=/MSIE .\./.test(bm)||mm&&function(){var t=vm.Bun.version.split(".");return t.length<3||0==t[0]&&(t[1]<3||3==t[1]&&0==t[2])}(),Cm=function(t,e){var r=e?2:1;return km?function(n,i){var o=wm(arguments.length,1)>r,a=ym(n)?n:_m(n),s=o?xm(arguments,r):[],u=o?function(){gm(a,this,s)}:a;return e?t(u,i):t(u)}:t},Em=Tn,Sm=b,Tm=Cm(Sm.setInterval,!0);Em({global:!0,bind:!0,forced:Sm.setInterval!==Tm},{setInterval:Tm});var Om=Tn,Pm=b,Am=Cm(Pm.setTimeout,!0);Om({global:!0,bind:!0,forced:Pm.setTimeout!==Am},{setTimeout:Am});var Dm=le.setTimeout;!function(t){t.exports=Dm}(hm);var Lm=r(cm),Rm={},Fm={get exports(){return Rm},set exports(t){Rm=t}},Mm=j,jm=zn,Im=Gn,zm=function(t){for(var e=Mm(this),r=Im(e),n=arguments.length,i=jm(n>1?arguments[1]:void 0,r),o=n>2?arguments[2]:void 0,a=void 0===o?r:jm(o,r);a>i;)e[i++]=t;return e};Tn({target:"Array",proto:!0},{fill:zm});var Bm=dp("Array").fill,Nm=ve,Wm=Bm,Gm=Array.prototype,Ym=function(t){var e=t.fill;return t===Gm||Nm(Gm,t)&&e===Gm.fill?Wm:e};!function(t){t.exports=Ym}(Fm);var Vm=r(Rm),Xm={};!function(t){function e(t){if(t)return function(t){for(var r in e.prototype)t[r]=e.prototype[r];return t}(t)}t.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function r(){this.off(t,r),e.apply(this,arguments)}return r.fn=e,this.on(t,r),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var r,n=this._callbacks["$"+t];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var i=0;i<n.length;i++)if((r=n[i])===e||r.fn===e){n.splice(i,1);break}return 0===n.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),r=this._callbacks["$"+t],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(r){n=0;for(var i=(r=r.slice(0)).length;n<i;++n)r[n].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}({get exports(){return Xm},set exports(t){Xm=t}});var Um,Hm=Xm;function qm(){return qm=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var r=arguments[e];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(t[n]=r[n])}return t},qm.apply(this,arguments)}function Zm(t,e){t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t.__proto__=e}function $m(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}Um="function"!=typeof Object.assign?function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),r=1;r<arguments.length;r++){var n=arguments[r];if(null!=n)for(var i in n)n.hasOwnProperty(i)&&(e[i]=n[i])}return e}:Object.assign;var Qm,Km=Um,Jm=["","webkit","Moz","MS","ms","o"],tb="undefined"==typeof document?{style:{}}:document.createElement("div"),eb="function",rb=Math.round,nb=Math.abs,ib=Date.now;function ob(t,e){for(var r,n,i=e[0].toUpperCase()+e.slice(1),o=0;o<Jm.length;){if((n=(r=Jm[o])?r+i:e)in t)return n;o++}}Qm="undefined"==typeof window?{}:window;var ab=ob(tb.style,"touchAction"),sb=void 0!==ab;var ub="compute",lb="auto",cb="manipulation",hb="none",fb="pan-x",pb="pan-y",db=function(){if(!sb)return!1;var t={},e=Qm.CSS&&Qm.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(r){return t[r]=!e||Qm.CSS.supports("touch-action",r)})),t}(),vb="ontouchstart"in Qm,gb=void 0!==ob(Qm,"PointerEvent"),yb=vb&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),mb="touch",bb="mouse",xb=25,wb=1,_b=2,kb=4,Cb=8,Eb=1,Sb=2,Tb=4,Ob=8,Pb=16,Ab=Sb|Tb,Db=Ob|Pb,Lb=Ab|Db,Rb=["x","y"],Fb=["clientX","clientY"];function Mb(t,e,r){var n;if(t)if(t.forEach)t.forEach(e,r);else if(void 0!==t.length)for(n=0;n<t.length;)e.call(r,t[n],n,t),n++;else for(n in t)t.hasOwnProperty(n)&&e.call(r,t[n],n,t)}function jb(t,e){return typeof t===eb?t.apply(e&&e[0]||void 0,e):t}function Ib(t,e){return t.indexOf(e)>-1}var zb=function(){function t(t,e){this.manager=t,this.set(e)}var e=t.prototype;return e.set=function(t){t===ub&&(t=this.compute()),sb&&this.manager.element.style&&db[t]&&(this.manager.element.style[ab]=t),this.actions=t.toLowerCase().trim()},e.update=function(){this.set(this.manager.options.touchAction)},e.compute=function(){var t=[];return Mb(this.manager.recognizers,(function(e){jb(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(Ib(t,hb))return hb;var e=Ib(t,fb),r=Ib(t,pb);return e&&r?hb:e||r?e?fb:pb:Ib(t,cb)?cb:lb}(t.join(" "))},e.preventDefaults=function(t){var e=t.srcEvent,r=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var n=this.actions,i=Ib(n,hb)&&!db[hb],o=Ib(n,pb)&&!db[pb],a=Ib(n,fb)&&!db[fb];if(i){var s=1===t.pointers.length,u=t.distance<2,l=t.deltaTime<250;if(s&&u&&l)return}if(!a||!o)return i||o&&r&Ab||a&&r&Db?this.preventSrc(e):void 0}},e.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},t}();function Bb(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1}function Nb(t){var e=t.length;if(1===e)return{x:rb(t[0].clientX),y:rb(t[0].clientY)};for(var r=0,n=0,i=0;i<e;)r+=t[i].clientX,n+=t[i].clientY,i++;return{x:rb(r/e),y:rb(n/e)}}function Wb(t){for(var e=[],r=0;r<t.pointers.length;)e[r]={clientX:rb(t.pointers[r].clientX),clientY:rb(t.pointers[r].clientY)},r++;return{timeStamp:ib(),pointers:e,center:Nb(e),deltaX:t.deltaX,deltaY:t.deltaY}}function Gb(t,e,r){r||(r=Rb);var n=e[r[0]]-t[r[0]],i=e[r[1]]-t[r[1]];return Math.sqrt(n*n+i*i)}function Yb(t,e,r){r||(r=Rb);var n=e[r[0]]-t[r[0]],i=e[r[1]]-t[r[1]];return 180*Math.atan2(i,n)/Math.PI}function Vb(t,e){return t===e?Eb:nb(t)>=nb(e)?t<0?Sb:Tb:e<0?Ob:Pb}function Xb(t,e,r){return{x:e/t||0,y:r/t||0}}function Ub(t,e){var r=t.session,n=e.pointers,i=n.length;r.firstInput||(r.firstInput=Wb(e)),i>1&&!r.firstMultiple?r.firstMultiple=Wb(e):1===i&&(r.firstMultiple=!1);var o=r.firstInput,a=r.firstMultiple,s=a?a.center:o.center,u=e.center=Nb(n);e.timeStamp=ib(),e.deltaTime=e.timeStamp-o.timeStamp,e.angle=Yb(s,u),e.distance=Gb(s,u),function(t,e){var r=e.center,n=t.offsetDelta||{},i=t.prevDelta||{},o=t.prevInput||{};e.eventType!==wb&&o.eventType!==kb||(i=t.prevDelta={x:o.deltaX||0,y:o.deltaY||0},n=t.offsetDelta={x:r.x,y:r.y}),e.deltaX=i.x+(r.x-n.x),e.deltaY=i.y+(r.y-n.y)}(r,e),e.offsetDirection=Vb(e.deltaX,e.deltaY);var l,c,h=Xb(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=h.x,e.overallVelocityY=h.y,e.overallVelocity=nb(h.x)>nb(h.y)?h.x:h.y,e.scale=a?(l=a.pointers,Gb((c=n)[0],c[1],Fb)/Gb(l[0],l[1],Fb)):1,e.rotation=a?function(t,e){return Yb(e[1],e[0],Fb)+Yb(t[1],t[0],Fb)}(a.pointers,n):0,e.maxPointers=r.prevInput?e.pointers.length>r.prevInput.maxPointers?e.pointers.length:r.prevInput.maxPointers:e.pointers.length,function(t,e){var r,n,i,o,a=t.lastInterval||e,s=e.timeStamp-a.timeStamp;if(e.eventType!==Cb&&(s>xb||void 0===a.velocity)){var u=e.deltaX-a.deltaX,l=e.deltaY-a.deltaY,c=Xb(s,u,l);n=c.x,i=c.y,r=nb(c.x)>nb(c.y)?c.x:c.y,o=Vb(u,l),t.lastInterval=e}else r=a.velocity,n=a.velocityX,i=a.velocityY,o=a.direction;e.velocity=r,e.velocityX=n,e.velocityY=i,e.direction=o}(r,e);var f,p=t.element,d=e.srcEvent;Bb(f=d.composedPath?d.composedPath()[0]:d.path?d.path[0]:d.target,p)&&(p=f),e.target=p}function Hb(t,e,r){var n=r.pointers.length,i=r.changedPointers.length,o=e&wb&&n-i==0,a=e&(kb|Cb)&&n-i==0;r.isFirst=!!o,r.isFinal=!!a,o&&(t.session={}),r.eventType=e,Ub(t,r),t.emit("hammer.input",r),t.recognize(r),t.session.prevInput=r}function qb(t){return t.trim().split(/\s+/g)}function Zb(t,e,r){Mb(qb(e),(function(e){t.addEventListener(e,r,!1)}))}function $b(t,e,r){Mb(qb(e),(function(e){t.removeEventListener(e,r,!1)}))}function Qb(t){var e=t.ownerDocument||t;return e.defaultView||e.parentWindow||window}var Kb=function(){function t(t,e){var r=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){jb(t.options.enable,[t])&&r.handler(e)},this.init()}var e=t.prototype;return e.handler=function(){},e.init=function(){this.evEl&&Zb(this.element,this.evEl,this.domHandler),this.evTarget&&Zb(this.target,this.evTarget,this.domHandler),this.evWin&&Zb(Qb(this.element),this.evWin,this.domHandler)},e.destroy=function(){this.evEl&&$b(this.element,this.evEl,this.domHandler),this.evTarget&&$b(this.target,this.evTarget,this.domHandler),this.evWin&&$b(Qb(this.element),this.evWin,this.domHandler)},t}();function Jb(t,e,r){if(t.indexOf&&!r)return t.indexOf(e);for(var n=0;n<t.length;){if(r&&t[n][r]==e||!r&&t[n]===e)return n;n++}return-1}var tx={pointerdown:wb,pointermove:_b,pointerup:kb,pointercancel:Cb,pointerout:Cb},ex={2:mb,3:"pen",4:bb,5:"kinect"},rx="pointerdown",nx="pointermove pointerup pointercancel";Qm.MSPointerEvent&&!Qm.PointerEvent&&(rx="MSPointerDown",nx="MSPointerMove MSPointerUp MSPointerCancel");var ix=function(t){function e(){var r,n=e.prototype;return n.evEl=rx,n.evWin=nx,(r=t.apply(this,arguments)||this).store=r.manager.session.pointerEvents=[],r}return Zm(e,t),e.prototype.handler=function(t){var e=this.store,r=!1,n=t.type.toLowerCase().replace("ms",""),i=tx[n],o=ex[t.pointerType]||t.pointerType,a=o===mb,s=Jb(e,t.pointerId,"pointerId");i&wb&&(0===t.button||a)?s<0&&(e.push(t),s=e.length-1):i&(kb|Cb)&&(r=!0),s<0||(e[s]=t,this.callback(this.manager,i,{pointers:e,changedPointers:[t],pointerType:o,srcEvent:t}),r&&e.splice(s,1))},e}(Kb);function ox(t){return Array.prototype.slice.call(t,0)}function ax(t,e,r){for(var n=[],i=[],o=0;o<t.length;){var a=e?t[o][e]:t[o];Jb(i,a)<0&&n.push(t[o]),i[o]=a,o++}return r&&(n=e?n.sort((function(t,r){return t[e]>r[e]})):n.sort()),n}var sx={touchstart:wb,touchmove:_b,touchend:kb,touchcancel:Cb},ux="touchstart touchmove touchend touchcancel",lx=function(t){function e(){var r;return e.prototype.evTarget=ux,(r=t.apply(this,arguments)||this).targetIds={},r}return Zm(e,t),e.prototype.handler=function(t){var e=sx[t.type],r=cx.call(this,t,e);r&&this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:mb,srcEvent:t})},e}(Kb);function cx(t,e){var r,n,i=ox(t.touches),o=this.targetIds;if(e&(wb|_b)&&1===i.length)return o[i[0].identifier]=!0,[i,i];var a=ox(t.changedTouches),s=[],u=this.target;if(n=i.filter((function(t){return Bb(t.target,u)})),e===wb)for(r=0;r<n.length;)o[n[r].identifier]=!0,r++;for(r=0;r<a.length;)o[a[r].identifier]&&s.push(a[r]),e&(kb|Cb)&&delete o[a[r].identifier],r++;return s.length?[ax(n.concat(s),"identifier",!0),s]:void 0}var hx={mousedown:wb,mousemove:_b,mouseup:kb},fx="mousedown",px="mousemove mouseup",dx=function(t){function e(){var r,n=e.prototype;return n.evEl=fx,n.evWin=px,(r=t.apply(this,arguments)||this).pressed=!1,r}return Zm(e,t),e.prototype.handler=function(t){var e=hx[t.type];e&wb&&0===t.button&&(this.pressed=!0),e&_b&&1!==t.which&&(e=kb),this.pressed&&(e&kb&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:bb,srcEvent:t}))},e}(Kb),vx=2500,gx=25;function yx(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var r={x:e.clientX,y:e.clientY},n=this.lastTouches;this.lastTouches.push(r);setTimeout((function(){var t=n.indexOf(r);t>-1&&n.splice(t,1)}),vx)}}function mx(t,e){t&wb?(this.primaryTouch=e.changedPointers[0].identifier,yx.call(this,e)):t&(kb|Cb)&&yx.call(this,e)}function bx(t){for(var e=t.srcEvent.clientX,r=t.srcEvent.clientY,n=0;n<this.lastTouches.length;n++){var i=this.lastTouches[n],o=Math.abs(e-i.x),a=Math.abs(r-i.y);if(o<=gx&&a<=gx)return!0}return!1}var xx=function(){return function(t){function e(e,r){var n;return(n=t.call(this,e,r)||this).handler=function(t,e,r){var i=r.pointerType===mb,o=r.pointerType===bb;if(!(o&&r.sourceCapabilities&&r.sourceCapabilities.firesTouchEvents)){if(i)mx.call($m($m(n)),e,r);else if(o&&bx.call($m($m(n)),r))return;n.callback(t,e,r)}},n.touch=new lx(n.manager,n.handler),n.mouse=new dx(n.manager,n.handler),n.primaryTouch=null,n.lastTouches=[],n}return Zm(e,t),e.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(Kb)}();function wx(t,e,r){return!!Array.isArray(t)&&(Mb(t,r[e],r),!0)}var _x=1,kx=2,Cx=4,Ex=8,Sx=Ex,Tx=16,Ox=32,Px=1;function Ax(t,e){var r=e.manager;return r?r.get(t):t}function Dx(t){return t&Tx?"cancel":t&Ex?"end":t&Cx?"move":t&kx?"start":""}var Lx=function(){function t(t){void 0===t&&(t={}),this.options=qm({enable:!0},t),this.id=Px++,this.manager=null,this.state=_x,this.simultaneous={},this.requireFail=[]}var e=t.prototype;return e.set=function(t){return Km(this.options,t),this.manager&&this.manager.touchAction.update(),this},e.recognizeWith=function(t){if(wx(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=Ax(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},e.dropRecognizeWith=function(t){return wx(t,"dropRecognizeWith",this)||(t=Ax(t,this),delete this.simultaneous[t.id]),this},e.requireFailure=function(t){if(wx(t,"requireFailure",this))return this;var e=this.requireFail;return-1===Jb(e,t=Ax(t,this))&&(e.push(t),t.requireFailure(this)),this},e.dropRequireFailure=function(t){if(wx(t,"dropRequireFailure",this))return this;t=Ax(t,this);var e=Jb(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},e.hasRequireFailures=function(){return this.requireFail.length>0},e.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},e.emit=function(t){var e=this,r=this.state;function n(r){e.manager.emit(r,t)}r<Ex&&n(e.options.event+Dx(r)),n(e.options.event),t.additionalEvent&&n(t.additionalEvent),r>=Ex&&n(e.options.event+Dx(r))},e.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=Ox},e.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(this.requireFail[t].state&(Ox|_x)))return!1;t++}return!0},e.recognize=function(t){var e=Km({},t);if(!jb(this.options.enable,[this,e]))return this.reset(),void(this.state=Ox);this.state&(Sx|Tx|Ox)&&(this.state=_x),this.state=this.process(e),this.state&(kx|Cx|Ex|Tx)&&this.tryEmit(e)},e.process=function(t){},e.getTouchAction=function(){},e.reset=function(){},t}(),Rx=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,qm({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},e))||this).pTime=!1,r.pCenter=!1,r._timer=null,r._input=null,r.count=0,r}Zm(e,t);var r=e.prototype;return r.getTouchAction=function(){return[cb]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,i=t.distance<r.threshold,o=t.deltaTime<r.time;if(this.reset(),t.eventType&wb&&0===this.count)return this.failTimeout();if(i&&o&&n){if(t.eventType!==kb)return this.failTimeout();var a=!this.pTime||t.timeStamp-this.pTime<r.interval,s=!this.pCenter||Gb(this.pCenter,t.center)<r.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,s&&a?this.count+=1:this.count=1,this._input=t,0===this.count%r.taps)return this.hasRequireFailures()?(this._timer=setTimeout((function(){e.state=Sx,e.tryEmit()}),r.interval),kx):Sx}return Ox},r.failTimeout=function(){var t=this;return this._timer=setTimeout((function(){t.state=Ox}),this.options.interval),Ox},r.reset=function(){clearTimeout(this._timer)},r.emit=function(){this.state===Sx&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},e}(Lx),Fx=function(t){function e(e){return void 0===e&&(e={}),t.call(this,qm({pointers:1},e))||this}Zm(e,t);var r=e.prototype;return r.attrTest=function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},r.process=function(t){var e=this.state,r=t.eventType,n=e&(kx|Cx),i=this.attrTest(t);return n&&(r&Cb||!i)?e|Tx:n||i?r&kb?e|Ex:e&kx?e|Cx:kx:Ox},e}(Lx);function Mx(t){return t===Pb?"down":t===Ob?"up":t===Sb?"left":t===Tb?"right":""}var jx=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,qm({event:"pan",threshold:10,pointers:1,direction:Lb},e))||this).pX=null,r.pY=null,r}Zm(e,t);var r=e.prototype;return r.getTouchAction=function(){var t=this.options.direction,e=[];return t&Ab&&e.push(pb),t&Db&&e.push(fb),e},r.directionTest=function(t){var e=this.options,r=!0,n=t.distance,i=t.direction,o=t.deltaX,a=t.deltaY;return i&e.direction||(e.direction&Ab?(i=0===o?Eb:o<0?Sb:Tb,r=o!==this.pX,n=Math.abs(t.deltaX)):(i=0===a?Eb:a<0?Ob:Pb,r=a!==this.pY,n=Math.abs(t.deltaY))),t.direction=i,r&&n>e.threshold&&i&e.direction},r.attrTest=function(t){return Fx.prototype.attrTest.call(this,t)&&(this.state&kx||!(this.state&kx)&&this.directionTest(t))},r.emit=function(e){this.pX=e.deltaX,this.pY=e.deltaY;var r=Mx(e.direction);r&&(e.additionalEvent=this.options.event+r),t.prototype.emit.call(this,e)},e}(Fx),Ix=function(t){function e(e){return void 0===e&&(e={}),t.call(this,qm({event:"swipe",threshold:10,velocity:.3,direction:Ab|Db,pointers:1},e))||this}Zm(e,t);var r=e.prototype;return r.getTouchAction=function(){return jx.prototype.getTouchAction.call(this)},r.attrTest=function(e){var r,n=this.options.direction;return n&(Ab|Db)?r=e.overallVelocity:n&Ab?r=e.overallVelocityX:n&Db&&(r=e.overallVelocityY),t.prototype.attrTest.call(this,e)&&n&e.offsetDirection&&e.distance>this.options.threshold&&e.maxPointers===this.options.pointers&&nb(r)>this.options.velocity&&e.eventType&kb},r.emit=function(t){var e=Mx(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)},e}(Fx),zx=function(t){function e(e){return void 0===e&&(e={}),t.call(this,qm({event:"pinch",threshold:0,pointers:2},e))||this}Zm(e,t);var r=e.prototype;return r.getTouchAction=function(){return[hb]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.scale-1)>this.options.threshold||this.state&kx)},r.emit=function(e){if(1!==e.scale){var r=e.scale<1?"in":"out";e.additionalEvent=this.options.event+r}t.prototype.emit.call(this,e)},e}(Fx),Bx=function(t){function e(e){return void 0===e&&(e={}),t.call(this,qm({event:"rotate",threshold:0,pointers:2},e))||this}Zm(e,t);var r=e.prototype;return r.getTouchAction=function(){return[hb]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.rotation)>this.options.threshold||this.state&kx)},e}(Fx),Nx=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,qm({event:"press",pointers:1,time:251,threshold:9},e))||this)._timer=null,r._input=null,r}Zm(e,t);var r=e.prototype;return r.getTouchAction=function(){return[lb]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,i=t.distance<r.threshold,o=t.deltaTime>r.time;if(this._input=t,!i||!n||t.eventType&(kb|Cb)&&!o)this.reset();else if(t.eventType&wb)this.reset(),this._timer=setTimeout((function(){e.state=Sx,e.tryEmit()}),r.time);else if(t.eventType&kb)return Sx;return Ox},r.reset=function(){clearTimeout(this._timer)},r.emit=function(t){this.state===Sx&&(t&&t.eventType&kb?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=ib(),this.manager.emit(this.options.event,this._input)))},e}(Lx),Wx={domEvents:!1,touchAction:ub,enable:!0,inputTarget:null,inputClass:null,cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}},Gx=[[Bx,{enable:!1}],[zx,{enable:!1},["rotate"]],[Ix,{direction:Ab}],[jx,{direction:Ab},["swipe"]],[Rx],[Rx,{event:"doubletap",taps:2},["tap"]],[Nx]];function Yx(t,e){var r,n=t.element;n.style&&(Mb(t.options.cssProps,(function(i,o){r=ob(n.style,o),e?(t.oldCssProps[r]=n.style[r],n.style[r]=i):n.style[r]=t.oldCssProps[r]||""})),e||(t.oldCssProps={}))}var Vx=function(){function t(t,e){var r,n=this;this.options=Km({},Wx,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((r=this).options.inputClass||(gb?ix:yb?lx:vb?xx:dx))(r,Hb),this.touchAction=new zb(this,this.options.touchAction),Yx(this,!0),Mb(this.options.recognizers,(function(t){var e=n.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}var e=t.prototype;return e.set=function(t){return Km(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},e.stop=function(t){this.session.stopped=t?2:1},e.recognize=function(t){var e=this.session;if(!e.stopped){var r;this.touchAction.preventDefaults(t);var n=this.recognizers,i=e.curRecognizer;(!i||i&&i.state&Sx)&&(e.curRecognizer=null,i=null);for(var o=0;o<n.length;)r=n[o],2===e.stopped||i&&r!==i&&!r.canRecognizeWith(i)?r.reset():r.recognize(t),!i&&r.state&(kx|Cx|Ex)&&(e.curRecognizer=r,i=r),o++}},e.get=function(t){if(t instanceof Lx)return t;for(var e=this.recognizers,r=0;r<e.length;r++)if(e[r].options.event===t)return e[r];return null},e.add=function(t){if(wx(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},e.remove=function(t){if(wx(t,"remove",this))return this;var e=this.get(t);if(t){var r=this.recognizers,n=Jb(r,e);-1!==n&&(r.splice(n,1),this.touchAction.update())}return this},e.on=function(t,e){if(void 0===t||void 0===e)return this;var r=this.handlers;return Mb(qb(t),(function(t){r[t]=r[t]||[],r[t].push(e)})),this},e.off=function(t,e){if(void 0===t)return this;var r=this.handlers;return Mb(qb(t),(function(t){e?r[t]&&r[t].splice(Jb(r[t],e),1):delete r[t]})),this},e.emit=function(t,e){this.options.domEvents&&function(t,e){var r=document.createEvent("Event");r.initEvent(t,!0,!0),r.gesture=e,e.target.dispatchEvent(r)}(t,e);var r=this.handlers[t]&&this.handlers[t].slice();if(r&&r.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var n=0;n<r.length;)r[n](e),n++}},e.destroy=function(){this.element&&Yx(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},t}(),Xx={touchstart:wb,touchmove:_b,touchend:kb,touchcancel:Cb},Ux="touchstart",Hx="touchstart touchmove touchend touchcancel",qx=function(t){function e(){var r,n=e.prototype;return n.evTarget=Ux,n.evWin=Hx,(r=t.apply(this,arguments)||this).started=!1,r}return Zm(e,t),e.prototype.handler=function(t){var e=Xx[t.type];if(e===wb&&(this.started=!0),this.started){var r=Zx.call(this,t,e);e&(kb|Cb)&&r[0].length-r[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:mb,srcEvent:t})}},e}(Kb);function Zx(t,e){var r=ox(t.touches),n=ox(t.changedTouches);return e&(kb|Cb)&&(r=ax(r.concat(n),"identifier",!0)),[r,n]}function $x(t,e,r){var n="DEPRECATED METHOD: "+e+"\n"+r+" AT \n";return function(){var e=new Error("get-stack-trace"),r=e&&e.stack?e.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",i=window.console&&(window.console.warn||window.console.log);return i&&i.call(window.console,n,r),t.apply(this,arguments)}}var Qx=$x((function(t,e,r){for(var n=Object.keys(e),i=0;i<n.length;)(!r||r&&void 0===t[n[i]])&&(t[n[i]]=e[n[i]]),i++;return t}),"extend","Use `assign`."),Kx=$x((function(t,e){return Qx(t,e,!0)}),"merge","Use `assign`.");function Jx(t,e,r){var n,i=e.prototype;(n=t.prototype=Object.create(i)).constructor=t,n._super=i,r&&Km(n,r)}function tw(t,e){return function(){return t.apply(e,arguments)}}var ew=function(){var t=function(t,e){return void 0===e&&(e={}),new Vx(t,qm({recognizers:Gx.concat()},e))};return t.VERSION="2.0.17-rc",t.DIRECTION_ALL=Lb,t.DIRECTION_DOWN=Pb,t.DIRECTION_LEFT=Sb,t.DIRECTION_RIGHT=Tb,t.DIRECTION_UP=Ob,t.DIRECTION_HORIZONTAL=Ab,t.DIRECTION_VERTICAL=Db,t.DIRECTION_NONE=Eb,t.DIRECTION_DOWN=Pb,t.INPUT_START=wb,t.INPUT_MOVE=_b,t.INPUT_END=kb,t.INPUT_CANCEL=Cb,t.STATE_POSSIBLE=_x,t.STATE_BEGAN=kx,t.STATE_CHANGED=Cx,t.STATE_ENDED=Ex,t.STATE_RECOGNIZED=Sx,t.STATE_CANCELLED=Tx,t.STATE_FAILED=Ox,t.Manager=Vx,t.Input=Kb,t.TouchAction=zb,t.TouchInput=lx,t.MouseInput=dx,t.PointerEventInput=ix,t.TouchMouseInput=xx,t.SingleTouchInput=qx,t.Recognizer=Lx,t.AttrRecognizer=Fx,t.Tap=Rx,t.Pan=jx,t.Swipe=Ix,t.Pinch=zx,t.Rotate=Bx,t.Press=Nx,t.on=Zb,t.off=$b,t.each=Mb,t.merge=Kx,t.extend=Qx,t.bindFn=tw,t.assign=Km,t.inherit=Jx,t.bindFn=tw,t.prefixed=ob,t.toArray=ox,t.inArray=Jb,t.uniqueArray=ax,t.splitStr=qb,t.boolOrFn=jb,t.hasParent=Bb,t.addEventListeners=Zb,t.removeEventListeners=$b,t.defaults=Km({},Wx,{preset:Gx}),t}();ew.defaults;var rw=ew;function nw(t,e){var r=ld(t);if(Cc){var n=Cc(t);e&&(n=Yg(n).call(n,(function(e){return Ic(t,e).enumerable}))),r.push.apply(r,n)}return r}function iw(t){for(var e=1;e<arguments.length;e++){var r,n,i=null!=arguments[e]?arguments[e]:{};e%2?Kd(r=nw(Object(i),!0)).call(r,(function(e){Wf(t,e,i[e])})):Qc?uh(t,Qc(i)):Kd(n=nw(Object(i))).call(n,(function(e){bh(t,e,Ic(i,e))}))}return t}function ow(t,e){var r=void 0!==Lp&&Es(t)||t["@@iterator"];if(!r){if(qp(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return aw(t,e);var n=Gp(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return es(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return aw(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,s=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){s=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw o}}}}function aw(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}var sw=Lp("DELETE");function uw(t){for(var e,r=arguments.length,n=new Array(r>1?r-1:0),i=1;i<r;i++)n[i-1]=arguments[i];return lw.apply(void 0,Np(e=[{},t]).call(e,n))}function lw(){var t=cw.apply(void 0,arguments);return fw(t),t}function cw(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];if(e.length<2)return e[0];var n;if(e.length>2)return cw.apply(void 0,Np(n=[lw(e[0],e[1])]).call(n,Ap(Gp(e).call(e,2))));var i,o=e[0],a=e[1],s=ow(Up(a));try{for(s.s();!(i=s.n()).done;){var u=i.value;Object.prototype.propertyIsEnumerable.call(a,u)&&(a[u]===sw?delete o[u]:null===o[u]||null===a[u]||"object"!==Df(o[u])||"object"!==Df(a[u])||qp(o[u])||qp(a[u])?o[u]=hw(a[u]):o[u]=cw(o[u],a[u]))}}catch(t){s.e(t)}finally{s.f()}return o}function hw(t){return qp(t)?nd(t).call(t,(function(t){return hw(t)})):"object"===Df(t)&&null!==t?cw({},t):t}function fw(t){for(var e=0,r=ld(t);e<r.length;e++){var n=r[e];t[n]===sw?delete t[n]:"object"===Df(t[n])&&null!==t[n]&&fw(t[n])}}var pw="undefined"!=typeof window?window.Hammer||rw:function(){return function(){var t=function(){};return{on:t,off:t,destroy:t,emit:t,get:function(){return{set:t}}}}()};function dw(t){var e,r=this;this._cleanupQueue=[],this.active=!1,this._dom={container:t,overlay:document.createElement("div")},this._dom.overlay.classList.add("vis-overlay"),this._dom.container.appendChild(this._dom.overlay),this._cleanupQueue.push((function(){r._dom.overlay.parentNode.removeChild(r._dom.overlay)}));var n=pw(this._dom.overlay);n.on("tap",Id(e=this._onTapOverlay).call(e,this)),this._cleanupQueue.push((function(){n.destroy()}));var i=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];Kd(i).call(i,(function(t){n.on(t,(function(t){t.srcEvent.stopPropagation()}))})),document&&document.body&&(this._onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||r.deactivate()},document.body.addEventListener("click",this._onClick),this._cleanupQueue.push((function(){document.body.removeEventListener("click",r._onClick)}))),this._escListener=function(t){("key"in t?"Escape"===t.key:27===t.keyCode)&&r.deactivate()}}Hm(dw.prototype),dw.current=null,dw.prototype.destroy=function(){var t,e;this.deactivate();var r,n=ow(cv(t=Bv(e=this._cleanupQueue).call(e,0)).call(t));try{for(n.s();!(r=n.n()).done;){(0,r.value)()}}catch(t){n.e(t)}finally{n.f()}},dw.prototype.activate=function(){dw.current&&dw.current.deactivate(),dw.current=this,this.active=!0,this._dom.overlay.style.display="none",this._dom.container.classList.add("vis-active"),this.emit("change"),this.emit("activate"),document.body.addEventListener("keydown",this._escListener)},dw.prototype.deactivate=function(){this.active=!1,this._dom.overlay.style.display="block",this._dom.container.classList.remove("vis-active"),document.body.removeEventListener("keydown",this._escListener),this.emit("change"),this.emit("deactivate")},dw.prototype._onTapOverlay=function(t){this.activate(),t.srcEvent.stopPropagation()};var vw=/^\/?Date\((-?\d+)/i,gw=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,yw=/^#?([a-f\d])([a-f\d])([a-f\d])$/i,mw=/^rgb\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *\)$/i,bw=/^rgba\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *([01]|0?\.\d+) *\)$/i;function xw(t){return t instanceof Number||"number"==typeof t}function ww(t){return t instanceof String||"string"==typeof t}function _w(t){return"object"===Df(t)&&null!==t}function kw(t,e,r,n){var i=!1;!0===n&&(i=null===e[r]&&void 0!==t[r]),i?delete t[r]:t[r]=e[r]}var Cw=ng;function Ew(t,e,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(qp(r))throw new TypeError("Arrays are not supported by deepExtend");for(var i=0;i<t.length;i++){var o=t[i];if(Object.prototype.hasOwnProperty.call(r,o))if(r[o]&&r[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?Sw(e[o],r[o],!1,n):kw(e,r,o,n);else{if(qp(r[o]))throw new TypeError("Arrays are not supported by deepExtend");kw(e,r,o,n)}}return e}function Sw(t,e){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var i in e)if(Object.prototype.hasOwnProperty.call(e,i)||!0===r)if("object"===Df(e[i])&&null!==e[i]&&Fg(e[i])===Object.prototype)void 0===t[i]?t[i]=Sw({},e[i],r):"object"===Df(t[i])&&null!==t[i]&&Fg(t[i])===Object.prototype?Sw(t[i],e[i],r):kw(t,e,i,n);else if(qp(e[i])){var o;t[i]=Gp(o=e[i]).call(o)}else kw(t,e,i,n);return t}function Tw(t,e){var r;return Np(r=[]).call(r,Ap(t),[e])}function Ow(t){return Gp(t).call(t)}var Pw=ey;function Aw(t,e,r,n){var i;t.addEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&Tg(i=navigator.userAgent).call(i,"Firefox")&&(e="DOMMouseScroll"),t.addEventListener(e,r,n)):t.attachEvent("on"+e,r)}function Dw(t,e,r,n){var i;t.removeEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&Tg(i=navigator.userAgent).call(i,"Firefox")&&(e="DOMMouseScroll"),t.removeEventListener(e,r,n)):t.detachEvent("on"+e,r)}function Lw(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)}var Rw={asBoolean:function(t,e){return"function"==typeof t&&(t=t()),null!=t?0!=t:e||null},asNumber:function(t,e){return"function"==typeof t&&(t=t()),null!=t?Number(t)||e||null:e||null},asString:function(t,e){return"function"==typeof t&&(t=t()),null!=t?String(t):e||null},asSize:function(t,e){return"function"==typeof t&&(t=t()),ww(t)?t:xw(t)?t+"px":e||null},asElement:function(t,e){return"function"==typeof t&&(t=t()),t||e||null}};function Fw(t){var e;switch(t.length){case 3:case 4:return(e=yw.exec(t))?{r:Sy(e[1]+e[1],16),g:Sy(e[2]+e[2],16),b:Sy(e[3]+e[3],16)}:null;case 6:case 7:return(e=gw.exec(t))?{r:Sy(e[1],16),g:Sy(e[2],16),b:Sy(e[3],16)}:null;default:return null}}function Mw(t,e,r){var n;return"#"+Gp(n=((1<<24)+(t<<16)+(e<<8)+r).toString(16)).call(n,1)}function jw(t,e,r){t/=255,e/=255,r/=255;var n=Math.min(t,Math.min(e,r)),i=Math.max(t,Math.max(e,r));return n===i?{h:0,s:0,v:n}:{h:60*((t===n?3:r===n?1:5)-(t===n?e-r:r===n?t-e:r-t)/(i-n))/360,s:(i-n)/i,v:i}}var Iw={split:function(t){var e,r={};return Kd(e=t.split(";")).call(e,(function(t){if(""!=Qy(t).call(t)){var e,n,i=t.split(":"),o=Qy(e=i[0]).call(e),a=Qy(n=i[1]).call(n);r[o]=a}})),r},join:function(t){var e;return nd(e=ld(t)).call(e,(function(e){return e+": "+t[e]})).join("; ")}};function zw(t,e,r){var n,i,o,a=Math.floor(6*t),s=6*t-a,u=r*(1-e),l=r*(1-s*e),c=r*(1-(1-s)*e);switch(a%6){case 0:n=r,i=c,o=u;break;case 1:n=l,i=r,o=u;break;case 2:n=u,i=r,o=c;break;case 3:n=u,i=l,o=r;break;case 4:n=c,i=u,o=r;break;case 5:n=r,i=u,o=l}return{r:Math.floor(255*n),g:Math.floor(255*i),b:Math.floor(255*o)}}function Bw(t,e,r){var n=zw(t,e,r);return Mw(n.r,n.g,n.b)}function Nw(t){var e=Fw(t);if(!e)throw new TypeError("'".concat(t,"' is not a valid color."));return jw(e.r,e.g,e.b)}function Ww(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}function Gw(t){return mw.test(t)}function Yw(t){return bw.test(t)}function Vw(t){if(null===t||"object"!==Df(t))return null;if(t instanceof Element)return t;var e=rm(t);for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&"object"==Df(t[r])&&(e[r]=Vw(t[r]));return e}var Xw={black:"#000000",navy:"#000080",darkblue:"#00008B",mediumblue:"#0000CD",blue:"#0000FF",darkgreen:"#006400",green:"#008000",teal:"#008080",darkcyan:"#008B8B",deepskyblue:"#00BFFF",darkturquoise:"#00CED1",mediumspringgreen:"#00FA9A",lime:"#00FF00",springgreen:"#00FF7F",aqua:"#00FFFF",cyan:"#00FFFF",midnightblue:"#191970",dodgerblue:"#1E90FF",lightseagreen:"#20B2AA",forestgreen:"#228B22",seagreen:"#2E8B57",darkslategray:"#2F4F4F",limegreen:"#32CD32",mediumseagreen:"#3CB371",turquoise:"#40E0D0",royalblue:"#4169E1",steelblue:"#4682B4",darkslateblue:"#483D8B",mediumturquoise:"#48D1CC",indigo:"#4B0082",darkolivegreen:"#556B2F",cadetblue:"#5F9EA0",cornflowerblue:"#6495ED",mediumaquamarine:"#66CDAA",dimgray:"#696969",slateblue:"#6A5ACD",olivedrab:"#6B8E23",slategray:"#708090",lightslategray:"#778899",mediumslateblue:"#7B68EE",lawngreen:"#7CFC00",chartreuse:"#7FFF00",aquamarine:"#7FFFD4",maroon:"#800000",purple:"#800080",olive:"#808000",gray:"#808080",skyblue:"#87CEEB",lightskyblue:"#87CEFA",blueviolet:"#8A2BE2",darkred:"#8B0000",darkmagenta:"#8B008B",saddlebrown:"#8B4513",darkseagreen:"#8FBC8F",lightgreen:"#90EE90",mediumpurple:"#9370D8",darkviolet:"#9400D3",palegreen:"#98FB98",darkorchid:"#9932CC",yellowgreen:"#9ACD32",sienna:"#A0522D",brown:"#A52A2A",darkgray:"#A9A9A9",lightblue:"#ADD8E6",greenyellow:"#ADFF2F",paleturquoise:"#AFEEEE",lightsteelblue:"#B0C4DE",powderblue:"#B0E0E6",firebrick:"#B22222",darkgoldenrod:"#B8860B",mediumorchid:"#BA55D3",rosybrown:"#BC8F8F",darkkhaki:"#BDB76B",silver:"#C0C0C0",mediumvioletred:"#C71585",indianred:"#CD5C5C",peru:"#CD853F",chocolate:"#D2691E",tan:"#D2B48C",lightgrey:"#D3D3D3",palevioletred:"#D87093",thistle:"#D8BFD8",orchid:"#DA70D6",goldenrod:"#DAA520",crimson:"#DC143C",gainsboro:"#DCDCDC",plum:"#DDA0DD",burlywood:"#DEB887",lightcyan:"#E0FFFF",lavender:"#E6E6FA",darksalmon:"#E9967A",violet:"#EE82EE",palegoldenrod:"#EEE8AA",lightcoral:"#F08080",khaki:"#F0E68C",aliceblue:"#F0F8FF",honeydew:"#F0FFF0",azure:"#F0FFFF",sandybrown:"#F4A460",wheat:"#F5DEB3",beige:"#F5F5DC",whitesmoke:"#F5F5F5",mintcream:"#F5FFFA",ghostwhite:"#F8F8FF",salmon:"#FA8072",antiquewhite:"#FAEBD7",linen:"#FAF0E6",lightgoldenrodyellow:"#FAFAD2",oldlace:"#FDF5E6",red:"#FF0000",fuchsia:"#FF00FF",magenta:"#FF00FF",deeppink:"#FF1493",orangered:"#FF4500",tomato:"#FF6347",hotpink:"#FF69B4",coral:"#FF7F50",darkorange:"#FF8C00",lightsalmon:"#FFA07A",orange:"#FFA500",lightpink:"#FFB6C1",pink:"#FFC0CB",gold:"#FFD700",peachpuff:"#FFDAB9",navajowhite:"#FFDEAD",moccasin:"#FFE4B5",bisque:"#FFE4C4",mistyrose:"#FFE4E1",blanchedalmond:"#FFEBCD",papayawhip:"#FFEFD5",lavenderblush:"#FFF0F5",seashell:"#FFF5EE",cornsilk:"#FFF8DC",lemonchiffon:"#FFFACD",floralwhite:"#FFFAF0",snow:"#FFFAFA",yellow:"#FFFF00",lightyellow:"#FFFFE0",ivory:"#FFFFF0",white:"#FFFFFF"},Uw=function(){function t(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;xh(this,t),this.pixelRatio=e,this.generated=!1,this.centerCoordinates={x:144.5,y:144.5},this.r=289*.49,this.color={r:255,g:255,b:255,a:1},this.hueCircle=void 0,this.initialColor={r:255,g:255,b:255,a:1},this.previousColor=void 0,this.applied=!1,this.updateCallback=function(){},this.closeCallback=function(){},this._create()}return Nf(t,[{key:"insertTo",value:function(t){void 0!==this.hammer&&(this.hammer.destroy(),this.hammer=void 0),this.container=t,this.container.appendChild(this.frame),this._bindHammer(),this._setSize()}},{key:"setUpdateCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker update callback is not a function.");this.updateCallback=t}},{key:"setCloseCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker closing callback is not a function.");this.closeCallback=t}},{key:"_isColorString",value:function(t){if("string"==typeof t)return Xw[t]}},{key:"setColor",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if("none"!==t){var r,n=this._isColorString(t);if(void 0!==n&&(t=n),!0===ww(t)){if(!0===Gw(t)){var i=t.substr(4).substr(0,t.length-5).split(",");r={r:i[0],g:i[1],b:i[2],a:1}}else if(!0===Yw(t)){var o=t.substr(5).substr(0,t.length-6).split(",");r={r:o[0],g:o[1],b:o[2],a:o[3]}}else if(!0===Ww(t)){var a=Fw(t);r={r:a.r,g:a.g,b:a.b,a:1}}}else if(t instanceof Object&&void 0!==t.r&&void 0!==t.g&&void 0!==t.b){var s=void 0!==t.a?t.a:"1.0";r={r:t.r,g:t.g,b:t.b,a:s}}if(void 0===r)throw new Error("Unknown color passed to the colorPicker. Supported are strings: rgb, hex, rgba. Object: rgb ({r:r,g:g,b:b,[a:a]}). Supplied: "+lm(t));this._setColor(r,e)}}},{key:"show",value:function(){void 0!==this.closeCallback&&(this.closeCallback(),this.closeCallback=void 0),this.applied=!1,this.frame.style.display="block",this._generateHueCircle()}},{key:"_hide",value:function(){var t=this;!0===(!(arguments.length>0&&void 0!==arguments[0])||arguments[0])&&(this.previousColor=ng({},this.color)),!0===this.applied&&this.updateCallback(this.initialColor),this.frame.style.display="none",Lm((function(){void 0!==t.closeCallback&&(t.closeCallback(),t.closeCallback=void 0)}),0)}},{key:"_save",value:function(){this.updateCallback(this.color),this.applied=!1,this._hide()}},{key:"_apply",value:function(){this.applied=!0,this.updateCallback(this.color),this._updatePicker(this.color)}},{key:"_loadLast",value:function(){void 0!==this.previousColor?this.setColor(this.previousColor,!1):alert("There is no last color to load...")}},{key:"_setColor",value:function(t){!0===(!(arguments.length>1&&void 0!==arguments[1])||arguments[1])&&(this.initialColor=ng({},t)),this.color=t;var e=jw(t.r,t.g,t.b),r=2*Math.PI,n=this.r*e.s,i=this.centerCoordinates.x+n*Math.sin(r*e.h),o=this.centerCoordinates.y+n*Math.cos(r*e.h);this.colorPickerSelector.style.left=i-.5*this.colorPickerSelector.clientWidth+"px",this.colorPickerSelector.style.top=o-.5*this.colorPickerSelector.clientHeight+"px",this._updatePicker(t)}},{key:"_setOpacity",value:function(t){this.color.a=t/100,this._updatePicker(this.color)}},{key:"_setBrightness",value:function(t){var e=jw(this.color.r,this.color.g,this.color.b);e.v=t/100;var r=zw(e.h,e.s,e.v);r.a=this.color.a,this.color=r,this._updatePicker()}},{key:"_updatePicker",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.color,e=jw(t.r,t.g,t.b),r=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(r.webkitBackingStorePixelRatio||r.mozBackingStorePixelRatio||r.msBackingStorePixelRatio||r.oBackingStorePixelRatio||r.backingStorePixelRatio||1)),r.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var n=this.colorPickerCanvas.clientWidth,i=this.colorPickerCanvas.clientHeight;r.clearRect(0,0,n,i),r.putImageData(this.hueCircle,0,0),r.fillStyle="rgba(0,0,0,"+(1-e.v)+")",r.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),Vm(r).call(r),this.brightnessRange.value=100*e.v,this.opacityRange.value=100*t.a,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}},{key:"_setSize",value:function(){this.colorPickerCanvas.style.width="100%",this.colorPickerCanvas.style.height="100%",this.colorPickerCanvas.width=289*this.pixelRatio,this.colorPickerCanvas.height=289*this.pixelRatio}},{key:"_create",value:function(){var t,e,r,n;if(this.frame=document.createElement("div"),this.frame.className="vis-color-picker",this.colorPickerDiv=document.createElement("div"),this.colorPickerSelector=document.createElement("div"),this.colorPickerSelector.className="vis-selector",this.colorPickerDiv.appendChild(this.colorPickerSelector),this.colorPickerCanvas=document.createElement("canvas"),this.colorPickerDiv.appendChild(this.colorPickerCanvas),this.colorPickerCanvas.getContext){var i=this.colorPickerCanvas.getContext("2d");this.pixelRatio=(window.devicePixelRatio||1)/(i.webkitBackingStorePixelRatio||i.mozBackingStorePixelRatio||i.msBackingStorePixelRatio||i.oBackingStorePixelRatio||i.backingStorePixelRatio||1),this.colorPickerCanvas.getContext("2d").setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}else{var o=document.createElement("DIV");o.style.color="red",o.style.fontWeight="bold",o.style.padding="10px",o.innerText="Error: your browser does not support HTML canvas",this.colorPickerCanvas.appendChild(o)}this.colorPickerDiv.className="vis-color",this.opacityDiv=document.createElement("div"),this.opacityDiv.className="vis-opacity",this.brightnessDiv=document.createElement("div"),this.brightnessDiv.className="vis-brightness",this.arrowDiv=document.createElement("div"),this.arrowDiv.className="vis-arrow",this.opacityRange=document.createElement("input");try{this.opacityRange.type="range",this.opacityRange.min="0",this.opacityRange.max="100"}catch(t){}this.opacityRange.value="100",this.opacityRange.className="vis-range",this.brightnessRange=document.createElement("input");try{this.brightnessRange.type="range",this.brightnessRange.min="0",this.brightnessRange.max="100"}catch(t){}this.brightnessRange.value="100",this.brightnessRange.className="vis-range",this.opacityDiv.appendChild(this.opacityRange),this.brightnessDiv.appendChild(this.brightnessRange);var a=this;this.opacityRange.onchange=function(){a._setOpacity(this.value)},this.opacityRange.oninput=function(){a._setOpacity(this.value)},this.brightnessRange.onchange=function(){a._setBrightness(this.value)},this.brightnessRange.oninput=function(){a._setBrightness(this.value)},this.brightnessLabel=document.createElement("div"),this.brightnessLabel.className="vis-label vis-brightness",this.brightnessLabel.innerText="brightness:",this.opacityLabel=document.createElement("div"),this.opacityLabel.className="vis-label vis-opacity",this.opacityLabel.innerText="opacity:",this.newColorDiv=document.createElement("div"),this.newColorDiv.className="vis-new-color",this.newColorDiv.innerText="new",this.initialColorDiv=document.createElement("div"),this.initialColorDiv.className="vis-initial-color",this.initialColorDiv.innerText="initial",this.cancelButton=document.createElement("div"),this.cancelButton.className="vis-button vis-cancel",this.cancelButton.innerText="cancel",this.cancelButton.onclick=Id(t=this._hide).call(t,this,!1),this.applyButton=document.createElement("div"),this.applyButton.className="vis-button vis-apply",this.applyButton.innerText="apply",this.applyButton.onclick=Id(e=this._apply).call(e,this),this.saveButton=document.createElement("div"),this.saveButton.className="vis-button vis-save",this.saveButton.innerText="save",this.saveButton.onclick=Id(r=this._save).call(r,this),this.loadButton=document.createElement("div"),this.loadButton.className="vis-button vis-load",this.loadButton.innerText="load last",this.loadButton.onclick=Id(n=this._loadLast).call(n,this),this.frame.appendChild(this.colorPickerDiv),this.frame.appendChild(this.arrowDiv),this.frame.appendChild(this.brightnessLabel),this.frame.appendChild(this.brightnessDiv),this.frame.appendChild(this.opacityLabel),this.frame.appendChild(this.opacityDiv),this.frame.appendChild(this.newColorDiv),this.frame.appendChild(this.initialColorDiv),this.frame.appendChild(this.cancelButton),this.frame.appendChild(this.applyButton),this.frame.appendChild(this.saveButton),this.frame.appendChild(this.loadButton)}},{key:"_bindHammer",value:function(){var t=this;this.drag={},this.pinch={},this.hammer=new pw(this.colorPickerCanvas),this.hammer.get("pinch").set({enable:!0}),this.hammer.on("hammer.input",(function(e){e.isFirst&&t._moveSelector(e)})),this.hammer.on("tap",(function(e){t._moveSelector(e)})),this.hammer.on("panstart",(function(e){t._moveSelector(e)})),this.hammer.on("panmove",(function(e){t._moveSelector(e)})),this.hammer.on("panend",(function(e){t._moveSelector(e)}))}},{key:"_generateHueCircle",value:function(){if(!1===this.generated){var t=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(t.webkitBackingStorePixelRatio||t.mozBackingStorePixelRatio||t.msBackingStorePixelRatio||t.oBackingStorePixelRatio||t.backingStorePixelRatio||1)),t.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var e,r,n,i,o=this.colorPickerCanvas.clientWidth,a=this.colorPickerCanvas.clientHeight;t.clearRect(0,0,o,a),this.centerCoordinates={x:.5*o,y:.5*a},this.r=.49*o;var s,u=2*Math.PI/360,l=1/this.r;for(n=0;n<360;n++)for(i=0;i<this.r;i++)e=this.centerCoordinates.x+i*Math.sin(u*n),r=this.centerCoordinates.y+i*Math.cos(u*n),s=zw(.002777777777777778*n,i*l,1),t.fillStyle="rgb("+s.r+","+s.g+","+s.b+")",t.fillRect(e-.5,r-.5,2,2);t.strokeStyle="rgba(0,0,0,1)",t.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),t.stroke(),this.hueCircle=t.getImageData(0,0,o,a)}this.generated=!0}},{key:"_moveSelector",value:function(t){var e=this.colorPickerDiv.getBoundingClientRect(),r=t.center.x-e.left,n=t.center.y-e.top,i=.5*this.colorPickerDiv.clientHeight,o=.5*this.colorPickerDiv.clientWidth,a=r-o,s=n-i,u=Math.atan2(a,s),l=.98*Math.min(Math.sqrt(a*a+s*s),o),c=Math.cos(u)*l+i,h=Math.sin(u)*l+o;this.colorPickerSelector.style.top=c-.5*this.colorPickerSelector.clientHeight+"px",this.colorPickerSelector.style.left=h-.5*this.colorPickerSelector.clientWidth+"px";var f=u/(2*Math.PI);f=f<0?f+1:f;var p=l/this.r,d=jw(this.color.r,this.color.g,this.color.b);d.h=f,d.s=p;var v=zw(d.h,d.s,d.v);v.a=this.color.a,this.color=v,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}}]),t}();function Hw(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];if(e.length<1)throw new TypeError("Invalid arguments.");if(1===e.length)return document.createTextNode(e[0]);var n=document.createElement(e[0]);return n.appendChild(Hw.apply(void 0,Ap(Gp(e).call(e,1)))),n}var qw,Zw=function(){function t(e,r,n){var i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1,o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:function(){return!1};xh(this,t),this.parent=e,this.changedOptions=[],this.container=r,this.allowCreation=!1,this.hideOption=o,this.options={},this.initialized=!1,this.popupCounter=0,this.defaultOptions={enabled:!1,filter:!0,container:void 0,showButton:!0},ng(this.options,this.defaultOptions),this.configureOptions=n,this.moduleOptions={},this.domElements=[],this.popupDiv={},this.popupLimit=5,this.popupHistory={},this.colorPicker=new Uw(i),this.wrapper=void 0}return Nf(t,[{key:"setOptions",value:function(t){if(void 0!==t){this.popupHistory={},this._removePopup();var e=!0;if("string"==typeof t)this.options.filter=t;else if(qp(t))this.options.filter=t.join();else if("object"===Df(t)){if(null==t)throw new TypeError("options cannot be null");void 0!==t.container&&(this.options.container=t.container),void 0!==Yg(t)&&(this.options.filter=Yg(t)),void 0!==t.showButton&&(this.options.showButton=t.showButton),void 0!==t.enabled&&(e=t.enabled)}else"boolean"==typeof t?(this.options.filter=!0,e=t):"function"==typeof t&&(this.options.filter=t,e=!0);!1===Yg(this.options)&&(e=!1),this.options.enabled=e}this._clean()}},{key:"setModuleOptions",value:function(t){this.moduleOptions=t,!0===this.options.enabled&&(this._clean(),void 0!==this.options.container&&(this.container=this.options.container),this._create())}},{key:"_create",value:function(){this._clean(),this.changedOptions=[];var t=Yg(this.options),e=0,r=!1;for(var n in this.configureOptions)Object.prototype.hasOwnProperty.call(this.configureOptions,n)&&(this.allowCreation=!1,r=!1,"function"==typeof t?r=(r=t(n,[]))||this._handleObject(this.configureOptions[n],[n],!0):!0!==t&&-1===By(t).call(t,n)||(r=!0),!1!==r&&(this.allowCreation=!0,e>0&&this._makeItem([]),this._makeHeader(n),this._handleObject(this.configureOptions[n],[n])),e++);this._makeButton(),this._push()}},{key:"_push",value:function(){this.wrapper=document.createElement("div"),this.wrapper.className="vis-configuration-wrapper",this.container.appendChild(this.wrapper);for(var t=0;t<this.domElements.length;t++)this.wrapper.appendChild(this.domElements[t]);this._showPopupIfNeeded()}},{key:"_clean",value:function(){for(var t=0;t<this.domElements.length;t++)this.wrapper.removeChild(this.domElements[t]);void 0!==this.wrapper&&(this.container.removeChild(this.wrapper),this.wrapper=void 0),this.domElements=[],this._removePopup()}},{key:"_getValue",value:function(t){for(var e=this.moduleOptions,r=0;r<t.length;r++){if(void 0===e[t[r]]){e=void 0;break}e=e[t[r]]}return e}},{key:"_makeItem",value:function(t){if(!0===this.allowCreation){var e=document.createElement("div");e.className="vis-configuration vis-config-item vis-config-s"+t.length;for(var r=arguments.length,n=new Array(r>1?r-1:0),i=1;i<r;i++)n[i-1]=arguments[i];return Kd(n).call(n,(function(t){e.appendChild(t)})),this.domElements.push(e),this.domElements.length}return 0}},{key:"_makeHeader",value:function(t){var e=document.createElement("div");e.className="vis-configuration vis-config-header",e.innerText=t,this._makeItem([],e)}},{key:"_makeLabel",value:function(t,e){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=document.createElement("div");if(n.className="vis-configuration vis-config-label vis-config-s"+e.length,!0===r){for(;n.firstChild;)n.removeChild(n.firstChild);n.appendChild(Hw("i","b",t))}else n.innerText=t+":";return n}},{key:"_makeDropdown",value:function(t,e,r){var n=document.createElement("select");n.className="vis-configuration vis-config-select";var i=0;void 0!==e&&-1!==By(t).call(t,e)&&(i=By(t).call(t,e));for(var o=0;o<t.length;o++){var a=document.createElement("option");a.value=t[o],o===i&&(a.selected="selected"),a.innerText=t[o],n.appendChild(a)}var s=this;n.onchange=function(){s._update(this.value,r)};var u=this._makeLabel(r[r.length-1],r);this._makeItem(r,u,n)}},{key:"_makeRange",value:function(t,e,r){var n=t[0],i=t[1],o=t[2],a=t[3],s=document.createElement("input");s.className="vis-configuration vis-config-range";try{s.type="range",s.min=i,s.max=o}catch(t){}s.step=a;var u="",l=0;if(void 0!==e){var c=1.2;e<0&&e*c<i?(s.min=Math.ceil(e*c),l=s.min,u="range increased"):e/c<i&&(s.min=Math.ceil(e/c),l=s.min,u="range increased"),e*c>o&&1!==o&&(s.max=Math.ceil(e*c),l=s.max,u="range increased"),s.value=e}else s.value=n;var h=document.createElement("input");h.className="vis-configuration vis-config-rangeinput",h.value=s.value;var f=this;s.onchange=function(){h.value=this.value,f._update(Number(this.value),r)},s.oninput=function(){h.value=this.value};var p=this._makeLabel(r[r.length-1],r),d=this._makeItem(r,p,s,h);""!==u&&this.popupHistory[d]!==l&&(this.popupHistory[d]=l,this._setupPopup(u,d))}},{key:"_makeButton",value:function(){var t=this;if(!0===this.options.showButton){var e=document.createElement("div");e.className="vis-configuration vis-config-button",e.innerText="generate options",e.onclick=function(){t._printOptions()},e.onmouseover=function(){e.className="vis-configuration vis-config-button hover"},e.onmouseout=function(){e.className="vis-configuration vis-config-button"},this.optionsContainer=document.createElement("div"),this.optionsContainer.className="vis-configuration vis-config-option-container",this.domElements.push(this.optionsContainer),this.domElements.push(e)}}},{key:"_setupPopup",value:function(t,e){var r=this;if(!0===this.initialized&&!0===this.allowCreation&&this.popupCounter<this.popupLimit){var n=document.createElement("div");n.id="vis-configuration-popup",n.className="vis-configuration-popup",n.innerText=t,n.onclick=function(){r._removePopup()},this.popupCounter+=1,this.popupDiv={html:n,index:e}}}},{key:"_removePopup",value:function(){void 0!==this.popupDiv.html&&(this.popupDiv.html.parentNode.removeChild(this.popupDiv.html),clearTimeout(this.popupDiv.hideTimeout),clearTimeout(this.popupDiv.deleteTimeout),this.popupDiv={})}},{key:"_showPopupIfNeeded",value:function(){var t=this;if(void 0!==this.popupDiv.html){var e=this.domElements[this.popupDiv.index].getBoundingClientRect();this.popupDiv.html.style.left=e.left+"px",this.popupDiv.html.style.top=e.top-30+"px",document.body.appendChild(this.popupDiv.html),this.popupDiv.hideTimeout=Lm((function(){t.popupDiv.html.style.opacity=0}),1500),this.popupDiv.deleteTimeout=Lm((function(){t._removePopup()}),1800)}}},{key:"_makeCheckbox",value:function(t,e,r){var n=document.createElement("input");n.type="checkbox",n.className="vis-configuration vis-config-checkbox",n.checked=t,void 0!==e&&(n.checked=e,e!==t&&("object"===Df(t)?e!==t.enabled&&this.changedOptions.push({path:r,value:e}):this.changedOptions.push({path:r,value:e})));var i=this;n.onchange=function(){i._update(this.checked,r)};var o=this._makeLabel(r[r.length-1],r);this._makeItem(r,o,n)}},{key:"_makeTextInput",value:function(t,e,r){var n=document.createElement("input");n.type="text",n.className="vis-configuration vis-config-text",n.value=e,e!==t&&this.changedOptions.push({path:r,value:e});var i=this;n.onchange=function(){i._update(this.value,r)};var o=this._makeLabel(r[r.length-1],r);this._makeItem(r,o,n)}},{key:"_makeColorField",value:function(t,e,r){var n=this,i=t[1],o=document.createElement("div");"none"!==(e=void 0===e?i:e)?(o.className="vis-configuration vis-config-colorBlock",o.style.backgroundColor=e):o.className="vis-configuration vis-config-colorBlock none",e=void 0===e?i:e,o.onclick=function(){n._showColorPicker(e,o,r)};var a=this._makeLabel(r[r.length-1],r);this._makeItem(r,a,o)}},{key:"_showColorPicker",value:function(t,e,r){var n=this;e.onclick=function(){},this.colorPicker.insertTo(e),this.colorPicker.show(),this.colorPicker.setColor(t),this.colorPicker.setUpdateCallback((function(t){var i="rgba("+t.r+","+t.g+","+t.b+","+t.a+")";e.style.backgroundColor=i,n._update(i,r)})),this.colorPicker.setCloseCallback((function(){e.onclick=function(){n._showColorPicker(t,e,r)}}))}},{key:"_handleObject",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=!1,i=Yg(this.options),o=!1;for(var a in t)if(Object.prototype.hasOwnProperty.call(t,a)){n=!0;var s=t[a],u=Tw(e,a);if("function"==typeof i&&!1===(n=i(a,e))&&!qp(s)&&"string"!=typeof s&&"boolean"!=typeof s&&s instanceof Object&&(this.allowCreation=!1,n=this._handleObject(s,u,!0),this.allowCreation=!1===r),!1!==n){o=!0;var l=this._getValue(u);if(qp(s))this._handleArray(s,l,u);else if("string"==typeof s)this._makeTextInput(s,l,u);else if("boolean"==typeof s)this._makeCheckbox(s,l,u);else if(s instanceof Object){if(!this.hideOption(e,a,this.moduleOptions))if(void 0!==s.enabled){var c=Tw(u,"enabled"),h=this._getValue(c);if(!0===h){var f=this._makeLabel(a,u,!0);this._makeItem(u,f),o=this._handleObject(s,u)||o}else this._makeCheckbox(s,h,u)}else{var p=this._makeLabel(a,u,!0);this._makeItem(u,p),o=this._handleObject(s,u)||o}}else console.error("dont know how to handle",s,a,u)}}return o}},{key:"_handleArray",value:function(t,e,r){"string"==typeof t[0]&&"color"===t[0]?(this._makeColorField(t,e,r),t[1]!==e&&this.changedOptions.push({path:r,value:e})):"string"==typeof t[0]?(this._makeDropdown(t,e,r),t[0]!==e&&this.changedOptions.push({path:r,value:e})):"number"==typeof t[0]&&(this._makeRange(t,e,r),t[0]!==e&&this.changedOptions.push({path:r,value:Number(e)}))}},{key:"_update",value:function(t,e){var r=this._constructOptions(t,e);this.parent.body&&this.parent.body.emitter&&this.parent.body.emitter.emit&&this.parent.body.emitter.emit("configChange",r),this.initialized=!0,this.parent.setOptions(r)}},{key:"_constructOptions",value:function(t,e){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=r;t="false"!==(t="true"===t||t)&&t;for(var i=0;i<e.length;i++)"global"!==e[i]&&(void 0===n[e[i]]&&(n[e[i]]={}),i!==e.length-1?n=n[e[i]]:n[e[i]]=t);return r}},{key:"_printOptions",value:function(){for(var t=this.getOptions();this.optionsContainer.firstChild;)this.optionsContainer.removeChild(this.optionsContainer.firstChild);this.optionsContainer.appendChild(Hw("pre","const options = "+lm(t,null,2)))}},{key:"getOptions",value:function(){for(var t={},e=0;e<this.changedOptions.length;e++)this._constructOptions(this.changedOptions[e].value,this.changedOptions[e].path,t);return t}}]),t}(),$w=function(){function t(e,r){xh(this,t),this.container=e,this.overflowMethod=r||"cap",this.x=0,this.y=0,this.padding=5,this.hidden=!1,this.frame=document.createElement("div"),this.frame.className="vis-tooltip",this.container.appendChild(this.frame)}return Nf(t,[{key:"setPosition",value:function(t,e){this.x=Sy(t),this.y=Sy(e)}},{key:"setText",value:function(t){if(t instanceof Element){for(;this.frame.firstChild;)this.frame.removeChild(this.frame.firstChild);this.frame.appendChild(t)}else this.frame.innerText=t}},{key:"show",value:function(t){if(void 0===t&&(t=!0),!0===t){var e=this.frame.clientHeight,r=this.frame.clientWidth,n=this.frame.parentNode.clientHeight,i=this.frame.parentNode.clientWidth,o=0,a=0;if("flip"==this.overflowMethod){var s=!1,u=!0;this.y-e<this.padding&&(u=!1),this.x+r>i-this.padding&&(s=!0),o=s?this.x-r:this.x,a=u?this.y-e:this.y}else(a=this.y-e)+e+this.padding>n&&(a=n-e-this.padding),a<this.padding&&(a=this.padding),(o=this.x)+r+this.padding>i&&(o=i-r-this.padding),o<this.padding&&(o=this.padding);this.frame.style.left=o+"px",this.frame.style.top=a+"px",this.frame.style.visibility="visible",this.hidden=!1}else this.hide()}},{key:"hide",value:function(){this.hidden=!0,this.frame.style.left="0",this.frame.style.top="0",this.frame.style.visibility="hidden"}},{key:"destroy",value:function(){this.frame.parentNode.removeChild(this.frame)}}]),t}(),Qw=!1,Kw="background: #FFeeee; color: #dd0000",Jw=function(){function t(){xh(this,t)}return Nf(t,null,[{key:"validate",value:function(e,r,n){Qw=!1,qw=r;var i=r;return void 0!==n&&(i=r[n]),t.parse(e,i,[]),Qw}},{key:"parse",value:function(e,r,n){for(var i in e)Object.prototype.hasOwnProperty.call(e,i)&&t.check(i,e,r,n)}},{key:"check",value:function(e,r,n,i){if(void 0!==n[e]||void 0!==n.__any__){var o=e,a=!0;void 0===n[e]&&void 0!==n.__any__&&(o="__any__",a="object"===t.getType(r[e]));var s=n[o];a&&void 0!==s.__type__&&(s=s.__type__),t.checkFields(e,r,n,o,s,i)}else t.getSuggestion(e,n,i)}},{key:"checkFields",value:function(e,r,n,i,o,a){var s=function(r){console.error("%c"+r+t.printLocation(a,e),Kw)},u=t.getType(r[e]),l=o[u];void 0!==l?"array"===t.getType(l)&&-1===By(l).call(l,r[e])?(s('Invalid option detected in "'+e+'". Allowed values are:'+t.print(l)+' not "'+r[e]+'". '),Qw=!0):"object"===u&&"__any__"!==i&&(a=Tw(a,e),t.parse(r[e],n[i],a)):void 0===o.any&&(s('Invalid type received for "'+e+'". Expected: '+t.print(ld(o))+". Received ["+u+'] "'+r[e]+'"'),Qw=!0)}},{key:"getType",value:function(t){var e=Df(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":qp(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,r,n){var i,o=t.findInOptions(e,r,n,!1),a=t.findInOptions(e,qw,[],!0);i=void 0!==o.indexMatch?" in "+t.printLocation(o.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+o.indexMatch+'"?\n\n':a.distance<=4&&o.distance>a.distance?" in "+t.printLocation(o.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(a.path,a.closestMatch,""):o.distance<=8?'. Did you mean "'+o.closestMatch+'"?'+t.printLocation(o.path,e):". Did you mean one of these: "+t.print(ld(r))+t.printLocation(n,e),console.error('%cUnknown option detected: "'+e+'"'+i,Kw),Qw=!0}},{key:"findInOptions",value:function(e,r,n){var i=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=1e9,a="",s=[],u=e.toLowerCase(),l=void 0;for(var c in r){var h=void 0;if(void 0!==r[c].__type__&&!0===i){var f=t.findInOptions(e,r[c],Tw(n,c));o>f.distance&&(a=f.closestMatch,s=f.path,o=f.distance,l=f.indexMatch)}else{var p;-1!==By(p=c.toLowerCase()).call(p,u)&&(l=c),o>(h=t.levenshteinDistance(e,c))&&(a=c,s=Ow(n),o=h)}}return{closestMatch:a,path:s,distance:o,indexMatch:l}}},{key:"printLocation",value:function(t,e){for(var r="\n\n"+(arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n")+"options = {\n",n=0;n<t.length;n++){for(var i=0;i<n+1;i++)r+="  ";r+=t[n]+": {\n"}for(var o=0;o<t.length+1;o++)r+="  ";r+=e+"\n";for(var a=0;a<t.length+1;a++){for(var s=0;s<t.length-a;s++)r+="  ";r+="}\n"}return r+"\n\n"}},{key:"print",value:function(t){return lm(t).replace(/(")|(\[)|(\])|(,"__type__")/g,"").replace(/(,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var r,n,i=[];for(r=0;r<=e.length;r++)i[r]=[r];for(n=0;n<=t.length;n++)i[0][n]=n;for(r=1;r<=e.length;r++)for(n=1;n<=t.length;n++)e.charAt(r-1)==t.charAt(n-1)?i[r][n]=i[r-1][n-1]:i[r][n]=Math.min(i[r-1][n-1]+1,Math.min(i[r][n-1]+1,i[r-1][n]+1));return i[e.length][t.length]}}]),t}(),t_=dw,e_=Uw,r_=Zw,n_=pw,i_=$w,o_=Kw,a_=Jw,s_=Object.freeze({__proto__:null,Activator:t_,Alea:function(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];return function(t){var e=function(){for(var t=function(){var t=4022871197;return function(e){for(var r=e.toString(),n=0;n<r.length;n++){var i=.02519603282416938*(t+=r.charCodeAt(n));i-=t=i>>>0,t=(i*=t)>>>0,t+=4294967296*(i-=t)}return 2.3283064365386963e-10*(t>>>0)}}(),e=t(" "),r=t(" "),n=t(" "),i=0;i<arguments.length;i++)(e-=t(i<0||arguments.length<=i?void 0:arguments[i]))<0&&(e+=1),(r-=t(i<0||arguments.length<=i?void 0:arguments[i]))<0&&(r+=1),(n-=t(i<0||arguments.length<=i?void 0:arguments[i]))<0&&(n+=1);return[e,r,n]}(t),r=Pp(e,3),n=r[0],i=r[1],o=r[2],a=1,s=function(){var t=2091639*n+2.3283064365386963e-10*a;return n=i,i=o,o=t-(a=0|t)};return s.uint32=function(){return 4294967296*s()},s.fract53=function(){return s()+11102230246251565e-32*(2097152*s()|0)},s.algorithm="Alea",s.seed=t,s.version="0.9",s}(e.length?e:[gd()])},ColorPicker:e_,Configurator:r_,DELETE:sw,HSVToHex:Bw,HSVToRGB:zw,Hammer:n_,Popup:i_,RGBToHSV:jw,RGBToHex:Mw,VALIDATOR_PRINT_STYLE:o_,Validator:a_,addClassName:function(t,e){var r=t.className.split(" "),n=e.split(" ");r=Np(r).call(r,Yg(n).call(n,(function(t){return!Tg(r).call(r,t)}))),t.className=r.join(" ")},addCssText:function(t,e){var r=Iw.split(t.style.cssText),n=Iw.split(e),i=iw(iw({},r),n);t.style.cssText=Iw.join(i)},addEventListener:Aw,binarySearchCustom:function(t,e,r,n){for(var i=0,o=0,a=t.length-1;o<=a&&i<1e4;){var s=Math.floor((o+a)/2),u=t[s],l=e(void 0===n?u[r]:u[r][n]);if(0==l)return s;-1==l?o=s+1:a=s-1,i++}return-1},binarySearchValue:function(t,e,r,n,i){var o,a,s,u,l=0,c=0,h=t.length-1;for(i=null!=i?i:function(t,e){return t==e?0:t<e?-1:1};c<=h&&l<1e4;){if(u=Math.floor(.5*(h+c)),o=t[Math.max(0,u-1)][r],a=t[u][r],s=t[Math.min(t.length-1,u+1)][r],0==i(a,e))return u;if(i(o,e)<0&&i(a,e)>0)return"before"==n?Math.max(0,u-1):u;if(i(a,e)<0&&i(s,e)>0)return"before"==n?u:Math.min(t.length-1,u+1);i(a,e)<0?c=u+1:h=u-1,l++}return-1},bridgeObject:Vw,copyAndExtendArray:Tw,copyArray:Ow,deepExtend:Sw,deepObjectAssign:lw,easingFunctions:{linear:function(t){return t},easeInQuad:function(t){return t*t},easeOutQuad:function(t){return t*(2-t)},easeInOutQuad:function(t){return t<.5?2*t*t:(4-2*t)*t-1},easeInCubic:function(t){return t*t*t},easeOutCubic:function(t){return--t*t*t+1},easeInOutCubic:function(t){return t<.5?4*t*t*t:(t-1)*(2*t-2)*(2*t-2)+1},easeInQuart:function(t){return t*t*t*t},easeOutQuart:function(t){return 1- --t*t*t*t},easeInOutQuart:function(t){return t<.5?8*t*t*t*t:1-8*--t*t*t*t},easeInQuint:function(t){return t*t*t*t*t},easeOutQuint:function(t){return 1+--t*t*t*t*t},easeInOutQuint:function(t){return t<.5?16*t*t*t*t*t:1+16*--t*t*t*t*t}},equalArray:function(t,e){if(t.length!==e.length)return!1;for(var r=0,n=t.length;r<n;r++)if(t[r]!=e[r])return!1;return!0},extend:Cw,fillIfDefined:function t(e,r){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2];for(var i in e)if(void 0!==r[i])if(null===r[i]||"object"!==Df(r[i]))kw(e,r,i,n);else{var o=e[i],a=r[i];_w(o)&&_w(a)&&t(o,a,n)}},forEach:function(t,e){if(qp(t))for(var r=t.length,n=0;n<r;n++)e(t[n],n,t);else for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&e(t[i],i,t)},getAbsoluteLeft:function(t){return t.getBoundingClientRect().left},getAbsoluteRight:function(t){return t.getBoundingClientRect().right},getAbsoluteTop:function(t){return t.getBoundingClientRect().top},getScrollBarWidth:function(){var t=document.createElement("p");t.style.width="100%",t.style.height="200px";var e=document.createElement("div");e.style.position="absolute",e.style.top="0px",e.style.left="0px",e.style.visibility="hidden",e.style.width="200px",e.style.height="150px",e.style.overflow="hidden",e.appendChild(t),document.body.appendChild(e);var r=t.offsetWidth;e.style.overflow="scroll";var n=t.offsetWidth;return r==n&&(n=e.clientWidth),document.body.removeChild(e),r-n},getTarget:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:window.event,e=null;return t&&(t.target?e=t.target:t.srcElement&&(e=t.srcElement)),e instanceof Element&&(null==e.nodeType||3!=e.nodeType||(e=e.parentNode)instanceof Element)?e:null},getType:function(t){var e=Df(t);return"object"===e?null===t?"null":t instanceof Boolean?"Boolean":t instanceof Number?"Number":t instanceof String?"String":qp(t)?"Array":t instanceof Date?"Date":"Object":"number"===e?"Number":"boolean"===e?"Boolean":"string"===e?"String":void 0===e?"undefined":e},hasParent:function(t,e){for(var r=t;r;){if(r===e)return!0;if(!r.parentNode)return!1;r=r.parentNode}return!1},hexToHSV:Nw,hexToRGB:Fw,insertSort:function(t,e){for(var r=0;r<t.length;r++){var n=t[r],i=void 0;for(i=r;i>0&&e(n,t[i-1])<0;i--)t[i]=t[i-1];t[i]=n}return t},isDate:function(t){if(t instanceof Date)return!0;if(ww(t)){if(vw.exec(t))return!0;if(!isNaN(Date.parse(t)))return!0}return!1},isNumber:xw,isObject:_w,isString:ww,isValidHex:Ww,isValidRGB:Gw,isValidRGBA:Yw,mergeOptions:function(t,e,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},i=function(t){return null!=t},o=function(t){return null!==t&&"object"===Df(t)};if(!o(t))throw new Error("Parameter mergeTarget must be an object");if(!o(e))throw new Error("Parameter options must be an object");if(!i(r))throw new Error("Parameter option must have a value");if(!o(n))throw new Error("Parameter globalOptions must be an object");var a=e[r],s=o(n)&&!function(t){for(var e in t)if(Object.prototype.hasOwnProperty.call(t,e))return!1;return!0}(n)?n[r]:void 0,u=s?s.enabled:void 0;if(void 0!==a){if("boolean"==typeof a)return o(t[r])||(t[r]={}),void(t[r].enabled=a);if(null===a&&!o(t[r])){if(!i(s))return;t[r]=rm(s)}if(o(a)){var l=!0;void 0!==a.enabled?l=a.enabled:void 0!==u&&(l=s.enabled),function(t,e,r){o(t[r])||(t[r]={});var n=e[r],i=t[r];for(var a in n)Object.prototype.hasOwnProperty.call(n,a)&&(i[a]=n[a])}(t,e,r),t[r].enabled=l}}},option:Rw,overrideOpacity:function(t,e){if(Tg(t).call(t,"rgba"))return t;if(Tg(t).call(t,"rgb")){var r=t.substr(By(t).call(t,"(")+1).replace(")","").split(",");return"rgba("+r[0]+","+r[1]+","+r[2]+","+e+")"}var n=Fw(t);return null==n?t:"rgba("+n.r+","+n.g+","+n.b+","+e+")"},parseColor:function(t,e){if(ww(t)){var r=t;if(Gw(r)){var n,i=nd(n=r.substr(4).substr(0,r.length-5).split(",")).call(n,(function(t){return Sy(t)}));r=Mw(i[0],i[1],i[2])}if(!0===Ww(r)){var o=Nw(r),a={h:o.h,s:.8*o.s,v:Math.min(1,1.02*o.v)},s={h:o.h,s:Math.min(1,1.25*o.s),v:.8*o.v},u=Bw(s.h,s.s,s.v),l=Bw(a.h,a.s,a.v);return{background:r,border:u,highlight:{background:l,border:u},hover:{background:l,border:u}}}return{background:r,border:r,highlight:{background:r,border:r},hover:{background:r,border:r}}}return e?{background:t.background||e.background,border:t.border||e.border,highlight:ww(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||e.highlight.background,border:t.highlight&&t.highlight.border||e.highlight.border},hover:ww(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||e.hover.border,background:t.hover&&t.hover.background||e.hover.background}}:{background:t.background||void 0,border:t.border||void 0,highlight:ww(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||void 0,border:t.highlight&&t.highlight.border||void 0},hover:ww(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||void 0,background:t.hover&&t.hover.background||void 0}}},preventDefault:Lw,pureDeepObjectAssign:uw,recursiveDOMDelete:function t(e){if(e)for(;!0===e.hasChildNodes();){var r=e.firstChild;r&&(t(r),e.removeChild(r))}},removeClassName:function(t,e){var r=t.className.split(" "),n=e.split(" ");r=Yg(r).call(r,(function(t){return!Tg(n).call(n,t)})),t.className=r.join(" ")},removeCssText:function(t,e){var r=Iw.split(t.style.cssText),n=Iw.split(e);for(var i in n)Object.prototype.hasOwnProperty.call(n,i)&&delete r[i];t.style.cssText=Iw.join(r)},removeEventListener:Dw,selectiveBridgeObject:function(t,e){if(null!==e&&"object"===Df(e)){for(var r=rm(e),n=0;n<t.length;n++)Object.prototype.hasOwnProperty.call(e,t[n])&&"object"==Df(e[t[n]])&&(r[t[n]]=Vw(e[t[n]]));return r}return null},selectiveDeepExtend:Ew,selectiveExtend:function(t,e){if(!qp(t))throw new Error("Array with property names expected as first argument");for(var r=arguments.length,n=new Array(r>2?r-2:0),i=2;i<r;i++)n[i-2]=arguments[i];for(var o=0,a=n;o<a.length;o++)for(var s=a[o],u=0;u<t.length;u++){var l=t[u];s&&Object.prototype.hasOwnProperty.call(s,l)&&(e[l]=s[l])}return e},selectiveNotDeepExtend:function(t,e,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(qp(r))throw new TypeError("Arrays are not supported by deepExtend");for(var i in r)if(Object.prototype.hasOwnProperty.call(r,i)&&!Tg(t).call(t,i))if(r[i]&&r[i].constructor===Object)void 0===e[i]&&(e[i]={}),e[i].constructor===Object?Sw(e[i],r[i]):kw(e,r,i,n);else if(qp(r[i])){e[i]=[];for(var o=0;o<r[i].length;o++)e[i].push(r[i][o])}else kw(e,r,i,n);return e},throttle:function(t){var e=!1;return function(){e||(e=!0,requestAnimationFrame((function(){e=!1,t()})))}},toArray:Pw,topMost:function(t,e){var r;qp(e)||(e=[e]);var n,i=ow(t);try{for(i.s();!(n=i.n()).done;){var o=n.value;if(o){r=o[e[0]];for(var a=1;a<e.length;a++)r&&(r=r[e[a]]);if(void 0!==r)break}}}catch(t){i.e(t)}finally{i.f()}return r},updateProperty:function(t,e,r){return t[e]!==r&&(t[e]=r,!0)}}),u_=n(s_),l_={};function c_(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}!function(t){t.prepareElements=function(t){for(var e in t)Object.prototype.hasOwnProperty.call(t,e)&&(t[e].redundant=t[e].used,t[e].used=[])},t.cleanupElements=function(t){for(var e in t)if(Object.prototype.hasOwnProperty.call(e)&&t[e].redundant){for(var r=0;r<t[e].redundant.length;r++)t[e].redundant[r].parentNode.removeChild(t[e].redundant[r]);t[e].redundant=[]}},t.resetElements=function(e){t.prepareElements(e),t.cleanupElements(e),t.prepareElements(e)},t.getSVGElement=function(t,e,r){var n;return Object.prototype.hasOwnProperty.call(t)?e[t].redundant.length>0?(n=e[t].redundant[0],e[t].redundant.shift()):(n=document.createElementNS("http://www.w3.org/2000/svg",t),r.appendChild(n)):(n=document.createElementNS("http://www.w3.org/2000/svg",t),e[t]={used:[],redundant:[]},r.appendChild(n)),e[t].used.push(n),n},t.getDOMElement=function(t,e,r,n){var i;return Object.prototype.hasOwnProperty.call(t)?e[t].redundant.length>0?(i=e[t].redundant[0],e[t].redundant.shift()):(i=document.createElement(t),void 0!==n?r.insertBefore(i,n):r.appendChild(i)):(i=document.createElement(t),e[t]={used:[],redundant:[]},void 0!==n?r.insertBefore(i,n):r.appendChild(i)),e[t].used.push(i),i},t.drawPoint=function(e,r,n,i,o,a){var s;if("circle"==n.style?((s=t.getSVGElement("circle",i,o)).setAttributeNS(null,"cx",e),s.setAttributeNS(null,"cy",r),s.setAttributeNS(null,"r",.5*n.size)):((s=t.getSVGElement("rect",i,o)).setAttributeNS(null,"x",e-.5*n.size),s.setAttributeNS(null,"y",r-.5*n.size),s.setAttributeNS(null,"width",n.size),s.setAttributeNS(null,"height",n.size)),void 0!==n.styles&&s.setAttributeNS(null,"style",n.styles),s.setAttributeNS(null,"class",n.className+" vis-point"),a){var u=t.getSVGElement("text",i,o);a.xOffset&&(e+=a.xOffset),a.yOffset&&(r+=a.yOffset),a.content&&(u.textContent=a.content),a.className&&u.setAttributeNS(null,"class",a.className+" vis-label"),u.setAttributeNS(null,"x",e),u.setAttributeNS(null,"y",r)}return s},t.drawBar=function(e,r,n,i,o,a,s,u){if(0!=i){i<0&&(r-=i*=-1);var l=t.getSVGElement("rect",a,s);l.setAttributeNS(null,"x",e-.5*n),l.setAttributeNS(null,"y",r),l.setAttributeNS(null,"width",n),l.setAttributeNS(null,"height",i),l.setAttributeNS(null,"class",o),u&&l.setAttributeNS(null,"style",u)}}}(l_);var h_={},f_={get exports(){return h_},set exports(t){h_=t}},p_={},d_=em;!function(t){t.exports=d_}({get exports(){return p_},set exports(t){p_=t}}),function(t){t.exports=p_}(f_);var v_=r(h_),g_={},y_={get exports(){return g_},set exports(t){g_=t}},m_={},b_={get exports(){return m_},set exports(t){m_=t}};Tn({target:"Object",stat:!0},{setPrototypeOf:wo});var x_=le.Object.setPrototypeOf;!function(t){t.exports=x_}(b_),function(t){t.exports=m_}(y_);var w_=r(g_),__={},k_={get exports(){return __},set exports(t){__=t}},C_={},E_=jd;!function(t){t.exports=E_}({get exports(){return C_},set exports(t){C_=t}}),function(t){t.exports=C_}(k_);var S_=r(__);function T_(t,e){var r;return T_=w_?S_(r=w_).call(r):function(t,e){return t.__proto__=e,t},T_(t,e)}function O_(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=v_(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),Eh(t,"prototype",{writable:!1}),e&&T_(t,e)}var P_={},A_={get exports(){return P_},set exports(t){P_=t}},D_={},L_=Rg;!function(t){t.exports=L_}({get exports(){return D_},set exports(t){D_=t}}),function(t){t.exports=D_}(A_);var R_=r(P_);function F_(t){var e;return F_=w_?S_(e=R_).call(e):function(t){return t.__proto__||R_(t)},F_(t)}var M_={},j_={get exports(){return M_},set exports(t){M_=t}},I_={};!function(t){var e=Sh,r=Cf;function n(i){return t.exports=n="function"==typeof e&&"symbol"==typeof r?function(t){return typeof t}:function(t){return t&&"function"==typeof e&&t.constructor===e&&t!==e.prototype?"symbol":typeof t},t.exports.__esModule=!0,t.exports.default=t.exports,n(i)}t.exports=n,t.exports.__esModule=!0,t.exports.default=t.exports}({get exports(){return I_},set exports(t){I_=t}});var z_={},B_={get exports(){return z_},set exports(t){z_=t}},N_={},W_=Qd;!function(t){t.exports=W_}({get exports(){return N_},set exports(t){N_=t}}),function(t){t.exports=N_}(B_);var G_={},Y_={get exports(){return G_},set exports(t){G_=t}},V_={},X_={get exports(){return V_},set exports(t){V_=t}},U_=B,H_=Xc,q_=Fr,Z_=qt,$_=Ut,Q_=sr,K_=Error,J_=p("".replace),tk=String(K_("zxcasd").stack),ek=/\n\s*at [^:]*:[^\n]*/,rk=ek.test(tk),nk=ir,ik=!s((function(){var t=Error("a");return!("stack"in t)||(Object.defineProperty(t,"stack",nk(1,7)),7!==t.stack)})),ok=sr,ak=function(t,e){if(rk&&"string"==typeof t&&!K_.prepareStackTrace)for(;e--;)t=J_(t,ek,"");return t},sk=ik,uk=Error.captureStackTrace,lk=vn,ck=ue,hk=oe,fk=_e,pk=ea,dk=Gn,vk=ve,gk=ja,yk=Pa,mk=Zo,bk=TypeError,xk=function(t,e){this.stopped=t,this.result=e},wk=xk.prototype,_k=function(t,e,r){var n,i,o,a,s,u,l,c=r&&r.that,h=!(!r||!r.AS_ENTRIES),f=!(!r||!r.IS_RECORD),p=!(!r||!r.IS_ITERATOR),d=!(!r||!r.INTERRUPTED),v=lk(e,c),g=function(t){return n&&mk(n,"normal",t),new xk(!0,t)},y=function(t){return h?(hk(t),d?v(t[0],t[1],g):v(t[0],t[1])):d?v(t,g):v(t)};if(f)n=t.iterator;else if(p)n=t;else{if(!(i=yk(t)))throw bk(fk(t)+" is not iterable");if(pk(i)){for(o=0,a=dk(t);a>o;o++)if((s=y(t[o]))&&vk(wk,s))return s;return new xk(!1)}n=gk(t,i)}for(u=f?t.next:n.next;!(l=ck(u,n)).done;){try{s=y(l.value)}catch(t){mk(n,"throw",t)}if("object"==typeof s&&s&&vk(wk,s))return s}return new xk(!1)},kk=Dt,Ck=Tn,Ek=ve,Sk=Ii,Tk=wo,Ok=function(t,e,r){for(var n=H_(e),i=Z_.f,o=q_.f,a=0;a<n.length;a++){var s=n[a];U_(t,s)||r&&U_(r,s)||i(t,s,o(e,s))}},Pk=Oi,Ak=sr,Dk=ir,Lk=function(t,e){$_(e)&&"cause"in e&&Q_(t,"cause",e.cause)},Rk=function(t,e,r,n){sk&&(uk?uk(t,e):ok(t,"stack",ak(r,n)))},Fk=_k,Mk=function(t,e){return void 0===t?arguments.length<2?"":e:kk(t)},jk=ht("toStringTag"),Ik=Error,zk=[].push,Bk=function(t,e){var r,n=Ek(Nk,this);Tk?r=Tk(Ik(),n?Sk(this):Nk):(r=n?this:Pk(Nk),Ak(r,jk,"Error")),void 0!==e&&Ak(r,"message",Mk(e)),Rk(r,Bk,r.stack,1),arguments.length>2&&Lk(r,arguments[2]);var i=[];return Fk(t,zk,{that:i}),Ak(r,"errors",i),r};Tk?Tk(Bk,Ik):Ok(Bk,Ik,{name:!0});var Nk=Bk.prototype=Pk(Ik.prototype,{constructor:Dk(1,Bk),message:Dk(1,""),name:Dk(1,"AggregateError")});Ck({global:!0,constructor:!0,arity:2},{AggregateError:Bk});var Wk,Gk,Yk,Vk,Xk="undefined"!=typeof process&&"process"==wt(process),Uk=de,Hk=Xs,qk=Ht,Zk=ht("species"),$k=function(t){var e=Uk(t);qk&&e&&!e[Zk]&&Hk(e,Zk,{configurable:!0,get:function(){return this}})},Qk=ve,Kk=TypeError,Jk=function(t,e){if(Qk(e,t))return t;throw Kk("Incorrect invocation")},tC=ba,eC=_e,rC=TypeError,nC=function(t){if(tC(t))return t;throw rC(eC(t)+" is not a constructor")},iC=oe,oC=nC,aC=A,sC=ht("species"),uC=function(t,e){var r,n=iC(t).constructor;return void 0===n||aC(r=iC(n)[sC])?e:oC(r)},lC=/(?:ipad|iphone|ipod).*applewebkit/i.test(X),cC=b,hC=Ar,fC=vn,pC=yt,dC=B,vC=s,gC=hi,yC=Vl,mC=Kt,bC=dm,xC=lC,wC=Xk,_C=cC.setImmediate,kC=cC.clearImmediate,CC=cC.process,EC=cC.Dispatch,SC=cC.Function,TC=cC.MessageChannel,OC=cC.String,PC=0,AC={},DC="onreadystatechange";vC((function(){Wk=cC.location}));var LC=function(t){if(dC(AC,t)){var e=AC[t];delete AC[t],e()}},RC=function(t){return function(){LC(t)}},FC=function(t){LC(t.data)},MC=function(t){cC.postMessage(OC(t),Wk.protocol+"//"+Wk.host)};_C&&kC||(_C=function(t){bC(arguments.length,1);var e=pC(t)?t:SC(t),r=yC(arguments,1);return AC[++PC]=function(){hC(e,void 0,r)},Gk(PC),PC},kC=function(t){delete AC[t]},wC?Gk=function(t){CC.nextTick(RC(t))}:EC&&EC.now?Gk=function(t){EC.now(RC(t))}:TC&&!xC?(Vk=(Yk=new TC).port2,Yk.port1.onmessage=FC,Gk=fC(Vk.postMessage,Vk)):cC.addEventListener&&pC(cC.postMessage)&&!cC.importScripts&&Wk&&"file:"!==Wk.protocol&&!vC(MC)?(Gk=MC,cC.addEventListener("message",FC,!1)):Gk=DC in mC("script")?function(t){gC.appendChild(mC("script"))[DC]=function(){gC.removeChild(this),LC(t)}}:function(t){setTimeout(RC(t),0)});var jC={set:_C,clear:kC},IC=function(){this.head=null,this.tail=null};IC.prototype={add:function(t){var e={item:t,next:null},r=this.tail;r?r.next=e:this.head=e,this.tail=e},get:function(){var t=this.head;if(t)return null===(this.head=t.next)&&(this.tail=null),t.item}};var zC,BC,NC,WC,GC,YC=IC,VC=/ipad|iphone|ipod/i.test(X)&&"undefined"!=typeof Pebble,XC=/web0s(?!.*chrome)/i.test(X),UC=b,HC=vn,qC=Fr.f,ZC=jC.set,$C=YC,QC=lC,KC=VC,JC=XC,tE=Xk,eE=UC.MutationObserver||UC.WebKitMutationObserver,rE=UC.document,nE=UC.process,iE=UC.Promise,oE=qC(UC,"queueMicrotask"),aE=oE&&oE.value;if(!aE){var sE=new $C,uE=function(){var t,e;for(tE&&(t=nE.domain)&&t.exit();e=sE.get();)try{e()}catch(t){throw sE.head&&zC(),t}t&&t.enter()};QC||tE||JC||!eE||!rE?!KC&&iE&&iE.resolve?((WC=iE.resolve(void 0)).constructor=iE,GC=HC(WC.then,WC),zC=function(){GC(uE)}):tE?zC=function(){nE.nextTick(uE)}:(ZC=HC(ZC,UC),zC=function(){ZC(uE)}):(BC=!0,NC=rE.createTextNode(""),new eE(uE).observe(NC,{characterData:!0}),zC=function(){NC.data=BC=!BC}),aE=function(t){sE.head||zC(),sE.add(t)}}var lE=aE,cE=function(t){try{return{error:!1,value:t()}}catch(t){return{error:!0,value:t}}},hE=b.Promise,fE="object"==typeof Deno&&Deno&&"object"==typeof Deno.version,pE=!fE&&!Xk&&"object"==typeof window&&"object"==typeof document,dE=b,vE=hE,gE=yt,yE=hn,mE=oa,bE=ht,xE=pE,wE=fE,_E=K,kE=vE&&vE.prototype,CE=bE("species"),EE=!1,SE=gE(dE.PromiseRejectionEvent),TE=yE("Promise",(function(){var t=mE(vE),e=t!==String(vE);if(!e&&66===_E)return!0;if(!kE.catch||!kE.finally)return!0;if(!_E||_E<51||!/native code/.test(t)){var r=new vE((function(t){t(1)})),n=function(t){t((function(){}),(function(){}))};if((r.constructor={})[CE]=n,!(EE=r.then((function(){}))instanceof n))return!0}return!e&&(xE||wE)&&!SE})),OE={CONSTRUCTOR:TE,REJECTION_EVENT:SE,SUBCLASSING:EE},PE={},AE=Se,DE=TypeError,LE=function(t){var e,r;this.promise=new t((function(t,n){if(void 0!==e||void 0!==r)throw DE("Bad Promise constructor");e=t,r=n})),this.resolve=AE(e),this.reject=AE(r)};PE.f=function(t){return new LE(t)};var RE,FE,ME=Tn,jE=Xk,IE=b,zE=ue,BE=Bi,NE=io,WE=$k,GE=Se,YE=yt,VE=Ut,XE=Jk,UE=uC,HE=jC.set,qE=lE,ZE=function(t,e){try{1==arguments.length?console.error(t):console.error(t,e)}catch(t){}},$E=cE,QE=YC,KE=Er,JE=hE,tS=PE,eS="Promise",rS=OE.CONSTRUCTOR,nS=OE.REJECTION_EVENT,iS=KE.getterFor(eS),oS=KE.set,aS=JE&&JE.prototype,sS=JE,uS=aS,lS=IE.TypeError,cS=IE.document,hS=IE.process,fS=tS.f,pS=fS,dS=!!(cS&&cS.createEvent&&IE.dispatchEvent),vS="unhandledrejection",gS=function(t){var e;return!(!VE(t)||!YE(e=t.then))&&e},yS=function(t,e){var r,n,i,o=e.value,a=1==e.state,s=a?t.ok:t.fail,u=t.resolve,l=t.reject,c=t.domain;try{s?(a||(2===e.rejection&&_S(e),e.rejection=1),!0===s?r=o:(c&&c.enter(),r=s(o),c&&(c.exit(),i=!0)),r===t.promise?l(lS("Promise-chain cycle")):(n=gS(r))?zE(n,r,u,l):u(r)):l(o)}catch(t){c&&!i&&c.exit(),l(t)}},mS=function(t,e){t.notified||(t.notified=!0,qE((function(){for(var r,n=t.reactions;r=n.get();)yS(r,t);t.notified=!1,e&&!t.rejection&&xS(t)})))},bS=function(t,e,r){var n,i;dS?((n=cS.createEvent("Event")).promise=e,n.reason=r,n.initEvent(t,!1,!0),IE.dispatchEvent(n)):n={promise:e,reason:r},!nS&&(i=IE["on"+t])?i(n):t===vS&&ZE("Unhandled promise rejection",r)},xS=function(t){zE(HE,IE,(function(){var e,r=t.facade,n=t.value;if(wS(t)&&(e=$E((function(){jE?hS.emit("unhandledRejection",n,r):bS(vS,r,n)})),t.rejection=jE||wS(t)?2:1,e.error))throw e.value}))},wS=function(t){return 1!==t.rejection&&!t.parent},_S=function(t){zE(HE,IE,(function(){var e=t.facade;jE?hS.emit("rejectionHandled",e):bS("rejectionhandled",e,t.value)}))},kS=function(t,e,r){return function(n){t(e,n,r)}},CS=function(t,e,r){t.done||(t.done=!0,r&&(t=r),t.value=e,t.state=2,mS(t,!0))},ES=function(t,e,r){if(!t.done){t.done=!0,r&&(t=r);try{if(t.facade===e)throw lS("Promise can't be resolved itself");var n=gS(e);n?qE((function(){var r={done:!1};try{zE(n,e,kS(ES,r,t),kS(CS,r,t))}catch(e){CS(r,e,t)}})):(t.value=e,t.state=1,mS(t,!1))}catch(e){CS({done:!1},e,t)}}};rS&&(uS=(sS=function(t){XE(this,uS),GE(t),zE(RE,this);var e=iS(this);try{t(kS(ES,e),kS(CS,e))}catch(t){CS(e,t)}}).prototype,(RE=function(t){oS(this,{type:eS,done:!1,notified:!1,parent:!1,reactions:new QE,rejection:!1,state:0,value:void 0})}).prototype=BE(uS,"then",(function(t,e){var r=iS(this),n=fS(UE(this,sS));return r.parent=!0,n.ok=!YE(t)||t,n.fail=YE(e)&&e,n.domain=jE?hS.domain:void 0,0==r.state?r.reactions.add(n):qE((function(){yS(n,r)})),n.promise})),FE=function(){var t=new RE,e=iS(t);this.promise=t,this.resolve=kS(ES,e),this.reject=kS(CS,e)},tS.f=fS=function(t){return t===sS||undefined===t?new FE(t):pS(t)}),ME({global:!0,constructor:!0,wrap:!0,forced:rS},{Promise:sS}),NE(sS,eS,!1,!0),WE(eS);var SS=hE,TS=OE.CONSTRUCTOR||!Ka((function(t){SS.all(t).then(void 0,(function(){}))})),OS=ue,PS=Se,AS=PE,DS=cE,LS=_k;Tn({target:"Promise",stat:!0,forced:TS},{all:function(t){var e=this,r=AS.f(e),n=r.resolve,i=r.reject,o=DS((function(){var r=PS(e.resolve),o=[],a=0,s=1;LS(t,(function(t){var u=a++,l=!1;s++,OS(r,e,t).then((function(t){l||(l=!0,o[u]=t,--s||n(o))}),i)})),--s||n(o)}));return o.error&&i(o.value),r.promise}});var RS=Tn,FS=OE.CONSTRUCTOR;hE&&hE.prototype,RS({target:"Promise",proto:!0,forced:FS,real:!0},{catch:function(t){return this.then(void 0,t)}});var MS=ue,jS=Se,IS=PE,zS=cE,BS=_k;Tn({target:"Promise",stat:!0,forced:TS},{race:function(t){var e=this,r=IS.f(e),n=r.reject,i=zS((function(){var i=jS(e.resolve);BS(t,(function(t){MS(i,e,t).then(r.resolve,n)}))}));return i.error&&n(i.value),r.promise}});var NS=ue,WS=PE;Tn({target:"Promise",stat:!0,forced:OE.CONSTRUCTOR},{reject:function(t){var e=WS.f(this);return NS(e.reject,void 0,t),e.promise}});var GS=oe,YS=Ut,VS=PE,XS=function(t,e){if(GS(t),YS(e)&&e.constructor===t)return e;var r=VS.f(t);return(0,r.resolve)(e),r.promise},US=Tn,HS=hE,qS=OE.CONSTRUCTOR,ZS=XS,$S=de("Promise"),QS=!qS;US({target:"Promise",stat:!0,forced:true},{resolve:function(t){return ZS(QS&&this===$S?HS:this,t)}});var KS=ue,JS=Se,tT=PE,eT=cE,rT=_k;Tn({target:"Promise",stat:!0,forced:TS},{allSettled:function(t){var e=this,r=tT.f(e),n=r.resolve,i=r.reject,o=eT((function(){var r=JS(e.resolve),i=[],o=0,a=1;rT(t,(function(t){var s=o++,u=!1;a++,KS(r,e,t).then((function(t){u||(u=!0,i[s]={status:"fulfilled",value:t},--a||n(i))}),(function(t){u||(u=!0,i[s]={status:"rejected",reason:t},--a||n(i))}))})),--a||n(i)}));return o.error&&i(o.value),r.promise}});var nT=ue,iT=Se,oT=de,aT=PE,sT=cE,uT=_k,lT="No one promise resolved";Tn({target:"Promise",stat:!0,forced:TS},{any:function(t){var e=this,r=oT("AggregateError"),n=aT.f(e),i=n.resolve,o=n.reject,a=sT((function(){var n=iT(e.resolve),a=[],s=0,u=1,l=!1;uT(t,(function(t){var c=s++,h=!1;u++,nT(n,e,t).then((function(t){h||l||(l=!0,i(t))}),(function(t){h||l||(h=!0,a[c]=t,--u||o(new r(a,lT)))}))})),--u||o(new r(a,lT))}));return a.error&&o(a.value),n.promise}});var cT=Tn,hT=hE,fT=s,pT=de,dT=yt,vT=uC,gT=XS,yT=hT&&hT.prototype;cT({target:"Promise",proto:!0,real:!0,forced:!!hT&&fT((function(){yT.finally.call({then:function(){}},(function(){}))}))},{finally:function(t){var e=vT(this,pT("Promise")),r=dT(t);return this.then(r?function(r){return gT(e,t()).then((function(){return r}))}:t,r?function(r){return gT(e,t()).then((function(){throw r}))}:t)}});var mT=le.Promise,bT=PE,xT=cE;Tn({target:"Promise",stat:!0,forced:!0},{try:function(t){var e=bT.f(this),r=xT(t);return(r.error?e.reject:e.resolve)(r.value),e.promise}});var wT=mT;!function(t){t.exports=wT}(X_),function(t){t.exports=V_}(Y_);var _T={},kT={get exports(){return _T},set exports(t){_T=t}},CT={},ET=lv;!function(t){t.exports=ET}({get exports(){return CT},set exports(t){CT=t}}),function(t){t.exports=CT}(kT),function(t){var e=I_.default,r=wh,n=Sh,i=h_,o=P_,a=z_,s=g_,u=G_,l=_T,c=Zf;function h(){t.exports=h=function(){return f},t.exports.__esModule=!0,t.exports.default=t.exports;var f={},p=Object.prototype,d=p.hasOwnProperty,v=r||function(t,e,r){t[e]=r.value},g="function"==typeof n?n:{},y=g.iterator||"@@iterator",m=g.asyncIterator||"@@asyncIterator",b=g.toStringTag||"@@toStringTag";function x(t,e,n){return r(t,e,{value:n,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{x({},"")}catch(t){x=function(t,e,r){return t[e]=r}}function w(t,e,r,n){var o=e&&e.prototype instanceof C?e:C,a=i(o.prototype),s=new j(n||[]);return v(a,"_invoke",{value:L(t,r,s)}),a}function _(t,e,r){try{return{type:"normal",arg:t.call(e,r)}}catch(t){return{type:"throw",arg:t}}}f.wrap=w;var k={};function C(){}function E(){}function S(){}var T={};x(T,y,(function(){return this}));var O=o&&o(o(I([])));O&&O!==p&&d.call(O,y)&&(T=O);var P=S.prototype=C.prototype=i(T);function A(t){var e;a(e=["next","throw","return"]).call(e,(function(e){x(t,e,(function(t){return this._invoke(e,t)}))}))}function D(t,r){function n(i,o,a,s){var u=_(t[i],t,o);if("throw"!==u.type){var l=u.arg,c=l.value;return c&&"object"==e(c)&&d.call(c,"__await")?r.resolve(c.__await).then((function(t){n("next",t,a,s)}),(function(t){n("throw",t,a,s)})):r.resolve(c).then((function(t){l.value=t,a(l)}),(function(t){return n("throw",t,a,s)}))}s(u.arg)}var i;v(this,"_invoke",{value:function(t,e){function o(){return new r((function(r,i){n(t,e,r,i)}))}return i=i?i.then(o,o):o()}})}function L(t,e,r){var n="suspendedStart";return function(i,o){if("executing"===n)throw new Error("Generator is already running");if("completed"===n){if("throw"===i)throw o;return z()}for(r.method=i,r.arg=o;;){var a=r.delegate;if(a){var s=R(a,r);if(s){if(s===k)continue;return s}}if("next"===r.method)r.sent=r._sent=r.arg;else if("throw"===r.method){if("suspendedStart"===n)throw n="completed",r.arg;r.dispatchException(r.arg)}else"return"===r.method&&r.abrupt("return",r.arg);n="executing";var u=_(t,e,r);if("normal"===u.type){if(n=r.done?"completed":"suspendedYield",u.arg===k)continue;return{value:u.arg,done:r.done}}"throw"===u.type&&(n="completed",r.method="throw",r.arg=u.arg)}}}function R(t,e){var r=e.method,n=t.iterator[r];if(void 0===n)return e.delegate=null,"throw"===r&&t.iterator.return&&(e.method="return",e.arg=void 0,R(t,e),"throw"===e.method)||"return"!==r&&(e.method="throw",e.arg=new TypeError("The iterator does not provide a '"+r+"' method")),k;var i=_(n,t.iterator,e.arg);if("throw"===i.type)return e.method="throw",e.arg=i.arg,e.delegate=null,k;var o=i.arg;return o?o.done?(e[t.resultName]=o.value,e.next=t.nextLoc,"return"!==e.method&&(e.method="next",e.arg=void 0),e.delegate=null,k):o:(e.method="throw",e.arg=new TypeError("iterator result is not an object"),e.delegate=null,k)}function F(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function M(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function j(t){this.tryEntries=[{tryLoc:"root"}],a(t).call(t,F,this),this.reset(!0)}function I(t){if(t){var e=t[y];if(e)return e.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var r=-1,n=function e(){for(;++r<t.length;)if(d.call(t,r))return e.value=t[r],e.done=!1,e;return e.value=void 0,e.done=!0,e};return n.next=n}}return{next:z}}function z(){return{value:void 0,done:!0}}return E.prototype=S,v(P,"constructor",{value:S,configurable:!0}),v(S,"constructor",{value:E,configurable:!0}),E.displayName=x(S,b,"GeneratorFunction"),f.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===E||"GeneratorFunction"===(e.displayName||e.name))},f.mark=function(t){return s?s(t,S):(t.__proto__=S,x(t,b,"GeneratorFunction")),t.prototype=i(P),t},f.awrap=function(t){return{__await:t}},A(D.prototype),x(D.prototype,m,(function(){return this})),f.AsyncIterator=D,f.async=function(t,e,r,n,i){void 0===i&&(i=u);var o=new D(w(t,e,r,n),i);return f.isGeneratorFunction(e)?o:o.next().then((function(t){return t.done?t.value:o.next()}))},A(P),x(P,b,"Generator"),x(P,y,(function(){return this})),x(P,"toString",(function(){return"[object Generator]"})),f.keys=function(t){var e=Object(t),r=[];for(var n in e)r.push(n);return l(r).call(r),function t(){for(;r.length;){var n=r.pop();if(n in e)return t.value=n,t.done=!1,t}return t.done=!0,t}},f.values=I,j.prototype={constructor:j,reset:function(t){var e;if(this.prev=0,this.next=0,this.sent=this._sent=void 0,this.done=!1,this.delegate=null,this.method="next",this.arg=void 0,a(e=this.tryEntries).call(e,M),!t)for(var r in this)"t"===r.charAt(0)&&d.call(this,r)&&!isNaN(+c(r).call(r,1))&&(this[r]=void 0)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var e=this;function r(r,n){return o.type="throw",o.arg=t,e.next=r,n&&(e.method="next",e.arg=void 0),!!n}for(var n=this.tryEntries.length-1;n>=0;--n){var i=this.tryEntries[n],o=i.completion;if("root"===i.tryLoc)return r("end");if(i.tryLoc<=this.prev){var a=d.call(i,"catchLoc"),s=d.call(i,"finallyLoc");if(a&&s){if(this.prev<i.catchLoc)return r(i.catchLoc,!0);if(this.prev<i.finallyLoc)return r(i.finallyLoc)}else if(a){if(this.prev<i.catchLoc)return r(i.catchLoc,!0)}else{if(!s)throw new Error("try statement without catch or finally");if(this.prev<i.finallyLoc)return r(i.finallyLoc)}}}},abrupt:function(t,e){for(var r=this.tryEntries.length-1;r>=0;--r){var n=this.tryEntries[r];if(n.tryLoc<=this.prev&&d.call(n,"finallyLoc")&&this.prev<n.finallyLoc){var i=n;break}}i&&("break"===t||"continue"===t)&&i.tryLoc<=e&&e<=i.finallyLoc&&(i=null);var o=i?i.completion:{};return o.type=t,o.arg=e,i?(this.method="next",this.next=i.finallyLoc,k):this.complete(o)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),k},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.finallyLoc===t)return this.complete(r.completion,r.afterLoc),M(r),k}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.tryLoc===t){var n=r.completion;if("throw"===n.type){var i=n.arg;M(r)}return i}}throw new Error("illegal catch attempt")},delegateYield:function(t,e,r){return this.delegate={iterator:I(t),resultName:e,nextLoc:r},"next"===this.method&&(this.arg=void 0),k}},f}t.exports=h,t.exports.__esModule=!0,t.exports.default=t.exports}(j_);var ST=M_(),TT=ST;try{regeneratorRuntime=ST}catch(t){"object"==typeof globalThis?globalThis.regeneratorRuntime=ST:Function("r","regeneratorRuntime = r")(ST)}var OT={},PT={get exports(){return OT},set exports(t){OT=t}},AT=Se,DT=j,LT=Yr,RT=Gn,FT=TypeError,MT=function(t){return function(e,r,n,i){AT(r);var o=DT(e),a=LT(o),s=RT(o),u=t?s-1:0,l=t?-1:1;if(n<2)for(;;){if(u in a){i=a[u],u+=l;break}if(u+=l,t?u<0:s<=u)throw FT("Reduce of empty array with no initial value")}for(;t?u>=0:s>u;u+=l)u in a&&(i=r(i,a[u],u,o));return i}},jT={left:MT(!1),right:MT(!0)}.left;Tn({target:"Array",proto:!0,forced:!Xk&&K>79&&K<83||!Wd("reduce")},{reduce:function(t){var e=arguments.length;return jT(this,t,e,e>1?arguments[1]:void 0)}});var IT=dp("Array").reduce,zT=ve,BT=IT,NT=Array.prototype,WT=function(t){var e=t.reduce;return t===NT||zT(NT,t)&&e===NT.reduce?BT:e};!function(t){t.exports=WT}(PT);var GT=r(OT),YT={},VT={get exports(){return YT},set exports(t){YT=t}},XT=ou,UT=Gn,HT=Dh,qT=vn,ZT=function(t,e,r,n,i,o,a,s){for(var u,l,c=i,h=0,f=!!a&&qT(a,s);h<n;)h in r&&(u=f?f(r[h],h,e):r[h],o>0&&XT(u)?(l=UT(u),c=ZT(t,e,u,l,c,o-1)-1):(HT(c+1),t[c]=u),c++),h++;return c},$T=ZT,QT=Se,KT=j,JT=Gn,tO=fu;Tn({target:"Array",proto:!0},{flatMap:function(t){var e,r=KT(this),n=JT(r);return QT(t),(e=tO(r,0)).length=$T(e,r,r,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var eO=dp("Array").flatMap,rO=ve,nO=eO,iO=Array.prototype,oO=function(t){var e=t.flatMap;return t===iO||rO(iO,t)&&e===iO.flatMap?nO:e};!function(t){t.exports=oO}(VT);var aO=r(YT),sO={},uO={get exports(){return sO},set exports(t){sO=t}},lO={},cO={get exports(){return lO},set exports(t){lO=t}},hO=s((function(){if("function"==typeof ArrayBuffer){var t=new ArrayBuffer(8);Object.isExtensible(t)&&Object.defineProperty(t,"a",{value:8})}})),fO=s,pO=Ut,dO=wt,vO=hO,gO=Object.isExtensible,yO=fO((function(){gO(1)}))||vO?function(t){return!!pO(t)&&((!vO||"ArrayBuffer"!=dO(t))&&(!gO||gO(t)))}:gO,mO=!s((function(){return Object.isExtensible(Object.preventExtensions({}))})),bO=Tn,xO=p,wO=hr,_O=Ut,kO=B,CO=qt.f,EO=Os,SO=Ds,TO=yO,OO=mO,PO=!1,AO=V("meta"),DO=0,LO=function(t){CO(t,AO,{value:{objectID:"O"+DO++,weakData:{}}})},RO=cO.exports={enable:function(){RO.enable=function(){},PO=!0;var t=EO.f,e=xO([].splice),r={};r[AO]=1,t(r).length&&(EO.f=function(r){for(var n=t(r),i=0,o=n.length;i<o;i++)if(n[i]===AO){e(n,i,1);break}return n},bO({target:"Object",stat:!0,forced:!0},{getOwnPropertyNames:SO.f}))},fastKey:function(t,e){if(!_O(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!kO(t,AO)){if(!TO(t))return"F";if(!e)return"E";LO(t)}return t[AO].objectID},getWeakData:function(t,e){if(!kO(t,AO)){if(!TO(t))return!0;if(!e)return!1;LO(t)}return t[AO].weakData},onFreeze:function(t){return OO&&PO&&TO(t)&&!kO(t,AO)&&LO(t),t}};wO[AO]=!0;var FO=Tn,MO=b,jO=lO,IO=s,zO=sr,BO=_k,NO=Jk,WO=yt,GO=Ut,YO=io,VO=qt.f,XO=xu.forEach,UO=Ht,HO=Er.set,qO=Er.getterFor,ZO=function(t,e,r){var n,i=-1!==t.indexOf("Map"),o=-1!==t.indexOf("Weak"),a=i?"set":"add",s=MO[t],u=s&&s.prototype,l={};if(UO&&WO(s)&&(o||u.forEach&&!IO((function(){(new s).entries().next()})))){var c=(n=e((function(e,r){HO(NO(e,c),{type:t,collection:new s}),null!=r&&BO(r,e[a],{that:e,AS_ENTRIES:i})}))).prototype,h=qO(t);XO(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in u)||o&&"clear"==t||zO(c,t,(function(r,n){var i=h(this).collection;if(!e&&o&&!GO(r))return"get"==t&&void 0;var a=i[t](0===r?0:r,n);return e?this:a}))})),o||VO(c,"size",{configurable:!0,get:function(){return h(this).collection.size}})}else n=r.getConstructor(e,t,i,a),jO.enable();return YO(n,t,!1,!0),l[t]=n,FO({global:!0,forced:!0},l),o||r.setStrong(n,t,i),n},$O=Bi,QO=Oi,KO=Xs,JO=function(t,e,r){for(var n in e)r&&r.unsafe&&t[n]?t[n]=e[n]:$O(t,n,e[n],r);return t},tP=vn,eP=Jk,rP=A,nP=_k,iP=jo,oP=Io,aP=$k,sP=Ht,uP=lO.fastKey,lP=Er.set,cP=Er.getterFor,hP={getConstructor:function(t,e,r,n){var i=t((function(t,i){eP(t,o),lP(t,{type:e,index:QO(null),first:void 0,last:void 0,size:0}),sP||(t.size=0),rP(i)||nP(i,t[n],{that:t,AS_ENTRIES:r})})),o=i.prototype,a=cP(e),s=function(t,e,r){var n,i,o=a(t),s=u(t,e);return s?s.value=r:(o.last=s={index:i=uP(e,!0),key:e,value:r,previous:n=o.last,next:void 0,removed:!1},o.first||(o.first=s),n&&(n.next=s),sP?o.size++:t.size++,"F"!==i&&(o.index[i]=s)),t},u=function(t,e){var r,n=a(t),i=uP(e);if("F"!==i)return n.index[i];for(r=n.first;r;r=r.next)if(r.key==e)return r};return JO(o,{clear:function(){for(var t=a(this),e=t.index,r=t.first;r;)r.removed=!0,r.previous&&(r.previous=r.previous.next=void 0),delete e[r.index],r=r.next;t.first=t.last=void 0,sP?t.size=0:this.size=0},delete:function(t){var e=this,r=a(e),n=u(e,t);if(n){var i=n.next,o=n.previous;delete r.index[n.index],n.removed=!0,o&&(o.next=i),i&&(i.previous=o),r.first==n&&(r.first=i),r.last==n&&(r.last=o),sP?r.size--:e.size--}return!!n},forEach:function(t){for(var e,r=a(this),n=tP(t,arguments.length>1?arguments[1]:void 0);e=e?e.next:r.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!u(this,t)}}),JO(o,r?{get:function(t){var e=u(this,t);return e&&e.value},set:function(t,e){return s(this,0===t?0:t,e)}}:{add:function(t){return s(this,t=0===t?0:t,t)}}),sP&&KO(o,"size",{configurable:!0,get:function(){return a(this).size}}),i},setStrong:function(t,e,r){var n=e+" Iterator",i=cP(e),o=cP(n);iP(t,e,(function(t,e){lP(this,{type:n,target:t,state:i(t),kind:e,last:void 0})}),(function(){for(var t=o(this),e=t.kind,r=t.last;r&&r.removed;)r=r.previous;return t.target&&(t.last=r=r?r.next:t.state.first)?oP("keys"==e?r.key:"values"==e?r.value:[r.key,r.value],!1):(t.target=void 0,oP(void 0,!0))}),r?"entries":"values",!r,!0),aP(e)}};ZO("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),hP);var fP=le.Map;!function(t){t.exports=fP}(uO);var pP=r(sO),dP={},vP={get exports(){return dP},set exports(t){dP=t}};ZO("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),hP);var gP=le.Set;!function(t){t.exports=gP}(vP);var yP=r(dP),mP={};!function(t){t.exports=Of}({get exports(){return mP},set exports(t){mP=t}});var bP=r(mP),xP={},wP={get exports(){return xP},set exports(t){xP=t}},_P={},kP=ja;!function(t){t.exports=kP}({get exports(){return _P},set exports(t){_P=t}}),function(t){t.exports=_P}(wP);var CP=r(xP),EP={},SP={get exports(){return EP},set exports(t){EP=t}},TP=Is,OP=Math.floor,PP=function(t,e){var r=t.length,n=OP(r/2);return r<8?AP(t,e):DP(t,PP(TP(t,0,n),e),PP(TP(t,n),e),e)},AP=function(t,e){for(var r,n,i=t.length,o=1;o<i;){for(n=o,r=t[o];n&&e(t[n-1],r)>0;)t[n]=t[--n];n!==o++&&(t[n]=r)}return t},DP=function(t,e,r,n){for(var i=e.length,o=r.length,a=0,s=0;a<i||s<o;)t[a+s]=a<i&&s<o?n(e[a],r[s])<=0?e[a++]:r[s++]:a<i?e[a++]:r[s++];return t},LP=PP,RP=X.match(/firefox\/(\d+)/i),FP=!!RP&&+RP[1],MP=/MSIE|Trident/.test(X),jP=X.match(/AppleWebKit\/(\d+)\./),IP=!!jP&&+jP[1],zP=Tn,BP=p,NP=Se,WP=j,GP=Gn,YP=xv,VP=Dt,XP=s,UP=LP,HP=Wd,qP=FP,ZP=MP,$P=K,QP=IP,KP=[],JP=BP(KP.sort),tA=BP(KP.push),eA=XP((function(){KP.sort(void 0)})),rA=XP((function(){KP.sort(null)})),nA=HP("sort"),iA=!XP((function(){if($P)return $P<70;if(!(qP&&qP>3)){if(ZP)return!0;if(QP)return QP<603;var t,e,r,n,i="";for(t=65;t<76;t++){switch(e=String.fromCharCode(t),t){case 66:case 69:case 70:case 72:r=3;break;case 68:case 71:r=4;break;default:r=2}for(n=0;n<47;n++)KP.push({k:e+n,v:r})}for(KP.sort((function(t,e){return e.v-t.v})),n=0;n<KP.length;n++)e=KP[n].k.charAt(0),i.charAt(i.length-1)!==e&&(i+=e);return"DGBEFHACIJK"!==i}}));zP({target:"Array",proto:!0,forced:eA||!rA||!nA||!iA},{sort:function(t){void 0!==t&&NP(t);var e=WP(this);if(iA)return void 0===t?JP(e):JP(e,t);var r,n,i=[],o=GP(e);for(n=0;n<o;n++)n in e&&tA(i,e[n]);for(UP(i,function(t){return function(e,r){return void 0===r?-1:void 0===e?1:void 0!==t?+t(e,r)||0:VP(e)>VP(r)?1:-1}}(t)),r=GP(i),n=0;n<r;)e[n]=i[n++];for(;n<o;)YP(e,n++);return e}});var oA=dp("Array").sort,aA=ve,sA=oA,uA=Array.prototype,lA=function(t){var e=t.sort;return t===uA||aA(uA,t)&&e===uA.sort?sA:e};!function(t){t.exports=lA}(SP);var cA=r(EP),hA={},fA={get exports(){return hA},set exports(t){hA=t}},pA=xu.some;Tn({target:"Array",proto:!0,forced:!Wd("some")},{some:function(t){return pA(this,t,arguments.length>1?arguments[1]:void 0)}});var dA=dp("Array").some,vA=ve,gA=dA,yA=Array.prototype,mA=function(t){var e=t.some;return t===yA||vA(yA,t)&&e===yA.some?gA:e};!function(t){t.exports=mA}(fA);var bA=r(hA),xA={},wA={get exports(){return xA},set exports(t){xA=t}},_A=dp("Array").keys,kA=Ot,CA=B,EA=ve,SA=_A,TA=Array.prototype,OA={DOMTokenList:!0,NodeList:!0},PA=function(t){var e=t.keys;return t===TA||EA(TA,t)&&e===TA.keys||CA(OA,kA(t))?SA:e};!function(t){t.exports=PA}(wA);var AA=r(xA),DA={},LA={get exports(){return DA},set exports(t){DA=t}},RA=dp("Array").values,FA=Ot,MA=B,jA=ve,IA=RA,zA=Array.prototype,BA={DOMTokenList:!0,NodeList:!0},NA=function(t){var e=t.values;return t===zA||jA(zA,t)&&e===zA.values||MA(BA,FA(t))?IA:e};!function(t){t.exports=NA}(LA);var WA=r(DA),GA={},YA={get exports(){return GA},set exports(t){GA=t}},VA=dp("Array").entries,XA=Ot,UA=B,HA=ve,qA=VA,ZA=Array.prototype,$A={DOMTokenList:!0,NodeList:!0},QA=function(t){var e=t.entries;return t===ZA||HA(ZA,t)&&e===ZA.entries||UA($A,XA(t))?qA:e};!function(t){t.exports=QA}(YA);var KA=r(GA),JA={},tD={get exports(){return JA},set exports(t){JA=t}},eD=Tn,rD=Ar,nD=Ad,iD=nC,oD=oe,aD=Ut,sD=Oi,uD=s,lD=de("Reflect","construct"),cD=Object.prototype,hD=[].push,fD=uD((function(){function t(){}return!(lD((function(){}),[],t)instanceof t)})),pD=!uD((function(){lD((function(){}))})),dD=fD||pD;eD({target:"Reflect",stat:!0,forced:dD,sham:dD},{construct:function(t,e){iD(t),oD(e);var r=arguments.length<3?t:iD(arguments[2]);if(pD&&!fD)return lD(t,e,r);if(t==r){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return rD(hD,n,e),new(rD(nD,t,n))}var i=r.prototype,o=sD(aD(i)?i:cD),a=rD(t,o,e);return aD(a)?a:o}});var vD=le.Reflect.construct;!function(t){t.exports=vD}(tD);var gD,yD=r(JA),mD=new Uint8Array(16);function bD(){if(!gD&&!(gD="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto)))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return gD(mD)}var xD=/^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;for(var wD,_D=[],kD=0;kD<256;++kD)_D.push((kD+256).toString(16).substr(1));function CD(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=(_D[t[e+0]]+_D[t[e+1]]+_D[t[e+2]]+_D[t[e+3]]+"-"+_D[t[e+4]]+_D[t[e+5]]+"-"+_D[t[e+6]]+_D[t[e+7]]+"-"+_D[t[e+8]]+_D[t[e+9]]+"-"+_D[t[e+10]]+_D[t[e+11]]+_D[t[e+12]]+_D[t[e+13]]+_D[t[e+14]]+_D[t[e+15]]).toLowerCase();if(!function(t){return"string"==typeof t&&xD.test(t)}(r))throw TypeError("Stringified UUID is invalid");return r}function ED(t,e,r){var n=(t=t||{}).random||(t.rng||bD)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,e){r=r||0;for(var i=0;i<16;++i)e[r+i]=n[i];return e}return CD(n)}function SD(t,e){var r=ld(t);if(Cc){var n=Cc(t);e&&(n=Yg(n).call(n,(function(e){return Ic(t,e).enumerable}))),r.push.apply(r,n)}return r}function TD(t){for(var e=1;e<arguments.length;e++){var r,n,i=null!=arguments[e]?arguments[e]:{};e%2?Kd(r=SD(Object(i),!0)).call(r,(function(e){Wf(t,e,i[e])})):Qc?uh(t,Qc(i)):Kd(n=SD(Object(i))).call(n,(function(e){bh(t,e,Ic(i,e))}))}return t}function OD(t){var e=function(){if("undefined"==typeof Reflect||!yD)return!1;if(yD.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(yD(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=F_(t);if(e){var i=F_(this).constructor;r=yD(n,arguments,i)}else r=n.apply(this,arguments);return function(t,e){if(e&&("object"===Df(e)||"function"==typeof e))return e;if(void 0!==e)throw new TypeError("Derived constructors may only return object or undefined");return c_(t)}(this,r)}}function PD(t,e){var r=void 0!==Lp&&Es(t)||t["@@iterator"];if(!r){if(qp(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return AD(t,e);var n=Gp(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return es(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return AD(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,s=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){s=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw o}}}}function AD(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}var DD=function(){function t(e,r,n){var i,o,a;xh(this,t),Wf(this,"_source",void 0),Wf(this,"_transformers",void 0),Wf(this,"_target",void 0),Wf(this,"_listeners",{add:Id(i=this._add).call(i,this),remove:Id(o=this._remove).call(o,this),update:Id(a=this._update).call(a,this)}),this._source=e,this._transformers=r,this._target=n}return Nf(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return GT(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),LD=function(){function t(e){xh(this,t),Wf(this,"_source",void 0),Wf(this,"_transformers",[]),this._source=e}return Nf(t,[{key:"filter",value:function(t){return this._transformers.push((function(e){return Yg(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return nd(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return aO(e).call(e,t)})),this}},{key:"to",value:function(t){return new DD(this._source,this._transformers,t)}}]),t}();function RD(t){return"string"==typeof t||"number"==typeof t}var FD=function(){function t(e){xh(this,t),Wf(this,"delay",void 0),Wf(this,"max",void 0),Wf(this,"_queue",[]),Wf(this,"_timeout",null),Wf(this,"_extended",null),this.delay=null,this.max=1/0,this.setOptions(e)}return Nf(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,r=0;r<e.length;r++){var n=e[r];n.original?t[n.name]=n.original:delete t[n.name]}this._extended=null}}},{key:"replace",value:function(t,e){var r=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];r.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=Lm((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;Kd(t=Bv(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,r){var n=new t(r);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){n.flush()};var i=[{name:"flush",original:void 0}];if(r&&r.replace)for(var o=0;o<r.replace.length;o++){var a=r.replace[o];i.push({name:a,original:e[a]}),n.replace(e,a)}return n._extended={object:e,methods:i},n}}]),t}(),MD=function(){function t(){xh(this,t),Wf(this,"_subscribers",{"*":[],add:[],remove:[],update:[]}),Wf(this,"subscribe",t.prototype.on),Wf(this,"unsubscribe",t.prototype.off)}return Nf(t,[{key:"_trigger",value:function(t,e,r){var n,i;if("*"===t)throw new Error("Cannot trigger event *");Kd(n=Np(i=[]).call(i,Ap(this._subscribers[t]),Ap(this._subscribers["*"]))).call(n,(function(n){n(t,e,null!=r?r:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var r;this._subscribers[t]=Yg(r=this._subscribers[t]).call(r,(function(t){return t!==e}))}}]),t}();wD=bP;var jD=function(){function t(e){xh(this,t),Wf(this,"_pairs",void 0),this._pairs=e}return Nf(t,[{key:wD,value:TT.mark((function t(){var e,r,n,i,o;return TT.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=PD(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Pp(r.value,2),i=n[0],o=n[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:TT.mark((function t(){var e,r,n,i,o;return TT.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=PD(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Pp(r.value,2),i=n[0],o=n[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:TT.mark((function t(){var e,r,n,i;return TT.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=PD(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Pp(r.value,1),i=n[0],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:TT.mark((function t(){var e,r,n,i;return TT.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=PD(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Pp(r.value,2),i=n[1],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return nd(t=Ap(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return nd(t=Ap(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return Ap(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=rm(null),r=PD(this._pairs);try{for(r.s();!(t=r.n()).done;){var n=Pp(t.value,2),i=n[0],o=n[1];e[i]=o}}catch(t){r.e(t)}finally{r.f()}return e}},{key:"toMap",value:function(){return new pP(this._pairs)}},{key:"toIdSet",value:function(){return new yP(this.toIdArray())}},{key:"toItemSet",value:function(){return new yP(this.toItemArray())}},{key:"cache",value:function(){return new t(Ap(this._pairs))}},{key:"distinct",value:function(t){var e,r=new yP,n=PD(this._pairs);try{for(n.s();!(e=n.n()).done;){var i=Pp(e.value,2),o=i[0],a=i[1];r.add(t(a,o))}}catch(t){n.e(t)}finally{n.f()}return r}},{key:"filter",value:function(e){var r=this._pairs;return new t(Wf({},bP,TT.mark((function t(){var n,i,o,a,s;return TT.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=PD(r),t.prev=1,n.s();case 3:if((i=n.n()).done){t.next=10;break}if(o=Pp(i.value,2),a=o[0],s=o[1],!e(s,a)){t.next=8;break}return t.next=8,[a,s];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),n.e(t.t0);case 15:return t.prev=15,n.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,r=PD(this._pairs);try{for(r.s();!(e=r.n()).done;){var n=Pp(e.value,2),i=n[0];t(n[1],i)}}catch(t){r.e(t)}finally{r.f()}}},{key:"map",value:function(e){var r=this._pairs;return new t(Wf({},bP,TT.mark((function t(){var n,i,o,a,s;return TT.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=PD(r),t.prev=1,n.s();case 3:if((i=n.n()).done){t.next=9;break}return o=Pp(i.value,2),a=o[0],s=o[1],t.next=7,[a,e(s,a)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),n.e(t.t0);case 14:return t.prev=14,n.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=CP(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],i=t(r.value[1],r.value[0]);!(r=e.next()).done;){var o=Pp(r.value,2),a=o[0],s=o[1],u=t(s,a);u>i&&(i=u,n=s)}return n}},{key:"min",value:function(t){var e=CP(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],i=t(r.value[1],r.value[0]);!(r=e.next()).done;){var o=Pp(r.value,2),a=o[0],s=o[1],u=t(s,a);u<i&&(i=u,n=s)}return n}},{key:"reduce",value:function(t,e){var r,n=PD(this._pairs);try{for(n.s();!(r=n.n()).done;){var i=Pp(r.value,2),o=i[0];e=t(e,i[1],o)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(e){var r=this;return new t(Wf({},bP,(function(){var t;return CP(cA(t=Ap(r._pairs)).call(t,(function(t,r){var n=Pp(t,2),i=n[0],o=n[1],a=Pp(r,2),s=a[0],u=a[1];return e(o,u,i,s)})))})))}}]),t}();var ID=function(t){O_(r,t);var e=OD(r);function r(t,n){var i;return xh(this,r),Wf(c_(i=e.call(this)),"flush",void 0),Wf(c_(i),"length",void 0),Wf(c_(i),"_options",void 0),Wf(c_(i),"_data",void 0),Wf(c_(i),"_idProp",void 0),Wf(c_(i),"_queue",null),t&&!qp(t)&&(n=t,t=[]),i._options=n||{},i._data=new pP,i.length=0,i._idProp=i._options.fieldId||"id",t&&t.length&&i.add(t),i.setOptions(n),i}return Nf(r,[{key:"idProp",get:function(){return this._idProp}},{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),this._queue=null):(this._queue||(this._queue=FD.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===Df(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var r,n=this,i=[];if(qp(t)){var o=nd(t).call(t,(function(t){return t[n._idProp]}));if(bA(o).call(o,(function(t){return n._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var a=0,s=t.length;a<s;a++)r=this._addItem(t[a]),i.push(r)}else{if(!t||"object"!==Df(t))throw new Error("Unknown dataType");r=this._addItem(t),i.push(r)}return i.length&&this._trigger("add",{items:i},e),i}},{key:"update",value:function(t,e){var r=this,n=[],i=[],o=[],a=[],s=this._idProp,u=function(t){var e=t[s];if(null!=e&&r._data.has(e)){var u=t,l=ng({},r._data.get(e)),c=r._updateItem(u);i.push(c),a.push(u),o.push(l)}else{var h=r._addItem(t);n.push(h)}};if(qp(t))for(var l=0,c=t.length;l<c;l++)t[l]&&"object"===Df(t[l])?u(t[l]):console.warn("Ignoring input item, which is not an object at index "+l);else{if(!t||"object"!==Df(t))throw new Error("Unknown dataType");u(t)}if(n.length&&this._trigger("add",{items:n},e),i.length){var h={items:i,oldData:o,data:a};this._trigger("update",h,e)}return Np(n).call(n,i)}},{key:"updateOnly",value:function(t,e){var r,n=this;qp(t)||(t=[t]);var i=nd(r=nd(t).call(t,(function(t){var e=n._data.get(t[n._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(r,(function(t){var e=t.oldData,r=t.update,i=e[n._idProp],o=uw(e,r);return n._data.set(i,o),{id:i,oldData:e,updatedData:o}}));if(i.length){var o={items:nd(i).call(i,(function(t){return t.id})),oldData:nd(i).call(i,(function(t){return t.oldData})),data:nd(i).call(i,(function(t){return t.updatedData}))};return this._trigger("update",o,e),o.items}return[]}},{key:"get",value:function(t,e){var r=void 0,n=void 0,i=void 0;RD(t)?(r=t,i=e):qp(t)?(n=t,i=e):i=t;var o,a=i&&"Object"===i.returnType?"Object":"Array",s=i&&Yg(i),u=[],l=void 0,c=void 0,h=void 0;if(null!=r)(l=this._data.get(r))&&s&&!s(l)&&(l=void 0);else if(null!=n)for(var f=0,p=n.length;f<p;f++)null==(l=this._data.get(n[f]))||s&&!s(l)||u.push(l);else for(var d,v=0,g=(c=Ap(AA(d=this._data).call(d))).length;v<g;v++)h=c[v],null==(l=this._data.get(h))||s&&!s(l)||u.push(l);if(i&&i.order&&null==r&&this._sort(u,i.order),i&&i.fields){var y=i.fields;if(null!=r&&null!=l)l=this._filterFields(l,y);else for(var m=0,b=u.length;m<b;m++)u[m]=this._filterFields(u[m],y)}if("Object"==a){for(var x={},w=0,_=u.length;w<_;w++){var k=u[w];x[k[this._idProp]]=k}return x}return null!=r?null!==(o=l)&&void 0!==o?o:null:u}},{key:"getIds",value:function(t){var e=this._data,r=t&&Yg(t),n=t&&t.order,i=Ap(AA(e).call(e)),o=[];if(r)if(n){for(var a=[],s=0,u=i.length;s<u;s++){var l=i[s],c=this._data.get(l);null!=c&&r(c)&&a.push(c)}this._sort(a,n);for(var h=0,f=a.length;h<f;h++)o.push(a[h][this._idProp])}else for(var p=0,d=i.length;p<d;p++){var v=i[p],g=this._data.get(v);null!=g&&r(g)&&o.push(g[this._idProp])}else if(n){for(var y=[],m=0,b=i.length;m<b;m++){var x=i[m];y.push(e.get(x))}this._sort(y,n);for(var w=0,_=y.length;w<_;w++)o.push(y[w][this._idProp])}else for(var k=0,C=i.length;k<C;k++){var E=i[k],S=e.get(E);null!=S&&o.push(S[this._idProp])}return o}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var r=e&&Yg(e),n=this._data,i=Ap(AA(n).call(n));if(e&&e.order)for(var o=this.get(e),a=0,s=o.length;a<s;a++){var u=o[a];t(u,u[this._idProp])}else for(var l=0,c=i.length;l<c;l++){var h=i[l],f=this._data.get(h);null==f||r&&!r(f)||t(f,h)}}},{key:"map",value:function(t,e){for(var r=e&&Yg(e),n=[],i=this._data,o=Ap(AA(i).call(i)),a=0,s=o.length;a<s;a++){var u=o[a],l=this._data.get(u);null==l||r&&!r(l)||n.push(t(l,u))}return e&&e.order&&this._sort(n,e.order),n}},{key:"_filterFields",value:function(t,e){var r;return t?GT(r=qp(e)?e:ld(e)).call(r,(function(e,r){return e[r]=t[r],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var r=e;cA(t).call(t,(function(t,e){var n=t[r],i=e[r];return n>i?1:n<i?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");cA(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var r=[],n=[],i=qp(t)?t:[t],o=0,a=i.length;o<a;o++){var s=this._remove(i[o]);if(s){var u=s[this._idProp];null!=u&&(r.push(u),n.push(s))}}return r.length&&this._trigger("remove",{items:r,oldData:n},e),r}},{key:"_remove",value:function(t){var e;if(RD(t)?e=t:t&&"object"===Df(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var r=this._data.get(e)||null;return this._data.delete(e),--this.length,r}return null}},{key:"clear",value:function(t){for(var e,r=Ap(AA(e=this._data).call(e)),n=[],i=0,o=r.length;i<o;i++)n.push(this._data.get(r[i]));return this._data.clear(),this.length=0,this._trigger("remove",{items:r,oldData:n},t),r}},{key:"max",value:function(t){var e,r,n=null,i=null,o=PD(WA(e=this._data).call(e));try{for(o.s();!(r=o.n()).done;){var a=r.value,s=a[t];"number"==typeof s&&(null==i||s>i)&&(n=a,i=s)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"min",value:function(t){var e,r,n=null,i=null,o=PD(WA(e=this._data).call(e));try{for(o.s();!(r=o.n()).done;){var a=r.value,s=a[t];"number"==typeof s&&(null==i||s<i)&&(n=a,i=s)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"distinct",value:function(t){for(var e=this._data,r=Ap(AA(e).call(e)),n=[],i=0,o=0,a=r.length;o<a;o++){for(var s=r[o],u=e.get(s)[t],l=!1,c=0;c<i;c++)if(n[c]==u){l=!0;break}l||void 0===u||(n[i]=u,i++)}return n}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=ED()),t}(t,this._idProp),r=e[this._idProp];if(this._data.has(r))throw new Error("Cannot add item: item with id "+r+" already exists");return this._data.set(r,e),++this.length,r}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+lm(t)+")");var r=this._data.get(e);if(!r)throw new Error("Cannot update item: no item with id "+e+" found");return this._data.set(e,TD(TD({},r),t)),e}},{key:"stream",value:function(t){if(t){var e=this._data;return new jD(Wf({},bP,TT.mark((function r(){var n,i,o,a;return TT.wrap((function(r){for(;;)switch(r.prev=r.next){case 0:n=PD(t),r.prev=1,n.s();case 3:if((i=n.n()).done){r.next=11;break}if(o=i.value,null==(a=e.get(o))){r.next=9;break}return r.next=9,[o,a];case 9:r.next=3;break;case 11:r.next=16;break;case 13:r.prev=13,r.t0=r.catch(1),n.e(r.t0);case 16:return r.prev=16,n.f(),r.finish(16);case 19:case"end":return r.stop()}}),r,null,[[1,13,16,19]])}))))}var r;return new jD(Wf({},bP,Id(r=KA(this._data)).call(r,this._data)))}}]),r}(MD),zD=function(t){O_(r,t);var e=OD(r);function r(t,n){var i,o;return xh(this,r),Wf(c_(o=e.call(this)),"length",0),Wf(c_(o),"_listener",void 0),Wf(c_(o),"_data",void 0),Wf(c_(o),"_ids",new yP),Wf(c_(o),"_options",void 0),o._options=n||{},o._listener=Id(i=o._onEvent).call(i,c_(o)),o.setData(t),o}return Nf(r,[{key:"idProp",get:function(){return this.getDataSet().idProp}},{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:Yg(this._options)}),r=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:r})}if(null!=t){this._data=t;for(var n=this._data.getIds({filter:Yg(this._options)}),i=0,o=n.length;i<o;i++){var a=n[i];this._ids.add(a)}this.length=n.length,this._trigger("add",{items:n})}else this._data=new ID;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:Yg(this._options)}),e=Ap(this._ids),r={},n=[],i=[],o=[],a=0,s=t.length;a<s;a++){var u=t[a];r[u]=!0,this._ids.has(u)||(n.push(u),this._ids.add(u))}for(var l=0,c=e.length;l<c;l++){var h=e[l],f=this._data.get(h);null==f?console.error("If you see this, report it please."):r[h]||(i.push(h),o.push(f),this._ids.delete(h))}this.length+=n.length-i.length,n.length&&this._trigger("add",{items:n}),i.length&&this._trigger("remove",{items:i,oldData:o})}},{key:"get",value:function(t,e){if(null==this._data)return null;var r,n=null;RD(t)||qp(t)?(n=t,r=e):r=t;var i=ng({},this._options,r),o=Yg(this._options),a=r&&Yg(r);return o&&a&&(i.filter=function(t){return o(t)&&a(t)}),null==n?this._data.get(i):this._data.get(n,i)}},{key:"getIds",value:function(t){if(this._data.length){var e,r=Yg(this._options),n=null!=t?Yg(t):null;return e=n?r?function(t){return r(t)&&n(t)}:n:r,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var r,n,i=Yg(this._options),o=e&&Yg(e);n=o?i?function(t){return i(t)&&o(t)}:o:i,Kd(r=this._data).call(r,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var r,n,i=Yg(this._options),o=e&&Yg(e);return n=o?i?function(t){return i(t)&&o(t)}:o:i,nd(r=this._data).call(r,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||Wf({},bP,Id(e=AA(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;null!==(t=this._data)&&void 0!==t&&t.off&&this._data.off("*",this._listener);var e,n="This data view has already been disposed of.",i={get:function(){throw new Error(n)},set:function(){throw new Error(n)},configurable:!1},o=PD(Up(r.prototype));try{for(o.s();!(e=o.n()).done;){var a=e.value;bh(this,a,i)}}catch(t){o.e(t)}finally{o.f()}}},{key:"_onEvent",value:function(t,e,r){if(e&&e.items&&this._data){var n=e.items,i=[],o=[],a=[],s=[],u=[],l=[];switch(t){case"add":for(var c=0,h=n.length;c<h;c++){var f=n[c];this.get(f)&&(this._ids.add(f),i.push(f))}break;case"update":for(var p=0,d=n.length;p<d;p++){var v=n[p];this.get(v)?this._ids.has(v)?(o.push(v),u.push(e.data[p]),s.push(e.oldData[p])):(this._ids.add(v),i.push(v)):this._ids.has(v)&&(this._ids.delete(v),a.push(v),l.push(e.oldData[p]))}break;case"remove":for(var g=0,y=n.length;g<y;g++){var m=n[g];this._ids.has(m)&&(this._ids.delete(m),a.push(m),l.push(e.oldData[g]))}}this.length+=i.length-a.length,i.length&&this._trigger("add",{items:i},r),o.length&&this._trigger("update",{items:o,oldData:s,data:u},r),a.length&&this._trigger("remove",{items:a,oldData:l},r)}}}]),r}(MD);function BD(t,e){return"object"===Df(e)&&null!==e&&t===e.idProp&&"function"==typeof e.add&&"function"==typeof e.clear&&"function"==typeof e.distinct&&"function"==typeof Kd(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof nd(e)&&"function"==typeof e.max&&"function"==typeof e.min&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.remove&&"function"==typeof e.setOptions&&"function"==typeof e.stream&&"function"==typeof e.update&&"function"==typeof e.updateOnly}var ND=Object.freeze({__proto__:null,DELETE:sw,DataSet:ID,DataStream:jD,DataView:zD,Queue:FD,createNewDataPipeFrom:function(t){return new LD(t)},isDataSetLike:BD,isDataViewLike:function(t,e){return"object"===Df(e)&&null!==e&&t===e.idProp&&"function"==typeof Kd(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof nd(e)&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.stream&&BD(t,e.getDataSet())}}),WD=n(ND),GD={},YD={get exports(){return GD},set exports(t){GD=t}},VD=b,XD=s,UD=Dt,HD=fy.trim,qD=iy,ZD=p("".charAt),$D=VD.parseFloat,QD=VD.Symbol,KD=QD&&QD.iterator,JD=1/$D(qD+"-0")!=-1/0||KD&&!XD((function(){$D(Object(KD))}))?function(t){var e=HD(UD(t)),r=$D(e);return 0===r&&"-"==ZD(e,0)?-0:r}:$D;Tn({global:!0,forced:parseFloat!=JD},{parseFloat:JD});var tL=le.parseFloat;!function(t){t.exports=tL}(YD);var eL=r(GD),rL={},nL={get exports(){return rL},set exports(t){rL=t}};Tn({target:"Number",stat:!0},{isNaN:function(t){return t!=t}});var iL=le.Number.isNaN;!function(t){t.exports=iL}(nL);var oL=r(rL);function aL(t,e,r){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0,this.z=void 0!==r?r:0}aL.subtract=function(t,e){var r=new aL;return r.x=t.x-e.x,r.y=t.y-e.y,r.z=t.z-e.z,r},aL.add=function(t,e){var r=new aL;return r.x=t.x+e.x,r.y=t.y+e.y,r.z=t.z+e.z,r},aL.avg=function(t,e){return new aL((t.x+e.x)/2,(t.y+e.y)/2,(t.z+e.z)/2)},aL.scalarProduct=function(t,e){return new aL(t.x*e,t.y*e,t.z*e)},aL.dotProduct=function(t,e){return t.x*e.x+t.y*e.y+t.z*e.z},aL.crossProduct=function(t,e){var r=new aL;return r.x=t.y*e.z-t.z*e.y,r.y=t.z*e.x-t.x*e.z,r.z=t.x*e.y-t.y*e.x,r},aL.prototype.length=function(){return Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z)},aL.prototype.normalize=function(){return aL.scalarProduct(this,1/this.length())};var sL=aL;var uL=function(t,e){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0};function lL(t,e){if(void 0===t)throw new Error("No container element defined");if(this.container=t,this.visible=!e||null==e.visible||e.visible,this.visible){this.frame=document.createElement("DIV"),this.frame.style.width="100%",this.frame.style.position="relative",this.container.appendChild(this.frame),this.frame.prev=document.createElement("INPUT"),this.frame.prev.type="BUTTON",this.frame.prev.value="Prev",this.frame.appendChild(this.frame.prev),this.frame.play=document.createElement("INPUT"),this.frame.play.type="BUTTON",this.frame.play.value="Play",this.frame.appendChild(this.frame.play),this.frame.next=document.createElement("INPUT"),this.frame.next.type="BUTTON",this.frame.next.value="Next",this.frame.appendChild(this.frame.next),this.frame.bar=document.createElement("INPUT"),this.frame.bar.type="BUTTON",this.frame.bar.style.position="absolute",this.frame.bar.style.border="1px solid red",this.frame.bar.style.width="100px",this.frame.bar.style.height="6px",this.frame.bar.style.borderRadius="2px",this.frame.bar.style.MozBorderRadius="2px",this.frame.bar.style.border="1px solid #7F7F7F",this.frame.bar.style.backgroundColor="#E5E5E5",this.frame.appendChild(this.frame.bar),this.frame.slide=document.createElement("INPUT"),this.frame.slide.type="BUTTON",this.frame.slide.style.margin="0px",this.frame.slide.value=" ",this.frame.slide.style.position="relative",this.frame.slide.style.left="-100px",this.frame.appendChild(this.frame.slide);var r=this;this.frame.slide.onmousedown=function(t){r._onMouseDown(t)},this.frame.prev.onclick=function(t){r.prev(t)},this.frame.play.onclick=function(t){r.togglePlay(t)},this.frame.next.onclick=function(t){r.next(t)}}this.onChangeCallback=void 0,this.values=[],this.index=void 0,this.playTimeout=void 0,this.playInterval=1e3,this.playLoop=!0}lL.prototype.prev=function(){var t=this.getIndex();t>0&&(t--,this.setIndex(t))},lL.prototype.next=function(){var t=this.getIndex();t<WA(this).length-1&&(t++,this.setIndex(t))},lL.prototype.playNext=function(){var t=new Date,e=this.getIndex();e<WA(this).length-1?(e++,this.setIndex(e)):this.playLoop&&(e=0,this.setIndex(e));var r=new Date-t,n=Math.max(this.playInterval-r,0),i=this;this.playTimeout=Lm((function(){i.playNext()}),n)},lL.prototype.togglePlay=function(){void 0===this.playTimeout?this.play():this.stop()},lL.prototype.play=function(){this.playTimeout||(this.playNext(),this.frame&&(this.frame.play.value="Stop"))},lL.prototype.stop=function(){clearInterval(this.playTimeout),this.playTimeout=void 0,this.frame&&(this.frame.play.value="Play")},lL.prototype.setOnChangeCallback=function(t){this.onChangeCallback=t},lL.prototype.setPlayInterval=function(t){this.playInterval=t},lL.prototype.getPlayInterval=function(){return this.playInterval},lL.prototype.setPlayLoop=function(t){this.playLoop=t},lL.prototype.onChange=function(){void 0!==this.onChangeCallback&&this.onChangeCallback()},lL.prototype.redraw=function(){if(this.frame){this.frame.bar.style.top=this.frame.clientHeight/2-this.frame.bar.offsetHeight/2+"px",this.frame.bar.style.width=this.frame.clientWidth-this.frame.prev.clientWidth-this.frame.play.clientWidth-this.frame.next.clientWidth-30+"px";var t=this.indexToLeft(this.index);this.frame.slide.style.left=t+"px"}},lL.prototype.setValues=function(t){this.values=t,WA(this).length>0?this.setIndex(0):this.index=void 0},lL.prototype.setIndex=function(t){if(!(t<WA(this).length))throw new Error("Index out of range");this.index=t,this.redraw(),this.onChange()},lL.prototype.getIndex=function(){return this.index},lL.prototype.get=function(){return WA(this)[this.index]},lL.prototype._onMouseDown=function(t){if(t.which?1===t.which:1===t.button){this.startClientX=t.clientX,this.startSlideX=eL(this.frame.slide.style.left),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},Aw(document,"mousemove",this.onmousemove),Aw(document,"mouseup",this.onmouseup),Lw(t)}},lL.prototype.leftToIndex=function(t){var e=eL(this.frame.bar.style.width)-this.frame.slide.clientWidth-10,r=t-3,n=Math.round(r/e*(WA(this).length-1));return n<0&&(n=0),n>WA(this).length-1&&(n=WA(this).length-1),n},lL.prototype.indexToLeft=function(t){var e=eL(this.frame.bar.style.width)-this.frame.slide.clientWidth-10;return t/(WA(this).length-1)*e+3},lL.prototype._onMouseMove=function(t){var e=t.clientX-this.startClientX,r=this.startSlideX+e,n=this.leftToIndex(r);this.setIndex(n),Lw()},lL.prototype._onMouseUp=function(){this.frame.style.cursor="auto",Dw(document,"mousemove",this.onmousemove),Dw(document,"mouseup",this.onmouseup),Lw()};var cL=Object.freeze({__proto__:null,default:lL});function hL(t,e,r,n){this._start=0,this._end=0,this._step=1,this.prettyStep=!0,this.precision=5,this._current=0,this.setRange(t,e,r,n)}hL.prototype.isNumeric=function(t){return!isNaN(eL(t))&&isFinite(t)},hL.prototype.setRange=function(t,e,r,n){if(!this.isNumeric(t))throw new Error("Parameter 'start' is not numeric; value: "+t);if(!this.isNumeric(e))throw new Error("Parameter 'end' is not numeric; value: "+t);if(!this.isNumeric(r))throw new Error("Parameter 'step' is not numeric; value: "+t);this._start=t||0,this._end=e||0,this.setStep(r,n)},hL.prototype.setStep=function(t,e){void 0===t||t<=0||(void 0!==e&&(this.prettyStep=e),!0===this.prettyStep?this._step=hL.calculatePrettyStep(t):this._step=t)},hL.calculatePrettyStep=function(t){var e=function(t){return Math.log(t)/Math.LN10},r=Math.pow(10,Math.round(e(t))),n=2*Math.pow(10,Math.round(e(t/2))),i=5*Math.pow(10,Math.round(e(t/5))),o=r;return Math.abs(n-t)<=Math.abs(o-t)&&(o=n),Math.abs(i-t)<=Math.abs(o-t)&&(o=i),o<=0&&(o=1),o},hL.prototype.getCurrent=function(){return eL(this._current.toPrecision(this.precision))},hL.prototype.getStep=function(){return this._step},hL.prototype.start=function(t){void 0===t&&(t=!1),this._current=this._start-this._start%this._step,t&&this.getCurrent()<this._start&&this.next()},hL.prototype.next=function(){this._current+=this._step},hL.prototype.end=function(){return this._current>this._end};var fL=hL,pL={},dL={get exports(){return pL},set exports(t){pL=t}};Tn({target:"Math",stat:!0},{sign:Math.sign||function(t){var e=+t;return 0==e||e!=e?e:e<0?-1:1}});var vL=le.Math.sign;!function(t){t.exports=vL}(dL);var gL=r(pL);function yL(){this.armLocation=new sL,this.armRotation={},this.armRotation.horizontal=0,this.armRotation.vertical=0,this.armLength=1.7,this.cameraOffset=new sL,this.offsetMultiplier=.6,this.cameraLocation=new sL,this.cameraRotation=new sL(.5*Math.PI,0,0),this.calculateCameraOrientation()}yL.prototype.setOffset=function(t,e){var r=Math.abs,n=gL,i=this.offsetMultiplier,o=this.armLength*i;r(t)>o&&(t=n(t)*o),r(e)>o&&(e=n(e)*o),this.cameraOffset.x=t,this.cameraOffset.y=e,this.calculateCameraOrientation()},yL.prototype.getOffset=function(){return this.cameraOffset},yL.prototype.setArmLocation=function(t,e,r){this.armLocation.x=t,this.armLocation.y=e,this.armLocation.z=r,this.calculateCameraOrientation()},yL.prototype.setArmRotation=function(t,e){void 0!==t&&(this.armRotation.horizontal=t),void 0!==e&&(this.armRotation.vertical=e,this.armRotation.vertical<0&&(this.armRotation.vertical=0),this.armRotation.vertical>.5*Math.PI&&(this.armRotation.vertical=.5*Math.PI)),void 0===t&&void 0===e||this.calculateCameraOrientation()},yL.prototype.getArmRotation=function(){var t={};return t.horizontal=this.armRotation.horizontal,t.vertical=this.armRotation.vertical,t},yL.prototype.setArmLength=function(t){void 0!==t&&(this.armLength=t,this.armLength<.71&&(this.armLength=.71),this.armLength>5&&(this.armLength=5),this.setOffset(this.cameraOffset.x,this.cameraOffset.y),this.calculateCameraOrientation())},yL.prototype.getArmLength=function(){return this.armLength},yL.prototype.getCameraLocation=function(){return this.cameraLocation},yL.prototype.getCameraRotation=function(){return this.cameraRotation},yL.prototype.calculateCameraOrientation=function(){this.cameraLocation.x=this.armLocation.x-this.armLength*Math.sin(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.y=this.armLocation.y-this.armLength*Math.cos(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.z=this.armLocation.z+this.armLength*Math.sin(this.armRotation.vertical),this.cameraRotation.x=Math.PI/2-this.armRotation.vertical,this.cameraRotation.y=0,this.cameraRotation.z=-this.armRotation.horizontal;var t=this.cameraRotation.x,e=this.cameraRotation.z,r=this.cameraOffset.x,n=this.cameraOffset.y,i=Math.sin,o=Math.cos;this.cameraLocation.x=this.cameraLocation.x+r*o(e)+n*-i(e)*o(t),this.cameraLocation.y=this.cameraLocation.y+r*i(e)+n*o(e)*o(t),this.cameraLocation.z=this.cameraLocation.z+n*i(t)};var mL=Object.freeze({__proto__:null,default:yL}),bL={BAR:0,BARCOLOR:1,BARSIZE:2,DOT:3,DOTLINE:4,DOTCOLOR:5,DOTSIZE:6,GRID:7,LINE:8,SURFACE:9},xL={dot:bL.DOT,"dot-line":bL.DOTLINE,"dot-color":bL.DOTCOLOR,"dot-size":bL.DOTSIZE,line:bL.LINE,grid:bL.GRID,surface:bL.SURFACE,bar:bL.BAR,"bar-color":bL.BARCOLOR,"bar-size":bL.BARSIZE},wL=["width","height","filterLabel","legendLabel","xLabel","yLabel","zLabel","xValueLabel","yValueLabel","zValueLabel","showXAxis","showYAxis","showZAxis","showGrayBottom","showGrid","showPerspective","showShadow","showSurfaceGrid","keepAspectRatio","rotateAxisLabels","verticalRatio","dotSizeRatio","dotSizeMinFraction","dotSizeMaxFraction","showAnimationControls","animationInterval","animationPreload","animationAutoStart","axisColor","axisFontSize","axisFontType","gridColor","xCenter","yCenter","zoomable","tooltipDelay","ctrlToZoom"],_L=["xBarWidth","yBarWidth","valueMin","valueMax","xMin","xMax","xStep","yMin","yMax","yStep","zMin","zMax","zStep"],kL=void 0;function CL(t){for(var e in t)if(Object.prototype.hasOwnProperty.call(t,e))return!1;return!0}function EL(t,e){return void 0===t||""===t?e:t+(void 0===(r=e)||""===r||"string"!=typeof r?r:r.charAt(0).toUpperCase()+Gp(r).call(r,1));var r}function SL(t,e,r,n){for(var i,o=0;o<r.length;++o)e[EL(n,i=r[o])]=t[i]}function TL(t,e,r,n){for(var i,o=0;o<r.length;++o)void 0!==t[i=r[o]]&&(e[EL(n,i)]=t[i])}function OL(t,e){if(void 0!==t.backgroundColor&&function(t,e){var r="white",n="gray",i=1;if("string"==typeof t)r=t,n="none",i=0;else{if("object"!==Df(t))throw new Error("Unsupported type of backgroundColor");void 0!==Vm(t)&&(r=Vm(t)),void 0!==t.stroke&&(n=t.stroke),void 0!==t.strokeWidth&&(i=t.strokeWidth)}e.frame.style.backgroundColor=r,e.frame.style.borderColor=n,e.frame.style.borderWidth=i+"px",e.frame.style.borderStyle="solid"}(t.backgroundColor,e),function(t,e){if(void 0===t)return;void 0===e.dataColor&&(e.dataColor={});"string"==typeof t?(e.dataColor.fill=t,e.dataColor.stroke=t):(Vm(t)&&(e.dataColor.fill=Vm(t)),t.stroke&&(e.dataColor.stroke=t.stroke),void 0!==t.strokeWidth&&(e.dataColor.strokeWidth=t.strokeWidth))}(t.dataColor,e),function(t,e){if(void 0===t)return;var r;if("string"==typeof t){if(r=function(t){var e=xL[t];if(void 0===e)return-1;return e}(t),-1===r)throw new Error("Style '"+t+"' is invalid")}else{if(!function(t){var e=!1;for(var r in bL)if(bL[r]===t){e=!0;break}return e}(t))throw new Error("Style '"+t+"' is invalid");r=t}e.style=r}(t.style,e),void 0!==t.surfaceColors){if(console.warn("`options.surfaceColors` is deprecated and may be removed in a future version. Please use `options.colormap` instead. Note that the `colormap` option uses the inverse array ordering (running from vMin to vMax)."),void 0!==t.colormap)throw new Error("The `colormap` and `surfaceColors` options are mutually exclusive.");"surface"!==e.style?console.warn("Ignoring `surfaceColors` in graph style `"+e.style+"` for backward compatibility (only effective in `surface` plots)."):function(t,e){if(void 0===t||!0===t)return;if(!1===t)return void(e.surfaceColors=void 0);void 0===e.surfaceColors&&(e.surfaceColors={});var r;if(qp(t))r=PL(t);else{if("object"!==Df(t))throw new Error("Unsupported type of surfaceColors");r=AL(t.hue)}cv(r).call(r),e.colormap=r}(t.surfaceColors,e)}else!function(t,e){if(void 0===t)return;var r;if(qp(t))r=PL(t);else if("object"===Df(t))r=AL(t.hue);else{if("function"!=typeof t)throw new Error("Unsupported type of colormap");r=t}e.colormap=r}(t.colormap,e);!function(t,e){if(void 0===t){if(void 0===kL.showLegend){var r=e.style===bL.DOTCOLOR||e.style===bL.DOTSIZE;e.showLegend=r}}else e.showLegend=t}(t.showLegend,e),DL(t.cameraPosition,e),void 0!==t.tooltip&&(e.showTooltip=t.tooltip),null!=t.onclick&&(e.onclick_callback=t.onclick,console.warn("`options.onclick` is deprecated and may be removed in a future version. Please use `Graph3d.on('click', handler)` instead.")),void 0!==t.tooltipStyle&&Ew(["tooltipStyle"],e,t)}function PL(t){if(t.length<2)throw new Error("Colormap array length must be 2 or above.");return nd(t).call(t,(function(t){if(!Ww(t))throw new Error("Invalid hex color code supplied to colormap.");return Fw(t)}))}function AL(t){if(void 0===t)throw new Error("Unsupported type of colormap");if(!(t.saturation>=0&&t.saturation<=100))throw new Error("Saturation is out of bounds. Expected range is 0-100.");if(!(t.brightness>=0&&t.brightness<=100))throw new Error("Brightness is out of bounds. Expected range is 0-100.");if(!(t.colorStops>=2))throw new Error("colorStops is out of bounds. Expected 2 or above.");for(var e=(t.end-t.start)/(t.colorStops-1),r=[],n=0;n<t.colorStops;++n){var i=(t.start+e*n)%360/360;r.push(zw(i<0?i+1:i,t.saturation/100,t.brightness/100))}return r}function DL(t,e){var r=t;void 0!==r&&(void 0===e.camera&&(e.camera=new yL),e.camera.setArmRotation(r.horizontal,r.vertical),e.camera.setArmLength(r.distance))}var LL="string",RL="boolean",FL="number",ML="object",jL="array",IL={fill:{string:LL},stroke:{string:LL},strokeWidth:{number:FL},__type__:{string:LL,object:ML,undefined:"undefined"}},zL={animationAutoStart:{boolean:RL,undefined:"undefined"},animationInterval:{number:FL},animationPreload:{boolean:RL},axisColor:{string:LL},axisFontSize:{number:FL},axisFontType:{string:LL},backgroundColor:IL,xBarWidth:{number:FL,undefined:"undefined"},yBarWidth:{number:FL,undefined:"undefined"},cameraPosition:{distance:{number:FL},horizontal:{number:FL},vertical:{number:FL},__type__:{object:ML}},zoomable:{boolean:RL},ctrlToZoom:{boolean:RL},xCenter:{string:LL},yCenter:{string:LL},colormap:{hue:{start:{number:FL},end:{number:FL},saturation:{number:FL},brightness:{number:FL},colorStops:{number:FL},__type__:{object:ML}},__type__:{array:jL,object:ML,function:"function",undefined:"undefined"}},dataColor:IL,dotSizeMinFraction:{number:FL},dotSizeMaxFraction:{number:FL},dotSizeRatio:{number:FL},filterLabel:{string:LL},gridColor:{string:LL},onclick:{function:"function"},keepAspectRatio:{boolean:RL},xLabel:{string:LL},yLabel:{string:LL},zLabel:{string:LL},legendLabel:{string:LL},xMin:{number:FL,undefined:"undefined"},yMin:{number:FL,undefined:"undefined"},zMin:{number:FL,undefined:"undefined"},xMax:{number:FL,undefined:"undefined"},yMax:{number:FL,undefined:"undefined"},zMax:{number:FL,undefined:"undefined"},showAnimationControls:{boolean:RL,undefined:"undefined"},showGrayBottom:{boolean:RL},showGrid:{boolean:RL},showLegend:{boolean:RL,undefined:"undefined"},showPerspective:{boolean:RL},showShadow:{boolean:RL},showSurfaceGrid:{boolean:RL},showXAxis:{boolean:RL},showYAxis:{boolean:RL},showZAxis:{boolean:RL},rotateAxisLabels:{boolean:RL},surfaceColors:{hue:{start:{number:FL},end:{number:FL},saturation:{number:FL},brightness:{number:FL},colorStops:{number:FL},__type__:{object:ML}},__type__:{boolean:RL,array:jL,object:ML,undefined:"undefined"}},xStep:{number:FL,undefined:"undefined"},yStep:{number:FL,undefined:"undefined"},zStep:{number:FL,undefined:"undefined"},style:{number:FL,string:["bar","bar-color","bar-size","dot","dot-line","dot-color","dot-size","line","grid","surface"]},tooltip:{boolean:RL,function:"function"},tooltipDelay:{number:FL},tooltipStyle:{content:{color:{string:LL},background:{string:LL},border:{string:LL},borderRadius:{string:LL},boxShadow:{string:LL},padding:{string:LL},__type__:{object:ML}},line:{borderLeft:{string:LL},height:{string:LL},width:{string:LL},pointerEvents:{string:LL},__type__:{object:ML}},dot:{border:{string:LL},borderRadius:{string:LL},height:{string:LL},width:{string:LL},pointerEvents:{string:LL},__type__:{object:ML}},__type__:{object:ML}},xValueLabel:{function:"function"},yValueLabel:{function:"function"},zValueLabel:{function:"function"},valueMax:{number:FL,undefined:"undefined"},valueMin:{number:FL,undefined:"undefined"},verticalRatio:{number:FL},height:{string:LL},width:{string:LL},__type__:{object:ML}};function BL(){this.min=void 0,this.max=void 0}BL.prototype.adjust=function(t){void 0!==t&&((void 0===this.min||this.min>t)&&(this.min=t),(void 0===this.max||this.max<t)&&(this.max=t))},BL.prototype.combine=function(t){this.add(t.min),this.add(t.max)},BL.prototype.expand=function(t){if(void 0!==t){var e=this.min-t,r=this.max+t;if(e>r)throw new Error("Passed expansion value makes range invalid");this.min=e,this.max=r}},BL.prototype.range=function(){return this.max-this.min},BL.prototype.center=function(){return(this.min+this.max)/2};var NL=BL;function WL(t,e,r){this.dataGroup=t,this.column=e,this.graph=r,this.index=void 0,this.value=void 0,this.values=t.getDistinctValues(this.column),WA(this).length>0&&this.selectValue(0),this.dataPoints=[],this.loaded=!1,this.onLoadCallback=void 0,r.animationPreload?(this.loaded=!1,this.loadInBackground()):this.loaded=!0}WL.prototype.isLoaded=function(){return this.loaded},WL.prototype.getLoadedProgress=function(){for(var t=WA(this).length,e=0;this.dataPoints[e];)e++;return Math.round(e/t*100)},WL.prototype.getLabel=function(){return this.graph.filterLabel},WL.prototype.getColumn=function(){return this.column},WL.prototype.getSelectedValue=function(){if(void 0!==this.index)return WA(this)[this.index]},WL.prototype.getValues=function(){return WA(this)},WL.prototype.getValue=function(t){if(t>=WA(this).length)throw new Error("Index out of range");return WA(this)[t]},WL.prototype._getDataPoints=function(t){if(void 0===t&&(t=this.index),void 0===t)return[];var e;if(this.dataPoints[t])e=this.dataPoints[t];else{var r={};r.column=this.column,r.value=WA(this)[t];var n=new zD(this.dataGroup.getDataSet(),{filter:function(t){return t[r.column]==r.value}}).get();e=this.dataGroup._getDataPoints(n),this.dataPoints[t]=e}return e},WL.prototype.setOnLoadCallback=function(t){this.onLoadCallback=t},WL.prototype.selectValue=function(t){if(t>=WA(this).length)throw new Error("Index out of range");this.index=t,this.value=WA(this)[t]},WL.prototype.loadInBackground=function(t){void 0===t&&(t=0);var e=this.graph.frame;if(t<WA(this).length){void 0===e.progress&&(e.progress=document.createElement("DIV"),e.progress.style.position="absolute",e.progress.style.color="gray",e.appendChild(e.progress));var r=this.getLoadedProgress();e.progress.innerHTML="Loading animation... "+r+"%",e.progress.style.bottom="60px",e.progress.style.left="10px";var n=this;Lm((function(){n.loadInBackground(t+1)}),10),this.loaded=!1}else this.loaded=!0,void 0!==e.progress&&(e.removeChild(e.progress),e.progress=void 0),this.onLoadCallback&&this.onLoadCallback()};var GL=Object.freeze({__proto__:null,default:WL});function YL(){this.dataTable=null}YL.prototype.initializeData=function(t,e,r){if(void 0!==e){var n;if(qp(e)&&(e=new ID(e)),!(e instanceof ID||e instanceof zD))throw new Error("Array, DataSet, or DataView expected");if(0!=(n=e.get()).length){this.style=r,this.dataSet&&this.dataSet.off("*",this._onChange),this.dataSet=e,this.dataTable=n;var i=this;this._onChange=function(){t.setData(i.dataSet)},this.dataSet.on("*",this._onChange),this.colX="x",this.colY="y",this.colZ="z";var o=t.hasBars(r);if(o&&(void 0!==t.defaultXBarWidth?this.xBarWidth=t.defaultXBarWidth:this.xBarWidth=this.getSmallestDifference(n,this.colX)||1,void 0!==t.defaultYBarWidth?this.yBarWidth=t.defaultYBarWidth:this.yBarWidth=this.getSmallestDifference(n,this.colY)||1),this._initializeRange(n,this.colX,t,o),this._initializeRange(n,this.colY,t,o),this._initializeRange(n,this.colZ,t,!1),Object.prototype.hasOwnProperty.call(n[0],"style")){this.colValue="style";var a=this.getColumnRange(n,this.colValue);this._setRangeDefaults(a,t.defaultValueMin,t.defaultValueMax),this.valueRange=a}else this.colValue="z",this.valueRange=this.zRange;var s=this.getDataTable();return Object.prototype.hasOwnProperty.call(s[0],"filter")&&void 0===this.dataFilter&&(this.dataFilter=new WL(this,"filter",t),this.dataFilter.setOnLoadCallback((function(){t.redraw()}))),this.dataFilter?this.dataFilter._getDataPoints():this._getDataPoints(this.getDataTable())}}},YL.prototype._collectRangeSettings=function(t,e){var r;if(-1==By(r=["x","y","z"]).call(r,t))throw new Error("Column '"+t+"' invalid");var n=t.toUpperCase();return{barWidth:this[t+"BarWidth"],min:e["default"+n+"Min"],max:e["default"+n+"Max"],step:e["default"+n+"Step"],range_label:t+"Range",step_label:t+"Step"}},YL.prototype._initializeRange=function(t,e,r,n){var i=this._collectRangeSettings(e,r),o=this.getColumnRange(t,e);n&&"z"!=e&&o.expand(i.barWidth/2),this._setRangeDefaults(o,i.min,i.max),this[i.range_label]=o,this[i.step_label]=void 0!==i.step?i.step:o.range()/5},YL.prototype.getDistinctValues=function(t,e){void 0===e&&(e=this.dataTable);for(var r=[],n=0;n<e.length;n++){var i=e[n][t]||0;-1===By(r).call(r,i)&&r.push(i)}return cA(r).call(r,(function(t,e){return t-e}))},YL.prototype.getSmallestDifference=function(t,e){for(var r=this.getDistinctValues(t,e),n=null,i=1;i<r.length;i++){var o=r[i]-r[i-1];(null==n||n>o)&&(n=o)}return n},YL.prototype.getColumnRange=function(t,e){for(var r=new NL,n=0;n<t.length;n++){var i=t[n][e];r.adjust(i)}return r},YL.prototype.getNumberOfRows=function(){return this.dataTable.length},YL.prototype._setRangeDefaults=function(t,e,r){void 0!==e&&(t.min=e),void 0!==r&&(t.max=r),t.max<=t.min&&(t.max=t.min+1)},YL.prototype.getDataTable=function(){return this.dataTable},YL.prototype.getDataSet=function(){return this.dataSet},YL.prototype.getDataPoints=function(t){for(var e=[],r=0;r<t.length;r++){var n=new sL;n.x=t[r][this.colX]||0,n.y=t[r][this.colY]||0,n.z=t[r][this.colZ]||0,n.data=t[r],n.value=t[r][this.colValue]||0;var i={};i.point=n,i.bottom=new sL(n.x,n.y,this.zRange.min),i.trans=void 0,i.screen=void 0,e.push(i)}return e},YL.prototype.initDataAsMatrix=function(t){var e,r,n,i,o=this.getDistinctValues(this.colX,t),a=this.getDistinctValues(this.colY,t),s=this.getDataPoints(t),u=[];for(n=0;n<s.length;n++){i=s[n];var l=By(o).call(o,i.point.x),c=By(a).call(a,i.point.y);void 0===u[l]&&(u[l]=[]),u[l][c]=i}for(e=0;e<u.length;e++)for(r=0;r<u[e].length;r++)u[e][r]&&(u[e][r].pointRight=e<u.length-1?u[e+1][r]:void 0,u[e][r].pointTop=r<u[e].length-1?u[e][r+1]:void 0,u[e][r].pointCross=e<u.length-1&&r<u[e].length-1?u[e+1][r+1]:void 0);return s},YL.prototype.getInfo=function(){var t=this.dataFilter;if(t)return t.getLabel()+": "+t.getSelectedValue()},YL.prototype.reload=function(){this.dataTable&&this.setData(this.dataTable)},YL.prototype._getDataPoints=function(t){var e=[];if(this.style===bL.GRID||this.style===bL.SURFACE)e=this.initDataAsMatrix(t);else if(e=this.getDataPoints(t),this.style===bL.LINE)for(var r=0;r<e.length;r++)r>0&&(e[r-1].pointNext=e[r]);return e},XL.STYLE=bL;var VL=void 0;function XL(t,e,r){if(!(this instanceof XL))throw new SyntaxError("Constructor must be called with the new operator");this.containerElement=t,this.dataGroup=new YL,this.dataPoints=null,this.create(),function(t,e){if(void 0===t||CL(t))throw new Error("No DEFAULTS passed");if(void 0===e)throw new Error("No dst passed");kL=t,SL(t,e,wL),SL(t,e,_L,"default"),OL(t,e),e.margin=10,e.showTooltip=!1,e.onclick_callback=null,e.eye=new sL(0,0,-1)}(XL.DEFAULTS,this),this.colX=void 0,this.colY=void 0,this.colZ=void 0,this.colValue=void 0,this.setOptions(r),this.setData(e)}function UL(t){return"clientX"in t?t.clientX:t.targetTouches[0]&&t.targetTouches[0].clientX||0}function HL(t){return"clientY"in t?t.clientY:t.targetTouches[0]&&t.targetTouches[0].clientY||0}XL.DEFAULTS={width:"400px",height:"400px",filterLabel:"time",legendLabel:"value",xLabel:"x",yLabel:"y",zLabel:"z",xValueLabel:function(t){return t},yValueLabel:function(t){return t},zValueLabel:function(t){return t},showXAxis:!0,showYAxis:!0,showZAxis:!0,showGrayBottom:!1,showGrid:!0,showPerspective:!0,showShadow:!1,showSurfaceGrid:!0,keepAspectRatio:!0,rotateAxisLabels:!0,verticalRatio:.5,dotSizeRatio:.02,dotSizeMinFraction:.5,dotSizeMaxFraction:2.5,showAnimationControls:VL,animationInterval:1e3,animationPreload:!1,animationAutoStart:VL,axisFontSize:14,axisFontType:"arial",axisColor:"#4D4D4D",gridColor:"#D3D3D3",xCenter:"55%",yCenter:"50%",style:XL.STYLE.DOT,tooltip:!1,tooltipDelay:300,tooltipStyle:{content:{padding:"10px",border:"1px solid #4d4d4d",color:"#1a1a1a",background:"rgba(255,255,255,0.7)",borderRadius:"2px",boxShadow:"5px 5px 10px rgba(128,128,128,0.5)"},line:{height:"40px",width:"0",borderLeft:"1px solid #4d4d4d",pointerEvents:"none"},dot:{height:"0",width:"0",border:"5px solid #4d4d4d",borderRadius:"5px",pointerEvents:"none"}},dataColor:{fill:"#7DC1FF",stroke:"#3267D2",strokeWidth:1},surfaceColors:VL,colormap:VL,cameraPosition:{horizontal:1,vertical:.5,distance:1.7},zoomable:!0,ctrlToZoom:!1,showLegend:VL,backgroundColor:VL,xBarWidth:VL,yBarWidth:VL,valueMin:VL,valueMax:VL,xMin:VL,xMax:VL,xStep:VL,yMin:VL,yMax:VL,yStep:VL,zMin:VL,zMax:VL,zStep:VL},Hm(XL.prototype),XL.prototype._setScale=function(){this.scale=new sL(1/this.xRange.range(),1/this.yRange.range(),1/this.zRange.range()),this.keepAspectRatio&&(this.scale.x<this.scale.y?this.scale.y=this.scale.x:this.scale.x=this.scale.y),this.scale.z*=this.verticalRatio,void 0!==this.valueRange&&(this.scale.value=1/this.valueRange.range());var t=this.xRange.center()*this.scale.x,e=this.yRange.center()*this.scale.y,r=this.zRange.center()*this.scale.z;this.camera.setArmLocation(t,e,r)},XL.prototype._convert3Dto2D=function(t){var e=this._convertPointToTranslation(t);return this._convertTranslationToScreen(e)},XL.prototype._convertPointToTranslation=function(t){var e=this.camera.getCameraLocation(),r=this.camera.getCameraRotation(),n=t.x*this.scale.x,i=t.y*this.scale.y,o=t.z*this.scale.z,a=e.x,s=e.y,u=e.z,l=Math.sin(r.x),c=Math.cos(r.x),h=Math.sin(r.y),f=Math.cos(r.y),p=Math.sin(r.z),d=Math.cos(r.z);return new sL(f*(p*(i-s)+d*(n-a))-h*(o-u),l*(f*(o-u)+h*(p*(i-s)+d*(n-a)))+c*(d*(i-s)-p*(n-a)),c*(f*(o-u)+h*(p*(i-s)+d*(n-a)))-l*(d*(i-s)-p*(n-a)))},XL.prototype._convertTranslationToScreen=function(t){var e,r,n=this.eye.x,i=this.eye.y,o=this.eye.z,a=t.x,s=t.y,u=t.z;return this.showPerspective?(e=o/u*(a-n),r=o/u*(s-i)):(e=a*(-o/this.camera.getArmLength()),r=s*(-o/this.camera.getArmLength())),new uL(this.currentXCenter+e*this.frame.canvas.clientWidth,this.currentYCenter-r*this.frame.canvas.clientWidth)},XL.prototype._calcTranslations=function(t){for(var e=0;e<t.length;e++){var r=t[e];r.trans=this._convertPointToTranslation(r.point),r.screen=this._convertTranslationToScreen(r.trans);var n=this._convertPointToTranslation(r.bottom);r.dist=this.showPerspective?n.length():-n.z}cA(t).call(t,(function(t,e){return e.dist-t.dist}))},XL.prototype._initializeRanges=function(){var t=this.dataGroup;this.xRange=t.xRange,this.yRange=t.yRange,this.zRange=t.zRange,this.valueRange=t.valueRange,this.xStep=t.xStep,this.yStep=t.yStep,this.zStep=t.zStep,this.xBarWidth=t.xBarWidth,this.yBarWidth=t.yBarWidth,this.colX=t.colX,this.colY=t.colY,this.colZ=t.colZ,this.colValue=t.colValue,this._setScale()},XL.prototype.getDataPoints=function(t){for(var e=[],r=0;r<t.length;r++){var n=new sL;n.x=t[r][this.colX]||0,n.y=t[r][this.colY]||0,n.z=t[r][this.colZ]||0,n.data=t[r],n.value=t[r][this.colValue]||0;var i={};i.point=n,i.bottom=new sL(n.x,n.y,this.zRange.min),i.trans=void 0,i.screen=void 0,e.push(i)}return e},XL.prototype._getDataPoints=function(t){var e,r,n,i,o=[];if(this.style===XL.STYLE.GRID||this.style===XL.STYLE.SURFACE){var a=this.dataGroup.getDistinctValues(this.colX,t),s=this.dataGroup.getDistinctValues(this.colY,t);o=this.getDataPoints(t);var u=[];for(n=0;n<o.length;n++){i=o[n];var l=By(a).call(a,i.point.x),c=By(s).call(s,i.point.y);void 0===u[l]&&(u[l]=[]),u[l][c]=i}for(e=0;e<u.length;e++)for(r=0;r<u[e].length;r++)u[e][r]&&(u[e][r].pointRight=e<u.length-1?u[e+1][r]:void 0,u[e][r].pointTop=r<u[e].length-1?u[e][r+1]:void 0,u[e][r].pointCross=e<u.length-1&&r<u[e].length-1?u[e+1][r+1]:void 0)}else if(o=this.getDataPoints(t),this.style===XL.STYLE.LINE)for(n=0;n<o.length;n++)n>0&&(o[n-1].pointNext=o[n]);return o},XL.prototype.create=function(){for(;this.containerElement.hasChildNodes();)this.containerElement.removeChild(this.containerElement.firstChild);this.frame=document.createElement("div"),this.frame.style.position="relative",this.frame.style.overflow="hidden",this.frame.canvas=document.createElement("canvas"),this.frame.canvas.style.position="relative",this.frame.appendChild(this.frame.canvas);var t=document.createElement("DIV");t.style.color="red",t.style.fontWeight="bold",t.style.padding="10px",t.innerHTML="Error: your browser does not support HTML canvas",this.frame.canvas.appendChild(t),this.frame.filter=document.createElement("div"),Yg(this.frame).style.position="absolute",Yg(this.frame).style.bottom="0px",Yg(this.frame).style.left="0px",Yg(this.frame).style.width="100%",this.frame.appendChild(Yg(this.frame));var e=this;Aw(this.frame.canvas,"mousedown",(function(t){e._onMouseDown(t)})),Aw(this.frame.canvas,"touchstart",(function(t){e._onTouchStart(t)})),Aw(this.frame.canvas,"mousewheel",(function(t){e._onWheel(t)})),Aw(this.frame.canvas,"mousemove",(function(t){e._onTooltip(t)})),Aw(this.frame.canvas,"click",(function(t){e._onClick(t)})),this.containerElement.appendChild(this.frame)},XL.prototype._setSize=function(t,e){this.frame.style.width=t,this.frame.style.height=e,this._resizeCanvas()},XL.prototype._resizeCanvas=function(){this.frame.canvas.style.width="100%",this.frame.canvas.style.height="100%",this.frame.canvas.width=this.frame.canvas.clientWidth,this.frame.canvas.height=this.frame.canvas.clientHeight,Yg(this.frame).style.width=this.frame.canvas.clientWidth-20+"px"},XL.prototype.animationStart=function(){if(this.animationAutoStart&&this.dataGroup.dataFilter){if(!Yg(this.frame)||!Yg(this.frame).slider)throw new Error("No animation available");Yg(this.frame).slider.play()}},XL.prototype.animationStop=function(){Yg(this.frame)&&Yg(this.frame).slider&&Yg(this.frame).slider.stop()},XL.prototype._resizeCenter=function(){"%"===this.xCenter.charAt(this.xCenter.length-1)?this.currentXCenter=eL(this.xCenter)/100*this.frame.canvas.clientWidth:this.currentXCenter=eL(this.xCenter),"%"===this.yCenter.charAt(this.yCenter.length-1)?this.currentYCenter=eL(this.yCenter)/100*(this.frame.canvas.clientHeight-Yg(this.frame).clientHeight):this.currentYCenter=eL(this.yCenter)},XL.prototype.getCameraPosition=function(){var t=this.camera.getArmRotation();return t.distance=this.camera.getArmLength(),t},XL.prototype._readData=function(t){this.dataPoints=this.dataGroup.initializeData(this,t,this.style),this._initializeRanges(),this._redrawFilter()},XL.prototype.setData=function(t){null!=t&&(this._readData(t),this.redraw(),this.animationStart())},XL.prototype.setOptions=function(t){void 0!==t&&(!0===a_.validate(t,zL)&&console.error("%cErrors have been found in the supplied options object.",o_),this.animationStop(),function(t,e){if(void 0!==t){if(void 0===e)throw new Error("No dst passed");if(void 0===kL||CL(kL))throw new Error("DEFAULTS not set for module Settings");TL(t,e,wL),TL(t,e,_L,"default"),OL(t,e)}}(t,this),this.setPointDrawingMethod(),this._setSize(this.width,this.height),this.setAxisLabelMethod(),this.setData(this.dataGroup.getDataTable()),this.animationStart())},XL.prototype.setPointDrawingMethod=function(){var t=void 0;switch(this.style){case XL.STYLE.BAR:t=this._redrawBarGraphPoint;break;case XL.STYLE.BARCOLOR:t=this._redrawBarColorGraphPoint;break;case XL.STYLE.BARSIZE:t=this._redrawBarSizeGraphPoint;break;case XL.STYLE.DOT:t=this._redrawDotGraphPoint;break;case XL.STYLE.DOTLINE:t=this._redrawDotLineGraphPoint;break;case XL.STYLE.DOTCOLOR:t=this._redrawDotColorGraphPoint;break;case XL.STYLE.DOTSIZE:t=this._redrawDotSizeGraphPoint;break;case XL.STYLE.SURFACE:t=this._redrawSurfaceGraphPoint;break;case XL.STYLE.GRID:t=this._redrawGridGraphPoint;break;case XL.STYLE.LINE:t=this._redrawLineGraphPoint;break;default:throw new Error("Can not determine point drawing method for graph style '"+this.style+"'")}this._pointDrawingMethod=t},XL.prototype.setAxisLabelMethod=function(){this.rotateAxisLabels?(this._drawAxisLabelX=this.drawAxisLabelXRotate,this._drawAxisLabelY=this.drawAxisLabelYRotate,this._drawAxisLabelZ=this.drawAxisLabelZRotate):(this._drawAxisLabelX=this.drawAxisLabelX,this._drawAxisLabelY=this.drawAxisLabelY,this._drawAxisLabelZ=this.drawAxisLabelZ)},XL.prototype.redraw=function(){if(void 0===this.dataPoints)throw new Error("Graph data not initialized");this._resizeCanvas(),this._resizeCenter(),this._redrawSlider(),this._redrawClear(),this._redrawAxis(),this._redrawDataGraph(),this._redrawInfo(),this._redrawLegend()},XL.prototype._getContext=function(){var t=this.frame.canvas.getContext("2d");return t.lineJoin="round",t.lineCap="round",t},XL.prototype._redrawClear=function(){var t=this.frame.canvas;t.getContext("2d").clearRect(0,0,t.width,t.height)},XL.prototype._dotSize=function(){return this.frame.clientWidth*this.dotSizeRatio},XL.prototype._getLegendWidth=function(){var t;this.style===XL.STYLE.DOTSIZE?t=this._dotSize()*this.dotSizeMaxFraction:t=this.style===XL.STYLE.BARSIZE?this.xBarWidth:20;return t},XL.prototype._redrawLegend=function(){if(!0===this.showLegend&&this.style!==XL.STYLE.LINE&&this.style!==XL.STYLE.BARSIZE){var t=this.style===XL.STYLE.BARSIZE||this.style===XL.STYLE.DOTSIZE,e=this.style===XL.STYLE.DOTSIZE||this.style===XL.STYLE.DOTCOLOR||this.style===XL.STYLE.SURFACE||this.style===XL.STYLE.BARCOLOR,r=Math.max(.25*this.frame.clientHeight,100),n=this.margin,i=this._getLegendWidth(),o=this.frame.clientWidth-this.margin,a=o-i,s=n+r,u=this._getContext();if(u.lineWidth=1,u.font="14px arial",!1===t){var l,c=r;for(l=0;l<c;l++){var h=1-(l-0)/(c-0),f=this._colormap(h,1);u.strokeStyle=f,u.beginPath(),u.moveTo(a,n+l),u.lineTo(o,n+l),u.stroke()}u.strokeStyle=this.axisColor,u.strokeRect(a,n,i,r)}else{var p;this.style===XL.STYLE.DOTSIZE?p=i*(this.dotSizeMinFraction/this.dotSizeMaxFraction):(this.style,XL.STYLE.BARSIZE),u.strokeStyle=this.axisColor,u.fillStyle=Vm(this.dataColor),u.beginPath(),u.moveTo(a,n),u.lineTo(o,n),u.lineTo(a+p,s),u.lineTo(a,s),u.closePath(),Vm(u).call(u),u.stroke()}var d=e?this.valueRange.min:this.zRange.min,v=e?this.valueRange.max:this.zRange.max,g=new fL(d,v,(v-d)/5,!0);for(g.start(!0);!g.end();){var y=s-(g.getCurrent()-d)/(v-d)*r,m=new uL(a-5,y),b=new uL(a,y);this._line(u,m,b),u.textAlign="right",u.textBaseline="middle",u.fillStyle=this.axisColor,u.fillText(g.getCurrent(),a-10,y),g.next()}u.textAlign="right",u.textBaseline="top";var x=this.legendLabel;u.fillText(x,o,s+this.margin)}},XL.prototype._redrawFilter=function(){var t=this.dataGroup.dataFilter,e=Yg(this.frame);if(e.innerHTML="",t){var r=new lL(e,{visible:this.showAnimationControls});e.slider=r,e.style.padding="10px",r.setValues(WA(t)),r.setPlayInterval(this.animationInterval);var n=this;r.setOnChangeCallback((function(){var t=n.dataGroup.dataFilter,e=r.getIndex();t.selectValue(e),n.dataPoints=t._getDataPoints(),n.redraw()}))}else e.slider=void 0},XL.prototype._redrawSlider=function(){void 0!==Yg(this.frame).slider&&Yg(this.frame).slider.redraw()},XL.prototype._redrawInfo=function(){var t=this.dataGroup.getInfo();if(void 0!==t){var e=this._getContext();e.font="14px arial",e.lineStyle="gray",e.fillStyle="gray",e.textAlign="left",e.textBaseline="top";var r=this.margin,n=this.margin;e.fillText(t,r,n)}},XL.prototype._line=function(t,e,r,n){void 0!==n&&(t.strokeStyle=n),t.beginPath(),t.moveTo(e.x,e.y),t.lineTo(r.x,r.y),t.stroke()},XL.prototype.drawAxisLabelX=function(t,e,r,n,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*n)>0?(t.textAlign="center",t.textBaseline="top",o.y+=i):Math.sin(2*n)<0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)},XL.prototype.drawAxisLabelY=function(t,e,r,n,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*n)<0?(t.textAlign="center",t.textBaseline="top",o.y+=i):Math.sin(2*n)>0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)},XL.prototype.drawAxisLabelZ=function(t,e,r,n){void 0===n&&(n=0);var i=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,i.x-n,i.y)},XL.prototype.drawAxisLabelXRotate=function(t,e,r,n,i){var o=this._convert3Dto2D(e);Math.cos(2*n)>0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,0,0),t.restore()):Math.sin(2*n)<0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y))},XL.prototype.drawAxisLabelYRotate=function(t,e,r,n,i){var o=this._convert3Dto2D(e);Math.cos(2*n)<0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,0,0),t.restore()):Math.sin(2*n)>0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y))},XL.prototype.drawAxisLabelZRotate=function(t,e,r,n){void 0===n&&(n=0);var i=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,i.x-n,i.y)},XL.prototype._line3d=function(t,e,r,n){var i=this._convert3Dto2D(e),o=this._convert3Dto2D(r);this._line(t,i,o,n)},XL.prototype._redrawAxis=function(){var t,e,r,n,i,o,a,s,u,l,c=this._getContext();c.font=this.axisFontSize/this.camera.getArmLength()+"px "+this.axisFontType;var h,f,p,d=.025/this.scale.x,v=.025/this.scale.y,g=5/this.camera.getArmLength(),y=this.camera.getArmRotation().horizontal,m=new uL(Math.cos(y),Math.sin(y)),b=this.xRange,x=this.yRange,w=this.zRange;for(c.lineWidth=1,n=void 0===this.defaultXStep,(r=new fL(b.min,b.max,this.xStep,n)).start(!0);!r.end();){var _=r.getCurrent();if(this.showGrid?(t=new sL(_,x.min,w.min),e=new sL(_,x.max,w.min),this._line3d(c,t,e,this.gridColor)):this.showXAxis&&(t=new sL(_,x.min,w.min),e=new sL(_,x.min+d,w.min),this._line3d(c,t,e,this.axisColor),t=new sL(_,x.max,w.min),e=new sL(_,x.max-d,w.min),this._line3d(c,t,e,this.axisColor)),this.showXAxis){a=m.x>0?x.min:x.max,h=new sL(_,a,w.min);var k="  "+this.xValueLabel(_)+"  ";this._drawAxisLabelX.call(this,c,h,k,y,g)}r.next()}for(c.lineWidth=1,n=void 0===this.defaultYStep,(r=new fL(x.min,x.max,this.yStep,n)).start(!0);!r.end();){var C=r.getCurrent();if(this.showGrid?(t=new sL(b.min,C,w.min),e=new sL(b.max,C,w.min),this._line3d(c,t,e,this.gridColor)):this.showYAxis&&(t=new sL(b.min,C,w.min),e=new sL(b.min+v,C,w.min),this._line3d(c,t,e,this.axisColor),t=new sL(b.max,C,w.min),e=new sL(b.max-v,C,w.min),this._line3d(c,t,e,this.axisColor)),this.showYAxis){o=m.y>0?b.min:b.max,h=new sL(o,C,w.min);var E="  "+this.yValueLabel(C)+"  ";this._drawAxisLabelY.call(this,c,h,E,y,g)}r.next()}if(this.showZAxis){for(c.lineWidth=1,n=void 0===this.defaultZStep,(r=new fL(w.min,w.max,this.zStep,n)).start(!0),o=m.x>0?b.min:b.max,a=m.y<0?x.min:x.max;!r.end();){var S=r.getCurrent(),T=new sL(o,a,S),O=this._convert3Dto2D(T);e=new uL(O.x-g,O.y),this._line(c,O,e,this.axisColor);var P=this.zValueLabel(S)+" ";this._drawAxisLabelZ.call(this,c,T,P,5),r.next()}c.lineWidth=1,t=new sL(o,a,w.min),e=new sL(o,a,w.max),this._line3d(c,t,e,this.axisColor)}this.showXAxis&&(c.lineWidth=1,f=new sL(b.min,x.min,w.min),p=new sL(b.max,x.min,w.min),this._line3d(c,f,p,this.axisColor),f=new sL(b.min,x.max,w.min),p=new sL(b.max,x.max,w.min),this._line3d(c,f,p,this.axisColor));this.showYAxis&&(c.lineWidth=1,t=new sL(b.min,x.min,w.min),e=new sL(b.min,x.max,w.min),this._line3d(c,t,e,this.axisColor),t=new sL(b.max,x.min,w.min),e=new sL(b.max,x.max,w.min),this._line3d(c,t,e,this.axisColor));var A=this.xLabel;A.length>0&&this.showXAxis&&(l=.1/this.scale.y,o=(b.max+3*b.min)/4,a=m.x>0?x.min-l:x.max+l,i=new sL(o,a,w.min),this.drawAxisLabelX(c,i,A,y));var D=this.yLabel;D.length>0&&this.showYAxis&&(u=.1/this.scale.x,o=m.y>0?b.min-u:b.max+u,a=(x.max+3*x.min)/4,i=new sL(o,a,w.min),this.drawAxisLabelY(c,i,D,y));var L=this.zLabel;L.length>0&&this.showZAxis&&(30,o=m.x>0?b.min:b.max,a=m.y<0?x.min:x.max,s=(w.max+3*w.min)/4,i=new sL(o,a,s),this.drawAxisLabelZ(c,i,L,30))},XL.prototype._getStrokeWidth=function(t){return void 0!==t?this.showPerspective?1/-t.trans.z*this.dataColor.strokeWidth:-this.eye.z/this.camera.getArmLength()*this.dataColor.strokeWidth:this.dataColor.strokeWidth},XL.prototype._redrawBar=function(t,e,r,n,i,o){var a,s=this,u=e.point,l=this.zRange.min,c=[{point:new sL(u.x-r,u.y-n,u.z)},{point:new sL(u.x+r,u.y-n,u.z)},{point:new sL(u.x+r,u.y+n,u.z)},{point:new sL(u.x-r,u.y+n,u.z)}],h=[{point:new sL(u.x-r,u.y-n,l)},{point:new sL(u.x+r,u.y-n,l)},{point:new sL(u.x+r,u.y+n,l)},{point:new sL(u.x-r,u.y+n,l)}];Kd(c).call(c,(function(t){t.screen=s._convert3Dto2D(t.point)})),Kd(h).call(h,(function(t){t.screen=s._convert3Dto2D(t.point)}));var f=[{corners:c,center:sL.avg(h[0].point,h[2].point)},{corners:[c[0],c[1],h[1],h[0]],center:sL.avg(h[1].point,h[0].point)},{corners:[c[1],c[2],h[2],h[1]],center:sL.avg(h[2].point,h[1].point)},{corners:[c[2],c[3],h[3],h[2]],center:sL.avg(h[3].point,h[2].point)},{corners:[c[3],c[0],h[0],h[3]],center:sL.avg(h[0].point,h[3].point)}];e.surfaces=f;for(var p=0;p<f.length;p++){a=f[p];var d=this._convertPointToTranslation(a.center);a.dist=this.showPerspective?d.length():-d.z}cA(f).call(f,(function(t,e){var r=e.dist-t.dist;return r||(t.corners===c?1:e.corners===c?-1:0)})),t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=o,t.fillStyle=i;for(var v=2;v<f.length;v++)a=f[v],this._polygon(t,a.corners)},XL.prototype._polygon=function(t,e,r,n){if(!(e.length<2)){void 0!==r&&(t.fillStyle=r),void 0!==n&&(t.strokeStyle=n),t.beginPath(),t.moveTo(e[0].screen.x,e[0].screen.y);for(var i=1;i<e.length;++i){var o=e[i];t.lineTo(o.screen.x,o.screen.y)}t.closePath(),Vm(t).call(t),t.stroke()}},XL.prototype._drawCircle=function(t,e,r,n,i){var o=this._calcRadius(e,i);t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=n,t.fillStyle=r,t.beginPath(),t.arc(e.screen.x,e.screen.y,o,0,2*Math.PI,!0),Vm(t).call(t),t.stroke()},XL.prototype._getColorsRegular=function(t){var e=(t.point.value-this.valueRange.min)*this.scale.value;return{fill:this._colormap(e,1),border:this._colormap(e,.8)}},XL.prototype._getColorsColor=function(t){var e,r,n;if(t&&t.point&&t.point.data&&t.point.data.style&&(n=t.point.data.style),n&&"object"===Df(n)&&Vm(n)&&n.stroke)return{fill:Vm(n),border:n.stroke};if("string"==typeof t.point.value)e=t.point.value,r=t.point.value;else{var i=(t.point.value-this.valueRange.min)*this.scale.value;e=this._colormap(i,1),r=this._colormap(i,.8)}return{fill:e,border:r}},XL.prototype._getColorsSize=function(){return{fill:Vm(this.dataColor),border:this.dataColor.stroke}},XL.prototype._colormap=function(t){var e,r,n,i,o,a,s,u,l,c=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1,h=this.colormap;if(qp(h)){var f=h.length-1,p=Math.max(Math.floor(t*f),0),d=Math.min(p+1,f),v=t*f-p,g=h[p],y=h[d];e=g.r+v*(y.r-g.r),r=g.g+v*(y.g-g.g),n=g.b+v*(y.b-g.b)}else if("function"==typeof h){var m=h(t);e=m.r,r=m.g,n=m.b,i=m.a}else{var b=zw(240*(1-t)/360,1,1);e=b.r,r=b.g,n=b.b}return"number"!=typeof i||oL(i)?Np(o=Np(a="RGB(".concat(Math.round(e*c),", ")).call(a,Math.round(r*c),", ")).call(o,Math.round(n*c),")"):Np(s=Np(u=Np(l="RGBA(".concat(Math.round(e*c),", ")).call(l,Math.round(r*c),", ")).call(u,Math.round(n*c),", ")).call(s,i,")")},XL.prototype._calcRadius=function(t,e){var r;return void 0===e&&(e=this._dotSize()),(r=this.showPerspective?e/-t.trans.z:e*(-this.eye.z/this.camera.getArmLength()))<0&&(r=0),r},XL.prototype._redrawBarGraphPoint=function(t,e){var r=this.xBarWidth/2,n=this.yBarWidth/2,i=this._getColorsRegular(e);this._redrawBar(t,e,r,n,Vm(i),i.border)},XL.prototype._redrawBarColorGraphPoint=function(t,e){var r=this.xBarWidth/2,n=this.yBarWidth/2,i=this._getColorsColor(e);this._redrawBar(t,e,r,n,Vm(i),i.border)},XL.prototype._redrawBarSizeGraphPoint=function(t,e){var r=(e.point.value-this.valueRange.min)/this.valueRange.range(),n=this.xBarWidth/2*(.8*r+.2),i=this.yBarWidth/2*(.8*r+.2),o=this._getColorsSize();this._redrawBar(t,e,n,i,Vm(o),o.border)},XL.prototype._redrawDotGraphPoint=function(t,e){var r=this._getColorsRegular(e);this._drawCircle(t,e,Vm(r),r.border)},XL.prototype._redrawDotLineGraphPoint=function(t,e){var r=this._convert3Dto2D(e.bottom);t.lineWidth=1,this._line(t,r,e.screen,this.gridColor),this._redrawDotGraphPoint(t,e)},XL.prototype._redrawDotColorGraphPoint=function(t,e){var r=this._getColorsColor(e);this._drawCircle(t,e,Vm(r),r.border)},XL.prototype._redrawDotSizeGraphPoint=function(t,e){var r=this._dotSize(),n=(e.point.value-this.valueRange.min)/this.valueRange.range(),i=r*this.dotSizeMinFraction,o=i+(r*this.dotSizeMaxFraction-i)*n,a=this._getColorsSize();this._drawCircle(t,e,Vm(a),a.border,o)},XL.prototype._redrawSurfaceGraphPoint=function(t,e){var r=e.pointRight,n=e.pointTop,i=e.pointCross;if(void 0!==e&&void 0!==r&&void 0!==n&&void 0!==i){var o,a,s,u=!0;if(this.showGrayBottom||this.showShadow){var l=sL.subtract(i.trans,e.trans),c=sL.subtract(n.trans,r.trans),h=sL.crossProduct(l,c);if(this.showPerspective){var f=sL.avg(sL.avg(e.trans,i.trans),sL.avg(r.trans,n.trans));s=-sL.dotProduct(h.normalize(),f.normalize())}else s=h.z/h.length();u=s>0}if(u||!this.showGrayBottom){var p=((e.point.value+r.point.value+n.point.value+i.point.value)/4-this.valueRange.min)*this.scale.value,d=this.showShadow?(1+s)/2:1;o=this._colormap(p,d)}else o="gray";a=this.showSurfaceGrid?this.axisColor:o,t.lineWidth=this._getStrokeWidth(e);var v=[e,r,i,n];this._polygon(t,v,o,a)}},XL.prototype._drawGridLine=function(t,e,r){if(void 0!==e&&void 0!==r){var n=((e.point.value+r.point.value)/2-this.valueRange.min)*this.scale.value;t.lineWidth=2*this._getStrokeWidth(e),t.strokeStyle=this._colormap(n,1),this._line(t,e.screen,r.screen)}},XL.prototype._redrawGridGraphPoint=function(t,e){this._drawGridLine(t,e,e.pointRight),this._drawGridLine(t,e,e.pointTop)},XL.prototype._redrawLineGraphPoint=function(t,e){void 0!==e.pointNext&&(t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=this.dataColor.stroke,this._line(t,e.screen,e.pointNext.screen))},XL.prototype._redrawDataGraph=function(){var t,e=this._getContext();if(!(void 0===this.dataPoints||this.dataPoints.length<=0))for(this._calcTranslations(this.dataPoints),t=0;t<this.dataPoints.length;t++){var r=this.dataPoints[t];this._pointDrawingMethod.call(this,e,r)}},XL.prototype._storeMousePosition=function(t){this.startMouseX=UL(t),this.startMouseY=HL(t),this._startCameraOffset=this.camera.getOffset()},XL.prototype._onMouseDown=function(t){if(t=t||window.event,this.leftButtonDown&&this._onMouseUp(t),this.leftButtonDown=t.which?1===t.which:1===t.button,this.leftButtonDown||this.touchDown){this._storeMousePosition(t),this.startStart=new Date(this.start),this.startEnd=new Date(this.end),this.startArmRotation=this.camera.getArmRotation(),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},Aw(document,"mousemove",e.onmousemove),Aw(document,"mouseup",e.onmouseup),Lw(t)}},XL.prototype._onMouseMove=function(t){this.moving=!0,t=t||window.event;var e=eL(UL(t))-this.startMouseX,r=eL(HL(t))-this.startMouseY;if(t&&!0===t.ctrlKey){var n=.5*this.frame.clientWidth,i=.5*this.frame.clientHeight,o=(this._startCameraOffset.x||0)-e/n*this.camera.armLength*.8,a=(this._startCameraOffset.y||0)+r/i*this.camera.armLength*.8;this.camera.setOffset(o,a),this._storeMousePosition(t)}else{var s=this.startArmRotation.horizontal+e/200,u=this.startArmRotation.vertical+r/200,l=Math.sin(4/360*2*Math.PI);Math.abs(Math.sin(s))<l&&(s=Math.round(s/Math.PI)*Math.PI-.001),Math.abs(Math.cos(s))<l&&(s=(Math.round(s/Math.PI-.5)+.5)*Math.PI-.001),Math.abs(Math.sin(u))<l&&(u=Math.round(u/Math.PI)*Math.PI),Math.abs(Math.cos(u))<l&&(u=(Math.round(u/Math.PI-.5)+.5)*Math.PI),this.camera.setArmRotation(s,u)}this.redraw();var c=this.getCameraPosition();this.emit("cameraPositionChange",c),Lw(t)},XL.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",this.leftButtonDown=!1,Dw(document,"mousemove",this.onmousemove),Dw(document,"mouseup",this.onmouseup),Lw(t)},XL.prototype._onClick=function(t){if(this.onclick_callback||this.hasListeners("click")){if(this.moving)this.moving=!1;else{var e=this.frame.getBoundingClientRect(),r=UL(t)-e.left,n=HL(t)-e.top,i=this._dataPointFromXY(r,n);i&&(this.onclick_callback&&this.onclick_callback(i.point.data),this.emit("click",i.point.data))}Lw(t)}},XL.prototype._onTooltip=function(t){var e=this.tooltipDelay,r=this.frame.getBoundingClientRect(),n=UL(t)-r.left,i=HL(t)-r.top;if(this.showTooltip)if(this.tooltipTimeout&&clearTimeout(this.tooltipTimeout),this.leftButtonDown)this._hideTooltip();else if(this.tooltip&&this.tooltip.dataPoint){var o=this._dataPointFromXY(n,i);o!==this.tooltip.dataPoint&&(o?this._showTooltip(o):this._hideTooltip())}else{var a=this;this.tooltipTimeout=Lm((function(){a.tooltipTimeout=null;var t=a._dataPointFromXY(n,i);t&&a._showTooltip(t)}),e)}},XL.prototype._onTouchStart=function(t){this.touchDown=!0;var e=this;this.ontouchmove=function(t){e._onTouchMove(t)},this.ontouchend=function(t){e._onTouchEnd(t)},Aw(document,"touchmove",e.ontouchmove),Aw(document,"touchend",e.ontouchend),this._onMouseDown(t)},XL.prototype._onTouchMove=function(t){this._onMouseMove(t)},XL.prototype._onTouchEnd=function(t){this.touchDown=!1,Dw(document,"touchmove",this.ontouchmove),Dw(document,"touchend",this.ontouchend),this._onMouseUp(t)},XL.prototype._onWheel=function(t){if(t||(t=window.event),this.zoomable&&(!this.ctrlToZoom||t.ctrlKey)){var e=0;if(t.wheelDelta?e=t.wheelDelta/120:t.detail&&(e=-t.detail/3),e){var r=this.camera.getArmLength()*(1-e/10);this.camera.setArmLength(r),this.redraw(),this._hideTooltip()}var n=this.getCameraPosition();this.emit("cameraPositionChange",n),Lw(t)}},XL.prototype._insideTriangle=function(t,e){var r=e[0],n=e[1],i=e[2];function o(t){return t>0?1:t<0?-1:0}var a=o((n.x-r.x)*(t.y-r.y)-(n.y-r.y)*(t.x-r.x)),s=o((i.x-n.x)*(t.y-n.y)-(i.y-n.y)*(t.x-n.x)),u=o((r.x-i.x)*(t.y-i.y)-(r.y-i.y)*(t.x-i.x));return!(0!=a&&0!=s&&a!=s||0!=s&&0!=u&&s!=u||0!=a&&0!=u&&a!=u)},XL.prototype._dataPointFromXY=function(t,e){var r,n=new uL(t,e),i=null,o=null,a=null;if(this.style===XL.STYLE.BAR||this.style===XL.STYLE.BARCOLOR||this.style===XL.STYLE.BARSIZE)for(r=this.dataPoints.length-1;r>=0;r--){var s=(i=this.dataPoints[r]).surfaces;if(s)for(var u=s.length-1;u>=0;u--){var l=s[u].corners,c=[l[0].screen,l[1].screen,l[2].screen],h=[l[2].screen,l[3].screen,l[0].screen];if(this._insideTriangle(n,c)||this._insideTriangle(n,h))return i}}else for(r=0;r<this.dataPoints.length;r++){var f=(i=this.dataPoints[r]).screen;if(f){var p=Math.abs(t-f.x),d=Math.abs(e-f.y),v=Math.sqrt(p*p+d*d);(null===a||v<a)&&v<100&&(a=v,o=i)}}return o},XL.prototype.hasBars=function(t){return t==XL.STYLE.BAR||t==XL.STYLE.BARCOLOR||t==XL.STYLE.BARSIZE},XL.prototype._showTooltip=function(t){var e,r,n;this.tooltip?(e=this.tooltip.dom.content,r=this.tooltip.dom.line,n=this.tooltip.dom.dot):(e=document.createElement("div"),ng(e.style,{},this.tooltipStyle.content),e.style.position="absolute",r=document.createElement("div"),ng(r.style,{},this.tooltipStyle.line),r.style.position="absolute",n=document.createElement("div"),ng(n.style,{},this.tooltipStyle.dot),n.style.position="absolute",this.tooltip={dataPoint:null,dom:{content:e,line:r,dot:n}}),this._hideTooltip(),this.tooltip.dataPoint=t,"function"==typeof this.showTooltip?e.innerHTML=this.showTooltip(t.point):e.innerHTML="<table><tr><td>"+this.xLabel+":</td><td>"+t.point.x+"</td></tr><tr><td>"+this.yLabel+":</td><td>"+t.point.y+"</td></tr><tr><td>"+this.zLabel+":</td><td>"+t.point.z+"</td></tr></table>",e.style.left="0",e.style.top="0",this.frame.appendChild(e),this.frame.appendChild(r),this.frame.appendChild(n);var i=e.offsetWidth,o=e.offsetHeight,a=r.offsetHeight,s=n.offsetWidth,u=n.offsetHeight,l=t.screen.x-i/2;l=Math.min(Math.max(l,10),this.frame.clientWidth-10-i),r.style.left=t.screen.x+"px",r.style.top=t.screen.y-a+"px",e.style.left=l+"px",e.style.top=t.screen.y-a-o+"px",n.style.left=t.screen.x-s/2+"px",n.style.top=t.screen.y-u/2+"px"},XL.prototype._hideTooltip=function(){if(this.tooltip)for(var t in this.tooltip.dataPoint=null,this.tooltip.dom)if(Object.prototype.hasOwnProperty.call(this.tooltip.dom,t)){var e=this.tooltip.dom[t];e&&e.parentNode&&e.parentNode.removeChild(e)}},XL.prototype.setCameraPosition=function(t){DL(t,this),this.redraw()},XL.prototype.setSize=function(t,e){this._setSize(t,e),this.redraw()};var qL=n(Object.freeze({__proto__:null,default:XL})),ZL=n(mL),$L=n(GL),QL=n(cL);var KL=Object.freeze({__proto__:null,default:function(t){var e,r=t&&t.preventDefault||!1,n=t&&t.container||window,i={},o={keydown:{},keyup:{}},a={};for(e=97;e<=122;e++)a[String.fromCharCode(e)]={code:e-97+65,shift:!1};for(e=65;e<=90;e++)a[String.fromCharCode(e)]={code:e,shift:!0};for(e=0;e<=9;e++)a[""+e]={code:48+e,shift:!1};for(e=1;e<=12;e++)a["F"+e]={code:111+e,shift:!1};for(e=0;e<=9;e++)a["num"+e]={code:96+e,shift:!1};a["num*"]={code:106,shift:!1},a["num+"]={code:107,shift:!1},a["num-"]={code:109,shift:!1},a["num/"]={code:111,shift:!1},a["num."]={code:110,shift:!1},a.left={code:37,shift:!1},a.up={code:38,shift:!1},a.right={code:39,shift:!1},a.down={code:40,shift:!1},a.space={code:32,shift:!1},a.enter={code:13,shift:!1},a.shift={code:16,shift:void 0},a.esc={code:27,shift:!1},a.backspace={code:8,shift:!1},a.tab={code:9,shift:!1},a.ctrl={code:17,shift:!1},a.alt={code:18,shift:!1},a.delete={code:46,shift:!1},a.pageup={code:33,shift:!1},a.pagedown={code:34,shift:!1},a["="]={code:187,shift:!1},a["-"]={code:189,shift:!1},a["]"]={code:221,shift:!1},a["["]={code:219,shift:!1};var s=function(t){l(t,"keydown")},u=function(t){l(t,"keyup")},l=function(t,e){if(void 0!==o[e][t.keyCode]){for(var n=o[e][t.keyCode],i=0;i<n.length;i++)(void 0===n[i].shift||1==n[i].shift&&1==t.shiftKey||0==n[i].shift&&0==t.shiftKey)&&n[i].fn(t);1==r&&t.preventDefault()}};return i.bind=function(t,e,r){if(void 0===r&&(r="keydown"),void 0===a[t])throw new Error("unsupported key: "+t);void 0===o[r][a[t].code]&&(o[r][a[t].code]=[]),o[r][a[t].code].push({fn:e,shift:a[t].shift})},i.bindAll=function(t,e){for(var r in void 0===e&&(e="keydown"),a)a.hasOwnProperty(r)&&i.bind(r,t,e)},i.getKey=function(t){for(var e in a)if(a.hasOwnProperty(e)){if(1==t.shiftKey&&1==a[e].shift&&t.keyCode==a[e].code)return e;if(0==t.shiftKey&&0==a[e].shift&&t.keyCode==a[e].code)return e;if(t.keyCode==a[e].code&&"shift"==e)return e}return"unknown key, currently not supported"},i.unbind=function(t,e,r){if(void 0===r&&(r="keydown"),void 0===a[t])throw new Error("unsupported key: "+t);if(void 0!==e){var n=[],i=o[r][a[t].code];if(void 0!==i)for(var s=0;s<i.length;s++)i[s].fn==e&&i[s].shift==a[t].shift||n.push(o[r][a[t].code][s]);o[r][a[t].code]=n}else o[r][a[t].code]=[]},i.reset=function(){o={keydown:{},keyup:{}}},i.destroy=function(){o={keydown:{},keyup:{}},n.removeEventListener("keydown",s,!0),n.removeEventListener("keyup",u,!0)},n.addEventListener("keydown",s,!0),n.addEventListener("keyup",u,!0),i}}),JL=n(KL),tR=u_,eR=i.util=tR,rR=i.DOMutil=l_,nR=WD.DataSet,iR=WD.DataView,oR=WD.Queue,aR=i.DataSet=nR,sR=i.DataView=iR,uR=i.Queue=oR,lR=i.Graph3d=qL,cR=i.graph3d={Camera:ZL,Filter:$L,Point2d:uL,Point3d:sL,Slider:QL,StepNumber:fL},hR=i.Hammer=u_.Hammer,fR=i.keycharm=JL;t.DOMutil=rR,t.DataSet=aR,t.DataView=sR,t.Graph3d=lR,t.Hammer=hR,t.Queue=uR,t.default=i,t.graph3d=cR,t.keycharm=fR,t.util=eR,Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=vis-graph3d.min.js.map
