/**
 * vis-graph3d
 * https://visjs.github.io/vis-graph3d/
 *
 * Create interactive, animated 3d graphs. Surfaces, lines, dots and block styling out of the box.
 *
 * @version 6.0.3
 * @date    2023-03-21T17:15:34.624Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
import{DataView as t,DataSet as e}from"vis-data/peer/esm/vis-data.js";var r="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function n(t){return t&&t.__esModule&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t}var i={},o={get exports(){return i},set exports(t){i=t}},a={},s={get exports(){return a},set exports(t){a=t}},c=function(t){return t&&t.Math==Math&&t},l=c("object"==typeof globalThis&&globalThis)||c("object"==typeof window&&window)||c("object"==typeof self&&self)||c("object"==typeof r&&r)||function(){return this}()||Function("return this")(),h=function(t){try{return!!t()}catch(t){return!0}},u=!h((function(){var t=function(){}.bind();return"function"!=typeof t||t.hasOwnProperty("prototype")})),p=u,f=Function.prototype,d=f.apply,v=f.call,y="object"==typeof Reflect&&Reflect.apply||(p?v.bind(d):function(){return v.apply(d,arguments)}),m=u,g=Function.prototype,x=g.call,b=m&&g.bind.bind(x,x),w=m?b:function(t){return function(){return x.apply(t,arguments)}},_=w,S=_({}.toString),T=_("".slice),C=function(t){return T(S(t),8,-1)},A=C,E=w,L=function(t){if("Function"===A(t))return E(t)},O="object"==typeof document&&document.all,P={all:O,IS_HTMLDDA:void 0===O&&void 0!==O},M=P.all,D=P.IS_HTMLDDA?function(t){return"function"==typeof t||t===M}:function(t){return"function"==typeof t},R={},k=!h((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),I=u,z=Function.prototype.call,j=I?z.bind(z):function(){return z.apply(z,arguments)},F={},B={}.propertyIsEnumerable,N=Object.getOwnPropertyDescriptor,W=N&&!B.call({1:2},1);F.f=W?function(t){var e=N(this,t);return!!e&&e.enumerable}:B;var Y,G,X=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},V=h,U=C,Z=Object,H=w("".split),q=V((function(){return!Z("z").propertyIsEnumerable(0)}))?function(t){return"String"==U(t)?H(t,""):Z(t)}:Z,$=function(t){return null==t},J=$,K=TypeError,Q=function(t){if(J(t))throw K("Can't call method on "+t);return t},tt=q,et=Q,rt=function(t){return tt(et(t))},nt=D,it=P.all,ot=P.IS_HTMLDDA?function(t){return"object"==typeof t?null!==t:nt(t)||t===it}:function(t){return"object"==typeof t?null!==t:nt(t)},at={},st=at,ct=l,lt=D,ht=function(t){return lt(t)?t:void 0},ut=function(t,e){return arguments.length<2?ht(st[t])||ht(ct[t]):st[t]&&st[t][e]||ct[t]&&ct[t][e]},pt=w({}.isPrototypeOf),ft="undefined"!=typeof navigator&&String(navigator.userAgent)||"",dt=l,vt=ft,yt=dt.process,mt=dt.Deno,gt=yt&&yt.versions||mt&&mt.version,xt=gt&&gt.v8;xt&&(G=(Y=xt.split("."))[0]>0&&Y[0]<4?1:+(Y[0]+Y[1])),!G&&vt&&(!(Y=vt.match(/Edge\/(\d+)/))||Y[1]>=74)&&(Y=vt.match(/Chrome\/(\d+)/))&&(G=+Y[1]);var bt=G,wt=bt,_t=h,St=!!Object.getOwnPropertySymbols&&!_t((function(){var t=Symbol();return!String(t)||!(Object(t)instanceof Symbol)||!Symbol.sham&&wt&&wt<41})),Tt=St&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,Ct=ut,At=D,Et=pt,Lt=Object,Ot=Tt?function(t){return"symbol"==typeof t}:function(t){var e=Ct("Symbol");return At(e)&&Et(e.prototype,Lt(t))},Pt=String,Mt=function(t){try{return Pt(t)}catch(t){return"Object"}},Dt=D,Rt=Mt,kt=TypeError,It=function(t){if(Dt(t))return t;throw kt(Rt(t)+" is not a function")},zt=It,jt=$,Ft=function(t,e){var r=t[e];return jt(r)?void 0:zt(r)},Bt=j,Nt=D,Wt=ot,Yt=TypeError,Gt={},Xt={get exports(){return Gt},set exports(t){Gt=t}},Vt=l,Ut=Object.defineProperty,Zt=function(t,e){try{Ut(Vt,t,{value:e,configurable:!0,writable:!0})}catch(r){Vt[t]=e}return e},Ht="__core-js_shared__",qt=l[Ht]||Zt(Ht,{}),$t=qt;(Xt.exports=function(t,e){return $t[t]||($t[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.29.0",mode:"pure",copyright:"© 2014-2023 Denis Pushkarev (zloirock.ru)",license:"https://github.com/zloirock/core-js/blob/v3.29.0/LICENSE",source:"https://github.com/zloirock/core-js"});var Jt=Q,Kt=Object,Qt=function(t){return Kt(Jt(t))},te=Qt,ee=w({}.hasOwnProperty),re=Object.hasOwn||function(t,e){return ee(te(t),e)},ne=w,ie=0,oe=Math.random(),ae=ne(1..toString),se=function(t){return"Symbol("+(void 0===t?"":t)+")_"+ae(++ie+oe,36)},ce=Gt,le=re,he=se,ue=St,pe=Tt,fe=l.Symbol,de=ce("wks"),ve=pe?fe.for||fe:fe&&fe.withoutSetter||he,ye=function(t){return le(de,t)||(de[t]=ue&&le(fe,t)?fe[t]:ve("Symbol."+t)),de[t]},me=j,ge=ot,xe=Ot,be=Ft,we=function(t,e){var r,n;if("string"===e&&Nt(r=t.toString)&&!Wt(n=Bt(r,t)))return n;if(Nt(r=t.valueOf)&&!Wt(n=Bt(r,t)))return n;if("string"!==e&&Nt(r=t.toString)&&!Wt(n=Bt(r,t)))return n;throw Yt("Can't convert object to primitive value")},_e=TypeError,Se=ye("toPrimitive"),Te=function(t,e){if(!ge(t)||xe(t))return t;var r,n=be(t,Se);if(n){if(void 0===e&&(e="default"),r=me(n,t,e),!ge(r)||xe(r))return r;throw _e("Can't convert object to primitive value")}return void 0===e&&(e="number"),we(t,e)},Ce=Ot,Ae=function(t){var e=Te(t,"string");return Ce(e)?e:e+""},Ee=ot,Le=l.document,Oe=Ee(Le)&&Ee(Le.createElement),Pe=function(t){return Oe?Le.createElement(t):{}},Me=Pe,De=!k&&!h((function(){return 7!=Object.defineProperty(Me("div"),"a",{get:function(){return 7}}).a})),Re=k,ke=j,Ie=F,ze=X,je=rt,Fe=Ae,Be=re,Ne=De,We=Object.getOwnPropertyDescriptor;R.f=Re?We:function(t,e){if(t=je(t),e=Fe(e),Ne)try{return We(t,e)}catch(t){}if(Be(t,e))return ze(!ke(Ie.f,t,e),t[e])};var Ye=h,Ge=D,Xe=/#|\.prototype\./,Ve=function(t,e){var r=Ze[Ue(t)];return r==qe||r!=He&&(Ge(e)?Ye(e):!!e)},Ue=Ve.normalize=function(t){return String(t).replace(Xe,".").toLowerCase()},Ze=Ve.data={},He=Ve.NATIVE="N",qe=Ve.POLYFILL="P",$e=Ve,Je=It,Ke=u,Qe=L(L.bind),tr=function(t,e){return Je(t),void 0===e?t:Ke?Qe(t,e):function(){return t.apply(e,arguments)}},er={},rr=k&&h((function(){return 42!=Object.defineProperty((function(){}),"prototype",{value:42,writable:!1}).prototype})),nr=ot,ir=String,or=TypeError,ar=function(t){if(nr(t))return t;throw or(ir(t)+" is not an object")},sr=k,cr=De,lr=rr,hr=ar,ur=Ae,pr=TypeError,fr=Object.defineProperty,dr=Object.getOwnPropertyDescriptor,vr="enumerable",yr="configurable",mr="writable";er.f=sr?lr?function(t,e,r){if(hr(t),e=ur(e),hr(r),"function"==typeof t&&"prototype"===e&&"value"in r&&mr in r&&!r[mr]){var n=dr(t,e);n&&n[mr]&&(t[e]=r.value,r={configurable:yr in r?r[yr]:n[yr],enumerable:vr in r?r[vr]:n[vr],writable:!1})}return fr(t,e,r)}:fr:function(t,e,r){if(hr(t),e=ur(e),hr(r),cr)try{return fr(t,e,r)}catch(t){}if("get"in r||"set"in r)throw pr("Accessors not supported");return"value"in r&&(t[e]=r.value),t};var gr=er,xr=X,br=k?function(t,e,r){return gr.f(t,e,xr(1,r))}:function(t,e,r){return t[e]=r,t},wr=l,_r=y,Sr=L,Tr=D,Cr=R.f,Ar=$e,Er=at,Lr=tr,Or=br,Pr=re,Mr=function(t){var e=function(r,n,i){if(this instanceof e){switch(arguments.length){case 0:return new t;case 1:return new t(r);case 2:return new t(r,n)}return new t(r,n,i)}return _r(t,this,arguments)};return e.prototype=t.prototype,e},Dr=function(t,e){var r,n,i,o,a,s,c,l,h,u=t.target,p=t.global,f=t.stat,d=t.proto,v=p?wr:f?wr[u]:(wr[u]||{}).prototype,y=p?Er:Er[u]||Or(Er,u,{})[u],m=y.prototype;for(o in e)n=!(r=Ar(p?o:u+(f?".":"#")+o,t.forced))&&v&&Pr(v,o),s=y[o],n&&(c=t.dontCallGetSet?(h=Cr(v,o))&&h.value:v[o]),a=n&&c?c:e[o],n&&typeof s==typeof a||(l=t.bind&&n?Lr(a,wr):t.wrap&&n?Mr(a):d&&Tr(a)?Sr(a):a,(t.sham||a&&a.sham||s&&s.sham)&&Or(l,"sham",!0),Or(y,o,l),d&&(Pr(Er,i=u+"Prototype")||Or(Er,i,{}),Or(Er[i],o,a),t.real&&m&&(r||!m[o])&&Or(m,o,a)))},Rr=C,kr=Array.isArray||function(t){return"Array"==Rr(t)},Ir=Math.ceil,zr=Math.floor,jr=Math.trunc||function(t){var e=+t;return(e>0?zr:Ir)(e)},Fr=function(t){var e=+t;return e!=e||0===e?0:jr(e)},Br=Fr,Nr=Math.min,Wr=function(t){return t>0?Nr(Br(t),9007199254740991):0},Yr=function(t){return Wr(t.length)},Gr=TypeError,Xr=function(t){if(t>9007199254740991)throw Gr("Maximum allowed index exceeded");return t},Vr=Ae,Ur=er,Zr=X,Hr=function(t,e,r){var n=Vr(e);n in t?Ur.f(t,n,Zr(0,r)):t[n]=r},qr={};qr[ye("toStringTag")]="z";var $r="[object z]"===String(qr),Jr=$r,Kr=D,Qr=C,tn=ye("toStringTag"),en=Object,rn="Arguments"==Qr(function(){return arguments}()),nn=Jr?Qr:function(t){var e,r,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(r=function(t,e){try{return t[e]}catch(t){}}(e=en(t),tn))?r:rn?Qr(e):"Object"==(n=Qr(e))&&Kr(e.callee)?"Arguments":n},on=D,an=qt,sn=w(Function.toString);on(an.inspectSource)||(an.inspectSource=function(t){return sn(t)});var cn=an.inspectSource,ln=w,hn=h,un=D,pn=nn,fn=cn,dn=function(){},vn=[],yn=ut("Reflect","construct"),mn=/^\s*(?:class|function)\b/,gn=ln(mn.exec),xn=!mn.exec(dn),bn=function(t){if(!un(t))return!1;try{return yn(dn,vn,t),!0}catch(t){return!1}},wn=function(t){if(!un(t))return!1;switch(pn(t)){case"AsyncFunction":case"GeneratorFunction":case"AsyncGeneratorFunction":return!1}try{return xn||!!gn(mn,fn(t))}catch(t){return!0}};wn.sham=!0;var _n=!yn||hn((function(){var t;return bn(bn.call)||!bn(Object)||!bn((function(){t=!0}))||t}))?wn:bn,Sn=kr,Tn=_n,Cn=ot,An=ye("species"),En=Array,Ln=function(t){var e;return Sn(t)&&(e=t.constructor,(Tn(e)&&(e===En||Sn(e.prototype))||Cn(e)&&null===(e=e[An]))&&(e=void 0)),void 0===e?En:e},On=function(t,e){return new(Ln(t))(0===e?0:e)},Pn=h,Mn=bt,Dn=ye("species"),Rn=function(t){return Mn>=51||!Pn((function(){var e=[];return(e.constructor={})[Dn]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},kn=Dr,In=h,zn=kr,jn=ot,Fn=Qt,Bn=Yr,Nn=Xr,Wn=Hr,Yn=On,Gn=Rn,Xn=bt,Vn=ye("isConcatSpreadable"),Un=Xn>=51||!In((function(){var t=[];return t[Vn]=!1,t.concat()[0]!==t})),Zn=function(t){if(!jn(t))return!1;var e=t[Vn];return void 0!==e?!!e:zn(t)};kn({target:"Array",proto:!0,arity:1,forced:!Un||!Gn("concat")},{concat:function(t){var e,r,n,i,o,a=Fn(this),s=Yn(a,0),c=0;for(e=-1,n=arguments.length;e<n;e++)if(Zn(o=-1===e?a:arguments[e]))for(i=Bn(o),Nn(c+i),r=0;r<i;r++,c++)r in o&&Wn(s,c,o[r]);else Nn(c+1),Wn(s,c++,o);return s.length=c,s}});var Hn=nn,qn=String,$n=function(t){if("Symbol"===Hn(t))throw TypeError("Cannot convert a Symbol value to a string");return qn(t)},Jn={},Kn=Fr,Qn=Math.max,ti=Math.min,ei=function(t,e){var r=Kn(t);return r<0?Qn(r+e,0):ti(r,e)},ri=rt,ni=ei,ii=Yr,oi=function(t){return function(e,r,n){var i,o=ri(e),a=ii(o),s=ni(n,a);if(t&&r!=r){for(;a>s;)if((i=o[s++])!=i)return!0}else for(;a>s;s++)if((t||s in o)&&o[s]===r)return t||s||0;return!t&&-1}},ai={includes:oi(!0),indexOf:oi(!1)},si={},ci=re,li=rt,hi=ai.indexOf,ui=si,pi=w([].push),fi=function(t,e){var r,n=li(t),i=0,o=[];for(r in n)!ci(ui,r)&&ci(n,r)&&pi(o,r);for(;e.length>i;)ci(n,r=e[i++])&&(~hi(o,r)||pi(o,r));return o},di=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],vi=fi,yi=di,mi=Object.keys||function(t){return vi(t,yi)},gi=k,xi=rr,bi=er,wi=ar,_i=rt,Si=mi;Jn.f=gi&&!xi?Object.defineProperties:function(t,e){wi(t);for(var r,n=_i(e),i=Si(e),o=i.length,a=0;o>a;)bi.f(t,r=i[a++],n[r]);return t};var Ti,Ci=ut("document","documentElement"),Ai=se,Ei=Gt("keys"),Li=function(t){return Ei[t]||(Ei[t]=Ai(t))},Oi=ar,Pi=Jn,Mi=di,Di=si,Ri=Ci,ki=Pe,Ii="prototype",zi="script",ji=Li("IE_PROTO"),Fi=function(){},Bi=function(t){return"<"+zi+">"+t+"</"+zi+">"},Ni=function(t){t.write(Bi("")),t.close();var e=t.parentWindow.Object;return t=null,e},Wi=function(){try{Ti=new ActiveXObject("htmlfile")}catch(t){}var t,e,r;Wi="undefined"!=typeof document?document.domain&&Ti?Ni(Ti):(e=ki("iframe"),r="java"+zi+":",e.style.display="none",Ri.appendChild(e),e.src=String(r),(t=e.contentWindow.document).open(),t.write(Bi("document.F=Object")),t.close(),t.F):Ni(Ti);for(var n=Mi.length;n--;)delete Wi[Ii][Mi[n]];return Wi()};Di[ji]=!0;var Yi=Object.create||function(t,e){var r;return null!==t?(Fi[Ii]=Oi(t),r=new Fi,Fi[Ii]=null,r[ji]=t):r=Wi(),void 0===e?r:Pi.f(r,e)},Gi={},Xi=fi,Vi=di.concat("length","prototype");Gi.f=Object.getOwnPropertyNames||function(t){return Xi(t,Vi)};var Ui={},Zi=ei,Hi=Yr,qi=Hr,$i=Array,Ji=Math.max,Ki=function(t,e,r){for(var n=Hi(t),i=Zi(e,n),o=Zi(void 0===r?n:r,n),a=$i(Ji(o-i,0)),s=0;i<o;i++,s++)qi(a,s,t[i]);return a.length=s,a},Qi=C,to=rt,eo=Gi.f,ro=Ki,no="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[];Ui.f=function(t){return no&&"Window"==Qi(t)?function(t){try{return eo(t)}catch(t){return ro(no)}}(t):eo(to(t))};var io={};io.f=Object.getOwnPropertySymbols;var oo=br,ao=function(t,e,r,n){return n&&n.enumerable?t[e]=r:oo(t,e,r),t},so=er,co={},lo=ye;co.f=lo;var ho,uo,po,fo=at,vo=re,yo=co,mo=er.f,go=function(t){var e=fo.Symbol||(fo.Symbol={});vo(e,t)||mo(e,t,{value:yo.f(t)})},xo=j,bo=ut,wo=ye,_o=ao,So=function(){var t=bo("Symbol"),e=t&&t.prototype,r=e&&e.valueOf,n=wo("toPrimitive");e&&!e[n]&&_o(e,n,(function(t){return xo(r,this)}),{arity:1})},To=nn,Co=$r?{}.toString:function(){return"[object "+To(this)+"]"},Ao=$r,Eo=er.f,Lo=br,Oo=re,Po=Co,Mo=ye("toStringTag"),Do=function(t,e,r,n){if(t){var i=r?t:t.prototype;Oo(i,Mo)||Eo(i,Mo,{configurable:!0,value:e}),n&&!Ao&&Lo(i,"toString",Po)}},Ro=D,ko=l.WeakMap,Io=Ro(ko)&&/native code/.test(String(ko)),zo=l,jo=ot,Fo=br,Bo=re,No=qt,Wo=Li,Yo=si,Go="Object already initialized",Xo=zo.TypeError,Vo=zo.WeakMap;if(Io||No.state){var Uo=No.state||(No.state=new Vo);Uo.get=Uo.get,Uo.has=Uo.has,Uo.set=Uo.set,ho=function(t,e){if(Uo.has(t))throw Xo(Go);return e.facade=t,Uo.set(t,e),e},uo=function(t){return Uo.get(t)||{}},po=function(t){return Uo.has(t)}}else{var Zo=Wo("state");Yo[Zo]=!0,ho=function(t,e){if(Bo(t,Zo))throw Xo(Go);return e.facade=t,Fo(t,Zo,e),e},uo=function(t){return Bo(t,Zo)?t[Zo]:{}},po=function(t){return Bo(t,Zo)}}var Ho={set:ho,get:uo,has:po,enforce:function(t){return po(t)?uo(t):ho(t,{})},getterFor:function(t){return function(e){var r;if(!jo(e)||(r=uo(e)).type!==t)throw Xo("Incompatible receiver, "+t+" required");return r}}},qo=tr,$o=q,Jo=Qt,Ko=Yr,Qo=On,ta=w([].push),ea=function(t){var e=1==t,r=2==t,n=3==t,i=4==t,o=6==t,a=7==t,s=5==t||o;return function(c,l,h,u){for(var p,f,d=Jo(c),v=$o(d),y=qo(l,h),m=Ko(v),g=0,x=u||Qo,b=e?x(c,m):r||a?x(c,0):void 0;m>g;g++)if((s||g in v)&&(f=y(p=v[g],g,d),t))if(e)b[g]=f;else if(f)switch(t){case 3:return!0;case 5:return p;case 6:return g;case 2:ta(b,p)}else switch(t){case 4:return!1;case 7:ta(b,p)}return o?-1:n||i?i:b}},ra={forEach:ea(0),map:ea(1),filter:ea(2),some:ea(3),every:ea(4),find:ea(5),findIndex:ea(6),filterReject:ea(7)},na=Dr,ia=l,oa=j,aa=w,sa=k,ca=St,la=h,ha=re,ua=pt,pa=ar,fa=rt,da=Ae,va=$n,ya=X,ma=Yi,ga=mi,xa=Gi,ba=Ui,wa=io,_a=R,Sa=er,Ta=Jn,Ca=F,Aa=ao,Ea=function(t,e,r){return so.f(t,e,r)},La=Gt,Oa=si,Pa=se,Ma=ye,Da=co,Ra=go,ka=So,Ia=Do,za=Ho,ja=ra.forEach,Fa=Li("hidden"),Ba="Symbol",Na="prototype",Wa=za.set,Ya=za.getterFor(Ba),Ga=Object[Na],Xa=ia.Symbol,Va=Xa&&Xa[Na],Ua=ia.TypeError,Za=ia.QObject,Ha=_a.f,qa=Sa.f,$a=ba.f,Ja=Ca.f,Ka=aa([].push),Qa=La("symbols"),ts=La("op-symbols"),es=La("wks"),rs=!Za||!Za[Na]||!Za[Na].findChild,ns=sa&&la((function(){return 7!=ma(qa({},"a",{get:function(){return qa(this,"a",{value:7}).a}})).a}))?function(t,e,r){var n=Ha(Ga,e);n&&delete Ga[e],qa(t,e,r),n&&t!==Ga&&qa(Ga,e,n)}:qa,is=function(t,e){var r=Qa[t]=ma(Va);return Wa(r,{type:Ba,tag:t,description:e}),sa||(r.description=e),r},os=function(t,e,r){t===Ga&&os(ts,e,r),pa(t);var n=da(e);return pa(r),ha(Qa,n)?(r.enumerable?(ha(t,Fa)&&t[Fa][n]&&(t[Fa][n]=!1),r=ma(r,{enumerable:ya(0,!1)})):(ha(t,Fa)||qa(t,Fa,ya(1,{})),t[Fa][n]=!0),ns(t,n,r)):qa(t,n,r)},as=function(t,e){pa(t);var r=fa(e),n=ga(r).concat(hs(r));return ja(n,(function(e){sa&&!oa(ss,r,e)||os(t,e,r[e])})),t},ss=function(t){var e=da(t),r=oa(Ja,this,e);return!(this===Ga&&ha(Qa,e)&&!ha(ts,e))&&(!(r||!ha(this,e)||!ha(Qa,e)||ha(this,Fa)&&this[Fa][e])||r)},cs=function(t,e){var r=fa(t),n=da(e);if(r!==Ga||!ha(Qa,n)||ha(ts,n)){var i=Ha(r,n);return!i||!ha(Qa,n)||ha(r,Fa)&&r[Fa][n]||(i.enumerable=!0),i}},ls=function(t){var e=$a(fa(t)),r=[];return ja(e,(function(t){ha(Qa,t)||ha(Oa,t)||Ka(r,t)})),r},hs=function(t){var e=t===Ga,r=$a(e?ts:fa(t)),n=[];return ja(r,(function(t){!ha(Qa,t)||e&&!ha(Ga,t)||Ka(n,Qa[t])})),n};ca||(Aa(Va=(Xa=function(){if(ua(Va,this))throw Ua("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?va(arguments[0]):void 0,e=Pa(t),r=function(t){this===Ga&&oa(r,ts,t),ha(this,Fa)&&ha(this[Fa],e)&&(this[Fa][e]=!1),ns(this,e,ya(1,t))};return sa&&rs&&ns(Ga,e,{configurable:!0,set:r}),is(e,t)})[Na],"toString",(function(){return Ya(this).tag})),Aa(Xa,"withoutSetter",(function(t){return is(Pa(t),t)})),Ca.f=ss,Sa.f=os,Ta.f=as,_a.f=cs,xa.f=ba.f=ls,wa.f=hs,Da.f=function(t){return is(Ma(t),t)},sa&&Ea(Va,"description",{configurable:!0,get:function(){return Ya(this).description}})),na({global:!0,constructor:!0,wrap:!0,forced:!ca,sham:!ca},{Symbol:Xa}),ja(ga(es),(function(t){Ra(t)})),na({target:Ba,stat:!0,forced:!ca},{useSetter:function(){rs=!0},useSimple:function(){rs=!1}}),na({target:"Object",stat:!0,forced:!ca,sham:!sa},{create:function(t,e){return void 0===e?ma(t):as(ma(t),e)},defineProperty:os,defineProperties:as,getOwnPropertyDescriptor:cs}),na({target:"Object",stat:!0,forced:!ca},{getOwnPropertyNames:ls}),ka(),Ia(Xa,Ba),Oa[Fa]=!0;var us=St&&!!Symbol.for&&!!Symbol.keyFor,ps=Dr,fs=ut,ds=re,vs=$n,ys=Gt,ms=us,gs=ys("string-to-symbol-registry"),xs=ys("symbol-to-string-registry");ps({target:"Symbol",stat:!0,forced:!ms},{for:function(t){var e=vs(t);if(ds(gs,e))return gs[e];var r=fs("Symbol")(e);return gs[e]=r,xs[r]=e,r}});var bs=Dr,ws=re,_s=Ot,Ss=Mt,Ts=us,Cs=Gt("symbol-to-string-registry");bs({target:"Symbol",stat:!0,forced:!Ts},{keyFor:function(t){if(!_s(t))throw TypeError(Ss(t)+" is not a symbol");if(ws(Cs,t))return Cs[t]}});var As=w([].slice),Es=kr,Ls=D,Os=C,Ps=$n,Ms=w([].push),Ds=Dr,Rs=ut,ks=y,Is=j,zs=w,js=h,Fs=D,Bs=Ot,Ns=As,Ws=function(t){if(Ls(t))return t;if(Es(t)){for(var e=t.length,r=[],n=0;n<e;n++){var i=t[n];"string"==typeof i?Ms(r,i):"number"!=typeof i&&"Number"!=Os(i)&&"String"!=Os(i)||Ms(r,Ps(i))}var o=r.length,a=!0;return function(t,e){if(a)return a=!1,e;if(Es(this))return e;for(var n=0;n<o;n++)if(r[n]===t)return e}}},Ys=St,Gs=String,Xs=Rs("JSON","stringify"),Vs=zs(/./.exec),Us=zs("".charAt),Zs=zs("".charCodeAt),Hs=zs("".replace),qs=zs(1..toString),$s=/[\uD800-\uDFFF]/g,Js=/^[\uD800-\uDBFF]$/,Ks=/^[\uDC00-\uDFFF]$/,Qs=!Ys||js((function(){var t=Rs("Symbol")();return"[null]"!=Xs([t])||"{}"!=Xs({a:t})||"{}"!=Xs(Object(t))})),tc=js((function(){return'"\\udf06\\ud834"'!==Xs("\udf06\ud834")||'"\\udead"'!==Xs("\udead")})),ec=function(t,e){var r=Ns(arguments),n=Ws(e);if(Fs(n)||void 0!==t&&!Bs(t))return r[1]=function(t,e){if(Fs(n)&&(e=Is(n,this,Gs(t),e)),!Bs(e))return e},ks(Xs,null,r)},rc=function(t,e,r){var n=Us(r,e-1),i=Us(r,e+1);return Vs(Js,t)&&!Vs(Ks,i)||Vs(Ks,t)&&!Vs(Js,n)?"\\u"+qs(Zs(t,0),16):t};Xs&&Ds({target:"JSON",stat:!0,arity:3,forced:Qs||tc},{stringify:function(t,e,r){var n=Ns(arguments),i=ks(Qs?ec:Xs,null,n);return tc&&"string"==typeof i?Hs(i,$s,rc):i}});var nc=io,ic=Qt;Dr({target:"Object",stat:!0,forced:!St||h((function(){nc.f(1)}))},{getOwnPropertySymbols:function(t){var e=nc.f;return e?e(ic(t)):[]}}),go("asyncIterator"),go("hasInstance"),go("isConcatSpreadable"),go("iterator"),go("match"),go("matchAll"),go("replace"),go("search"),go("species"),go("split");var oc=So;go("toPrimitive"),oc();var ac=ut,sc=Do;go("toStringTag"),sc(ac("Symbol"),"Symbol"),go("unscopables"),Do(l.JSON,"JSON",!0);var cc,lc,hc,uc=at.Symbol,pc={},fc=k,dc=re,vc=Function.prototype,yc=fc&&Object.getOwnPropertyDescriptor,mc=dc(vc,"name"),gc={EXISTS:mc,PROPER:mc&&"something"===function(){}.name,CONFIGURABLE:mc&&(!fc||fc&&yc(vc,"name").configurable)},xc=!h((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),bc=re,wc=D,_c=Qt,Sc=xc,Tc=Li("IE_PROTO"),Cc=Object,Ac=Cc.prototype,Ec=Sc?Cc.getPrototypeOf:function(t){var e=_c(t);if(bc(e,Tc))return e[Tc];var r=e.constructor;return wc(r)&&e instanceof r?r.prototype:e instanceof Cc?Ac:null},Lc=h,Oc=D,Pc=ot,Mc=Yi,Dc=Ec,Rc=ao,kc=ye("iterator"),Ic=!1;[].keys&&("next"in(hc=[].keys())?(lc=Dc(Dc(hc)))!==Object.prototype&&(cc=lc):Ic=!0);var zc=!Pc(cc)||Lc((function(){var t={};return cc[kc].call(t)!==t}));Oc((cc=zc?{}:Mc(cc))[kc])||Rc(cc,kc,(function(){return this}));var jc={IteratorPrototype:cc,BUGGY_SAFARI_ITERATORS:Ic},Fc=jc.IteratorPrototype,Bc=Yi,Nc=X,Wc=Do,Yc=pc,Gc=function(){return this},Xc=Dr,Vc=j,Uc=function(t,e,r,n){var i=e+" Iterator";return t.prototype=Bc(Fc,{next:Nc(+!n,r)}),Wc(t,i,!1,!0),Yc[i]=Gc,t},Zc=Ec,Hc=Do,qc=ao,$c=pc,Jc=gc.PROPER,Kc=jc.BUGGY_SAFARI_ITERATORS,Qc=ye("iterator"),tl="keys",el="values",rl="entries",nl=function(){return this},il=function(t,e,r,n,i,o,a){Uc(r,e,n);var s,c,l,h=function(t){if(t===i&&v)return v;if(!Kc&&t in f)return f[t];switch(t){case tl:case el:case rl:return function(){return new r(this,t)}}return function(){return new r(this)}},u=e+" Iterator",p=!1,f=t.prototype,d=f[Qc]||f["@@iterator"]||i&&f[i],v=!Kc&&d||h(i),y="Array"==e&&f.entries||d;if(y&&(s=Zc(y.call(new t)))!==Object.prototype&&s.next&&(Hc(s,u,!0,!0),$c[u]=nl),Jc&&i==el&&d&&d.name!==el&&(p=!0,v=function(){return Vc(d,this)}),i)if(c={values:h(el),keys:o?v:h(tl),entries:h(rl)},a)for(l in c)(Kc||p||!(l in f))&&qc(f,l,c[l]);else Xc({target:e,proto:!0,forced:Kc||p},c);return a&&f[Qc]!==v&&qc(f,Qc,v,{name:i}),$c[e]=v,c},ol=function(t,e){return{value:t,done:e}},al=rt,sl=pc,cl=Ho;er.f;var ll=il,hl=ol,ul="Array Iterator",pl=cl.set,fl=cl.getterFor(ul);ll(Array,"Array",(function(t,e){pl(this,{type:ul,target:al(t),index:0,kind:e})}),(function(){var t=fl(this),e=t.target,r=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,hl(void 0,!0)):hl("keys"==r?n:"values"==r?e[n]:[n,e[n]],!1)}),"values"),sl.Arguments=sl.Array;var dl={CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0},vl=l,yl=nn,ml=br,gl=pc,xl=ye("toStringTag");for(var bl in dl){var wl=vl[bl],_l=wl&&wl.prototype;_l&&yl(_l)!==xl&&ml(_l,xl,bl),gl[bl]=gl.Array}var Sl=uc;go("dispose");var Tl=Sl;go("asyncDispose");var Cl=Dr,Al=w,El=ut("Symbol"),Ll=El.keyFor,Ol=Al(El.prototype.valueOf);Cl({target:"Symbol",stat:!0},{isRegistered:function(t){try{return void 0!==Ll(Ol(t))}catch(t){return!1}}});for(var Pl=Dr,Ml=Gt,Dl=ut,Rl=w,kl=Ot,Il=ye,zl=Dl("Symbol"),jl=zl.isWellKnown,Fl=Dl("Object","getOwnPropertyNames"),Bl=Rl(zl.prototype.valueOf),Nl=Ml("wks"),Wl=0,Yl=Fl(zl),Gl=Yl.length;Wl<Gl;Wl++)try{var Xl=Yl[Wl];kl(zl[Xl])&&Il(Xl)}catch(t){}Pl({target:"Symbol",stat:!0,forced:!0},{isWellKnown:function(t){if(jl&&jl(t))return!0;try{for(var e=Bl(t),r=0,n=Fl(Nl),i=n.length;r<i;r++)if(Nl[n[r]]==e)return!0}catch(t){}return!1}}),go("matcher"),go("metadataKey"),go("observable"),go("metadata"),go("patternMatch"),go("replaceAll");var Vl=Tl;s.exports=Vl,o.exports=a;var Ul=n(i),Zl={},Hl={get exports(){return Zl},set exports(t){Zl=t}},ql={},$l={get exports(){return ql},set exports(t){ql=t}},Jl=w,Kl=Fr,Ql=$n,th=Q,eh=Jl("".charAt),rh=Jl("".charCodeAt),nh=Jl("".slice),ih=function(t){return function(e,r){var n,i,o=Ql(th(e)),a=Kl(r),s=o.length;return a<0||a>=s?t?"":void 0:(n=rh(o,a))<55296||n>56319||a+1===s||(i=rh(o,a+1))<56320||i>57343?t?eh(o,a):n:t?nh(o,a,a+2):i-56320+(n-55296<<10)+65536}},oh={codeAt:ih(!1),charAt:ih(!0)}.charAt,ah=$n,sh=Ho,ch=il,lh=ol,hh="String Iterator",uh=sh.set,ph=sh.getterFor(hh);ch(String,"String",(function(t){uh(this,{type:hh,string:ah(t),index:0})}),(function(){var t,e=ph(this),r=e.string,n=e.index;return n>=r.length?lh(void 0,!0):(t=oh(r,n),e.index+=t.length,lh(t,!1))}));var fh=co.f("iterator");$l.exports=fh,Hl.exports=ql;var dh=n(Zl);function vh(t){return vh="function"==typeof Ul&&"symbol"==typeof dh?function(t){return typeof t}:function(t){return t&&"function"==typeof Ul&&t.constructor===Ul&&t!==Ul.prototype?"symbol":typeof t},vh(t)}var yh={},mh={get exports(){return yh},set exports(t){yh=t}},gh=Mt,xh=TypeError,bh=function(t,e){if(!delete t[e])throw xh("Cannot delete property "+gh(e)+" of "+gh(t))},wh=Ki,_h=Math.floor,Sh=function(t,e){var r=t.length,n=_h(r/2);return r<8?Th(t,e):Ch(t,Sh(wh(t,0,n),e),Sh(wh(t,n),e),e)},Th=function(t,e){for(var r,n,i=t.length,o=1;o<i;){for(n=o,r=t[o];n&&e(t[n-1],r)>0;)t[n]=t[--n];n!==o++&&(t[n]=r)}return t},Ch=function(t,e,r,n){for(var i=e.length,o=r.length,a=0,s=0;a<i||s<o;)t[a+s]=a<i&&s<o?n(e[a],r[s])<=0?e[a++]:r[s++]:a<i?e[a++]:r[s++];return t},Ah=Sh,Eh=h,Lh=function(t,e){var r=[][t];return!!r&&Eh((function(){r.call(null,e||function(){return 1},1)}))},Oh=ft.match(/firefox\/(\d+)/i),Ph=!!Oh&&+Oh[1],Mh=/MSIE|Trident/.test(ft),Dh=ft.match(/AppleWebKit\/(\d+)\./),Rh=!!Dh&&+Dh[1],kh=Dr,Ih=w,zh=It,jh=Qt,Fh=Yr,Bh=bh,Nh=$n,Wh=h,Yh=Ah,Gh=Lh,Xh=Ph,Vh=Mh,Uh=bt,Zh=Rh,Hh=[],qh=Ih(Hh.sort),$h=Ih(Hh.push),Jh=Wh((function(){Hh.sort(void 0)})),Kh=Wh((function(){Hh.sort(null)})),Qh=Gh("sort"),tu=!Wh((function(){if(Uh)return Uh<70;if(!(Xh&&Xh>3)){if(Vh)return!0;if(Zh)return Zh<603;var t,e,r,n,i="";for(t=65;t<76;t++){switch(e=String.fromCharCode(t),t){case 66:case 69:case 70:case 72:r=3;break;case 68:case 71:r=4;break;default:r=2}for(n=0;n<47;n++)Hh.push({k:e+n,v:r})}for(Hh.sort((function(t,e){return e.v-t.v})),n=0;n<Hh.length;n++)e=Hh[n].k.charAt(0),i.charAt(i.length-1)!==e&&(i+=e);return"DGBEFHACIJK"!==i}}));kh({target:"Array",proto:!0,forced:Jh||!Kh||!Qh||!tu},{sort:function(t){void 0!==t&&zh(t);var e=jh(this);if(tu)return void 0===t?qh(e):qh(e,t);var r,n,i=[],o=Fh(e);for(n=0;n<o;n++)n in e&&$h(i,e[n]);for(Yh(i,function(t){return function(e,r){return void 0===r?-1:void 0===e?1:void 0!==t?+t(e,r)||0:Nh(e)>Nh(r)?1:-1}}(t)),r=Fh(i),n=0;n<r;)e[n]=i[n++];for(;n<o;)Bh(e,n++);return e}});var eu=at,ru=function(t){return eu[t+"Prototype"]},nu=ru("Array").sort,iu=pt,ou=nu,au=Array.prototype,su=function(t){var e=t.sort;return t===au||iu(au,t)&&e===au.sort?ou:e};mh.exports=su;var cu=n(yh),lu={},hu={get exports(){return lu},set exports(t){lu=t}},uu=Dr,pu=ai.indexOf,fu=Lh,du=L([].indexOf),vu=!!du&&1/du([1],1,-0)<0;uu({target:"Array",proto:!0,forced:vu||!fu("indexOf")},{indexOf:function(t){var e=arguments.length>1?arguments[1]:void 0;return vu?du(this,t,e)||0:pu(this,t,e)}});var yu=ru("Array").indexOf,mu=pt,gu=yu,xu=Array.prototype,bu=function(t){var e=t.indexOf;return t===xu||mu(xu,t)&&e===xu.indexOf?gu:e};hu.exports=bu;var wu=n(lu),_u={},Su={get exports(){return _u},set exports(t){_u=t}},Tu=ra.filter;Dr({target:"Array",proto:!0,forced:!Rn("filter")},{filter:function(t){return Tu(this,t,arguments.length>1?arguments[1]:void 0)}});var Cu=ru("Array").filter,Au=pt,Eu=Cu,Lu=Array.prototype,Ou=function(t){var e=t.filter;return t===Lu||Au(Lu,t)&&e===Lu.filter?Eu:e};Su.exports=Ou;var Pu=n(_u),Mu={},Du={get exports(){return Mu},set exports(t){Mu=t}},Ru="\t\n\v\f\r                　\u2028\u2029\ufeff",ku=Q,Iu=$n,zu=Ru,ju=w("".replace),Fu=RegExp("^["+zu+"]+"),Bu=RegExp("(^|[^"+zu+"])["+zu+"]+$"),Nu=function(t){return function(e){var r=Iu(ku(e));return 1&t&&(r=ju(r,Fu,"")),2&t&&(r=ju(r,Bu,"$1")),r}},Wu={start:Nu(1),end:Nu(2),trim:Nu(3)},Yu=l,Gu=h,Xu=$n,Vu=Wu.trim,Uu=Ru,Zu=w("".charAt),Hu=Yu.parseFloat,qu=Yu.Symbol,$u=qu&&qu.iterator,Ju=1/Hu(Uu+"-0")!=-1/0||$u&&!Gu((function(){Hu(Object($u))}))?function(t){var e=Vu(Xu(t)),r=Hu(e);return 0===r&&"-"==Zu(e,0)?-0:r}:Hu;Dr({global:!0,forced:parseFloat!=Ju},{parseFloat:Ju});var Ku=at.parseFloat;Du.exports=Ku;var Qu=n(Mu),tp={},ep={get exports(){return tp},set exports(t){tp=t}},rp=Qt,np=ei,ip=Yr;Dr({target:"Array",proto:!0},{fill:function(t){for(var e=rp(this),r=ip(e),n=arguments.length,i=np(n>1?arguments[1]:void 0,r),o=n>2?arguments[2]:void 0,a=void 0===o?r:np(o,r);a>i;)e[i++]=t;return e}});var op=ru("Array").fill,ap=pt,sp=op,cp=Array.prototype,lp=function(t){var e=t.fill;return t===cp||ap(cp,t)&&e===cp.fill?sp:e};ep.exports=lp;var hp=n(tp),up={},pp={get exports(){return up},set exports(t){up=t}},fp=ru("Array").values,dp=nn,vp=re,yp=pt,mp=fp,gp=Array.prototype,xp={DOMTokenList:!0,NodeList:!0},bp=function(t){var e=t.values;return t===gp||yp(gp,t)&&e===gp.values||vp(xp,dp(t))?mp:e};pp.exports=bp;var wp=n(up),_p={},Sp={get exports(){return _p},set exports(t){_p=t}},Tp=ra.forEach,Cp=Lh("forEach")?[].forEach:function(t){return Tp(this,t,arguments.length>1?arguments[1]:void 0)};Dr({target:"Array",proto:!0,forced:[].forEach!=Cp},{forEach:Cp});var Ap=ru("Array").forEach,Ep=nn,Lp=re,Op=pt,Pp=Ap,Mp=Array.prototype,Dp={DOMTokenList:!0,NodeList:!0},Rp=function(t){var e=t.forEach;return t===Mp||Op(Mp,t)&&e===Mp.forEach||Lp(Dp,Ep(t))?Pp:e};Sp.exports=Rp;var kp=n(_p),Ip={},zp={get exports(){return Ip},set exports(t){Ip=t}};Dr({target:"Array",stat:!0},{isArray:kr});var jp=at.Array.isArray;zp.exports=jp;var Fp=n(Ip),Bp={},Np={get exports(){return Bp},set exports(t){Bp=t}};Dr({target:"Number",stat:!0},{isNaN:function(t){return t!=t}});var Wp=at.Number.isNaN;Np.exports=Wp;var Yp=n(Bp),Gp={},Xp={get exports(){return Gp},set exports(t){Gp=t}},Vp=ru("Array").concat,Up=pt,Zp=Vp,Hp=Array.prototype,qp=function(t){var e=t.concat;return t===Hp||Up(Hp,t)&&e===Hp.concat?Zp:e};Xp.exports=qp;var $p=n(Gp),Jp={},Kp={get exports(){return Jp},set exports(t){Jp=t}},Qp="function"==typeof Bun&&Bun&&"string"==typeof Bun.version,tf=TypeError,ef=l,rf=y,nf=D,of=Qp,af=ft,sf=As,cf=function(t,e){if(t<e)throw tf("Not enough arguments");return t},lf=ef.Function,hf=/MSIE .\./.test(af)||of&&function(){var t=ef.Bun.version.split(".");return t.length<3||0==t[0]&&(t[1]<3||3==t[1]&&0==t[2])}(),uf=function(t,e){var r=e?2:1;return hf?function(n,i){var o=cf(arguments.length,1)>r,a=nf(n)?n:lf(n),s=o?sf(arguments,r):[],c=o?function(){rf(a,this,s)}:a;return e?t(c,i):t(c)}:t},pf=Dr,ff=l,df=uf(ff.setInterval,!0);pf({global:!0,bind:!0,forced:ff.setInterval!==df},{setInterval:df});var vf=Dr,yf=l,mf=uf(yf.setTimeout,!0);vf({global:!0,bind:!0,forced:yf.setTimeout!==mf},{setTimeout:mf});var gf=at.setTimeout;Kp.exports=gf;var xf=n(Jp),bf={},wf={get exports(){return bf},set exports(t){bf=t}},_f=k,Sf=w,Tf=j,Cf=h,Af=mi,Ef=io,Lf=F,Of=Qt,Pf=q,Mf=Object.assign,Df=Object.defineProperty,Rf=Sf([].concat),kf=!Mf||Cf((function(){if(_f&&1!==Mf({b:1},Mf(Df({},"a",{enumerable:!0,get:function(){Df(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},r=Symbol(),n="abcdefghijklmnopqrst";return t[r]=7,n.split("").forEach((function(t){e[t]=t})),7!=Mf({},t)[r]||Af(Mf({},e)).join("")!=n}))?function(t,e){for(var r=Of(t),n=arguments.length,i=1,o=Ef.f,a=Lf.f;n>i;)for(var s,c=Pf(arguments[i++]),l=o?Rf(Af(c),o(c)):Af(c),h=l.length,u=0;h>u;)s=l[u++],_f&&!Tf(a,c,s)||(r[s]=c[s]);return r}:Mf,If=kf;Dr({target:"Object",stat:!0,arity:2,forced:Object.assign!==If},{assign:If});var zf=at.Object.assign;wf.exports=zf;var jf=n(bf),Ff={},Bf={get exports(){return Ff},set exports(t){Ff=t}};!function(t){function e(t){if(t)return function(t){for(var r in e.prototype)t[r]=e.prototype[r];return t}(t)}Bf.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function r(){this.off(t,r),e.apply(this,arguments)}return r.fn=e,this.on(t,r),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var r,n=this._callbacks["$"+t];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var i=0;i<n.length;i++)if((r=n[i])===e||r.fn===e){n.splice(i,1);break}return 0===n.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),r=this._callbacks["$"+t],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(r){n=0;for(var i=(r=r.slice(0)).length;n<i;++n)r[n].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}();var Nf=Ff,Wf={},Yf={get exports(){return Wf},set exports(t){Wf=t}},Gf=j,Xf=ar,Vf=Ft,Uf=ar,Zf=function(t,e,r){var n,i;Xf(t);try{if(!(n=Vf(t,"return"))){if("throw"===e)throw r;return r}n=Gf(n,t)}catch(t){i=!0,n=t}if("throw"===e)throw r;if(i)throw n;return Xf(n),r},Hf=pc,qf=ye("iterator"),$f=Array.prototype,Jf=nn,Kf=Ft,Qf=$,td=pc,ed=ye("iterator"),rd=function(t){if(!Qf(t))return Kf(t,ed)||Kf(t,"@@iterator")||td[Jf(t)]},nd=j,id=It,od=ar,ad=Mt,sd=rd,cd=TypeError,ld=tr,hd=j,ud=Qt,pd=function(t,e,r,n){try{return n?e(Uf(r)[0],r[1]):e(r)}catch(e){Zf(t,"throw",e)}},fd=function(t){return void 0!==t&&(Hf.Array===t||$f[qf]===t)},dd=_n,vd=Yr,yd=Hr,md=function(t,e){var r=arguments.length<2?sd(t):e;if(id(r))return od(nd(r,t));throw cd(ad(t)+" is not iterable")},gd=rd,xd=Array,bd=ye("iterator"),wd=!1;try{var _d=0,Sd={next:function(){return{done:!!_d++}},return:function(){wd=!0}};Sd[bd]=function(){return this},Array.from(Sd,(function(){throw 2}))}catch(t){}var Td=function(t){var e=ud(t),r=dd(this),n=arguments.length,i=n>1?arguments[1]:void 0,o=void 0!==i;o&&(i=ld(i,n>2?arguments[2]:void 0));var a,s,c,l,h,u,p=gd(e),f=0;if(!p||this===xd&&fd(p))for(a=vd(e),s=r?new this(a):xd(a);a>f;f++)u=o?i(e[f],f):e[f],yd(s,f,u);else for(h=(l=md(e,p)).next,s=r?new this:[];!(c=hd(h,l)).done;f++)u=o?pd(l,i,[c.value,f],!0):c.value,yd(s,f,u);return s.length=f,s},Cd=function(t,e){if(!e&&!wd)return!1;var r=!1;try{var n={};n[bd]=function(){return{next:function(){return{done:r=!0}}}},t(n)}catch(t){}return r};Dr({target:"Array",stat:!0,forced:!Cd((function(t){Array.from(t)}))},{from:Td});var Ad=at.Array.from;Yf.exports=Ad;var Ed=n(Wf),Ld={},Od={get exports(){return Ld},set exports(t){Ld=t}},Pd={},Md=rd;({get exports(){return Pd},set exports(t){Pd=t}}).exports=Md,Od.exports=Pd;var Dd=n(Ld),Rd={},kd={get exports(){return Rd},set exports(t){Rd=t}},Id=at.Object.getOwnPropertySymbols;kd.exports=Id;var zd={},jd={get exports(){return zd},set exports(t){zd=t}},Fd={},Bd={get exports(){return Fd},set exports(t){Fd=t}},Nd=Dr,Wd=h,Yd=rt,Gd=R.f,Xd=k;Nd({target:"Object",stat:!0,forced:!Xd||Wd((function(){Gd(1)})),sham:!Xd},{getOwnPropertyDescriptor:function(t,e){return Gd(Yd(t),e)}});var Vd=at.Object,Ud=Bd.exports=function(t,e){return Vd.getOwnPropertyDescriptor(t,e)};Vd.getOwnPropertyDescriptor.sham&&(Ud.sham=!0);var Zd=Fd;jd.exports=Zd;var Hd={},qd={get exports(){return Hd},set exports(t){Hd=t}},$d=ut,Jd=Gi,Kd=io,Qd=ar,tv=w([].concat),ev=$d("Reflect","ownKeys")||function(t){var e=Jd.f(Qd(t)),r=Kd.f;return r?tv(e,r(t)):e},rv=ev,nv=rt,iv=R,ov=Hr;Dr({target:"Object",stat:!0,sham:!k},{getOwnPropertyDescriptors:function(t){for(var e,r,n=nv(t),i=iv.f,o=rv(n),a={},s=0;o.length>s;)void 0!==(r=i(n,e=o[s++]))&&ov(a,e,r);return a}});var av=at.Object.getOwnPropertyDescriptors;qd.exports=av;var sv={},cv={get exports(){return sv},set exports(t){sv=t}},lv={},hv={get exports(){return lv},set exports(t){lv=t}},uv=Dr,pv=k,fv=Jn.f;uv({target:"Object",stat:!0,forced:Object.defineProperties!==fv,sham:!pv},{defineProperties:fv});var dv=at.Object,vv=hv.exports=function(t,e){return dv.defineProperties(t,e)};dv.defineProperties.sham&&(vv.sham=!0);var yv=lv;cv.exports=yv;var mv={},gv={get exports(){return mv},set exports(t){mv=t}},xv={},bv={get exports(){return xv},set exports(t){xv=t}},wv=Dr,_v=k,Sv=er.f;wv({target:"Object",stat:!0,forced:Object.defineProperty!==Sv,sham:!_v},{defineProperty:Sv});var Tv=at.Object,Cv=bv.exports=function(t,e,r){return Tv.defineProperty(t,e,r)};Tv.defineProperty.sham&&(Cv.sham=!0);var Av=xv;gv.exports=Av;var Ev={},Lv={get exports(){return Ev},set exports(t){Ev=t}},Ov={},Pv=Av;({get exports(){return Ov},set exports(t){Ov=t}}).exports=Pv,Lv.exports=Ov;var Mv=n(Ev),Dv={},Rv={get exports(){return Dv},set exports(t){Dv=t}},kv={},Iv={get exports(){return kv},set exports(t){kv=t}},zv=co.f("toPrimitive");Iv.exports=zv,Rv.exports=kv;var jv=n(Dv);function Fv(t){var e=function(t,e){if("object"!==vh(t)||null===t)return t;var r=t[jv];if(void 0!==r){var n=r.call(t,e||"default");if("object"!==vh(n))return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===e?String:Number)(t)}(t,"string");return"symbol"===vh(e)?e:String(e)}function Bv(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Mv(t,Fv(n.key),n)}}var Nv={},Wv={get exports(){return Nv},set exports(t){Nv=t}},Yv={},Gv=jp;({get exports(){return Yv},set exports(t){Yv=t}}).exports=Gv,Wv.exports=Yv;var Xv=n(Nv),Vv={},Uv={get exports(){return Vv},set exports(t){Vv=t}},Zv={},Hv={get exports(){return Zv},set exports(t){Zv=t}},qv=Dr,$v=kr,Jv=_n,Kv=ot,Qv=ei,ty=Yr,ey=rt,ry=Hr,ny=ye,iy=As,oy=Rn("slice"),ay=ny("species"),sy=Array,cy=Math.max;qv({target:"Array",proto:!0,forced:!oy},{slice:function(t,e){var r,n,i,o=ey(this),a=ty(o),s=Qv(t,a),c=Qv(void 0===e?a:e,a);if($v(o)&&(r=o.constructor,(Jv(r)&&(r===sy||$v(r.prototype))||Kv(r)&&null===(r=r[ay]))&&(r=void 0),r===sy||void 0===r))return iy(o,s,c);for(n=new(void 0===r?sy:r)(cy(c-s,0)),i=0;s<c;s++,i++)s in o&&ry(n,i,o[s]);return n.length=i,n}});var ly=ru("Array").slice,hy=pt,uy=ly,py=Array.prototype,fy=function(t){var e=t.slice;return t===py||hy(py,t)&&e===py.slice?uy:e},dy=fy;Hv.exports=dy,Uv.exports=Zv;var vy=n(Vv),yy={},my={get exports(){return yy},set exports(t){yy=t}},gy={},xy=Ad;({get exports(){return gy},set exports(t){gy=t}}).exports=xy,my.exports=gy;var by=n(yy);function wy(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function _y(t){return function(t){if(Xv(t))return wy(t)}(t)||function(t){if(void 0!==Ul&&null!=Dd(t)||null!=t["@@iterator"])return by(t)}(t)||function(t,e){var r;if(t){if("string"==typeof t)return wy(t,e);var n=vy(r=Object.prototype.toString.call(t)).call(r,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?by(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?wy(t,e):void 0}}(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Sy={};({get exports(){return Sy},set exports(t){Sy=t}}).exports=Sl;var Ty=n(Sy),Cy={};({get exports(){return Cy},set exports(t){Cy=t}}).exports=fy;var Ay=n(Cy),Ey={},Ly={get exports(){return Ey},set exports(t){Ey=t}};Dr({target:"Reflect",stat:!0},{ownKeys:ev});var Oy=at.Reflect.ownKeys;Ly.exports=Oy;var Py={},My={get exports(){return Py},set exports(t){Py=t}},Dy=ra.map;Dr({target:"Array",proto:!0,forced:!Rn("map")},{map:function(t){return Dy(this,t,arguments.length>1?arguments[1]:void 0)}});var Ry=ru("Array").map,ky=pt,Iy=Ry,zy=Array.prototype,jy=function(t){var e=t.map;return t===zy||ky(zy,t)&&e===zy.map?Iy:e};My.exports=jy;var Fy=n(Py),By={},Ny={get exports(){return By},set exports(t){By=t}},Wy=Qt,Yy=mi;Dr({target:"Object",stat:!0,forced:h((function(){Yy(1)}))},{keys:function(t){return Yy(Wy(t))}});var Gy=at.Object.keys;Ny.exports=Gy;var Xy=n(By),Vy={},Uy={get exports(){return Vy},set exports(t){Vy=t}},Zy=Dr,Hy=Date,qy=w(Hy.prototype.getTime);Zy({target:"Date",stat:!0},{now:function(){return qy(new Hy)}});var $y=at.Date.now;Uy.exports=$y;var Jy={},Ky={get exports(){return Jy},set exports(t){Jy=t}},Qy=w,tm=It,em=ot,rm=re,nm=As,im=u,om=Function,am=Qy([].concat),sm=Qy([].join),cm={},lm=function(t,e,r){if(!rm(cm,e)){for(var n=[],i=0;i<e;i++)n[i]="a["+i+"]";cm[e]=om("C,a","return new C("+sm(n,",")+")")}return cm[e](t,r)},hm=im?om.bind:function(t){var e=tm(this),r=e.prototype,n=nm(arguments,1),i=function(){var r=am(n,nm(arguments));return this instanceof i?lm(e,r.length,r):e.apply(t,r)};return em(r)&&(i.prototype=r),i};Dr({target:"Function",proto:!0,forced:Function.bind!==hm},{bind:hm});var um=ru("Function").bind,pm=pt,fm=um,dm=Function.prototype,vm=function(t){var e=t.bind;return t===dm||pm(dm,t)&&e===dm.bind?fm:e};Ky.exports=vm;var ym=n(Jy),mm={},gm={get exports(){return mm},set exports(t){mm=t}},xm=Dr,bm=kr,wm=w([].reverse),_m=[1,2];xm({target:"Array",proto:!0,forced:String(_m)===String(_m.reverse())},{reverse:function(){return bm(this)&&(this.length=this.length),wm(this)}});var Sm=ru("Array").reverse,Tm=pt,Cm=Sm,Am=Array.prototype,Em=function(t){var e=t.reverse;return t===Am||Tm(Am,t)&&e===Am.reverse?Cm:e};gm.exports=Em;var Lm=n(mm),Om={},Pm={get exports(){return Om},set exports(t){Om=t}},Mm=k,Dm=kr,Rm=TypeError,km=Object.getOwnPropertyDescriptor,Im=Mm&&!function(){if(void 0!==this)return!0;try{Object.defineProperty([],"length",{writable:!1}).length=1}catch(t){return t instanceof TypeError}}(),zm=Dr,jm=Qt,Fm=ei,Bm=Fr,Nm=Yr,Wm=Im?function(t,e){if(Dm(t)&&!km(t,"length").writable)throw Rm("Cannot set read only .length");return t.length=e}:function(t,e){return t.length=e},Ym=Xr,Gm=On,Xm=Hr,Vm=bh,Um=Rn("splice"),Zm=Math.max,Hm=Math.min;zm({target:"Array",proto:!0,forced:!Um},{splice:function(t,e){var r,n,i,o,a,s,c=jm(this),l=Nm(c),h=Fm(t,l),u=arguments.length;for(0===u?r=n=0:1===u?(r=0,n=l-h):(r=u-2,n=Hm(Zm(Bm(e),0),l-h)),Ym(l+r-n),i=Gm(c,n),o=0;o<n;o++)(a=h+o)in c&&Xm(i,o,c[a]);if(i.length=n,r<n){for(o=h;o<l-n;o++)s=o+r,(a=o+n)in c?c[s]=c[a]:Vm(c,s);for(o=l;o>l-n+r;o--)Vm(c,o-1)}else if(r>n)for(o=l-n;o>h;o--)s=o+r-1,(a=o+n-1)in c?c[s]=c[a]:Vm(c,s);for(o=0;o<r;o++)c[o+h]=arguments[o+2];return Wm(c,l-n+r),i}});var qm=ru("Array").splice,$m=pt,Jm=qm,Km=Array.prototype,Qm=function(t){var e=t.splice;return t===Km||$m(Km,t)&&e===Km.splice?Jm:e};Pm.exports=Qm;var tg=n(Om),eg={},rg={get exports(){return eg},set exports(t){eg=t}},ng=ai.includes;Dr({target:"Array",proto:!0,forced:h((function(){return!Array(1).includes()}))},{includes:function(t){return ng(this,t,arguments.length>1?arguments[1]:void 0)}});var ig=ru("Array").includes,og=ot,ag=C,sg=ye("match"),cg=function(t){var e;return og(t)&&(void 0!==(e=t[sg])?!!e:"RegExp"==ag(t))},lg=TypeError,hg=ye("match"),ug=Dr,pg=function(t){if(cg(t))throw lg("The method doesn't accept regular expressions");return t},fg=Q,dg=$n,vg=function(t){var e=/./;try{"/./"[t](e)}catch(r){try{return e[hg]=!1,"/./"[t](e)}catch(t){}}return!1},yg=w("".indexOf);ug({target:"String",proto:!0,forced:!vg("includes")},{includes:function(t){return!!~yg(dg(fg(this)),dg(pg(t)),arguments.length>1?arguments[1]:void 0)}});var mg=ru("String").includes,gg=pt,xg=ig,bg=mg,wg=Array.prototype,_g=String.prototype,Sg=function(t){var e=t.includes;return t===wg||gg(wg,t)&&e===wg.includes?xg:"string"==typeof t||t===_g||gg(_g,t)&&e===_g.includes?bg:e};rg.exports=Sg;var Tg=n(eg),Cg={},Ag={get exports(){return Cg},set exports(t){Cg=t}},Eg=Qt,Lg=Ec,Og=xc;Dr({target:"Object",stat:!0,forced:h((function(){Lg(1)})),sham:!Og},{getPrototypeOf:function(t){return Lg(Eg(t))}});var Pg=at.Object.getPrototypeOf;Ag.exports=Pg;var Mg=n(Cg),Dg={},Rg={get exports(){return Dg},set exports(t){Dg=t}},kg=k,Ig=w,zg=mi,jg=rt,Fg=Ig(F.f),Bg=Ig([].push),Ng=function(t){return function(e){for(var r,n=jg(e),i=zg(n),o=i.length,a=0,s=[];o>a;)r=i[a++],kg&&!Fg(n,r)||Bg(s,t?[r,n[r]]:n[r]);return s}},Wg={entries:Ng(!0),values:Ng(!1)}.values;Dr({target:"Object",stat:!0},{values:function(t){return Wg(t)}});var Yg=at.Object.values;Rg.exports=Yg;var Gg={},Xg={get exports(){return Gg},set exports(t){Gg=t}},Vg=l,Ug=h,Zg=w,Hg=$n,qg=Wu.trim,$g=Ru,Jg=Vg.parseInt,Kg=Vg.Symbol,Qg=Kg&&Kg.iterator,tx=/^[+-]?0x/i,ex=Zg(tx.exec),rx=8!==Jg($g+"08")||22!==Jg($g+"0x16")||Qg&&!Ug((function(){Jg(Object(Qg))}))?function(t,e){var r=qg(Hg(t));return Jg(r,e>>>0||(ex(tx,r)?16:10))}:Jg;Dr({global:!0,forced:parseInt!=rx},{parseInt:rx});var nx=at.parseInt;Xg.exports=nx;var ix=n(Gg),ox={},ax={get exports(){return ox},set exports(t){ox=t}},sx=gc.PROPER,cx=h,lx=Ru,hx=Wu.trim;Dr({target:"String",proto:!0,forced:function(t){return cx((function(){return!!lx[t]()||"​᠎"!=="​᠎"[t]()||sx&&lx[t].name!==t}))}("trim")},{trim:function(){return hx(this)}});var ux=ru("String").trim,px=pt,fx=ux,dx=String.prototype,vx=function(t){var e=t.trim;return"string"==typeof t||t===dx||px(dx,t)&&e===dx.trim?fx:e};ax.exports=vx;var yx={},mx={get exports(){return yx},set exports(t){yx=t}};Dr({target:"Object",stat:!0,sham:!k},{create:Yi});var gx=at.Object,xx=function(t,e){return gx.create(t,e)};mx.exports=xx;var bx={},wx={get exports(){return bx},set exports(t){bx=t}},_x=at,Sx=y;_x.JSON||(_x.JSON={stringify:JSON.stringify});var Tx=function(t,e,r){return Sx(_x.JSON.stringify,null,arguments)};wx.exports=Tx;var Cx=n(bx);
/*! Hammer.JS - v2.0.17-rc - 2019-12-16
 * http://naver.github.io/egjs
 *
 * Forked By Naver egjs
 * Copyright (c) hammerjs
 * Licensed under the MIT license */function Ax(){return Ax=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var r=arguments[e];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(t[n]=r[n])}return t},Ax.apply(this,arguments)}function Ex(t,e){t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t.__proto__=e}function Lx(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var Ox,Px="function"!=typeof Object.assign?function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),r=1;r<arguments.length;r++){var n=arguments[r];if(null!=n)for(var i in n)n.hasOwnProperty(i)&&(e[i]=n[i])}return e}:Object.assign,Mx=["","webkit","Moz","MS","ms","o"],Dx="undefined"==typeof document?{style:{}}:document.createElement("div"),Rx="function",kx=Math.round,Ix=Math.abs,zx=Date.now;function jx(t,e){for(var r,n,i=e[0].toUpperCase()+e.slice(1),o=0;o<Mx.length;){if((n=(r=Mx[o])?r+i:e)in t)return n;o++}}Ox="undefined"==typeof window?{}:window;var Fx=jx(Dx.style,"touchAction"),Bx=void 0!==Fx;var Nx="compute",Wx="auto",Yx="manipulation",Gx="none",Xx="pan-x",Vx="pan-y",Ux=function(){if(!Bx)return!1;var t={},e=Ox.CSS&&Ox.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(r){return t[r]=!e||Ox.CSS.supports("touch-action",r)})),t}(),Zx="ontouchstart"in Ox,Hx=void 0!==jx(Ox,"PointerEvent"),qx=Zx&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),$x="touch",Jx="mouse",Kx=25,Qx=1,tb=2,eb=4,rb=8,nb=1,ib=2,ob=4,ab=8,sb=16,cb=ib|ob,lb=ab|sb,hb=cb|lb,ub=["x","y"],pb=["clientX","clientY"];function fb(t,e,r){var n;if(t)if(t.forEach)t.forEach(e,r);else if(void 0!==t.length)for(n=0;n<t.length;)e.call(r,t[n],n,t),n++;else for(n in t)t.hasOwnProperty(n)&&e.call(r,t[n],n,t)}function db(t,e){return typeof t===Rx?t.apply(e&&e[0]||void 0,e):t}function vb(t,e){return t.indexOf(e)>-1}var yb=function(){function t(t,e){this.manager=t,this.set(e)}var e=t.prototype;return e.set=function(t){t===Nx&&(t=this.compute()),Bx&&this.manager.element.style&&Ux[t]&&(this.manager.element.style[Fx]=t),this.actions=t.toLowerCase().trim()},e.update=function(){this.set(this.manager.options.touchAction)},e.compute=function(){var t=[];return fb(this.manager.recognizers,(function(e){db(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(vb(t,Gx))return Gx;var e=vb(t,Xx),r=vb(t,Vx);return e&&r?Gx:e||r?e?Xx:Vx:vb(t,Yx)?Yx:Wx}(t.join(" "))},e.preventDefaults=function(t){var e=t.srcEvent,r=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var n=this.actions,i=vb(n,Gx)&&!Ux[Gx],o=vb(n,Vx)&&!Ux[Vx],a=vb(n,Xx)&&!Ux[Xx];if(i){var s=1===t.pointers.length,c=t.distance<2,l=t.deltaTime<250;if(s&&c&&l)return}if(!a||!o)return i||o&&r&cb||a&&r&lb?this.preventSrc(e):void 0}},e.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},t}();function mb(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1}function gb(t){var e=t.length;if(1===e)return{x:kx(t[0].clientX),y:kx(t[0].clientY)};for(var r=0,n=0,i=0;i<e;)r+=t[i].clientX,n+=t[i].clientY,i++;return{x:kx(r/e),y:kx(n/e)}}function xb(t){for(var e=[],r=0;r<t.pointers.length;)e[r]={clientX:kx(t.pointers[r].clientX),clientY:kx(t.pointers[r].clientY)},r++;return{timeStamp:zx(),pointers:e,center:gb(e),deltaX:t.deltaX,deltaY:t.deltaY}}function bb(t,e,r){r||(r=ub);var n=e[r[0]]-t[r[0]],i=e[r[1]]-t[r[1]];return Math.sqrt(n*n+i*i)}function wb(t,e,r){r||(r=ub);var n=e[r[0]]-t[r[0]],i=e[r[1]]-t[r[1]];return 180*Math.atan2(i,n)/Math.PI}function _b(t,e){return t===e?nb:Ix(t)>=Ix(e)?t<0?ib:ob:e<0?ab:sb}function Sb(t,e,r){return{x:e/t||0,y:r/t||0}}function Tb(t,e){var r=t.session,n=e.pointers,i=n.length;r.firstInput||(r.firstInput=xb(e)),i>1&&!r.firstMultiple?r.firstMultiple=xb(e):1===i&&(r.firstMultiple=!1);var o=r.firstInput,a=r.firstMultiple,s=a?a.center:o.center,c=e.center=gb(n);e.timeStamp=zx(),e.deltaTime=e.timeStamp-o.timeStamp,e.angle=wb(s,c),e.distance=bb(s,c),function(t,e){var r=e.center,n=t.offsetDelta||{},i=t.prevDelta||{},o=t.prevInput||{};e.eventType!==Qx&&o.eventType!==eb||(i=t.prevDelta={x:o.deltaX||0,y:o.deltaY||0},n=t.offsetDelta={x:r.x,y:r.y}),e.deltaX=i.x+(r.x-n.x),e.deltaY=i.y+(r.y-n.y)}(r,e),e.offsetDirection=_b(e.deltaX,e.deltaY);var l,h,u=Sb(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=u.x,e.overallVelocityY=u.y,e.overallVelocity=Ix(u.x)>Ix(u.y)?u.x:u.y,e.scale=a?(l=a.pointers,bb((h=n)[0],h[1],pb)/bb(l[0],l[1],pb)):1,e.rotation=a?function(t,e){return wb(e[1],e[0],pb)+wb(t[1],t[0],pb)}(a.pointers,n):0,e.maxPointers=r.prevInput?e.pointers.length>r.prevInput.maxPointers?e.pointers.length:r.prevInput.maxPointers:e.pointers.length,function(t,e){var r,n,i,o,a=t.lastInterval||e,s=e.timeStamp-a.timeStamp;if(e.eventType!==rb&&(s>Kx||void 0===a.velocity)){var c=e.deltaX-a.deltaX,l=e.deltaY-a.deltaY,h=Sb(s,c,l);n=h.x,i=h.y,r=Ix(h.x)>Ix(h.y)?h.x:h.y,o=_b(c,l),t.lastInterval=e}else r=a.velocity,n=a.velocityX,i=a.velocityY,o=a.direction;e.velocity=r,e.velocityX=n,e.velocityY=i,e.direction=o}(r,e);var p,f=t.element,d=e.srcEvent;mb(p=d.composedPath?d.composedPath()[0]:d.path?d.path[0]:d.target,f)&&(f=p),e.target=f}function Cb(t,e,r){var n=r.pointers.length,i=r.changedPointers.length,o=e&Qx&&n-i==0,a=e&(eb|rb)&&n-i==0;r.isFirst=!!o,r.isFinal=!!a,o&&(t.session={}),r.eventType=e,Tb(t,r),t.emit("hammer.input",r),t.recognize(r),t.session.prevInput=r}function Ab(t){return t.trim().split(/\s+/g)}function Eb(t,e,r){fb(Ab(e),(function(e){t.addEventListener(e,r,!1)}))}function Lb(t,e,r){fb(Ab(e),(function(e){t.removeEventListener(e,r,!1)}))}function Ob(t){var e=t.ownerDocument||t;return e.defaultView||e.parentWindow||window}var Pb=function(){function t(t,e){var r=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){db(t.options.enable,[t])&&r.handler(e)},this.init()}var e=t.prototype;return e.handler=function(){},e.init=function(){this.evEl&&Eb(this.element,this.evEl,this.domHandler),this.evTarget&&Eb(this.target,this.evTarget,this.domHandler),this.evWin&&Eb(Ob(this.element),this.evWin,this.domHandler)},e.destroy=function(){this.evEl&&Lb(this.element,this.evEl,this.domHandler),this.evTarget&&Lb(this.target,this.evTarget,this.domHandler),this.evWin&&Lb(Ob(this.element),this.evWin,this.domHandler)},t}();function Mb(t,e,r){if(t.indexOf&&!r)return t.indexOf(e);for(var n=0;n<t.length;){if(r&&t[n][r]==e||!r&&t[n]===e)return n;n++}return-1}var Db={pointerdown:Qx,pointermove:tb,pointerup:eb,pointercancel:rb,pointerout:rb},Rb={2:$x,3:"pen",4:Jx,5:"kinect"},kb="pointerdown",Ib="pointermove pointerup pointercancel";Ox.MSPointerEvent&&!Ox.PointerEvent&&(kb="MSPointerDown",Ib="MSPointerMove MSPointerUp MSPointerCancel");var zb=function(t){function e(){var r,n=e.prototype;return n.evEl=kb,n.evWin=Ib,(r=t.apply(this,arguments)||this).store=r.manager.session.pointerEvents=[],r}return Ex(e,t),e.prototype.handler=function(t){var e=this.store,r=!1,n=t.type.toLowerCase().replace("ms",""),i=Db[n],o=Rb[t.pointerType]||t.pointerType,a=o===$x,s=Mb(e,t.pointerId,"pointerId");i&Qx&&(0===t.button||a)?s<0&&(e.push(t),s=e.length-1):i&(eb|rb)&&(r=!0),s<0||(e[s]=t,this.callback(this.manager,i,{pointers:e,changedPointers:[t],pointerType:o,srcEvent:t}),r&&e.splice(s,1))},e}(Pb);function jb(t){return Array.prototype.slice.call(t,0)}function Fb(t,e,r){for(var n=[],i=[],o=0;o<t.length;){var a=e?t[o][e]:t[o];Mb(i,a)<0&&n.push(t[o]),i[o]=a,o++}return r&&(n=e?n.sort((function(t,r){return t[e]>r[e]})):n.sort()),n}var Bb={touchstart:Qx,touchmove:tb,touchend:eb,touchcancel:rb},Nb="touchstart touchmove touchend touchcancel",Wb=function(t){function e(){var r;return e.prototype.evTarget=Nb,(r=t.apply(this,arguments)||this).targetIds={},r}return Ex(e,t),e.prototype.handler=function(t){var e=Bb[t.type],r=Yb.call(this,t,e);r&&this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:$x,srcEvent:t})},e}(Pb);function Yb(t,e){var r,n,i=jb(t.touches),o=this.targetIds;if(e&(Qx|tb)&&1===i.length)return o[i[0].identifier]=!0,[i,i];var a=jb(t.changedTouches),s=[],c=this.target;if(n=i.filter((function(t){return mb(t.target,c)})),e===Qx)for(r=0;r<n.length;)o[n[r].identifier]=!0,r++;for(r=0;r<a.length;)o[a[r].identifier]&&s.push(a[r]),e&(eb|rb)&&delete o[a[r].identifier],r++;return s.length?[Fb(n.concat(s),"identifier",!0),s]:void 0}var Gb={mousedown:Qx,mousemove:tb,mouseup:eb},Xb="mousedown",Vb="mousemove mouseup",Ub=function(t){function e(){var r,n=e.prototype;return n.evEl=Xb,n.evWin=Vb,(r=t.apply(this,arguments)||this).pressed=!1,r}return Ex(e,t),e.prototype.handler=function(t){var e=Gb[t.type];e&Qx&&0===t.button&&(this.pressed=!0),e&tb&&1!==t.which&&(e=eb),this.pressed&&(e&eb&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:Jx,srcEvent:t}))},e}(Pb),Zb=2500,Hb=25;function qb(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var r={x:e.clientX,y:e.clientY},n=this.lastTouches;this.lastTouches.push(r);setTimeout((function(){var t=n.indexOf(r);t>-1&&n.splice(t,1)}),Zb)}}function $b(t,e){t&Qx?(this.primaryTouch=e.changedPointers[0].identifier,qb.call(this,e)):t&(eb|rb)&&qb.call(this,e)}function Jb(t){for(var e=t.srcEvent.clientX,r=t.srcEvent.clientY,n=0;n<this.lastTouches.length;n++){var i=this.lastTouches[n],o=Math.abs(e-i.x),a=Math.abs(r-i.y);if(o<=Hb&&a<=Hb)return!0}return!1}var Kb=function(){return function(t){function e(e,r){var n;return(n=t.call(this,e,r)||this).handler=function(t,e,r){var i=r.pointerType===$x,o=r.pointerType===Jx;if(!(o&&r.sourceCapabilities&&r.sourceCapabilities.firesTouchEvents)){if(i)$b.call(Lx(Lx(n)),e,r);else if(o&&Jb.call(Lx(Lx(n)),r))return;n.callback(t,e,r)}},n.touch=new Wb(n.manager,n.handler),n.mouse=new Ub(n.manager,n.handler),n.primaryTouch=null,n.lastTouches=[],n}return Ex(e,t),e.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(Pb)}();function Qb(t,e,r){return!!Array.isArray(t)&&(fb(t,r[e],r),!0)}var tw=1,ew=2,rw=4,nw=8,iw=nw,ow=16,aw=32,sw=1;function cw(t,e){var r=e.manager;return r?r.get(t):t}function lw(t){return t&ow?"cancel":t&nw?"end":t&rw?"move":t&ew?"start":""}var hw=function(){function t(t){void 0===t&&(t={}),this.options=Ax({enable:!0},t),this.id=sw++,this.manager=null,this.state=tw,this.simultaneous={},this.requireFail=[]}var e=t.prototype;return e.set=function(t){return Px(this.options,t),this.manager&&this.manager.touchAction.update(),this},e.recognizeWith=function(t){if(Qb(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=cw(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},e.dropRecognizeWith=function(t){return Qb(t,"dropRecognizeWith",this)||(t=cw(t,this),delete this.simultaneous[t.id]),this},e.requireFailure=function(t){if(Qb(t,"requireFailure",this))return this;var e=this.requireFail;return-1===Mb(e,t=cw(t,this))&&(e.push(t),t.requireFailure(this)),this},e.dropRequireFailure=function(t){if(Qb(t,"dropRequireFailure",this))return this;t=cw(t,this);var e=Mb(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},e.hasRequireFailures=function(){return this.requireFail.length>0},e.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},e.emit=function(t){var e=this,r=this.state;function n(r){e.manager.emit(r,t)}r<nw&&n(e.options.event+lw(r)),n(e.options.event),t.additionalEvent&&n(t.additionalEvent),r>=nw&&n(e.options.event+lw(r))},e.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=aw},e.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(this.requireFail[t].state&(aw|tw)))return!1;t++}return!0},e.recognize=function(t){var e=Px({},t);if(!db(this.options.enable,[this,e]))return this.reset(),void(this.state=aw);this.state&(iw|ow|aw)&&(this.state=tw),this.state=this.process(e),this.state&(ew|rw|nw|ow)&&this.tryEmit(e)},e.process=function(t){},e.getTouchAction=function(){},e.reset=function(){},t}(),uw=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,Ax({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},e))||this).pTime=!1,r.pCenter=!1,r._timer=null,r._input=null,r.count=0,r}Ex(e,t);var r=e.prototype;return r.getTouchAction=function(){return[Yx]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,i=t.distance<r.threshold,o=t.deltaTime<r.time;if(this.reset(),t.eventType&Qx&&0===this.count)return this.failTimeout();if(i&&o&&n){if(t.eventType!==eb)return this.failTimeout();var a=!this.pTime||t.timeStamp-this.pTime<r.interval,s=!this.pCenter||bb(this.pCenter,t.center)<r.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,s&&a?this.count+=1:this.count=1,this._input=t,0===this.count%r.taps)return this.hasRequireFailures()?(this._timer=setTimeout((function(){e.state=iw,e.tryEmit()}),r.interval),ew):iw}return aw},r.failTimeout=function(){var t=this;return this._timer=setTimeout((function(){t.state=aw}),this.options.interval),aw},r.reset=function(){clearTimeout(this._timer)},r.emit=function(){this.state===iw&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},e}(hw),pw=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Ax({pointers:1},e))||this}Ex(e,t);var r=e.prototype;return r.attrTest=function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},r.process=function(t){var e=this.state,r=t.eventType,n=e&(ew|rw),i=this.attrTest(t);return n&&(r&rb||!i)?e|ow:n||i?r&eb?e|nw:e&ew?e|rw:ew:aw},e}(hw);function fw(t){return t===sb?"down":t===ab?"up":t===ib?"left":t===ob?"right":""}var dw=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,Ax({event:"pan",threshold:10,pointers:1,direction:hb},e))||this).pX=null,r.pY=null,r}Ex(e,t);var r=e.prototype;return r.getTouchAction=function(){var t=this.options.direction,e=[];return t&cb&&e.push(Vx),t&lb&&e.push(Xx),e},r.directionTest=function(t){var e=this.options,r=!0,n=t.distance,i=t.direction,o=t.deltaX,a=t.deltaY;return i&e.direction||(e.direction&cb?(i=0===o?nb:o<0?ib:ob,r=o!==this.pX,n=Math.abs(t.deltaX)):(i=0===a?nb:a<0?ab:sb,r=a!==this.pY,n=Math.abs(t.deltaY))),t.direction=i,r&&n>e.threshold&&i&e.direction},r.attrTest=function(t){return pw.prototype.attrTest.call(this,t)&&(this.state&ew||!(this.state&ew)&&this.directionTest(t))},r.emit=function(e){this.pX=e.deltaX,this.pY=e.deltaY;var r=fw(e.direction);r&&(e.additionalEvent=this.options.event+r),t.prototype.emit.call(this,e)},e}(pw),vw=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Ax({event:"swipe",threshold:10,velocity:.3,direction:cb|lb,pointers:1},e))||this}Ex(e,t);var r=e.prototype;return r.getTouchAction=function(){return dw.prototype.getTouchAction.call(this)},r.attrTest=function(e){var r,n=this.options.direction;return n&(cb|lb)?r=e.overallVelocity:n&cb?r=e.overallVelocityX:n&lb&&(r=e.overallVelocityY),t.prototype.attrTest.call(this,e)&&n&e.offsetDirection&&e.distance>this.options.threshold&&e.maxPointers===this.options.pointers&&Ix(r)>this.options.velocity&&e.eventType&eb},r.emit=function(t){var e=fw(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)},e}(pw),yw=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Ax({event:"pinch",threshold:0,pointers:2},e))||this}Ex(e,t);var r=e.prototype;return r.getTouchAction=function(){return[Gx]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.scale-1)>this.options.threshold||this.state&ew)},r.emit=function(e){if(1!==e.scale){var r=e.scale<1?"in":"out";e.additionalEvent=this.options.event+r}t.prototype.emit.call(this,e)},e}(pw),mw=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Ax({event:"rotate",threshold:0,pointers:2},e))||this}Ex(e,t);var r=e.prototype;return r.getTouchAction=function(){return[Gx]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.rotation)>this.options.threshold||this.state&ew)},e}(pw),gw=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,Ax({event:"press",pointers:1,time:251,threshold:9},e))||this)._timer=null,r._input=null,r}Ex(e,t);var r=e.prototype;return r.getTouchAction=function(){return[Wx]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,i=t.distance<r.threshold,o=t.deltaTime>r.time;if(this._input=t,!i||!n||t.eventType&(eb|rb)&&!o)this.reset();else if(t.eventType&Qx)this.reset(),this._timer=setTimeout((function(){e.state=iw,e.tryEmit()}),r.time);else if(t.eventType&eb)return iw;return aw},r.reset=function(){clearTimeout(this._timer)},r.emit=function(t){this.state===iw&&(t&&t.eventType&eb?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=zx(),this.manager.emit(this.options.event,this._input)))},e}(hw),xw={domEvents:!1,touchAction:Nx,enable:!0,inputTarget:null,inputClass:null,cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}},bw=[[mw,{enable:!1}],[yw,{enable:!1},["rotate"]],[vw,{direction:cb}],[dw,{direction:cb},["swipe"]],[uw],[uw,{event:"doubletap",taps:2},["tap"]],[gw]];function ww(t,e){var r,n=t.element;n.style&&(fb(t.options.cssProps,(function(i,o){r=jx(n.style,o),e?(t.oldCssProps[r]=n.style[r],n.style[r]=i):n.style[r]=t.oldCssProps[r]||""})),e||(t.oldCssProps={}))}var _w=function(){function t(t,e){var r,n=this;this.options=Px({},xw,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((r=this).options.inputClass||(Hx?zb:qx?Wb:Zx?Kb:Ub))(r,Cb),this.touchAction=new yb(this,this.options.touchAction),ww(this,!0),fb(this.options.recognizers,(function(t){var e=n.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}var e=t.prototype;return e.set=function(t){return Px(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},e.stop=function(t){this.session.stopped=t?2:1},e.recognize=function(t){var e=this.session;if(!e.stopped){var r;this.touchAction.preventDefaults(t);var n=this.recognizers,i=e.curRecognizer;(!i||i&&i.state&iw)&&(e.curRecognizer=null,i=null);for(var o=0;o<n.length;)r=n[o],2===e.stopped||i&&r!==i&&!r.canRecognizeWith(i)?r.reset():r.recognize(t),!i&&r.state&(ew|rw|nw)&&(e.curRecognizer=r,i=r),o++}},e.get=function(t){if(t instanceof hw)return t;for(var e=this.recognizers,r=0;r<e.length;r++)if(e[r].options.event===t)return e[r];return null},e.add=function(t){if(Qb(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},e.remove=function(t){if(Qb(t,"remove",this))return this;var e=this.get(t);if(t){var r=this.recognizers,n=Mb(r,e);-1!==n&&(r.splice(n,1),this.touchAction.update())}return this},e.on=function(t,e){if(void 0===t||void 0===e)return this;var r=this.handlers;return fb(Ab(t),(function(t){r[t]=r[t]||[],r[t].push(e)})),this},e.off=function(t,e){if(void 0===t)return this;var r=this.handlers;return fb(Ab(t),(function(t){e?r[t]&&r[t].splice(Mb(r[t],e),1):delete r[t]})),this},e.emit=function(t,e){this.options.domEvents&&function(t,e){var r=document.createEvent("Event");r.initEvent(t,!0,!0),r.gesture=e,e.target.dispatchEvent(r)}(t,e);var r=this.handlers[t]&&this.handlers[t].slice();if(r&&r.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var n=0;n<r.length;)r[n](e),n++}},e.destroy=function(){this.element&&ww(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},t}(),Sw={touchstart:Qx,touchmove:tb,touchend:eb,touchcancel:rb},Tw="touchstart",Cw="touchstart touchmove touchend touchcancel",Aw=function(t){function e(){var r,n=e.prototype;return n.evTarget=Tw,n.evWin=Cw,(r=t.apply(this,arguments)||this).started=!1,r}return Ex(e,t),e.prototype.handler=function(t){var e=Sw[t.type];if(e===Qx&&(this.started=!0),this.started){var r=Ew.call(this,t,e);e&(eb|rb)&&r[0].length-r[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:$x,srcEvent:t})}},e}(Pb);function Ew(t,e){var r=jb(t.touches),n=jb(t.changedTouches);return e&(eb|rb)&&(r=Fb(r.concat(n),"identifier",!0)),[r,n]}function Lw(t,e,r){var n="DEPRECATED METHOD: "+e+"\n"+r+" AT \n";return function(){var e=new Error("get-stack-trace"),r=e&&e.stack?e.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",i=window.console&&(window.console.warn||window.console.log);return i&&i.call(window.console,n,r),t.apply(this,arguments)}}var Ow=Lw((function(t,e,r){for(var n=Object.keys(e),i=0;i<n.length;)(!r||r&&void 0===t[n[i]])&&(t[n[i]]=e[n[i]]),i++;return t}),"extend","Use `assign`."),Pw=Lw((function(t,e){return Ow(t,e,!0)}),"merge","Use `assign`.");function Mw(t,e,r){var n,i=e.prototype;(n=t.prototype=Object.create(i)).constructor=t,n._super=i,r&&Px(n,r)}function Dw(t,e){return function(){return t.apply(e,arguments)}}var Rw=function(){var t=function(t,e){return void 0===e&&(e={}),new _w(t,Ax({recognizers:bw.concat()},e))};return t.VERSION="2.0.17-rc",t.DIRECTION_ALL=hb,t.DIRECTION_DOWN=sb,t.DIRECTION_LEFT=ib,t.DIRECTION_RIGHT=ob,t.DIRECTION_UP=ab,t.DIRECTION_HORIZONTAL=cb,t.DIRECTION_VERTICAL=lb,t.DIRECTION_NONE=nb,t.DIRECTION_DOWN=sb,t.INPUT_START=Qx,t.INPUT_MOVE=tb,t.INPUT_END=eb,t.INPUT_CANCEL=rb,t.STATE_POSSIBLE=tw,t.STATE_BEGAN=ew,t.STATE_CHANGED=rw,t.STATE_ENDED=nw,t.STATE_RECOGNIZED=iw,t.STATE_CANCELLED=ow,t.STATE_FAILED=aw,t.Manager=_w,t.Input=Pb,t.TouchAction=yb,t.TouchInput=Wb,t.MouseInput=Ub,t.PointerEventInput=zb,t.TouchMouseInput=Kb,t.SingleTouchInput=Aw,t.Recognizer=hw,t.AttrRecognizer=pw,t.Tap=uw,t.Pan=dw,t.Swipe=vw,t.Pinch=yw,t.Rotate=mw,t.Press=gw,t.on=Eb,t.off=Lb,t.each=fb,t.merge=Pw,t.extend=Ow,t.bindFn=Dw,t.assign=Px,t.inherit=Mw,t.bindFn=Dw,t.prefixed=jx,t.toArray=jb,t.inArray=Mb,t.uniqueArray=Fb,t.splitStr=Ab,t.boolOrFn=db,t.hasParent=mb,t.addEventListeners=Eb,t.removeEventListeners=Lb,t.defaults=Px({},xw,{preset:bw}),t}();function kw(t,e){var r=void 0!==Ty&&Dd(t)||t["@@iterator"];if(!r){if(Fp(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Iw(t,e);var n=Ay(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Ed(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Iw(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,s=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){s=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw o}}}}function Iw(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}Ty("DELETE");var zw="undefined"!=typeof window?window.Hammer||Rw:function(){return function(){var t=function(){};return{on:t,off:t,destroy:t,emit:t,get:function(){return{set:t}}}}()};function jw(t){var e,r=this;this._cleanupQueue=[],this.active=!1,this._dom={container:t,overlay:document.createElement("div")},this._dom.overlay.classList.add("vis-overlay"),this._dom.container.appendChild(this._dom.overlay),this._cleanupQueue.push((function(){r._dom.overlay.parentNode.removeChild(r._dom.overlay)}));var n=zw(this._dom.overlay);n.on("tap",ym(e=this._onTapOverlay).call(e,this)),this._cleanupQueue.push((function(){n.destroy()}));var i=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];kp(i).call(i,(function(t){n.on(t,(function(t){t.srcEvent.stopPropagation()}))})),document&&document.body&&(this._onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||r.deactivate()},document.body.addEventListener("click",this._onClick),this._cleanupQueue.push((function(){document.body.removeEventListener("click",r._onClick)}))),this._escListener=function(t){("key"in t?"Escape"===t.key:27===t.keyCode)&&r.deactivate()}}Nf(jw.prototype),jw.current=null,jw.prototype.destroy=function(){var t,e;this.deactivate();var r,n=kw(Lm(t=tg(e=this._cleanupQueue).call(e,0)).call(t));try{for(n.s();!(r=n.n()).done;){(0,r.value)()}}catch(t){n.e(t)}finally{n.f()}},jw.prototype.activate=function(){jw.current&&jw.current.deactivate(),jw.current=this,this.active=!0,this._dom.overlay.style.display="none",this._dom.container.classList.add("vis-active"),this.emit("change"),this.emit("activate"),document.body.addEventListener("keydown",this._escListener)},jw.prototype.deactivate=function(){this.active=!1,this._dom.overlay.style.display="block",this._dom.container.classList.remove("vis-active"),document.body.removeEventListener("keydown",this._escListener),this.emit("change"),this.emit("deactivate")},jw.prototype._onTapOverlay=function(t){this.activate(),t.srcEvent.stopPropagation()};var Fw=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,Bw=/^#?([a-f\d])([a-f\d])([a-f\d])$/i;function Nw(t,e,r,n){var i=!1;!0===n&&(i=null===e[r]&&void 0!==t[r]),i?delete t[r]:t[r]=e[r]}function Ww(t,e){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var i in e)if(Object.prototype.hasOwnProperty.call(e,i)||!0===r)if("object"===vh(e[i])&&null!==e[i]&&Mg(e[i])===Object.prototype)void 0===t[i]?t[i]=Ww({},e[i],r):"object"===vh(t[i])&&null!==t[i]&&Mg(t[i])===Object.prototype?Ww(t[i],e[i],r):Nw(t,e,i,n);else if(Fp(e[i])){var o;t[i]=Ay(o=e[i]).call(o)}else Nw(t,e,i,n);return t}function Yw(t,e){var r;return $p(r=[]).call(r,_y(t),[e])}function Gw(t,e,r,n){var i;t.addEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&Tg(i=navigator.userAgent).call(i,"Firefox")&&(e="DOMMouseScroll"),t.addEventListener(e,r,n)):t.attachEvent("on"+e,r)}function Xw(t,e,r,n){var i;t.removeEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&Tg(i=navigator.userAgent).call(i,"Firefox")&&(e="DOMMouseScroll"),t.removeEventListener(e,r,n)):t.detachEvent("on"+e,r)}function Vw(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)}function Uw(t,e,r){var n,i,o,a=Math.floor(6*t),s=6*t-a,c=r*(1-e),l=r*(1-s*e),h=r*(1-(1-s)*e);switch(a%6){case 0:n=r,i=h,o=c;break;case 1:n=l,i=r,o=c;break;case 2:n=c,i=r,o=h;break;case 3:n=c,i=l,o=r;break;case 4:n=h,i=c,o=r;break;case 5:n=r,i=c,o=l}return{r:Math.floor(255*n),g:Math.floor(255*i),b:Math.floor(255*o)}}var Zw,Hw=!1,qw="background: #FFeeee; color: #dd0000",$w=function(){function t(){!function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,t)}var e,r,n;return e=t,n=[{key:"validate",value:function(e,r,n){Hw=!1,Zw=r;var i=r;return void 0!==n&&(i=r[n]),t.parse(e,i,[]),Hw}},{key:"parse",value:function(e,r,n){for(var i in e)Object.prototype.hasOwnProperty.call(e,i)&&t.check(i,e,r,n)}},{key:"check",value:function(e,r,n,i){if(void 0!==n[e]||void 0!==n.__any__){var o=e,a=!0;void 0===n[e]&&void 0!==n.__any__&&(o="__any__",a="object"===t.getType(r[e]));var s=n[o];a&&void 0!==s.__type__&&(s=s.__type__),t.checkFields(e,r,n,o,s,i)}else t.getSuggestion(e,n,i)}},{key:"checkFields",value:function(e,r,n,i,o,a){var s=function(r){console.error("%c"+r+t.printLocation(a,e),qw)},c=t.getType(r[e]),l=o[c];void 0!==l?"array"===t.getType(l)&&-1===wu(l).call(l,r[e])?(s('Invalid option detected in "'+e+'". Allowed values are:'+t.print(l)+' not "'+r[e]+'". '),Hw=!0):"object"===c&&"__any__"!==i&&(a=Yw(a,e),t.parse(r[e],n[i],a)):void 0===o.any&&(s('Invalid type received for "'+e+'". Expected: '+t.print(Xy(o))+". Received ["+c+'] "'+r[e]+'"'),Hw=!0)}},{key:"getType",value:function(t){var e=vh(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":Fp(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,r,n){var i,o=t.findInOptions(e,r,n,!1),a=t.findInOptions(e,Zw,[],!0);i=void 0!==o.indexMatch?" in "+t.printLocation(o.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+o.indexMatch+'"?\n\n':a.distance<=4&&o.distance>a.distance?" in "+t.printLocation(o.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(a.path,a.closestMatch,""):o.distance<=8?'. Did you mean "'+o.closestMatch+'"?'+t.printLocation(o.path,e):". Did you mean one of these: "+t.print(Xy(r))+t.printLocation(n,e),console.error('%cUnknown option detected: "'+e+'"'+i,qw),Hw=!0}},{key:"findInOptions",value:function(e,r,n){var i,o=arguments.length>3&&void 0!==arguments[3]&&arguments[3],a=1e9,s="",c=[],l=e.toLowerCase(),h=void 0;for(var u in r){var p=void 0;if(void 0!==r[u].__type__&&!0===o){var f=t.findInOptions(e,r[u],Yw(n,u));a>f.distance&&(s=f.closestMatch,c=f.path,a=f.distance,h=f.indexMatch)}else{var d;-1!==wu(d=u.toLowerCase()).call(d,l)&&(h=u),a>(p=t.levenshteinDistance(e,u))&&(s=u,c=Ay(i=n).call(i),a=p)}}return{closestMatch:s,path:c,distance:a,indexMatch:h}}},{key:"printLocation",value:function(t,e){for(var r="\n\n"+(arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n")+"options = {\n",n=0;n<t.length;n++){for(var i=0;i<n+1;i++)r+="  ";r+=t[n]+": {\n"}for(var o=0;o<t.length+1;o++)r+="  ";r+=e+"\n";for(var a=0;a<t.length+1;a++){for(var s=0;s<t.length-a;s++)r+="  ";r+="}\n"}return r+"\n\n"}},{key:"print",value:function(t){return Cx(t).replace(/(")|(\[)|(\])|(,"__type__")/g,"").replace(/(,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var r,n,i=[];for(r=0;r<=e.length;r++)i[r]=[r];for(n=0;n<=t.length;n++)i[0][n]=n;for(r=1;r<=e.length;r++)for(n=1;n<=t.length;n++)e.charAt(r-1)==t.charAt(n-1)?i[r][n]=i[r-1][n-1]:i[r][n]=Math.min(i[r-1][n-1]+1,Math.min(i[r][n-1]+1,i[r-1][n]+1));return i[e.length][t.length]}}],(r=null)&&Bv(e.prototype,r),n&&Bv(e,n),Mv(e,"prototype",{writable:!1}),t}(),Jw=qw,Kw=$w;function Qw(t,e,r){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0,this.z=void 0!==r?r:0}Qw.subtract=function(t,e){var r=new Qw;return r.x=t.x-e.x,r.y=t.y-e.y,r.z=t.z-e.z,r},Qw.add=function(t,e){var r=new Qw;return r.x=t.x+e.x,r.y=t.y+e.y,r.z=t.z+e.z,r},Qw.avg=function(t,e){return new Qw((t.x+e.x)/2,(t.y+e.y)/2,(t.z+e.z)/2)},Qw.scalarProduct=function(t,e){return new Qw(t.x*e,t.y*e,t.z*e)},Qw.dotProduct=function(t,e){return t.x*e.x+t.y*e.y+t.z*e.z},Qw.crossProduct=function(t,e){var r=new Qw;return r.x=t.y*e.z-t.z*e.y,r.y=t.z*e.x-t.x*e.z,r.z=t.x*e.y-t.y*e.x,r},Qw.prototype.length=function(){return Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z)},Qw.prototype.normalize=function(){return Qw.scalarProduct(this,1/this.length())};var t_=Qw;var e_=function(t,e){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0};function r_(t,e){if(void 0===t)throw new Error("No container element defined");if(this.container=t,this.visible=!e||null==e.visible||e.visible,this.visible){this.frame=document.createElement("DIV"),this.frame.style.width="100%",this.frame.style.position="relative",this.container.appendChild(this.frame),this.frame.prev=document.createElement("INPUT"),this.frame.prev.type="BUTTON",this.frame.prev.value="Prev",this.frame.appendChild(this.frame.prev),this.frame.play=document.createElement("INPUT"),this.frame.play.type="BUTTON",this.frame.play.value="Play",this.frame.appendChild(this.frame.play),this.frame.next=document.createElement("INPUT"),this.frame.next.type="BUTTON",this.frame.next.value="Next",this.frame.appendChild(this.frame.next),this.frame.bar=document.createElement("INPUT"),this.frame.bar.type="BUTTON",this.frame.bar.style.position="absolute",this.frame.bar.style.border="1px solid red",this.frame.bar.style.width="100px",this.frame.bar.style.height="6px",this.frame.bar.style.borderRadius="2px",this.frame.bar.style.MozBorderRadius="2px",this.frame.bar.style.border="1px solid #7F7F7F",this.frame.bar.style.backgroundColor="#E5E5E5",this.frame.appendChild(this.frame.bar),this.frame.slide=document.createElement("INPUT"),this.frame.slide.type="BUTTON",this.frame.slide.style.margin="0px",this.frame.slide.value=" ",this.frame.slide.style.position="relative",this.frame.slide.style.left="-100px",this.frame.appendChild(this.frame.slide);var r=this;this.frame.slide.onmousedown=function(t){r._onMouseDown(t)},this.frame.prev.onclick=function(t){r.prev(t)},this.frame.play.onclick=function(t){r.togglePlay(t)},this.frame.next.onclick=function(t){r.next(t)}}this.onChangeCallback=void 0,this.values=[],this.index=void 0,this.playTimeout=void 0,this.playInterval=1e3,this.playLoop=!0}function n_(t,e,r,n){this._start=0,this._end=0,this._step=1,this.prettyStep=!0,this.precision=5,this._current=0,this.setRange(t,e,r,n)}r_.prototype.prev=function(){var t=this.getIndex();t>0&&(t--,this.setIndex(t))},r_.prototype.next=function(){var t=this.getIndex();t<wp(this).length-1&&(t++,this.setIndex(t))},r_.prototype.playNext=function(){var t=new Date,e=this.getIndex();e<wp(this).length-1?(e++,this.setIndex(e)):this.playLoop&&(e=0,this.setIndex(e));var r=new Date-t,n=Math.max(this.playInterval-r,0),i=this;this.playTimeout=xf((function(){i.playNext()}),n)},r_.prototype.togglePlay=function(){void 0===this.playTimeout?this.play():this.stop()},r_.prototype.play=function(){this.playTimeout||(this.playNext(),this.frame&&(this.frame.play.value="Stop"))},r_.prototype.stop=function(){clearInterval(this.playTimeout),this.playTimeout=void 0,this.frame&&(this.frame.play.value="Play")},r_.prototype.setOnChangeCallback=function(t){this.onChangeCallback=t},r_.prototype.setPlayInterval=function(t){this.playInterval=t},r_.prototype.getPlayInterval=function(){return this.playInterval},r_.prototype.setPlayLoop=function(t){this.playLoop=t},r_.prototype.onChange=function(){void 0!==this.onChangeCallback&&this.onChangeCallback()},r_.prototype.redraw=function(){if(this.frame){this.frame.bar.style.top=this.frame.clientHeight/2-this.frame.bar.offsetHeight/2+"px",this.frame.bar.style.width=this.frame.clientWidth-this.frame.prev.clientWidth-this.frame.play.clientWidth-this.frame.next.clientWidth-30+"px";var t=this.indexToLeft(this.index);this.frame.slide.style.left=t+"px"}},r_.prototype.setValues=function(t){this.values=t,wp(this).length>0?this.setIndex(0):this.index=void 0},r_.prototype.setIndex=function(t){if(!(t<wp(this).length))throw new Error("Index out of range");this.index=t,this.redraw(),this.onChange()},r_.prototype.getIndex=function(){return this.index},r_.prototype.get=function(){return wp(this)[this.index]},r_.prototype._onMouseDown=function(t){if(t.which?1===t.which:1===t.button){this.startClientX=t.clientX,this.startSlideX=Qu(this.frame.slide.style.left),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},Gw(document,"mousemove",this.onmousemove),Gw(document,"mouseup",this.onmouseup),Vw(t)}},r_.prototype.leftToIndex=function(t){var e=Qu(this.frame.bar.style.width)-this.frame.slide.clientWidth-10,r=t-3,n=Math.round(r/e*(wp(this).length-1));return n<0&&(n=0),n>wp(this).length-1&&(n=wp(this).length-1),n},r_.prototype.indexToLeft=function(t){var e=Qu(this.frame.bar.style.width)-this.frame.slide.clientWidth-10;return t/(wp(this).length-1)*e+3},r_.prototype._onMouseMove=function(t){var e=t.clientX-this.startClientX,r=this.startSlideX+e,n=this.leftToIndex(r);this.setIndex(n),Vw()},r_.prototype._onMouseUp=function(){this.frame.style.cursor="auto",Xw(document,"mousemove",this.onmousemove),Xw(document,"mouseup",this.onmouseup),Vw()},n_.prototype.isNumeric=function(t){return!isNaN(Qu(t))&&isFinite(t)},n_.prototype.setRange=function(t,e,r,n){if(!this.isNumeric(t))throw new Error("Parameter 'start' is not numeric; value: "+t);if(!this.isNumeric(e))throw new Error("Parameter 'end' is not numeric; value: "+t);if(!this.isNumeric(r))throw new Error("Parameter 'step' is not numeric; value: "+t);this._start=t||0,this._end=e||0,this.setStep(r,n)},n_.prototype.setStep=function(t,e){void 0===t||t<=0||(void 0!==e&&(this.prettyStep=e),!0===this.prettyStep?this._step=n_.calculatePrettyStep(t):this._step=t)},n_.calculatePrettyStep=function(t){var e=function(t){return Math.log(t)/Math.LN10},r=Math.pow(10,Math.round(e(t))),n=2*Math.pow(10,Math.round(e(t/2))),i=5*Math.pow(10,Math.round(e(t/5))),o=r;return Math.abs(n-t)<=Math.abs(o-t)&&(o=n),Math.abs(i-t)<=Math.abs(o-t)&&(o=i),o<=0&&(o=1),o},n_.prototype.getCurrent=function(){return Qu(this._current.toPrecision(this.precision))},n_.prototype.getStep=function(){return this._step},n_.prototype.start=function(t){void 0===t&&(t=!1),this._current=this._start-this._start%this._step,t&&this.getCurrent()<this._start&&this.next()},n_.prototype.next=function(){this._current+=this._step},n_.prototype.end=function(){return this._current>this._end};var i_=n_,o_={},a_={get exports(){return o_},set exports(t){o_=t}};Dr({target:"Math",stat:!0},{sign:Math.sign||function(t){var e=+t;return 0==e||e!=e?e:e<0?-1:1}});var s_=at.Math.sign;a_.exports=s_;var c_=n(o_);function l_(){this.armLocation=new t_,this.armRotation={},this.armRotation.horizontal=0,this.armRotation.vertical=0,this.armLength=1.7,this.cameraOffset=new t_,this.offsetMultiplier=.6,this.cameraLocation=new t_,this.cameraRotation=new t_(.5*Math.PI,0,0),this.calculateCameraOrientation()}l_.prototype.setOffset=function(t,e){var r=Math.abs,n=c_,i=this.offsetMultiplier,o=this.armLength*i;r(t)>o&&(t=n(t)*o),r(e)>o&&(e=n(e)*o),this.cameraOffset.x=t,this.cameraOffset.y=e,this.calculateCameraOrientation()},l_.prototype.getOffset=function(){return this.cameraOffset},l_.prototype.setArmLocation=function(t,e,r){this.armLocation.x=t,this.armLocation.y=e,this.armLocation.z=r,this.calculateCameraOrientation()},l_.prototype.setArmRotation=function(t,e){void 0!==t&&(this.armRotation.horizontal=t),void 0!==e&&(this.armRotation.vertical=e,this.armRotation.vertical<0&&(this.armRotation.vertical=0),this.armRotation.vertical>.5*Math.PI&&(this.armRotation.vertical=.5*Math.PI)),void 0===t&&void 0===e||this.calculateCameraOrientation()},l_.prototype.getArmRotation=function(){var t={};return t.horizontal=this.armRotation.horizontal,t.vertical=this.armRotation.vertical,t},l_.prototype.setArmLength=function(t){void 0!==t&&(this.armLength=t,this.armLength<.71&&(this.armLength=.71),this.armLength>5&&(this.armLength=5),this.setOffset(this.cameraOffset.x,this.cameraOffset.y),this.calculateCameraOrientation())},l_.prototype.getArmLength=function(){return this.armLength},l_.prototype.getCameraLocation=function(){return this.cameraLocation},l_.prototype.getCameraRotation=function(){return this.cameraRotation},l_.prototype.calculateCameraOrientation=function(){this.cameraLocation.x=this.armLocation.x-this.armLength*Math.sin(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.y=this.armLocation.y-this.armLength*Math.cos(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.z=this.armLocation.z+this.armLength*Math.sin(this.armRotation.vertical),this.cameraRotation.x=Math.PI/2-this.armRotation.vertical,this.cameraRotation.y=0,this.cameraRotation.z=-this.armRotation.horizontal;var t=this.cameraRotation.x,e=this.cameraRotation.z,r=this.cameraOffset.x,n=this.cameraOffset.y,i=Math.sin,o=Math.cos;this.cameraLocation.x=this.cameraLocation.x+r*o(e)+n*-i(e)*o(t),this.cameraLocation.y=this.cameraLocation.y+r*i(e)+n*o(e)*o(t),this.cameraLocation.z=this.cameraLocation.z+n*i(t)};var h_={BAR:0,BARCOLOR:1,BARSIZE:2,DOT:3,DOTLINE:4,DOTCOLOR:5,DOTSIZE:6,GRID:7,LINE:8,SURFACE:9},u_={dot:h_.DOT,"dot-line":h_.DOTLINE,"dot-color":h_.DOTCOLOR,"dot-size":h_.DOTSIZE,line:h_.LINE,grid:h_.GRID,surface:h_.SURFACE,bar:h_.BAR,"bar-color":h_.BARCOLOR,"bar-size":h_.BARSIZE},p_=["width","height","filterLabel","legendLabel","xLabel","yLabel","zLabel","xValueLabel","yValueLabel","zValueLabel","showXAxis","showYAxis","showZAxis","showGrayBottom","showGrid","showPerspective","showShadow","showSurfaceGrid","keepAspectRatio","rotateAxisLabels","verticalRatio","dotSizeRatio","dotSizeMinFraction","dotSizeMaxFraction","showAnimationControls","animationInterval","animationPreload","animationAutoStart","axisColor","axisFontSize","axisFontType","gridColor","xCenter","yCenter","zoomable","tooltipDelay","ctrlToZoom"],f_=["xBarWidth","yBarWidth","valueMin","valueMax","xMin","xMax","xStep","yMin","yMax","yStep","zMin","zMax","zStep"],d_=void 0;function v_(t){for(var e in t)if(Object.prototype.hasOwnProperty.call(t,e))return!1;return!0}function y_(t,e){return void 0===t||""===t?e:t+(void 0===(r=e)||""===r||"string"!=typeof r?r:r.charAt(0).toUpperCase()+Ay(r).call(r,1));var r}function m_(t,e,r,n){for(var i,o=0;o<r.length;++o)e[y_(n,i=r[o])]=t[i]}function g_(t,e,r,n){for(var i,o=0;o<r.length;++o)void 0!==t[i=r[o]]&&(e[y_(n,i)]=t[i])}function x_(t,e){if(void 0!==t.backgroundColor&&function(t,e){var r="white",n="gray",i=1;if("string"==typeof t)r=t,n="none",i=0;else{if("object"!==vh(t))throw new Error("Unsupported type of backgroundColor");void 0!==hp(t)&&(r=hp(t)),void 0!==t.stroke&&(n=t.stroke),void 0!==t.strokeWidth&&(i=t.strokeWidth)}e.frame.style.backgroundColor=r,e.frame.style.borderColor=n,e.frame.style.borderWidth=i+"px",e.frame.style.borderStyle="solid"}(t.backgroundColor,e),function(t,e){if(void 0===t)return;void 0===e.dataColor&&(e.dataColor={});"string"==typeof t?(e.dataColor.fill=t,e.dataColor.stroke=t):(hp(t)&&(e.dataColor.fill=hp(t)),t.stroke&&(e.dataColor.stroke=t.stroke),void 0!==t.strokeWidth&&(e.dataColor.strokeWidth=t.strokeWidth))}(t.dataColor,e),function(t,e){if(void 0===t)return;var r;if("string"==typeof t){if(r=function(t){var e=u_[t];if(void 0===e)return-1;return e}(t),-1===r)throw new Error("Style '"+t+"' is invalid")}else{if(!function(t){var e=!1;for(var r in h_)if(h_[r]===t){e=!0;break}return e}(t))throw new Error("Style '"+t+"' is invalid");r=t}e.style=r}(t.style,e),void 0!==t.surfaceColors){if(console.warn("`options.surfaceColors` is deprecated and may be removed in a future version. Please use `options.colormap` instead. Note that the `colormap` option uses the inverse array ordering (running from vMin to vMax)."),void 0!==t.colormap)throw new Error("The `colormap` and `surfaceColors` options are mutually exclusive.");"surface"!==e.style?console.warn("Ignoring `surfaceColors` in graph style `"+e.style+"` for backward compatibility (only effective in `surface` plots)."):function(t,e){if(void 0===t||!0===t)return;if(!1===t)return void(e.surfaceColors=void 0);void 0===e.surfaceColors&&(e.surfaceColors={});var r;if(Fp(t))r=b_(t);else{if("object"!==vh(t))throw new Error("Unsupported type of surfaceColors");r=w_(t.hue)}Lm(r).call(r),e.colormap=r}(t.surfaceColors,e)}else!function(t,e){if(void 0===t)return;var r;if(Fp(t))r=b_(t);else if("object"===vh(t))r=w_(t.hue);else{if("function"!=typeof t)throw new Error("Unsupported type of colormap");r=t}e.colormap=r}(t.colormap,e);!function(t,e){if(void 0===t){if(void 0===d_.showLegend){var r=e.style===h_.DOTCOLOR||e.style===h_.DOTSIZE;e.showLegend=r}}else e.showLegend=t}(t.showLegend,e),__(t.cameraPosition,e),void 0!==t.tooltip&&(e.showTooltip=t.tooltip),null!=t.onclick&&(e.onclick_callback=t.onclick,console.warn("`options.onclick` is deprecated and may be removed in a future version. Please use `Graph3d.on('click', handler)` instead.")),void 0!==t.tooltipStyle&&function(t,e,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Fp(r))throw new TypeError("Arrays are not supported by deepExtend");for(var i=0;i<t.length;i++){var o=t[i];if(Object.prototype.hasOwnProperty.call(r,o))if(r[o]&&r[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?Ww(e[o],r[o],!1,n):Nw(e,r,o,n);else{if(Fp(r[o]))throw new TypeError("Arrays are not supported by deepExtend");Nw(e,r,o,n)}}}(["tooltipStyle"],e,t)}function b_(t){if(t.length<2)throw new Error("Colormap array length must be 2 or above.");return Fy(t).call(t,(function(t){if(!function(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}(t))throw new Error("Invalid hex color code supplied to colormap.");return function(t){var e;switch(t.length){case 3:case 4:return(e=Bw.exec(t))?{r:ix(e[1]+e[1],16),g:ix(e[2]+e[2],16),b:ix(e[3]+e[3],16)}:null;case 6:case 7:return(e=Fw.exec(t))?{r:ix(e[1],16),g:ix(e[2],16),b:ix(e[3],16)}:null;default:return null}}(t)}))}function w_(t){if(void 0===t)throw new Error("Unsupported type of colormap");if(!(t.saturation>=0&&t.saturation<=100))throw new Error("Saturation is out of bounds. Expected range is 0-100.");if(!(t.brightness>=0&&t.brightness<=100))throw new Error("Brightness is out of bounds. Expected range is 0-100.");if(!(t.colorStops>=2))throw new Error("colorStops is out of bounds. Expected 2 or above.");for(var e=(t.end-t.start)/(t.colorStops-1),r=[],n=0;n<t.colorStops;++n){var i=(t.start+e*n)%360/360;r.push(Uw(i<0?i+1:i,t.saturation/100,t.brightness/100))}return r}function __(t,e){var r=t;void 0!==r&&(void 0===e.camera&&(e.camera=new l_),e.camera.setArmRotation(r.horizontal,r.vertical),e.camera.setArmLength(r.distance))}var S_="string",T_="boolean",C_="number",A_="object",E_="array",L_={fill:{string:S_},stroke:{string:S_},strokeWidth:{number:C_},__type__:{string:S_,object:A_,undefined:"undefined"}},O_={animationAutoStart:{boolean:T_,undefined:"undefined"},animationInterval:{number:C_},animationPreload:{boolean:T_},axisColor:{string:S_},axisFontSize:{number:C_},axisFontType:{string:S_},backgroundColor:L_,xBarWidth:{number:C_,undefined:"undefined"},yBarWidth:{number:C_,undefined:"undefined"},cameraPosition:{distance:{number:C_},horizontal:{number:C_},vertical:{number:C_},__type__:{object:A_}},zoomable:{boolean:T_},ctrlToZoom:{boolean:T_},xCenter:{string:S_},yCenter:{string:S_},colormap:{hue:{start:{number:C_},end:{number:C_},saturation:{number:C_},brightness:{number:C_},colorStops:{number:C_},__type__:{object:A_}},__type__:{array:E_,object:A_,function:"function",undefined:"undefined"}},dataColor:L_,dotSizeMinFraction:{number:C_},dotSizeMaxFraction:{number:C_},dotSizeRatio:{number:C_},filterLabel:{string:S_},gridColor:{string:S_},onclick:{function:"function"},keepAspectRatio:{boolean:T_},xLabel:{string:S_},yLabel:{string:S_},zLabel:{string:S_},legendLabel:{string:S_},xMin:{number:C_,undefined:"undefined"},yMin:{number:C_,undefined:"undefined"},zMin:{number:C_,undefined:"undefined"},xMax:{number:C_,undefined:"undefined"},yMax:{number:C_,undefined:"undefined"},zMax:{number:C_,undefined:"undefined"},showAnimationControls:{boolean:T_,undefined:"undefined"},showGrayBottom:{boolean:T_},showGrid:{boolean:T_},showLegend:{boolean:T_,undefined:"undefined"},showPerspective:{boolean:T_},showShadow:{boolean:T_},showSurfaceGrid:{boolean:T_},showXAxis:{boolean:T_},showYAxis:{boolean:T_},showZAxis:{boolean:T_},rotateAxisLabels:{boolean:T_},surfaceColors:{hue:{start:{number:C_},end:{number:C_},saturation:{number:C_},brightness:{number:C_},colorStops:{number:C_},__type__:{object:A_}},__type__:{boolean:T_,array:E_,object:A_,undefined:"undefined"}},xStep:{number:C_,undefined:"undefined"},yStep:{number:C_,undefined:"undefined"},zStep:{number:C_,undefined:"undefined"},style:{number:C_,string:["bar","bar-color","bar-size","dot","dot-line","dot-color","dot-size","line","grid","surface"]},tooltip:{boolean:T_,function:"function"},tooltipDelay:{number:C_},tooltipStyle:{content:{color:{string:S_},background:{string:S_},border:{string:S_},borderRadius:{string:S_},boxShadow:{string:S_},padding:{string:S_},__type__:{object:A_}},line:{borderLeft:{string:S_},height:{string:S_},width:{string:S_},pointerEvents:{string:S_},__type__:{object:A_}},dot:{border:{string:S_},borderRadius:{string:S_},height:{string:S_},width:{string:S_},pointerEvents:{string:S_},__type__:{object:A_}},__type__:{object:A_}},xValueLabel:{function:"function"},yValueLabel:{function:"function"},zValueLabel:{function:"function"},valueMax:{number:C_,undefined:"undefined"},valueMin:{number:C_,undefined:"undefined"},verticalRatio:{number:C_},height:{string:S_},width:{string:S_},__type__:{object:A_}};function P_(){this.min=void 0,this.max=void 0}P_.prototype.adjust=function(t){void 0!==t&&((void 0===this.min||this.min>t)&&(this.min=t),(void 0===this.max||this.max<t)&&(this.max=t))},P_.prototype.combine=function(t){this.add(t.min),this.add(t.max)},P_.prototype.expand=function(t){if(void 0!==t){var e=this.min-t,r=this.max+t;if(e>r)throw new Error("Passed expansion value makes range invalid");this.min=e,this.max=r}},P_.prototype.range=function(){return this.max-this.min},P_.prototype.center=function(){return(this.min+this.max)/2};var M_=P_;function D_(t,e,r){this.dataGroup=t,this.column=e,this.graph=r,this.index=void 0,this.value=void 0,this.values=t.getDistinctValues(this.column),wp(this).length>0&&this.selectValue(0),this.dataPoints=[],this.loaded=!1,this.onLoadCallback=void 0,r.animationPreload?(this.loaded=!1,this.loadInBackground()):this.loaded=!0}function R_(){this.dataTable=null}D_.prototype.isLoaded=function(){return this.loaded},D_.prototype.getLoadedProgress=function(){for(var t=wp(this).length,e=0;this.dataPoints[e];)e++;return Math.round(e/t*100)},D_.prototype.getLabel=function(){return this.graph.filterLabel},D_.prototype.getColumn=function(){return this.column},D_.prototype.getSelectedValue=function(){if(void 0!==this.index)return wp(this)[this.index]},D_.prototype.getValues=function(){return wp(this)},D_.prototype.getValue=function(t){if(t>=wp(this).length)throw new Error("Index out of range");return wp(this)[t]},D_.prototype._getDataPoints=function(e){if(void 0===e&&(e=this.index),void 0===e)return[];var r;if(this.dataPoints[e])r=this.dataPoints[e];else{var n={};n.column=this.column,n.value=wp(this)[e];var i=new t(this.dataGroup.getDataSet(),{filter:function(t){return t[n.column]==n.value}}).get();r=this.dataGroup._getDataPoints(i),this.dataPoints[e]=r}return r},D_.prototype.setOnLoadCallback=function(t){this.onLoadCallback=t},D_.prototype.selectValue=function(t){if(t>=wp(this).length)throw new Error("Index out of range");this.index=t,this.value=wp(this)[t]},D_.prototype.loadInBackground=function(t){void 0===t&&(t=0);var e=this.graph.frame;if(t<wp(this).length){void 0===e.progress&&(e.progress=document.createElement("DIV"),e.progress.style.position="absolute",e.progress.style.color="gray",e.appendChild(e.progress));var r=this.getLoadedProgress();e.progress.innerHTML="Loading animation... "+r+"%",e.progress.style.bottom="60px",e.progress.style.left="10px";var n=this;xf((function(){n.loadInBackground(t+1)}),10),this.loaded=!1}else this.loaded=!0,void 0!==e.progress&&(e.removeChild(e.progress),e.progress=void 0),this.onLoadCallback&&this.onLoadCallback()},R_.prototype.initializeData=function(r,n,i){if(void 0!==n){var o;if(Fp(n)&&(n=new e(n)),!(n instanceof e||n instanceof t))throw new Error("Array, DataSet, or DataView expected");if(0!=(o=n.get()).length){this.style=i,this.dataSet&&this.dataSet.off("*",this._onChange),this.dataSet=n,this.dataTable=o;var a=this;this._onChange=function(){r.setData(a.dataSet)},this.dataSet.on("*",this._onChange),this.colX="x",this.colY="y",this.colZ="z";var s=r.hasBars(i);if(s&&(void 0!==r.defaultXBarWidth?this.xBarWidth=r.defaultXBarWidth:this.xBarWidth=this.getSmallestDifference(o,this.colX)||1,void 0!==r.defaultYBarWidth?this.yBarWidth=r.defaultYBarWidth:this.yBarWidth=this.getSmallestDifference(o,this.colY)||1),this._initializeRange(o,this.colX,r,s),this._initializeRange(o,this.colY,r,s),this._initializeRange(o,this.colZ,r,!1),Object.prototype.hasOwnProperty.call(o[0],"style")){this.colValue="style";var c=this.getColumnRange(o,this.colValue);this._setRangeDefaults(c,r.defaultValueMin,r.defaultValueMax),this.valueRange=c}else this.colValue="z",this.valueRange=this.zRange;var l=this.getDataTable();return Object.prototype.hasOwnProperty.call(l[0],"filter")&&void 0===this.dataFilter&&(this.dataFilter=new D_(this,"filter",r),this.dataFilter.setOnLoadCallback((function(){r.redraw()}))),this.dataFilter?this.dataFilter._getDataPoints():this._getDataPoints(this.getDataTable())}}},R_.prototype._collectRangeSettings=function(t,e){var r;if(-1==wu(r=["x","y","z"]).call(r,t))throw new Error("Column '"+t+"' invalid");var n=t.toUpperCase();return{barWidth:this[t+"BarWidth"],min:e["default"+n+"Min"],max:e["default"+n+"Max"],step:e["default"+n+"Step"],range_label:t+"Range",step_label:t+"Step"}},R_.prototype._initializeRange=function(t,e,r,n){var i=this._collectRangeSettings(e,r),o=this.getColumnRange(t,e);n&&"z"!=e&&o.expand(i.barWidth/2),this._setRangeDefaults(o,i.min,i.max),this[i.range_label]=o,this[i.step_label]=void 0!==i.step?i.step:o.range()/5},R_.prototype.getDistinctValues=function(t,e){void 0===e&&(e=this.dataTable);for(var r=[],n=0;n<e.length;n++){var i=e[n][t]||0;-1===wu(r).call(r,i)&&r.push(i)}return cu(r).call(r,(function(t,e){return t-e}))},R_.prototype.getSmallestDifference=function(t,e){for(var r=this.getDistinctValues(t,e),n=null,i=1;i<r.length;i++){var o=r[i]-r[i-1];(null==n||n>o)&&(n=o)}return n},R_.prototype.getColumnRange=function(t,e){for(var r=new M_,n=0;n<t.length;n++){var i=t[n][e];r.adjust(i)}return r},R_.prototype.getNumberOfRows=function(){return this.dataTable.length},R_.prototype._setRangeDefaults=function(t,e,r){void 0!==e&&(t.min=e),void 0!==r&&(t.max=r),t.max<=t.min&&(t.max=t.min+1)},R_.prototype.getDataTable=function(){return this.dataTable},R_.prototype.getDataSet=function(){return this.dataSet},R_.prototype.getDataPoints=function(t){for(var e=[],r=0;r<t.length;r++){var n=new t_;n.x=t[r][this.colX]||0,n.y=t[r][this.colY]||0,n.z=t[r][this.colZ]||0,n.data=t[r],n.value=t[r][this.colValue]||0;var i={};i.point=n,i.bottom=new t_(n.x,n.y,this.zRange.min),i.trans=void 0,i.screen=void 0,e.push(i)}return e},R_.prototype.initDataAsMatrix=function(t){var e,r,n,i,o=this.getDistinctValues(this.colX,t),a=this.getDistinctValues(this.colY,t),s=this.getDataPoints(t),c=[];for(n=0;n<s.length;n++){i=s[n];var l=wu(o).call(o,i.point.x),h=wu(a).call(a,i.point.y);void 0===c[l]&&(c[l]=[]),c[l][h]=i}for(e=0;e<c.length;e++)for(r=0;r<c[e].length;r++)c[e][r]&&(c[e][r].pointRight=e<c.length-1?c[e+1][r]:void 0,c[e][r].pointTop=r<c[e].length-1?c[e][r+1]:void 0,c[e][r].pointCross=e<c.length-1&&r<c[e].length-1?c[e+1][r+1]:void 0);return s},R_.prototype.getInfo=function(){var t=this.dataFilter;if(t)return t.getLabel()+": "+t.getSelectedValue()},R_.prototype.reload=function(){this.dataTable&&this.setData(this.dataTable)},R_.prototype._getDataPoints=function(t){var e=[];if(this.style===h_.GRID||this.style===h_.SURFACE)e=this.initDataAsMatrix(t);else if(e=this.getDataPoints(t),this.style===h_.LINE)for(var r=0;r<e.length;r++)r>0&&(e[r-1].pointNext=e[r]);return e},I_.STYLE=h_;var k_=void 0;function I_(t,e,r){if(!(this instanceof I_))throw new SyntaxError("Constructor must be called with the new operator");this.containerElement=t,this.dataGroup=new R_,this.dataPoints=null,this.create(),function(t,e){if(void 0===t||v_(t))throw new Error("No DEFAULTS passed");if(void 0===e)throw new Error("No dst passed");d_=t,m_(t,e,p_),m_(t,e,f_,"default"),x_(t,e),e.margin=10,e.showTooltip=!1,e.onclick_callback=null,e.eye=new t_(0,0,-1)}(I_.DEFAULTS,this),this.colX=void 0,this.colY=void 0,this.colZ=void 0,this.colValue=void 0,this.setOptions(r),this.setData(e)}function z_(t){return"clientX"in t?t.clientX:t.targetTouches[0]&&t.targetTouches[0].clientX||0}function j_(t){return"clientY"in t?t.clientY:t.targetTouches[0]&&t.targetTouches[0].clientY||0}I_.DEFAULTS={width:"400px",height:"400px",filterLabel:"time",legendLabel:"value",xLabel:"x",yLabel:"y",zLabel:"z",xValueLabel:function(t){return t},yValueLabel:function(t){return t},zValueLabel:function(t){return t},showXAxis:!0,showYAxis:!0,showZAxis:!0,showGrayBottom:!1,showGrid:!0,showPerspective:!0,showShadow:!1,showSurfaceGrid:!0,keepAspectRatio:!0,rotateAxisLabels:!0,verticalRatio:.5,dotSizeRatio:.02,dotSizeMinFraction:.5,dotSizeMaxFraction:2.5,showAnimationControls:k_,animationInterval:1e3,animationPreload:!1,animationAutoStart:k_,axisFontSize:14,axisFontType:"arial",axisColor:"#4D4D4D",gridColor:"#D3D3D3",xCenter:"55%",yCenter:"50%",style:I_.STYLE.DOT,tooltip:!1,tooltipDelay:300,tooltipStyle:{content:{padding:"10px",border:"1px solid #4d4d4d",color:"#1a1a1a",background:"rgba(255,255,255,0.7)",borderRadius:"2px",boxShadow:"5px 5px 10px rgba(128,128,128,0.5)"},line:{height:"40px",width:"0",borderLeft:"1px solid #4d4d4d",pointerEvents:"none"},dot:{height:"0",width:"0",border:"5px solid #4d4d4d",borderRadius:"5px",pointerEvents:"none"}},dataColor:{fill:"#7DC1FF",stroke:"#3267D2",strokeWidth:1},surfaceColors:k_,colormap:k_,cameraPosition:{horizontal:1,vertical:.5,distance:1.7},zoomable:!0,ctrlToZoom:!1,showLegend:k_,backgroundColor:k_,xBarWidth:k_,yBarWidth:k_,valueMin:k_,valueMax:k_,xMin:k_,xMax:k_,xStep:k_,yMin:k_,yMax:k_,yStep:k_,zMin:k_,zMax:k_,zStep:k_},Nf(I_.prototype),I_.prototype._setScale=function(){this.scale=new t_(1/this.xRange.range(),1/this.yRange.range(),1/this.zRange.range()),this.keepAspectRatio&&(this.scale.x<this.scale.y?this.scale.y=this.scale.x:this.scale.x=this.scale.y),this.scale.z*=this.verticalRatio,void 0!==this.valueRange&&(this.scale.value=1/this.valueRange.range());var t=this.xRange.center()*this.scale.x,e=this.yRange.center()*this.scale.y,r=this.zRange.center()*this.scale.z;this.camera.setArmLocation(t,e,r)},I_.prototype._convert3Dto2D=function(t){var e=this._convertPointToTranslation(t);return this._convertTranslationToScreen(e)},I_.prototype._convertPointToTranslation=function(t){var e=this.camera.getCameraLocation(),r=this.camera.getCameraRotation(),n=t.x*this.scale.x,i=t.y*this.scale.y,o=t.z*this.scale.z,a=e.x,s=e.y,c=e.z,l=Math.sin(r.x),h=Math.cos(r.x),u=Math.sin(r.y),p=Math.cos(r.y),f=Math.sin(r.z),d=Math.cos(r.z);return new t_(p*(f*(i-s)+d*(n-a))-u*(o-c),l*(p*(o-c)+u*(f*(i-s)+d*(n-a)))+h*(d*(i-s)-f*(n-a)),h*(p*(o-c)+u*(f*(i-s)+d*(n-a)))-l*(d*(i-s)-f*(n-a)))},I_.prototype._convertTranslationToScreen=function(t){var e,r,n=this.eye.x,i=this.eye.y,o=this.eye.z,a=t.x,s=t.y,c=t.z;return this.showPerspective?(e=o/c*(a-n),r=o/c*(s-i)):(e=a*(-o/this.camera.getArmLength()),r=s*(-o/this.camera.getArmLength())),new e_(this.currentXCenter+e*this.frame.canvas.clientWidth,this.currentYCenter-r*this.frame.canvas.clientWidth)},I_.prototype._calcTranslations=function(t){for(var e=0;e<t.length;e++){var r=t[e];r.trans=this._convertPointToTranslation(r.point),r.screen=this._convertTranslationToScreen(r.trans);var n=this._convertPointToTranslation(r.bottom);r.dist=this.showPerspective?n.length():-n.z}cu(t).call(t,(function(t,e){return e.dist-t.dist}))},I_.prototype._initializeRanges=function(){var t=this.dataGroup;this.xRange=t.xRange,this.yRange=t.yRange,this.zRange=t.zRange,this.valueRange=t.valueRange,this.xStep=t.xStep,this.yStep=t.yStep,this.zStep=t.zStep,this.xBarWidth=t.xBarWidth,this.yBarWidth=t.yBarWidth,this.colX=t.colX,this.colY=t.colY,this.colZ=t.colZ,this.colValue=t.colValue,this._setScale()},I_.prototype.getDataPoints=function(t){for(var e=[],r=0;r<t.length;r++){var n=new t_;n.x=t[r][this.colX]||0,n.y=t[r][this.colY]||0,n.z=t[r][this.colZ]||0,n.data=t[r],n.value=t[r][this.colValue]||0;var i={};i.point=n,i.bottom=new t_(n.x,n.y,this.zRange.min),i.trans=void 0,i.screen=void 0,e.push(i)}return e},I_.prototype._getDataPoints=function(t){var e,r,n,i,o=[];if(this.style===I_.STYLE.GRID||this.style===I_.STYLE.SURFACE){var a=this.dataGroup.getDistinctValues(this.colX,t),s=this.dataGroup.getDistinctValues(this.colY,t);o=this.getDataPoints(t);var c=[];for(n=0;n<o.length;n++){i=o[n];var l=wu(a).call(a,i.point.x),h=wu(s).call(s,i.point.y);void 0===c[l]&&(c[l]=[]),c[l][h]=i}for(e=0;e<c.length;e++)for(r=0;r<c[e].length;r++)c[e][r]&&(c[e][r].pointRight=e<c.length-1?c[e+1][r]:void 0,c[e][r].pointTop=r<c[e].length-1?c[e][r+1]:void 0,c[e][r].pointCross=e<c.length-1&&r<c[e].length-1?c[e+1][r+1]:void 0)}else if(o=this.getDataPoints(t),this.style===I_.STYLE.LINE)for(n=0;n<o.length;n++)n>0&&(o[n-1].pointNext=o[n]);return o},I_.prototype.create=function(){for(;this.containerElement.hasChildNodes();)this.containerElement.removeChild(this.containerElement.firstChild);this.frame=document.createElement("div"),this.frame.style.position="relative",this.frame.style.overflow="hidden",this.frame.canvas=document.createElement("canvas"),this.frame.canvas.style.position="relative",this.frame.appendChild(this.frame.canvas);var t=document.createElement("DIV");t.style.color="red",t.style.fontWeight="bold",t.style.padding="10px",t.innerHTML="Error: your browser does not support HTML canvas",this.frame.canvas.appendChild(t),this.frame.filter=document.createElement("div"),Pu(this.frame).style.position="absolute",Pu(this.frame).style.bottom="0px",Pu(this.frame).style.left="0px",Pu(this.frame).style.width="100%",this.frame.appendChild(Pu(this.frame));var e=this;Gw(this.frame.canvas,"mousedown",(function(t){e._onMouseDown(t)})),Gw(this.frame.canvas,"touchstart",(function(t){e._onTouchStart(t)})),Gw(this.frame.canvas,"mousewheel",(function(t){e._onWheel(t)})),Gw(this.frame.canvas,"mousemove",(function(t){e._onTooltip(t)})),Gw(this.frame.canvas,"click",(function(t){e._onClick(t)})),this.containerElement.appendChild(this.frame)},I_.prototype._setSize=function(t,e){this.frame.style.width=t,this.frame.style.height=e,this._resizeCanvas()},I_.prototype._resizeCanvas=function(){this.frame.canvas.style.width="100%",this.frame.canvas.style.height="100%",this.frame.canvas.width=this.frame.canvas.clientWidth,this.frame.canvas.height=this.frame.canvas.clientHeight,Pu(this.frame).style.width=this.frame.canvas.clientWidth-20+"px"},I_.prototype.animationStart=function(){if(this.animationAutoStart&&this.dataGroup.dataFilter){if(!Pu(this.frame)||!Pu(this.frame).slider)throw new Error("No animation available");Pu(this.frame).slider.play()}},I_.prototype.animationStop=function(){Pu(this.frame)&&Pu(this.frame).slider&&Pu(this.frame).slider.stop()},I_.prototype._resizeCenter=function(){"%"===this.xCenter.charAt(this.xCenter.length-1)?this.currentXCenter=Qu(this.xCenter)/100*this.frame.canvas.clientWidth:this.currentXCenter=Qu(this.xCenter),"%"===this.yCenter.charAt(this.yCenter.length-1)?this.currentYCenter=Qu(this.yCenter)/100*(this.frame.canvas.clientHeight-Pu(this.frame).clientHeight):this.currentYCenter=Qu(this.yCenter)},I_.prototype.getCameraPosition=function(){var t=this.camera.getArmRotation();return t.distance=this.camera.getArmLength(),t},I_.prototype._readData=function(t){this.dataPoints=this.dataGroup.initializeData(this,t,this.style),this._initializeRanges(),this._redrawFilter()},I_.prototype.setData=function(t){null!=t&&(this._readData(t),this.redraw(),this.animationStart())},I_.prototype.setOptions=function(t){void 0!==t&&(!0===Kw.validate(t,O_)&&console.error("%cErrors have been found in the supplied options object.",Jw),this.animationStop(),function(t,e){if(void 0!==t){if(void 0===e)throw new Error("No dst passed");if(void 0===d_||v_(d_))throw new Error("DEFAULTS not set for module Settings");g_(t,e,p_),g_(t,e,f_,"default"),x_(t,e)}}(t,this),this.setPointDrawingMethod(),this._setSize(this.width,this.height),this.setAxisLabelMethod(),this.setData(this.dataGroup.getDataTable()),this.animationStart())},I_.prototype.setPointDrawingMethod=function(){var t=void 0;switch(this.style){case I_.STYLE.BAR:t=this._redrawBarGraphPoint;break;case I_.STYLE.BARCOLOR:t=this._redrawBarColorGraphPoint;break;case I_.STYLE.BARSIZE:t=this._redrawBarSizeGraphPoint;break;case I_.STYLE.DOT:t=this._redrawDotGraphPoint;break;case I_.STYLE.DOTLINE:t=this._redrawDotLineGraphPoint;break;case I_.STYLE.DOTCOLOR:t=this._redrawDotColorGraphPoint;break;case I_.STYLE.DOTSIZE:t=this._redrawDotSizeGraphPoint;break;case I_.STYLE.SURFACE:t=this._redrawSurfaceGraphPoint;break;case I_.STYLE.GRID:t=this._redrawGridGraphPoint;break;case I_.STYLE.LINE:t=this._redrawLineGraphPoint;break;default:throw new Error("Can not determine point drawing method for graph style '"+this.style+"'")}this._pointDrawingMethod=t},I_.prototype.setAxisLabelMethod=function(){this.rotateAxisLabels?(this._drawAxisLabelX=this.drawAxisLabelXRotate,this._drawAxisLabelY=this.drawAxisLabelYRotate,this._drawAxisLabelZ=this.drawAxisLabelZRotate):(this._drawAxisLabelX=this.drawAxisLabelX,this._drawAxisLabelY=this.drawAxisLabelY,this._drawAxisLabelZ=this.drawAxisLabelZ)},I_.prototype.redraw=function(){if(void 0===this.dataPoints)throw new Error("Graph data not initialized");this._resizeCanvas(),this._resizeCenter(),this._redrawSlider(),this._redrawClear(),this._redrawAxis(),this._redrawDataGraph(),this._redrawInfo(),this._redrawLegend()},I_.prototype._getContext=function(){var t=this.frame.canvas.getContext("2d");return t.lineJoin="round",t.lineCap="round",t},I_.prototype._redrawClear=function(){var t=this.frame.canvas;t.getContext("2d").clearRect(0,0,t.width,t.height)},I_.prototype._dotSize=function(){return this.frame.clientWidth*this.dotSizeRatio},I_.prototype._getLegendWidth=function(){var t;this.style===I_.STYLE.DOTSIZE?t=this._dotSize()*this.dotSizeMaxFraction:t=this.style===I_.STYLE.BARSIZE?this.xBarWidth:20;return t},I_.prototype._redrawLegend=function(){if(!0===this.showLegend&&this.style!==I_.STYLE.LINE&&this.style!==I_.STYLE.BARSIZE){var t=this.style===I_.STYLE.BARSIZE||this.style===I_.STYLE.DOTSIZE,e=this.style===I_.STYLE.DOTSIZE||this.style===I_.STYLE.DOTCOLOR||this.style===I_.STYLE.SURFACE||this.style===I_.STYLE.BARCOLOR,r=Math.max(.25*this.frame.clientHeight,100),n=this.margin,i=this._getLegendWidth(),o=this.frame.clientWidth-this.margin,a=o-i,s=n+r,c=this._getContext();if(c.lineWidth=1,c.font="14px arial",!1===t){var l,h=r;for(l=0;l<h;l++){var u=1-(l-0)/(h-0),p=this._colormap(u,1);c.strokeStyle=p,c.beginPath(),c.moveTo(a,n+l),c.lineTo(o,n+l),c.stroke()}c.strokeStyle=this.axisColor,c.strokeRect(a,n,i,r)}else{var f;this.style===I_.STYLE.DOTSIZE?f=i*(this.dotSizeMinFraction/this.dotSizeMaxFraction):(this.style,I_.STYLE.BARSIZE),c.strokeStyle=this.axisColor,c.fillStyle=hp(this.dataColor),c.beginPath(),c.moveTo(a,n),c.lineTo(o,n),c.lineTo(a+f,s),c.lineTo(a,s),c.closePath(),hp(c).call(c),c.stroke()}var d=e?this.valueRange.min:this.zRange.min,v=e?this.valueRange.max:this.zRange.max,y=new i_(d,v,(v-d)/5,!0);for(y.start(!0);!y.end();){var m=s-(y.getCurrent()-d)/(v-d)*r,g=new e_(a-5,m),x=new e_(a,m);this._line(c,g,x),c.textAlign="right",c.textBaseline="middle",c.fillStyle=this.axisColor,c.fillText(y.getCurrent(),a-10,m),y.next()}c.textAlign="right",c.textBaseline="top";var b=this.legendLabel;c.fillText(b,o,s+this.margin)}},I_.prototype._redrawFilter=function(){var t=this.dataGroup.dataFilter,e=Pu(this.frame);if(e.innerHTML="",t){var r=new r_(e,{visible:this.showAnimationControls});e.slider=r,e.style.padding="10px",r.setValues(wp(t)),r.setPlayInterval(this.animationInterval);var n=this;r.setOnChangeCallback((function(){var t=n.dataGroup.dataFilter,e=r.getIndex();t.selectValue(e),n.dataPoints=t._getDataPoints(),n.redraw()}))}else e.slider=void 0},I_.prototype._redrawSlider=function(){void 0!==Pu(this.frame).slider&&Pu(this.frame).slider.redraw()},I_.prototype._redrawInfo=function(){var t=this.dataGroup.getInfo();if(void 0!==t){var e=this._getContext();e.font="14px arial",e.lineStyle="gray",e.fillStyle="gray",e.textAlign="left",e.textBaseline="top";var r=this.margin,n=this.margin;e.fillText(t,r,n)}},I_.prototype._line=function(t,e,r,n){void 0!==n&&(t.strokeStyle=n),t.beginPath(),t.moveTo(e.x,e.y),t.lineTo(r.x,r.y),t.stroke()},I_.prototype.drawAxisLabelX=function(t,e,r,n,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*n)>0?(t.textAlign="center",t.textBaseline="top",o.y+=i):Math.sin(2*n)<0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)},I_.prototype.drawAxisLabelY=function(t,e,r,n,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*n)<0?(t.textAlign="center",t.textBaseline="top",o.y+=i):Math.sin(2*n)>0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)},I_.prototype.drawAxisLabelZ=function(t,e,r,n){void 0===n&&(n=0);var i=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,i.x-n,i.y)},I_.prototype.drawAxisLabelXRotate=function(t,e,r,n,i){var o=this._convert3Dto2D(e);Math.cos(2*n)>0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,0,0),t.restore()):Math.sin(2*n)<0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y))},I_.prototype.drawAxisLabelYRotate=function(t,e,r,n,i){var o=this._convert3Dto2D(e);Math.cos(2*n)<0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,0,0),t.restore()):Math.sin(2*n)>0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y))},I_.prototype.drawAxisLabelZRotate=function(t,e,r,n){void 0===n&&(n=0);var i=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,i.x-n,i.y)},I_.prototype._line3d=function(t,e,r,n){var i=this._convert3Dto2D(e),o=this._convert3Dto2D(r);this._line(t,i,o,n)},I_.prototype._redrawAxis=function(){var t,e,r,n,i,o,a,s,c,l,h=this._getContext();h.font=this.axisFontSize/this.camera.getArmLength()+"px "+this.axisFontType;var u,p,f,d=.025/this.scale.x,v=.025/this.scale.y,y=5/this.camera.getArmLength(),m=this.camera.getArmRotation().horizontal,g=new e_(Math.cos(m),Math.sin(m)),x=this.xRange,b=this.yRange,w=this.zRange;for(h.lineWidth=1,n=void 0===this.defaultXStep,(r=new i_(x.min,x.max,this.xStep,n)).start(!0);!r.end();){var _=r.getCurrent();if(this.showGrid?(t=new t_(_,b.min,w.min),e=new t_(_,b.max,w.min),this._line3d(h,t,e,this.gridColor)):this.showXAxis&&(t=new t_(_,b.min,w.min),e=new t_(_,b.min+d,w.min),this._line3d(h,t,e,this.axisColor),t=new t_(_,b.max,w.min),e=new t_(_,b.max-d,w.min),this._line3d(h,t,e,this.axisColor)),this.showXAxis){a=g.x>0?b.min:b.max,u=new t_(_,a,w.min);var S="  "+this.xValueLabel(_)+"  ";this._drawAxisLabelX.call(this,h,u,S,m,y)}r.next()}for(h.lineWidth=1,n=void 0===this.defaultYStep,(r=new i_(b.min,b.max,this.yStep,n)).start(!0);!r.end();){var T=r.getCurrent();if(this.showGrid?(t=new t_(x.min,T,w.min),e=new t_(x.max,T,w.min),this._line3d(h,t,e,this.gridColor)):this.showYAxis&&(t=new t_(x.min,T,w.min),e=new t_(x.min+v,T,w.min),this._line3d(h,t,e,this.axisColor),t=new t_(x.max,T,w.min),e=new t_(x.max-v,T,w.min),this._line3d(h,t,e,this.axisColor)),this.showYAxis){o=g.y>0?x.min:x.max,u=new t_(o,T,w.min);var C="  "+this.yValueLabel(T)+"  ";this._drawAxisLabelY.call(this,h,u,C,m,y)}r.next()}if(this.showZAxis){for(h.lineWidth=1,n=void 0===this.defaultZStep,(r=new i_(w.min,w.max,this.zStep,n)).start(!0),o=g.x>0?x.min:x.max,a=g.y<0?b.min:b.max;!r.end();){var A=r.getCurrent(),E=new t_(o,a,A),L=this._convert3Dto2D(E);e=new e_(L.x-y,L.y),this._line(h,L,e,this.axisColor);var O=this.zValueLabel(A)+" ";this._drawAxisLabelZ.call(this,h,E,O,5),r.next()}h.lineWidth=1,t=new t_(o,a,w.min),e=new t_(o,a,w.max),this._line3d(h,t,e,this.axisColor)}this.showXAxis&&(h.lineWidth=1,p=new t_(x.min,b.min,w.min),f=new t_(x.max,b.min,w.min),this._line3d(h,p,f,this.axisColor),p=new t_(x.min,b.max,w.min),f=new t_(x.max,b.max,w.min),this._line3d(h,p,f,this.axisColor));this.showYAxis&&(h.lineWidth=1,t=new t_(x.min,b.min,w.min),e=new t_(x.min,b.max,w.min),this._line3d(h,t,e,this.axisColor),t=new t_(x.max,b.min,w.min),e=new t_(x.max,b.max,w.min),this._line3d(h,t,e,this.axisColor));var P=this.xLabel;P.length>0&&this.showXAxis&&(l=.1/this.scale.y,o=(x.max+3*x.min)/4,a=g.x>0?b.min-l:b.max+l,i=new t_(o,a,w.min),this.drawAxisLabelX(h,i,P,m));var M=this.yLabel;M.length>0&&this.showYAxis&&(c=.1/this.scale.x,o=g.y>0?x.min-c:x.max+c,a=(b.max+3*b.min)/4,i=new t_(o,a,w.min),this.drawAxisLabelY(h,i,M,m));var D=this.zLabel;D.length>0&&this.showZAxis&&(30,o=g.x>0?x.min:x.max,a=g.y<0?b.min:b.max,s=(w.max+3*w.min)/4,i=new t_(o,a,s),this.drawAxisLabelZ(h,i,D,30))},I_.prototype._getStrokeWidth=function(t){return void 0!==t?this.showPerspective?1/-t.trans.z*this.dataColor.strokeWidth:-this.eye.z/this.camera.getArmLength()*this.dataColor.strokeWidth:this.dataColor.strokeWidth},I_.prototype._redrawBar=function(t,e,r,n,i,o){var a,s=this,c=e.point,l=this.zRange.min,h=[{point:new t_(c.x-r,c.y-n,c.z)},{point:new t_(c.x+r,c.y-n,c.z)},{point:new t_(c.x+r,c.y+n,c.z)},{point:new t_(c.x-r,c.y+n,c.z)}],u=[{point:new t_(c.x-r,c.y-n,l)},{point:new t_(c.x+r,c.y-n,l)},{point:new t_(c.x+r,c.y+n,l)},{point:new t_(c.x-r,c.y+n,l)}];kp(h).call(h,(function(t){t.screen=s._convert3Dto2D(t.point)})),kp(u).call(u,(function(t){t.screen=s._convert3Dto2D(t.point)}));var p=[{corners:h,center:t_.avg(u[0].point,u[2].point)},{corners:[h[0],h[1],u[1],u[0]],center:t_.avg(u[1].point,u[0].point)},{corners:[h[1],h[2],u[2],u[1]],center:t_.avg(u[2].point,u[1].point)},{corners:[h[2],h[3],u[3],u[2]],center:t_.avg(u[3].point,u[2].point)},{corners:[h[3],h[0],u[0],u[3]],center:t_.avg(u[0].point,u[3].point)}];e.surfaces=p;for(var f=0;f<p.length;f++){a=p[f];var d=this._convertPointToTranslation(a.center);a.dist=this.showPerspective?d.length():-d.z}cu(p).call(p,(function(t,e){var r=e.dist-t.dist;return r||(t.corners===h?1:e.corners===h?-1:0)})),t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=o,t.fillStyle=i;for(var v=2;v<p.length;v++)a=p[v],this._polygon(t,a.corners)},I_.prototype._polygon=function(t,e,r,n){if(!(e.length<2)){void 0!==r&&(t.fillStyle=r),void 0!==n&&(t.strokeStyle=n),t.beginPath(),t.moveTo(e[0].screen.x,e[0].screen.y);for(var i=1;i<e.length;++i){var o=e[i];t.lineTo(o.screen.x,o.screen.y)}t.closePath(),hp(t).call(t),t.stroke()}},I_.prototype._drawCircle=function(t,e,r,n,i){var o=this._calcRadius(e,i);t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=n,t.fillStyle=r,t.beginPath(),t.arc(e.screen.x,e.screen.y,o,0,2*Math.PI,!0),hp(t).call(t),t.stroke()},I_.prototype._getColorsRegular=function(t){var e=(t.point.value-this.valueRange.min)*this.scale.value;return{fill:this._colormap(e,1),border:this._colormap(e,.8)}},I_.prototype._getColorsColor=function(t){var e,r,n;if(t&&t.point&&t.point.data&&t.point.data.style&&(n=t.point.data.style),n&&"object"===vh(n)&&hp(n)&&n.stroke)return{fill:hp(n),border:n.stroke};if("string"==typeof t.point.value)e=t.point.value,r=t.point.value;else{var i=(t.point.value-this.valueRange.min)*this.scale.value;e=this._colormap(i,1),r=this._colormap(i,.8)}return{fill:e,border:r}},I_.prototype._getColorsSize=function(){return{fill:hp(this.dataColor),border:this.dataColor.stroke}},I_.prototype._colormap=function(t){var e,r,n,i,o,a,s,c,l,h=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1,u=this.colormap;if(Fp(u)){var p=u.length-1,f=Math.max(Math.floor(t*p),0),d=Math.min(f+1,p),v=t*p-f,y=u[f],m=u[d];e=y.r+v*(m.r-y.r),r=y.g+v*(m.g-y.g),n=y.b+v*(m.b-y.b)}else if("function"==typeof u){var g=u(t);e=g.r,r=g.g,n=g.b,i=g.a}else{var x=Uw(240*(1-t)/360,1,1);e=x.r,r=x.g,n=x.b}return"number"!=typeof i||Yp(i)?$p(o=$p(a="RGB(".concat(Math.round(e*h),", ")).call(a,Math.round(r*h),", ")).call(o,Math.round(n*h),")"):$p(s=$p(c=$p(l="RGBA(".concat(Math.round(e*h),", ")).call(l,Math.round(r*h),", ")).call(c,Math.round(n*h),", ")).call(s,i,")")},I_.prototype._calcRadius=function(t,e){var r;return void 0===e&&(e=this._dotSize()),(r=this.showPerspective?e/-t.trans.z:e*(-this.eye.z/this.camera.getArmLength()))<0&&(r=0),r},I_.prototype._redrawBarGraphPoint=function(t,e){var r=this.xBarWidth/2,n=this.yBarWidth/2,i=this._getColorsRegular(e);this._redrawBar(t,e,r,n,hp(i),i.border)},I_.prototype._redrawBarColorGraphPoint=function(t,e){var r=this.xBarWidth/2,n=this.yBarWidth/2,i=this._getColorsColor(e);this._redrawBar(t,e,r,n,hp(i),i.border)},I_.prototype._redrawBarSizeGraphPoint=function(t,e){var r=(e.point.value-this.valueRange.min)/this.valueRange.range(),n=this.xBarWidth/2*(.8*r+.2),i=this.yBarWidth/2*(.8*r+.2),o=this._getColorsSize();this._redrawBar(t,e,n,i,hp(o),o.border)},I_.prototype._redrawDotGraphPoint=function(t,e){var r=this._getColorsRegular(e);this._drawCircle(t,e,hp(r),r.border)},I_.prototype._redrawDotLineGraphPoint=function(t,e){var r=this._convert3Dto2D(e.bottom);t.lineWidth=1,this._line(t,r,e.screen,this.gridColor),this._redrawDotGraphPoint(t,e)},I_.prototype._redrawDotColorGraphPoint=function(t,e){var r=this._getColorsColor(e);this._drawCircle(t,e,hp(r),r.border)},I_.prototype._redrawDotSizeGraphPoint=function(t,e){var r=this._dotSize(),n=(e.point.value-this.valueRange.min)/this.valueRange.range(),i=r*this.dotSizeMinFraction,o=i+(r*this.dotSizeMaxFraction-i)*n,a=this._getColorsSize();this._drawCircle(t,e,hp(a),a.border,o)},I_.prototype._redrawSurfaceGraphPoint=function(t,e){var r=e.pointRight,n=e.pointTop,i=e.pointCross;if(void 0!==e&&void 0!==r&&void 0!==n&&void 0!==i){var o,a,s,c=!0;if(this.showGrayBottom||this.showShadow){var l=t_.subtract(i.trans,e.trans),h=t_.subtract(n.trans,r.trans),u=t_.crossProduct(l,h);if(this.showPerspective){var p=t_.avg(t_.avg(e.trans,i.trans),t_.avg(r.trans,n.trans));s=-t_.dotProduct(u.normalize(),p.normalize())}else s=u.z/u.length();c=s>0}if(c||!this.showGrayBottom){var f=((e.point.value+r.point.value+n.point.value+i.point.value)/4-this.valueRange.min)*this.scale.value,d=this.showShadow?(1+s)/2:1;o=this._colormap(f,d)}else o="gray";a=this.showSurfaceGrid?this.axisColor:o,t.lineWidth=this._getStrokeWidth(e);var v=[e,r,i,n];this._polygon(t,v,o,a)}},I_.prototype._drawGridLine=function(t,e,r){if(void 0!==e&&void 0!==r){var n=((e.point.value+r.point.value)/2-this.valueRange.min)*this.scale.value;t.lineWidth=2*this._getStrokeWidth(e),t.strokeStyle=this._colormap(n,1),this._line(t,e.screen,r.screen)}},I_.prototype._redrawGridGraphPoint=function(t,e){this._drawGridLine(t,e,e.pointRight),this._drawGridLine(t,e,e.pointTop)},I_.prototype._redrawLineGraphPoint=function(t,e){void 0!==e.pointNext&&(t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=this.dataColor.stroke,this._line(t,e.screen,e.pointNext.screen))},I_.prototype._redrawDataGraph=function(){var t,e=this._getContext();if(!(void 0===this.dataPoints||this.dataPoints.length<=0))for(this._calcTranslations(this.dataPoints),t=0;t<this.dataPoints.length;t++){var r=this.dataPoints[t];this._pointDrawingMethod.call(this,e,r)}},I_.prototype._storeMousePosition=function(t){this.startMouseX=z_(t),this.startMouseY=j_(t),this._startCameraOffset=this.camera.getOffset()},I_.prototype._onMouseDown=function(t){if(t=t||window.event,this.leftButtonDown&&this._onMouseUp(t),this.leftButtonDown=t.which?1===t.which:1===t.button,this.leftButtonDown||this.touchDown){this._storeMousePosition(t),this.startStart=new Date(this.start),this.startEnd=new Date(this.end),this.startArmRotation=this.camera.getArmRotation(),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},Gw(document,"mousemove",e.onmousemove),Gw(document,"mouseup",e.onmouseup),Vw(t)}},I_.prototype._onMouseMove=function(t){this.moving=!0,t=t||window.event;var e=Qu(z_(t))-this.startMouseX,r=Qu(j_(t))-this.startMouseY;if(t&&!0===t.ctrlKey){var n=.5*this.frame.clientWidth,i=.5*this.frame.clientHeight,o=(this._startCameraOffset.x||0)-e/n*this.camera.armLength*.8,a=(this._startCameraOffset.y||0)+r/i*this.camera.armLength*.8;this.camera.setOffset(o,a),this._storeMousePosition(t)}else{var s=this.startArmRotation.horizontal+e/200,c=this.startArmRotation.vertical+r/200,l=Math.sin(4/360*2*Math.PI);Math.abs(Math.sin(s))<l&&(s=Math.round(s/Math.PI)*Math.PI-.001),Math.abs(Math.cos(s))<l&&(s=(Math.round(s/Math.PI-.5)+.5)*Math.PI-.001),Math.abs(Math.sin(c))<l&&(c=Math.round(c/Math.PI)*Math.PI),Math.abs(Math.cos(c))<l&&(c=(Math.round(c/Math.PI-.5)+.5)*Math.PI),this.camera.setArmRotation(s,c)}this.redraw();var h=this.getCameraPosition();this.emit("cameraPositionChange",h),Vw(t)},I_.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",this.leftButtonDown=!1,Xw(document,"mousemove",this.onmousemove),Xw(document,"mouseup",this.onmouseup),Vw(t)},I_.prototype._onClick=function(t){if(this.onclick_callback||this.hasListeners("click")){if(this.moving)this.moving=!1;else{var e=this.frame.getBoundingClientRect(),r=z_(t)-e.left,n=j_(t)-e.top,i=this._dataPointFromXY(r,n);i&&(this.onclick_callback&&this.onclick_callback(i.point.data),this.emit("click",i.point.data))}Vw(t)}},I_.prototype._onTooltip=function(t){var e=this.tooltipDelay,r=this.frame.getBoundingClientRect(),n=z_(t)-r.left,i=j_(t)-r.top;if(this.showTooltip)if(this.tooltipTimeout&&clearTimeout(this.tooltipTimeout),this.leftButtonDown)this._hideTooltip();else if(this.tooltip&&this.tooltip.dataPoint){var o=this._dataPointFromXY(n,i);o!==this.tooltip.dataPoint&&(o?this._showTooltip(o):this._hideTooltip())}else{var a=this;this.tooltipTimeout=xf((function(){a.tooltipTimeout=null;var t=a._dataPointFromXY(n,i);t&&a._showTooltip(t)}),e)}},I_.prototype._onTouchStart=function(t){this.touchDown=!0;var e=this;this.ontouchmove=function(t){e._onTouchMove(t)},this.ontouchend=function(t){e._onTouchEnd(t)},Gw(document,"touchmove",e.ontouchmove),Gw(document,"touchend",e.ontouchend),this._onMouseDown(t)},I_.prototype._onTouchMove=function(t){this._onMouseMove(t)},I_.prototype._onTouchEnd=function(t){this.touchDown=!1,Xw(document,"touchmove",this.ontouchmove),Xw(document,"touchend",this.ontouchend),this._onMouseUp(t)},I_.prototype._onWheel=function(t){if(t||(t=window.event),this.zoomable&&(!this.ctrlToZoom||t.ctrlKey)){var e=0;if(t.wheelDelta?e=t.wheelDelta/120:t.detail&&(e=-t.detail/3),e){var r=this.camera.getArmLength()*(1-e/10);this.camera.setArmLength(r),this.redraw(),this._hideTooltip()}var n=this.getCameraPosition();this.emit("cameraPositionChange",n),Vw(t)}},I_.prototype._insideTriangle=function(t,e){var r=e[0],n=e[1],i=e[2];function o(t){return t>0?1:t<0?-1:0}var a=o((n.x-r.x)*(t.y-r.y)-(n.y-r.y)*(t.x-r.x)),s=o((i.x-n.x)*(t.y-n.y)-(i.y-n.y)*(t.x-n.x)),c=o((r.x-i.x)*(t.y-i.y)-(r.y-i.y)*(t.x-i.x));return!(0!=a&&0!=s&&a!=s||0!=s&&0!=c&&s!=c||0!=a&&0!=c&&a!=c)},I_.prototype._dataPointFromXY=function(t,e){var r,n=new e_(t,e),i=null,o=null,a=null;if(this.style===I_.STYLE.BAR||this.style===I_.STYLE.BARCOLOR||this.style===I_.STYLE.BARSIZE)for(r=this.dataPoints.length-1;r>=0;r--){var s=(i=this.dataPoints[r]).surfaces;if(s)for(var c=s.length-1;c>=0;c--){var l=s[c].corners,h=[l[0].screen,l[1].screen,l[2].screen],u=[l[2].screen,l[3].screen,l[0].screen];if(this._insideTriangle(n,h)||this._insideTriangle(n,u))return i}}else for(r=0;r<this.dataPoints.length;r++){var p=(i=this.dataPoints[r]).screen;if(p){var f=Math.abs(t-p.x),d=Math.abs(e-p.y),v=Math.sqrt(f*f+d*d);(null===a||v<a)&&v<100&&(a=v,o=i)}}return o},I_.prototype.hasBars=function(t){return t==I_.STYLE.BAR||t==I_.STYLE.BARCOLOR||t==I_.STYLE.BARSIZE},I_.prototype._showTooltip=function(t){var e,r,n;this.tooltip?(e=this.tooltip.dom.content,r=this.tooltip.dom.line,n=this.tooltip.dom.dot):(e=document.createElement("div"),jf(e.style,{},this.tooltipStyle.content),e.style.position="absolute",r=document.createElement("div"),jf(r.style,{},this.tooltipStyle.line),r.style.position="absolute",n=document.createElement("div"),jf(n.style,{},this.tooltipStyle.dot),n.style.position="absolute",this.tooltip={dataPoint:null,dom:{content:e,line:r,dot:n}}),this._hideTooltip(),this.tooltip.dataPoint=t,"function"==typeof this.showTooltip?e.innerHTML=this.showTooltip(t.point):e.innerHTML="<table><tr><td>"+this.xLabel+":</td><td>"+t.point.x+"</td></tr><tr><td>"+this.yLabel+":</td><td>"+t.point.y+"</td></tr><tr><td>"+this.zLabel+":</td><td>"+t.point.z+"</td></tr></table>",e.style.left="0",e.style.top="0",this.frame.appendChild(e),this.frame.appendChild(r),this.frame.appendChild(n);var i=e.offsetWidth,o=e.offsetHeight,a=r.offsetHeight,s=n.offsetWidth,c=n.offsetHeight,l=t.screen.x-i/2;l=Math.min(Math.max(l,10),this.frame.clientWidth-10-i),r.style.left=t.screen.x+"px",r.style.top=t.screen.y-a+"px",e.style.left=l+"px",e.style.top=t.screen.y-a-o+"px",n.style.left=t.screen.x-s/2+"px",n.style.top=t.screen.y-c/2+"px"},I_.prototype._hideTooltip=function(){if(this.tooltip)for(var t in this.tooltip.dataPoint=null,this.tooltip.dom)if(Object.prototype.hasOwnProperty.call(this.tooltip.dom,t)){var e=this.tooltip.dom[t];e&&e.parentNode&&e.parentNode.removeChild(e)}},I_.prototype.setCameraPosition=function(t){__(t,this),this.redraw()},I_.prototype.setSize=function(t,e){this._setSize(t,e),this.redraw()};export{I_ as Graph3d,l_ as Graph3dCamera,D_ as Graph3dFilter,e_ as Graph3dPoint2d,t_ as Graph3dPoint3d,r_ as Graph3dSlider,i_ as Graph3dStepNumber};
//# sourceMappingURL=vis-graph3d.min.js.map
