/**
 * vis-graph3d
 * https://visjs.github.io/vis-graph3d/
 *
 * Create interactive, animated 3d graphs. Surfaces, lines, dots and block styling out of the box.
 *
 * @version 6.0.3
 * @date    2023-03-21T17:15:34.624Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports,require("vis-data/peer/umd/vis-data.js")):"function"==typeof define&&define.amd?define(["exports","vis-data/peer/umd/vis-data.js"],e):e((t="undefined"!=typeof globalThis?globalThis:t||self).vis=t.vis||{},t.vis)}(this,(function(t,e){var r="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function n(t){return t&&t.__esModule&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t}var i={},o={get exports(){return i},set exports(t){i=t}},a={},s={get exports(){return a},set exports(t){a=t}},c=function(t){return t&&t.Math==Math&&t},u=c("object"==typeof globalThis&&globalThis)||c("object"==typeof window&&window)||c("object"==typeof self&&self)||c("object"==typeof r&&r)||function(){return this}()||Function("return this")(),l=function(t){try{return!!t()}catch(t){return!0}},h=!l((function(){var t=function(){}.bind();return"function"!=typeof t||t.hasOwnProperty("prototype")})),f=h,p=Function.prototype,d=p.apply,v=p.call,y="object"==typeof Reflect&&Reflect.apply||(f?v.bind(d):function(){return v.apply(d,arguments)}),m=h,g=Function.prototype,x=g.call,b=m&&g.bind.bind(x,x),w=m?b:function(t){return function(){return x.apply(t,arguments)}},_=w,S=_({}.toString),T=_("".slice),C=function(t){return T(S(t),8,-1)},A=C,E=w,L=function(t){if("Function"===A(t))return E(t)},O="object"==typeof document&&document.all,P={all:O,IS_HTMLDDA:void 0===O&&void 0!==O},M=P.all,D=P.IS_HTMLDDA?function(t){return"function"==typeof t||t===M}:function(t){return"function"==typeof t},R={},k=!l((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),I=h,z=Function.prototype.call,j=I?z.bind(z):function(){return z.apply(z,arguments)},F={},B={}.propertyIsEnumerable,N=Object.getOwnPropertyDescriptor,W=N&&!B.call({1:2},1);F.f=W?function(t){var e=N(this,t);return!!e&&e.enumerable}:B;var Y,G,X=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},V=l,U=C,Z=Object,H=w("".split),q=V((function(){return!Z("z").propertyIsEnumerable(0)}))?function(t){return"String"==U(t)?H(t,""):Z(t)}:Z,$=function(t){return null==t},J=$,K=TypeError,Q=function(t){if(J(t))throw K("Can't call method on "+t);return t},tt=q,et=Q,rt=function(t){return tt(et(t))},nt=D,it=P.all,ot=P.IS_HTMLDDA?function(t){return"object"==typeof t?null!==t:nt(t)||t===it}:function(t){return"object"==typeof t?null!==t:nt(t)},at={},st=at,ct=u,ut=D,lt=function(t){return ut(t)?t:void 0},ht=function(t,e){return arguments.length<2?lt(st[t])||lt(ct[t]):st[t]&&st[t][e]||ct[t]&&ct[t][e]},ft=w({}.isPrototypeOf),pt="undefined"!=typeof navigator&&String(navigator.userAgent)||"",dt=u,vt=pt,yt=dt.process,mt=dt.Deno,gt=yt&&yt.versions||mt&&mt.version,xt=gt&&gt.v8;xt&&(G=(Y=xt.split("."))[0]>0&&Y[0]<4?1:+(Y[0]+Y[1])),!G&&vt&&(!(Y=vt.match(/Edge\/(\d+)/))||Y[1]>=74)&&(Y=vt.match(/Chrome\/(\d+)/))&&(G=+Y[1]);var bt=G,wt=bt,_t=l,St=!!Object.getOwnPropertySymbols&&!_t((function(){var t=Symbol();return!String(t)||!(Object(t)instanceof Symbol)||!Symbol.sham&&wt&&wt<41})),Tt=St&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,Ct=ht,At=D,Et=ft,Lt=Object,Ot=Tt?function(t){return"symbol"==typeof t}:function(t){var e=Ct("Symbol");return At(e)&&Et(e.prototype,Lt(t))},Pt=String,Mt=function(t){try{return Pt(t)}catch(t){return"Object"}},Dt=D,Rt=Mt,kt=TypeError,It=function(t){if(Dt(t))return t;throw kt(Rt(t)+" is not a function")},zt=It,jt=$,Ft=function(t,e){var r=t[e];return jt(r)?void 0:zt(r)},Bt=j,Nt=D,Wt=ot,Yt=TypeError,Gt={},Xt={get exports(){return Gt},set exports(t){Gt=t}},Vt=u,Ut=Object.defineProperty,Zt=function(t,e){try{Ut(Vt,t,{value:e,configurable:!0,writable:!0})}catch(r){Vt[t]=e}return e},Ht="__core-js_shared__",qt=u[Ht]||Zt(Ht,{}),$t=qt;(Xt.exports=function(t,e){return $t[t]||($t[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.29.0",mode:"pure",copyright:"© 2014-2023 Denis Pushkarev (zloirock.ru)",license:"https://github.com/zloirock/core-js/blob/v3.29.0/LICENSE",source:"https://github.com/zloirock/core-js"});var Jt=Q,Kt=Object,Qt=function(t){return Kt(Jt(t))},te=Qt,ee=w({}.hasOwnProperty),re=Object.hasOwn||function(t,e){return ee(te(t),e)},ne=w,ie=0,oe=Math.random(),ae=ne(1..toString),se=function(t){return"Symbol("+(void 0===t?"":t)+")_"+ae(++ie+oe,36)},ce=Gt,ue=re,le=se,he=St,fe=Tt,pe=u.Symbol,de=ce("wks"),ve=fe?pe.for||pe:pe&&pe.withoutSetter||le,ye=function(t){return ue(de,t)||(de[t]=he&&ue(pe,t)?pe[t]:ve("Symbol."+t)),de[t]},me=j,ge=ot,xe=Ot,be=Ft,we=function(t,e){var r,n;if("string"===e&&Nt(r=t.toString)&&!Wt(n=Bt(r,t)))return n;if(Nt(r=t.valueOf)&&!Wt(n=Bt(r,t)))return n;if("string"!==e&&Nt(r=t.toString)&&!Wt(n=Bt(r,t)))return n;throw Yt("Can't convert object to primitive value")},_e=TypeError,Se=ye("toPrimitive"),Te=function(t,e){if(!ge(t)||xe(t))return t;var r,n=be(t,Se);if(n){if(void 0===e&&(e="default"),r=me(n,t,e),!ge(r)||xe(r))return r;throw _e("Can't convert object to primitive value")}return void 0===e&&(e="number"),we(t,e)},Ce=Ot,Ae=function(t){var e=Te(t,"string");return Ce(e)?e:e+""},Ee=ot,Le=u.document,Oe=Ee(Le)&&Ee(Le.createElement),Pe=function(t){return Oe?Le.createElement(t):{}},Me=Pe,De=!k&&!l((function(){return 7!=Object.defineProperty(Me("div"),"a",{get:function(){return 7}}).a})),Re=k,ke=j,Ie=F,ze=X,je=rt,Fe=Ae,Be=re,Ne=De,We=Object.getOwnPropertyDescriptor;R.f=Re?We:function(t,e){if(t=je(t),e=Fe(e),Ne)try{return We(t,e)}catch(t){}if(Be(t,e))return ze(!ke(Ie.f,t,e),t[e])};var Ye=l,Ge=D,Xe=/#|\.prototype\./,Ve=function(t,e){var r=Ze[Ue(t)];return r==qe||r!=He&&(Ge(e)?Ye(e):!!e)},Ue=Ve.normalize=function(t){return String(t).replace(Xe,".").toLowerCase()},Ze=Ve.data={},He=Ve.NATIVE="N",qe=Ve.POLYFILL="P",$e=Ve,Je=It,Ke=h,Qe=L(L.bind),tr=function(t,e){return Je(t),void 0===e?t:Ke?Qe(t,e):function(){return t.apply(e,arguments)}},er={},rr=k&&l((function(){return 42!=Object.defineProperty((function(){}),"prototype",{value:42,writable:!1}).prototype})),nr=ot,ir=String,or=TypeError,ar=function(t){if(nr(t))return t;throw or(ir(t)+" is not an object")},sr=k,cr=De,ur=rr,lr=ar,hr=Ae,fr=TypeError,pr=Object.defineProperty,dr=Object.getOwnPropertyDescriptor,vr="enumerable",yr="configurable",mr="writable";er.f=sr?ur?function(t,e,r){if(lr(t),e=hr(e),lr(r),"function"==typeof t&&"prototype"===e&&"value"in r&&mr in r&&!r[mr]){var n=dr(t,e);n&&n[mr]&&(t[e]=r.value,r={configurable:yr in r?r[yr]:n[yr],enumerable:vr in r?r[vr]:n[vr],writable:!1})}return pr(t,e,r)}:pr:function(t,e,r){if(lr(t),e=hr(e),lr(r),cr)try{return pr(t,e,r)}catch(t){}if("get"in r||"set"in r)throw fr("Accessors not supported");return"value"in r&&(t[e]=r.value),t};var gr=er,xr=X,br=k?function(t,e,r){return gr.f(t,e,xr(1,r))}:function(t,e,r){return t[e]=r,t},wr=u,_r=y,Sr=L,Tr=D,Cr=R.f,Ar=$e,Er=at,Lr=tr,Or=br,Pr=re,Mr=function(t){var e=function(r,n,i){if(this instanceof e){switch(arguments.length){case 0:return new t;case 1:return new t(r);case 2:return new t(r,n)}return new t(r,n,i)}return _r(t,this,arguments)};return e.prototype=t.prototype,e},Dr=function(t,e){var r,n,i,o,a,s,c,u,l,h=t.target,f=t.global,p=t.stat,d=t.proto,v=f?wr:p?wr[h]:(wr[h]||{}).prototype,y=f?Er:Er[h]||Or(Er,h,{})[h],m=y.prototype;for(o in e)n=!(r=Ar(f?o:h+(p?".":"#")+o,t.forced))&&v&&Pr(v,o),s=y[o],n&&(c=t.dontCallGetSet?(l=Cr(v,o))&&l.value:v[o]),a=n&&c?c:e[o],n&&typeof s==typeof a||(u=t.bind&&n?Lr(a,wr):t.wrap&&n?Mr(a):d&&Tr(a)?Sr(a):a,(t.sham||a&&a.sham||s&&s.sham)&&Or(u,"sham",!0),Or(y,o,u),d&&(Pr(Er,i=h+"Prototype")||Or(Er,i,{}),Or(Er[i],o,a),t.real&&m&&(r||!m[o])&&Or(m,o,a)))},Rr=C,kr=Array.isArray||function(t){return"Array"==Rr(t)},Ir=Math.ceil,zr=Math.floor,jr=Math.trunc||function(t){var e=+t;return(e>0?zr:Ir)(e)},Fr=function(t){var e=+t;return e!=e||0===e?0:jr(e)},Br=Fr,Nr=Math.min,Wr=function(t){return t>0?Nr(Br(t),9007199254740991):0},Yr=function(t){return Wr(t.length)},Gr=TypeError,Xr=function(t){if(t>9007199254740991)throw Gr("Maximum allowed index exceeded");return t},Vr=Ae,Ur=er,Zr=X,Hr=function(t,e,r){var n=Vr(e);n in t?Ur.f(t,n,Zr(0,r)):t[n]=r},qr={};qr[ye("toStringTag")]="z";var $r="[object z]"===String(qr),Jr=$r,Kr=D,Qr=C,tn=ye("toStringTag"),en=Object,rn="Arguments"==Qr(function(){return arguments}()),nn=Jr?Qr:function(t){var e,r,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(r=function(t,e){try{return t[e]}catch(t){}}(e=en(t),tn))?r:rn?Qr(e):"Object"==(n=Qr(e))&&Kr(e.callee)?"Arguments":n},on=D,an=qt,sn=w(Function.toString);on(an.inspectSource)||(an.inspectSource=function(t){return sn(t)});var cn=an.inspectSource,un=w,ln=l,hn=D,fn=nn,pn=cn,dn=function(){},vn=[],yn=ht("Reflect","construct"),mn=/^\s*(?:class|function)\b/,gn=un(mn.exec),xn=!mn.exec(dn),bn=function(t){if(!hn(t))return!1;try{return yn(dn,vn,t),!0}catch(t){return!1}},wn=function(t){if(!hn(t))return!1;switch(fn(t)){case"AsyncFunction":case"GeneratorFunction":case"AsyncGeneratorFunction":return!1}try{return xn||!!gn(mn,pn(t))}catch(t){return!0}};wn.sham=!0;var _n=!yn||ln((function(){var t;return bn(bn.call)||!bn(Object)||!bn((function(){t=!0}))||t}))?wn:bn,Sn=kr,Tn=_n,Cn=ot,An=ye("species"),En=Array,Ln=function(t){var e;return Sn(t)&&(e=t.constructor,(Tn(e)&&(e===En||Sn(e.prototype))||Cn(e)&&null===(e=e[An]))&&(e=void 0)),void 0===e?En:e},On=function(t,e){return new(Ln(t))(0===e?0:e)},Pn=l,Mn=bt,Dn=ye("species"),Rn=function(t){return Mn>=51||!Pn((function(){var e=[];return(e.constructor={})[Dn]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},kn=Dr,In=l,zn=kr,jn=ot,Fn=Qt,Bn=Yr,Nn=Xr,Wn=Hr,Yn=On,Gn=Rn,Xn=bt,Vn=ye("isConcatSpreadable"),Un=Xn>=51||!In((function(){var t=[];return t[Vn]=!1,t.concat()[0]!==t})),Zn=function(t){if(!jn(t))return!1;var e=t[Vn];return void 0!==e?!!e:zn(t)};kn({target:"Array",proto:!0,arity:1,forced:!Un||!Gn("concat")},{concat:function(t){var e,r,n,i,o,a=Fn(this),s=Yn(a,0),c=0;for(e=-1,n=arguments.length;e<n;e++)if(Zn(o=-1===e?a:arguments[e]))for(i=Bn(o),Nn(c+i),r=0;r<i;r++,c++)r in o&&Wn(s,c,o[r]);else Nn(c+1),Wn(s,c++,o);return s.length=c,s}});var Hn=nn,qn=String,$n=function(t){if("Symbol"===Hn(t))throw TypeError("Cannot convert a Symbol value to a string");return qn(t)},Jn={},Kn=Fr,Qn=Math.max,ti=Math.min,ei=function(t,e){var r=Kn(t);return r<0?Qn(r+e,0):ti(r,e)},ri=rt,ni=ei,ii=Yr,oi=function(t){return function(e,r,n){var i,o=ri(e),a=ii(o),s=ni(n,a);if(t&&r!=r){for(;a>s;)if((i=o[s++])!=i)return!0}else for(;a>s;s++)if((t||s in o)&&o[s]===r)return t||s||0;return!t&&-1}},ai={includes:oi(!0),indexOf:oi(!1)},si={},ci=re,ui=rt,li=ai.indexOf,hi=si,fi=w([].push),pi=function(t,e){var r,n=ui(t),i=0,o=[];for(r in n)!ci(hi,r)&&ci(n,r)&&fi(o,r);for(;e.length>i;)ci(n,r=e[i++])&&(~li(o,r)||fi(o,r));return o},di=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],vi=pi,yi=di,mi=Object.keys||function(t){return vi(t,yi)},gi=k,xi=rr,bi=er,wi=ar,_i=rt,Si=mi;Jn.f=gi&&!xi?Object.defineProperties:function(t,e){wi(t);for(var r,n=_i(e),i=Si(e),o=i.length,a=0;o>a;)bi.f(t,r=i[a++],n[r]);return t};var Ti,Ci=ht("document","documentElement"),Ai=se,Ei=Gt("keys"),Li=function(t){return Ei[t]||(Ei[t]=Ai(t))},Oi=ar,Pi=Jn,Mi=di,Di=si,Ri=Ci,ki=Pe,Ii="prototype",zi="script",ji=Li("IE_PROTO"),Fi=function(){},Bi=function(t){return"<"+zi+">"+t+"</"+zi+">"},Ni=function(t){t.write(Bi("")),t.close();var e=t.parentWindow.Object;return t=null,e},Wi=function(){try{Ti=new ActiveXObject("htmlfile")}catch(t){}var t,e,r;Wi="undefined"!=typeof document?document.domain&&Ti?Ni(Ti):(e=ki("iframe"),r="java"+zi+":",e.style.display="none",Ri.appendChild(e),e.src=String(r),(t=e.contentWindow.document).open(),t.write(Bi("document.F=Object")),t.close(),t.F):Ni(Ti);for(var n=Mi.length;n--;)delete Wi[Ii][Mi[n]];return Wi()};Di[ji]=!0;var Yi=Object.create||function(t,e){var r;return null!==t?(Fi[Ii]=Oi(t),r=new Fi,Fi[Ii]=null,r[ji]=t):r=Wi(),void 0===e?r:Pi.f(r,e)},Gi={},Xi=pi,Vi=di.concat("length","prototype");Gi.f=Object.getOwnPropertyNames||function(t){return Xi(t,Vi)};var Ui={},Zi=ei,Hi=Yr,qi=Hr,$i=Array,Ji=Math.max,Ki=function(t,e,r){for(var n=Hi(t),i=Zi(e,n),o=Zi(void 0===r?n:r,n),a=$i(Ji(o-i,0)),s=0;i<o;i++,s++)qi(a,s,t[i]);return a.length=s,a},Qi=C,to=rt,eo=Gi.f,ro=Ki,no="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[];Ui.f=function(t){return no&&"Window"==Qi(t)?function(t){try{return eo(t)}catch(t){return ro(no)}}(t):eo(to(t))};var io={};io.f=Object.getOwnPropertySymbols;var oo=br,ao=function(t,e,r,n){return n&&n.enumerable?t[e]=r:oo(t,e,r),t},so=er,co={},uo=ye;co.f=uo;var lo,ho,fo,po=at,vo=re,yo=co,mo=er.f,go=function(t){var e=po.Symbol||(po.Symbol={});vo(e,t)||mo(e,t,{value:yo.f(t)})},xo=j,bo=ht,wo=ye,_o=ao,So=function(){var t=bo("Symbol"),e=t&&t.prototype,r=e&&e.valueOf,n=wo("toPrimitive");e&&!e[n]&&_o(e,n,(function(t){return xo(r,this)}),{arity:1})},To=nn,Co=$r?{}.toString:function(){return"[object "+To(this)+"]"},Ao=$r,Eo=er.f,Lo=br,Oo=re,Po=Co,Mo=ye("toStringTag"),Do=function(t,e,r,n){if(t){var i=r?t:t.prototype;Oo(i,Mo)||Eo(i,Mo,{configurable:!0,value:e}),n&&!Ao&&Lo(i,"toString",Po)}},Ro=D,ko=u.WeakMap,Io=Ro(ko)&&/native code/.test(String(ko)),zo=u,jo=ot,Fo=br,Bo=re,No=qt,Wo=Li,Yo=si,Go="Object already initialized",Xo=zo.TypeError,Vo=zo.WeakMap;if(Io||No.state){var Uo=No.state||(No.state=new Vo);Uo.get=Uo.get,Uo.has=Uo.has,Uo.set=Uo.set,lo=function(t,e){if(Uo.has(t))throw Xo(Go);return e.facade=t,Uo.set(t,e),e},ho=function(t){return Uo.get(t)||{}},fo=function(t){return Uo.has(t)}}else{var Zo=Wo("state");Yo[Zo]=!0,lo=function(t,e){if(Bo(t,Zo))throw Xo(Go);return e.facade=t,Fo(t,Zo,e),e},ho=function(t){return Bo(t,Zo)?t[Zo]:{}},fo=function(t){return Bo(t,Zo)}}var Ho={set:lo,get:ho,has:fo,enforce:function(t){return fo(t)?ho(t):lo(t,{})},getterFor:function(t){return function(e){var r;if(!jo(e)||(r=ho(e)).type!==t)throw Xo("Incompatible receiver, "+t+" required");return r}}},qo=tr,$o=q,Jo=Qt,Ko=Yr,Qo=On,ta=w([].push),ea=function(t){var e=1==t,r=2==t,n=3==t,i=4==t,o=6==t,a=7==t,s=5==t||o;return function(c,u,l,h){for(var f,p,d=Jo(c),v=$o(d),y=qo(u,l),m=Ko(v),g=0,x=h||Qo,b=e?x(c,m):r||a?x(c,0):void 0;m>g;g++)if((s||g in v)&&(p=y(f=v[g],g,d),t))if(e)b[g]=p;else if(p)switch(t){case 3:return!0;case 5:return f;case 6:return g;case 2:ta(b,f)}else switch(t){case 4:return!1;case 7:ta(b,f)}return o?-1:n||i?i:b}},ra={forEach:ea(0),map:ea(1),filter:ea(2),some:ea(3),every:ea(4),find:ea(5),findIndex:ea(6),filterReject:ea(7)},na=Dr,ia=u,oa=j,aa=w,sa=k,ca=St,ua=l,la=re,ha=ft,fa=ar,pa=rt,da=Ae,va=$n,ya=X,ma=Yi,ga=mi,xa=Gi,ba=Ui,wa=io,_a=R,Sa=er,Ta=Jn,Ca=F,Aa=ao,Ea=function(t,e,r){return so.f(t,e,r)},La=Gt,Oa=si,Pa=se,Ma=ye,Da=co,Ra=go,ka=So,Ia=Do,za=Ho,ja=ra.forEach,Fa=Li("hidden"),Ba="Symbol",Na="prototype",Wa=za.set,Ya=za.getterFor(Ba),Ga=Object[Na],Xa=ia.Symbol,Va=Xa&&Xa[Na],Ua=ia.TypeError,Za=ia.QObject,Ha=_a.f,qa=Sa.f,$a=ba.f,Ja=Ca.f,Ka=aa([].push),Qa=La("symbols"),ts=La("op-symbols"),es=La("wks"),rs=!Za||!Za[Na]||!Za[Na].findChild,ns=sa&&ua((function(){return 7!=ma(qa({},"a",{get:function(){return qa(this,"a",{value:7}).a}})).a}))?function(t,e,r){var n=Ha(Ga,e);n&&delete Ga[e],qa(t,e,r),n&&t!==Ga&&qa(Ga,e,n)}:qa,is=function(t,e){var r=Qa[t]=ma(Va);return Wa(r,{type:Ba,tag:t,description:e}),sa||(r.description=e),r},os=function(t,e,r){t===Ga&&os(ts,e,r),fa(t);var n=da(e);return fa(r),la(Qa,n)?(r.enumerable?(la(t,Fa)&&t[Fa][n]&&(t[Fa][n]=!1),r=ma(r,{enumerable:ya(0,!1)})):(la(t,Fa)||qa(t,Fa,ya(1,{})),t[Fa][n]=!0),ns(t,n,r)):qa(t,n,r)},as=function(t,e){fa(t);var r=pa(e),n=ga(r).concat(ls(r));return ja(n,(function(e){sa&&!oa(ss,r,e)||os(t,e,r[e])})),t},ss=function(t){var e=da(t),r=oa(Ja,this,e);return!(this===Ga&&la(Qa,e)&&!la(ts,e))&&(!(r||!la(this,e)||!la(Qa,e)||la(this,Fa)&&this[Fa][e])||r)},cs=function(t,e){var r=pa(t),n=da(e);if(r!==Ga||!la(Qa,n)||la(ts,n)){var i=Ha(r,n);return!i||!la(Qa,n)||la(r,Fa)&&r[Fa][n]||(i.enumerable=!0),i}},us=function(t){var e=$a(pa(t)),r=[];return ja(e,(function(t){la(Qa,t)||la(Oa,t)||Ka(r,t)})),r},ls=function(t){var e=t===Ga,r=$a(e?ts:pa(t)),n=[];return ja(r,(function(t){!la(Qa,t)||e&&!la(Ga,t)||Ka(n,Qa[t])})),n};ca||(Xa=function(){if(ha(Va,this))throw Ua("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?va(arguments[0]):void 0,e=Pa(t),r=function(t){this===Ga&&oa(r,ts,t),la(this,Fa)&&la(this[Fa],e)&&(this[Fa][e]=!1),ns(this,e,ya(1,t))};return sa&&rs&&ns(Ga,e,{configurable:!0,set:r}),is(e,t)},Aa(Va=Xa[Na],"toString",(function(){return Ya(this).tag})),Aa(Xa,"withoutSetter",(function(t){return is(Pa(t),t)})),Ca.f=ss,Sa.f=os,Ta.f=as,_a.f=cs,xa.f=ba.f=us,wa.f=ls,Da.f=function(t){return is(Ma(t),t)},sa&&Ea(Va,"description",{configurable:!0,get:function(){return Ya(this).description}})),na({global:!0,constructor:!0,wrap:!0,forced:!ca,sham:!ca},{Symbol:Xa}),ja(ga(es),(function(t){Ra(t)})),na({target:Ba,stat:!0,forced:!ca},{useSetter:function(){rs=!0},useSimple:function(){rs=!1}}),na({target:"Object",stat:!0,forced:!ca,sham:!sa},{create:function(t,e){return void 0===e?ma(t):as(ma(t),e)},defineProperty:os,defineProperties:as,getOwnPropertyDescriptor:cs}),na({target:"Object",stat:!0,forced:!ca},{getOwnPropertyNames:us}),ka(),Ia(Xa,Ba),Oa[Fa]=!0;var hs=St&&!!Symbol.for&&!!Symbol.keyFor,fs=Dr,ps=ht,ds=re,vs=$n,ys=Gt,ms=hs,gs=ys("string-to-symbol-registry"),xs=ys("symbol-to-string-registry");fs({target:"Symbol",stat:!0,forced:!ms},{for:function(t){var e=vs(t);if(ds(gs,e))return gs[e];var r=ps("Symbol")(e);return gs[e]=r,xs[r]=e,r}});var bs=Dr,ws=re,_s=Ot,Ss=Mt,Ts=hs,Cs=Gt("symbol-to-string-registry");bs({target:"Symbol",stat:!0,forced:!Ts},{keyFor:function(t){if(!_s(t))throw TypeError(Ss(t)+" is not a symbol");if(ws(Cs,t))return Cs[t]}});var As=w([].slice),Es=kr,Ls=D,Os=C,Ps=$n,Ms=w([].push),Ds=Dr,Rs=ht,ks=y,Is=j,zs=w,js=l,Fs=D,Bs=Ot,Ns=As,Ws=function(t){if(Ls(t))return t;if(Es(t)){for(var e=t.length,r=[],n=0;n<e;n++){var i=t[n];"string"==typeof i?Ms(r,i):"number"!=typeof i&&"Number"!=Os(i)&&"String"!=Os(i)||Ms(r,Ps(i))}var o=r.length,a=!0;return function(t,e){if(a)return a=!1,e;if(Es(this))return e;for(var n=0;n<o;n++)if(r[n]===t)return e}}},Ys=St,Gs=String,Xs=Rs("JSON","stringify"),Vs=zs(/./.exec),Us=zs("".charAt),Zs=zs("".charCodeAt),Hs=zs("".replace),qs=zs(1..toString),$s=/[\uD800-\uDFFF]/g,Js=/^[\uD800-\uDBFF]$/,Ks=/^[\uDC00-\uDFFF]$/,Qs=!Ys||js((function(){var t=Rs("Symbol")();return"[null]"!=Xs([t])||"{}"!=Xs({a:t})||"{}"!=Xs(Object(t))})),tc=js((function(){return'"\\udf06\\ud834"'!==Xs("\udf06\ud834")||'"\\udead"'!==Xs("\udead")})),ec=function(t,e){var r=Ns(arguments),n=Ws(e);if(Fs(n)||void 0!==t&&!Bs(t))return r[1]=function(t,e){if(Fs(n)&&(e=Is(n,this,Gs(t),e)),!Bs(e))return e},ks(Xs,null,r)},rc=function(t,e,r){var n=Us(r,e-1),i=Us(r,e+1);return Vs(Js,t)&&!Vs(Ks,i)||Vs(Ks,t)&&!Vs(Js,n)?"\\u"+qs(Zs(t,0),16):t};Xs&&Ds({target:"JSON",stat:!0,arity:3,forced:Qs||tc},{stringify:function(t,e,r){var n=Ns(arguments),i=ks(Qs?ec:Xs,null,n);return tc&&"string"==typeof i?Hs(i,$s,rc):i}});var nc=io,ic=Qt;Dr({target:"Object",stat:!0,forced:!St||l((function(){nc.f(1)}))},{getOwnPropertySymbols:function(t){var e=nc.f;return e?e(ic(t)):[]}}),go("asyncIterator"),go("hasInstance"),go("isConcatSpreadable"),go("iterator"),go("match"),go("matchAll"),go("replace"),go("search"),go("species"),go("split");var oc=So;go("toPrimitive"),oc();var ac=ht,sc=Do;go("toStringTag"),sc(ac("Symbol"),"Symbol"),go("unscopables"),Do(u.JSON,"JSON",!0);var cc,uc,lc,hc=at.Symbol,fc={},pc=k,dc=re,vc=Function.prototype,yc=pc&&Object.getOwnPropertyDescriptor,mc=dc(vc,"name"),gc={EXISTS:mc,PROPER:mc&&"something"===function(){}.name,CONFIGURABLE:mc&&(!pc||pc&&yc(vc,"name").configurable)},xc=!l((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),bc=re,wc=D,_c=Qt,Sc=xc,Tc=Li("IE_PROTO"),Cc=Object,Ac=Cc.prototype,Ec=Sc?Cc.getPrototypeOf:function(t){var e=_c(t);if(bc(e,Tc))return e[Tc];var r=e.constructor;return wc(r)&&e instanceof r?r.prototype:e instanceof Cc?Ac:null},Lc=l,Oc=D,Pc=ot,Mc=Yi,Dc=Ec,Rc=ao,kc=ye("iterator"),Ic=!1;[].keys&&("next"in(lc=[].keys())?(uc=Dc(Dc(lc)))!==Object.prototype&&(cc=uc):Ic=!0);var zc=!Pc(cc)||Lc((function(){var t={};return cc[kc].call(t)!==t}));Oc((cc=zc?{}:Mc(cc))[kc])||Rc(cc,kc,(function(){return this}));var jc={IteratorPrototype:cc,BUGGY_SAFARI_ITERATORS:Ic},Fc=jc.IteratorPrototype,Bc=Yi,Nc=X,Wc=Do,Yc=fc,Gc=function(){return this},Xc=Dr,Vc=j,Uc=function(t,e,r,n){var i=e+" Iterator";return t.prototype=Bc(Fc,{next:Nc(+!n,r)}),Wc(t,i,!1,!0),Yc[i]=Gc,t},Zc=Ec,Hc=Do,qc=ao,$c=fc,Jc=gc.PROPER,Kc=jc.BUGGY_SAFARI_ITERATORS,Qc=ye("iterator"),tu="keys",eu="values",ru="entries",nu=function(){return this},iu=function(t,e,r,n,i,o,a){Uc(r,e,n);var s,c,u,l=function(t){if(t===i&&v)return v;if(!Kc&&t in p)return p[t];switch(t){case tu:case eu:case ru:return function(){return new r(this,t)}}return function(){return new r(this)}},h=e+" Iterator",f=!1,p=t.prototype,d=p[Qc]||p["@@iterator"]||i&&p[i],v=!Kc&&d||l(i),y="Array"==e&&p.entries||d;if(y&&(s=Zc(y.call(new t)))!==Object.prototype&&s.next&&(Hc(s,h,!0,!0),$c[h]=nu),Jc&&i==eu&&d&&d.name!==eu&&(f=!0,v=function(){return Vc(d,this)}),i)if(c={values:l(eu),keys:o?v:l(tu),entries:l(ru)},a)for(u in c)(Kc||f||!(u in p))&&qc(p,u,c[u]);else Xc({target:e,proto:!0,forced:Kc||f},c);return a&&p[Qc]!==v&&qc(p,Qc,v,{name:i}),$c[e]=v,c},ou=function(t,e){return{value:t,done:e}},au=rt,su=fc,cu=Ho;er.f;var uu=iu,lu=ou,hu="Array Iterator",fu=cu.set,pu=cu.getterFor(hu);uu(Array,"Array",(function(t,e){fu(this,{type:hu,target:au(t),index:0,kind:e})}),(function(){var t=pu(this),e=t.target,r=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,lu(void 0,!0)):lu("keys"==r?n:"values"==r?e[n]:[n,e[n]],!1)}),"values"),su.Arguments=su.Array;var du={CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0},vu=u,yu=nn,mu=br,gu=fc,xu=ye("toStringTag");for(var bu in du){var wu=vu[bu],_u=wu&&wu.prototype;_u&&yu(_u)!==xu&&mu(_u,xu,bu),gu[bu]=gu.Array}var Su=hc;go("dispose");var Tu=Su;go("asyncDispose");var Cu=Dr,Au=w,Eu=ht("Symbol"),Lu=Eu.keyFor,Ou=Au(Eu.prototype.valueOf);Cu({target:"Symbol",stat:!0},{isRegistered:function(t){try{return void 0!==Lu(Ou(t))}catch(t){return!1}}});for(var Pu=Dr,Mu=Gt,Du=ht,Ru=w,ku=Ot,Iu=ye,zu=Du("Symbol"),ju=zu.isWellKnown,Fu=Du("Object","getOwnPropertyNames"),Bu=Ru(zu.prototype.valueOf),Nu=Mu("wks"),Wu=0,Yu=Fu(zu),Gu=Yu.length;Wu<Gu;Wu++)try{var Xu=Yu[Wu];ku(zu[Xu])&&Iu(Xu)}catch(t){}Pu({target:"Symbol",stat:!0,forced:!0},{isWellKnown:function(t){if(ju&&ju(t))return!0;try{for(var e=Bu(t),r=0,n=Fu(Nu),i=n.length;r<i;r++)if(Nu[n[r]]==e)return!0}catch(t){}return!1}}),go("matcher"),go("metadataKey"),go("observable"),go("metadata"),go("patternMatch"),go("replaceAll");var Vu=Tu;!function(t){t.exports=Vu}(s),function(t){t.exports=a}(o);var Uu=n(i),Zu={},Hu={get exports(){return Zu},set exports(t){Zu=t}},qu={},$u={get exports(){return qu},set exports(t){qu=t}},Ju=w,Ku=Fr,Qu=$n,tl=Q,el=Ju("".charAt),rl=Ju("".charCodeAt),nl=Ju("".slice),il=function(t){return function(e,r){var n,i,o=Qu(tl(e)),a=Ku(r),s=o.length;return a<0||a>=s?t?"":void 0:(n=rl(o,a))<55296||n>56319||a+1===s||(i=rl(o,a+1))<56320||i>57343?t?el(o,a):n:t?nl(o,a,a+2):i-56320+(n-55296<<10)+65536}},ol={codeAt:il(!1),charAt:il(!0)}.charAt,al=$n,sl=Ho,cl=iu,ul=ou,ll="String Iterator",hl=sl.set,fl=sl.getterFor(ll);cl(String,"String",(function(t){hl(this,{type:ll,string:al(t),index:0})}),(function(){var t,e=fl(this),r=e.string,n=e.index;return n>=r.length?ul(void 0,!0):(t=ol(r,n),e.index+=t.length,ul(t,!1))}));var pl=co.f("iterator");!function(t){t.exports=pl}($u),function(t){t.exports=qu}(Hu);var dl=n(Zu);function vl(t){return vl="function"==typeof Uu&&"symbol"==typeof dl?function(t){return typeof t}:function(t){return t&&"function"==typeof Uu&&t.constructor===Uu&&t!==Uu.prototype?"symbol":typeof t},vl(t)}var yl={},ml={get exports(){return yl},set exports(t){yl=t}},gl=Mt,xl=TypeError,bl=function(t,e){if(!delete t[e])throw xl("Cannot delete property "+gl(e)+" of "+gl(t))},wl=Ki,_l=Math.floor,Sl=function(t,e){var r=t.length,n=_l(r/2);return r<8?Tl(t,e):Cl(t,Sl(wl(t,0,n),e),Sl(wl(t,n),e),e)},Tl=function(t,e){for(var r,n,i=t.length,o=1;o<i;){for(n=o,r=t[o];n&&e(t[n-1],r)>0;)t[n]=t[--n];n!==o++&&(t[n]=r)}return t},Cl=function(t,e,r,n){for(var i=e.length,o=r.length,a=0,s=0;a<i||s<o;)t[a+s]=a<i&&s<o?n(e[a],r[s])<=0?e[a++]:r[s++]:a<i?e[a++]:r[s++];return t},Al=Sl,El=l,Ll=function(t,e){var r=[][t];return!!r&&El((function(){r.call(null,e||function(){return 1},1)}))},Ol=pt.match(/firefox\/(\d+)/i),Pl=!!Ol&&+Ol[1],Ml=/MSIE|Trident/.test(pt),Dl=pt.match(/AppleWebKit\/(\d+)\./),Rl=!!Dl&&+Dl[1],kl=Dr,Il=w,zl=It,jl=Qt,Fl=Yr,Bl=bl,Nl=$n,Wl=l,Yl=Al,Gl=Ll,Xl=Pl,Vl=Ml,Ul=bt,Zl=Rl,Hl=[],ql=Il(Hl.sort),$l=Il(Hl.push),Jl=Wl((function(){Hl.sort(void 0)})),Kl=Wl((function(){Hl.sort(null)})),Ql=Gl("sort"),th=!Wl((function(){if(Ul)return Ul<70;if(!(Xl&&Xl>3)){if(Vl)return!0;if(Zl)return Zl<603;var t,e,r,n,i="";for(t=65;t<76;t++){switch(e=String.fromCharCode(t),t){case 66:case 69:case 70:case 72:r=3;break;case 68:case 71:r=4;break;default:r=2}for(n=0;n<47;n++)Hl.push({k:e+n,v:r})}for(Hl.sort((function(t,e){return e.v-t.v})),n=0;n<Hl.length;n++)e=Hl[n].k.charAt(0),i.charAt(i.length-1)!==e&&(i+=e);return"DGBEFHACIJK"!==i}}));kl({target:"Array",proto:!0,forced:Jl||!Kl||!Ql||!th},{sort:function(t){void 0!==t&&zl(t);var e=jl(this);if(th)return void 0===t?ql(e):ql(e,t);var r,n,i=[],o=Fl(e);for(n=0;n<o;n++)n in e&&$l(i,e[n]);for(Yl(i,function(t){return function(e,r){return void 0===r?-1:void 0===e?1:void 0!==t?+t(e,r)||0:Nl(e)>Nl(r)?1:-1}}(t)),r=Fl(i),n=0;n<r;)e[n]=i[n++];for(;n<o;)Bl(e,n++);return e}});var eh=at,rh=function(t){return eh[t+"Prototype"]},nh=rh("Array").sort,ih=ft,oh=nh,ah=Array.prototype,sh=function(t){var e=t.sort;return t===ah||ih(ah,t)&&e===ah.sort?oh:e};!function(t){t.exports=sh}(ml);var ch=n(yl),uh={},lh={get exports(){return uh},set exports(t){uh=t}},hh=Dr,fh=ai.indexOf,ph=Ll,dh=L([].indexOf),vh=!!dh&&1/dh([1],1,-0)<0;hh({target:"Array",proto:!0,forced:vh||!ph("indexOf")},{indexOf:function(t){var e=arguments.length>1?arguments[1]:void 0;return vh?dh(this,t,e)||0:fh(this,t,e)}});var yh=rh("Array").indexOf,mh=ft,gh=yh,xh=Array.prototype,bh=function(t){var e=t.indexOf;return t===xh||mh(xh,t)&&e===xh.indexOf?gh:e};!function(t){t.exports=bh}(lh);var wh=n(uh),_h={},Sh={get exports(){return _h},set exports(t){_h=t}},Th=ra.filter;Dr({target:"Array",proto:!0,forced:!Rn("filter")},{filter:function(t){return Th(this,t,arguments.length>1?arguments[1]:void 0)}});var Ch=rh("Array").filter,Ah=ft,Eh=Ch,Lh=Array.prototype,Oh=function(t){var e=t.filter;return t===Lh||Ah(Lh,t)&&e===Lh.filter?Eh:e};!function(t){t.exports=Oh}(Sh);var Ph=n(_h),Mh={},Dh={get exports(){return Mh},set exports(t){Mh=t}},Rh="\t\n\v\f\r                　\u2028\u2029\ufeff",kh=Q,Ih=$n,zh=Rh,jh=w("".replace),Fh=RegExp("^["+zh+"]+"),Bh=RegExp("(^|[^"+zh+"])["+zh+"]+$"),Nh=function(t){return function(e){var r=Ih(kh(e));return 1&t&&(r=jh(r,Fh,"")),2&t&&(r=jh(r,Bh,"$1")),r}},Wh={start:Nh(1),end:Nh(2),trim:Nh(3)},Yh=u,Gh=l,Xh=$n,Vh=Wh.trim,Uh=Rh,Zh=w("".charAt),Hh=Yh.parseFloat,qh=Yh.Symbol,$h=qh&&qh.iterator,Jh=1/Hh(Uh+"-0")!=-1/0||$h&&!Gh((function(){Hh(Object($h))}))?function(t){var e=Vh(Xh(t)),r=Hh(e);return 0===r&&"-"==Zh(e,0)?-0:r}:Hh;Dr({global:!0,forced:parseFloat!=Jh},{parseFloat:Jh});var Kh=at.parseFloat;!function(t){t.exports=Kh}(Dh);var Qh=n(Mh),tf={},ef={get exports(){return tf},set exports(t){tf=t}},rf=Qt,nf=ei,of=Yr,af=function(t){for(var e=rf(this),r=of(e),n=arguments.length,i=nf(n>1?arguments[1]:void 0,r),o=n>2?arguments[2]:void 0,a=void 0===o?r:nf(o,r);a>i;)e[i++]=t;return e};Dr({target:"Array",proto:!0},{fill:af});var sf=rh("Array").fill,cf=ft,uf=sf,lf=Array.prototype,hf=function(t){var e=t.fill;return t===lf||cf(lf,t)&&e===lf.fill?uf:e};!function(t){t.exports=hf}(ef);var ff=n(tf),pf={},df={get exports(){return pf},set exports(t){pf=t}},vf=rh("Array").values,yf=nn,mf=re,gf=ft,xf=vf,bf=Array.prototype,wf={DOMTokenList:!0,NodeList:!0},_f=function(t){var e=t.values;return t===bf||gf(bf,t)&&e===bf.values||mf(wf,yf(t))?xf:e};!function(t){t.exports=_f}(df);var Sf=n(pf),Tf={},Cf={get exports(){return Tf},set exports(t){Tf=t}},Af=ra.forEach,Ef=Ll("forEach")?[].forEach:function(t){return Af(this,t,arguments.length>1?arguments[1]:void 0)};Dr({target:"Array",proto:!0,forced:[].forEach!=Ef},{forEach:Ef});var Lf=rh("Array").forEach,Of=nn,Pf=re,Mf=ft,Df=Lf,Rf=Array.prototype,kf={DOMTokenList:!0,NodeList:!0},If=function(t){var e=t.forEach;return t===Rf||Mf(Rf,t)&&e===Rf.forEach||Pf(kf,Of(t))?Df:e};!function(t){t.exports=If}(Cf);var zf=n(Tf),jf={},Ff={get exports(){return jf},set exports(t){jf=t}};Dr({target:"Array",stat:!0},{isArray:kr});var Bf=at.Array.isArray;!function(t){t.exports=Bf}(Ff);var Nf=n(jf),Wf={},Yf={get exports(){return Wf},set exports(t){Wf=t}};Dr({target:"Number",stat:!0},{isNaN:function(t){return t!=t}});var Gf=at.Number.isNaN;!function(t){t.exports=Gf}(Yf);var Xf=n(Wf),Vf={},Uf={get exports(){return Vf},set exports(t){Vf=t}},Zf=rh("Array").concat,Hf=ft,qf=Zf,$f=Array.prototype,Jf=function(t){var e=t.concat;return t===$f||Hf($f,t)&&e===$f.concat?qf:e};!function(t){t.exports=Jf}(Uf);var Kf=n(Vf),Qf={},tp={get exports(){return Qf},set exports(t){Qf=t}},ep="function"==typeof Bun&&Bun&&"string"==typeof Bun.version,rp=TypeError,np=u,ip=y,op=D,ap=ep,sp=pt,cp=As,up=function(t,e){if(t<e)throw rp("Not enough arguments");return t},lp=np.Function,hp=/MSIE .\./.test(sp)||ap&&function(){var t=np.Bun.version.split(".");return t.length<3||0==t[0]&&(t[1]<3||3==t[1]&&0==t[2])}(),fp=function(t,e){var r=e?2:1;return hp?function(n,i){var o=up(arguments.length,1)>r,a=op(n)?n:lp(n),s=o?cp(arguments,r):[],c=o?function(){ip(a,this,s)}:a;return e?t(c,i):t(c)}:t},pp=Dr,dp=u,vp=fp(dp.setInterval,!0);pp({global:!0,bind:!0,forced:dp.setInterval!==vp},{setInterval:vp});var yp=Dr,mp=u,gp=fp(mp.setTimeout,!0);yp({global:!0,bind:!0,forced:mp.setTimeout!==gp},{setTimeout:gp});var xp=at.setTimeout;!function(t){t.exports=xp}(tp);var bp=n(Qf),wp={},_p={get exports(){return wp},set exports(t){wp=t}},Sp=k,Tp=w,Cp=j,Ap=l,Ep=mi,Lp=io,Op=F,Pp=Qt,Mp=q,Dp=Object.assign,Rp=Object.defineProperty,kp=Tp([].concat),Ip=!Dp||Ap((function(){if(Sp&&1!==Dp({b:1},Dp(Rp({},"a",{enumerable:!0,get:function(){Rp(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},r=Symbol(),n="abcdefghijklmnopqrst";return t[r]=7,n.split("").forEach((function(t){e[t]=t})),7!=Dp({},t)[r]||Ep(Dp({},e)).join("")!=n}))?function(t,e){for(var r=Pp(t),n=arguments.length,i=1,o=Lp.f,a=Op.f;n>i;)for(var s,c=Mp(arguments[i++]),u=o?kp(Ep(c),o(c)):Ep(c),l=u.length,h=0;l>h;)s=u[h++],Sp&&!Cp(a,c,s)||(r[s]=c[s]);return r}:Dp,zp=Ip;Dr({target:"Object",stat:!0,arity:2,forced:Object.assign!==zp},{assign:zp});var jp=at.Object.assign;!function(t){t.exports=jp}(_p);var Fp=n(wp),Bp={};!function(t){function e(t){if(t)return function(t){for(var r in e.prototype)t[r]=e.prototype[r];return t}(t)}t.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function r(){this.off(t,r),e.apply(this,arguments)}return r.fn=e,this.on(t,r),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var r,n=this._callbacks["$"+t];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var i=0;i<n.length;i++)if((r=n[i])===e||r.fn===e){n.splice(i,1);break}return 0===n.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),r=this._callbacks["$"+t],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(r){n=0;for(var i=(r=r.slice(0)).length;n<i;++n)r[n].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}({get exports(){return Bp},set exports(t){Bp=t}});var Np=Bp,Wp={},Yp={get exports(){return Wp},set exports(t){Wp=t}},Gp=j,Xp=ar,Vp=Ft,Up=ar,Zp=function(t,e,r){var n,i;Xp(t);try{if(!(n=Vp(t,"return"))){if("throw"===e)throw r;return r}n=Gp(n,t)}catch(t){i=!0,n=t}if("throw"===e)throw r;if(i)throw n;return Xp(n),r},Hp=fc,qp=ye("iterator"),$p=Array.prototype,Jp=nn,Kp=Ft,Qp=$,td=fc,ed=ye("iterator"),rd=function(t){if(!Qp(t))return Kp(t,ed)||Kp(t,"@@iterator")||td[Jp(t)]},nd=j,id=It,od=ar,ad=Mt,sd=rd,cd=TypeError,ud=tr,ld=j,hd=Qt,fd=function(t,e,r,n){try{return n?e(Up(r)[0],r[1]):e(r)}catch(e){Zp(t,"throw",e)}},pd=function(t){return void 0!==t&&(Hp.Array===t||$p[qp]===t)},dd=_n,vd=Yr,yd=Hr,md=function(t,e){var r=arguments.length<2?sd(t):e;if(id(r))return od(nd(r,t));throw cd(ad(t)+" is not iterable")},gd=rd,xd=Array,bd=ye("iterator"),wd=!1;try{var _d=0,Sd={next:function(){return{done:!!_d++}},return:function(){wd=!0}};Sd[bd]=function(){return this},Array.from(Sd,(function(){throw 2}))}catch(t){}var Td=function(t){var e=hd(t),r=dd(this),n=arguments.length,i=n>1?arguments[1]:void 0,o=void 0!==i;o&&(i=ud(i,n>2?arguments[2]:void 0));var a,s,c,u,l,h,f=gd(e),p=0;if(!f||this===xd&&pd(f))for(a=vd(e),s=r?new this(a):xd(a);a>p;p++)h=o?i(e[p],p):e[p],yd(s,p,h);else for(l=(u=md(e,f)).next,s=r?new this:[];!(c=ld(l,u)).done;p++)h=o?fd(u,i,[c.value,p],!0):c.value,yd(s,p,h);return s.length=p,s},Cd=function(t,e){if(!e&&!wd)return!1;var r=!1;try{var n={};n[bd]=function(){return{next:function(){return{done:r=!0}}}},t(n)}catch(t){}return r};Dr({target:"Array",stat:!0,forced:!Cd((function(t){Array.from(t)}))},{from:Td});var Ad=at.Array.from;!function(t){t.exports=Ad}(Yp);var Ed=n(Wp),Ld={},Od={get exports(){return Ld},set exports(t){Ld=t}},Pd={},Md=rd;!function(t){t.exports=Md}({get exports(){return Pd},set exports(t){Pd=t}}),function(t){t.exports=Pd}(Od);var Dd=n(Ld),Rd={},kd={get exports(){return Rd},set exports(t){Rd=t}},Id=at.Object.getOwnPropertySymbols;!function(t){t.exports=Id}(kd);var zd={},jd={get exports(){return zd},set exports(t){zd=t}},Fd={},Bd={get exports(){return Fd},set exports(t){Fd=t}},Nd=Dr,Wd=l,Yd=rt,Gd=R.f,Xd=k;Nd({target:"Object",stat:!0,forced:!Xd||Wd((function(){Gd(1)})),sham:!Xd},{getOwnPropertyDescriptor:function(t,e){return Gd(Yd(t),e)}});var Vd=at.Object,Ud=Bd.exports=function(t,e){return Vd.getOwnPropertyDescriptor(t,e)};Vd.getOwnPropertyDescriptor.sham&&(Ud.sham=!0);var Zd=Fd;!function(t){t.exports=Zd}(jd);var Hd={},qd={get exports(){return Hd},set exports(t){Hd=t}},$d=ht,Jd=Gi,Kd=io,Qd=ar,tv=w([].concat),ev=$d("Reflect","ownKeys")||function(t){var e=Jd.f(Qd(t)),r=Kd.f;return r?tv(e,r(t)):e},rv=ev,nv=rt,iv=R,ov=Hr;Dr({target:"Object",stat:!0,sham:!k},{getOwnPropertyDescriptors:function(t){for(var e,r,n=nv(t),i=iv.f,o=rv(n),a={},s=0;o.length>s;)void 0!==(r=i(n,e=o[s++]))&&ov(a,e,r);return a}});var av=at.Object.getOwnPropertyDescriptors;!function(t){t.exports=av}(qd);var sv={},cv={get exports(){return sv},set exports(t){sv=t}},uv={},lv={get exports(){return uv},set exports(t){uv=t}},hv=Dr,fv=k,pv=Jn.f;hv({target:"Object",stat:!0,forced:Object.defineProperties!==pv,sham:!fv},{defineProperties:pv});var dv=at.Object,vv=lv.exports=function(t,e){return dv.defineProperties(t,e)};dv.defineProperties.sham&&(vv.sham=!0);var yv=uv;!function(t){t.exports=yv}(cv);var mv={},gv={get exports(){return mv},set exports(t){mv=t}},xv={},bv={get exports(){return xv},set exports(t){xv=t}},wv=Dr,_v=k,Sv=er.f;wv({target:"Object",stat:!0,forced:Object.defineProperty!==Sv,sham:!_v},{defineProperty:Sv});var Tv=at.Object,Cv=bv.exports=function(t,e,r){return Tv.defineProperty(t,e,r)};Tv.defineProperty.sham&&(Cv.sham=!0);var Av=xv;!function(t){t.exports=Av}(gv);var Ev={},Lv={get exports(){return Ev},set exports(t){Ev=t}},Ov={},Pv=Av;!function(t){t.exports=Pv}({get exports(){return Ov},set exports(t){Ov=t}}),function(t){t.exports=Ov}(Lv);var Mv=n(Ev),Dv={},Rv={get exports(){return Dv},set exports(t){Dv=t}},kv={},Iv={get exports(){return kv},set exports(t){kv=t}},zv=co.f("toPrimitive");!function(t){t.exports=zv}(Iv),function(t){t.exports=kv}(Rv);var jv=n(Dv);function Fv(t){var e=function(t,e){if("object"!==vl(t)||null===t)return t;var r=t[jv];if(void 0!==r){var n=r.call(t,e||"default");if("object"!==vl(n))return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===e?String:Number)(t)}(t,"string");return"symbol"===vl(e)?e:String(e)}function Bv(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Mv(t,Fv(n.key),n)}}var Nv={},Wv={get exports(){return Nv},set exports(t){Nv=t}},Yv={},Gv=Bf;!function(t){t.exports=Gv}({get exports(){return Yv},set exports(t){Yv=t}}),function(t){t.exports=Yv}(Wv);var Xv=n(Nv),Vv={},Uv={get exports(){return Vv},set exports(t){Vv=t}},Zv={},Hv={get exports(){return Zv},set exports(t){Zv=t}},qv=Dr,$v=kr,Jv=_n,Kv=ot,Qv=ei,ty=Yr,ey=rt,ry=Hr,ny=ye,iy=As,oy=Rn("slice"),ay=ny("species"),sy=Array,cy=Math.max;qv({target:"Array",proto:!0,forced:!oy},{slice:function(t,e){var r,n,i,o=ey(this),a=ty(o),s=Qv(t,a),c=Qv(void 0===e?a:e,a);if($v(o)&&(r=o.constructor,(Jv(r)&&(r===sy||$v(r.prototype))||Kv(r)&&null===(r=r[ay]))&&(r=void 0),r===sy||void 0===r))return iy(o,s,c);for(n=new(void 0===r?sy:r)(cy(c-s,0)),i=0;s<c;s++,i++)s in o&&ry(n,i,o[s]);return n.length=i,n}});var uy=rh("Array").slice,ly=ft,hy=uy,fy=Array.prototype,py=function(t){var e=t.slice;return t===fy||ly(fy,t)&&e===fy.slice?hy:e},dy=py;!function(t){t.exports=dy}(Hv),function(t){t.exports=Zv}(Uv);var vy=n(Vv),yy={},my={get exports(){return yy},set exports(t){yy=t}},gy={},xy=Ad;!function(t){t.exports=xy}({get exports(){return gy},set exports(t){gy=t}}),function(t){t.exports=gy}(my);var by=n(yy);function wy(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function _y(t){return function(t){if(Xv(t))return wy(t)}(t)||function(t){if(void 0!==Uu&&null!=Dd(t)||null!=t["@@iterator"])return by(t)}(t)||function(t,e){var r;if(t){if("string"==typeof t)return wy(t,e);var n=vy(r=Object.prototype.toString.call(t)).call(r,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?by(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?wy(t,e):void 0}}(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Sy={};!function(t){t.exports=Su}({get exports(){return Sy},set exports(t){Sy=t}});var Ty=n(Sy),Cy={};!function(t){t.exports=py}({get exports(){return Cy},set exports(t){Cy=t}});var Ay=n(Cy),Ey={},Ly={get exports(){return Ey},set exports(t){Ey=t}};Dr({target:"Reflect",stat:!0},{ownKeys:ev});var Oy=at.Reflect.ownKeys;!function(t){t.exports=Oy}(Ly);var Py={},My={get exports(){return Py},set exports(t){Py=t}},Dy=ra.map;Dr({target:"Array",proto:!0,forced:!Rn("map")},{map:function(t){return Dy(this,t,arguments.length>1?arguments[1]:void 0)}});var Ry=rh("Array").map,ky=ft,Iy=Ry,zy=Array.prototype,jy=function(t){var e=t.map;return t===zy||ky(zy,t)&&e===zy.map?Iy:e};!function(t){t.exports=jy}(My);var Fy=n(Py),By={},Ny={get exports(){return By},set exports(t){By=t}},Wy=Qt,Yy=mi;Dr({target:"Object",stat:!0,forced:l((function(){Yy(1)}))},{keys:function(t){return Yy(Wy(t))}});var Gy=at.Object.keys;!function(t){t.exports=Gy}(Ny);var Xy=n(By),Vy={},Uy={get exports(){return Vy},set exports(t){Vy=t}},Zy=Dr,Hy=Date,qy=w(Hy.prototype.getTime);Zy({target:"Date",stat:!0},{now:function(){return qy(new Hy)}});var $y=at.Date.now;!function(t){t.exports=$y}(Uy);var Jy={},Ky={get exports(){return Jy},set exports(t){Jy=t}},Qy=w,tm=It,em=ot,rm=re,nm=As,im=h,om=Function,am=Qy([].concat),sm=Qy([].join),cm={},um=function(t,e,r){if(!rm(cm,e)){for(var n=[],i=0;i<e;i++)n[i]="a["+i+"]";cm[e]=om("C,a","return new C("+sm(n,",")+")")}return cm[e](t,r)},lm=im?om.bind:function(t){var e=tm(this),r=e.prototype,n=nm(arguments,1),i=function(){var r=am(n,nm(arguments));return this instanceof i?um(e,r.length,r):e.apply(t,r)};return em(r)&&(i.prototype=r),i},hm=lm;Dr({target:"Function",proto:!0,forced:Function.bind!==hm},{bind:hm});var fm=rh("Function").bind,pm=ft,dm=fm,vm=Function.prototype,ym=function(t){var e=t.bind;return t===vm||pm(vm,t)&&e===vm.bind?dm:e};!function(t){t.exports=ym}(Ky);var mm=n(Jy),gm={},xm={get exports(){return gm},set exports(t){gm=t}},bm=Dr,wm=kr,_m=w([].reverse),Sm=[1,2];bm({target:"Array",proto:!0,forced:String(Sm)===String(Sm.reverse())},{reverse:function(){return wm(this)&&(this.length=this.length),_m(this)}});var Tm=rh("Array").reverse,Cm=ft,Am=Tm,Em=Array.prototype,Lm=function(t){var e=t.reverse;return t===Em||Cm(Em,t)&&e===Em.reverse?Am:e};!function(t){t.exports=Lm}(xm);var Om=n(gm),Pm={},Mm={get exports(){return Pm},set exports(t){Pm=t}},Dm=k,Rm=kr,km=TypeError,Im=Object.getOwnPropertyDescriptor,zm=Dm&&!function(){if(void 0!==this)return!0;try{Object.defineProperty([],"length",{writable:!1}).length=1}catch(t){return t instanceof TypeError}}(),jm=Dr,Fm=Qt,Bm=ei,Nm=Fr,Wm=Yr,Ym=zm?function(t,e){if(Rm(t)&&!Im(t,"length").writable)throw km("Cannot set read only .length");return t.length=e}:function(t,e){return t.length=e},Gm=Xr,Xm=On,Vm=Hr,Um=bl,Zm=Rn("splice"),Hm=Math.max,qm=Math.min;jm({target:"Array",proto:!0,forced:!Zm},{splice:function(t,e){var r,n,i,o,a,s,c=Fm(this),u=Wm(c),l=Bm(t,u),h=arguments.length;for(0===h?r=n=0:1===h?(r=0,n=u-l):(r=h-2,n=qm(Hm(Nm(e),0),u-l)),Gm(u+r-n),i=Xm(c,n),o=0;o<n;o++)(a=l+o)in c&&Vm(i,o,c[a]);if(i.length=n,r<n){for(o=l;o<u-n;o++)s=o+r,(a=o+n)in c?c[s]=c[a]:Um(c,s);for(o=u;o>u-n+r;o--)Um(c,o-1)}else if(r>n)for(o=u-n;o>l;o--)s=o+r-1,(a=o+n-1)in c?c[s]=c[a]:Um(c,s);for(o=0;o<r;o++)c[o+l]=arguments[o+2];return Ym(c,u-n+r),i}});var $m=rh("Array").splice,Jm=ft,Km=$m,Qm=Array.prototype,tg=function(t){var e=t.splice;return t===Qm||Jm(Qm,t)&&e===Qm.splice?Km:e};!function(t){t.exports=tg}(Mm);var eg=n(Pm),rg={},ng={get exports(){return rg},set exports(t){rg=t}},ig=ai.includes;Dr({target:"Array",proto:!0,forced:l((function(){return!Array(1).includes()}))},{includes:function(t){return ig(this,t,arguments.length>1?arguments[1]:void 0)}});var og=rh("Array").includes,ag=ot,sg=C,cg=ye("match"),ug=function(t){var e;return ag(t)&&(void 0!==(e=t[cg])?!!e:"RegExp"==sg(t))},lg=TypeError,hg=ye("match"),fg=Dr,pg=function(t){if(ug(t))throw lg("The method doesn't accept regular expressions");return t},dg=Q,vg=$n,yg=function(t){var e=/./;try{"/./"[t](e)}catch(r){try{return e[hg]=!1,"/./"[t](e)}catch(t){}}return!1},mg=w("".indexOf);fg({target:"String",proto:!0,forced:!yg("includes")},{includes:function(t){return!!~mg(vg(dg(this)),vg(pg(t)),arguments.length>1?arguments[1]:void 0)}});var gg=rh("String").includes,xg=ft,bg=og,wg=gg,_g=Array.prototype,Sg=String.prototype,Tg=function(t){var e=t.includes;return t===_g||xg(_g,t)&&e===_g.includes?bg:"string"==typeof t||t===Sg||xg(Sg,t)&&e===Sg.includes?wg:e};!function(t){t.exports=Tg}(ng);var Cg=n(rg),Ag={},Eg={get exports(){return Ag},set exports(t){Ag=t}},Lg=Qt,Og=Ec,Pg=xc;Dr({target:"Object",stat:!0,forced:l((function(){Og(1)})),sham:!Pg},{getPrototypeOf:function(t){return Og(Lg(t))}});var Mg=at.Object.getPrototypeOf;!function(t){t.exports=Mg}(Eg);var Dg=n(Ag),Rg={},kg={get exports(){return Rg},set exports(t){Rg=t}},Ig=k,zg=w,jg=mi,Fg=rt,Bg=zg(F.f),Ng=zg([].push),Wg=function(t){return function(e){for(var r,n=Fg(e),i=jg(n),o=i.length,a=0,s=[];o>a;)r=i[a++],Ig&&!Bg(n,r)||Ng(s,t?[r,n[r]]:n[r]);return s}},Yg={entries:Wg(!0),values:Wg(!1)}.values;Dr({target:"Object",stat:!0},{values:function(t){return Yg(t)}});var Gg=at.Object.values;!function(t){t.exports=Gg}(kg);var Xg={},Vg={get exports(){return Xg},set exports(t){Xg=t}},Ug=u,Zg=l,Hg=w,qg=$n,$g=Wh.trim,Jg=Rh,Kg=Ug.parseInt,Qg=Ug.Symbol,tx=Qg&&Qg.iterator,ex=/^[+-]?0x/i,rx=Hg(ex.exec),nx=8!==Kg(Jg+"08")||22!==Kg(Jg+"0x16")||tx&&!Zg((function(){Kg(Object(tx))}))?function(t,e){var r=$g(qg(t));return Kg(r,e>>>0||(rx(ex,r)?16:10))}:Kg;Dr({global:!0,forced:parseInt!=nx},{parseInt:nx});var ix=at.parseInt;!function(t){t.exports=ix}(Vg);var ox=n(Xg),ax={},sx={get exports(){return ax},set exports(t){ax=t}},cx=gc.PROPER,ux=l,lx=Rh,hx=Wh.trim;Dr({target:"String",proto:!0,forced:function(t){return ux((function(){return!!lx[t]()||"​᠎"!=="​᠎"[t]()||cx&&lx[t].name!==t}))}("trim")},{trim:function(){return hx(this)}});var fx=rh("String").trim,px=ft,dx=fx,vx=String.prototype,yx=function(t){var e=t.trim;return"string"==typeof t||t===vx||px(vx,t)&&e===vx.trim?dx:e};!function(t){t.exports=yx}(sx);var mx={},gx={get exports(){return mx},set exports(t){mx=t}};Dr({target:"Object",stat:!0,sham:!k},{create:Yi});var xx=at.Object,bx=function(t,e){return xx.create(t,e)};!function(t){t.exports=bx}(gx);var wx={},_x={get exports(){return wx},set exports(t){wx=t}},Sx=at,Tx=y;Sx.JSON||(Sx.JSON={stringify:JSON.stringify});var Cx=function(t,e,r){return Tx(Sx.JSON.stringify,null,arguments)},Ax=Cx;!function(t){t.exports=Ax}(_x);var Ex,Lx=n(wx);
/*! Hammer.JS - v2.0.17-rc - 2019-12-16
	 * http://naver.github.io/egjs
	 *
	 * Forked By Naver egjs
	 * Copyright (c) hammerjs
	 * Licensed under the MIT license */function Ox(){return Ox=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var r=arguments[e];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(t[n]=r[n])}return t},Ox.apply(this,arguments)}function Px(t,e){t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t.__proto__=e}function Mx(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}Ex="function"!=typeof Object.assign?function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),r=1;r<arguments.length;r++){var n=arguments[r];if(null!=n)for(var i in n)n.hasOwnProperty(i)&&(e[i]=n[i])}return e}:Object.assign;var Dx,Rx=Ex,kx=["","webkit","Moz","MS","ms","o"],Ix="undefined"==typeof document?{style:{}}:document.createElement("div"),zx="function",jx=Math.round,Fx=Math.abs,Bx=Date.now;function Nx(t,e){for(var r,n,i=e[0].toUpperCase()+e.slice(1),o=0;o<kx.length;){if((n=(r=kx[o])?r+i:e)in t)return n;o++}}Dx="undefined"==typeof window?{}:window;var Wx=Nx(Ix.style,"touchAction"),Yx=void 0!==Wx;var Gx="compute",Xx="auto",Vx="manipulation",Ux="none",Zx="pan-x",Hx="pan-y",qx=function(){if(!Yx)return!1;var t={},e=Dx.CSS&&Dx.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(r){return t[r]=!e||Dx.CSS.supports("touch-action",r)})),t}(),$x="ontouchstart"in Dx,Jx=void 0!==Nx(Dx,"PointerEvent"),Kx=$x&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),Qx="touch",tb="mouse",eb=25,rb=1,nb=2,ib=4,ob=8,ab=1,sb=2,cb=4,ub=8,lb=16,hb=sb|cb,fb=ub|lb,pb=hb|fb,db=["x","y"],vb=["clientX","clientY"];function yb(t,e,r){var n;if(t)if(t.forEach)t.forEach(e,r);else if(void 0!==t.length)for(n=0;n<t.length;)e.call(r,t[n],n,t),n++;else for(n in t)t.hasOwnProperty(n)&&e.call(r,t[n],n,t)}function mb(t,e){return typeof t===zx?t.apply(e&&e[0]||void 0,e):t}function gb(t,e){return t.indexOf(e)>-1}var xb=function(){function t(t,e){this.manager=t,this.set(e)}var e=t.prototype;return e.set=function(t){t===Gx&&(t=this.compute()),Yx&&this.manager.element.style&&qx[t]&&(this.manager.element.style[Wx]=t),this.actions=t.toLowerCase().trim()},e.update=function(){this.set(this.manager.options.touchAction)},e.compute=function(){var t=[];return yb(this.manager.recognizers,(function(e){mb(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(gb(t,Ux))return Ux;var e=gb(t,Zx),r=gb(t,Hx);return e&&r?Ux:e||r?e?Zx:Hx:gb(t,Vx)?Vx:Xx}(t.join(" "))},e.preventDefaults=function(t){var e=t.srcEvent,r=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var n=this.actions,i=gb(n,Ux)&&!qx[Ux],o=gb(n,Hx)&&!qx[Hx],a=gb(n,Zx)&&!qx[Zx];if(i){var s=1===t.pointers.length,c=t.distance<2,u=t.deltaTime<250;if(s&&c&&u)return}if(!a||!o)return i||o&&r&hb||a&&r&fb?this.preventSrc(e):void 0}},e.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},t}();function bb(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1}function wb(t){var e=t.length;if(1===e)return{x:jx(t[0].clientX),y:jx(t[0].clientY)};for(var r=0,n=0,i=0;i<e;)r+=t[i].clientX,n+=t[i].clientY,i++;return{x:jx(r/e),y:jx(n/e)}}function _b(t){for(var e=[],r=0;r<t.pointers.length;)e[r]={clientX:jx(t.pointers[r].clientX),clientY:jx(t.pointers[r].clientY)},r++;return{timeStamp:Bx(),pointers:e,center:wb(e),deltaX:t.deltaX,deltaY:t.deltaY}}function Sb(t,e,r){r||(r=db);var n=e[r[0]]-t[r[0]],i=e[r[1]]-t[r[1]];return Math.sqrt(n*n+i*i)}function Tb(t,e,r){r||(r=db);var n=e[r[0]]-t[r[0]],i=e[r[1]]-t[r[1]];return 180*Math.atan2(i,n)/Math.PI}function Cb(t,e){return t===e?ab:Fx(t)>=Fx(e)?t<0?sb:cb:e<0?ub:lb}function Ab(t,e,r){return{x:e/t||0,y:r/t||0}}function Eb(t,e){var r=t.session,n=e.pointers,i=n.length;r.firstInput||(r.firstInput=_b(e)),i>1&&!r.firstMultiple?r.firstMultiple=_b(e):1===i&&(r.firstMultiple=!1);var o=r.firstInput,a=r.firstMultiple,s=a?a.center:o.center,c=e.center=wb(n);e.timeStamp=Bx(),e.deltaTime=e.timeStamp-o.timeStamp,e.angle=Tb(s,c),e.distance=Sb(s,c),function(t,e){var r=e.center,n=t.offsetDelta||{},i=t.prevDelta||{},o=t.prevInput||{};e.eventType!==rb&&o.eventType!==ib||(i=t.prevDelta={x:o.deltaX||0,y:o.deltaY||0},n=t.offsetDelta={x:r.x,y:r.y}),e.deltaX=i.x+(r.x-n.x),e.deltaY=i.y+(r.y-n.y)}(r,e),e.offsetDirection=Cb(e.deltaX,e.deltaY);var u,l,h=Ab(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=h.x,e.overallVelocityY=h.y,e.overallVelocity=Fx(h.x)>Fx(h.y)?h.x:h.y,e.scale=a?(u=a.pointers,Sb((l=n)[0],l[1],vb)/Sb(u[0],u[1],vb)):1,e.rotation=a?function(t,e){return Tb(e[1],e[0],vb)+Tb(t[1],t[0],vb)}(a.pointers,n):0,e.maxPointers=r.prevInput?e.pointers.length>r.prevInput.maxPointers?e.pointers.length:r.prevInput.maxPointers:e.pointers.length,function(t,e){var r,n,i,o,a=t.lastInterval||e,s=e.timeStamp-a.timeStamp;if(e.eventType!==ob&&(s>eb||void 0===a.velocity)){var c=e.deltaX-a.deltaX,u=e.deltaY-a.deltaY,l=Ab(s,c,u);n=l.x,i=l.y,r=Fx(l.x)>Fx(l.y)?l.x:l.y,o=Cb(c,u),t.lastInterval=e}else r=a.velocity,n=a.velocityX,i=a.velocityY,o=a.direction;e.velocity=r,e.velocityX=n,e.velocityY=i,e.direction=o}(r,e);var f,p=t.element,d=e.srcEvent;bb(f=d.composedPath?d.composedPath()[0]:d.path?d.path[0]:d.target,p)&&(p=f),e.target=p}function Lb(t,e,r){var n=r.pointers.length,i=r.changedPointers.length,o=e&rb&&n-i==0,a=e&(ib|ob)&&n-i==0;r.isFirst=!!o,r.isFinal=!!a,o&&(t.session={}),r.eventType=e,Eb(t,r),t.emit("hammer.input",r),t.recognize(r),t.session.prevInput=r}function Ob(t){return t.trim().split(/\s+/g)}function Pb(t,e,r){yb(Ob(e),(function(e){t.addEventListener(e,r,!1)}))}function Mb(t,e,r){yb(Ob(e),(function(e){t.removeEventListener(e,r,!1)}))}function Db(t){var e=t.ownerDocument||t;return e.defaultView||e.parentWindow||window}var Rb=function(){function t(t,e){var r=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){mb(t.options.enable,[t])&&r.handler(e)},this.init()}var e=t.prototype;return e.handler=function(){},e.init=function(){this.evEl&&Pb(this.element,this.evEl,this.domHandler),this.evTarget&&Pb(this.target,this.evTarget,this.domHandler),this.evWin&&Pb(Db(this.element),this.evWin,this.domHandler)},e.destroy=function(){this.evEl&&Mb(this.element,this.evEl,this.domHandler),this.evTarget&&Mb(this.target,this.evTarget,this.domHandler),this.evWin&&Mb(Db(this.element),this.evWin,this.domHandler)},t}();function kb(t,e,r){if(t.indexOf&&!r)return t.indexOf(e);for(var n=0;n<t.length;){if(r&&t[n][r]==e||!r&&t[n]===e)return n;n++}return-1}var Ib={pointerdown:rb,pointermove:nb,pointerup:ib,pointercancel:ob,pointerout:ob},zb={2:Qx,3:"pen",4:tb,5:"kinect"},jb="pointerdown",Fb="pointermove pointerup pointercancel";Dx.MSPointerEvent&&!Dx.PointerEvent&&(jb="MSPointerDown",Fb="MSPointerMove MSPointerUp MSPointerCancel");var Bb=function(t){function e(){var r,n=e.prototype;return n.evEl=jb,n.evWin=Fb,(r=t.apply(this,arguments)||this).store=r.manager.session.pointerEvents=[],r}return Px(e,t),e.prototype.handler=function(t){var e=this.store,r=!1,n=t.type.toLowerCase().replace("ms",""),i=Ib[n],o=zb[t.pointerType]||t.pointerType,a=o===Qx,s=kb(e,t.pointerId,"pointerId");i&rb&&(0===t.button||a)?s<0&&(e.push(t),s=e.length-1):i&(ib|ob)&&(r=!0),s<0||(e[s]=t,this.callback(this.manager,i,{pointers:e,changedPointers:[t],pointerType:o,srcEvent:t}),r&&e.splice(s,1))},e}(Rb);function Nb(t){return Array.prototype.slice.call(t,0)}function Wb(t,e,r){for(var n=[],i=[],o=0;o<t.length;){var a=e?t[o][e]:t[o];kb(i,a)<0&&n.push(t[o]),i[o]=a,o++}return r&&(n=e?n.sort((function(t,r){return t[e]>r[e]})):n.sort()),n}var Yb={touchstart:rb,touchmove:nb,touchend:ib,touchcancel:ob},Gb="touchstart touchmove touchend touchcancel",Xb=function(t){function e(){var r;return e.prototype.evTarget=Gb,(r=t.apply(this,arguments)||this).targetIds={},r}return Px(e,t),e.prototype.handler=function(t){var e=Yb[t.type],r=Vb.call(this,t,e);r&&this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:Qx,srcEvent:t})},e}(Rb);function Vb(t,e){var r,n,i=Nb(t.touches),o=this.targetIds;if(e&(rb|nb)&&1===i.length)return o[i[0].identifier]=!0,[i,i];var a=Nb(t.changedTouches),s=[],c=this.target;if(n=i.filter((function(t){return bb(t.target,c)})),e===rb)for(r=0;r<n.length;)o[n[r].identifier]=!0,r++;for(r=0;r<a.length;)o[a[r].identifier]&&s.push(a[r]),e&(ib|ob)&&delete o[a[r].identifier],r++;return s.length?[Wb(n.concat(s),"identifier",!0),s]:void 0}var Ub={mousedown:rb,mousemove:nb,mouseup:ib},Zb="mousedown",Hb="mousemove mouseup",qb=function(t){function e(){var r,n=e.prototype;return n.evEl=Zb,n.evWin=Hb,(r=t.apply(this,arguments)||this).pressed=!1,r}return Px(e,t),e.prototype.handler=function(t){var e=Ub[t.type];e&rb&&0===t.button&&(this.pressed=!0),e&nb&&1!==t.which&&(e=ib),this.pressed&&(e&ib&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:tb,srcEvent:t}))},e}(Rb),$b=2500,Jb=25;function Kb(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var r={x:e.clientX,y:e.clientY},n=this.lastTouches;this.lastTouches.push(r);setTimeout((function(){var t=n.indexOf(r);t>-1&&n.splice(t,1)}),$b)}}function Qb(t,e){t&rb?(this.primaryTouch=e.changedPointers[0].identifier,Kb.call(this,e)):t&(ib|ob)&&Kb.call(this,e)}function tw(t){for(var e=t.srcEvent.clientX,r=t.srcEvent.clientY,n=0;n<this.lastTouches.length;n++){var i=this.lastTouches[n],o=Math.abs(e-i.x),a=Math.abs(r-i.y);if(o<=Jb&&a<=Jb)return!0}return!1}var ew=function(){return function(t){function e(e,r){var n;return(n=t.call(this,e,r)||this).handler=function(t,e,r){var i=r.pointerType===Qx,o=r.pointerType===tb;if(!(o&&r.sourceCapabilities&&r.sourceCapabilities.firesTouchEvents)){if(i)Qb.call(Mx(Mx(n)),e,r);else if(o&&tw.call(Mx(Mx(n)),r))return;n.callback(t,e,r)}},n.touch=new Xb(n.manager,n.handler),n.mouse=new qb(n.manager,n.handler),n.primaryTouch=null,n.lastTouches=[],n}return Px(e,t),e.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(Rb)}();function rw(t,e,r){return!!Array.isArray(t)&&(yb(t,r[e],r),!0)}var nw=1,iw=2,ow=4,aw=8,sw=aw,cw=16,uw=32,lw=1;function hw(t,e){var r=e.manager;return r?r.get(t):t}function fw(t){return t&cw?"cancel":t&aw?"end":t&ow?"move":t&iw?"start":""}var pw=function(){function t(t){void 0===t&&(t={}),this.options=Ox({enable:!0},t),this.id=lw++,this.manager=null,this.state=nw,this.simultaneous={},this.requireFail=[]}var e=t.prototype;return e.set=function(t){return Rx(this.options,t),this.manager&&this.manager.touchAction.update(),this},e.recognizeWith=function(t){if(rw(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=hw(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},e.dropRecognizeWith=function(t){return rw(t,"dropRecognizeWith",this)||(t=hw(t,this),delete this.simultaneous[t.id]),this},e.requireFailure=function(t){if(rw(t,"requireFailure",this))return this;var e=this.requireFail;return-1===kb(e,t=hw(t,this))&&(e.push(t),t.requireFailure(this)),this},e.dropRequireFailure=function(t){if(rw(t,"dropRequireFailure",this))return this;t=hw(t,this);var e=kb(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},e.hasRequireFailures=function(){return this.requireFail.length>0},e.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},e.emit=function(t){var e=this,r=this.state;function n(r){e.manager.emit(r,t)}r<aw&&n(e.options.event+fw(r)),n(e.options.event),t.additionalEvent&&n(t.additionalEvent),r>=aw&&n(e.options.event+fw(r))},e.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=uw},e.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(this.requireFail[t].state&(uw|nw)))return!1;t++}return!0},e.recognize=function(t){var e=Rx({},t);if(!mb(this.options.enable,[this,e]))return this.reset(),void(this.state=uw);this.state&(sw|cw|uw)&&(this.state=nw),this.state=this.process(e),this.state&(iw|ow|aw|cw)&&this.tryEmit(e)},e.process=function(t){},e.getTouchAction=function(){},e.reset=function(){},t}(),dw=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,Ox({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},e))||this).pTime=!1,r.pCenter=!1,r._timer=null,r._input=null,r.count=0,r}Px(e,t);var r=e.prototype;return r.getTouchAction=function(){return[Vx]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,i=t.distance<r.threshold,o=t.deltaTime<r.time;if(this.reset(),t.eventType&rb&&0===this.count)return this.failTimeout();if(i&&o&&n){if(t.eventType!==ib)return this.failTimeout();var a=!this.pTime||t.timeStamp-this.pTime<r.interval,s=!this.pCenter||Sb(this.pCenter,t.center)<r.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,s&&a?this.count+=1:this.count=1,this._input=t,0===this.count%r.taps)return this.hasRequireFailures()?(this._timer=setTimeout((function(){e.state=sw,e.tryEmit()}),r.interval),iw):sw}return uw},r.failTimeout=function(){var t=this;return this._timer=setTimeout((function(){t.state=uw}),this.options.interval),uw},r.reset=function(){clearTimeout(this._timer)},r.emit=function(){this.state===sw&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},e}(pw),vw=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Ox({pointers:1},e))||this}Px(e,t);var r=e.prototype;return r.attrTest=function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},r.process=function(t){var e=this.state,r=t.eventType,n=e&(iw|ow),i=this.attrTest(t);return n&&(r&ob||!i)?e|cw:n||i?r&ib?e|aw:e&iw?e|ow:iw:uw},e}(pw);function yw(t){return t===lb?"down":t===ub?"up":t===sb?"left":t===cb?"right":""}var mw=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,Ox({event:"pan",threshold:10,pointers:1,direction:pb},e))||this).pX=null,r.pY=null,r}Px(e,t);var r=e.prototype;return r.getTouchAction=function(){var t=this.options.direction,e=[];return t&hb&&e.push(Hx),t&fb&&e.push(Zx),e},r.directionTest=function(t){var e=this.options,r=!0,n=t.distance,i=t.direction,o=t.deltaX,a=t.deltaY;return i&e.direction||(e.direction&hb?(i=0===o?ab:o<0?sb:cb,r=o!==this.pX,n=Math.abs(t.deltaX)):(i=0===a?ab:a<0?ub:lb,r=a!==this.pY,n=Math.abs(t.deltaY))),t.direction=i,r&&n>e.threshold&&i&e.direction},r.attrTest=function(t){return vw.prototype.attrTest.call(this,t)&&(this.state&iw||!(this.state&iw)&&this.directionTest(t))},r.emit=function(e){this.pX=e.deltaX,this.pY=e.deltaY;var r=yw(e.direction);r&&(e.additionalEvent=this.options.event+r),t.prototype.emit.call(this,e)},e}(vw),gw=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Ox({event:"swipe",threshold:10,velocity:.3,direction:hb|fb,pointers:1},e))||this}Px(e,t);var r=e.prototype;return r.getTouchAction=function(){return mw.prototype.getTouchAction.call(this)},r.attrTest=function(e){var r,n=this.options.direction;return n&(hb|fb)?r=e.overallVelocity:n&hb?r=e.overallVelocityX:n&fb&&(r=e.overallVelocityY),t.prototype.attrTest.call(this,e)&&n&e.offsetDirection&&e.distance>this.options.threshold&&e.maxPointers===this.options.pointers&&Fx(r)>this.options.velocity&&e.eventType&ib},r.emit=function(t){var e=yw(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)},e}(vw),xw=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Ox({event:"pinch",threshold:0,pointers:2},e))||this}Px(e,t);var r=e.prototype;return r.getTouchAction=function(){return[Ux]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.scale-1)>this.options.threshold||this.state&iw)},r.emit=function(e){if(1!==e.scale){var r=e.scale<1?"in":"out";e.additionalEvent=this.options.event+r}t.prototype.emit.call(this,e)},e}(vw),bw=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Ox({event:"rotate",threshold:0,pointers:2},e))||this}Px(e,t);var r=e.prototype;return r.getTouchAction=function(){return[Ux]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.rotation)>this.options.threshold||this.state&iw)},e}(vw),ww=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,Ox({event:"press",pointers:1,time:251,threshold:9},e))||this)._timer=null,r._input=null,r}Px(e,t);var r=e.prototype;return r.getTouchAction=function(){return[Xx]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,i=t.distance<r.threshold,o=t.deltaTime>r.time;if(this._input=t,!i||!n||t.eventType&(ib|ob)&&!o)this.reset();else if(t.eventType&rb)this.reset(),this._timer=setTimeout((function(){e.state=sw,e.tryEmit()}),r.time);else if(t.eventType&ib)return sw;return uw},r.reset=function(){clearTimeout(this._timer)},r.emit=function(t){this.state===sw&&(t&&t.eventType&ib?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=Bx(),this.manager.emit(this.options.event,this._input)))},e}(pw),_w={domEvents:!1,touchAction:Gx,enable:!0,inputTarget:null,inputClass:null,cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}},Sw=[[bw,{enable:!1}],[xw,{enable:!1},["rotate"]],[gw,{direction:hb}],[mw,{direction:hb},["swipe"]],[dw],[dw,{event:"doubletap",taps:2},["tap"]],[ww]];function Tw(t,e){var r,n=t.element;n.style&&(yb(t.options.cssProps,(function(i,o){r=Nx(n.style,o),e?(t.oldCssProps[r]=n.style[r],n.style[r]=i):n.style[r]=t.oldCssProps[r]||""})),e||(t.oldCssProps={}))}var Cw=function(){function t(t,e){var r,n=this;this.options=Rx({},_w,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((r=this).options.inputClass||(Jx?Bb:Kx?Xb:$x?ew:qb))(r,Lb),this.touchAction=new xb(this,this.options.touchAction),Tw(this,!0),yb(this.options.recognizers,(function(t){var e=n.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}var e=t.prototype;return e.set=function(t){return Rx(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},e.stop=function(t){this.session.stopped=t?2:1},e.recognize=function(t){var e=this.session;if(!e.stopped){var r;this.touchAction.preventDefaults(t);var n=this.recognizers,i=e.curRecognizer;(!i||i&&i.state&sw)&&(e.curRecognizer=null,i=null);for(var o=0;o<n.length;)r=n[o],2===e.stopped||i&&r!==i&&!r.canRecognizeWith(i)?r.reset():r.recognize(t),!i&&r.state&(iw|ow|aw)&&(e.curRecognizer=r,i=r),o++}},e.get=function(t){if(t instanceof pw)return t;for(var e=this.recognizers,r=0;r<e.length;r++)if(e[r].options.event===t)return e[r];return null},e.add=function(t){if(rw(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},e.remove=function(t){if(rw(t,"remove",this))return this;var e=this.get(t);if(t){var r=this.recognizers,n=kb(r,e);-1!==n&&(r.splice(n,1),this.touchAction.update())}return this},e.on=function(t,e){if(void 0===t||void 0===e)return this;var r=this.handlers;return yb(Ob(t),(function(t){r[t]=r[t]||[],r[t].push(e)})),this},e.off=function(t,e){if(void 0===t)return this;var r=this.handlers;return yb(Ob(t),(function(t){e?r[t]&&r[t].splice(kb(r[t],e),1):delete r[t]})),this},e.emit=function(t,e){this.options.domEvents&&function(t,e){var r=document.createEvent("Event");r.initEvent(t,!0,!0),r.gesture=e,e.target.dispatchEvent(r)}(t,e);var r=this.handlers[t]&&this.handlers[t].slice();if(r&&r.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var n=0;n<r.length;)r[n](e),n++}},e.destroy=function(){this.element&&Tw(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},t}(),Aw={touchstart:rb,touchmove:nb,touchend:ib,touchcancel:ob},Ew="touchstart",Lw="touchstart touchmove touchend touchcancel",Ow=function(t){function e(){var r,n=e.prototype;return n.evTarget=Ew,n.evWin=Lw,(r=t.apply(this,arguments)||this).started=!1,r}return Px(e,t),e.prototype.handler=function(t){var e=Aw[t.type];if(e===rb&&(this.started=!0),this.started){var r=Pw.call(this,t,e);e&(ib|ob)&&r[0].length-r[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:Qx,srcEvent:t})}},e}(Rb);function Pw(t,e){var r=Nb(t.touches),n=Nb(t.changedTouches);return e&(ib|ob)&&(r=Wb(r.concat(n),"identifier",!0)),[r,n]}function Mw(t,e,r){var n="DEPRECATED METHOD: "+e+"\n"+r+" AT \n";return function(){var e=new Error("get-stack-trace"),r=e&&e.stack?e.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",i=window.console&&(window.console.warn||window.console.log);return i&&i.call(window.console,n,r),t.apply(this,arguments)}}var Dw=Mw((function(t,e,r){for(var n=Object.keys(e),i=0;i<n.length;)(!r||r&&void 0===t[n[i]])&&(t[n[i]]=e[n[i]]),i++;return t}),"extend","Use `assign`."),Rw=Mw((function(t,e){return Dw(t,e,!0)}),"merge","Use `assign`.");function kw(t,e,r){var n,i=e.prototype;(n=t.prototype=Object.create(i)).constructor=t,n._super=i,r&&Rx(n,r)}function Iw(t,e){return function(){return t.apply(e,arguments)}}var zw=function(){var t=function(t,e){return void 0===e&&(e={}),new Cw(t,Ox({recognizers:Sw.concat()},e))};return t.VERSION="2.0.17-rc",t.DIRECTION_ALL=pb,t.DIRECTION_DOWN=lb,t.DIRECTION_LEFT=sb,t.DIRECTION_RIGHT=cb,t.DIRECTION_UP=ub,t.DIRECTION_HORIZONTAL=hb,t.DIRECTION_VERTICAL=fb,t.DIRECTION_NONE=ab,t.DIRECTION_DOWN=lb,t.INPUT_START=rb,t.INPUT_MOVE=nb,t.INPUT_END=ib,t.INPUT_CANCEL=ob,t.STATE_POSSIBLE=nw,t.STATE_BEGAN=iw,t.STATE_CHANGED=ow,t.STATE_ENDED=aw,t.STATE_RECOGNIZED=sw,t.STATE_CANCELLED=cw,t.STATE_FAILED=uw,t.Manager=Cw,t.Input=Rb,t.TouchAction=xb,t.TouchInput=Xb,t.MouseInput=qb,t.PointerEventInput=Bb,t.TouchMouseInput=ew,t.SingleTouchInput=Ow,t.Recognizer=pw,t.AttrRecognizer=vw,t.Tap=dw,t.Pan=mw,t.Swipe=gw,t.Pinch=xw,t.Rotate=bw,t.Press=ww,t.on=Pb,t.off=Mb,t.each=yb,t.merge=Rw,t.extend=Dw,t.bindFn=Iw,t.assign=Rx,t.inherit=kw,t.bindFn=Iw,t.prefixed=Nx,t.toArray=Nb,t.inArray=kb,t.uniqueArray=Wb,t.splitStr=Ob,t.boolOrFn=mb,t.hasParent=bb,t.addEventListeners=Pb,t.removeEventListeners=Mb,t.defaults=Rx({},_w,{preset:Sw}),t}();function jw(t,e){var r=void 0!==Ty&&Dd(t)||t["@@iterator"];if(!r){if(Nf(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Fw(t,e);var n=Ay(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Ed(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Fw(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,s=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){s=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw o}}}}function Fw(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}Ty("DELETE");var Bw="undefined"!=typeof window?window.Hammer||zw:function(){return function(){var t=function(){};return{on:t,off:t,destroy:t,emit:t,get:function(){return{set:t}}}}()};function Nw(t){var e,r=this;this._cleanupQueue=[],this.active=!1,this._dom={container:t,overlay:document.createElement("div")},this._dom.overlay.classList.add("vis-overlay"),this._dom.container.appendChild(this._dom.overlay),this._cleanupQueue.push((function(){r._dom.overlay.parentNode.removeChild(r._dom.overlay)}));var n=Bw(this._dom.overlay);n.on("tap",mm(e=this._onTapOverlay).call(e,this)),this._cleanupQueue.push((function(){n.destroy()}));var i=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];zf(i).call(i,(function(t){n.on(t,(function(t){t.srcEvent.stopPropagation()}))})),document&&document.body&&(this._onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||r.deactivate()},document.body.addEventListener("click",this._onClick),this._cleanupQueue.push((function(){document.body.removeEventListener("click",r._onClick)}))),this._escListener=function(t){("key"in t?"Escape"===t.key:27===t.keyCode)&&r.deactivate()}}Np(Nw.prototype),Nw.current=null,Nw.prototype.destroy=function(){var t,e;this.deactivate();var r,n=jw(Om(t=eg(e=this._cleanupQueue).call(e,0)).call(t));try{for(n.s();!(r=n.n()).done;){(0,r.value)()}}catch(t){n.e(t)}finally{n.f()}},Nw.prototype.activate=function(){Nw.current&&Nw.current.deactivate(),Nw.current=this,this.active=!0,this._dom.overlay.style.display="none",this._dom.container.classList.add("vis-active"),this.emit("change"),this.emit("activate"),document.body.addEventListener("keydown",this._escListener)},Nw.prototype.deactivate=function(){this.active=!1,this._dom.overlay.style.display="block",this._dom.container.classList.remove("vis-active"),document.body.removeEventListener("keydown",this._escListener),this.emit("change"),this.emit("deactivate")},Nw.prototype._onTapOverlay=function(t){this.activate(),t.srcEvent.stopPropagation()};var Ww=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,Yw=/^#?([a-f\d])([a-f\d])([a-f\d])$/i;function Gw(t,e,r,n){var i=!1;!0===n&&(i=null===e[r]&&void 0!==t[r]),i?delete t[r]:t[r]=e[r]}function Xw(t,e){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var i in e)if(Object.prototype.hasOwnProperty.call(e,i)||!0===r)if("object"===vl(e[i])&&null!==e[i]&&Dg(e[i])===Object.prototype)void 0===t[i]?t[i]=Xw({},e[i],r):"object"===vl(t[i])&&null!==t[i]&&Dg(t[i])===Object.prototype?Xw(t[i],e[i],r):Gw(t,e,i,n);else if(Nf(e[i])){var o;t[i]=Ay(o=e[i]).call(o)}else Gw(t,e,i,n);return t}function Vw(t,e){var r;return Kf(r=[]).call(r,_y(t),[e])}function Uw(t,e,r,n){var i;t.addEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&Cg(i=navigator.userAgent).call(i,"Firefox")&&(e="DOMMouseScroll"),t.addEventListener(e,r,n)):t.attachEvent("on"+e,r)}function Zw(t,e,r,n){var i;t.removeEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&Cg(i=navigator.userAgent).call(i,"Firefox")&&(e="DOMMouseScroll"),t.removeEventListener(e,r,n)):t.detachEvent("on"+e,r)}function Hw(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)}function qw(t,e,r){var n,i,o,a=Math.floor(6*t),s=6*t-a,c=r*(1-e),u=r*(1-s*e),l=r*(1-(1-s)*e);switch(a%6){case 0:n=r,i=l,o=c;break;case 1:n=u,i=r,o=c;break;case 2:n=c,i=r,o=l;break;case 3:n=c,i=u,o=r;break;case 4:n=l,i=c,o=r;break;case 5:n=r,i=c,o=u}return{r:Math.floor(255*n),g:Math.floor(255*i),b:Math.floor(255*o)}}var $w,Jw=!1,Kw="background: #FFeeee; color: #dd0000",Qw=function(){function t(){!function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,t)}var e,r,n;return e=t,n=[{key:"validate",value:function(e,r,n){Jw=!1,$w=r;var i=r;return void 0!==n&&(i=r[n]),t.parse(e,i,[]),Jw}},{key:"parse",value:function(e,r,n){for(var i in e)Object.prototype.hasOwnProperty.call(e,i)&&t.check(i,e,r,n)}},{key:"check",value:function(e,r,n,i){if(void 0!==n[e]||void 0!==n.__any__){var o=e,a=!0;void 0===n[e]&&void 0!==n.__any__&&(o="__any__",a="object"===t.getType(r[e]));var s=n[o];a&&void 0!==s.__type__&&(s=s.__type__),t.checkFields(e,r,n,o,s,i)}else t.getSuggestion(e,n,i)}},{key:"checkFields",value:function(e,r,n,i,o,a){var s=function(r){console.error("%c"+r+t.printLocation(a,e),Kw)},c=t.getType(r[e]),u=o[c];void 0!==u?"array"===t.getType(u)&&-1===wh(u).call(u,r[e])?(s('Invalid option detected in "'+e+'". Allowed values are:'+t.print(u)+' not "'+r[e]+'". '),Jw=!0):"object"===c&&"__any__"!==i&&(a=Vw(a,e),t.parse(r[e],n[i],a)):void 0===o.any&&(s('Invalid type received for "'+e+'". Expected: '+t.print(Xy(o))+". Received ["+c+'] "'+r[e]+'"'),Jw=!0)}},{key:"getType",value:function(t){var e=vl(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":Nf(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,r,n){var i,o=t.findInOptions(e,r,n,!1),a=t.findInOptions(e,$w,[],!0);i=void 0!==o.indexMatch?" in "+t.printLocation(o.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+o.indexMatch+'"?\n\n':a.distance<=4&&o.distance>a.distance?" in "+t.printLocation(o.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(a.path,a.closestMatch,""):o.distance<=8?'. Did you mean "'+o.closestMatch+'"?'+t.printLocation(o.path,e):". Did you mean one of these: "+t.print(Xy(r))+t.printLocation(n,e),console.error('%cUnknown option detected: "'+e+'"'+i,Kw),Jw=!0}},{key:"findInOptions",value:function(e,r,n){var i,o=arguments.length>3&&void 0!==arguments[3]&&arguments[3],a=1e9,s="",c=[],u=e.toLowerCase(),l=void 0;for(var h in r){var f=void 0;if(void 0!==r[h].__type__&&!0===o){var p=t.findInOptions(e,r[h],Vw(n,h));a>p.distance&&(s=p.closestMatch,c=p.path,a=p.distance,l=p.indexMatch)}else{var d;-1!==wh(d=h.toLowerCase()).call(d,u)&&(l=h),a>(f=t.levenshteinDistance(e,h))&&(s=h,c=Ay(i=n).call(i),a=f)}}return{closestMatch:s,path:c,distance:a,indexMatch:l}}},{key:"printLocation",value:function(t,e){for(var r="\n\n"+(arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n")+"options = {\n",n=0;n<t.length;n++){for(var i=0;i<n+1;i++)r+="  ";r+=t[n]+": {\n"}for(var o=0;o<t.length+1;o++)r+="  ";r+=e+"\n";for(var a=0;a<t.length+1;a++){for(var s=0;s<t.length-a;s++)r+="  ";r+="}\n"}return r+"\n\n"}},{key:"print",value:function(t){return Lx(t).replace(/(")|(\[)|(\])|(,"__type__")/g,"").replace(/(,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var r,n,i=[];for(r=0;r<=e.length;r++)i[r]=[r];for(n=0;n<=t.length;n++)i[0][n]=n;for(r=1;r<=e.length;r++)for(n=1;n<=t.length;n++)e.charAt(r-1)==t.charAt(n-1)?i[r][n]=i[r-1][n-1]:i[r][n]=Math.min(i[r-1][n-1]+1,Math.min(i[r][n-1]+1,i[r-1][n]+1));return i[e.length][t.length]}}],(r=null)&&Bv(e.prototype,r),n&&Bv(e,n),Mv(e,"prototype",{writable:!1}),t}(),t_=Kw,e_=Qw;function r_(t,e,r){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0,this.z=void 0!==r?r:0}r_.subtract=function(t,e){var r=new r_;return r.x=t.x-e.x,r.y=t.y-e.y,r.z=t.z-e.z,r},r_.add=function(t,e){var r=new r_;return r.x=t.x+e.x,r.y=t.y+e.y,r.z=t.z+e.z,r},r_.avg=function(t,e){return new r_((t.x+e.x)/2,(t.y+e.y)/2,(t.z+e.z)/2)},r_.scalarProduct=function(t,e){return new r_(t.x*e,t.y*e,t.z*e)},r_.dotProduct=function(t,e){return t.x*e.x+t.y*e.y+t.z*e.z},r_.crossProduct=function(t,e){var r=new r_;return r.x=t.y*e.z-t.z*e.y,r.y=t.z*e.x-t.x*e.z,r.z=t.x*e.y-t.y*e.x,r},r_.prototype.length=function(){return Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z)},r_.prototype.normalize=function(){return r_.scalarProduct(this,1/this.length())};var n_=r_;var i_=function(t,e){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0};function o_(t,e){if(void 0===t)throw new Error("No container element defined");if(this.container=t,this.visible=!e||null==e.visible||e.visible,this.visible){this.frame=document.createElement("DIV"),this.frame.style.width="100%",this.frame.style.position="relative",this.container.appendChild(this.frame),this.frame.prev=document.createElement("INPUT"),this.frame.prev.type="BUTTON",this.frame.prev.value="Prev",this.frame.appendChild(this.frame.prev),this.frame.play=document.createElement("INPUT"),this.frame.play.type="BUTTON",this.frame.play.value="Play",this.frame.appendChild(this.frame.play),this.frame.next=document.createElement("INPUT"),this.frame.next.type="BUTTON",this.frame.next.value="Next",this.frame.appendChild(this.frame.next),this.frame.bar=document.createElement("INPUT"),this.frame.bar.type="BUTTON",this.frame.bar.style.position="absolute",this.frame.bar.style.border="1px solid red",this.frame.bar.style.width="100px",this.frame.bar.style.height="6px",this.frame.bar.style.borderRadius="2px",this.frame.bar.style.MozBorderRadius="2px",this.frame.bar.style.border="1px solid #7F7F7F",this.frame.bar.style.backgroundColor="#E5E5E5",this.frame.appendChild(this.frame.bar),this.frame.slide=document.createElement("INPUT"),this.frame.slide.type="BUTTON",this.frame.slide.style.margin="0px",this.frame.slide.value=" ",this.frame.slide.style.position="relative",this.frame.slide.style.left="-100px",this.frame.appendChild(this.frame.slide);var r=this;this.frame.slide.onmousedown=function(t){r._onMouseDown(t)},this.frame.prev.onclick=function(t){r.prev(t)},this.frame.play.onclick=function(t){r.togglePlay(t)},this.frame.next.onclick=function(t){r.next(t)}}this.onChangeCallback=void 0,this.values=[],this.index=void 0,this.playTimeout=void 0,this.playInterval=1e3,this.playLoop=!0}function a_(t,e,r,n){this._start=0,this._end=0,this._step=1,this.prettyStep=!0,this.precision=5,this._current=0,this.setRange(t,e,r,n)}o_.prototype.prev=function(){var t=this.getIndex();t>0&&(t--,this.setIndex(t))},o_.prototype.next=function(){var t=this.getIndex();t<Sf(this).length-1&&(t++,this.setIndex(t))},o_.prototype.playNext=function(){var t=new Date,e=this.getIndex();e<Sf(this).length-1?(e++,this.setIndex(e)):this.playLoop&&(e=0,this.setIndex(e));var r=new Date-t,n=Math.max(this.playInterval-r,0),i=this;this.playTimeout=bp((function(){i.playNext()}),n)},o_.prototype.togglePlay=function(){void 0===this.playTimeout?this.play():this.stop()},o_.prototype.play=function(){this.playTimeout||(this.playNext(),this.frame&&(this.frame.play.value="Stop"))},o_.prototype.stop=function(){clearInterval(this.playTimeout),this.playTimeout=void 0,this.frame&&(this.frame.play.value="Play")},o_.prototype.setOnChangeCallback=function(t){this.onChangeCallback=t},o_.prototype.setPlayInterval=function(t){this.playInterval=t},o_.prototype.getPlayInterval=function(){return this.playInterval},o_.prototype.setPlayLoop=function(t){this.playLoop=t},o_.prototype.onChange=function(){void 0!==this.onChangeCallback&&this.onChangeCallback()},o_.prototype.redraw=function(){if(this.frame){this.frame.bar.style.top=this.frame.clientHeight/2-this.frame.bar.offsetHeight/2+"px",this.frame.bar.style.width=this.frame.clientWidth-this.frame.prev.clientWidth-this.frame.play.clientWidth-this.frame.next.clientWidth-30+"px";var t=this.indexToLeft(this.index);this.frame.slide.style.left=t+"px"}},o_.prototype.setValues=function(t){this.values=t,Sf(this).length>0?this.setIndex(0):this.index=void 0},o_.prototype.setIndex=function(t){if(!(t<Sf(this).length))throw new Error("Index out of range");this.index=t,this.redraw(),this.onChange()},o_.prototype.getIndex=function(){return this.index},o_.prototype.get=function(){return Sf(this)[this.index]},o_.prototype._onMouseDown=function(t){if(t.which?1===t.which:1===t.button){this.startClientX=t.clientX,this.startSlideX=Qh(this.frame.slide.style.left),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},Uw(document,"mousemove",this.onmousemove),Uw(document,"mouseup",this.onmouseup),Hw(t)}},o_.prototype.leftToIndex=function(t){var e=Qh(this.frame.bar.style.width)-this.frame.slide.clientWidth-10,r=t-3,n=Math.round(r/e*(Sf(this).length-1));return n<0&&(n=0),n>Sf(this).length-1&&(n=Sf(this).length-1),n},o_.prototype.indexToLeft=function(t){var e=Qh(this.frame.bar.style.width)-this.frame.slide.clientWidth-10;return t/(Sf(this).length-1)*e+3},o_.prototype._onMouseMove=function(t){var e=t.clientX-this.startClientX,r=this.startSlideX+e,n=this.leftToIndex(r);this.setIndex(n),Hw()},o_.prototype._onMouseUp=function(){this.frame.style.cursor="auto",Zw(document,"mousemove",this.onmousemove),Zw(document,"mouseup",this.onmouseup),Hw()},a_.prototype.isNumeric=function(t){return!isNaN(Qh(t))&&isFinite(t)},a_.prototype.setRange=function(t,e,r,n){if(!this.isNumeric(t))throw new Error("Parameter 'start' is not numeric; value: "+t);if(!this.isNumeric(e))throw new Error("Parameter 'end' is not numeric; value: "+t);if(!this.isNumeric(r))throw new Error("Parameter 'step' is not numeric; value: "+t);this._start=t||0,this._end=e||0,this.setStep(r,n)},a_.prototype.setStep=function(t,e){void 0===t||t<=0||(void 0!==e&&(this.prettyStep=e),!0===this.prettyStep?this._step=a_.calculatePrettyStep(t):this._step=t)},a_.calculatePrettyStep=function(t){var e=function(t){return Math.log(t)/Math.LN10},r=Math.pow(10,Math.round(e(t))),n=2*Math.pow(10,Math.round(e(t/2))),i=5*Math.pow(10,Math.round(e(t/5))),o=r;return Math.abs(n-t)<=Math.abs(o-t)&&(o=n),Math.abs(i-t)<=Math.abs(o-t)&&(o=i),o<=0&&(o=1),o},a_.prototype.getCurrent=function(){return Qh(this._current.toPrecision(this.precision))},a_.prototype.getStep=function(){return this._step},a_.prototype.start=function(t){void 0===t&&(t=!1),this._current=this._start-this._start%this._step,t&&this.getCurrent()<this._start&&this.next()},a_.prototype.next=function(){this._current+=this._step},a_.prototype.end=function(){return this._current>this._end};var s_=a_,c_={},u_={get exports(){return c_},set exports(t){c_=t}};Dr({target:"Math",stat:!0},{sign:Math.sign||function(t){var e=+t;return 0==e||e!=e?e:e<0?-1:1}});var l_=at.Math.sign;!function(t){t.exports=l_}(u_);var h_=n(c_);function f_(){this.armLocation=new n_,this.armRotation={},this.armRotation.horizontal=0,this.armRotation.vertical=0,this.armLength=1.7,this.cameraOffset=new n_,this.offsetMultiplier=.6,this.cameraLocation=new n_,this.cameraRotation=new n_(.5*Math.PI,0,0),this.calculateCameraOrientation()}f_.prototype.setOffset=function(t,e){var r=Math.abs,n=h_,i=this.offsetMultiplier,o=this.armLength*i;r(t)>o&&(t=n(t)*o),r(e)>o&&(e=n(e)*o),this.cameraOffset.x=t,this.cameraOffset.y=e,this.calculateCameraOrientation()},f_.prototype.getOffset=function(){return this.cameraOffset},f_.prototype.setArmLocation=function(t,e,r){this.armLocation.x=t,this.armLocation.y=e,this.armLocation.z=r,this.calculateCameraOrientation()},f_.prototype.setArmRotation=function(t,e){void 0!==t&&(this.armRotation.horizontal=t),void 0!==e&&(this.armRotation.vertical=e,this.armRotation.vertical<0&&(this.armRotation.vertical=0),this.armRotation.vertical>.5*Math.PI&&(this.armRotation.vertical=.5*Math.PI)),void 0===t&&void 0===e||this.calculateCameraOrientation()},f_.prototype.getArmRotation=function(){var t={};return t.horizontal=this.armRotation.horizontal,t.vertical=this.armRotation.vertical,t},f_.prototype.setArmLength=function(t){void 0!==t&&(this.armLength=t,this.armLength<.71&&(this.armLength=.71),this.armLength>5&&(this.armLength=5),this.setOffset(this.cameraOffset.x,this.cameraOffset.y),this.calculateCameraOrientation())},f_.prototype.getArmLength=function(){return this.armLength},f_.prototype.getCameraLocation=function(){return this.cameraLocation},f_.prototype.getCameraRotation=function(){return this.cameraRotation},f_.prototype.calculateCameraOrientation=function(){this.cameraLocation.x=this.armLocation.x-this.armLength*Math.sin(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.y=this.armLocation.y-this.armLength*Math.cos(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.z=this.armLocation.z+this.armLength*Math.sin(this.armRotation.vertical),this.cameraRotation.x=Math.PI/2-this.armRotation.vertical,this.cameraRotation.y=0,this.cameraRotation.z=-this.armRotation.horizontal;var t=this.cameraRotation.x,e=this.cameraRotation.z,r=this.cameraOffset.x,n=this.cameraOffset.y,i=Math.sin,o=Math.cos;this.cameraLocation.x=this.cameraLocation.x+r*o(e)+n*-i(e)*o(t),this.cameraLocation.y=this.cameraLocation.y+r*i(e)+n*o(e)*o(t),this.cameraLocation.z=this.cameraLocation.z+n*i(t)};var p_={BAR:0,BARCOLOR:1,BARSIZE:2,DOT:3,DOTLINE:4,DOTCOLOR:5,DOTSIZE:6,GRID:7,LINE:8,SURFACE:9},d_={dot:p_.DOT,"dot-line":p_.DOTLINE,"dot-color":p_.DOTCOLOR,"dot-size":p_.DOTSIZE,line:p_.LINE,grid:p_.GRID,surface:p_.SURFACE,bar:p_.BAR,"bar-color":p_.BARCOLOR,"bar-size":p_.BARSIZE},v_=["width","height","filterLabel","legendLabel","xLabel","yLabel","zLabel","xValueLabel","yValueLabel","zValueLabel","showXAxis","showYAxis","showZAxis","showGrayBottom","showGrid","showPerspective","showShadow","showSurfaceGrid","keepAspectRatio","rotateAxisLabels","verticalRatio","dotSizeRatio","dotSizeMinFraction","dotSizeMaxFraction","showAnimationControls","animationInterval","animationPreload","animationAutoStart","axisColor","axisFontSize","axisFontType","gridColor","xCenter","yCenter","zoomable","tooltipDelay","ctrlToZoom"],y_=["xBarWidth","yBarWidth","valueMin","valueMax","xMin","xMax","xStep","yMin","yMax","yStep","zMin","zMax","zStep"],m_=void 0;function g_(t){for(var e in t)if(Object.prototype.hasOwnProperty.call(t,e))return!1;return!0}function x_(t,e){return void 0===t||""===t?e:t+(void 0===(r=e)||""===r||"string"!=typeof r?r:r.charAt(0).toUpperCase()+Ay(r).call(r,1));var r}function b_(t,e,r,n){for(var i,o=0;o<r.length;++o)e[x_(n,i=r[o])]=t[i]}function w_(t,e,r,n){for(var i,o=0;o<r.length;++o)void 0!==t[i=r[o]]&&(e[x_(n,i)]=t[i])}function __(t,e){if(void 0!==t.backgroundColor&&function(t,e){var r="white",n="gray",i=1;if("string"==typeof t)r=t,n="none",i=0;else{if("object"!==vl(t))throw new Error("Unsupported type of backgroundColor");void 0!==ff(t)&&(r=ff(t)),void 0!==t.stroke&&(n=t.stroke),void 0!==t.strokeWidth&&(i=t.strokeWidth)}e.frame.style.backgroundColor=r,e.frame.style.borderColor=n,e.frame.style.borderWidth=i+"px",e.frame.style.borderStyle="solid"}(t.backgroundColor,e),function(t,e){if(void 0===t)return;void 0===e.dataColor&&(e.dataColor={});"string"==typeof t?(e.dataColor.fill=t,e.dataColor.stroke=t):(ff(t)&&(e.dataColor.fill=ff(t)),t.stroke&&(e.dataColor.stroke=t.stroke),void 0!==t.strokeWidth&&(e.dataColor.strokeWidth=t.strokeWidth))}(t.dataColor,e),function(t,e){if(void 0===t)return;var r;if("string"==typeof t){if(r=function(t){var e=d_[t];if(void 0===e)return-1;return e}(t),-1===r)throw new Error("Style '"+t+"' is invalid")}else{if(!function(t){var e=!1;for(var r in p_)if(p_[r]===t){e=!0;break}return e}(t))throw new Error("Style '"+t+"' is invalid");r=t}e.style=r}(t.style,e),void 0!==t.surfaceColors){if(console.warn("`options.surfaceColors` is deprecated and may be removed in a future version. Please use `options.colormap` instead. Note that the `colormap` option uses the inverse array ordering (running from vMin to vMax)."),void 0!==t.colormap)throw new Error("The `colormap` and `surfaceColors` options are mutually exclusive.");"surface"!==e.style?console.warn("Ignoring `surfaceColors` in graph style `"+e.style+"` for backward compatibility (only effective in `surface` plots)."):function(t,e){if(void 0===t||!0===t)return;if(!1===t)return void(e.surfaceColors=void 0);void 0===e.surfaceColors&&(e.surfaceColors={});var r;if(Nf(t))r=S_(t);else{if("object"!==vl(t))throw new Error("Unsupported type of surfaceColors");r=T_(t.hue)}Om(r).call(r),e.colormap=r}(t.surfaceColors,e)}else!function(t,e){if(void 0===t)return;var r;if(Nf(t))r=S_(t);else if("object"===vl(t))r=T_(t.hue);else{if("function"!=typeof t)throw new Error("Unsupported type of colormap");r=t}e.colormap=r}(t.colormap,e);!function(t,e){if(void 0===t){if(void 0===m_.showLegend){var r=e.style===p_.DOTCOLOR||e.style===p_.DOTSIZE;e.showLegend=r}}else e.showLegend=t}(t.showLegend,e),C_(t.cameraPosition,e),void 0!==t.tooltip&&(e.showTooltip=t.tooltip),null!=t.onclick&&(e.onclick_callback=t.onclick,console.warn("`options.onclick` is deprecated and may be removed in a future version. Please use `Graph3d.on('click', handler)` instead.")),void 0!==t.tooltipStyle&&function(t,e,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Nf(r))throw new TypeError("Arrays are not supported by deepExtend");for(var i=0;i<t.length;i++){var o=t[i];if(Object.prototype.hasOwnProperty.call(r,o))if(r[o]&&r[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?Xw(e[o],r[o],!1,n):Gw(e,r,o,n);else{if(Nf(r[o]))throw new TypeError("Arrays are not supported by deepExtend");Gw(e,r,o,n)}}}(["tooltipStyle"],e,t)}function S_(t){if(t.length<2)throw new Error("Colormap array length must be 2 or above.");return Fy(t).call(t,(function(t){if(!function(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}(t))throw new Error("Invalid hex color code supplied to colormap.");return function(t){var e;switch(t.length){case 3:case 4:return(e=Yw.exec(t))?{r:ox(e[1]+e[1],16),g:ox(e[2]+e[2],16),b:ox(e[3]+e[3],16)}:null;case 6:case 7:return(e=Ww.exec(t))?{r:ox(e[1],16),g:ox(e[2],16),b:ox(e[3],16)}:null;default:return null}}(t)}))}function T_(t){if(void 0===t)throw new Error("Unsupported type of colormap");if(!(t.saturation>=0&&t.saturation<=100))throw new Error("Saturation is out of bounds. Expected range is 0-100.");if(!(t.brightness>=0&&t.brightness<=100))throw new Error("Brightness is out of bounds. Expected range is 0-100.");if(!(t.colorStops>=2))throw new Error("colorStops is out of bounds. Expected 2 or above.");for(var e=(t.end-t.start)/(t.colorStops-1),r=[],n=0;n<t.colorStops;++n){var i=(t.start+e*n)%360/360;r.push(qw(i<0?i+1:i,t.saturation/100,t.brightness/100))}return r}function C_(t,e){var r=t;void 0!==r&&(void 0===e.camera&&(e.camera=new f_),e.camera.setArmRotation(r.horizontal,r.vertical),e.camera.setArmLength(r.distance))}var A_="string",E_="boolean",L_="number",O_="object",P_="array",M_={fill:{string:A_},stroke:{string:A_},strokeWidth:{number:L_},__type__:{string:A_,object:O_,undefined:"undefined"}},D_={animationAutoStart:{boolean:E_,undefined:"undefined"},animationInterval:{number:L_},animationPreload:{boolean:E_},axisColor:{string:A_},axisFontSize:{number:L_},axisFontType:{string:A_},backgroundColor:M_,xBarWidth:{number:L_,undefined:"undefined"},yBarWidth:{number:L_,undefined:"undefined"},cameraPosition:{distance:{number:L_},horizontal:{number:L_},vertical:{number:L_},__type__:{object:O_}},zoomable:{boolean:E_},ctrlToZoom:{boolean:E_},xCenter:{string:A_},yCenter:{string:A_},colormap:{hue:{start:{number:L_},end:{number:L_},saturation:{number:L_},brightness:{number:L_},colorStops:{number:L_},__type__:{object:O_}},__type__:{array:P_,object:O_,function:"function",undefined:"undefined"}},dataColor:M_,dotSizeMinFraction:{number:L_},dotSizeMaxFraction:{number:L_},dotSizeRatio:{number:L_},filterLabel:{string:A_},gridColor:{string:A_},onclick:{function:"function"},keepAspectRatio:{boolean:E_},xLabel:{string:A_},yLabel:{string:A_},zLabel:{string:A_},legendLabel:{string:A_},xMin:{number:L_,undefined:"undefined"},yMin:{number:L_,undefined:"undefined"},zMin:{number:L_,undefined:"undefined"},xMax:{number:L_,undefined:"undefined"},yMax:{number:L_,undefined:"undefined"},zMax:{number:L_,undefined:"undefined"},showAnimationControls:{boolean:E_,undefined:"undefined"},showGrayBottom:{boolean:E_},showGrid:{boolean:E_},showLegend:{boolean:E_,undefined:"undefined"},showPerspective:{boolean:E_},showShadow:{boolean:E_},showSurfaceGrid:{boolean:E_},showXAxis:{boolean:E_},showYAxis:{boolean:E_},showZAxis:{boolean:E_},rotateAxisLabels:{boolean:E_},surfaceColors:{hue:{start:{number:L_},end:{number:L_},saturation:{number:L_},brightness:{number:L_},colorStops:{number:L_},__type__:{object:O_}},__type__:{boolean:E_,array:P_,object:O_,undefined:"undefined"}},xStep:{number:L_,undefined:"undefined"},yStep:{number:L_,undefined:"undefined"},zStep:{number:L_,undefined:"undefined"},style:{number:L_,string:["bar","bar-color","bar-size","dot","dot-line","dot-color","dot-size","line","grid","surface"]},tooltip:{boolean:E_,function:"function"},tooltipDelay:{number:L_},tooltipStyle:{content:{color:{string:A_},background:{string:A_},border:{string:A_},borderRadius:{string:A_},boxShadow:{string:A_},padding:{string:A_},__type__:{object:O_}},line:{borderLeft:{string:A_},height:{string:A_},width:{string:A_},pointerEvents:{string:A_},__type__:{object:O_}},dot:{border:{string:A_},borderRadius:{string:A_},height:{string:A_},width:{string:A_},pointerEvents:{string:A_},__type__:{object:O_}},__type__:{object:O_}},xValueLabel:{function:"function"},yValueLabel:{function:"function"},zValueLabel:{function:"function"},valueMax:{number:L_,undefined:"undefined"},valueMin:{number:L_,undefined:"undefined"},verticalRatio:{number:L_},height:{string:A_},width:{string:A_},__type__:{object:O_}};function R_(){this.min=void 0,this.max=void 0}R_.prototype.adjust=function(t){void 0!==t&&((void 0===this.min||this.min>t)&&(this.min=t),(void 0===this.max||this.max<t)&&(this.max=t))},R_.prototype.combine=function(t){this.add(t.min),this.add(t.max)},R_.prototype.expand=function(t){if(void 0!==t){var e=this.min-t,r=this.max+t;if(e>r)throw new Error("Passed expansion value makes range invalid");this.min=e,this.max=r}},R_.prototype.range=function(){return this.max-this.min},R_.prototype.center=function(){return(this.min+this.max)/2};var k_=R_;function I_(t,e,r){this.dataGroup=t,this.column=e,this.graph=r,this.index=void 0,this.value=void 0,this.values=t.getDistinctValues(this.column),Sf(this).length>0&&this.selectValue(0),this.dataPoints=[],this.loaded=!1,this.onLoadCallback=void 0,r.animationPreload?(this.loaded=!1,this.loadInBackground()):this.loaded=!0}function z_(){this.dataTable=null}I_.prototype.isLoaded=function(){return this.loaded},I_.prototype.getLoadedProgress=function(){for(var t=Sf(this).length,e=0;this.dataPoints[e];)e++;return Math.round(e/t*100)},I_.prototype.getLabel=function(){return this.graph.filterLabel},I_.prototype.getColumn=function(){return this.column},I_.prototype.getSelectedValue=function(){if(void 0!==this.index)return Sf(this)[this.index]},I_.prototype.getValues=function(){return Sf(this)},I_.prototype.getValue=function(t){if(t>=Sf(this).length)throw new Error("Index out of range");return Sf(this)[t]},I_.prototype._getDataPoints=function(t){if(void 0===t&&(t=this.index),void 0===t)return[];var r;if(this.dataPoints[t])r=this.dataPoints[t];else{var n={};n.column=this.column,n.value=Sf(this)[t];var i=new e.DataView(this.dataGroup.getDataSet(),{filter:function(t){return t[n.column]==n.value}}).get();r=this.dataGroup._getDataPoints(i),this.dataPoints[t]=r}return r},I_.prototype.setOnLoadCallback=function(t){this.onLoadCallback=t},I_.prototype.selectValue=function(t){if(t>=Sf(this).length)throw new Error("Index out of range");this.index=t,this.value=Sf(this)[t]},I_.prototype.loadInBackground=function(t){void 0===t&&(t=0);var e=this.graph.frame;if(t<Sf(this).length){void 0===e.progress&&(e.progress=document.createElement("DIV"),e.progress.style.position="absolute",e.progress.style.color="gray",e.appendChild(e.progress));var r=this.getLoadedProgress();e.progress.innerHTML="Loading animation... "+r+"%",e.progress.style.bottom="60px",e.progress.style.left="10px";var n=this;bp((function(){n.loadInBackground(t+1)}),10),this.loaded=!1}else this.loaded=!0,void 0!==e.progress&&(e.removeChild(e.progress),e.progress=void 0),this.onLoadCallback&&this.onLoadCallback()},z_.prototype.initializeData=function(t,r,n){if(void 0!==r){var i;if(Nf(r)&&(r=new e.DataSet(r)),!(r instanceof e.DataSet||r instanceof e.DataView))throw new Error("Array, DataSet, or DataView expected");if(0!=(i=r.get()).length){this.style=n,this.dataSet&&this.dataSet.off("*",this._onChange),this.dataSet=r,this.dataTable=i;var o=this;this._onChange=function(){t.setData(o.dataSet)},this.dataSet.on("*",this._onChange),this.colX="x",this.colY="y",this.colZ="z";var a=t.hasBars(n);if(a&&(void 0!==t.defaultXBarWidth?this.xBarWidth=t.defaultXBarWidth:this.xBarWidth=this.getSmallestDifference(i,this.colX)||1,void 0!==t.defaultYBarWidth?this.yBarWidth=t.defaultYBarWidth:this.yBarWidth=this.getSmallestDifference(i,this.colY)||1),this._initializeRange(i,this.colX,t,a),this._initializeRange(i,this.colY,t,a),this._initializeRange(i,this.colZ,t,!1),Object.prototype.hasOwnProperty.call(i[0],"style")){this.colValue="style";var s=this.getColumnRange(i,this.colValue);this._setRangeDefaults(s,t.defaultValueMin,t.defaultValueMax),this.valueRange=s}else this.colValue="z",this.valueRange=this.zRange;var c=this.getDataTable();return Object.prototype.hasOwnProperty.call(c[0],"filter")&&void 0===this.dataFilter&&(this.dataFilter=new I_(this,"filter",t),this.dataFilter.setOnLoadCallback((function(){t.redraw()}))),this.dataFilter?this.dataFilter._getDataPoints():this._getDataPoints(this.getDataTable())}}},z_.prototype._collectRangeSettings=function(t,e){var r;if(-1==wh(r=["x","y","z"]).call(r,t))throw new Error("Column '"+t+"' invalid");var n=t.toUpperCase();return{barWidth:this[t+"BarWidth"],min:e["default"+n+"Min"],max:e["default"+n+"Max"],step:e["default"+n+"Step"],range_label:t+"Range",step_label:t+"Step"}},z_.prototype._initializeRange=function(t,e,r,n){var i=this._collectRangeSettings(e,r),o=this.getColumnRange(t,e);n&&"z"!=e&&o.expand(i.barWidth/2),this._setRangeDefaults(o,i.min,i.max),this[i.range_label]=o,this[i.step_label]=void 0!==i.step?i.step:o.range()/5},z_.prototype.getDistinctValues=function(t,e){void 0===e&&(e=this.dataTable);for(var r=[],n=0;n<e.length;n++){var i=e[n][t]||0;-1===wh(r).call(r,i)&&r.push(i)}return ch(r).call(r,(function(t,e){return t-e}))},z_.prototype.getSmallestDifference=function(t,e){for(var r=this.getDistinctValues(t,e),n=null,i=1;i<r.length;i++){var o=r[i]-r[i-1];(null==n||n>o)&&(n=o)}return n},z_.prototype.getColumnRange=function(t,e){for(var r=new k_,n=0;n<t.length;n++){var i=t[n][e];r.adjust(i)}return r},z_.prototype.getNumberOfRows=function(){return this.dataTable.length},z_.prototype._setRangeDefaults=function(t,e,r){void 0!==e&&(t.min=e),void 0!==r&&(t.max=r),t.max<=t.min&&(t.max=t.min+1)},z_.prototype.getDataTable=function(){return this.dataTable},z_.prototype.getDataSet=function(){return this.dataSet},z_.prototype.getDataPoints=function(t){for(var e=[],r=0;r<t.length;r++){var n=new n_;n.x=t[r][this.colX]||0,n.y=t[r][this.colY]||0,n.z=t[r][this.colZ]||0,n.data=t[r],n.value=t[r][this.colValue]||0;var i={};i.point=n,i.bottom=new n_(n.x,n.y,this.zRange.min),i.trans=void 0,i.screen=void 0,e.push(i)}return e},z_.prototype.initDataAsMatrix=function(t){var e,r,n,i,o=this.getDistinctValues(this.colX,t),a=this.getDistinctValues(this.colY,t),s=this.getDataPoints(t),c=[];for(n=0;n<s.length;n++){i=s[n];var u=wh(o).call(o,i.point.x),l=wh(a).call(a,i.point.y);void 0===c[u]&&(c[u]=[]),c[u][l]=i}for(e=0;e<c.length;e++)for(r=0;r<c[e].length;r++)c[e][r]&&(c[e][r].pointRight=e<c.length-1?c[e+1][r]:void 0,c[e][r].pointTop=r<c[e].length-1?c[e][r+1]:void 0,c[e][r].pointCross=e<c.length-1&&r<c[e].length-1?c[e+1][r+1]:void 0);return s},z_.prototype.getInfo=function(){var t=this.dataFilter;if(t)return t.getLabel()+": "+t.getSelectedValue()},z_.prototype.reload=function(){this.dataTable&&this.setData(this.dataTable)},z_.prototype._getDataPoints=function(t){var e=[];if(this.style===p_.GRID||this.style===p_.SURFACE)e=this.initDataAsMatrix(t);else if(e=this.getDataPoints(t),this.style===p_.LINE)for(var r=0;r<e.length;r++)r>0&&(e[r-1].pointNext=e[r]);return e},F_.STYLE=p_;var j_=void 0;function F_(t,e,r){if(!(this instanceof F_))throw new SyntaxError("Constructor must be called with the new operator");this.containerElement=t,this.dataGroup=new z_,this.dataPoints=null,this.create(),function(t,e){if(void 0===t||g_(t))throw new Error("No DEFAULTS passed");if(void 0===e)throw new Error("No dst passed");m_=t,b_(t,e,v_),b_(t,e,y_,"default"),__(t,e),e.margin=10,e.showTooltip=!1,e.onclick_callback=null,e.eye=new n_(0,0,-1)}(F_.DEFAULTS,this),this.colX=void 0,this.colY=void 0,this.colZ=void 0,this.colValue=void 0,this.setOptions(r),this.setData(e)}function B_(t){return"clientX"in t?t.clientX:t.targetTouches[0]&&t.targetTouches[0].clientX||0}function N_(t){return"clientY"in t?t.clientY:t.targetTouches[0]&&t.targetTouches[0].clientY||0}F_.DEFAULTS={width:"400px",height:"400px",filterLabel:"time",legendLabel:"value",xLabel:"x",yLabel:"y",zLabel:"z",xValueLabel:function(t){return t},yValueLabel:function(t){return t},zValueLabel:function(t){return t},showXAxis:!0,showYAxis:!0,showZAxis:!0,showGrayBottom:!1,showGrid:!0,showPerspective:!0,showShadow:!1,showSurfaceGrid:!0,keepAspectRatio:!0,rotateAxisLabels:!0,verticalRatio:.5,dotSizeRatio:.02,dotSizeMinFraction:.5,dotSizeMaxFraction:2.5,showAnimationControls:j_,animationInterval:1e3,animationPreload:!1,animationAutoStart:j_,axisFontSize:14,axisFontType:"arial",axisColor:"#4D4D4D",gridColor:"#D3D3D3",xCenter:"55%",yCenter:"50%",style:F_.STYLE.DOT,tooltip:!1,tooltipDelay:300,tooltipStyle:{content:{padding:"10px",border:"1px solid #4d4d4d",color:"#1a1a1a",background:"rgba(255,255,255,0.7)",borderRadius:"2px",boxShadow:"5px 5px 10px rgba(128,128,128,0.5)"},line:{height:"40px",width:"0",borderLeft:"1px solid #4d4d4d",pointerEvents:"none"},dot:{height:"0",width:"0",border:"5px solid #4d4d4d",borderRadius:"5px",pointerEvents:"none"}},dataColor:{fill:"#7DC1FF",stroke:"#3267D2",strokeWidth:1},surfaceColors:j_,colormap:j_,cameraPosition:{horizontal:1,vertical:.5,distance:1.7},zoomable:!0,ctrlToZoom:!1,showLegend:j_,backgroundColor:j_,xBarWidth:j_,yBarWidth:j_,valueMin:j_,valueMax:j_,xMin:j_,xMax:j_,xStep:j_,yMin:j_,yMax:j_,yStep:j_,zMin:j_,zMax:j_,zStep:j_},Np(F_.prototype),F_.prototype._setScale=function(){this.scale=new n_(1/this.xRange.range(),1/this.yRange.range(),1/this.zRange.range()),this.keepAspectRatio&&(this.scale.x<this.scale.y?this.scale.y=this.scale.x:this.scale.x=this.scale.y),this.scale.z*=this.verticalRatio,void 0!==this.valueRange&&(this.scale.value=1/this.valueRange.range());var t=this.xRange.center()*this.scale.x,e=this.yRange.center()*this.scale.y,r=this.zRange.center()*this.scale.z;this.camera.setArmLocation(t,e,r)},F_.prototype._convert3Dto2D=function(t){var e=this._convertPointToTranslation(t);return this._convertTranslationToScreen(e)},F_.prototype._convertPointToTranslation=function(t){var e=this.camera.getCameraLocation(),r=this.camera.getCameraRotation(),n=t.x*this.scale.x,i=t.y*this.scale.y,o=t.z*this.scale.z,a=e.x,s=e.y,c=e.z,u=Math.sin(r.x),l=Math.cos(r.x),h=Math.sin(r.y),f=Math.cos(r.y),p=Math.sin(r.z),d=Math.cos(r.z);return new n_(f*(p*(i-s)+d*(n-a))-h*(o-c),u*(f*(o-c)+h*(p*(i-s)+d*(n-a)))+l*(d*(i-s)-p*(n-a)),l*(f*(o-c)+h*(p*(i-s)+d*(n-a)))-u*(d*(i-s)-p*(n-a)))},F_.prototype._convertTranslationToScreen=function(t){var e,r,n=this.eye.x,i=this.eye.y,o=this.eye.z,a=t.x,s=t.y,c=t.z;return this.showPerspective?(e=o/c*(a-n),r=o/c*(s-i)):(e=a*(-o/this.camera.getArmLength()),r=s*(-o/this.camera.getArmLength())),new i_(this.currentXCenter+e*this.frame.canvas.clientWidth,this.currentYCenter-r*this.frame.canvas.clientWidth)},F_.prototype._calcTranslations=function(t){for(var e=0;e<t.length;e++){var r=t[e];r.trans=this._convertPointToTranslation(r.point),r.screen=this._convertTranslationToScreen(r.trans);var n=this._convertPointToTranslation(r.bottom);r.dist=this.showPerspective?n.length():-n.z}ch(t).call(t,(function(t,e){return e.dist-t.dist}))},F_.prototype._initializeRanges=function(){var t=this.dataGroup;this.xRange=t.xRange,this.yRange=t.yRange,this.zRange=t.zRange,this.valueRange=t.valueRange,this.xStep=t.xStep,this.yStep=t.yStep,this.zStep=t.zStep,this.xBarWidth=t.xBarWidth,this.yBarWidth=t.yBarWidth,this.colX=t.colX,this.colY=t.colY,this.colZ=t.colZ,this.colValue=t.colValue,this._setScale()},F_.prototype.getDataPoints=function(t){for(var e=[],r=0;r<t.length;r++){var n=new n_;n.x=t[r][this.colX]||0,n.y=t[r][this.colY]||0,n.z=t[r][this.colZ]||0,n.data=t[r],n.value=t[r][this.colValue]||0;var i={};i.point=n,i.bottom=new n_(n.x,n.y,this.zRange.min),i.trans=void 0,i.screen=void 0,e.push(i)}return e},F_.prototype._getDataPoints=function(t){var e,r,n,i,o=[];if(this.style===F_.STYLE.GRID||this.style===F_.STYLE.SURFACE){var a=this.dataGroup.getDistinctValues(this.colX,t),s=this.dataGroup.getDistinctValues(this.colY,t);o=this.getDataPoints(t);var c=[];for(n=0;n<o.length;n++){i=o[n];var u=wh(a).call(a,i.point.x),l=wh(s).call(s,i.point.y);void 0===c[u]&&(c[u]=[]),c[u][l]=i}for(e=0;e<c.length;e++)for(r=0;r<c[e].length;r++)c[e][r]&&(c[e][r].pointRight=e<c.length-1?c[e+1][r]:void 0,c[e][r].pointTop=r<c[e].length-1?c[e][r+1]:void 0,c[e][r].pointCross=e<c.length-1&&r<c[e].length-1?c[e+1][r+1]:void 0)}else if(o=this.getDataPoints(t),this.style===F_.STYLE.LINE)for(n=0;n<o.length;n++)n>0&&(o[n-1].pointNext=o[n]);return o},F_.prototype.create=function(){for(;this.containerElement.hasChildNodes();)this.containerElement.removeChild(this.containerElement.firstChild);this.frame=document.createElement("div"),this.frame.style.position="relative",this.frame.style.overflow="hidden",this.frame.canvas=document.createElement("canvas"),this.frame.canvas.style.position="relative",this.frame.appendChild(this.frame.canvas);var t=document.createElement("DIV");t.style.color="red",t.style.fontWeight="bold",t.style.padding="10px",t.innerHTML="Error: your browser does not support HTML canvas",this.frame.canvas.appendChild(t),this.frame.filter=document.createElement("div"),Ph(this.frame).style.position="absolute",Ph(this.frame).style.bottom="0px",Ph(this.frame).style.left="0px",Ph(this.frame).style.width="100%",this.frame.appendChild(Ph(this.frame));var e=this;Uw(this.frame.canvas,"mousedown",(function(t){e._onMouseDown(t)})),Uw(this.frame.canvas,"touchstart",(function(t){e._onTouchStart(t)})),Uw(this.frame.canvas,"mousewheel",(function(t){e._onWheel(t)})),Uw(this.frame.canvas,"mousemove",(function(t){e._onTooltip(t)})),Uw(this.frame.canvas,"click",(function(t){e._onClick(t)})),this.containerElement.appendChild(this.frame)},F_.prototype._setSize=function(t,e){this.frame.style.width=t,this.frame.style.height=e,this._resizeCanvas()},F_.prototype._resizeCanvas=function(){this.frame.canvas.style.width="100%",this.frame.canvas.style.height="100%",this.frame.canvas.width=this.frame.canvas.clientWidth,this.frame.canvas.height=this.frame.canvas.clientHeight,Ph(this.frame).style.width=this.frame.canvas.clientWidth-20+"px"},F_.prototype.animationStart=function(){if(this.animationAutoStart&&this.dataGroup.dataFilter){if(!Ph(this.frame)||!Ph(this.frame).slider)throw new Error("No animation available");Ph(this.frame).slider.play()}},F_.prototype.animationStop=function(){Ph(this.frame)&&Ph(this.frame).slider&&Ph(this.frame).slider.stop()},F_.prototype._resizeCenter=function(){"%"===this.xCenter.charAt(this.xCenter.length-1)?this.currentXCenter=Qh(this.xCenter)/100*this.frame.canvas.clientWidth:this.currentXCenter=Qh(this.xCenter),"%"===this.yCenter.charAt(this.yCenter.length-1)?this.currentYCenter=Qh(this.yCenter)/100*(this.frame.canvas.clientHeight-Ph(this.frame).clientHeight):this.currentYCenter=Qh(this.yCenter)},F_.prototype.getCameraPosition=function(){var t=this.camera.getArmRotation();return t.distance=this.camera.getArmLength(),t},F_.prototype._readData=function(t){this.dataPoints=this.dataGroup.initializeData(this,t,this.style),this._initializeRanges(),this._redrawFilter()},F_.prototype.setData=function(t){null!=t&&(this._readData(t),this.redraw(),this.animationStart())},F_.prototype.setOptions=function(t){void 0!==t&&(!0===e_.validate(t,D_)&&console.error("%cErrors have been found in the supplied options object.",t_),this.animationStop(),function(t,e){if(void 0!==t){if(void 0===e)throw new Error("No dst passed");if(void 0===m_||g_(m_))throw new Error("DEFAULTS not set for module Settings");w_(t,e,v_),w_(t,e,y_,"default"),__(t,e)}}(t,this),this.setPointDrawingMethod(),this._setSize(this.width,this.height),this.setAxisLabelMethod(),this.setData(this.dataGroup.getDataTable()),this.animationStart())},F_.prototype.setPointDrawingMethod=function(){var t=void 0;switch(this.style){case F_.STYLE.BAR:t=this._redrawBarGraphPoint;break;case F_.STYLE.BARCOLOR:t=this._redrawBarColorGraphPoint;break;case F_.STYLE.BARSIZE:t=this._redrawBarSizeGraphPoint;break;case F_.STYLE.DOT:t=this._redrawDotGraphPoint;break;case F_.STYLE.DOTLINE:t=this._redrawDotLineGraphPoint;break;case F_.STYLE.DOTCOLOR:t=this._redrawDotColorGraphPoint;break;case F_.STYLE.DOTSIZE:t=this._redrawDotSizeGraphPoint;break;case F_.STYLE.SURFACE:t=this._redrawSurfaceGraphPoint;break;case F_.STYLE.GRID:t=this._redrawGridGraphPoint;break;case F_.STYLE.LINE:t=this._redrawLineGraphPoint;break;default:throw new Error("Can not determine point drawing method for graph style '"+this.style+"'")}this._pointDrawingMethod=t},F_.prototype.setAxisLabelMethod=function(){this.rotateAxisLabels?(this._drawAxisLabelX=this.drawAxisLabelXRotate,this._drawAxisLabelY=this.drawAxisLabelYRotate,this._drawAxisLabelZ=this.drawAxisLabelZRotate):(this._drawAxisLabelX=this.drawAxisLabelX,this._drawAxisLabelY=this.drawAxisLabelY,this._drawAxisLabelZ=this.drawAxisLabelZ)},F_.prototype.redraw=function(){if(void 0===this.dataPoints)throw new Error("Graph data not initialized");this._resizeCanvas(),this._resizeCenter(),this._redrawSlider(),this._redrawClear(),this._redrawAxis(),this._redrawDataGraph(),this._redrawInfo(),this._redrawLegend()},F_.prototype._getContext=function(){var t=this.frame.canvas.getContext("2d");return t.lineJoin="round",t.lineCap="round",t},F_.prototype._redrawClear=function(){var t=this.frame.canvas;t.getContext("2d").clearRect(0,0,t.width,t.height)},F_.prototype._dotSize=function(){return this.frame.clientWidth*this.dotSizeRatio},F_.prototype._getLegendWidth=function(){var t;this.style===F_.STYLE.DOTSIZE?t=this._dotSize()*this.dotSizeMaxFraction:t=this.style===F_.STYLE.BARSIZE?this.xBarWidth:20;return t},F_.prototype._redrawLegend=function(){if(!0===this.showLegend&&this.style!==F_.STYLE.LINE&&this.style!==F_.STYLE.BARSIZE){var t=this.style===F_.STYLE.BARSIZE||this.style===F_.STYLE.DOTSIZE,e=this.style===F_.STYLE.DOTSIZE||this.style===F_.STYLE.DOTCOLOR||this.style===F_.STYLE.SURFACE||this.style===F_.STYLE.BARCOLOR,r=Math.max(.25*this.frame.clientHeight,100),n=this.margin,i=this._getLegendWidth(),o=this.frame.clientWidth-this.margin,a=o-i,s=n+r,c=this._getContext();if(c.lineWidth=1,c.font="14px arial",!1===t){var u,l=r;for(u=0;u<l;u++){var h=1-(u-0)/(l-0),f=this._colormap(h,1);c.strokeStyle=f,c.beginPath(),c.moveTo(a,n+u),c.lineTo(o,n+u),c.stroke()}c.strokeStyle=this.axisColor,c.strokeRect(a,n,i,r)}else{var p;this.style===F_.STYLE.DOTSIZE?p=i*(this.dotSizeMinFraction/this.dotSizeMaxFraction):(this.style,F_.STYLE.BARSIZE),c.strokeStyle=this.axisColor,c.fillStyle=ff(this.dataColor),c.beginPath(),c.moveTo(a,n),c.lineTo(o,n),c.lineTo(a+p,s),c.lineTo(a,s),c.closePath(),ff(c).call(c),c.stroke()}var d=e?this.valueRange.min:this.zRange.min,v=e?this.valueRange.max:this.zRange.max,y=new s_(d,v,(v-d)/5,!0);for(y.start(!0);!y.end();){var m=s-(y.getCurrent()-d)/(v-d)*r,g=new i_(a-5,m),x=new i_(a,m);this._line(c,g,x),c.textAlign="right",c.textBaseline="middle",c.fillStyle=this.axisColor,c.fillText(y.getCurrent(),a-10,m),y.next()}c.textAlign="right",c.textBaseline="top";var b=this.legendLabel;c.fillText(b,o,s+this.margin)}},F_.prototype._redrawFilter=function(){var t=this.dataGroup.dataFilter,e=Ph(this.frame);if(e.innerHTML="",t){var r=new o_(e,{visible:this.showAnimationControls});e.slider=r,e.style.padding="10px",r.setValues(Sf(t)),r.setPlayInterval(this.animationInterval);var n=this;r.setOnChangeCallback((function(){var t=n.dataGroup.dataFilter,e=r.getIndex();t.selectValue(e),n.dataPoints=t._getDataPoints(),n.redraw()}))}else e.slider=void 0},F_.prototype._redrawSlider=function(){void 0!==Ph(this.frame).slider&&Ph(this.frame).slider.redraw()},F_.prototype._redrawInfo=function(){var t=this.dataGroup.getInfo();if(void 0!==t){var e=this._getContext();e.font="14px arial",e.lineStyle="gray",e.fillStyle="gray",e.textAlign="left",e.textBaseline="top";var r=this.margin,n=this.margin;e.fillText(t,r,n)}},F_.prototype._line=function(t,e,r,n){void 0!==n&&(t.strokeStyle=n),t.beginPath(),t.moveTo(e.x,e.y),t.lineTo(r.x,r.y),t.stroke()},F_.prototype.drawAxisLabelX=function(t,e,r,n,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*n)>0?(t.textAlign="center",t.textBaseline="top",o.y+=i):Math.sin(2*n)<0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)},F_.prototype.drawAxisLabelY=function(t,e,r,n,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*n)<0?(t.textAlign="center",t.textBaseline="top",o.y+=i):Math.sin(2*n)>0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)},F_.prototype.drawAxisLabelZ=function(t,e,r,n){void 0===n&&(n=0);var i=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,i.x-n,i.y)},F_.prototype.drawAxisLabelXRotate=function(t,e,r,n,i){var o=this._convert3Dto2D(e);Math.cos(2*n)>0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,0,0),t.restore()):Math.sin(2*n)<0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y))},F_.prototype.drawAxisLabelYRotate=function(t,e,r,n,i){var o=this._convert3Dto2D(e);Math.cos(2*n)<0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,0,0),t.restore()):Math.sin(2*n)>0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y))},F_.prototype.drawAxisLabelZRotate=function(t,e,r,n){void 0===n&&(n=0);var i=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,i.x-n,i.y)},F_.prototype._line3d=function(t,e,r,n){var i=this._convert3Dto2D(e),o=this._convert3Dto2D(r);this._line(t,i,o,n)},F_.prototype._redrawAxis=function(){var t,e,r,n,i,o,a,s,c,u,l=this._getContext();l.font=this.axisFontSize/this.camera.getArmLength()+"px "+this.axisFontType;var h,f,p,d=.025/this.scale.x,v=.025/this.scale.y,y=5/this.camera.getArmLength(),m=this.camera.getArmRotation().horizontal,g=new i_(Math.cos(m),Math.sin(m)),x=this.xRange,b=this.yRange,w=this.zRange;for(l.lineWidth=1,n=void 0===this.defaultXStep,(r=new s_(x.min,x.max,this.xStep,n)).start(!0);!r.end();){var _=r.getCurrent();if(this.showGrid?(t=new n_(_,b.min,w.min),e=new n_(_,b.max,w.min),this._line3d(l,t,e,this.gridColor)):this.showXAxis&&(t=new n_(_,b.min,w.min),e=new n_(_,b.min+d,w.min),this._line3d(l,t,e,this.axisColor),t=new n_(_,b.max,w.min),e=new n_(_,b.max-d,w.min),this._line3d(l,t,e,this.axisColor)),this.showXAxis){a=g.x>0?b.min:b.max,h=new n_(_,a,w.min);var S="  "+this.xValueLabel(_)+"  ";this._drawAxisLabelX.call(this,l,h,S,m,y)}r.next()}for(l.lineWidth=1,n=void 0===this.defaultYStep,(r=new s_(b.min,b.max,this.yStep,n)).start(!0);!r.end();){var T=r.getCurrent();if(this.showGrid?(t=new n_(x.min,T,w.min),e=new n_(x.max,T,w.min),this._line3d(l,t,e,this.gridColor)):this.showYAxis&&(t=new n_(x.min,T,w.min),e=new n_(x.min+v,T,w.min),this._line3d(l,t,e,this.axisColor),t=new n_(x.max,T,w.min),e=new n_(x.max-v,T,w.min),this._line3d(l,t,e,this.axisColor)),this.showYAxis){o=g.y>0?x.min:x.max,h=new n_(o,T,w.min);var C="  "+this.yValueLabel(T)+"  ";this._drawAxisLabelY.call(this,l,h,C,m,y)}r.next()}if(this.showZAxis){for(l.lineWidth=1,n=void 0===this.defaultZStep,(r=new s_(w.min,w.max,this.zStep,n)).start(!0),o=g.x>0?x.min:x.max,a=g.y<0?b.min:b.max;!r.end();){var A=r.getCurrent(),E=new n_(o,a,A),L=this._convert3Dto2D(E);e=new i_(L.x-y,L.y),this._line(l,L,e,this.axisColor);var O=this.zValueLabel(A)+" ";this._drawAxisLabelZ.call(this,l,E,O,5),r.next()}l.lineWidth=1,t=new n_(o,a,w.min),e=new n_(o,a,w.max),this._line3d(l,t,e,this.axisColor)}this.showXAxis&&(l.lineWidth=1,f=new n_(x.min,b.min,w.min),p=new n_(x.max,b.min,w.min),this._line3d(l,f,p,this.axisColor),f=new n_(x.min,b.max,w.min),p=new n_(x.max,b.max,w.min),this._line3d(l,f,p,this.axisColor));this.showYAxis&&(l.lineWidth=1,t=new n_(x.min,b.min,w.min),e=new n_(x.min,b.max,w.min),this._line3d(l,t,e,this.axisColor),t=new n_(x.max,b.min,w.min),e=new n_(x.max,b.max,w.min),this._line3d(l,t,e,this.axisColor));var P=this.xLabel;P.length>0&&this.showXAxis&&(u=.1/this.scale.y,o=(x.max+3*x.min)/4,a=g.x>0?b.min-u:b.max+u,i=new n_(o,a,w.min),this.drawAxisLabelX(l,i,P,m));var M=this.yLabel;M.length>0&&this.showYAxis&&(c=.1/this.scale.x,o=g.y>0?x.min-c:x.max+c,a=(b.max+3*b.min)/4,i=new n_(o,a,w.min),this.drawAxisLabelY(l,i,M,m));var D=this.zLabel;D.length>0&&this.showZAxis&&(30,o=g.x>0?x.min:x.max,a=g.y<0?b.min:b.max,s=(w.max+3*w.min)/4,i=new n_(o,a,s),this.drawAxisLabelZ(l,i,D,30))},F_.prototype._getStrokeWidth=function(t){return void 0!==t?this.showPerspective?1/-t.trans.z*this.dataColor.strokeWidth:-this.eye.z/this.camera.getArmLength()*this.dataColor.strokeWidth:this.dataColor.strokeWidth},F_.prototype._redrawBar=function(t,e,r,n,i,o){var a,s=this,c=e.point,u=this.zRange.min,l=[{point:new n_(c.x-r,c.y-n,c.z)},{point:new n_(c.x+r,c.y-n,c.z)},{point:new n_(c.x+r,c.y+n,c.z)},{point:new n_(c.x-r,c.y+n,c.z)}],h=[{point:new n_(c.x-r,c.y-n,u)},{point:new n_(c.x+r,c.y-n,u)},{point:new n_(c.x+r,c.y+n,u)},{point:new n_(c.x-r,c.y+n,u)}];zf(l).call(l,(function(t){t.screen=s._convert3Dto2D(t.point)})),zf(h).call(h,(function(t){t.screen=s._convert3Dto2D(t.point)}));var f=[{corners:l,center:n_.avg(h[0].point,h[2].point)},{corners:[l[0],l[1],h[1],h[0]],center:n_.avg(h[1].point,h[0].point)},{corners:[l[1],l[2],h[2],h[1]],center:n_.avg(h[2].point,h[1].point)},{corners:[l[2],l[3],h[3],h[2]],center:n_.avg(h[3].point,h[2].point)},{corners:[l[3],l[0],h[0],h[3]],center:n_.avg(h[0].point,h[3].point)}];e.surfaces=f;for(var p=0;p<f.length;p++){a=f[p];var d=this._convertPointToTranslation(a.center);a.dist=this.showPerspective?d.length():-d.z}ch(f).call(f,(function(t,e){var r=e.dist-t.dist;return r||(t.corners===l?1:e.corners===l?-1:0)})),t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=o,t.fillStyle=i;for(var v=2;v<f.length;v++)a=f[v],this._polygon(t,a.corners)},F_.prototype._polygon=function(t,e,r,n){if(!(e.length<2)){void 0!==r&&(t.fillStyle=r),void 0!==n&&(t.strokeStyle=n),t.beginPath(),t.moveTo(e[0].screen.x,e[0].screen.y);for(var i=1;i<e.length;++i){var o=e[i];t.lineTo(o.screen.x,o.screen.y)}t.closePath(),ff(t).call(t),t.stroke()}},F_.prototype._drawCircle=function(t,e,r,n,i){var o=this._calcRadius(e,i);t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=n,t.fillStyle=r,t.beginPath(),t.arc(e.screen.x,e.screen.y,o,0,2*Math.PI,!0),ff(t).call(t),t.stroke()},F_.prototype._getColorsRegular=function(t){var e=(t.point.value-this.valueRange.min)*this.scale.value;return{fill:this._colormap(e,1),border:this._colormap(e,.8)}},F_.prototype._getColorsColor=function(t){var e,r,n;if(t&&t.point&&t.point.data&&t.point.data.style&&(n=t.point.data.style),n&&"object"===vl(n)&&ff(n)&&n.stroke)return{fill:ff(n),border:n.stroke};if("string"==typeof t.point.value)e=t.point.value,r=t.point.value;else{var i=(t.point.value-this.valueRange.min)*this.scale.value;e=this._colormap(i,1),r=this._colormap(i,.8)}return{fill:e,border:r}},F_.prototype._getColorsSize=function(){return{fill:ff(this.dataColor),border:this.dataColor.stroke}},F_.prototype._colormap=function(t){var e,r,n,i,o,a,s,c,u,l=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1,h=this.colormap;if(Nf(h)){var f=h.length-1,p=Math.max(Math.floor(t*f),0),d=Math.min(p+1,f),v=t*f-p,y=h[p],m=h[d];e=y.r+v*(m.r-y.r),r=y.g+v*(m.g-y.g),n=y.b+v*(m.b-y.b)}else if("function"==typeof h){var g=h(t);e=g.r,r=g.g,n=g.b,i=g.a}else{var x=qw(240*(1-t)/360,1,1);e=x.r,r=x.g,n=x.b}return"number"!=typeof i||Xf(i)?Kf(o=Kf(a="RGB(".concat(Math.round(e*l),", ")).call(a,Math.round(r*l),", ")).call(o,Math.round(n*l),")"):Kf(s=Kf(c=Kf(u="RGBA(".concat(Math.round(e*l),", ")).call(u,Math.round(r*l),", ")).call(c,Math.round(n*l),", ")).call(s,i,")")},F_.prototype._calcRadius=function(t,e){var r;return void 0===e&&(e=this._dotSize()),(r=this.showPerspective?e/-t.trans.z:e*(-this.eye.z/this.camera.getArmLength()))<0&&(r=0),r},F_.prototype._redrawBarGraphPoint=function(t,e){var r=this.xBarWidth/2,n=this.yBarWidth/2,i=this._getColorsRegular(e);this._redrawBar(t,e,r,n,ff(i),i.border)},F_.prototype._redrawBarColorGraphPoint=function(t,e){var r=this.xBarWidth/2,n=this.yBarWidth/2,i=this._getColorsColor(e);this._redrawBar(t,e,r,n,ff(i),i.border)},F_.prototype._redrawBarSizeGraphPoint=function(t,e){var r=(e.point.value-this.valueRange.min)/this.valueRange.range(),n=this.xBarWidth/2*(.8*r+.2),i=this.yBarWidth/2*(.8*r+.2),o=this._getColorsSize();this._redrawBar(t,e,n,i,ff(o),o.border)},F_.prototype._redrawDotGraphPoint=function(t,e){var r=this._getColorsRegular(e);this._drawCircle(t,e,ff(r),r.border)},F_.prototype._redrawDotLineGraphPoint=function(t,e){var r=this._convert3Dto2D(e.bottom);t.lineWidth=1,this._line(t,r,e.screen,this.gridColor),this._redrawDotGraphPoint(t,e)},F_.prototype._redrawDotColorGraphPoint=function(t,e){var r=this._getColorsColor(e);this._drawCircle(t,e,ff(r),r.border)},F_.prototype._redrawDotSizeGraphPoint=function(t,e){var r=this._dotSize(),n=(e.point.value-this.valueRange.min)/this.valueRange.range(),i=r*this.dotSizeMinFraction,o=i+(r*this.dotSizeMaxFraction-i)*n,a=this._getColorsSize();this._drawCircle(t,e,ff(a),a.border,o)},F_.prototype._redrawSurfaceGraphPoint=function(t,e){var r=e.pointRight,n=e.pointTop,i=e.pointCross;if(void 0!==e&&void 0!==r&&void 0!==n&&void 0!==i){var o,a,s,c=!0;if(this.showGrayBottom||this.showShadow){var u=n_.subtract(i.trans,e.trans),l=n_.subtract(n.trans,r.trans),h=n_.crossProduct(u,l);if(this.showPerspective){var f=n_.avg(n_.avg(e.trans,i.trans),n_.avg(r.trans,n.trans));s=-n_.dotProduct(h.normalize(),f.normalize())}else s=h.z/h.length();c=s>0}if(c||!this.showGrayBottom){var p=((e.point.value+r.point.value+n.point.value+i.point.value)/4-this.valueRange.min)*this.scale.value,d=this.showShadow?(1+s)/2:1;o=this._colormap(p,d)}else o="gray";a=this.showSurfaceGrid?this.axisColor:o,t.lineWidth=this._getStrokeWidth(e);var v=[e,r,i,n];this._polygon(t,v,o,a)}},F_.prototype._drawGridLine=function(t,e,r){if(void 0!==e&&void 0!==r){var n=((e.point.value+r.point.value)/2-this.valueRange.min)*this.scale.value;t.lineWidth=2*this._getStrokeWidth(e),t.strokeStyle=this._colormap(n,1),this._line(t,e.screen,r.screen)}},F_.prototype._redrawGridGraphPoint=function(t,e){this._drawGridLine(t,e,e.pointRight),this._drawGridLine(t,e,e.pointTop)},F_.prototype._redrawLineGraphPoint=function(t,e){void 0!==e.pointNext&&(t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=this.dataColor.stroke,this._line(t,e.screen,e.pointNext.screen))},F_.prototype._redrawDataGraph=function(){var t,e=this._getContext();if(!(void 0===this.dataPoints||this.dataPoints.length<=0))for(this._calcTranslations(this.dataPoints),t=0;t<this.dataPoints.length;t++){var r=this.dataPoints[t];this._pointDrawingMethod.call(this,e,r)}},F_.prototype._storeMousePosition=function(t){this.startMouseX=B_(t),this.startMouseY=N_(t),this._startCameraOffset=this.camera.getOffset()},F_.prototype._onMouseDown=function(t){if(t=t||window.event,this.leftButtonDown&&this._onMouseUp(t),this.leftButtonDown=t.which?1===t.which:1===t.button,this.leftButtonDown||this.touchDown){this._storeMousePosition(t),this.startStart=new Date(this.start),this.startEnd=new Date(this.end),this.startArmRotation=this.camera.getArmRotation(),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},Uw(document,"mousemove",e.onmousemove),Uw(document,"mouseup",e.onmouseup),Hw(t)}},F_.prototype._onMouseMove=function(t){this.moving=!0,t=t||window.event;var e=Qh(B_(t))-this.startMouseX,r=Qh(N_(t))-this.startMouseY;if(t&&!0===t.ctrlKey){var n=.5*this.frame.clientWidth,i=.5*this.frame.clientHeight,o=(this._startCameraOffset.x||0)-e/n*this.camera.armLength*.8,a=(this._startCameraOffset.y||0)+r/i*this.camera.armLength*.8;this.camera.setOffset(o,a),this._storeMousePosition(t)}else{var s=this.startArmRotation.horizontal+e/200,c=this.startArmRotation.vertical+r/200,u=Math.sin(4/360*2*Math.PI);Math.abs(Math.sin(s))<u&&(s=Math.round(s/Math.PI)*Math.PI-.001),Math.abs(Math.cos(s))<u&&(s=(Math.round(s/Math.PI-.5)+.5)*Math.PI-.001),Math.abs(Math.sin(c))<u&&(c=Math.round(c/Math.PI)*Math.PI),Math.abs(Math.cos(c))<u&&(c=(Math.round(c/Math.PI-.5)+.5)*Math.PI),this.camera.setArmRotation(s,c)}this.redraw();var l=this.getCameraPosition();this.emit("cameraPositionChange",l),Hw(t)},F_.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",this.leftButtonDown=!1,Zw(document,"mousemove",this.onmousemove),Zw(document,"mouseup",this.onmouseup),Hw(t)},F_.prototype._onClick=function(t){if(this.onclick_callback||this.hasListeners("click")){if(this.moving)this.moving=!1;else{var e=this.frame.getBoundingClientRect(),r=B_(t)-e.left,n=N_(t)-e.top,i=this._dataPointFromXY(r,n);i&&(this.onclick_callback&&this.onclick_callback(i.point.data),this.emit("click",i.point.data))}Hw(t)}},F_.prototype._onTooltip=function(t){var e=this.tooltipDelay,r=this.frame.getBoundingClientRect(),n=B_(t)-r.left,i=N_(t)-r.top;if(this.showTooltip)if(this.tooltipTimeout&&clearTimeout(this.tooltipTimeout),this.leftButtonDown)this._hideTooltip();else if(this.tooltip&&this.tooltip.dataPoint){var o=this._dataPointFromXY(n,i);o!==this.tooltip.dataPoint&&(o?this._showTooltip(o):this._hideTooltip())}else{var a=this;this.tooltipTimeout=bp((function(){a.tooltipTimeout=null;var t=a._dataPointFromXY(n,i);t&&a._showTooltip(t)}),e)}},F_.prototype._onTouchStart=function(t){this.touchDown=!0;var e=this;this.ontouchmove=function(t){e._onTouchMove(t)},this.ontouchend=function(t){e._onTouchEnd(t)},Uw(document,"touchmove",e.ontouchmove),Uw(document,"touchend",e.ontouchend),this._onMouseDown(t)},F_.prototype._onTouchMove=function(t){this._onMouseMove(t)},F_.prototype._onTouchEnd=function(t){this.touchDown=!1,Zw(document,"touchmove",this.ontouchmove),Zw(document,"touchend",this.ontouchend),this._onMouseUp(t)},F_.prototype._onWheel=function(t){if(t||(t=window.event),this.zoomable&&(!this.ctrlToZoom||t.ctrlKey)){var e=0;if(t.wheelDelta?e=t.wheelDelta/120:t.detail&&(e=-t.detail/3),e){var r=this.camera.getArmLength()*(1-e/10);this.camera.setArmLength(r),this.redraw(),this._hideTooltip()}var n=this.getCameraPosition();this.emit("cameraPositionChange",n),Hw(t)}},F_.prototype._insideTriangle=function(t,e){var r=e[0],n=e[1],i=e[2];function o(t){return t>0?1:t<0?-1:0}var a=o((n.x-r.x)*(t.y-r.y)-(n.y-r.y)*(t.x-r.x)),s=o((i.x-n.x)*(t.y-n.y)-(i.y-n.y)*(t.x-n.x)),c=o((r.x-i.x)*(t.y-i.y)-(r.y-i.y)*(t.x-i.x));return!(0!=a&&0!=s&&a!=s||0!=s&&0!=c&&s!=c||0!=a&&0!=c&&a!=c)},F_.prototype._dataPointFromXY=function(t,e){var r,n=new i_(t,e),i=null,o=null,a=null;if(this.style===F_.STYLE.BAR||this.style===F_.STYLE.BARCOLOR||this.style===F_.STYLE.BARSIZE)for(r=this.dataPoints.length-1;r>=0;r--){var s=(i=this.dataPoints[r]).surfaces;if(s)for(var c=s.length-1;c>=0;c--){var u=s[c].corners,l=[u[0].screen,u[1].screen,u[2].screen],h=[u[2].screen,u[3].screen,u[0].screen];if(this._insideTriangle(n,l)||this._insideTriangle(n,h))return i}}else for(r=0;r<this.dataPoints.length;r++){var f=(i=this.dataPoints[r]).screen;if(f){var p=Math.abs(t-f.x),d=Math.abs(e-f.y),v=Math.sqrt(p*p+d*d);(null===a||v<a)&&v<100&&(a=v,o=i)}}return o},F_.prototype.hasBars=function(t){return t==F_.STYLE.BAR||t==F_.STYLE.BARCOLOR||t==F_.STYLE.BARSIZE},F_.prototype._showTooltip=function(t){var e,r,n;this.tooltip?(e=this.tooltip.dom.content,r=this.tooltip.dom.line,n=this.tooltip.dom.dot):(e=document.createElement("div"),Fp(e.style,{},this.tooltipStyle.content),e.style.position="absolute",r=document.createElement("div"),Fp(r.style,{},this.tooltipStyle.line),r.style.position="absolute",n=document.createElement("div"),Fp(n.style,{},this.tooltipStyle.dot),n.style.position="absolute",this.tooltip={dataPoint:null,dom:{content:e,line:r,dot:n}}),this._hideTooltip(),this.tooltip.dataPoint=t,"function"==typeof this.showTooltip?e.innerHTML=this.showTooltip(t.point):e.innerHTML="<table><tr><td>"+this.xLabel+":</td><td>"+t.point.x+"</td></tr><tr><td>"+this.yLabel+":</td><td>"+t.point.y+"</td></tr><tr><td>"+this.zLabel+":</td><td>"+t.point.z+"</td></tr></table>",e.style.left="0",e.style.top="0",this.frame.appendChild(e),this.frame.appendChild(r),this.frame.appendChild(n);var i=e.offsetWidth,o=e.offsetHeight,a=r.offsetHeight,s=n.offsetWidth,c=n.offsetHeight,u=t.screen.x-i/2;u=Math.min(Math.max(u,10),this.frame.clientWidth-10-i),r.style.left=t.screen.x+"px",r.style.top=t.screen.y-a+"px",e.style.left=u+"px",e.style.top=t.screen.y-a-o+"px",n.style.left=t.screen.x-s/2+"px",n.style.top=t.screen.y-c/2+"px"},F_.prototype._hideTooltip=function(){if(this.tooltip)for(var t in this.tooltip.dataPoint=null,this.tooltip.dom)if(Object.prototype.hasOwnProperty.call(this.tooltip.dom,t)){var e=this.tooltip.dom[t];e&&e.parentNode&&e.parentNode.removeChild(e)}},F_.prototype.setCameraPosition=function(t){C_(t,this),this.redraw()},F_.prototype.setSize=function(t,e){this._setSize(t,e),this.redraw()},t.Graph3d=F_,t.Graph3dCamera=f_,t.Graph3dFilter=I_,t.Graph3dPoint2d=i_,t.Graph3dPoint3d=n_,t.Graph3dSlider=o_,t.Graph3dStepNumber=s_}));
//# sourceMappingURL=vis-graph3d.min.js.map
