/**
 * vis-graph3d
 * https://visjs.github.io/vis-graph3d/
 *
 * Create interactive, animated 3d graphs. Surfaces, lines, dots and block styling out of the box.
 *
 * @version 6.0.3
 * @date    2023-03-21T17:15:34.624Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
var t="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function e(t){return t&&t.__esModule&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t}var r={},n={get exports(){return r},set exports(t){r=t}},i={},o={get exports(){return i},set exports(t){i=t}},a=function(t){return t&&t.Math==Math&&t},s=a("object"==typeof globalThis&&globalThis)||a("object"==typeof window&&window)||a("object"==typeof self&&self)||a("object"==typeof t&&t)||function(){return this}()||Function("return this")(),u=function(t){try{return!!t()}catch(t){return!0}},c=!u((function(){var t=function(){}.bind();return"function"!=typeof t||t.hasOwnProperty("prototype")})),l=c,h=Function.prototype,f=h.apply,p=h.call,d="object"==typeof Reflect&&Reflect.apply||(l?p.bind(f):function(){return p.apply(f,arguments)}),v=c,y=Function.prototype,g=y.call,m=v&&y.bind.bind(g,g),x=v?m:function(t){return function(){return g.apply(t,arguments)}},b=x,w=b({}.toString),_=b("".slice),S=function(t){return _(w(t),8,-1)},T=S,E=x,k=function(t){if("Function"===T(t))return E(t)},O="object"==typeof document&&document.all,C={all:O,IS_HTMLDDA:void 0===O&&void 0!==O},A=C.all,L=C.IS_HTMLDDA?function(t){return"function"==typeof t||t===A}:function(t){return"function"==typeof t},P={},M=!u((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),D=c,R=Function.prototype.call,I=D?R.bind(R):function(){return R.apply(R,arguments)},j={},z={}.propertyIsEnumerable,F=Object.getOwnPropertyDescriptor,N=F&&!z.call({1:2},1);j.f=N?function(t){var e=F(this,t);return!!e&&e.enumerable}:z;var B,W,Y=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},G=u,X=S,V=Object,U=x("".split),Z=G((function(){return!V("z").propertyIsEnumerable(0)}))?function(t){return"String"==X(t)?U(t,""):V(t)}:V,q=function(t){return null==t},H=q,$=TypeError,K=function(t){if(H(t))throw $("Can't call method on "+t);return t},J=Z,Q=K,tt=function(t){return J(Q(t))},et=L,rt=C.all,nt=C.IS_HTMLDDA?function(t){return"object"==typeof t?null!==t:et(t)||t===rt}:function(t){return"object"==typeof t?null!==t:et(t)},it={},ot=it,at=s,st=L,ut=function(t){return st(t)?t:void 0},ct=function(t,e){return arguments.length<2?ut(ot[t])||ut(at[t]):ot[t]&&ot[t][e]||at[t]&&at[t][e]},lt=x({}.isPrototypeOf),ht="undefined"!=typeof navigator&&String(navigator.userAgent)||"",ft=s,pt=ht,dt=ft.process,vt=ft.Deno,yt=dt&&dt.versions||vt&&vt.version,gt=yt&&yt.v8;gt&&(W=(B=gt.split("."))[0]>0&&B[0]<4?1:+(B[0]+B[1])),!W&&pt&&(!(B=pt.match(/Edge\/(\d+)/))||B[1]>=74)&&(B=pt.match(/Chrome\/(\d+)/))&&(W=+B[1]);var mt=W,xt=mt,bt=u,wt=!!Object.getOwnPropertySymbols&&!bt((function(){var t=Symbol();return!String(t)||!(Object(t)instanceof Symbol)||!Symbol.sham&&xt&&xt<41})),_t=wt&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,St=ct,Tt=L,Et=lt,kt=Object,Ot=_t?function(t){return"symbol"==typeof t}:function(t){var e=St("Symbol");return Tt(e)&&Et(e.prototype,kt(t))},Ct=String,At=function(t){try{return Ct(t)}catch(t){return"Object"}},Lt=L,Pt=At,Mt=TypeError,Dt=function(t){if(Lt(t))return t;throw Mt(Pt(t)+" is not a function")},Rt=Dt,It=q,jt=function(t,e){var r=t[e];return It(r)?void 0:Rt(r)},zt=I,Ft=L,Nt=nt,Bt=TypeError,Wt={},Yt={get exports(){return Wt},set exports(t){Wt=t}},Gt=s,Xt=Object.defineProperty,Vt=function(t,e){try{Xt(Gt,t,{value:e,configurable:!0,writable:!0})}catch(r){Gt[t]=e}return e},Ut="__core-js_shared__",Zt=s[Ut]||Vt(Ut,{}),qt=Zt;(Yt.exports=function(t,e){return qt[t]||(qt[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.29.0",mode:"pure",copyright:"© 2014-2023 Denis Pushkarev (zloirock.ru)",license:"https://github.com/zloirock/core-js/blob/v3.29.0/LICENSE",source:"https://github.com/zloirock/core-js"});var Ht=K,$t=Object,Kt=function(t){return $t(Ht(t))},Jt=Kt,Qt=x({}.hasOwnProperty),te=Object.hasOwn||function(t,e){return Qt(Jt(t),e)},ee=x,re=0,ne=Math.random(),ie=ee(1..toString),oe=function(t){return"Symbol("+(void 0===t?"":t)+")_"+ie(++re+ne,36)},ae=Wt,se=te,ue=oe,ce=wt,le=_t,he=s.Symbol,fe=ae("wks"),pe=le?he.for||he:he&&he.withoutSetter||ue,de=function(t){return se(fe,t)||(fe[t]=ce&&se(he,t)?he[t]:pe("Symbol."+t)),fe[t]},ve=I,ye=nt,ge=Ot,me=jt,xe=function(t,e){var r,n;if("string"===e&&Ft(r=t.toString)&&!Nt(n=zt(r,t)))return n;if(Ft(r=t.valueOf)&&!Nt(n=zt(r,t)))return n;if("string"!==e&&Ft(r=t.toString)&&!Nt(n=zt(r,t)))return n;throw Bt("Can't convert object to primitive value")},be=TypeError,we=de("toPrimitive"),_e=function(t,e){if(!ye(t)||ge(t))return t;var r,n=me(t,we);if(n){if(void 0===e&&(e="default"),r=ve(n,t,e),!ye(r)||ge(r))return r;throw be("Can't convert object to primitive value")}return void 0===e&&(e="number"),xe(t,e)},Se=Ot,Te=function(t){var e=_e(t,"string");return Se(e)?e:e+""},Ee=nt,ke=s.document,Oe=Ee(ke)&&Ee(ke.createElement),Ce=function(t){return Oe?ke.createElement(t):{}},Ae=Ce,Le=!M&&!u((function(){return 7!=Object.defineProperty(Ae("div"),"a",{get:function(){return 7}}).a})),Pe=M,Me=I,De=j,Re=Y,Ie=tt,je=Te,ze=te,Fe=Le,Ne=Object.getOwnPropertyDescriptor;P.f=Pe?Ne:function(t,e){if(t=Ie(t),e=je(e),Fe)try{return Ne(t,e)}catch(t){}if(ze(t,e))return Re(!Me(De.f,t,e),t[e])};var Be=u,We=L,Ye=/#|\.prototype\./,Ge=function(t,e){var r=Ve[Xe(t)];return r==Ze||r!=Ue&&(We(e)?Be(e):!!e)},Xe=Ge.normalize=function(t){return String(t).replace(Ye,".").toLowerCase()},Ve=Ge.data={},Ue=Ge.NATIVE="N",Ze=Ge.POLYFILL="P",qe=Ge,He=Dt,$e=c,Ke=k(k.bind),Je=function(t,e){return He(t),void 0===e?t:$e?Ke(t,e):function(){return t.apply(e,arguments)}},Qe={},tr=M&&u((function(){return 42!=Object.defineProperty((function(){}),"prototype",{value:42,writable:!1}).prototype})),er=nt,rr=String,nr=TypeError,ir=function(t){if(er(t))return t;throw nr(rr(t)+" is not an object")},or=M,ar=Le,sr=tr,ur=ir,cr=Te,lr=TypeError,hr=Object.defineProperty,fr=Object.getOwnPropertyDescriptor,pr="enumerable",dr="configurable",vr="writable";Qe.f=or?sr?function(t,e,r){if(ur(t),e=cr(e),ur(r),"function"==typeof t&&"prototype"===e&&"value"in r&&vr in r&&!r[vr]){var n=fr(t,e);n&&n[vr]&&(t[e]=r.value,r={configurable:dr in r?r[dr]:n[dr],enumerable:pr in r?r[pr]:n[pr],writable:!1})}return hr(t,e,r)}:hr:function(t,e,r){if(ur(t),e=cr(e),ur(r),ar)try{return hr(t,e,r)}catch(t){}if("get"in r||"set"in r)throw lr("Accessors not supported");return"value"in r&&(t[e]=r.value),t};var yr=Qe,gr=Y,mr=M?function(t,e,r){return yr.f(t,e,gr(1,r))}:function(t,e,r){return t[e]=r,t},xr=s,br=d,wr=k,_r=L,Sr=P.f,Tr=qe,Er=it,kr=Je,Or=mr,Cr=te,Ar=function(t){var e=function(r,n,i){if(this instanceof e){switch(arguments.length){case 0:return new t;case 1:return new t(r);case 2:return new t(r,n)}return new t(r,n,i)}return br(t,this,arguments)};return e.prototype=t.prototype,e},Lr=function(t,e){var r,n,i,o,a,s,u,c,l,h=t.target,f=t.global,p=t.stat,d=t.proto,v=f?xr:p?xr[h]:(xr[h]||{}).prototype,y=f?Er:Er[h]||Or(Er,h,{})[h],g=y.prototype;for(o in e)n=!(r=Tr(f?o:h+(p?".":"#")+o,t.forced))&&v&&Cr(v,o),s=y[o],n&&(u=t.dontCallGetSet?(l=Sr(v,o))&&l.value:v[o]),a=n&&u?u:e[o],n&&typeof s==typeof a||(c=t.bind&&n?kr(a,xr):t.wrap&&n?Ar(a):d&&_r(a)?wr(a):a,(t.sham||a&&a.sham||s&&s.sham)&&Or(c,"sham",!0),Or(y,o,c),d&&(Cr(Er,i=h+"Prototype")||Or(Er,i,{}),Or(Er[i],o,a),t.real&&g&&(r||!g[o])&&Or(g,o,a)))},Pr=S,Mr=Array.isArray||function(t){return"Array"==Pr(t)},Dr=Math.ceil,Rr=Math.floor,Ir=Math.trunc||function(t){var e=+t;return(e>0?Rr:Dr)(e)},jr=function(t){var e=+t;return e!=e||0===e?0:Ir(e)},zr=jr,Fr=Math.min,Nr=function(t){return t>0?Fr(zr(t),9007199254740991):0},Br=function(t){return Nr(t.length)},Wr=TypeError,Yr=function(t){if(t>9007199254740991)throw Wr("Maximum allowed index exceeded");return t},Gr=Te,Xr=Qe,Vr=Y,Ur=function(t,e,r){var n=Gr(e);n in t?Xr.f(t,n,Vr(0,r)):t[n]=r},Zr={};Zr[de("toStringTag")]="z";var qr="[object z]"===String(Zr),Hr=qr,$r=L,Kr=S,Jr=de("toStringTag"),Qr=Object,tn="Arguments"==Kr(function(){return arguments}()),en=Hr?Kr:function(t){var e,r,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(r=function(t,e){try{return t[e]}catch(t){}}(e=Qr(t),Jr))?r:tn?Kr(e):"Object"==(n=Kr(e))&&$r(e.callee)?"Arguments":n},rn=L,nn=Zt,on=x(Function.toString);rn(nn.inspectSource)||(nn.inspectSource=function(t){return on(t)});var an=nn.inspectSource,sn=x,un=u,cn=L,ln=en,hn=an,fn=function(){},pn=[],dn=ct("Reflect","construct"),vn=/^\s*(?:class|function)\b/,yn=sn(vn.exec),gn=!vn.exec(fn),mn=function(t){if(!cn(t))return!1;try{return dn(fn,pn,t),!0}catch(t){return!1}},xn=function(t){if(!cn(t))return!1;switch(ln(t)){case"AsyncFunction":case"GeneratorFunction":case"AsyncGeneratorFunction":return!1}try{return gn||!!yn(vn,hn(t))}catch(t){return!0}};xn.sham=!0;var bn=!dn||un((function(){var t;return mn(mn.call)||!mn(Object)||!mn((function(){t=!0}))||t}))?xn:mn,wn=Mr,_n=bn,Sn=nt,Tn=de("species"),En=Array,kn=function(t){var e;return wn(t)&&(e=t.constructor,(_n(e)&&(e===En||wn(e.prototype))||Sn(e)&&null===(e=e[Tn]))&&(e=void 0)),void 0===e?En:e},On=function(t,e){return new(kn(t))(0===e?0:e)},Cn=u,An=mt,Ln=de("species"),Pn=function(t){return An>=51||!Cn((function(){var e=[];return(e.constructor={})[Ln]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},Mn=Lr,Dn=u,Rn=Mr,In=nt,jn=Kt,zn=Br,Fn=Yr,Nn=Ur,Bn=On,Wn=Pn,Yn=mt,Gn=de("isConcatSpreadable"),Xn=Yn>=51||!Dn((function(){var t=[];return t[Gn]=!1,t.concat()[0]!==t})),Vn=function(t){if(!In(t))return!1;var e=t[Gn];return void 0!==e?!!e:Rn(t)};Mn({target:"Array",proto:!0,arity:1,forced:!Xn||!Wn("concat")},{concat:function(t){var e,r,n,i,o,a=jn(this),s=Bn(a,0),u=0;for(e=-1,n=arguments.length;e<n;e++)if(Vn(o=-1===e?a:arguments[e]))for(i=zn(o),Fn(u+i),r=0;r<i;r++,u++)r in o&&Nn(s,u,o[r]);else Fn(u+1),Nn(s,u++,o);return s.length=u,s}});var Un=en,Zn=String,qn=function(t){if("Symbol"===Un(t))throw TypeError("Cannot convert a Symbol value to a string");return Zn(t)},Hn={},$n=jr,Kn=Math.max,Jn=Math.min,Qn=function(t,e){var r=$n(t);return r<0?Kn(r+e,0):Jn(r,e)},ti=tt,ei=Qn,ri=Br,ni=function(t){return function(e,r,n){var i,o=ti(e),a=ri(o),s=ei(n,a);if(t&&r!=r){for(;a>s;)if((i=o[s++])!=i)return!0}else for(;a>s;s++)if((t||s in o)&&o[s]===r)return t||s||0;return!t&&-1}},ii={includes:ni(!0),indexOf:ni(!1)},oi={},ai=te,si=tt,ui=ii.indexOf,ci=oi,li=x([].push),hi=function(t,e){var r,n=si(t),i=0,o=[];for(r in n)!ai(ci,r)&&ai(n,r)&&li(o,r);for(;e.length>i;)ai(n,r=e[i++])&&(~ui(o,r)||li(o,r));return o},fi=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],pi=hi,di=fi,vi=Object.keys||function(t){return pi(t,di)},yi=M,gi=tr,mi=Qe,xi=ir,bi=tt,wi=vi;Hn.f=yi&&!gi?Object.defineProperties:function(t,e){xi(t);for(var r,n=bi(e),i=wi(e),o=i.length,a=0;o>a;)mi.f(t,r=i[a++],n[r]);return t};var _i,Si=ct("document","documentElement"),Ti=oe,Ei=Wt("keys"),ki=function(t){return Ei[t]||(Ei[t]=Ti(t))},Oi=ir,Ci=Hn,Ai=fi,Li=oi,Pi=Si,Mi=Ce,Di="prototype",Ri="script",Ii=ki("IE_PROTO"),ji=function(){},zi=function(t){return"<"+Ri+">"+t+"</"+Ri+">"},Fi=function(t){t.write(zi("")),t.close();var e=t.parentWindow.Object;return t=null,e},Ni=function(){try{_i=new ActiveXObject("htmlfile")}catch(t){}var t,e,r;Ni="undefined"!=typeof document?document.domain&&_i?Fi(_i):(e=Mi("iframe"),r="java"+Ri+":",e.style.display="none",Pi.appendChild(e),e.src=String(r),(t=e.contentWindow.document).open(),t.write(zi("document.F=Object")),t.close(),t.F):Fi(_i);for(var n=Ai.length;n--;)delete Ni[Di][Ai[n]];return Ni()};Li[Ii]=!0;var Bi=Object.create||function(t,e){var r;return null!==t?(ji[Di]=Oi(t),r=new ji,ji[Di]=null,r[Ii]=t):r=Ni(),void 0===e?r:Ci.f(r,e)},Wi={},Yi=hi,Gi=fi.concat("length","prototype");Wi.f=Object.getOwnPropertyNames||function(t){return Yi(t,Gi)};var Xi={},Vi=Qn,Ui=Br,Zi=Ur,qi=Array,Hi=Math.max,$i=function(t,e,r){for(var n=Ui(t),i=Vi(e,n),o=Vi(void 0===r?n:r,n),a=qi(Hi(o-i,0)),s=0;i<o;i++,s++)Zi(a,s,t[i]);return a.length=s,a},Ki=S,Ji=tt,Qi=Wi.f,to=$i,eo="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[];Xi.f=function(t){return eo&&"Window"==Ki(t)?function(t){try{return Qi(t)}catch(t){return to(eo)}}(t):Qi(Ji(t))};var ro={};ro.f=Object.getOwnPropertySymbols;var no=mr,io=function(t,e,r,n){return n&&n.enumerable?t[e]=r:no(t,e,r),t},oo=Qe,ao=function(t,e,r){return oo.f(t,e,r)},so={},uo=de;so.f=uo;var co,lo,ho,fo=it,po=te,vo=so,yo=Qe.f,go=function(t){var e=fo.Symbol||(fo.Symbol={});po(e,t)||yo(e,t,{value:vo.f(t)})},mo=I,xo=ct,bo=de,wo=io,_o=function(){var t=xo("Symbol"),e=t&&t.prototype,r=e&&e.valueOf,n=bo("toPrimitive");e&&!e[n]&&wo(e,n,(function(t){return mo(r,this)}),{arity:1})},So=en,To=qr?{}.toString:function(){return"[object "+So(this)+"]"},Eo=qr,ko=Qe.f,Oo=mr,Co=te,Ao=To,Lo=de("toStringTag"),Po=function(t,e,r,n){if(t){var i=r?t:t.prototype;Co(i,Lo)||ko(i,Lo,{configurable:!0,value:e}),n&&!Eo&&Oo(i,"toString",Ao)}},Mo=L,Do=s.WeakMap,Ro=Mo(Do)&&/native code/.test(String(Do)),Io=s,jo=nt,zo=mr,Fo=te,No=Zt,Bo=ki,Wo=oi,Yo="Object already initialized",Go=Io.TypeError,Xo=Io.WeakMap;if(Ro||No.state){var Vo=No.state||(No.state=new Xo);Vo.get=Vo.get,Vo.has=Vo.has,Vo.set=Vo.set,co=function(t,e){if(Vo.has(t))throw Go(Yo);return e.facade=t,Vo.set(t,e),e},lo=function(t){return Vo.get(t)||{}},ho=function(t){return Vo.has(t)}}else{var Uo=Bo("state");Wo[Uo]=!0,co=function(t,e){if(Fo(t,Uo))throw Go(Yo);return e.facade=t,zo(t,Uo,e),e},lo=function(t){return Fo(t,Uo)?t[Uo]:{}},ho=function(t){return Fo(t,Uo)}}var Zo={set:co,get:lo,has:ho,enforce:function(t){return ho(t)?lo(t):co(t,{})},getterFor:function(t){return function(e){var r;if(!jo(e)||(r=lo(e)).type!==t)throw Go("Incompatible receiver, "+t+" required");return r}}},qo=Je,Ho=Z,$o=Kt,Ko=Br,Jo=On,Qo=x([].push),ta=function(t){var e=1==t,r=2==t,n=3==t,i=4==t,o=6==t,a=7==t,s=5==t||o;return function(u,c,l,h){for(var f,p,d=$o(u),v=Ho(d),y=qo(c,l),g=Ko(v),m=0,x=h||Jo,b=e?x(u,g):r||a?x(u,0):void 0;g>m;m++)if((s||m in v)&&(p=y(f=v[m],m,d),t))if(e)b[m]=p;else if(p)switch(t){case 3:return!0;case 5:return f;case 6:return m;case 2:Qo(b,f)}else switch(t){case 4:return!1;case 7:Qo(b,f)}return o?-1:n||i?i:b}},ea={forEach:ta(0),map:ta(1),filter:ta(2),some:ta(3),every:ta(4),find:ta(5),findIndex:ta(6),filterReject:ta(7)},ra=Lr,na=s,ia=I,oa=x,aa=M,sa=wt,ua=u,ca=te,la=lt,ha=ir,fa=tt,pa=Te,da=qn,va=Y,ya=Bi,ga=vi,ma=Wi,xa=Xi,ba=ro,wa=P,_a=Qe,Sa=Hn,Ta=j,Ea=io,ka=ao,Oa=Wt,Ca=oi,Aa=oe,La=de,Pa=so,Ma=go,Da=_o,Ra=Po,Ia=Zo,ja=ea.forEach,za=ki("hidden"),Fa="Symbol",Na="prototype",Ba=Ia.set,Wa=Ia.getterFor(Fa),Ya=Object[Na],Ga=na.Symbol,Xa=Ga&&Ga[Na],Va=na.TypeError,Ua=na.QObject,Za=wa.f,qa=_a.f,Ha=xa.f,$a=Ta.f,Ka=oa([].push),Ja=Oa("symbols"),Qa=Oa("op-symbols"),ts=Oa("wks"),es=!Ua||!Ua[Na]||!Ua[Na].findChild,rs=aa&&ua((function(){return 7!=ya(qa({},"a",{get:function(){return qa(this,"a",{value:7}).a}})).a}))?function(t,e,r){var n=Za(Ya,e);n&&delete Ya[e],qa(t,e,r),n&&t!==Ya&&qa(Ya,e,n)}:qa,ns=function(t,e){var r=Ja[t]=ya(Xa);return Ba(r,{type:Fa,tag:t,description:e}),aa||(r.description=e),r},is=function(t,e,r){t===Ya&&is(Qa,e,r),ha(t);var n=pa(e);return ha(r),ca(Ja,n)?(r.enumerable?(ca(t,za)&&t[za][n]&&(t[za][n]=!1),r=ya(r,{enumerable:va(0,!1)})):(ca(t,za)||qa(t,za,va(1,{})),t[za][n]=!0),rs(t,n,r)):qa(t,n,r)},os=function(t,e){ha(t);var r=fa(e),n=ga(r).concat(cs(r));return ja(n,(function(e){aa&&!ia(as,r,e)||is(t,e,r[e])})),t},as=function(t){var e=pa(t),r=ia($a,this,e);return!(this===Ya&&ca(Ja,e)&&!ca(Qa,e))&&(!(r||!ca(this,e)||!ca(Ja,e)||ca(this,za)&&this[za][e])||r)},ss=function(t,e){var r=fa(t),n=pa(e);if(r!==Ya||!ca(Ja,n)||ca(Qa,n)){var i=Za(r,n);return!i||!ca(Ja,n)||ca(r,za)&&r[za][n]||(i.enumerable=!0),i}},us=function(t){var e=Ha(fa(t)),r=[];return ja(e,(function(t){ca(Ja,t)||ca(Ca,t)||Ka(r,t)})),r},cs=function(t){var e=t===Ya,r=Ha(e?Qa:fa(t)),n=[];return ja(r,(function(t){!ca(Ja,t)||e&&!ca(Ya,t)||Ka(n,Ja[t])})),n};sa||(Ea(Xa=(Ga=function(){if(la(Xa,this))throw Va("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?da(arguments[0]):void 0,e=Aa(t),r=function(t){this===Ya&&ia(r,Qa,t),ca(this,za)&&ca(this[za],e)&&(this[za][e]=!1),rs(this,e,va(1,t))};return aa&&es&&rs(Ya,e,{configurable:!0,set:r}),ns(e,t)})[Na],"toString",(function(){return Wa(this).tag})),Ea(Ga,"withoutSetter",(function(t){return ns(Aa(t),t)})),Ta.f=as,_a.f=is,Sa.f=os,wa.f=ss,ma.f=xa.f=us,ba.f=cs,Pa.f=function(t){return ns(La(t),t)},aa&&ka(Xa,"description",{configurable:!0,get:function(){return Wa(this).description}})),ra({global:!0,constructor:!0,wrap:!0,forced:!sa,sham:!sa},{Symbol:Ga}),ja(ga(ts),(function(t){Ma(t)})),ra({target:Fa,stat:!0,forced:!sa},{useSetter:function(){es=!0},useSimple:function(){es=!1}}),ra({target:"Object",stat:!0,forced:!sa,sham:!aa},{create:function(t,e){return void 0===e?ya(t):os(ya(t),e)},defineProperty:is,defineProperties:os,getOwnPropertyDescriptor:ss}),ra({target:"Object",stat:!0,forced:!sa},{getOwnPropertyNames:us}),Da(),Ra(Ga,Fa),Ca[za]=!0;var ls=wt&&!!Symbol.for&&!!Symbol.keyFor,hs=Lr,fs=ct,ps=te,ds=qn,vs=Wt,ys=ls,gs=vs("string-to-symbol-registry"),ms=vs("symbol-to-string-registry");hs({target:"Symbol",stat:!0,forced:!ys},{for:function(t){var e=ds(t);if(ps(gs,e))return gs[e];var r=fs("Symbol")(e);return gs[e]=r,ms[r]=e,r}});var xs=Lr,bs=te,ws=Ot,_s=At,Ss=ls,Ts=Wt("symbol-to-string-registry");xs({target:"Symbol",stat:!0,forced:!Ss},{keyFor:function(t){if(!ws(t))throw TypeError(_s(t)+" is not a symbol");if(bs(Ts,t))return Ts[t]}});var Es=x([].slice),ks=Mr,Os=L,Cs=S,As=qn,Ls=x([].push),Ps=Lr,Ms=ct,Ds=d,Rs=I,Is=x,js=u,zs=L,Fs=Ot,Ns=Es,Bs=function(t){if(Os(t))return t;if(ks(t)){for(var e=t.length,r=[],n=0;n<e;n++){var i=t[n];"string"==typeof i?Ls(r,i):"number"!=typeof i&&"Number"!=Cs(i)&&"String"!=Cs(i)||Ls(r,As(i))}var o=r.length,a=!0;return function(t,e){if(a)return a=!1,e;if(ks(this))return e;for(var n=0;n<o;n++)if(r[n]===t)return e}}},Ws=wt,Ys=String,Gs=Ms("JSON","stringify"),Xs=Is(/./.exec),Vs=Is("".charAt),Us=Is("".charCodeAt),Zs=Is("".replace),qs=Is(1..toString),Hs=/[\uD800-\uDFFF]/g,$s=/^[\uD800-\uDBFF]$/,Ks=/^[\uDC00-\uDFFF]$/,Js=!Ws||js((function(){var t=Ms("Symbol")();return"[null]"!=Gs([t])||"{}"!=Gs({a:t})||"{}"!=Gs(Object(t))})),Qs=js((function(){return'"\\udf06\\ud834"'!==Gs("\udf06\ud834")||'"\\udead"'!==Gs("\udead")})),tu=function(t,e){var r=Ns(arguments),n=Bs(e);if(zs(n)||void 0!==t&&!Fs(t))return r[1]=function(t,e){if(zs(n)&&(e=Rs(n,this,Ys(t),e)),!Fs(e))return e},Ds(Gs,null,r)},eu=function(t,e,r){var n=Vs(r,e-1),i=Vs(r,e+1);return Xs($s,t)&&!Xs(Ks,i)||Xs(Ks,t)&&!Xs($s,n)?"\\u"+qs(Us(t,0),16):t};Gs&&Ps({target:"JSON",stat:!0,arity:3,forced:Js||Qs},{stringify:function(t,e,r){var n=Ns(arguments),i=Ds(Js?tu:Gs,null,n);return Qs&&"string"==typeof i?Zs(i,Hs,eu):i}});var ru=ro,nu=Kt;Lr({target:"Object",stat:!0,forced:!wt||u((function(){ru.f(1)}))},{getOwnPropertySymbols:function(t){var e=ru.f;return e?e(nu(t)):[]}}),go("asyncIterator"),go("hasInstance"),go("isConcatSpreadable"),go("iterator"),go("match"),go("matchAll"),go("replace"),go("search"),go("species"),go("split");var iu=_o;go("toPrimitive"),iu();var ou=ct,au=Po;go("toStringTag"),au(ou("Symbol"),"Symbol"),go("unscopables"),Po(s.JSON,"JSON",!0);var su,uu,cu,lu=it.Symbol,hu={},fu=M,pu=te,du=Function.prototype,vu=fu&&Object.getOwnPropertyDescriptor,yu=pu(du,"name"),gu={EXISTS:yu,PROPER:yu&&"something"===function(){}.name,CONFIGURABLE:yu&&(!fu||fu&&vu(du,"name").configurable)},mu=!u((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),xu=te,bu=L,wu=Kt,_u=mu,Su=ki("IE_PROTO"),Tu=Object,Eu=Tu.prototype,ku=_u?Tu.getPrototypeOf:function(t){var e=wu(t);if(xu(e,Su))return e[Su];var r=e.constructor;return bu(r)&&e instanceof r?r.prototype:e instanceof Tu?Eu:null},Ou=u,Cu=L,Au=nt,Lu=Bi,Pu=ku,Mu=io,Du=de("iterator"),Ru=!1;[].keys&&("next"in(cu=[].keys())?(uu=Pu(Pu(cu)))!==Object.prototype&&(su=uu):Ru=!0);var Iu=!Au(su)||Ou((function(){var t={};return su[Du].call(t)!==t}));Cu((su=Iu?{}:Lu(su))[Du])||Mu(su,Du,(function(){return this}));var ju={IteratorPrototype:su,BUGGY_SAFARI_ITERATORS:Ru},zu=ju.IteratorPrototype,Fu=Bi,Nu=Y,Bu=Po,Wu=hu,Yu=function(){return this},Gu=x,Xu=Dt,Vu=L,Uu=String,Zu=TypeError,qu=function(t,e,r){try{return Gu(Xu(Object.getOwnPropertyDescriptor(t,e)[r]))}catch(t){}},Hu=ir,$u=function(t){if("object"==typeof t||Vu(t))return t;throw Zu("Can't set "+Uu(t)+" as a prototype")},Ku=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,r={};try{(t=qu(Object.prototype,"__proto__","set"))(r,[]),e=r instanceof Array}catch(t){}return function(r,n){return Hu(r),$u(n),e?t(r,n):r.__proto__=n,r}}():void 0),Ju=Lr,Qu=I,tc=function(t,e,r,n){var i=e+" Iterator";return t.prototype=Fu(zu,{next:Nu(+!n,r)}),Bu(t,i,!1,!0),Wu[i]=Yu,t},ec=ku,rc=Po,nc=io,ic=hu,oc=gu.PROPER,ac=ju.BUGGY_SAFARI_ITERATORS,sc=de("iterator"),uc="keys",cc="values",lc="entries",hc=function(){return this},fc=function(t,e,r,n,i,o,a){tc(r,e,n);var s,u,c,l=function(t){if(t===i&&v)return v;if(!ac&&t in p)return p[t];switch(t){case uc:case cc:case lc:return function(){return new r(this,t)}}return function(){return new r(this)}},h=e+" Iterator",f=!1,p=t.prototype,d=p[sc]||p["@@iterator"]||i&&p[i],v=!ac&&d||l(i),y="Array"==e&&p.entries||d;if(y&&(s=ec(y.call(new t)))!==Object.prototype&&s.next&&(rc(s,h,!0,!0),ic[h]=hc),oc&&i==cc&&d&&d.name!==cc&&(f=!0,v=function(){return Qu(d,this)}),i)if(u={values:l(cc),keys:o?v:l(uc),entries:l(lc)},a)for(c in u)(ac||f||!(c in p))&&nc(p,c,u[c]);else Ju({target:e,proto:!0,forced:ac||f},u);return a&&p[sc]!==v&&nc(p,sc,v,{name:i}),ic[e]=v,u},pc=function(t,e){return{value:t,done:e}},dc=tt,vc=hu,yc=Zo;Qe.f;var gc=fc,mc=pc,xc="Array Iterator",bc=yc.set,wc=yc.getterFor(xc);gc(Array,"Array",(function(t,e){bc(this,{type:xc,target:dc(t),index:0,kind:e})}),(function(){var t=wc(this),e=t.target,r=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,mc(void 0,!0)):mc("keys"==r?n:"values"==r?e[n]:[n,e[n]],!1)}),"values"),vc.Arguments=vc.Array;var _c={CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0},Sc=s,Tc=en,Ec=mr,kc=hu,Oc=de("toStringTag");for(var Cc in _c){var Ac=Sc[Cc],Lc=Ac&&Ac.prototype;Lc&&Tc(Lc)!==Oc&&Ec(Lc,Oc,Cc),kc[Cc]=kc.Array}var Pc=lu;go("dispose");var Mc=Pc;go("asyncDispose");var Dc=Lr,Rc=x,Ic=ct("Symbol"),jc=Ic.keyFor,zc=Rc(Ic.prototype.valueOf);Dc({target:"Symbol",stat:!0},{isRegistered:function(t){try{return void 0!==jc(zc(t))}catch(t){return!1}}});for(var Fc=Lr,Nc=Wt,Bc=ct,Wc=x,Yc=Ot,Gc=de,Xc=Bc("Symbol"),Vc=Xc.isWellKnown,Uc=Bc("Object","getOwnPropertyNames"),Zc=Wc(Xc.prototype.valueOf),qc=Nc("wks"),Hc=0,$c=Uc(Xc),Kc=$c.length;Hc<Kc;Hc++)try{var Jc=$c[Hc];Yc(Xc[Jc])&&Gc(Jc)}catch(t){}Fc({target:"Symbol",stat:!0,forced:!0},{isWellKnown:function(t){if(Vc&&Vc(t))return!0;try{for(var e=Zc(t),r=0,n=Uc(qc),i=n.length;r<i;r++)if(qc[n[r]]==e)return!0}catch(t){}return!1}}),go("matcher"),go("metadataKey"),go("observable"),go("metadata"),go("patternMatch"),go("replaceAll");var Qc=Mc;o.exports=Qc,n.exports=i;var tl=e(r),el={},rl={get exports(){return el},set exports(t){el=t}},nl={},il={get exports(){return nl},set exports(t){nl=t}},ol=x,al=jr,sl=qn,ul=K,cl=ol("".charAt),ll=ol("".charCodeAt),hl=ol("".slice),fl=function(t){return function(e,r){var n,i,o=sl(ul(e)),a=al(r),s=o.length;return a<0||a>=s?t?"":void 0:(n=ll(o,a))<55296||n>56319||a+1===s||(i=ll(o,a+1))<56320||i>57343?t?cl(o,a):n:t?hl(o,a,a+2):i-56320+(n-55296<<10)+65536}},pl={codeAt:fl(!1),charAt:fl(!0)}.charAt,dl=qn,vl=Zo,yl=fc,gl=pc,ml="String Iterator",xl=vl.set,bl=vl.getterFor(ml);yl(String,"String",(function(t){xl(this,{type:ml,string:dl(t),index:0})}),(function(){var t,e=bl(this),r=e.string,n=e.index;return n>=r.length?gl(void 0,!0):(t=pl(r,n),e.index+=t.length,gl(t,!1))}));var wl=so.f("iterator"),_l=wl;il.exports=_l,rl.exports=nl;var Sl=e(el);function Tl(t){return Tl="function"==typeof tl&&"symbol"==typeof Sl?function(t){return typeof t}:function(t){return t&&"function"==typeof tl&&t.constructor===tl&&t!==tl.prototype?"symbol":typeof t},Tl(t)}var El={},kl={get exports(){return El},set exports(t){El=t}},Ol=At,Cl=TypeError,Al=function(t,e){if(!delete t[e])throw Cl("Cannot delete property "+Ol(e)+" of "+Ol(t))},Ll=$i,Pl=Math.floor,Ml=function(t,e){var r=t.length,n=Pl(r/2);return r<8?Dl(t,e):Rl(t,Ml(Ll(t,0,n),e),Ml(Ll(t,n),e),e)},Dl=function(t,e){for(var r,n,i=t.length,o=1;o<i;){for(n=o,r=t[o];n&&e(t[n-1],r)>0;)t[n]=t[--n];n!==o++&&(t[n]=r)}return t},Rl=function(t,e,r,n){for(var i=e.length,o=r.length,a=0,s=0;a<i||s<o;)t[a+s]=a<i&&s<o?n(e[a],r[s])<=0?e[a++]:r[s++]:a<i?e[a++]:r[s++];return t},Il=Ml,jl=u,zl=function(t,e){var r=[][t];return!!r&&jl((function(){r.call(null,e||function(){return 1},1)}))},Fl=ht.match(/firefox\/(\d+)/i),Nl=!!Fl&&+Fl[1],Bl=/MSIE|Trident/.test(ht),Wl=ht.match(/AppleWebKit\/(\d+)\./),Yl=!!Wl&&+Wl[1],Gl=Lr,Xl=x,Vl=Dt,Ul=Kt,Zl=Br,ql=Al,Hl=qn,$l=u,Kl=Il,Jl=zl,Ql=Nl,th=Bl,eh=mt,rh=Yl,nh=[],ih=Xl(nh.sort),oh=Xl(nh.push),ah=$l((function(){nh.sort(void 0)})),sh=$l((function(){nh.sort(null)})),uh=Jl("sort"),ch=!$l((function(){if(eh)return eh<70;if(!(Ql&&Ql>3)){if(th)return!0;if(rh)return rh<603;var t,e,r,n,i="";for(t=65;t<76;t++){switch(e=String.fromCharCode(t),t){case 66:case 69:case 70:case 72:r=3;break;case 68:case 71:r=4;break;default:r=2}for(n=0;n<47;n++)nh.push({k:e+n,v:r})}for(nh.sort((function(t,e){return e.v-t.v})),n=0;n<nh.length;n++)e=nh[n].k.charAt(0),i.charAt(i.length-1)!==e&&(i+=e);return"DGBEFHACIJK"!==i}}));Gl({target:"Array",proto:!0,forced:ah||!sh||!uh||!ch},{sort:function(t){void 0!==t&&Vl(t);var e=Ul(this);if(ch)return void 0===t?ih(e):ih(e,t);var r,n,i=[],o=Zl(e);for(n=0;n<o;n++)n in e&&oh(i,e[n]);for(Kl(i,function(t){return function(e,r){return void 0===r?-1:void 0===e?1:void 0!==t?+t(e,r)||0:Hl(e)>Hl(r)?1:-1}}(t)),r=Zl(i),n=0;n<r;)e[n]=i[n++];for(;n<o;)ql(e,n++);return e}});var lh=it,hh=function(t){return lh[t+"Prototype"]},fh=hh("Array").sort,ph=lt,dh=fh,vh=Array.prototype,yh=function(t){var e=t.sort;return t===vh||ph(vh,t)&&e===vh.sort?dh:e};kl.exports=yh;var gh=e(El),mh={},xh={get exports(){return mh},set exports(t){mh=t}},bh=Lr,wh=ii.indexOf,_h=zl,Sh=k([].indexOf),Th=!!Sh&&1/Sh([1],1,-0)<0;bh({target:"Array",proto:!0,forced:Th||!_h("indexOf")},{indexOf:function(t){var e=arguments.length>1?arguments[1]:void 0;return Th?Sh(this,t,e)||0:wh(this,t,e)}});var Eh=hh("Array").indexOf,kh=lt,Oh=Eh,Ch=Array.prototype,Ah=function(t){var e=t.indexOf;return t===Ch||kh(Ch,t)&&e===Ch.indexOf?Oh:e};xh.exports=Ah;var Lh=e(mh),Ph={},Mh={get exports(){return Ph},set exports(t){Ph=t}},Dh=ea.filter;Lr({target:"Array",proto:!0,forced:!Pn("filter")},{filter:function(t){return Dh(this,t,arguments.length>1?arguments[1]:void 0)}});var Rh=hh("Array").filter,Ih=lt,jh=Rh,zh=Array.prototype,Fh=function(t){var e=t.filter;return t===zh||Ih(zh,t)&&e===zh.filter?jh:e};Mh.exports=Fh;var Nh=e(Ph),Bh={},Wh={get exports(){return Bh},set exports(t){Bh=t}},Yh="\t\n\v\f\r                　\u2028\u2029\ufeff",Gh=K,Xh=qn,Vh=Yh,Uh=x("".replace),Zh=RegExp("^["+Vh+"]+"),qh=RegExp("(^|[^"+Vh+"])["+Vh+"]+$"),Hh=function(t){return function(e){var r=Xh(Gh(e));return 1&t&&(r=Uh(r,Zh,"")),2&t&&(r=Uh(r,qh,"$1")),r}},$h={start:Hh(1),end:Hh(2),trim:Hh(3)},Kh=s,Jh=u,Qh=qn,tf=$h.trim,ef=Yh,rf=x("".charAt),nf=Kh.parseFloat,of=Kh.Symbol,af=of&&of.iterator,sf=1/nf(ef+"-0")!=-1/0||af&&!Jh((function(){nf(Object(af))}))?function(t){var e=tf(Qh(t)),r=nf(e);return 0===r&&"-"==rf(e,0)?-0:r}:nf;Lr({global:!0,forced:parseFloat!=sf},{parseFloat:sf});var uf=it.parseFloat;Wh.exports=uf;var cf=e(Bh),lf={},hf={get exports(){return lf},set exports(t){lf=t}},ff=Kt,pf=Qn,df=Br;Lr({target:"Array",proto:!0},{fill:function(t){for(var e=ff(this),r=df(e),n=arguments.length,i=pf(n>1?arguments[1]:void 0,r),o=n>2?arguments[2]:void 0,a=void 0===o?r:pf(o,r);a>i;)e[i++]=t;return e}});var vf=hh("Array").fill,yf=lt,gf=vf,mf=Array.prototype,xf=function(t){var e=t.fill;return t===mf||yf(mf,t)&&e===mf.fill?gf:e};hf.exports=xf;var bf=e(lf),wf={},_f={get exports(){return wf},set exports(t){wf=t}},Sf=hh("Array").values,Tf=en,Ef=te,kf=lt,Of=Sf,Cf=Array.prototype,Af={DOMTokenList:!0,NodeList:!0},Lf=function(t){var e=t.values;return t===Cf||kf(Cf,t)&&e===Cf.values||Ef(Af,Tf(t))?Of:e};_f.exports=Lf;var Pf=e(wf),Mf={},Df={get exports(){return Mf},set exports(t){Mf=t}},Rf=ea.forEach,If=zl("forEach")?[].forEach:function(t){return Rf(this,t,arguments.length>1?arguments[1]:void 0)};Lr({target:"Array",proto:!0,forced:[].forEach!=If},{forEach:If});var jf=hh("Array").forEach,zf=en,Ff=te,Nf=lt,Bf=jf,Wf=Array.prototype,Yf={DOMTokenList:!0,NodeList:!0},Gf=function(t){var e=t.forEach;return t===Wf||Nf(Wf,t)&&e===Wf.forEach||Ff(Yf,zf(t))?Bf:e};Df.exports=Gf;var Xf=e(Mf),Vf={},Uf={get exports(){return Vf},set exports(t){Vf=t}};Lr({target:"Array",stat:!0},{isArray:Mr});var Zf=it.Array.isArray;Uf.exports=Zf;var qf=e(Vf),Hf={},$f={get exports(){return Hf},set exports(t){Hf=t}};Lr({target:"Number",stat:!0},{isNaN:function(t){return t!=t}});var Kf=it.Number.isNaN;$f.exports=Kf;var Jf=e(Hf),Qf={},tp={get exports(){return Qf},set exports(t){Qf=t}},ep=hh("Array").concat,rp=lt,np=ep,ip=Array.prototype,op=function(t){var e=t.concat;return t===ip||rp(ip,t)&&e===ip.concat?np:e};tp.exports=op;var ap=e(Qf),sp={},up={get exports(){return sp},set exports(t){sp=t}},cp="function"==typeof Bun&&Bun&&"string"==typeof Bun.version,lp=TypeError,hp=function(t,e){if(t<e)throw lp("Not enough arguments");return t},fp=s,pp=d,dp=L,vp=cp,yp=ht,gp=Es,mp=hp,xp=fp.Function,bp=/MSIE .\./.test(yp)||vp&&function(){var t=fp.Bun.version.split(".");return t.length<3||0==t[0]&&(t[1]<3||3==t[1]&&0==t[2])}(),wp=function(t,e){var r=e?2:1;return bp?function(n,i){var o=mp(arguments.length,1)>r,a=dp(n)?n:xp(n),s=o?gp(arguments,r):[],u=o?function(){pp(a,this,s)}:a;return e?t(u,i):t(u)}:t},_p=Lr,Sp=s,Tp=wp(Sp.setInterval,!0);_p({global:!0,bind:!0,forced:Sp.setInterval!==Tp},{setInterval:Tp});var Ep=Lr,kp=s,Op=wp(kp.setTimeout,!0);Ep({global:!0,bind:!0,forced:kp.setTimeout!==Op},{setTimeout:Op});var Cp=it.setTimeout;up.exports=Cp;var Ap=e(sp),Lp={},Pp={get exports(){return Lp},set exports(t){Lp=t}},Mp=M,Dp=x,Rp=I,Ip=u,jp=vi,zp=ro,Fp=j,Np=Kt,Bp=Z,Wp=Object.assign,Yp=Object.defineProperty,Gp=Dp([].concat),Xp=!Wp||Ip((function(){if(Mp&&1!==Wp({b:1},Wp(Yp({},"a",{enumerable:!0,get:function(){Yp(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},r=Symbol(),n="abcdefghijklmnopqrst";return t[r]=7,n.split("").forEach((function(t){e[t]=t})),7!=Wp({},t)[r]||jp(Wp({},e)).join("")!=n}))?function(t,e){for(var r=Np(t),n=arguments.length,i=1,o=zp.f,a=Fp.f;n>i;)for(var s,u=Bp(arguments[i++]),c=o?Gp(jp(u),o(u)):jp(u),l=c.length,h=0;l>h;)s=c[h++],Mp&&!Rp(a,u,s)||(r[s]=u[s]);return r}:Wp,Vp=Xp;Lr({target:"Object",stat:!0,arity:2,forced:Object.assign!==Vp},{assign:Vp});var Up=it.Object.assign;Pp.exports=Up;var Zp=e(Lp),qp={},Hp={get exports(){return qp},set exports(t){qp=t}};!function(t){function e(t){if(t)return function(t){for(var r in e.prototype)t[r]=e.prototype[r];return t}(t)}Hp.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function r(){this.off(t,r),e.apply(this,arguments)}return r.fn=e,this.on(t,r),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var r,n=this._callbacks["$"+t];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var i=0;i<n.length;i++)if((r=n[i])===e||r.fn===e){n.splice(i,1);break}return 0===n.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),r=this._callbacks["$"+t],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(r){n=0;for(var i=(r=r.slice(0)).length;n<i;++n)r[n].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}();var $p=qp,Kp={},Jp={get exports(){return Kp},set exports(t){Kp=t}},Qp=I,td=ir,ed=jt,rd=function(t,e,r){var n,i;td(t);try{if(!(n=ed(t,"return"))){if("throw"===e)throw r;return r}n=Qp(n,t)}catch(t){i=!0,n=t}if("throw"===e)throw r;if(i)throw n;return td(n),r},nd=ir,id=rd,od=hu,ad=de("iterator"),sd=Array.prototype,ud=function(t){return void 0!==t&&(od.Array===t||sd[ad]===t)},cd=en,ld=jt,hd=q,fd=hu,pd=de("iterator"),dd=function(t){if(!hd(t))return ld(t,pd)||ld(t,"@@iterator")||fd[cd(t)]},vd=I,yd=Dt,gd=ir,md=At,xd=dd,bd=TypeError,wd=function(t,e){var r=arguments.length<2?xd(t):e;if(yd(r))return gd(vd(r,t));throw bd(md(t)+" is not iterable")},_d=Je,Sd=I,Td=Kt,Ed=function(t,e,r,n){try{return n?e(nd(r)[0],r[1]):e(r)}catch(e){id(t,"throw",e)}},kd=ud,Od=bn,Cd=Br,Ad=Ur,Ld=wd,Pd=dd,Md=Array,Dd=de("iterator"),Rd=!1;try{var Id=0,jd={next:function(){return{done:!!Id++}},return:function(){Rd=!0}};jd[Dd]=function(){return this},Array.from(jd,(function(){throw 2}))}catch(t){}var zd=function(t,e){if(!e&&!Rd)return!1;var r=!1;try{var n={};n[Dd]=function(){return{next:function(){return{done:r=!0}}}},t(n)}catch(t){}return r},Fd=function(t){var e=Td(t),r=Od(this),n=arguments.length,i=n>1?arguments[1]:void 0,o=void 0!==i;o&&(i=_d(i,n>2?arguments[2]:void 0));var a,s,u,c,l,h,f=Pd(e),p=0;if(!f||this===Md&&kd(f))for(a=Cd(e),s=r?new this(a):Md(a);a>p;p++)h=o?i(e[p],p):e[p],Ad(s,p,h);else for(l=(c=Ld(e,f)).next,s=r?new this:[];!(u=Sd(l,c)).done;p++)h=o?Ed(c,i,[u.value,p],!0):u.value,Ad(s,p,h);return s.length=p,s};Lr({target:"Array",stat:!0,forced:!zd((function(t){Array.from(t)}))},{from:Fd});var Nd=it.Array.from;Jp.exports=Nd;var Bd=e(Kp),Wd={},Yd={get exports(){return Wd},set exports(t){Wd=t}},Gd={},Xd=dd;({get exports(){return Gd},set exports(t){Gd=t}}).exports=Xd,Yd.exports=Gd;var Vd=e(Wd),Ud={},Zd={get exports(){return Ud},set exports(t){Ud=t}},qd=it.Object.getOwnPropertySymbols;Zd.exports=qd;var Hd=e(Ud),$d={},Kd={get exports(){return $d},set exports(t){$d=t}},Jd={},Qd={get exports(){return Jd},set exports(t){Jd=t}},tv=Lr,ev=u,rv=tt,nv=P.f,iv=M;tv({target:"Object",stat:!0,forced:!iv||ev((function(){nv(1)})),sham:!iv},{getOwnPropertyDescriptor:function(t,e){return nv(rv(t),e)}});var ov=it.Object,av=Qd.exports=function(t,e){return ov.getOwnPropertyDescriptor(t,e)};ov.getOwnPropertyDescriptor.sham&&(av.sham=!0);var sv=Jd;Kd.exports=sv;var uv=e($d),cv={},lv={get exports(){return cv},set exports(t){cv=t}},hv=ct,fv=Wi,pv=ro,dv=ir,vv=x([].concat),yv=hv("Reflect","ownKeys")||function(t){var e=fv.f(dv(t)),r=pv.f;return r?vv(e,r(t)):e},gv=yv,mv=tt,xv=P,bv=Ur;Lr({target:"Object",stat:!0,sham:!M},{getOwnPropertyDescriptors:function(t){for(var e,r,n=mv(t),i=xv.f,o=gv(n),a={},s=0;o.length>s;)void 0!==(r=i(n,e=o[s++]))&&bv(a,e,r);return a}});var wv=it.Object.getOwnPropertyDescriptors;lv.exports=wv;var _v=e(cv),Sv={},Tv={get exports(){return Sv},set exports(t){Sv=t}},Ev={},kv={get exports(){return Ev},set exports(t){Ev=t}},Ov=Lr,Cv=M,Av=Hn.f;Ov({target:"Object",stat:!0,forced:Object.defineProperties!==Av,sham:!Cv},{defineProperties:Av});var Lv=it.Object,Pv=kv.exports=function(t,e){return Lv.defineProperties(t,e)};Lv.defineProperties.sham&&(Pv.sham=!0);var Mv=Ev;Tv.exports=Mv;var Dv=e(Sv),Rv={},Iv={get exports(){return Rv},set exports(t){Rv=t}},jv={},zv={get exports(){return jv},set exports(t){jv=t}},Fv=Lr,Nv=M,Bv=Qe.f;Fv({target:"Object",stat:!0,forced:Object.defineProperty!==Bv,sham:!Nv},{defineProperty:Bv});var Wv=it.Object,Yv=zv.exports=function(t,e,r){return Wv.defineProperty(t,e,r)};Wv.defineProperty.sham&&(Yv.sham=!0);var Gv=jv;Iv.exports=Gv;var Xv=e(Rv);function Vv(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}var Uv={},Zv={get exports(){return Uv},set exports(t){Uv=t}},qv={},Hv=Gv;({get exports(){return qv},set exports(t){qv=t}}).exports=Hv,Zv.exports=qv;var $v=e(Uv),Kv={},Jv={get exports(){return Kv},set exports(t){Kv=t}},Qv={},ty={get exports(){return Qv},set exports(t){Qv=t}},ey=so.f("toPrimitive");ty.exports=ey,Jv.exports=Qv;var ry=e(Kv);function ny(t){var e=function(t,e){if("object"!==Tl(t)||null===t)return t;var r=t[ry];if(void 0!==r){var n=r.call(t,e||"default");if("object"!==Tl(n))return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===e?String:Number)(t)}(t,"string");return"symbol"===Tl(e)?e:String(e)}function iy(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),$v(t,ny(n.key),n)}}function oy(t,e,r){return e&&iy(t.prototype,e),r&&iy(t,r),$v(t,"prototype",{writable:!1}),t}function ay(t,e,r){return(e=ny(e))in t?$v(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t}var sy={},uy={get exports(){return sy},set exports(t){sy=t}},cy={},ly=Zf;({get exports(){return cy},set exports(t){cy=t}}).exports=ly,uy.exports=cy;var hy=e(sy);var fy={},py={get exports(){return fy},set exports(t){fy=t}},dy={},vy={get exports(){return dy},set exports(t){dy=t}},yy=Lr,gy=Mr,my=bn,xy=nt,by=Qn,wy=Br,_y=tt,Sy=Ur,Ty=de,Ey=Es,ky=Pn("slice"),Oy=Ty("species"),Cy=Array,Ay=Math.max;yy({target:"Array",proto:!0,forced:!ky},{slice:function(t,e){var r,n,i,o=_y(this),a=wy(o),s=by(t,a),u=by(void 0===e?a:e,a);if(gy(o)&&(r=o.constructor,(my(r)&&(r===Cy||gy(r.prototype))||xy(r)&&null===(r=r[Oy]))&&(r=void 0),r===Cy||void 0===r))return Ey(o,s,u);for(n=new(void 0===r?Cy:r)(Ay(u-s,0)),i=0;s<u;s++,i++)s in o&&Sy(n,i,o[s]);return n.length=i,n}});var Ly=hh("Array").slice,Py=lt,My=Ly,Dy=Array.prototype,Ry=function(t){var e=t.slice;return t===Dy||Py(Dy,t)&&e===Dy.slice?My:e},Iy=Ry;vy.exports=Iy,py.exports=dy;var jy=e(fy),zy={},Fy={get exports(){return zy},set exports(t){zy=t}},Ny={},By=Nd;({get exports(){return Ny},set exports(t){Ny=t}}).exports=By,Fy.exports=Ny;var Wy=e(zy);function Yy(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function Gy(t,e){var r;if(t){if("string"==typeof t)return Yy(t,e);var n=jy(r=Object.prototype.toString.call(t)).call(r,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?Wy(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Yy(t,e):void 0}}function Xy(t,e){return function(t){if(hy(t))return t}(t)||function(t,e){var r=null==t?null:void 0!==tl&&Vd(t)||t["@@iterator"];if(null!=r){var n,i,o,a,s=[],u=!0,c=!1;try{if(o=(r=r.call(t)).next,0===e){if(Object(r)!==r)return;u=!1}else for(;!(u=(n=o.call(r)).done)&&(s.push(n.value),s.length!==e);u=!0);}catch(t){c=!0,i=t}finally{try{if(!u&&null!=r.return&&(a=r.return(),Object(a)!==a))return}finally{if(c)throw i}}return s}}(t,e)||Gy(t,e)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Vy(t){return function(t){if(hy(t))return Yy(t)}(t)||function(t){if(void 0!==tl&&null!=Vd(t)||null!=t["@@iterator"])return Wy(t)}(t)||Gy(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Uy={};({get exports(){return Uy},set exports(t){Uy=t}}).exports=Pc;var Zy=e(Uy),qy={};({get exports(){return qy},set exports(t){qy=t}}).exports=Ry;var Hy=e(qy),$y={},Ky={get exports(){return $y},set exports(t){$y=t}};Lr({target:"Reflect",stat:!0},{ownKeys:yv});var Jy=it.Reflect.ownKeys;Ky.exports=Jy;var Qy=e($y),tg={},eg={get exports(){return tg},set exports(t){tg=t}},rg=ea.map;Lr({target:"Array",proto:!0,forced:!Pn("map")},{map:function(t){return rg(this,t,arguments.length>1?arguments[1]:void 0)}});var ng=hh("Array").map,ig=lt,og=ng,ag=Array.prototype,sg=function(t){var e=t.map;return t===ag||ig(ag,t)&&e===ag.map?og:e};eg.exports=sg;var ug=e(tg),cg={},lg={get exports(){return cg},set exports(t){cg=t}},hg=Kt,fg=vi;Lr({target:"Object",stat:!0,forced:u((function(){fg(1)}))},{keys:function(t){return fg(hg(t))}});var pg=it.Object.keys;lg.exports=pg;var dg=e(cg),vg={},yg={get exports(){return vg},set exports(t){vg=t}},gg=Lr,mg=Date,xg=x(mg.prototype.getTime);gg({target:"Date",stat:!0},{now:function(){return xg(new mg)}});var bg=it.Date.now;yg.exports=bg;var wg={},_g={get exports(){return wg},set exports(t){wg=t}},Sg=x,Tg=Dt,Eg=nt,kg=te,Og=Es,Cg=c,Ag=Function,Lg=Sg([].concat),Pg=Sg([].join),Mg={},Dg=function(t,e,r){if(!kg(Mg,e)){for(var n=[],i=0;i<e;i++)n[i]="a["+i+"]";Mg[e]=Ag("C,a","return new C("+Pg(n,",")+")")}return Mg[e](t,r)},Rg=Cg?Ag.bind:function(t){var e=Tg(this),r=e.prototype,n=Og(arguments,1),i=function(){var r=Lg(n,Og(arguments));return this instanceof i?Dg(e,r.length,r):e.apply(t,r)};return Eg(r)&&(i.prototype=r),i},Ig=Rg;Lr({target:"Function",proto:!0,forced:Function.bind!==Ig},{bind:Ig});var jg=hh("Function").bind,zg=lt,Fg=jg,Ng=Function.prototype,Bg=function(t){var e=t.bind;return t===Ng||zg(Ng,t)&&e===Ng.bind?Fg:e};_g.exports=Bg;var Wg=e(wg),Yg={},Gg={get exports(){return Yg},set exports(t){Yg=t}},Xg=Lr,Vg=Mr,Ug=x([].reverse),Zg=[1,2];Xg({target:"Array",proto:!0,forced:String(Zg)===String(Zg.reverse())},{reverse:function(){return Vg(this)&&(this.length=this.length),Ug(this)}});var qg=hh("Array").reverse,Hg=lt,$g=qg,Kg=Array.prototype,Jg=function(t){var e=t.reverse;return t===Kg||Hg(Kg,t)&&e===Kg.reverse?$g:e};Gg.exports=Jg;var Qg=e(Yg),tm={},em={get exports(){return tm},set exports(t){tm=t}},rm=M,nm=Mr,im=TypeError,om=Object.getOwnPropertyDescriptor,am=rm&&!function(){if(void 0!==this)return!0;try{Object.defineProperty([],"length",{writable:!1}).length=1}catch(t){return t instanceof TypeError}}(),sm=Lr,um=Kt,cm=Qn,lm=jr,hm=Br,fm=am?function(t,e){if(nm(t)&&!om(t,"length").writable)throw im("Cannot set read only .length");return t.length=e}:function(t,e){return t.length=e},pm=Yr,dm=On,vm=Ur,ym=Al,gm=Pn("splice"),mm=Math.max,xm=Math.min;sm({target:"Array",proto:!0,forced:!gm},{splice:function(t,e){var r,n,i,o,a,s,u=um(this),c=hm(u),l=cm(t,c),h=arguments.length;for(0===h?r=n=0:1===h?(r=0,n=c-l):(r=h-2,n=xm(mm(lm(e),0),c-l)),pm(c+r-n),i=dm(u,n),o=0;o<n;o++)(a=l+o)in u&&vm(i,o,u[a]);if(i.length=n,r<n){for(o=l;o<c-n;o++)s=o+r,(a=o+n)in u?u[s]=u[a]:ym(u,s);for(o=c;o>c-n+r;o--)ym(u,o-1)}else if(r>n)for(o=c-n;o>l;o--)s=o+r-1,(a=o+n-1)in u?u[s]=u[a]:ym(u,s);for(o=0;o<r;o++)u[o+l]=arguments[o+2];return fm(u,c-n+r),i}});var bm=hh("Array").splice,wm=lt,_m=bm,Sm=Array.prototype,Tm=function(t){var e=t.splice;return t===Sm||wm(Sm,t)&&e===Sm.splice?_m:e};em.exports=Tm;var Em=e(tm),km={},Om={get exports(){return km},set exports(t){km=t}},Cm=ii.includes;Lr({target:"Array",proto:!0,forced:u((function(){return!Array(1).includes()}))},{includes:function(t){return Cm(this,t,arguments.length>1?arguments[1]:void 0)}});var Am=hh("Array").includes,Lm=nt,Pm=S,Mm=de("match"),Dm=function(t){var e;return Lm(t)&&(void 0!==(e=t[Mm])?!!e:"RegExp"==Pm(t))},Rm=TypeError,Im=de("match"),jm=Lr,zm=function(t){if(Dm(t))throw Rm("The method doesn't accept regular expressions");return t},Fm=K,Nm=qn,Bm=function(t){var e=/./;try{"/./"[t](e)}catch(r){try{return e[Im]=!1,"/./"[t](e)}catch(t){}}return!1},Wm=x("".indexOf);jm({target:"String",proto:!0,forced:!Bm("includes")},{includes:function(t){return!!~Wm(Nm(Fm(this)),Nm(zm(t)),arguments.length>1?arguments[1]:void 0)}});var Ym=hh("String").includes,Gm=lt,Xm=Am,Vm=Ym,Um=Array.prototype,Zm=String.prototype,qm=function(t){var e=t.includes;return t===Um||Gm(Um,t)&&e===Um.includes?Xm:"string"==typeof t||t===Zm||Gm(Zm,t)&&e===Zm.includes?Vm:e};Om.exports=qm;var Hm=e(km),$m={},Km={get exports(){return $m},set exports(t){$m=t}},Jm=Kt,Qm=ku,tx=mu;Lr({target:"Object",stat:!0,forced:u((function(){Qm(1)})),sham:!tx},{getPrototypeOf:function(t){return Qm(Jm(t))}});var ex=it.Object.getPrototypeOf;Km.exports=ex;var rx=e($m),nx={},ix={get exports(){return nx},set exports(t){nx=t}},ox=M,ax=x,sx=vi,ux=tt,cx=ax(j.f),lx=ax([].push),hx=function(t){return function(e){for(var r,n=ux(e),i=sx(n),o=i.length,a=0,s=[];o>a;)r=i[a++],ox&&!cx(n,r)||lx(s,t?[r,n[r]]:n[r]);return s}},fx={entries:hx(!0),values:hx(!1)}.values;Lr({target:"Object",stat:!0},{values:function(t){return fx(t)}});var px=it.Object.values;ix.exports=px;var dx={},vx={get exports(){return dx},set exports(t){dx=t}},yx=s,gx=u,mx=x,xx=qn,bx=$h.trim,wx=Yh,_x=yx.parseInt,Sx=yx.Symbol,Tx=Sx&&Sx.iterator,Ex=/^[+-]?0x/i,kx=mx(Ex.exec),Ox=8!==_x(wx+"08")||22!==_x(wx+"0x16")||Tx&&!gx((function(){_x(Object(Tx))}))?function(t,e){var r=bx(xx(t));return _x(r,e>>>0||(kx(Ex,r)?16:10))}:_x;Lr({global:!0,forced:parseInt!=Ox},{parseInt:Ox});var Cx=it.parseInt;vx.exports=Cx;var Ax=e(dx),Lx={},Px={get exports(){return Lx},set exports(t){Lx=t}},Mx=gu.PROPER,Dx=u,Rx=Yh,Ix=$h.trim;Lr({target:"String",proto:!0,forced:function(t){return Dx((function(){return!!Rx[t]()||"​᠎"!=="​᠎"[t]()||Mx&&Rx[t].name!==t}))}("trim")},{trim:function(){return Ix(this)}});var jx=hh("String").trim,zx=lt,Fx=jx,Nx=String.prototype,Bx=function(t){var e=t.trim;return"string"==typeof t||t===Nx||zx(Nx,t)&&e===Nx.trim?Fx:e};Px.exports=Bx;var Wx={},Yx={get exports(){return Wx},set exports(t){Wx=t}};Lr({target:"Object",stat:!0,sham:!M},{create:Bi});var Gx=it.Object,Xx=function(t,e){return Gx.create(t,e)};Yx.exports=Xx;var Vx=e(Wx),Ux={},Zx={get exports(){return Ux},set exports(t){Ux=t}},qx=it,Hx=d;qx.JSON||(qx.JSON={stringify:JSON.stringify});var $x=function(t,e,r){return Hx(qx.JSON.stringify,null,arguments)};Zx.exports=$x;var Kx=e(Ux);
/*! Hammer.JS - v2.0.17-rc - 2019-12-16
 * http://naver.github.io/egjs
 *
 * Forked By Naver egjs
 * Copyright (c) hammerjs
 * Licensed under the MIT license */function Jx(){return Jx=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var r=arguments[e];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(t[n]=r[n])}return t},Jx.apply(this,arguments)}function Qx(t,e){t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t.__proto__=e}function tb(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var eb,rb="function"!=typeof Object.assign?function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),r=1;r<arguments.length;r++){var n=arguments[r];if(null!=n)for(var i in n)n.hasOwnProperty(i)&&(e[i]=n[i])}return e}:Object.assign,nb=["","webkit","Moz","MS","ms","o"],ib="undefined"==typeof document?{style:{}}:document.createElement("div"),ob="function",ab=Math.round,sb=Math.abs,ub=Date.now;function cb(t,e){for(var r,n,i=e[0].toUpperCase()+e.slice(1),o=0;o<nb.length;){if((n=(r=nb[o])?r+i:e)in t)return n;o++}}eb="undefined"==typeof window?{}:window;var lb=cb(ib.style,"touchAction"),hb=void 0!==lb;var fb="compute",pb="auto",db="manipulation",vb="none",yb="pan-x",gb="pan-y",mb=function(){if(!hb)return!1;var t={},e=eb.CSS&&eb.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(r){return t[r]=!e||eb.CSS.supports("touch-action",r)})),t}(),xb="ontouchstart"in eb,bb=void 0!==cb(eb,"PointerEvent"),wb=xb&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),_b="touch",Sb="mouse",Tb=25,Eb=1,kb=2,Ob=4,Cb=8,Ab=1,Lb=2,Pb=4,Mb=8,Db=16,Rb=Lb|Pb,Ib=Mb|Db,jb=Rb|Ib,zb=["x","y"],Fb=["clientX","clientY"];function Nb(t,e,r){var n;if(t)if(t.forEach)t.forEach(e,r);else if(void 0!==t.length)for(n=0;n<t.length;)e.call(r,t[n],n,t),n++;else for(n in t)t.hasOwnProperty(n)&&e.call(r,t[n],n,t)}function Bb(t,e){return typeof t===ob?t.apply(e&&e[0]||void 0,e):t}function Wb(t,e){return t.indexOf(e)>-1}var Yb=function(){function t(t,e){this.manager=t,this.set(e)}var e=t.prototype;return e.set=function(t){t===fb&&(t=this.compute()),hb&&this.manager.element.style&&mb[t]&&(this.manager.element.style[lb]=t),this.actions=t.toLowerCase().trim()},e.update=function(){this.set(this.manager.options.touchAction)},e.compute=function(){var t=[];return Nb(this.manager.recognizers,(function(e){Bb(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(Wb(t,vb))return vb;var e=Wb(t,yb),r=Wb(t,gb);return e&&r?vb:e||r?e?yb:gb:Wb(t,db)?db:pb}(t.join(" "))},e.preventDefaults=function(t){var e=t.srcEvent,r=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var n=this.actions,i=Wb(n,vb)&&!mb[vb],o=Wb(n,gb)&&!mb[gb],a=Wb(n,yb)&&!mb[yb];if(i){var s=1===t.pointers.length,u=t.distance<2,c=t.deltaTime<250;if(s&&u&&c)return}if(!a||!o)return i||o&&r&Rb||a&&r&Ib?this.preventSrc(e):void 0}},e.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},t}();function Gb(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1}function Xb(t){var e=t.length;if(1===e)return{x:ab(t[0].clientX),y:ab(t[0].clientY)};for(var r=0,n=0,i=0;i<e;)r+=t[i].clientX,n+=t[i].clientY,i++;return{x:ab(r/e),y:ab(n/e)}}function Vb(t){for(var e=[],r=0;r<t.pointers.length;)e[r]={clientX:ab(t.pointers[r].clientX),clientY:ab(t.pointers[r].clientY)},r++;return{timeStamp:ub(),pointers:e,center:Xb(e),deltaX:t.deltaX,deltaY:t.deltaY}}function Ub(t,e,r){r||(r=zb);var n=e[r[0]]-t[r[0]],i=e[r[1]]-t[r[1]];return Math.sqrt(n*n+i*i)}function Zb(t,e,r){r||(r=zb);var n=e[r[0]]-t[r[0]],i=e[r[1]]-t[r[1]];return 180*Math.atan2(i,n)/Math.PI}function qb(t,e){return t===e?Ab:sb(t)>=sb(e)?t<0?Lb:Pb:e<0?Mb:Db}function Hb(t,e,r){return{x:e/t||0,y:r/t||0}}function $b(t,e){var r=t.session,n=e.pointers,i=n.length;r.firstInput||(r.firstInput=Vb(e)),i>1&&!r.firstMultiple?r.firstMultiple=Vb(e):1===i&&(r.firstMultiple=!1);var o=r.firstInput,a=r.firstMultiple,s=a?a.center:o.center,u=e.center=Xb(n);e.timeStamp=ub(),e.deltaTime=e.timeStamp-o.timeStamp,e.angle=Zb(s,u),e.distance=Ub(s,u),function(t,e){var r=e.center,n=t.offsetDelta||{},i=t.prevDelta||{},o=t.prevInput||{};e.eventType!==Eb&&o.eventType!==Ob||(i=t.prevDelta={x:o.deltaX||0,y:o.deltaY||0},n=t.offsetDelta={x:r.x,y:r.y}),e.deltaX=i.x+(r.x-n.x),e.deltaY=i.y+(r.y-n.y)}(r,e),e.offsetDirection=qb(e.deltaX,e.deltaY);var c,l,h=Hb(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=h.x,e.overallVelocityY=h.y,e.overallVelocity=sb(h.x)>sb(h.y)?h.x:h.y,e.scale=a?(c=a.pointers,Ub((l=n)[0],l[1],Fb)/Ub(c[0],c[1],Fb)):1,e.rotation=a?function(t,e){return Zb(e[1],e[0],Fb)+Zb(t[1],t[0],Fb)}(a.pointers,n):0,e.maxPointers=r.prevInput?e.pointers.length>r.prevInput.maxPointers?e.pointers.length:r.prevInput.maxPointers:e.pointers.length,function(t,e){var r,n,i,o,a=t.lastInterval||e,s=e.timeStamp-a.timeStamp;if(e.eventType!==Cb&&(s>Tb||void 0===a.velocity)){var u=e.deltaX-a.deltaX,c=e.deltaY-a.deltaY,l=Hb(s,u,c);n=l.x,i=l.y,r=sb(l.x)>sb(l.y)?l.x:l.y,o=qb(u,c),t.lastInterval=e}else r=a.velocity,n=a.velocityX,i=a.velocityY,o=a.direction;e.velocity=r,e.velocityX=n,e.velocityY=i,e.direction=o}(r,e);var f,p=t.element,d=e.srcEvent;Gb(f=d.composedPath?d.composedPath()[0]:d.path?d.path[0]:d.target,p)&&(p=f),e.target=p}function Kb(t,e,r){var n=r.pointers.length,i=r.changedPointers.length,o=e&Eb&&n-i==0,a=e&(Ob|Cb)&&n-i==0;r.isFirst=!!o,r.isFinal=!!a,o&&(t.session={}),r.eventType=e,$b(t,r),t.emit("hammer.input",r),t.recognize(r),t.session.prevInput=r}function Jb(t){return t.trim().split(/\s+/g)}function Qb(t,e,r){Nb(Jb(e),(function(e){t.addEventListener(e,r,!1)}))}function tw(t,e,r){Nb(Jb(e),(function(e){t.removeEventListener(e,r,!1)}))}function ew(t){var e=t.ownerDocument||t;return e.defaultView||e.parentWindow||window}var rw=function(){function t(t,e){var r=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){Bb(t.options.enable,[t])&&r.handler(e)},this.init()}var e=t.prototype;return e.handler=function(){},e.init=function(){this.evEl&&Qb(this.element,this.evEl,this.domHandler),this.evTarget&&Qb(this.target,this.evTarget,this.domHandler),this.evWin&&Qb(ew(this.element),this.evWin,this.domHandler)},e.destroy=function(){this.evEl&&tw(this.element,this.evEl,this.domHandler),this.evTarget&&tw(this.target,this.evTarget,this.domHandler),this.evWin&&tw(ew(this.element),this.evWin,this.domHandler)},t}();function nw(t,e,r){if(t.indexOf&&!r)return t.indexOf(e);for(var n=0;n<t.length;){if(r&&t[n][r]==e||!r&&t[n]===e)return n;n++}return-1}var iw={pointerdown:Eb,pointermove:kb,pointerup:Ob,pointercancel:Cb,pointerout:Cb},ow={2:_b,3:"pen",4:Sb,5:"kinect"},aw="pointerdown",sw="pointermove pointerup pointercancel";eb.MSPointerEvent&&!eb.PointerEvent&&(aw="MSPointerDown",sw="MSPointerMove MSPointerUp MSPointerCancel");var uw=function(t){function e(){var r,n=e.prototype;return n.evEl=aw,n.evWin=sw,(r=t.apply(this,arguments)||this).store=r.manager.session.pointerEvents=[],r}return Qx(e,t),e.prototype.handler=function(t){var e=this.store,r=!1,n=t.type.toLowerCase().replace("ms",""),i=iw[n],o=ow[t.pointerType]||t.pointerType,a=o===_b,s=nw(e,t.pointerId,"pointerId");i&Eb&&(0===t.button||a)?s<0&&(e.push(t),s=e.length-1):i&(Ob|Cb)&&(r=!0),s<0||(e[s]=t,this.callback(this.manager,i,{pointers:e,changedPointers:[t],pointerType:o,srcEvent:t}),r&&e.splice(s,1))},e}(rw);function cw(t){return Array.prototype.slice.call(t,0)}function lw(t,e,r){for(var n=[],i=[],o=0;o<t.length;){var a=e?t[o][e]:t[o];nw(i,a)<0&&n.push(t[o]),i[o]=a,o++}return r&&(n=e?n.sort((function(t,r){return t[e]>r[e]})):n.sort()),n}var hw={touchstart:Eb,touchmove:kb,touchend:Ob,touchcancel:Cb},fw="touchstart touchmove touchend touchcancel",pw=function(t){function e(){var r;return e.prototype.evTarget=fw,(r=t.apply(this,arguments)||this).targetIds={},r}return Qx(e,t),e.prototype.handler=function(t){var e=hw[t.type],r=dw.call(this,t,e);r&&this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:_b,srcEvent:t})},e}(rw);function dw(t,e){var r,n,i=cw(t.touches),o=this.targetIds;if(e&(Eb|kb)&&1===i.length)return o[i[0].identifier]=!0,[i,i];var a=cw(t.changedTouches),s=[],u=this.target;if(n=i.filter((function(t){return Gb(t.target,u)})),e===Eb)for(r=0;r<n.length;)o[n[r].identifier]=!0,r++;for(r=0;r<a.length;)o[a[r].identifier]&&s.push(a[r]),e&(Ob|Cb)&&delete o[a[r].identifier],r++;return s.length?[lw(n.concat(s),"identifier",!0),s]:void 0}var vw={mousedown:Eb,mousemove:kb,mouseup:Ob},yw="mousedown",gw="mousemove mouseup",mw=function(t){function e(){var r,n=e.prototype;return n.evEl=yw,n.evWin=gw,(r=t.apply(this,arguments)||this).pressed=!1,r}return Qx(e,t),e.prototype.handler=function(t){var e=vw[t.type];e&Eb&&0===t.button&&(this.pressed=!0),e&kb&&1!==t.which&&(e=Ob),this.pressed&&(e&Ob&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:Sb,srcEvent:t}))},e}(rw),xw=2500,bw=25;function ww(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var r={x:e.clientX,y:e.clientY},n=this.lastTouches;this.lastTouches.push(r);setTimeout((function(){var t=n.indexOf(r);t>-1&&n.splice(t,1)}),xw)}}function _w(t,e){t&Eb?(this.primaryTouch=e.changedPointers[0].identifier,ww.call(this,e)):t&(Ob|Cb)&&ww.call(this,e)}function Sw(t){for(var e=t.srcEvent.clientX,r=t.srcEvent.clientY,n=0;n<this.lastTouches.length;n++){var i=this.lastTouches[n],o=Math.abs(e-i.x),a=Math.abs(r-i.y);if(o<=bw&&a<=bw)return!0}return!1}var Tw=function(){return function(t){function e(e,r){var n;return(n=t.call(this,e,r)||this).handler=function(t,e,r){var i=r.pointerType===_b,o=r.pointerType===Sb;if(!(o&&r.sourceCapabilities&&r.sourceCapabilities.firesTouchEvents)){if(i)_w.call(tb(tb(n)),e,r);else if(o&&Sw.call(tb(tb(n)),r))return;n.callback(t,e,r)}},n.touch=new pw(n.manager,n.handler),n.mouse=new mw(n.manager,n.handler),n.primaryTouch=null,n.lastTouches=[],n}return Qx(e,t),e.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(rw)}();function Ew(t,e,r){return!!Array.isArray(t)&&(Nb(t,r[e],r),!0)}var kw=1,Ow=2,Cw=4,Aw=8,Lw=Aw,Pw=16,Mw=32,Dw=1;function Rw(t,e){var r=e.manager;return r?r.get(t):t}function Iw(t){return t&Pw?"cancel":t&Aw?"end":t&Cw?"move":t&Ow?"start":""}var jw=function(){function t(t){void 0===t&&(t={}),this.options=Jx({enable:!0},t),this.id=Dw++,this.manager=null,this.state=kw,this.simultaneous={},this.requireFail=[]}var e=t.prototype;return e.set=function(t){return rb(this.options,t),this.manager&&this.manager.touchAction.update(),this},e.recognizeWith=function(t){if(Ew(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=Rw(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},e.dropRecognizeWith=function(t){return Ew(t,"dropRecognizeWith",this)||(t=Rw(t,this),delete this.simultaneous[t.id]),this},e.requireFailure=function(t){if(Ew(t,"requireFailure",this))return this;var e=this.requireFail;return-1===nw(e,t=Rw(t,this))&&(e.push(t),t.requireFailure(this)),this},e.dropRequireFailure=function(t){if(Ew(t,"dropRequireFailure",this))return this;t=Rw(t,this);var e=nw(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},e.hasRequireFailures=function(){return this.requireFail.length>0},e.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},e.emit=function(t){var e=this,r=this.state;function n(r){e.manager.emit(r,t)}r<Aw&&n(e.options.event+Iw(r)),n(e.options.event),t.additionalEvent&&n(t.additionalEvent),r>=Aw&&n(e.options.event+Iw(r))},e.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=Mw},e.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(this.requireFail[t].state&(Mw|kw)))return!1;t++}return!0},e.recognize=function(t){var e=rb({},t);if(!Bb(this.options.enable,[this,e]))return this.reset(),void(this.state=Mw);this.state&(Lw|Pw|Mw)&&(this.state=kw),this.state=this.process(e),this.state&(Ow|Cw|Aw|Pw)&&this.tryEmit(e)},e.process=function(t){},e.getTouchAction=function(){},e.reset=function(){},t}(),zw=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,Jx({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},e))||this).pTime=!1,r.pCenter=!1,r._timer=null,r._input=null,r.count=0,r}Qx(e,t);var r=e.prototype;return r.getTouchAction=function(){return[db]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,i=t.distance<r.threshold,o=t.deltaTime<r.time;if(this.reset(),t.eventType&Eb&&0===this.count)return this.failTimeout();if(i&&o&&n){if(t.eventType!==Ob)return this.failTimeout();var a=!this.pTime||t.timeStamp-this.pTime<r.interval,s=!this.pCenter||Ub(this.pCenter,t.center)<r.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,s&&a?this.count+=1:this.count=1,this._input=t,0===this.count%r.taps)return this.hasRequireFailures()?(this._timer=setTimeout((function(){e.state=Lw,e.tryEmit()}),r.interval),Ow):Lw}return Mw},r.failTimeout=function(){var t=this;return this._timer=setTimeout((function(){t.state=Mw}),this.options.interval),Mw},r.reset=function(){clearTimeout(this._timer)},r.emit=function(){this.state===Lw&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},e}(jw),Fw=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Jx({pointers:1},e))||this}Qx(e,t);var r=e.prototype;return r.attrTest=function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},r.process=function(t){var e=this.state,r=t.eventType,n=e&(Ow|Cw),i=this.attrTest(t);return n&&(r&Cb||!i)?e|Pw:n||i?r&Ob?e|Aw:e&Ow?e|Cw:Ow:Mw},e}(jw);function Nw(t){return t===Db?"down":t===Mb?"up":t===Lb?"left":t===Pb?"right":""}var Bw=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,Jx({event:"pan",threshold:10,pointers:1,direction:jb},e))||this).pX=null,r.pY=null,r}Qx(e,t);var r=e.prototype;return r.getTouchAction=function(){var t=this.options.direction,e=[];return t&Rb&&e.push(gb),t&Ib&&e.push(yb),e},r.directionTest=function(t){var e=this.options,r=!0,n=t.distance,i=t.direction,o=t.deltaX,a=t.deltaY;return i&e.direction||(e.direction&Rb?(i=0===o?Ab:o<0?Lb:Pb,r=o!==this.pX,n=Math.abs(t.deltaX)):(i=0===a?Ab:a<0?Mb:Db,r=a!==this.pY,n=Math.abs(t.deltaY))),t.direction=i,r&&n>e.threshold&&i&e.direction},r.attrTest=function(t){return Fw.prototype.attrTest.call(this,t)&&(this.state&Ow||!(this.state&Ow)&&this.directionTest(t))},r.emit=function(e){this.pX=e.deltaX,this.pY=e.deltaY;var r=Nw(e.direction);r&&(e.additionalEvent=this.options.event+r),t.prototype.emit.call(this,e)},e}(Fw),Ww=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Jx({event:"swipe",threshold:10,velocity:.3,direction:Rb|Ib,pointers:1},e))||this}Qx(e,t);var r=e.prototype;return r.getTouchAction=function(){return Bw.prototype.getTouchAction.call(this)},r.attrTest=function(e){var r,n=this.options.direction;return n&(Rb|Ib)?r=e.overallVelocity:n&Rb?r=e.overallVelocityX:n&Ib&&(r=e.overallVelocityY),t.prototype.attrTest.call(this,e)&&n&e.offsetDirection&&e.distance>this.options.threshold&&e.maxPointers===this.options.pointers&&sb(r)>this.options.velocity&&e.eventType&Ob},r.emit=function(t){var e=Nw(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)},e}(Fw),Yw=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Jx({event:"pinch",threshold:0,pointers:2},e))||this}Qx(e,t);var r=e.prototype;return r.getTouchAction=function(){return[vb]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.scale-1)>this.options.threshold||this.state&Ow)},r.emit=function(e){if(1!==e.scale){var r=e.scale<1?"in":"out";e.additionalEvent=this.options.event+r}t.prototype.emit.call(this,e)},e}(Fw),Gw=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Jx({event:"rotate",threshold:0,pointers:2},e))||this}Qx(e,t);var r=e.prototype;return r.getTouchAction=function(){return[vb]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.rotation)>this.options.threshold||this.state&Ow)},e}(Fw),Xw=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,Jx({event:"press",pointers:1,time:251,threshold:9},e))||this)._timer=null,r._input=null,r}Qx(e,t);var r=e.prototype;return r.getTouchAction=function(){return[pb]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,i=t.distance<r.threshold,o=t.deltaTime>r.time;if(this._input=t,!i||!n||t.eventType&(Ob|Cb)&&!o)this.reset();else if(t.eventType&Eb)this.reset(),this._timer=setTimeout((function(){e.state=Lw,e.tryEmit()}),r.time);else if(t.eventType&Ob)return Lw;return Mw},r.reset=function(){clearTimeout(this._timer)},r.emit=function(t){this.state===Lw&&(t&&t.eventType&Ob?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=ub(),this.manager.emit(this.options.event,this._input)))},e}(jw),Vw={domEvents:!1,touchAction:fb,enable:!0,inputTarget:null,inputClass:null,cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}},Uw=[[Gw,{enable:!1}],[Yw,{enable:!1},["rotate"]],[Ww,{direction:Rb}],[Bw,{direction:Rb},["swipe"]],[zw],[zw,{event:"doubletap",taps:2},["tap"]],[Xw]];function Zw(t,e){var r,n=t.element;n.style&&(Nb(t.options.cssProps,(function(i,o){r=cb(n.style,o),e?(t.oldCssProps[r]=n.style[r],n.style[r]=i):n.style[r]=t.oldCssProps[r]||""})),e||(t.oldCssProps={}))}var qw=function(){function t(t,e){var r,n=this;this.options=rb({},Vw,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((r=this).options.inputClass||(bb?uw:wb?pw:xb?Tw:mw))(r,Kb),this.touchAction=new Yb(this,this.options.touchAction),Zw(this,!0),Nb(this.options.recognizers,(function(t){var e=n.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}var e=t.prototype;return e.set=function(t){return rb(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},e.stop=function(t){this.session.stopped=t?2:1},e.recognize=function(t){var e=this.session;if(!e.stopped){var r;this.touchAction.preventDefaults(t);var n=this.recognizers,i=e.curRecognizer;(!i||i&&i.state&Lw)&&(e.curRecognizer=null,i=null);for(var o=0;o<n.length;)r=n[o],2===e.stopped||i&&r!==i&&!r.canRecognizeWith(i)?r.reset():r.recognize(t),!i&&r.state&(Ow|Cw|Aw)&&(e.curRecognizer=r,i=r),o++}},e.get=function(t){if(t instanceof jw)return t;for(var e=this.recognizers,r=0;r<e.length;r++)if(e[r].options.event===t)return e[r];return null},e.add=function(t){if(Ew(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},e.remove=function(t){if(Ew(t,"remove",this))return this;var e=this.get(t);if(t){var r=this.recognizers,n=nw(r,e);-1!==n&&(r.splice(n,1),this.touchAction.update())}return this},e.on=function(t,e){if(void 0===t||void 0===e)return this;var r=this.handlers;return Nb(Jb(t),(function(t){r[t]=r[t]||[],r[t].push(e)})),this},e.off=function(t,e){if(void 0===t)return this;var r=this.handlers;return Nb(Jb(t),(function(t){e?r[t]&&r[t].splice(nw(r[t],e),1):delete r[t]})),this},e.emit=function(t,e){this.options.domEvents&&function(t,e){var r=document.createEvent("Event");r.initEvent(t,!0,!0),r.gesture=e,e.target.dispatchEvent(r)}(t,e);var r=this.handlers[t]&&this.handlers[t].slice();if(r&&r.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var n=0;n<r.length;)r[n](e),n++}},e.destroy=function(){this.element&&Zw(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},t}(),Hw={touchstart:Eb,touchmove:kb,touchend:Ob,touchcancel:Cb},$w="touchstart",Kw="touchstart touchmove touchend touchcancel",Jw=function(t){function e(){var r,n=e.prototype;return n.evTarget=$w,n.evWin=Kw,(r=t.apply(this,arguments)||this).started=!1,r}return Qx(e,t),e.prototype.handler=function(t){var e=Hw[t.type];if(e===Eb&&(this.started=!0),this.started){var r=Qw.call(this,t,e);e&(Ob|Cb)&&r[0].length-r[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:_b,srcEvent:t})}},e}(rw);function Qw(t,e){var r=cw(t.touches),n=cw(t.changedTouches);return e&(Ob|Cb)&&(r=lw(r.concat(n),"identifier",!0)),[r,n]}function t_(t,e,r){var n="DEPRECATED METHOD: "+e+"\n"+r+" AT \n";return function(){var e=new Error("get-stack-trace"),r=e&&e.stack?e.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",i=window.console&&(window.console.warn||window.console.log);return i&&i.call(window.console,n,r),t.apply(this,arguments)}}var e_=t_((function(t,e,r){for(var n=Object.keys(e),i=0;i<n.length;)(!r||r&&void 0===t[n[i]])&&(t[n[i]]=e[n[i]]),i++;return t}),"extend","Use `assign`."),r_=t_((function(t,e){return e_(t,e,!0)}),"merge","Use `assign`.");function n_(t,e,r){var n,i=e.prototype;(n=t.prototype=Object.create(i)).constructor=t,n._super=i,r&&rb(n,r)}function i_(t,e){return function(){return t.apply(e,arguments)}}var o_=function(){var t=function(t,e){return void 0===e&&(e={}),new qw(t,Jx({recognizers:Uw.concat()},e))};return t.VERSION="2.0.17-rc",t.DIRECTION_ALL=jb,t.DIRECTION_DOWN=Db,t.DIRECTION_LEFT=Lb,t.DIRECTION_RIGHT=Pb,t.DIRECTION_UP=Mb,t.DIRECTION_HORIZONTAL=Rb,t.DIRECTION_VERTICAL=Ib,t.DIRECTION_NONE=Ab,t.DIRECTION_DOWN=Db,t.INPUT_START=Eb,t.INPUT_MOVE=kb,t.INPUT_END=Ob,t.INPUT_CANCEL=Cb,t.STATE_POSSIBLE=kw,t.STATE_BEGAN=Ow,t.STATE_CHANGED=Cw,t.STATE_ENDED=Aw,t.STATE_RECOGNIZED=Lw,t.STATE_CANCELLED=Pw,t.STATE_FAILED=Mw,t.Manager=qw,t.Input=rw,t.TouchAction=Yb,t.TouchInput=pw,t.MouseInput=mw,t.PointerEventInput=uw,t.TouchMouseInput=Tw,t.SingleTouchInput=Jw,t.Recognizer=jw,t.AttrRecognizer=Fw,t.Tap=zw,t.Pan=Bw,t.Swipe=Ww,t.Pinch=Yw,t.Rotate=Gw,t.Press=Xw,t.on=Qb,t.off=tw,t.each=Nb,t.merge=r_,t.extend=e_,t.bindFn=i_,t.assign=rb,t.inherit=n_,t.bindFn=i_,t.prefixed=cb,t.toArray=cw,t.inArray=nw,t.uniqueArray=lw,t.splitStr=Jb,t.boolOrFn=Bb,t.hasParent=Gb,t.addEventListeners=Qb,t.removeEventListeners=tw,t.defaults=rb({},Vw,{preset:Uw}),t}();function a_(t,e){var r=void 0!==Zy&&Vd(t)||t["@@iterator"];if(!r){if(qf(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return s_(t,e);var n=Hy(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Bd(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return s_(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,s=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){s=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw o}}}}function s_(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}var u_=Zy("DELETE");function c_(){var t=l_.apply(void 0,arguments);return f_(t),t}function l_(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];if(e.length<2)return e[0];var n;if(e.length>2)return l_.apply(void 0,ap(n=[c_(e[0],e[1])]).call(n,Vy(Hy(e).call(e,2))));var i,o=e[0],a=e[1],s=a_(Qy(a));try{for(s.s();!(i=s.n()).done;){var u=i.value;Object.prototype.propertyIsEnumerable.call(a,u)&&(a[u]===u_?delete o[u]:null===o[u]||null===a[u]||"object"!==Tl(o[u])||"object"!==Tl(a[u])||qf(o[u])||qf(a[u])?o[u]=h_(a[u]):o[u]=l_(o[u],a[u]))}}catch(t){s.e(t)}finally{s.f()}return o}function h_(t){return qf(t)?ug(t).call(t,(function(t){return h_(t)})):"object"===Tl(t)&&null!==t?l_({},t):t}function f_(t){for(var e=0,r=dg(t);e<r.length;e++){var n=r[e];t[n]===u_?delete t[n]:"object"===Tl(t[n])&&null!==t[n]&&f_(t[n])}}var p_="undefined"!=typeof window?window.Hammer||o_:function(){return function(){var t=function(){};return{on:t,off:t,destroy:t,emit:t,get:function(){return{set:t}}}}()};function d_(t){var e,r=this;this._cleanupQueue=[],this.active=!1,this._dom={container:t,overlay:document.createElement("div")},this._dom.overlay.classList.add("vis-overlay"),this._dom.container.appendChild(this._dom.overlay),this._cleanupQueue.push((function(){r._dom.overlay.parentNode.removeChild(r._dom.overlay)}));var n=p_(this._dom.overlay);n.on("tap",Wg(e=this._onTapOverlay).call(e,this)),this._cleanupQueue.push((function(){n.destroy()}));var i=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];Xf(i).call(i,(function(t){n.on(t,(function(t){t.srcEvent.stopPropagation()}))})),document&&document.body&&(this._onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||r.deactivate()},document.body.addEventListener("click",this._onClick),this._cleanupQueue.push((function(){document.body.removeEventListener("click",r._onClick)}))),this._escListener=function(t){("key"in t?"Escape"===t.key:27===t.keyCode)&&r.deactivate()}}$p(d_.prototype),d_.current=null,d_.prototype.destroy=function(){var t,e;this.deactivate();var r,n=a_(Qg(t=Em(e=this._cleanupQueue).call(e,0)).call(t));try{for(n.s();!(r=n.n()).done;){(0,r.value)()}}catch(t){n.e(t)}finally{n.f()}},d_.prototype.activate=function(){d_.current&&d_.current.deactivate(),d_.current=this,this.active=!0,this._dom.overlay.style.display="none",this._dom.container.classList.add("vis-active"),this.emit("change"),this.emit("activate"),document.body.addEventListener("keydown",this._escListener)},d_.prototype.deactivate=function(){this.active=!1,this._dom.overlay.style.display="block",this._dom.container.classList.remove("vis-active"),document.body.removeEventListener("keydown",this._escListener),this.emit("change"),this.emit("deactivate")},d_.prototype._onTapOverlay=function(t){this.activate(),t.srcEvent.stopPropagation()};var v_=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,y_=/^#?([a-f\d])([a-f\d])([a-f\d])$/i;function g_(t,e,r,n){var i=!1;!0===n&&(i=null===e[r]&&void 0!==t[r]),i?delete t[r]:t[r]=e[r]}function m_(t,e){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var i in e)if(Object.prototype.hasOwnProperty.call(e,i)||!0===r)if("object"===Tl(e[i])&&null!==e[i]&&rx(e[i])===Object.prototype)void 0===t[i]?t[i]=m_({},e[i],r):"object"===Tl(t[i])&&null!==t[i]&&rx(t[i])===Object.prototype?m_(t[i],e[i],r):g_(t,e,i,n);else if(qf(e[i])){var o;t[i]=Hy(o=e[i]).call(o)}else g_(t,e,i,n);return t}function x_(t,e){var r;return ap(r=[]).call(r,Vy(t),[e])}function b_(t,e,r,n){var i;t.addEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&Hm(i=navigator.userAgent).call(i,"Firefox")&&(e="DOMMouseScroll"),t.addEventListener(e,r,n)):t.attachEvent("on"+e,r)}function w_(t,e,r,n){var i;t.removeEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&Hm(i=navigator.userAgent).call(i,"Firefox")&&(e="DOMMouseScroll"),t.removeEventListener(e,r,n)):t.detachEvent("on"+e,r)}function __(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)}function S_(t,e,r){var n,i,o,a=Math.floor(6*t),s=6*t-a,u=r*(1-e),c=r*(1-s*e),l=r*(1-(1-s)*e);switch(a%6){case 0:n=r,i=l,o=u;break;case 1:n=c,i=r,o=u;break;case 2:n=u,i=r,o=l;break;case 3:n=u,i=c,o=r;break;case 4:n=l,i=u,o=r;break;case 5:n=r,i=u,o=c}return{r:Math.floor(255*n),g:Math.floor(255*i),b:Math.floor(255*o)}}var T_,E_=!1,k_="background: #FFeeee; color: #dd0000",O_=function(){function t(){Vv(this,t)}return oy(t,null,[{key:"validate",value:function(e,r,n){E_=!1,T_=r;var i=r;return void 0!==n&&(i=r[n]),t.parse(e,i,[]),E_}},{key:"parse",value:function(e,r,n){for(var i in e)Object.prototype.hasOwnProperty.call(e,i)&&t.check(i,e,r,n)}},{key:"check",value:function(e,r,n,i){if(void 0!==n[e]||void 0!==n.__any__){var o=e,a=!0;void 0===n[e]&&void 0!==n.__any__&&(o="__any__",a="object"===t.getType(r[e]));var s=n[o];a&&void 0!==s.__type__&&(s=s.__type__),t.checkFields(e,r,n,o,s,i)}else t.getSuggestion(e,n,i)}},{key:"checkFields",value:function(e,r,n,i,o,a){var s=function(r){console.error("%c"+r+t.printLocation(a,e),k_)},u=t.getType(r[e]),c=o[u];void 0!==c?"array"===t.getType(c)&&-1===Lh(c).call(c,r[e])?(s('Invalid option detected in "'+e+'". Allowed values are:'+t.print(c)+' not "'+r[e]+'". '),E_=!0):"object"===u&&"__any__"!==i&&(a=x_(a,e),t.parse(r[e],n[i],a)):void 0===o.any&&(s('Invalid type received for "'+e+'". Expected: '+t.print(dg(o))+". Received ["+u+'] "'+r[e]+'"'),E_=!0)}},{key:"getType",value:function(t){var e=Tl(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":qf(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,r,n){var i,o=t.findInOptions(e,r,n,!1),a=t.findInOptions(e,T_,[],!0);i=void 0!==o.indexMatch?" in "+t.printLocation(o.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+o.indexMatch+'"?\n\n':a.distance<=4&&o.distance>a.distance?" in "+t.printLocation(o.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(a.path,a.closestMatch,""):o.distance<=8?'. Did you mean "'+o.closestMatch+'"?'+t.printLocation(o.path,e):". Did you mean one of these: "+t.print(dg(r))+t.printLocation(n,e),console.error('%cUnknown option detected: "'+e+'"'+i,k_),E_=!0}},{key:"findInOptions",value:function(e,r,n){var i,o=arguments.length>3&&void 0!==arguments[3]&&arguments[3],a=1e9,s="",u=[],c=e.toLowerCase(),l=void 0;for(var h in r){var f=void 0;if(void 0!==r[h].__type__&&!0===o){var p=t.findInOptions(e,r[h],x_(n,h));a>p.distance&&(s=p.closestMatch,u=p.path,a=p.distance,l=p.indexMatch)}else{var d;-1!==Lh(d=h.toLowerCase()).call(d,c)&&(l=h),a>(f=t.levenshteinDistance(e,h))&&(s=h,u=Hy(i=n).call(i),a=f)}}return{closestMatch:s,path:u,distance:a,indexMatch:l}}},{key:"printLocation",value:function(t,e){for(var r="\n\n"+(arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n")+"options = {\n",n=0;n<t.length;n++){for(var i=0;i<n+1;i++)r+="  ";r+=t[n]+": {\n"}for(var o=0;o<t.length+1;o++)r+="  ";r+=e+"\n";for(var a=0;a<t.length+1;a++){for(var s=0;s<t.length-a;s++)r+="  ";r+="}\n"}return r+"\n\n"}},{key:"print",value:function(t){return Kx(t).replace(/(")|(\[)|(\])|(,"__type__")/g,"").replace(/(,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var r,n,i=[];for(r=0;r<=e.length;r++)i[r]=[r];for(n=0;n<=t.length;n++)i[0][n]=n;for(r=1;r<=e.length;r++)for(n=1;n<=t.length;n++)e.charAt(r-1)==t.charAt(n-1)?i[r][n]=i[r-1][n-1]:i[r][n]=Math.min(i[r-1][n-1]+1,Math.min(i[r][n-1]+1,i[r-1][n]+1));return i[e.length][t.length]}}]),t}(),C_=k_,A_=O_;function L_(t,e,r){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0,this.z=void 0!==r?r:0}L_.subtract=function(t,e){var r=new L_;return r.x=t.x-e.x,r.y=t.y-e.y,r.z=t.z-e.z,r},L_.add=function(t,e){var r=new L_;return r.x=t.x+e.x,r.y=t.y+e.y,r.z=t.z+e.z,r},L_.avg=function(t,e){return new L_((t.x+e.x)/2,(t.y+e.y)/2,(t.z+e.z)/2)},L_.scalarProduct=function(t,e){return new L_(t.x*e,t.y*e,t.z*e)},L_.dotProduct=function(t,e){return t.x*e.x+t.y*e.y+t.z*e.z},L_.crossProduct=function(t,e){var r=new L_;return r.x=t.y*e.z-t.z*e.y,r.y=t.z*e.x-t.x*e.z,r.z=t.x*e.y-t.y*e.x,r},L_.prototype.length=function(){return Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z)},L_.prototype.normalize=function(){return L_.scalarProduct(this,1/this.length())};var P_=L_;var M_=function(t,e){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0};function D_(t,e){if(void 0===t)throw new Error("No container element defined");if(this.container=t,this.visible=!e||null==e.visible||e.visible,this.visible){this.frame=document.createElement("DIV"),this.frame.style.width="100%",this.frame.style.position="relative",this.container.appendChild(this.frame),this.frame.prev=document.createElement("INPUT"),this.frame.prev.type="BUTTON",this.frame.prev.value="Prev",this.frame.appendChild(this.frame.prev),this.frame.play=document.createElement("INPUT"),this.frame.play.type="BUTTON",this.frame.play.value="Play",this.frame.appendChild(this.frame.play),this.frame.next=document.createElement("INPUT"),this.frame.next.type="BUTTON",this.frame.next.value="Next",this.frame.appendChild(this.frame.next),this.frame.bar=document.createElement("INPUT"),this.frame.bar.type="BUTTON",this.frame.bar.style.position="absolute",this.frame.bar.style.border="1px solid red",this.frame.bar.style.width="100px",this.frame.bar.style.height="6px",this.frame.bar.style.borderRadius="2px",this.frame.bar.style.MozBorderRadius="2px",this.frame.bar.style.border="1px solid #7F7F7F",this.frame.bar.style.backgroundColor="#E5E5E5",this.frame.appendChild(this.frame.bar),this.frame.slide=document.createElement("INPUT"),this.frame.slide.type="BUTTON",this.frame.slide.style.margin="0px",this.frame.slide.value=" ",this.frame.slide.style.position="relative",this.frame.slide.style.left="-100px",this.frame.appendChild(this.frame.slide);var r=this;this.frame.slide.onmousedown=function(t){r._onMouseDown(t)},this.frame.prev.onclick=function(t){r.prev(t)},this.frame.play.onclick=function(t){r.togglePlay(t)},this.frame.next.onclick=function(t){r.next(t)}}this.onChangeCallback=void 0,this.values=[],this.index=void 0,this.playTimeout=void 0,this.playInterval=1e3,this.playLoop=!0}function R_(t,e,r,n){this._start=0,this._end=0,this._step=1,this.prettyStep=!0,this.precision=5,this._current=0,this.setRange(t,e,r,n)}D_.prototype.prev=function(){var t=this.getIndex();t>0&&(t--,this.setIndex(t))},D_.prototype.next=function(){var t=this.getIndex();t<Pf(this).length-1&&(t++,this.setIndex(t))},D_.prototype.playNext=function(){var t=new Date,e=this.getIndex();e<Pf(this).length-1?(e++,this.setIndex(e)):this.playLoop&&(e=0,this.setIndex(e));var r=new Date-t,n=Math.max(this.playInterval-r,0),i=this;this.playTimeout=Ap((function(){i.playNext()}),n)},D_.prototype.togglePlay=function(){void 0===this.playTimeout?this.play():this.stop()},D_.prototype.play=function(){this.playTimeout||(this.playNext(),this.frame&&(this.frame.play.value="Stop"))},D_.prototype.stop=function(){clearInterval(this.playTimeout),this.playTimeout=void 0,this.frame&&(this.frame.play.value="Play")},D_.prototype.setOnChangeCallback=function(t){this.onChangeCallback=t},D_.prototype.setPlayInterval=function(t){this.playInterval=t},D_.prototype.getPlayInterval=function(){return this.playInterval},D_.prototype.setPlayLoop=function(t){this.playLoop=t},D_.prototype.onChange=function(){void 0!==this.onChangeCallback&&this.onChangeCallback()},D_.prototype.redraw=function(){if(this.frame){this.frame.bar.style.top=this.frame.clientHeight/2-this.frame.bar.offsetHeight/2+"px",this.frame.bar.style.width=this.frame.clientWidth-this.frame.prev.clientWidth-this.frame.play.clientWidth-this.frame.next.clientWidth-30+"px";var t=this.indexToLeft(this.index);this.frame.slide.style.left=t+"px"}},D_.prototype.setValues=function(t){this.values=t,Pf(this).length>0?this.setIndex(0):this.index=void 0},D_.prototype.setIndex=function(t){if(!(t<Pf(this).length))throw new Error("Index out of range");this.index=t,this.redraw(),this.onChange()},D_.prototype.getIndex=function(){return this.index},D_.prototype.get=function(){return Pf(this)[this.index]},D_.prototype._onMouseDown=function(t){if(t.which?1===t.which:1===t.button){this.startClientX=t.clientX,this.startSlideX=cf(this.frame.slide.style.left),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},b_(document,"mousemove",this.onmousemove),b_(document,"mouseup",this.onmouseup),__(t)}},D_.prototype.leftToIndex=function(t){var e=cf(this.frame.bar.style.width)-this.frame.slide.clientWidth-10,r=t-3,n=Math.round(r/e*(Pf(this).length-1));return n<0&&(n=0),n>Pf(this).length-1&&(n=Pf(this).length-1),n},D_.prototype.indexToLeft=function(t){var e=cf(this.frame.bar.style.width)-this.frame.slide.clientWidth-10;return t/(Pf(this).length-1)*e+3},D_.prototype._onMouseMove=function(t){var e=t.clientX-this.startClientX,r=this.startSlideX+e,n=this.leftToIndex(r);this.setIndex(n),__()},D_.prototype._onMouseUp=function(){this.frame.style.cursor="auto",w_(document,"mousemove",this.onmousemove),w_(document,"mouseup",this.onmouseup),__()},R_.prototype.isNumeric=function(t){return!isNaN(cf(t))&&isFinite(t)},R_.prototype.setRange=function(t,e,r,n){if(!this.isNumeric(t))throw new Error("Parameter 'start' is not numeric; value: "+t);if(!this.isNumeric(e))throw new Error("Parameter 'end' is not numeric; value: "+t);if(!this.isNumeric(r))throw new Error("Parameter 'step' is not numeric; value: "+t);this._start=t||0,this._end=e||0,this.setStep(r,n)},R_.prototype.setStep=function(t,e){void 0===t||t<=0||(void 0!==e&&(this.prettyStep=e),!0===this.prettyStep?this._step=R_.calculatePrettyStep(t):this._step=t)},R_.calculatePrettyStep=function(t){var e=function(t){return Math.log(t)/Math.LN10},r=Math.pow(10,Math.round(e(t))),n=2*Math.pow(10,Math.round(e(t/2))),i=5*Math.pow(10,Math.round(e(t/5))),o=r;return Math.abs(n-t)<=Math.abs(o-t)&&(o=n),Math.abs(i-t)<=Math.abs(o-t)&&(o=i),o<=0&&(o=1),o},R_.prototype.getCurrent=function(){return cf(this._current.toPrecision(this.precision))},R_.prototype.getStep=function(){return this._step},R_.prototype.start=function(t){void 0===t&&(t=!1),this._current=this._start-this._start%this._step,t&&this.getCurrent()<this._start&&this.next()},R_.prototype.next=function(){this._current+=this._step},R_.prototype.end=function(){return this._current>this._end};var I_=R_,j_={},z_={get exports(){return j_},set exports(t){j_=t}};Lr({target:"Math",stat:!0},{sign:Math.sign||function(t){var e=+t;return 0==e||e!=e?e:e<0?-1:1}});var F_=it.Math.sign;z_.exports=F_;var N_=e(j_);function B_(){this.armLocation=new P_,this.armRotation={},this.armRotation.horizontal=0,this.armRotation.vertical=0,this.armLength=1.7,this.cameraOffset=new P_,this.offsetMultiplier=.6,this.cameraLocation=new P_,this.cameraRotation=new P_(.5*Math.PI,0,0),this.calculateCameraOrientation()}B_.prototype.setOffset=function(t,e){var r=Math.abs,n=N_,i=this.offsetMultiplier,o=this.armLength*i;r(t)>o&&(t=n(t)*o),r(e)>o&&(e=n(e)*o),this.cameraOffset.x=t,this.cameraOffset.y=e,this.calculateCameraOrientation()},B_.prototype.getOffset=function(){return this.cameraOffset},B_.prototype.setArmLocation=function(t,e,r){this.armLocation.x=t,this.armLocation.y=e,this.armLocation.z=r,this.calculateCameraOrientation()},B_.prototype.setArmRotation=function(t,e){void 0!==t&&(this.armRotation.horizontal=t),void 0!==e&&(this.armRotation.vertical=e,this.armRotation.vertical<0&&(this.armRotation.vertical=0),this.armRotation.vertical>.5*Math.PI&&(this.armRotation.vertical=.5*Math.PI)),void 0===t&&void 0===e||this.calculateCameraOrientation()},B_.prototype.getArmRotation=function(){var t={};return t.horizontal=this.armRotation.horizontal,t.vertical=this.armRotation.vertical,t},B_.prototype.setArmLength=function(t){void 0!==t&&(this.armLength=t,this.armLength<.71&&(this.armLength=.71),this.armLength>5&&(this.armLength=5),this.setOffset(this.cameraOffset.x,this.cameraOffset.y),this.calculateCameraOrientation())},B_.prototype.getArmLength=function(){return this.armLength},B_.prototype.getCameraLocation=function(){return this.cameraLocation},B_.prototype.getCameraRotation=function(){return this.cameraRotation},B_.prototype.calculateCameraOrientation=function(){this.cameraLocation.x=this.armLocation.x-this.armLength*Math.sin(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.y=this.armLocation.y-this.armLength*Math.cos(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.z=this.armLocation.z+this.armLength*Math.sin(this.armRotation.vertical),this.cameraRotation.x=Math.PI/2-this.armRotation.vertical,this.cameraRotation.y=0,this.cameraRotation.z=-this.armRotation.horizontal;var t=this.cameraRotation.x,e=this.cameraRotation.z,r=this.cameraOffset.x,n=this.cameraOffset.y,i=Math.sin,o=Math.cos;this.cameraLocation.x=this.cameraLocation.x+r*o(e)+n*-i(e)*o(t),this.cameraLocation.y=this.cameraLocation.y+r*i(e)+n*o(e)*o(t),this.cameraLocation.z=this.cameraLocation.z+n*i(t)};var W_={BAR:0,BARCOLOR:1,BARSIZE:2,DOT:3,DOTLINE:4,DOTCOLOR:5,DOTSIZE:6,GRID:7,LINE:8,SURFACE:9},Y_={dot:W_.DOT,"dot-line":W_.DOTLINE,"dot-color":W_.DOTCOLOR,"dot-size":W_.DOTSIZE,line:W_.LINE,grid:W_.GRID,surface:W_.SURFACE,bar:W_.BAR,"bar-color":W_.BARCOLOR,"bar-size":W_.BARSIZE},G_=["width","height","filterLabel","legendLabel","xLabel","yLabel","zLabel","xValueLabel","yValueLabel","zValueLabel","showXAxis","showYAxis","showZAxis","showGrayBottom","showGrid","showPerspective","showShadow","showSurfaceGrid","keepAspectRatio","rotateAxisLabels","verticalRatio","dotSizeRatio","dotSizeMinFraction","dotSizeMaxFraction","showAnimationControls","animationInterval","animationPreload","animationAutoStart","axisColor","axisFontSize","axisFontType","gridColor","xCenter","yCenter","zoomable","tooltipDelay","ctrlToZoom"],X_=["xBarWidth","yBarWidth","valueMin","valueMax","xMin","xMax","xStep","yMin","yMax","yStep","zMin","zMax","zStep"],V_=void 0;function U_(t){for(var e in t)if(Object.prototype.hasOwnProperty.call(t,e))return!1;return!0}function Z_(t,e){return void 0===t||""===t?e:t+(void 0===(r=e)||""===r||"string"!=typeof r?r:r.charAt(0).toUpperCase()+Hy(r).call(r,1));var r}function q_(t,e,r,n){for(var i,o=0;o<r.length;++o)e[Z_(n,i=r[o])]=t[i]}function H_(t,e,r,n){for(var i,o=0;o<r.length;++o)void 0!==t[i=r[o]]&&(e[Z_(n,i)]=t[i])}function $_(t,e){if(void 0!==t.backgroundColor&&function(t,e){var r="white",n="gray",i=1;if("string"==typeof t)r=t,n="none",i=0;else{if("object"!==Tl(t))throw new Error("Unsupported type of backgroundColor");void 0!==bf(t)&&(r=bf(t)),void 0!==t.stroke&&(n=t.stroke),void 0!==t.strokeWidth&&(i=t.strokeWidth)}e.frame.style.backgroundColor=r,e.frame.style.borderColor=n,e.frame.style.borderWidth=i+"px",e.frame.style.borderStyle="solid"}(t.backgroundColor,e),function(t,e){if(void 0===t)return;void 0===e.dataColor&&(e.dataColor={});"string"==typeof t?(e.dataColor.fill=t,e.dataColor.stroke=t):(bf(t)&&(e.dataColor.fill=bf(t)),t.stroke&&(e.dataColor.stroke=t.stroke),void 0!==t.strokeWidth&&(e.dataColor.strokeWidth=t.strokeWidth))}(t.dataColor,e),function(t,e){if(void 0===t)return;var r;if("string"==typeof t){if(r=function(t){var e=Y_[t];if(void 0===e)return-1;return e}(t),-1===r)throw new Error("Style '"+t+"' is invalid")}else{if(!function(t){var e=!1;for(var r in W_)if(W_[r]===t){e=!0;break}return e}(t))throw new Error("Style '"+t+"' is invalid");r=t}e.style=r}(t.style,e),void 0!==t.surfaceColors){if(console.warn("`options.surfaceColors` is deprecated and may be removed in a future version. Please use `options.colormap` instead. Note that the `colormap` option uses the inverse array ordering (running from vMin to vMax)."),void 0!==t.colormap)throw new Error("The `colormap` and `surfaceColors` options are mutually exclusive.");"surface"!==e.style?console.warn("Ignoring `surfaceColors` in graph style `"+e.style+"` for backward compatibility (only effective in `surface` plots)."):function(t,e){if(void 0===t||!0===t)return;if(!1===t)return void(e.surfaceColors=void 0);void 0===e.surfaceColors&&(e.surfaceColors={});var r;if(qf(t))r=K_(t);else{if("object"!==Tl(t))throw new Error("Unsupported type of surfaceColors");r=J_(t.hue)}Qg(r).call(r),e.colormap=r}(t.surfaceColors,e)}else!function(t,e){if(void 0===t)return;var r;if(qf(t))r=K_(t);else if("object"===Tl(t))r=J_(t.hue);else{if("function"!=typeof t)throw new Error("Unsupported type of colormap");r=t}e.colormap=r}(t.colormap,e);!function(t,e){if(void 0===t){if(void 0===V_.showLegend){var r=e.style===W_.DOTCOLOR||e.style===W_.DOTSIZE;e.showLegend=r}}else e.showLegend=t}(t.showLegend,e),Q_(t.cameraPosition,e),void 0!==t.tooltip&&(e.showTooltip=t.tooltip),null!=t.onclick&&(e.onclick_callback=t.onclick,console.warn("`options.onclick` is deprecated and may be removed in a future version. Please use `Graph3d.on('click', handler)` instead.")),void 0!==t.tooltipStyle&&function(t,e,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(qf(r))throw new TypeError("Arrays are not supported by deepExtend");for(var i=0;i<t.length;i++){var o=t[i];if(Object.prototype.hasOwnProperty.call(r,o))if(r[o]&&r[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?m_(e[o],r[o],!1,n):g_(e,r,o,n);else{if(qf(r[o]))throw new TypeError("Arrays are not supported by deepExtend");g_(e,r,o,n)}}}(["tooltipStyle"],e,t)}function K_(t){if(t.length<2)throw new Error("Colormap array length must be 2 or above.");return ug(t).call(t,(function(t){if(!function(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}(t))throw new Error("Invalid hex color code supplied to colormap.");return function(t){var e;switch(t.length){case 3:case 4:return(e=y_.exec(t))?{r:Ax(e[1]+e[1],16),g:Ax(e[2]+e[2],16),b:Ax(e[3]+e[3],16)}:null;case 6:case 7:return(e=v_.exec(t))?{r:Ax(e[1],16),g:Ax(e[2],16),b:Ax(e[3],16)}:null;default:return null}}(t)}))}function J_(t){if(void 0===t)throw new Error("Unsupported type of colormap");if(!(t.saturation>=0&&t.saturation<=100))throw new Error("Saturation is out of bounds. Expected range is 0-100.");if(!(t.brightness>=0&&t.brightness<=100))throw new Error("Brightness is out of bounds. Expected range is 0-100.");if(!(t.colorStops>=2))throw new Error("colorStops is out of bounds. Expected 2 or above.");for(var e=(t.end-t.start)/(t.colorStops-1),r=[],n=0;n<t.colorStops;++n){var i=(t.start+e*n)%360/360;r.push(S_(i<0?i+1:i,t.saturation/100,t.brightness/100))}return r}function Q_(t,e){var r=t;void 0!==r&&(void 0===e.camera&&(e.camera=new B_),e.camera.setArmRotation(r.horizontal,r.vertical),e.camera.setArmLength(r.distance))}var tS="string",eS="boolean",rS="number",nS="object",iS="array",oS={fill:{string:tS},stroke:{string:tS},strokeWidth:{number:rS},__type__:{string:tS,object:nS,undefined:"undefined"}},aS={animationAutoStart:{boolean:eS,undefined:"undefined"},animationInterval:{number:rS},animationPreload:{boolean:eS},axisColor:{string:tS},axisFontSize:{number:rS},axisFontType:{string:tS},backgroundColor:oS,xBarWidth:{number:rS,undefined:"undefined"},yBarWidth:{number:rS,undefined:"undefined"},cameraPosition:{distance:{number:rS},horizontal:{number:rS},vertical:{number:rS},__type__:{object:nS}},zoomable:{boolean:eS},ctrlToZoom:{boolean:eS},xCenter:{string:tS},yCenter:{string:tS},colormap:{hue:{start:{number:rS},end:{number:rS},saturation:{number:rS},brightness:{number:rS},colorStops:{number:rS},__type__:{object:nS}},__type__:{array:iS,object:nS,function:"function",undefined:"undefined"}},dataColor:oS,dotSizeMinFraction:{number:rS},dotSizeMaxFraction:{number:rS},dotSizeRatio:{number:rS},filterLabel:{string:tS},gridColor:{string:tS},onclick:{function:"function"},keepAspectRatio:{boolean:eS},xLabel:{string:tS},yLabel:{string:tS},zLabel:{string:tS},legendLabel:{string:tS},xMin:{number:rS,undefined:"undefined"},yMin:{number:rS,undefined:"undefined"},zMin:{number:rS,undefined:"undefined"},xMax:{number:rS,undefined:"undefined"},yMax:{number:rS,undefined:"undefined"},zMax:{number:rS,undefined:"undefined"},showAnimationControls:{boolean:eS,undefined:"undefined"},showGrayBottom:{boolean:eS},showGrid:{boolean:eS},showLegend:{boolean:eS,undefined:"undefined"},showPerspective:{boolean:eS},showShadow:{boolean:eS},showSurfaceGrid:{boolean:eS},showXAxis:{boolean:eS},showYAxis:{boolean:eS},showZAxis:{boolean:eS},rotateAxisLabels:{boolean:eS},surfaceColors:{hue:{start:{number:rS},end:{number:rS},saturation:{number:rS},brightness:{number:rS},colorStops:{number:rS},__type__:{object:nS}},__type__:{boolean:eS,array:iS,object:nS,undefined:"undefined"}},xStep:{number:rS,undefined:"undefined"},yStep:{number:rS,undefined:"undefined"},zStep:{number:rS,undefined:"undefined"},style:{number:rS,string:["bar","bar-color","bar-size","dot","dot-line","dot-color","dot-size","line","grid","surface"]},tooltip:{boolean:eS,function:"function"},tooltipDelay:{number:rS},tooltipStyle:{content:{color:{string:tS},background:{string:tS},border:{string:tS},borderRadius:{string:tS},boxShadow:{string:tS},padding:{string:tS},__type__:{object:nS}},line:{borderLeft:{string:tS},height:{string:tS},width:{string:tS},pointerEvents:{string:tS},__type__:{object:nS}},dot:{border:{string:tS},borderRadius:{string:tS},height:{string:tS},width:{string:tS},pointerEvents:{string:tS},__type__:{object:nS}},__type__:{object:nS}},xValueLabel:{function:"function"},yValueLabel:{function:"function"},zValueLabel:{function:"function"},valueMax:{number:rS,undefined:"undefined"},valueMin:{number:rS,undefined:"undefined"},verticalRatio:{number:rS},height:{string:tS},width:{string:tS},__type__:{object:nS}};function sS(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var uS={},cS={get exports(){return uS},set exports(t){uS=t}},lS={},hS=Xx;({get exports(){return lS},set exports(t){lS=t}}).exports=hS,cS.exports=lS;var fS=e(uS),pS={},dS={get exports(){return pS},set exports(t){pS=t}},vS={},yS={get exports(){return vS},set exports(t){vS=t}};Lr({target:"Object",stat:!0},{setPrototypeOf:Ku});var gS=it.Object.setPrototypeOf;yS.exports=gS,dS.exports=vS;var mS=e(pS),xS={},bS={get exports(){return xS},set exports(t){xS=t}},wS={},_S=Bg;({get exports(){return wS},set exports(t){wS=t}}).exports=_S,bS.exports=wS;var SS=e(xS);function TS(t,e){var r;return TS=mS?SS(r=mS).call(r):function(t,e){return t.__proto__=e,t},TS(t,e)}function ES(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=fS(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),$v(t,"prototype",{writable:!1}),e&&TS(t,e)}var kS={},OS={get exports(){return kS},set exports(t){kS=t}},CS={},AS=ex;({get exports(){return CS},set exports(t){CS=t}}).exports=AS,OS.exports=CS;var LS=e(kS);function PS(t){var e;return PS=mS?SS(e=LS).call(e):function(t){return t.__proto__||LS(t)},PS(t)}var MS={},DS={get exports(){return MS},set exports(t){MS=t}},RS={};!function(t){var e=r,n=el;function i(r){return t.exports=i="function"==typeof e&&"symbol"==typeof n?function(t){return typeof t}:function(t){return t&&"function"==typeof e&&t.constructor===e&&t!==e.prototype?"symbol":typeof t},t.exports.__esModule=!0,t.exports.default=t.exports,i(r)}t.exports=i,t.exports.__esModule=!0,t.exports.default=t.exports}({get exports(){return RS},set exports(t){RS=t}});var IS={},jS={get exports(){return IS},set exports(t){IS=t}},zS={},FS=Gf;({get exports(){return zS},set exports(t){zS=t}}).exports=FS,jS.exports=zS;var NS={},BS={get exports(){return NS},set exports(t){NS=t}},WS={},YS={get exports(){return WS},set exports(t){WS=t}},GS=te,XS=yv,VS=P,US=Qe,ZS=nt,qS=mr,HS=Error,$S=x("".replace),KS=String(HS("zxcasd").stack),JS=/\n\s*at [^:]*:[^\n]*/,QS=JS.test(KS),tT=Y,eT=!u((function(){var t=Error("a");return!("stack"in t)||(Object.defineProperty(t,"stack",tT(1,7)),7!==t.stack)})),rT=mr,nT=function(t,e){if(QS&&"string"==typeof t&&!HS.prepareStackTrace)for(;e--;)t=$S(t,JS,"");return t},iT=eT,oT=Error.captureStackTrace,aT=Je,sT=I,uT=ir,cT=At,lT=ud,hT=Br,fT=lt,pT=wd,dT=dd,vT=rd,yT=TypeError,gT=function(t,e){this.stopped=t,this.result=e},mT=gT.prototype,xT=function(t,e,r){var n,i,o,a,s,u,c,l=r&&r.that,h=!(!r||!r.AS_ENTRIES),f=!(!r||!r.IS_RECORD),p=!(!r||!r.IS_ITERATOR),d=!(!r||!r.INTERRUPTED),v=aT(e,l),y=function(t){return n&&vT(n,"normal",t),new gT(!0,t)},g=function(t){return h?(uT(t),d?v(t[0],t[1],y):v(t[0],t[1])):d?v(t,y):v(t)};if(f)n=t.iterator;else if(p)n=t;else{if(!(i=dT(t)))throw yT(cT(t)+" is not iterable");if(lT(i)){for(o=0,a=hT(t);a>o;o++)if((s=g(t[o]))&&fT(mT,s))return s;return new gT(!1)}n=pT(t,i)}for(u=f?t.next:n.next;!(c=sT(u,n)).done;){try{s=g(c.value)}catch(t){vT(n,"throw",t)}if("object"==typeof s&&s&&fT(mT,s))return s}return new gT(!1)},bT=qn,wT=Lr,_T=lt,ST=ku,TT=Ku,ET=function(t,e,r){for(var n=XS(e),i=US.f,o=VS.f,a=0;a<n.length;a++){var s=n[a];GS(t,s)||r&&GS(r,s)||i(t,s,o(e,s))}},kT=Bi,OT=mr,CT=Y,AT=function(t,e){ZS(e)&&"cause"in e&&qS(t,"cause",e.cause)},LT=function(t,e,r,n){iT&&(oT?oT(t,e):rT(t,"stack",nT(r,n)))},PT=xT,MT=function(t,e){return void 0===t?arguments.length<2?"":e:bT(t)},DT=de("toStringTag"),RT=Error,IT=[].push,jT=function(t,e){var r,n=_T(zT,this);TT?r=TT(RT(),n?ST(this):zT):(r=n?this:kT(zT),OT(r,DT,"Error")),void 0!==e&&OT(r,"message",MT(e)),LT(r,jT,r.stack,1),arguments.length>2&&AT(r,arguments[2]);var i=[];return PT(t,IT,{that:i}),OT(r,"errors",i),r};TT?TT(jT,RT):ET(jT,RT,{name:!0});var zT=jT.prototype=kT(RT.prototype,{constructor:CT(1,jT),message:CT(1,""),name:CT(1,"AggregateError")});wT({global:!0,constructor:!0,arity:2},{AggregateError:jT});var FT,NT,BT,WT,YT="undefined"!=typeof process&&"process"==S(process),GT=ct,XT=ao,VT=M,UT=de("species"),ZT=function(t){var e=GT(t);VT&&e&&!e[UT]&&XT(e,UT,{configurable:!0,get:function(){return this}})},qT=lt,HT=TypeError,$T=function(t,e){if(qT(e,t))return t;throw HT("Incorrect invocation")},KT=bn,JT=At,QT=TypeError,tE=function(t){if(KT(t))return t;throw QT(JT(t)+" is not a constructor")},eE=ir,rE=tE,nE=q,iE=de("species"),oE=function(t,e){var r,n=eE(t).constructor;return void 0===n||nE(r=eE(n)[iE])?e:rE(r)},aE=/(?:ipad|iphone|ipod).*applewebkit/i.test(ht),sE=s,uE=d,cE=Je,lE=L,hE=te,fE=u,pE=Si,dE=Es,vE=Ce,yE=hp,gE=aE,mE=YT,xE=sE.setImmediate,bE=sE.clearImmediate,wE=sE.process,_E=sE.Dispatch,SE=sE.Function,TE=sE.MessageChannel,EE=sE.String,kE=0,OE={},CE="onreadystatechange";fE((function(){FT=sE.location}));var AE=function(t){if(hE(OE,t)){var e=OE[t];delete OE[t],e()}},LE=function(t){return function(){AE(t)}},PE=function(t){AE(t.data)},ME=function(t){sE.postMessage(EE(t),FT.protocol+"//"+FT.host)};xE&&bE||(xE=function(t){yE(arguments.length,1);var e=lE(t)?t:SE(t),r=dE(arguments,1);return OE[++kE]=function(){uE(e,void 0,r)},NT(kE),kE},bE=function(t){delete OE[t]},mE?NT=function(t){wE.nextTick(LE(t))}:_E&&_E.now?NT=function(t){_E.now(LE(t))}:TE&&!gE?(WT=(BT=new TE).port2,BT.port1.onmessage=PE,NT=cE(WT.postMessage,WT)):sE.addEventListener&&lE(sE.postMessage)&&!sE.importScripts&&FT&&"file:"!==FT.protocol&&!fE(ME)?(NT=ME,sE.addEventListener("message",PE,!1)):NT=CE in vE("script")?function(t){pE.appendChild(vE("script"))[CE]=function(){pE.removeChild(this),AE(t)}}:function(t){setTimeout(LE(t),0)});var DE={set:xE,clear:bE},RE=function(){this.head=null,this.tail=null};RE.prototype={add:function(t){var e={item:t,next:null},r=this.tail;r?r.next=e:this.head=e,this.tail=e},get:function(){var t=this.head;if(t)return null===(this.head=t.next)&&(this.tail=null),t.item}};var IE,jE,zE,FE,NE,BE=RE,WE=/ipad|iphone|ipod/i.test(ht)&&"undefined"!=typeof Pebble,YE=/web0s(?!.*chrome)/i.test(ht),GE=s,XE=Je,VE=P.f,UE=DE.set,ZE=BE,qE=aE,HE=WE,$E=YE,KE=YT,JE=GE.MutationObserver||GE.WebKitMutationObserver,QE=GE.document,tk=GE.process,ek=GE.Promise,rk=VE(GE,"queueMicrotask"),nk=rk&&rk.value;if(!nk){var ik=new ZE,ok=function(){var t,e;for(KE&&(t=tk.domain)&&t.exit();e=ik.get();)try{e()}catch(t){throw ik.head&&IE(),t}t&&t.enter()};qE||KE||$E||!JE||!QE?!HE&&ek&&ek.resolve?((FE=ek.resolve(void 0)).constructor=ek,NE=XE(FE.then,FE),IE=function(){NE(ok)}):KE?IE=function(){tk.nextTick(ok)}:(UE=XE(UE,GE),IE=function(){UE(ok)}):(jE=!0,zE=QE.createTextNode(""),new JE(ok).observe(zE,{characterData:!0}),IE=function(){zE.data=jE=!jE}),nk=function(t){ik.head||IE(),ik.add(t)}}var ak=nk,sk=function(t){try{return{error:!1,value:t()}}catch(t){return{error:!0,value:t}}},uk=s.Promise,ck="object"==typeof Deno&&Deno&&"object"==typeof Deno.version,lk=!ck&&!YT&&"object"==typeof window&&"object"==typeof document,hk=s,fk=uk,pk=L,dk=qe,vk=an,yk=de,gk=lk,mk=ck,xk=mt,bk=fk&&fk.prototype,wk=yk("species"),_k=!1,Sk=pk(hk.PromiseRejectionEvent),Tk=dk("Promise",(function(){var t=vk(fk),e=t!==String(fk);if(!e&&66===xk)return!0;if(!bk.catch||!bk.finally)return!0;if(!xk||xk<51||!/native code/.test(t)){var r=new fk((function(t){t(1)})),n=function(t){t((function(){}),(function(){}))};if((r.constructor={})[wk]=n,!(_k=r.then((function(){}))instanceof n))return!0}return!e&&(gk||mk)&&!Sk})),Ek={CONSTRUCTOR:Tk,REJECTION_EVENT:Sk,SUBCLASSING:_k},kk={},Ok=Dt,Ck=TypeError,Ak=function(t){var e,r;this.promise=new t((function(t,n){if(void 0!==e||void 0!==r)throw Ck("Bad Promise constructor");e=t,r=n})),this.resolve=Ok(e),this.reject=Ok(r)};kk.f=function(t){return new Ak(t)};var Lk,Pk,Mk=Lr,Dk=YT,Rk=s,Ik=I,jk=io,zk=Po,Fk=ZT,Nk=Dt,Bk=L,Wk=nt,Yk=$T,Gk=oE,Xk=DE.set,Vk=ak,Uk=function(t,e){try{1==arguments.length?console.error(t):console.error(t,e)}catch(t){}},Zk=sk,qk=BE,Hk=Zo,$k=uk,Kk=kk,Jk="Promise",Qk=Ek.CONSTRUCTOR,tO=Ek.REJECTION_EVENT,eO=Hk.getterFor(Jk),rO=Hk.set,nO=$k&&$k.prototype,iO=$k,oO=nO,aO=Rk.TypeError,sO=Rk.document,uO=Rk.process,cO=Kk.f,lO=cO,hO=!!(sO&&sO.createEvent&&Rk.dispatchEvent),fO="unhandledrejection",pO=function(t){var e;return!(!Wk(t)||!Bk(e=t.then))&&e},dO=function(t,e){var r,n,i,o=e.value,a=1==e.state,s=a?t.ok:t.fail,u=t.resolve,c=t.reject,l=t.domain;try{s?(a||(2===e.rejection&&xO(e),e.rejection=1),!0===s?r=o:(l&&l.enter(),r=s(o),l&&(l.exit(),i=!0)),r===t.promise?c(aO("Promise-chain cycle")):(n=pO(r))?Ik(n,r,u,c):u(r)):c(o)}catch(t){l&&!i&&l.exit(),c(t)}},vO=function(t,e){t.notified||(t.notified=!0,Vk((function(){for(var r,n=t.reactions;r=n.get();)dO(r,t);t.notified=!1,e&&!t.rejection&&gO(t)})))},yO=function(t,e,r){var n,i;hO?((n=sO.createEvent("Event")).promise=e,n.reason=r,n.initEvent(t,!1,!0),Rk.dispatchEvent(n)):n={promise:e,reason:r},!tO&&(i=Rk["on"+t])?i(n):t===fO&&Uk("Unhandled promise rejection",r)},gO=function(t){Ik(Xk,Rk,(function(){var e,r=t.facade,n=t.value;if(mO(t)&&(e=Zk((function(){Dk?uO.emit("unhandledRejection",n,r):yO(fO,r,n)})),t.rejection=Dk||mO(t)?2:1,e.error))throw e.value}))},mO=function(t){return 1!==t.rejection&&!t.parent},xO=function(t){Ik(Xk,Rk,(function(){var e=t.facade;Dk?uO.emit("rejectionHandled",e):yO("rejectionhandled",e,t.value)}))},bO=function(t,e,r){return function(n){t(e,n,r)}},wO=function(t,e,r){t.done||(t.done=!0,r&&(t=r),t.value=e,t.state=2,vO(t,!0))},_O=function(t,e,r){if(!t.done){t.done=!0,r&&(t=r);try{if(t.facade===e)throw aO("Promise can't be resolved itself");var n=pO(e);n?Vk((function(){var r={done:!1};try{Ik(n,e,bO(_O,r,t),bO(wO,r,t))}catch(e){wO(r,e,t)}})):(t.value=e,t.state=1,vO(t,!1))}catch(e){wO({done:!1},e,t)}}};Qk&&(oO=(iO=function(t){Yk(this,oO),Nk(t),Ik(Lk,this);var e=eO(this);try{t(bO(_O,e),bO(wO,e))}catch(t){wO(e,t)}}).prototype,(Lk=function(t){rO(this,{type:Jk,done:!1,notified:!1,parent:!1,reactions:new qk,rejection:!1,state:0,value:void 0})}).prototype=jk(oO,"then",(function(t,e){var r=eO(this),n=cO(Gk(this,iO));return r.parent=!0,n.ok=!Bk(t)||t,n.fail=Bk(e)&&e,n.domain=Dk?uO.domain:void 0,0==r.state?r.reactions.add(n):Vk((function(){dO(n,r)})),n.promise})),Pk=function(){var t=new Lk,e=eO(t);this.promise=t,this.resolve=bO(_O,e),this.reject=bO(wO,e)},Kk.f=cO=function(t){return t===iO||undefined===t?new Pk(t):lO(t)}),Mk({global:!0,constructor:!0,wrap:!0,forced:Qk},{Promise:iO}),zk(iO,Jk,!1,!0),Fk(Jk);var SO=uk,TO=Ek.CONSTRUCTOR||!zd((function(t){SO.all(t).then(void 0,(function(){}))})),EO=I,kO=Dt,OO=kk,CO=sk,AO=xT;Lr({target:"Promise",stat:!0,forced:TO},{all:function(t){var e=this,r=OO.f(e),n=r.resolve,i=r.reject,o=CO((function(){var r=kO(e.resolve),o=[],a=0,s=1;AO(t,(function(t){var u=a++,c=!1;s++,EO(r,e,t).then((function(t){c||(c=!0,o[u]=t,--s||n(o))}),i)})),--s||n(o)}));return o.error&&i(o.value),r.promise}});var LO=Lr,PO=Ek.CONSTRUCTOR;uk&&uk.prototype,LO({target:"Promise",proto:!0,forced:PO,real:!0},{catch:function(t){return this.then(void 0,t)}});var MO=I,DO=Dt,RO=kk,IO=sk,jO=xT;Lr({target:"Promise",stat:!0,forced:TO},{race:function(t){var e=this,r=RO.f(e),n=r.reject,i=IO((function(){var i=DO(e.resolve);jO(t,(function(t){MO(i,e,t).then(r.resolve,n)}))}));return i.error&&n(i.value),r.promise}});var zO=I,FO=kk;Lr({target:"Promise",stat:!0,forced:Ek.CONSTRUCTOR},{reject:function(t){var e=FO.f(this);return zO(e.reject,void 0,t),e.promise}});var NO=ir,BO=nt,WO=kk,YO=function(t,e){if(NO(t),BO(e)&&e.constructor===t)return e;var r=WO.f(t);return(0,r.resolve)(e),r.promise},GO=Lr,XO=uk,VO=Ek.CONSTRUCTOR,UO=YO,ZO=ct("Promise"),qO=!VO;GO({target:"Promise",stat:!0,forced:true},{resolve:function(t){return UO(qO&&this===ZO?XO:this,t)}});var HO=I,$O=Dt,KO=kk,JO=sk,QO=xT;Lr({target:"Promise",stat:!0,forced:TO},{allSettled:function(t){var e=this,r=KO.f(e),n=r.resolve,i=r.reject,o=JO((function(){var r=$O(e.resolve),i=[],o=0,a=1;QO(t,(function(t){var s=o++,u=!1;a++,HO(r,e,t).then((function(t){u||(u=!0,i[s]={status:"fulfilled",value:t},--a||n(i))}),(function(t){u||(u=!0,i[s]={status:"rejected",reason:t},--a||n(i))}))})),--a||n(i)}));return o.error&&i(o.value),r.promise}});var tC=I,eC=Dt,rC=ct,nC=kk,iC=sk,oC=xT,aC="No one promise resolved";Lr({target:"Promise",stat:!0,forced:TO},{any:function(t){var e=this,r=rC("AggregateError"),n=nC.f(e),i=n.resolve,o=n.reject,a=iC((function(){var n=eC(e.resolve),a=[],s=0,u=1,c=!1;oC(t,(function(t){var l=s++,h=!1;u++,tC(n,e,t).then((function(t){h||c||(c=!0,i(t))}),(function(t){h||c||(h=!0,a[l]=t,--u||o(new r(a,aC)))}))})),--u||o(new r(a,aC))}));return a.error&&o(a.value),n.promise}});var sC=Lr,uC=uk,cC=u,lC=ct,hC=L,fC=oE,pC=YO,dC=uC&&uC.prototype;sC({target:"Promise",proto:!0,real:!0,forced:!!uC&&cC((function(){dC.finally.call({then:function(){}},(function(){}))}))},{finally:function(t){var e=fC(this,lC("Promise")),r=hC(t);return this.then(r?function(r){return pC(e,t()).then((function(){return r}))}:t,r?function(r){return pC(e,t()).then((function(){throw r}))}:t)}});var vC=it.Promise,yC=kk,gC=sk;Lr({target:"Promise",stat:!0,forced:!0},{try:function(t){var e=yC.f(this),r=gC(t);return(r.error?e.reject:e.resolve)(r.value),e.promise}});var mC=vC;YS.exports=mC,BS.exports=WS;var xC={},bC={get exports(){return xC},set exports(t){xC=t}},wC={},_C=Jg;({get exports(){return wC},set exports(t){wC=t}}).exports=_C,bC.exports=wC,function(t){var e=RS.default,n=Uv,i=r,o=uS,a=kS,s=IS,u=pS,c=NS,l=xC,h=fy;function f(){t.exports=f=function(){return r},t.exports.__esModule=!0,t.exports.default=t.exports;var r={},p=Object.prototype,d=p.hasOwnProperty,v=n||function(t,e,r){t[e]=r.value},y="function"==typeof i?i:{},g=y.iterator||"@@iterator",m=y.asyncIterator||"@@asyncIterator",x=y.toStringTag||"@@toStringTag";function b(t,e,r){return n(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{b({},"")}catch(t){b=function(t,e,r){return t[e]=r}}function w(t,e,r,n){var i=e&&e.prototype instanceof T?e:T,a=o(i.prototype),s=new j(n||[]);return v(a,"_invoke",{value:M(t,r,s)}),a}function _(t,e,r){try{return{type:"normal",arg:t.call(e,r)}}catch(t){return{type:"throw",arg:t}}}r.wrap=w;var S={};function T(){}function E(){}function k(){}var O={};b(O,g,(function(){return this}));var C=a&&a(a(z([])));C&&C!==p&&d.call(C,g)&&(O=C);var A=k.prototype=T.prototype=o(O);function L(t){var e;s(e=["next","throw","return"]).call(e,(function(e){b(t,e,(function(t){return this._invoke(e,t)}))}))}function P(t,r){function n(i,o,a,s){var u=_(t[i],t,o);if("throw"!==u.type){var c=u.arg,l=c.value;return l&&"object"==e(l)&&d.call(l,"__await")?r.resolve(l.__await).then((function(t){n("next",t,a,s)}),(function(t){n("throw",t,a,s)})):r.resolve(l).then((function(t){c.value=t,a(c)}),(function(t){return n("throw",t,a,s)}))}s(u.arg)}var i;v(this,"_invoke",{value:function(t,e){function o(){return new r((function(r,i){n(t,e,r,i)}))}return i=i?i.then(o,o):o()}})}function M(t,e,r){var n="suspendedStart";return function(i,o){if("executing"===n)throw new Error("Generator is already running");if("completed"===n){if("throw"===i)throw o;return F()}for(r.method=i,r.arg=o;;){var a=r.delegate;if(a){var s=D(a,r);if(s){if(s===S)continue;return s}}if("next"===r.method)r.sent=r._sent=r.arg;else if("throw"===r.method){if("suspendedStart"===n)throw n="completed",r.arg;r.dispatchException(r.arg)}else"return"===r.method&&r.abrupt("return",r.arg);n="executing";var u=_(t,e,r);if("normal"===u.type){if(n=r.done?"completed":"suspendedYield",u.arg===S)continue;return{value:u.arg,done:r.done}}"throw"===u.type&&(n="completed",r.method="throw",r.arg=u.arg)}}}function D(t,e){var r=e.method,n=t.iterator[r];if(void 0===n)return e.delegate=null,"throw"===r&&t.iterator.return&&(e.method="return",e.arg=void 0,D(t,e),"throw"===e.method)||"return"!==r&&(e.method="throw",e.arg=new TypeError("The iterator does not provide a '"+r+"' method")),S;var i=_(n,t.iterator,e.arg);if("throw"===i.type)return e.method="throw",e.arg=i.arg,e.delegate=null,S;var o=i.arg;return o?o.done?(e[t.resultName]=o.value,e.next=t.nextLoc,"return"!==e.method&&(e.method="next",e.arg=void 0),e.delegate=null,S):o:(e.method="throw",e.arg=new TypeError("iterator result is not an object"),e.delegate=null,S)}function R(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function I(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function j(t){this.tryEntries=[{tryLoc:"root"}],s(t).call(t,R,this),this.reset(!0)}function z(t){if(t){var e=t[g];if(e)return e.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var r=-1,n=function e(){for(;++r<t.length;)if(d.call(t,r))return e.value=t[r],e.done=!1,e;return e.value=void 0,e.done=!0,e};return n.next=n}}return{next:F}}function F(){return{value:void 0,done:!0}}return E.prototype=k,v(A,"constructor",{value:k,configurable:!0}),v(k,"constructor",{value:E,configurable:!0}),E.displayName=b(k,x,"GeneratorFunction"),r.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===E||"GeneratorFunction"===(e.displayName||e.name))},r.mark=function(t){return u?u(t,k):(t.__proto__=k,b(t,x,"GeneratorFunction")),t.prototype=o(A),t},r.awrap=function(t){return{__await:t}},L(P.prototype),b(P.prototype,m,(function(){return this})),r.AsyncIterator=P,r.async=function(t,e,n,i,o){void 0===o&&(o=c);var a=new P(w(t,e,n,i),o);return r.isGeneratorFunction(e)?a:a.next().then((function(t){return t.done?t.value:a.next()}))},L(A),b(A,x,"Generator"),b(A,g,(function(){return this})),b(A,"toString",(function(){return"[object Generator]"})),r.keys=function(t){var e=Object(t),r=[];for(var n in e)r.push(n);return l(r).call(r),function t(){for(;r.length;){var n=r.pop();if(n in e)return t.value=n,t.done=!1,t}return t.done=!0,t}},r.values=z,j.prototype={constructor:j,reset:function(t){var e;if(this.prev=0,this.next=0,this.sent=this._sent=void 0,this.done=!1,this.delegate=null,this.method="next",this.arg=void 0,s(e=this.tryEntries).call(e,I),!t)for(var r in this)"t"===r.charAt(0)&&d.call(this,r)&&!isNaN(+h(r).call(r,1))&&(this[r]=void 0)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var e=this;function r(r,n){return o.type="throw",o.arg=t,e.next=r,n&&(e.method="next",e.arg=void 0),!!n}for(var n=this.tryEntries.length-1;n>=0;--n){var i=this.tryEntries[n],o=i.completion;if("root"===i.tryLoc)return r("end");if(i.tryLoc<=this.prev){var a=d.call(i,"catchLoc"),s=d.call(i,"finallyLoc");if(a&&s){if(this.prev<i.catchLoc)return r(i.catchLoc,!0);if(this.prev<i.finallyLoc)return r(i.finallyLoc)}else if(a){if(this.prev<i.catchLoc)return r(i.catchLoc,!0)}else{if(!s)throw new Error("try statement without catch or finally");if(this.prev<i.finallyLoc)return r(i.finallyLoc)}}}},abrupt:function(t,e){for(var r=this.tryEntries.length-1;r>=0;--r){var n=this.tryEntries[r];if(n.tryLoc<=this.prev&&d.call(n,"finallyLoc")&&this.prev<n.finallyLoc){var i=n;break}}i&&("break"===t||"continue"===t)&&i.tryLoc<=e&&e<=i.finallyLoc&&(i=null);var o=i?i.completion:{};return o.type=t,o.arg=e,i?(this.method="next",this.next=i.finallyLoc,S):this.complete(o)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),S},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.finallyLoc===t)return this.complete(r.completion,r.afterLoc),I(r),S}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.tryLoc===t){var n=r.completion;if("throw"===n.type){var i=n.arg;I(r)}return i}}throw new Error("illegal catch attempt")},delegateYield:function(t,e,r){return this.delegate={iterator:z(t),resultName:e,nextLoc:r},"next"===this.method&&(this.arg=void 0),S}},r}t.exports=f,t.exports.__esModule=!0,t.exports.default=t.exports}(DS);var SC=MS(),TC=SC;try{regeneratorRuntime=SC}catch(t){"object"==typeof globalThis?globalThis.regeneratorRuntime=SC:Function("r","regeneratorRuntime = r")(SC)}var EC={},kC={get exports(){return EC},set exports(t){EC=t}},OC=Dt,CC=Kt,AC=Z,LC=Br,PC=TypeError,MC=function(t){return function(e,r,n,i){OC(r);var o=CC(e),a=AC(o),s=LC(o),u=t?s-1:0,c=t?-1:1;if(n<2)for(;;){if(u in a){i=a[u],u+=c;break}if(u+=c,t?u<0:s<=u)throw PC("Reduce of empty array with no initial value")}for(;t?u>=0:s>u;u+=c)u in a&&(i=r(i,a[u],u,o));return i}},DC={left:MC(!1),right:MC(!0)}.left;Lr({target:"Array",proto:!0,forced:!YT&&mt>79&&mt<83||!zl("reduce")},{reduce:function(t){var e=arguments.length;return DC(this,t,e,e>1?arguments[1]:void 0)}});var RC=hh("Array").reduce,IC=lt,jC=RC,zC=Array.prototype,FC=function(t){var e=t.reduce;return t===zC||IC(zC,t)&&e===zC.reduce?jC:e};kC.exports=FC;var NC=e(EC),BC={},WC={get exports(){return BC},set exports(t){BC=t}},YC=Mr,GC=Br,XC=Yr,VC=Je,UC=function(t,e,r,n,i,o,a,s){for(var u,c,l=i,h=0,f=!!a&&VC(a,s);h<n;)h in r&&(u=f?f(r[h],h,e):r[h],o>0&&YC(u)?(c=GC(u),l=UC(t,e,u,c,l,o-1)-1):(XC(l+1),t[l]=u),l++),h++;return l},ZC=UC,qC=Dt,HC=Kt,$C=Br,KC=On;Lr({target:"Array",proto:!0},{flatMap:function(t){var e,r=HC(this),n=$C(r);return qC(t),(e=KC(r,0)).length=ZC(e,r,r,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var JC=hh("Array").flatMap,QC=lt,tA=JC,eA=Array.prototype,rA=function(t){var e=t.flatMap;return t===eA||QC(eA,t)&&e===eA.flatMap?tA:e};WC.exports=rA;var nA=e(BC),iA={},oA={get exports(){return iA},set exports(t){iA=t}},aA={},sA={get exports(){return aA},set exports(t){aA=t}},uA=u((function(){if("function"==typeof ArrayBuffer){var t=new ArrayBuffer(8);Object.isExtensible(t)&&Object.defineProperty(t,"a",{value:8})}})),cA=u,lA=nt,hA=S,fA=uA,pA=Object.isExtensible,dA=cA((function(){pA(1)}))||fA?function(t){return!!lA(t)&&((!fA||"ArrayBuffer"!=hA(t))&&(!pA||pA(t)))}:pA,vA=!u((function(){return Object.isExtensible(Object.preventExtensions({}))})),yA=Lr,gA=x,mA=oi,xA=nt,bA=te,wA=Qe.f,_A=Wi,SA=Xi,TA=dA,EA=vA,kA=!1,OA=oe("meta"),CA=0,AA=function(t){wA(t,OA,{value:{objectID:"O"+CA++,weakData:{}}})},LA=sA.exports={enable:function(){LA.enable=function(){},kA=!0;var t=_A.f,e=gA([].splice),r={};r[OA]=1,t(r).length&&(_A.f=function(r){for(var n=t(r),i=0,o=n.length;i<o;i++)if(n[i]===OA){e(n,i,1);break}return n},yA({target:"Object",stat:!0,forced:!0},{getOwnPropertyNames:SA.f}))},fastKey:function(t,e){if(!xA(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!bA(t,OA)){if(!TA(t))return"F";if(!e)return"E";AA(t)}return t[OA].objectID},getWeakData:function(t,e){if(!bA(t,OA)){if(!TA(t))return!0;if(!e)return!1;AA(t)}return t[OA].weakData},onFreeze:function(t){return EA&&kA&&TA(t)&&!bA(t,OA)&&AA(t),t}};mA[OA]=!0;var PA=Lr,MA=s,DA=aA,RA=u,IA=mr,jA=xT,zA=$T,FA=L,NA=nt,BA=Po,WA=Qe.f,YA=ea.forEach,GA=M,XA=Zo.set,VA=Zo.getterFor,UA=function(t,e,r){var n,i=-1!==t.indexOf("Map"),o=-1!==t.indexOf("Weak"),a=i?"set":"add",s=MA[t],u=s&&s.prototype,c={};if(GA&&FA(s)&&(o||u.forEach&&!RA((function(){(new s).entries().next()})))){var l=(n=e((function(e,r){XA(zA(e,l),{type:t,collection:new s}),null!=r&&jA(r,e[a],{that:e,AS_ENTRIES:i})}))).prototype,h=VA(t);YA(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in u)||o&&"clear"==t||IA(l,t,(function(r,n){var i=h(this).collection;if(!e&&o&&!NA(r))return"get"==t&&void 0;var a=i[t](0===r?0:r,n);return e?this:a}))})),o||WA(l,"size",{configurable:!0,get:function(){return h(this).collection.size}})}else n=r.getConstructor(e,t,i,a),DA.enable();return BA(n,t,!1,!0),c[t]=n,PA({global:!0,forced:!0},c),o||r.setStrong(n,t,i),n},ZA=io,qA=Bi,HA=ao,$A=function(t,e,r){for(var n in e)r&&r.unsafe&&t[n]?t[n]=e[n]:ZA(t,n,e[n],r);return t},KA=Je,JA=$T,QA=q,tL=xT,eL=fc,rL=pc,nL=ZT,iL=M,oL=aA.fastKey,aL=Zo.set,sL=Zo.getterFor,uL={getConstructor:function(t,e,r,n){var i=t((function(t,i){JA(t,o),aL(t,{type:e,index:qA(null),first:void 0,last:void 0,size:0}),iL||(t.size=0),QA(i)||tL(i,t[n],{that:t,AS_ENTRIES:r})})),o=i.prototype,a=sL(e),s=function(t,e,r){var n,i,o=a(t),s=u(t,e);return s?s.value=r:(o.last=s={index:i=oL(e,!0),key:e,value:r,previous:n=o.last,next:void 0,removed:!1},o.first||(o.first=s),n&&(n.next=s),iL?o.size++:t.size++,"F"!==i&&(o.index[i]=s)),t},u=function(t,e){var r,n=a(t),i=oL(e);if("F"!==i)return n.index[i];for(r=n.first;r;r=r.next)if(r.key==e)return r};return $A(o,{clear:function(){for(var t=a(this),e=t.index,r=t.first;r;)r.removed=!0,r.previous&&(r.previous=r.previous.next=void 0),delete e[r.index],r=r.next;t.first=t.last=void 0,iL?t.size=0:this.size=0},delete:function(t){var e=this,r=a(e),n=u(e,t);if(n){var i=n.next,o=n.previous;delete r.index[n.index],n.removed=!0,o&&(o.next=i),i&&(i.previous=o),r.first==n&&(r.first=i),r.last==n&&(r.last=o),iL?r.size--:e.size--}return!!n},forEach:function(t){for(var e,r=a(this),n=KA(t,arguments.length>1?arguments[1]:void 0);e=e?e.next:r.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!u(this,t)}}),$A(o,r?{get:function(t){var e=u(this,t);return e&&e.value},set:function(t,e){return s(this,0===t?0:t,e)}}:{add:function(t){return s(this,t=0===t?0:t,t)}}),iL&&HA(o,"size",{configurable:!0,get:function(){return a(this).size}}),i},setStrong:function(t,e,r){var n=e+" Iterator",i=sL(e),o=sL(n);eL(t,e,(function(t,e){aL(this,{type:n,target:t,state:i(t),kind:e,last:void 0})}),(function(){for(var t=o(this),e=t.kind,r=t.last;r&&r.removed;)r=r.previous;return t.target&&(t.last=r=r?r.next:t.state.first)?rL("keys"==e?r.key:"values"==e?r.value:[r.key,r.value],!1):(t.target=void 0,rL(void 0,!0))}),r?"entries":"values",!r,!0),nL(e)}};UA("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),uL);var cL=it.Map;oA.exports=cL;var lL=e(iA),hL={},fL={get exports(){return hL},set exports(t){hL=t}};UA("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),uL);var pL=it.Set;fL.exports=pL;var dL=e(hL),vL={};({get exports(){return vL},set exports(t){vL=t}}).exports=wl;var yL=e(vL),gL={},mL={get exports(){return gL},set exports(t){gL=t}},xL={},bL=wd;({get exports(){return xL},set exports(t){xL=t}}).exports=bL,mL.exports=xL;var wL=e(gL),_L={},SL={get exports(){return _L},set exports(t){_L=t}},TL=ea.some;Lr({target:"Array",proto:!0,forced:!zl("some")},{some:function(t){return TL(this,t,arguments.length>1?arguments[1]:void 0)}});var EL=hh("Array").some,kL=lt,OL=EL,CL=Array.prototype,AL=function(t){var e=t.some;return t===CL||kL(CL,t)&&e===CL.some?OL:e};SL.exports=AL;var LL=e(_L),PL={},ML={get exports(){return PL},set exports(t){PL=t}},DL=hh("Array").keys,RL=en,IL=te,jL=lt,zL=DL,FL=Array.prototype,NL={DOMTokenList:!0,NodeList:!0},BL=function(t){var e=t.keys;return t===FL||jL(FL,t)&&e===FL.keys||IL(NL,RL(t))?zL:e};ML.exports=BL;var WL=e(PL),YL={},GL={get exports(){return YL},set exports(t){YL=t}},XL=hh("Array").entries,VL=en,UL=te,ZL=lt,qL=XL,HL=Array.prototype,$L={DOMTokenList:!0,NodeList:!0},KL=function(t){var e=t.entries;return t===HL||ZL(HL,t)&&e===HL.entries||UL($L,VL(t))?qL:e};GL.exports=KL;var JL=e(YL),QL={},tP={get exports(){return QL},set exports(t){QL=t}},eP=Lr,rP=d,nP=Rg,iP=tE,oP=ir,aP=nt,sP=Bi,uP=u,cP=ct("Reflect","construct"),lP=Object.prototype,hP=[].push,fP=uP((function(){function t(){}return!(cP((function(){}),[],t)instanceof t)})),pP=!uP((function(){cP((function(){}))})),dP=fP||pP;eP({target:"Reflect",stat:!0,forced:dP,sham:dP},{construct:function(t,e){iP(t),oP(e);var r=arguments.length<3?t:iP(arguments[2]);if(pP&&!fP)return cP(t,e,r);if(t==r){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return rP(hP,n,e),new(rP(nP,t,n))}var i=r.prototype,o=sP(aP(i)?i:lP),a=rP(t,o,e);return aP(a)?a:o}});var vP=it.Reflect.construct;tP.exports=vP;var yP,gP=e(QL),mP=new Uint8Array(16);function xP(){if(!yP&&!(yP="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto)))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return yP(mP)}var bP=/^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;for(var wP,_P=[],SP=0;SP<256;++SP)_P.push((SP+256).toString(16).substr(1));function TP(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=(_P[t[e+0]]+_P[t[e+1]]+_P[t[e+2]]+_P[t[e+3]]+"-"+_P[t[e+4]]+_P[t[e+5]]+"-"+_P[t[e+6]]+_P[t[e+7]]+"-"+_P[t[e+8]]+_P[t[e+9]]+"-"+_P[t[e+10]]+_P[t[e+11]]+_P[t[e+12]]+_P[t[e+13]]+_P[t[e+14]]+_P[t[e+15]]).toLowerCase();if(!function(t){return"string"==typeof t&&bP.test(t)}(r))throw TypeError("Stringified UUID is invalid");return r}function EP(t,e,r){var n=(t=t||{}).random||(t.rng||xP)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,e){r=r||0;for(var i=0;i<16;++i)e[r+i]=n[i];return e}return TP(n)}function kP(t,e){var r=dg(t);if(Hd){var n=Hd(t);e&&(n=Nh(n).call(n,(function(e){return uv(t,e).enumerable}))),r.push.apply(r,n)}return r}function OP(t){for(var e=1;e<arguments.length;e++){var r,n,i=null!=arguments[e]?arguments[e]:{};e%2?Xf(r=kP(Object(i),!0)).call(r,(function(e){ay(t,e,i[e])})):_v?Dv(t,_v(i)):Xf(n=kP(Object(i))).call(n,(function(e){Xv(t,e,uv(i,e))}))}return t}function CP(t){var e=function(){if("undefined"==typeof Reflect||!gP)return!1;if(gP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(gP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=PS(t);if(e){var i=PS(this).constructor;r=gP(n,arguments,i)}else r=n.apply(this,arguments);return function(t,e){if(e&&("object"===Tl(e)||"function"==typeof e))return e;if(void 0!==e)throw new TypeError("Derived constructors may only return object or undefined");return sS(t)}(this,r)}}function AP(t,e){var r=void 0!==Zy&&Vd(t)||t["@@iterator"];if(!r){if(qf(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return LP(t,e);var n=Hy(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Bd(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return LP(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,s=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){s=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw o}}}}function LP(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function PP(t){return new DP(t)}var MP=function(){function t(e,r,n){var i,o,a;Vv(this,t),ay(this,"_source",void 0),ay(this,"_transformers",void 0),ay(this,"_target",void 0),ay(this,"_listeners",{add:Wg(i=this._add).call(i,this),remove:Wg(o=this._remove).call(o,this),update:Wg(a=this._update).call(a,this)}),this._source=e,this._transformers=r,this._target=n}return oy(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return NC(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),DP=function(){function t(e){Vv(this,t),ay(this,"_source",void 0),ay(this,"_transformers",[]),this._source=e}return oy(t,[{key:"filter",value:function(t){return this._transformers.push((function(e){return Nh(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return ug(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return nA(e).call(e,t)})),this}},{key:"to",value:function(t){return new MP(this._source,this._transformers,t)}}]),t}();function RP(t){return"string"==typeof t||"number"==typeof t}var IP=function(){function t(e){Vv(this,t),ay(this,"delay",void 0),ay(this,"max",void 0),ay(this,"_queue",[]),ay(this,"_timeout",null),ay(this,"_extended",null),this.delay=null,this.max=1/0,this.setOptions(e)}return oy(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,r=0;r<e.length;r++){var n=e[r];n.original?t[n.name]=n.original:delete t[n.name]}this._extended=null}}},{key:"replace",value:function(t,e){var r=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];r.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=Ap((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;Xf(t=Em(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,r){var n=new t(r);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){n.flush()};var i=[{name:"flush",original:void 0}];if(r&&r.replace)for(var o=0;o<r.replace.length;o++){var a=r.replace[o];i.push({name:a,original:e[a]}),n.replace(e,a)}return n._extended={object:e,methods:i},n}}]),t}(),jP=function(){function t(){Vv(this,t),ay(this,"_subscribers",{"*":[],add:[],remove:[],update:[]}),ay(this,"subscribe",t.prototype.on),ay(this,"unsubscribe",t.prototype.off)}return oy(t,[{key:"_trigger",value:function(t,e,r){var n,i;if("*"===t)throw new Error("Cannot trigger event *");Xf(n=ap(i=[]).call(i,Vy(this._subscribers[t]),Vy(this._subscribers["*"]))).call(n,(function(n){n(t,e,null!=r?r:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var r;this._subscribers[t]=Nh(r=this._subscribers[t]).call(r,(function(t){return t!==e}))}}]),t}();wP=yL;var zP=function(){function t(e){Vv(this,t),ay(this,"_pairs",void 0),this._pairs=e}return oy(t,[{key:wP,value:TC.mark((function t(){var e,r,n,i,o;return TC.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=AP(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Xy(r.value,2),i=n[0],o=n[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:TC.mark((function t(){var e,r,n,i,o;return TC.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=AP(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Xy(r.value,2),i=n[0],o=n[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:TC.mark((function t(){var e,r,n,i;return TC.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=AP(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Xy(r.value,1),i=n[0],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:TC.mark((function t(){var e,r,n,i;return TC.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=AP(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Xy(r.value,2),i=n[1],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return ug(t=Vy(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return ug(t=Vy(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return Vy(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=Vx(null),r=AP(this._pairs);try{for(r.s();!(t=r.n()).done;){var n=Xy(t.value,2),i=n[0],o=n[1];e[i]=o}}catch(t){r.e(t)}finally{r.f()}return e}},{key:"toMap",value:function(){return new lL(this._pairs)}},{key:"toIdSet",value:function(){return new dL(this.toIdArray())}},{key:"toItemSet",value:function(){return new dL(this.toItemArray())}},{key:"cache",value:function(){return new t(Vy(this._pairs))}},{key:"distinct",value:function(t){var e,r=new dL,n=AP(this._pairs);try{for(n.s();!(e=n.n()).done;){var i=Xy(e.value,2),o=i[0],a=i[1];r.add(t(a,o))}}catch(t){n.e(t)}finally{n.f()}return r}},{key:"filter",value:function(e){var r=this._pairs;return new t(ay({},yL,TC.mark((function t(){var n,i,o,a,s;return TC.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=AP(r),t.prev=1,n.s();case 3:if((i=n.n()).done){t.next=10;break}if(o=Xy(i.value,2),a=o[0],s=o[1],!e(s,a)){t.next=8;break}return t.next=8,[a,s];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),n.e(t.t0);case 15:return t.prev=15,n.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,r=AP(this._pairs);try{for(r.s();!(e=r.n()).done;){var n=Xy(e.value,2),i=n[0];t(n[1],i)}}catch(t){r.e(t)}finally{r.f()}}},{key:"map",value:function(e){var r=this._pairs;return new t(ay({},yL,TC.mark((function t(){var n,i,o,a,s;return TC.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=AP(r),t.prev=1,n.s();case 3:if((i=n.n()).done){t.next=9;break}return o=Xy(i.value,2),a=o[0],s=o[1],t.next=7,[a,e(s,a)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),n.e(t.t0);case 14:return t.prev=14,n.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=wL(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],i=t(r.value[1],r.value[0]);!(r=e.next()).done;){var o=Xy(r.value,2),a=o[0],s=o[1],u=t(s,a);u>i&&(i=u,n=s)}return n}},{key:"min",value:function(t){var e=wL(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],i=t(r.value[1],r.value[0]);!(r=e.next()).done;){var o=Xy(r.value,2),a=o[0],s=o[1],u=t(s,a);u<i&&(i=u,n=s)}return n}},{key:"reduce",value:function(t,e){var r,n=AP(this._pairs);try{for(n.s();!(r=n.n()).done;){var i=Xy(r.value,2),o=i[0];e=t(e,i[1],o)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(e){var r=this;return new t(ay({},yL,(function(){var t;return wL(gh(t=Vy(r._pairs)).call(t,(function(t,r){var n=Xy(t,2),i=n[0],o=n[1],a=Xy(r,2),s=a[0],u=a[1];return e(o,u,i,s)})))})))}}]),t}();var FP=function(t){ES(r,jP);var e=CP(r);function r(t,n){var i;return Vv(this,r),ay(sS(i=e.call(this)),"flush",void 0),ay(sS(i),"length",void 0),ay(sS(i),"_options",void 0),ay(sS(i),"_data",void 0),ay(sS(i),"_idProp",void 0),ay(sS(i),"_queue",null),t&&!qf(t)&&(n=t,t=[]),i._options=n||{},i._data=new lL,i.length=0,i._idProp=i._options.fieldId||"id",t&&t.length&&i.add(t),i.setOptions(n),i}return oy(r,[{key:"idProp",get:function(){return this._idProp}},{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),this._queue=null):(this._queue||(this._queue=IP.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===Tl(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var r,n=this,i=[];if(qf(t)){var o=ug(t).call(t,(function(t){return t[n._idProp]}));if(LL(o).call(o,(function(t){return n._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var a=0,s=t.length;a<s;a++)r=this._addItem(t[a]),i.push(r)}else{if(!t||"object"!==Tl(t))throw new Error("Unknown dataType");r=this._addItem(t),i.push(r)}return i.length&&this._trigger("add",{items:i},e),i}},{key:"update",value:function(t,e){var r=this,n=[],i=[],o=[],a=[],s=this._idProp,u=function(t){var e=t[s];if(null!=e&&r._data.has(e)){var u=t,c=Zp({},r._data.get(e)),l=r._updateItem(u);i.push(l),a.push(u),o.push(c)}else{var h=r._addItem(t);n.push(h)}};if(qf(t))for(var c=0,l=t.length;c<l;c++)t[c]&&"object"===Tl(t[c])?u(t[c]):console.warn("Ignoring input item, which is not an object at index "+c);else{if(!t||"object"!==Tl(t))throw new Error("Unknown dataType");u(t)}if(n.length&&this._trigger("add",{items:n},e),i.length){var h={items:i,oldData:o,data:a};this._trigger("update",h,e)}return ap(n).call(n,i)}},{key:"updateOnly",value:function(t,e){var r,n=this;qf(t)||(t=[t]);var i=ug(r=ug(t).call(t,(function(t){var e=n._data.get(t[n._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(r,(function(t){var e=t.oldData,r=t.update,i=e[n._idProp],o=function(t){for(var e,r=arguments.length,n=new Array(r>1?r-1:0),i=1;i<r;i++)n[i-1]=arguments[i];return c_.apply(void 0,ap(e=[{},t]).call(e,n))}(e,r);return n._data.set(i,o),{id:i,oldData:e,updatedData:o}}));if(i.length){var o={items:ug(i).call(i,(function(t){return t.id})),oldData:ug(i).call(i,(function(t){return t.oldData})),data:ug(i).call(i,(function(t){return t.updatedData}))};return this._trigger("update",o,e),o.items}return[]}},{key:"get",value:function(t,e){var r=void 0,n=void 0,i=void 0;RP(t)?(r=t,i=e):qf(t)?(n=t,i=e):i=t;var o,a=i&&"Object"===i.returnType?"Object":"Array",s=i&&Nh(i),u=[],c=void 0,l=void 0,h=void 0;if(null!=r)(c=this._data.get(r))&&s&&!s(c)&&(c=void 0);else if(null!=n)for(var f=0,p=n.length;f<p;f++)null==(c=this._data.get(n[f]))||s&&!s(c)||u.push(c);else for(var d,v=0,y=(l=Vy(WL(d=this._data).call(d))).length;v<y;v++)h=l[v],null==(c=this._data.get(h))||s&&!s(c)||u.push(c);if(i&&i.order&&null==r&&this._sort(u,i.order),i&&i.fields){var g=i.fields;if(null!=r&&null!=c)c=this._filterFields(c,g);else for(var m=0,x=u.length;m<x;m++)u[m]=this._filterFields(u[m],g)}if("Object"==a){for(var b={},w=0,_=u.length;w<_;w++){var S=u[w];b[S[this._idProp]]=S}return b}return null!=r?null!==(o=c)&&void 0!==o?o:null:u}},{key:"getIds",value:function(t){var e=this._data,r=t&&Nh(t),n=t&&t.order,i=Vy(WL(e).call(e)),o=[];if(r)if(n){for(var a=[],s=0,u=i.length;s<u;s++){var c=i[s],l=this._data.get(c);null!=l&&r(l)&&a.push(l)}this._sort(a,n);for(var h=0,f=a.length;h<f;h++)o.push(a[h][this._idProp])}else for(var p=0,d=i.length;p<d;p++){var v=i[p],y=this._data.get(v);null!=y&&r(y)&&o.push(y[this._idProp])}else if(n){for(var g=[],m=0,x=i.length;m<x;m++){var b=i[m];g.push(e.get(b))}this._sort(g,n);for(var w=0,_=g.length;w<_;w++)o.push(g[w][this._idProp])}else for(var S=0,T=i.length;S<T;S++){var E=i[S],k=e.get(E);null!=k&&o.push(k[this._idProp])}return o}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var r=e&&Nh(e),n=this._data,i=Vy(WL(n).call(n));if(e&&e.order)for(var o=this.get(e),a=0,s=o.length;a<s;a++){var u=o[a];t(u,u[this._idProp])}else for(var c=0,l=i.length;c<l;c++){var h=i[c],f=this._data.get(h);null==f||r&&!r(f)||t(f,h)}}},{key:"map",value:function(t,e){for(var r=e&&Nh(e),n=[],i=this._data,o=Vy(WL(i).call(i)),a=0,s=o.length;a<s;a++){var u=o[a],c=this._data.get(u);null==c||r&&!r(c)||n.push(t(c,u))}return e&&e.order&&this._sort(n,e.order),n}},{key:"_filterFields",value:function(t,e){var r;return t?NC(r=qf(e)?e:dg(e)).call(r,(function(e,r){return e[r]=t[r],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var r=e;gh(t).call(t,(function(t,e){var n=t[r],i=e[r];return n>i?1:n<i?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");gh(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var r=[],n=[],i=qf(t)?t:[t],o=0,a=i.length;o<a;o++){var s=this._remove(i[o]);if(s){var u=s[this._idProp];null!=u&&(r.push(u),n.push(s))}}return r.length&&this._trigger("remove",{items:r,oldData:n},e),r}},{key:"_remove",value:function(t){var e;if(RP(t)?e=t:t&&"object"===Tl(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var r=this._data.get(e)||null;return this._data.delete(e),--this.length,r}return null}},{key:"clear",value:function(t){for(var e,r=Vy(WL(e=this._data).call(e)),n=[],i=0,o=r.length;i<o;i++)n.push(this._data.get(r[i]));return this._data.clear(),this.length=0,this._trigger("remove",{items:r,oldData:n},t),r}},{key:"max",value:function(t){var e,r,n=null,i=null,o=AP(Pf(e=this._data).call(e));try{for(o.s();!(r=o.n()).done;){var a=r.value,s=a[t];"number"==typeof s&&(null==i||s>i)&&(n=a,i=s)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"min",value:function(t){var e,r,n=null,i=null,o=AP(Pf(e=this._data).call(e));try{for(o.s();!(r=o.n()).done;){var a=r.value,s=a[t];"number"==typeof s&&(null==i||s<i)&&(n=a,i=s)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"distinct",value:function(t){for(var e=this._data,r=Vy(WL(e).call(e)),n=[],i=0,o=0,a=r.length;o<a;o++){for(var s=r[o],u=e.get(s)[t],c=!1,l=0;l<i;l++)if(n[l]==u){c=!0;break}c||void 0===u||(n[i]=u,i++)}return n}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=EP()),t}(t,this._idProp),r=e[this._idProp];if(this._data.has(r))throw new Error("Cannot add item: item with id "+r+" already exists");return this._data.set(r,e),++this.length,r}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+Kx(t)+")");var r=this._data.get(e);if(!r)throw new Error("Cannot update item: no item with id "+e+" found");return this._data.set(e,OP(OP({},r),t)),e}},{key:"stream",value:function(t){if(t){var e=this._data;return new zP(ay({},yL,TC.mark((function r(){var n,i,o,a;return TC.wrap((function(r){for(;;)switch(r.prev=r.next){case 0:n=AP(t),r.prev=1,n.s();case 3:if((i=n.n()).done){r.next=11;break}if(o=i.value,null==(a=e.get(o))){r.next=9;break}return r.next=9,[o,a];case 9:r.next=3;break;case 11:r.next=16;break;case 13:r.prev=13,r.t0=r.catch(1),n.e(r.t0);case 16:return r.prev=16,n.f(),r.finish(16);case 19:case"end":return r.stop()}}),r,null,[[1,13,16,19]])}))))}var r;return new zP(ay({},yL,Wg(r=JL(this._data)).call(r,this._data)))}}]),r}(),NP=function(t){ES(r,jP);var e=CP(r);function r(t,n){var i,o;return Vv(this,r),ay(sS(o=e.call(this)),"length",0),ay(sS(o),"_listener",void 0),ay(sS(o),"_data",void 0),ay(sS(o),"_ids",new dL),ay(sS(o),"_options",void 0),o._options=n||{},o._listener=Wg(i=o._onEvent).call(i,sS(o)),o.setData(t),o}return oy(r,[{key:"idProp",get:function(){return this.getDataSet().idProp}},{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:Nh(this._options)}),r=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:r})}if(null!=t){this._data=t;for(var n=this._data.getIds({filter:Nh(this._options)}),i=0,o=n.length;i<o;i++){var a=n[i];this._ids.add(a)}this.length=n.length,this._trigger("add",{items:n})}else this._data=new FP;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:Nh(this._options)}),e=Vy(this._ids),r={},n=[],i=[],o=[],a=0,s=t.length;a<s;a++){var u=t[a];r[u]=!0,this._ids.has(u)||(n.push(u),this._ids.add(u))}for(var c=0,l=e.length;c<l;c++){var h=e[c],f=this._data.get(h);null==f?console.error("If you see this, report it please."):r[h]||(i.push(h),o.push(f),this._ids.delete(h))}this.length+=n.length-i.length,n.length&&this._trigger("add",{items:n}),i.length&&this._trigger("remove",{items:i,oldData:o})}},{key:"get",value:function(t,e){if(null==this._data)return null;var r,n=null;RP(t)||qf(t)?(n=t,r=e):r=t;var i=Zp({},this._options,r),o=Nh(this._options),a=r&&Nh(r);return o&&a&&(i.filter=function(t){return o(t)&&a(t)}),null==n?this._data.get(i):this._data.get(n,i)}},{key:"getIds",value:function(t){if(this._data.length){var e,r=Nh(this._options),n=null!=t?Nh(t):null;return e=n?r?function(t){return r(t)&&n(t)}:n:r,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var r,n,i=Nh(this._options),o=e&&Nh(e);n=o?i?function(t){return i(t)&&o(t)}:o:i,Xf(r=this._data).call(r,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var r,n,i=Nh(this._options),o=e&&Nh(e);return n=o?i?function(t){return i(t)&&o(t)}:o:i,ug(r=this._data).call(r,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||ay({},yL,Wg(e=WL(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;null!==(t=this._data)&&void 0!==t&&t.off&&this._data.off("*",this._listener);var e,n="This data view has already been disposed of.",i={get:function(){throw new Error(n)},set:function(){throw new Error(n)},configurable:!1},o=AP(Qy(r.prototype));try{for(o.s();!(e=o.n()).done;){var a=e.value;Xv(this,a,i)}}catch(t){o.e(t)}finally{o.f()}}},{key:"_onEvent",value:function(t,e,r){if(e&&e.items&&this._data){var n=e.items,i=[],o=[],a=[],s=[],u=[],c=[];switch(t){case"add":for(var l=0,h=n.length;l<h;l++){var f=n[l];this.get(f)&&(this._ids.add(f),i.push(f))}break;case"update":for(var p=0,d=n.length;p<d;p++){var v=n[p];this.get(v)?this._ids.has(v)?(o.push(v),u.push(e.data[p]),s.push(e.oldData[p])):(this._ids.add(v),i.push(v)):this._ids.has(v)&&(this._ids.delete(v),a.push(v),c.push(e.oldData[p]))}break;case"remove":for(var y=0,g=n.length;y<g;y++){var m=n[y];this._ids.has(m)&&(this._ids.delete(m),a.push(m),c.push(e.oldData[y]))}}this.length+=i.length-a.length,i.length&&this._trigger("add",{items:i},r),o.length&&this._trigger("update",{items:o,oldData:s,data:u},r),a.length&&this._trigger("remove",{items:a,oldData:c},r)}}}]),r}();function BP(t,e){return"object"===Tl(e)&&null!==e&&t===e.idProp&&"function"==typeof e.add&&"function"==typeof e.clear&&"function"==typeof e.distinct&&"function"==typeof Xf(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof ug(e)&&"function"==typeof e.max&&"function"==typeof e.min&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.remove&&"function"==typeof e.setOptions&&"function"==typeof e.stream&&"function"==typeof e.update&&"function"==typeof e.updateOnly}function WP(t,e){return"object"===Tl(e)&&null!==e&&t===e.idProp&&"function"==typeof Xf(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof ug(e)&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.stream&&BP(t,e.getDataSet())}function YP(){this.min=void 0,this.max=void 0}YP.prototype.adjust=function(t){void 0!==t&&((void 0===this.min||this.min>t)&&(this.min=t),(void 0===this.max||this.max<t)&&(this.max=t))},YP.prototype.combine=function(t){this.add(t.min),this.add(t.max)},YP.prototype.expand=function(t){if(void 0!==t){var e=this.min-t,r=this.max+t;if(e>r)throw new Error("Passed expansion value makes range invalid");this.min=e,this.max=r}},YP.prototype.range=function(){return this.max-this.min},YP.prototype.center=function(){return(this.min+this.max)/2};var GP=YP;function XP(t,e,r){this.dataGroup=t,this.column=e,this.graph=r,this.index=void 0,this.value=void 0,this.values=t.getDistinctValues(this.column),Pf(this).length>0&&this.selectValue(0),this.dataPoints=[],this.loaded=!1,this.onLoadCallback=void 0,r.animationPreload?(this.loaded=!1,this.loadInBackground()):this.loaded=!0}function VP(){this.dataTable=null}XP.prototype.isLoaded=function(){return this.loaded},XP.prototype.getLoadedProgress=function(){for(var t=Pf(this).length,e=0;this.dataPoints[e];)e++;return Math.round(e/t*100)},XP.prototype.getLabel=function(){return this.graph.filterLabel},XP.prototype.getColumn=function(){return this.column},XP.prototype.getSelectedValue=function(){if(void 0!==this.index)return Pf(this)[this.index]},XP.prototype.getValues=function(){return Pf(this)},XP.prototype.getValue=function(t){if(t>=Pf(this).length)throw new Error("Index out of range");return Pf(this)[t]},XP.prototype._getDataPoints=function(t){if(void 0===t&&(t=this.index),void 0===t)return[];var e;if(this.dataPoints[t])e=this.dataPoints[t];else{var r={};r.column=this.column,r.value=Pf(this)[t];var n=new NP(this.dataGroup.getDataSet(),{filter:function(t){return t[r.column]==r.value}}).get();e=this.dataGroup._getDataPoints(n),this.dataPoints[t]=e}return e},XP.prototype.setOnLoadCallback=function(t){this.onLoadCallback=t},XP.prototype.selectValue=function(t){if(t>=Pf(this).length)throw new Error("Index out of range");this.index=t,this.value=Pf(this)[t]},XP.prototype.loadInBackground=function(t){void 0===t&&(t=0);var e=this.graph.frame;if(t<Pf(this).length){void 0===e.progress&&(e.progress=document.createElement("DIV"),e.progress.style.position="absolute",e.progress.style.color="gray",e.appendChild(e.progress));var r=this.getLoadedProgress();e.progress.innerHTML="Loading animation... "+r+"%",e.progress.style.bottom="60px",e.progress.style.left="10px";var n=this;Ap((function(){n.loadInBackground(t+1)}),10),this.loaded=!1}else this.loaded=!0,void 0!==e.progress&&(e.removeChild(e.progress),e.progress=void 0),this.onLoadCallback&&this.onLoadCallback()},VP.prototype.initializeData=function(t,e,r){if(void 0!==e){var n;if(qf(e)&&(e=new FP(e)),!(e instanceof FP||e instanceof NP))throw new Error("Array, DataSet, or DataView expected");if(0!=(n=e.get()).length){this.style=r,this.dataSet&&this.dataSet.off("*",this._onChange),this.dataSet=e,this.dataTable=n;var i=this;this._onChange=function(){t.setData(i.dataSet)},this.dataSet.on("*",this._onChange),this.colX="x",this.colY="y",this.colZ="z";var o=t.hasBars(r);if(o&&(void 0!==t.defaultXBarWidth?this.xBarWidth=t.defaultXBarWidth:this.xBarWidth=this.getSmallestDifference(n,this.colX)||1,void 0!==t.defaultYBarWidth?this.yBarWidth=t.defaultYBarWidth:this.yBarWidth=this.getSmallestDifference(n,this.colY)||1),this._initializeRange(n,this.colX,t,o),this._initializeRange(n,this.colY,t,o),this._initializeRange(n,this.colZ,t,!1),Object.prototype.hasOwnProperty.call(n[0],"style")){this.colValue="style";var a=this.getColumnRange(n,this.colValue);this._setRangeDefaults(a,t.defaultValueMin,t.defaultValueMax),this.valueRange=a}else this.colValue="z",this.valueRange=this.zRange;var s=this.getDataTable();return Object.prototype.hasOwnProperty.call(s[0],"filter")&&void 0===this.dataFilter&&(this.dataFilter=new XP(this,"filter",t),this.dataFilter.setOnLoadCallback((function(){t.redraw()}))),this.dataFilter?this.dataFilter._getDataPoints():this._getDataPoints(this.getDataTable())}}},VP.prototype._collectRangeSettings=function(t,e){var r;if(-1==Lh(r=["x","y","z"]).call(r,t))throw new Error("Column '"+t+"' invalid");var n=t.toUpperCase();return{barWidth:this[t+"BarWidth"],min:e["default"+n+"Min"],max:e["default"+n+"Max"],step:e["default"+n+"Step"],range_label:t+"Range",step_label:t+"Step"}},VP.prototype._initializeRange=function(t,e,r,n){var i=this._collectRangeSettings(e,r),o=this.getColumnRange(t,e);n&&"z"!=e&&o.expand(i.barWidth/2),this._setRangeDefaults(o,i.min,i.max),this[i.range_label]=o,this[i.step_label]=void 0!==i.step?i.step:o.range()/5},VP.prototype.getDistinctValues=function(t,e){void 0===e&&(e=this.dataTable);for(var r=[],n=0;n<e.length;n++){var i=e[n][t]||0;-1===Lh(r).call(r,i)&&r.push(i)}return gh(r).call(r,(function(t,e){return t-e}))},VP.prototype.getSmallestDifference=function(t,e){for(var r=this.getDistinctValues(t,e),n=null,i=1;i<r.length;i++){var o=r[i]-r[i-1];(null==n||n>o)&&(n=o)}return n},VP.prototype.getColumnRange=function(t,e){for(var r=new GP,n=0;n<t.length;n++){var i=t[n][e];r.adjust(i)}return r},VP.prototype.getNumberOfRows=function(){return this.dataTable.length},VP.prototype._setRangeDefaults=function(t,e,r){void 0!==e&&(t.min=e),void 0!==r&&(t.max=r),t.max<=t.min&&(t.max=t.min+1)},VP.prototype.getDataTable=function(){return this.dataTable},VP.prototype.getDataSet=function(){return this.dataSet},VP.prototype.getDataPoints=function(t){for(var e=[],r=0;r<t.length;r++){var n=new P_;n.x=t[r][this.colX]||0,n.y=t[r][this.colY]||0,n.z=t[r][this.colZ]||0,n.data=t[r],n.value=t[r][this.colValue]||0;var i={};i.point=n,i.bottom=new P_(n.x,n.y,this.zRange.min),i.trans=void 0,i.screen=void 0,e.push(i)}return e},VP.prototype.initDataAsMatrix=function(t){var e,r,n,i,o=this.getDistinctValues(this.colX,t),a=this.getDistinctValues(this.colY,t),s=this.getDataPoints(t),u=[];for(n=0;n<s.length;n++){i=s[n];var c=Lh(o).call(o,i.point.x),l=Lh(a).call(a,i.point.y);void 0===u[c]&&(u[c]=[]),u[c][l]=i}for(e=0;e<u.length;e++)for(r=0;r<u[e].length;r++)u[e][r]&&(u[e][r].pointRight=e<u.length-1?u[e+1][r]:void 0,u[e][r].pointTop=r<u[e].length-1?u[e][r+1]:void 0,u[e][r].pointCross=e<u.length-1&&r<u[e].length-1?u[e+1][r+1]:void 0);return s},VP.prototype.getInfo=function(){var t=this.dataFilter;if(t)return t.getLabel()+": "+t.getSelectedValue()},VP.prototype.reload=function(){this.dataTable&&this.setData(this.dataTable)},VP.prototype._getDataPoints=function(t){var e=[];if(this.style===W_.GRID||this.style===W_.SURFACE)e=this.initDataAsMatrix(t);else if(e=this.getDataPoints(t),this.style===W_.LINE)for(var r=0;r<e.length;r++)r>0&&(e[r-1].pointNext=e[r]);return e},ZP.STYLE=W_;var UP=void 0;function ZP(t,e,r){if(!(this instanceof ZP))throw new SyntaxError("Constructor must be called with the new operator");this.containerElement=t,this.dataGroup=new VP,this.dataPoints=null,this.create(),function(t,e){if(void 0===t||U_(t))throw new Error("No DEFAULTS passed");if(void 0===e)throw new Error("No dst passed");V_=t,q_(t,e,G_),q_(t,e,X_,"default"),$_(t,e),e.margin=10,e.showTooltip=!1,e.onclick_callback=null,e.eye=new P_(0,0,-1)}(ZP.DEFAULTS,this),this.colX=void 0,this.colY=void 0,this.colZ=void 0,this.colValue=void 0,this.setOptions(r),this.setData(e)}function qP(t){return"clientX"in t?t.clientX:t.targetTouches[0]&&t.targetTouches[0].clientX||0}function HP(t){return"clientY"in t?t.clientY:t.targetTouches[0]&&t.targetTouches[0].clientY||0}ZP.DEFAULTS={width:"400px",height:"400px",filterLabel:"time",legendLabel:"value",xLabel:"x",yLabel:"y",zLabel:"z",xValueLabel:function(t){return t},yValueLabel:function(t){return t},zValueLabel:function(t){return t},showXAxis:!0,showYAxis:!0,showZAxis:!0,showGrayBottom:!1,showGrid:!0,showPerspective:!0,showShadow:!1,showSurfaceGrid:!0,keepAspectRatio:!0,rotateAxisLabels:!0,verticalRatio:.5,dotSizeRatio:.02,dotSizeMinFraction:.5,dotSizeMaxFraction:2.5,showAnimationControls:UP,animationInterval:1e3,animationPreload:!1,animationAutoStart:UP,axisFontSize:14,axisFontType:"arial",axisColor:"#4D4D4D",gridColor:"#D3D3D3",xCenter:"55%",yCenter:"50%",style:ZP.STYLE.DOT,tooltip:!1,tooltipDelay:300,tooltipStyle:{content:{padding:"10px",border:"1px solid #4d4d4d",color:"#1a1a1a",background:"rgba(255,255,255,0.7)",borderRadius:"2px",boxShadow:"5px 5px 10px rgba(128,128,128,0.5)"},line:{height:"40px",width:"0",borderLeft:"1px solid #4d4d4d",pointerEvents:"none"},dot:{height:"0",width:"0",border:"5px solid #4d4d4d",borderRadius:"5px",pointerEvents:"none"}},dataColor:{fill:"#7DC1FF",stroke:"#3267D2",strokeWidth:1},surfaceColors:UP,colormap:UP,cameraPosition:{horizontal:1,vertical:.5,distance:1.7},zoomable:!0,ctrlToZoom:!1,showLegend:UP,backgroundColor:UP,xBarWidth:UP,yBarWidth:UP,valueMin:UP,valueMax:UP,xMin:UP,xMax:UP,xStep:UP,yMin:UP,yMax:UP,yStep:UP,zMin:UP,zMax:UP,zStep:UP},$p(ZP.prototype),ZP.prototype._setScale=function(){this.scale=new P_(1/this.xRange.range(),1/this.yRange.range(),1/this.zRange.range()),this.keepAspectRatio&&(this.scale.x<this.scale.y?this.scale.y=this.scale.x:this.scale.x=this.scale.y),this.scale.z*=this.verticalRatio,void 0!==this.valueRange&&(this.scale.value=1/this.valueRange.range());var t=this.xRange.center()*this.scale.x,e=this.yRange.center()*this.scale.y,r=this.zRange.center()*this.scale.z;this.camera.setArmLocation(t,e,r)},ZP.prototype._convert3Dto2D=function(t){var e=this._convertPointToTranslation(t);return this._convertTranslationToScreen(e)},ZP.prototype._convertPointToTranslation=function(t){var e=this.camera.getCameraLocation(),r=this.camera.getCameraRotation(),n=t.x*this.scale.x,i=t.y*this.scale.y,o=t.z*this.scale.z,a=e.x,s=e.y,u=e.z,c=Math.sin(r.x),l=Math.cos(r.x),h=Math.sin(r.y),f=Math.cos(r.y),p=Math.sin(r.z),d=Math.cos(r.z);return new P_(f*(p*(i-s)+d*(n-a))-h*(o-u),c*(f*(o-u)+h*(p*(i-s)+d*(n-a)))+l*(d*(i-s)-p*(n-a)),l*(f*(o-u)+h*(p*(i-s)+d*(n-a)))-c*(d*(i-s)-p*(n-a)))},ZP.prototype._convertTranslationToScreen=function(t){var e,r,n=this.eye.x,i=this.eye.y,o=this.eye.z,a=t.x,s=t.y,u=t.z;return this.showPerspective?(e=o/u*(a-n),r=o/u*(s-i)):(e=a*(-o/this.camera.getArmLength()),r=s*(-o/this.camera.getArmLength())),new M_(this.currentXCenter+e*this.frame.canvas.clientWidth,this.currentYCenter-r*this.frame.canvas.clientWidth)},ZP.prototype._calcTranslations=function(t){for(var e=0;e<t.length;e++){var r=t[e];r.trans=this._convertPointToTranslation(r.point),r.screen=this._convertTranslationToScreen(r.trans);var n=this._convertPointToTranslation(r.bottom);r.dist=this.showPerspective?n.length():-n.z}gh(t).call(t,(function(t,e){return e.dist-t.dist}))},ZP.prototype._initializeRanges=function(){var t=this.dataGroup;this.xRange=t.xRange,this.yRange=t.yRange,this.zRange=t.zRange,this.valueRange=t.valueRange,this.xStep=t.xStep,this.yStep=t.yStep,this.zStep=t.zStep,this.xBarWidth=t.xBarWidth,this.yBarWidth=t.yBarWidth,this.colX=t.colX,this.colY=t.colY,this.colZ=t.colZ,this.colValue=t.colValue,this._setScale()},ZP.prototype.getDataPoints=function(t){for(var e=[],r=0;r<t.length;r++){var n=new P_;n.x=t[r][this.colX]||0,n.y=t[r][this.colY]||0,n.z=t[r][this.colZ]||0,n.data=t[r],n.value=t[r][this.colValue]||0;var i={};i.point=n,i.bottom=new P_(n.x,n.y,this.zRange.min),i.trans=void 0,i.screen=void 0,e.push(i)}return e},ZP.prototype._getDataPoints=function(t){var e,r,n,i,o=[];if(this.style===ZP.STYLE.GRID||this.style===ZP.STYLE.SURFACE){var a=this.dataGroup.getDistinctValues(this.colX,t),s=this.dataGroup.getDistinctValues(this.colY,t);o=this.getDataPoints(t);var u=[];for(n=0;n<o.length;n++){i=o[n];var c=Lh(a).call(a,i.point.x),l=Lh(s).call(s,i.point.y);void 0===u[c]&&(u[c]=[]),u[c][l]=i}for(e=0;e<u.length;e++)for(r=0;r<u[e].length;r++)u[e][r]&&(u[e][r].pointRight=e<u.length-1?u[e+1][r]:void 0,u[e][r].pointTop=r<u[e].length-1?u[e][r+1]:void 0,u[e][r].pointCross=e<u.length-1&&r<u[e].length-1?u[e+1][r+1]:void 0)}else if(o=this.getDataPoints(t),this.style===ZP.STYLE.LINE)for(n=0;n<o.length;n++)n>0&&(o[n-1].pointNext=o[n]);return o},ZP.prototype.create=function(){for(;this.containerElement.hasChildNodes();)this.containerElement.removeChild(this.containerElement.firstChild);this.frame=document.createElement("div"),this.frame.style.position="relative",this.frame.style.overflow="hidden",this.frame.canvas=document.createElement("canvas"),this.frame.canvas.style.position="relative",this.frame.appendChild(this.frame.canvas);var t=document.createElement("DIV");t.style.color="red",t.style.fontWeight="bold",t.style.padding="10px",t.innerHTML="Error: your browser does not support HTML canvas",this.frame.canvas.appendChild(t),this.frame.filter=document.createElement("div"),Nh(this.frame).style.position="absolute",Nh(this.frame).style.bottom="0px",Nh(this.frame).style.left="0px",Nh(this.frame).style.width="100%",this.frame.appendChild(Nh(this.frame));var e=this;b_(this.frame.canvas,"mousedown",(function(t){e._onMouseDown(t)})),b_(this.frame.canvas,"touchstart",(function(t){e._onTouchStart(t)})),b_(this.frame.canvas,"mousewheel",(function(t){e._onWheel(t)})),b_(this.frame.canvas,"mousemove",(function(t){e._onTooltip(t)})),b_(this.frame.canvas,"click",(function(t){e._onClick(t)})),this.containerElement.appendChild(this.frame)},ZP.prototype._setSize=function(t,e){this.frame.style.width=t,this.frame.style.height=e,this._resizeCanvas()},ZP.prototype._resizeCanvas=function(){this.frame.canvas.style.width="100%",this.frame.canvas.style.height="100%",this.frame.canvas.width=this.frame.canvas.clientWidth,this.frame.canvas.height=this.frame.canvas.clientHeight,Nh(this.frame).style.width=this.frame.canvas.clientWidth-20+"px"},ZP.prototype.animationStart=function(){if(this.animationAutoStart&&this.dataGroup.dataFilter){if(!Nh(this.frame)||!Nh(this.frame).slider)throw new Error("No animation available");Nh(this.frame).slider.play()}},ZP.prototype.animationStop=function(){Nh(this.frame)&&Nh(this.frame).slider&&Nh(this.frame).slider.stop()},ZP.prototype._resizeCenter=function(){"%"===this.xCenter.charAt(this.xCenter.length-1)?this.currentXCenter=cf(this.xCenter)/100*this.frame.canvas.clientWidth:this.currentXCenter=cf(this.xCenter),"%"===this.yCenter.charAt(this.yCenter.length-1)?this.currentYCenter=cf(this.yCenter)/100*(this.frame.canvas.clientHeight-Nh(this.frame).clientHeight):this.currentYCenter=cf(this.yCenter)},ZP.prototype.getCameraPosition=function(){var t=this.camera.getArmRotation();return t.distance=this.camera.getArmLength(),t},ZP.prototype._readData=function(t){this.dataPoints=this.dataGroup.initializeData(this,t,this.style),this._initializeRanges(),this._redrawFilter()},ZP.prototype.setData=function(t){null!=t&&(this._readData(t),this.redraw(),this.animationStart())},ZP.prototype.setOptions=function(t){void 0!==t&&(!0===A_.validate(t,aS)&&console.error("%cErrors have been found in the supplied options object.",C_),this.animationStop(),function(t,e){if(void 0!==t){if(void 0===e)throw new Error("No dst passed");if(void 0===V_||U_(V_))throw new Error("DEFAULTS not set for module Settings");H_(t,e,G_),H_(t,e,X_,"default"),$_(t,e)}}(t,this),this.setPointDrawingMethod(),this._setSize(this.width,this.height),this.setAxisLabelMethod(),this.setData(this.dataGroup.getDataTable()),this.animationStart())},ZP.prototype.setPointDrawingMethod=function(){var t=void 0;switch(this.style){case ZP.STYLE.BAR:t=this._redrawBarGraphPoint;break;case ZP.STYLE.BARCOLOR:t=this._redrawBarColorGraphPoint;break;case ZP.STYLE.BARSIZE:t=this._redrawBarSizeGraphPoint;break;case ZP.STYLE.DOT:t=this._redrawDotGraphPoint;break;case ZP.STYLE.DOTLINE:t=this._redrawDotLineGraphPoint;break;case ZP.STYLE.DOTCOLOR:t=this._redrawDotColorGraphPoint;break;case ZP.STYLE.DOTSIZE:t=this._redrawDotSizeGraphPoint;break;case ZP.STYLE.SURFACE:t=this._redrawSurfaceGraphPoint;break;case ZP.STYLE.GRID:t=this._redrawGridGraphPoint;break;case ZP.STYLE.LINE:t=this._redrawLineGraphPoint;break;default:throw new Error("Can not determine point drawing method for graph style '"+this.style+"'")}this._pointDrawingMethod=t},ZP.prototype.setAxisLabelMethod=function(){this.rotateAxisLabels?(this._drawAxisLabelX=this.drawAxisLabelXRotate,this._drawAxisLabelY=this.drawAxisLabelYRotate,this._drawAxisLabelZ=this.drawAxisLabelZRotate):(this._drawAxisLabelX=this.drawAxisLabelX,this._drawAxisLabelY=this.drawAxisLabelY,this._drawAxisLabelZ=this.drawAxisLabelZ)},ZP.prototype.redraw=function(){if(void 0===this.dataPoints)throw new Error("Graph data not initialized");this._resizeCanvas(),this._resizeCenter(),this._redrawSlider(),this._redrawClear(),this._redrawAxis(),this._redrawDataGraph(),this._redrawInfo(),this._redrawLegend()},ZP.prototype._getContext=function(){var t=this.frame.canvas.getContext("2d");return t.lineJoin="round",t.lineCap="round",t},ZP.prototype._redrawClear=function(){var t=this.frame.canvas;t.getContext("2d").clearRect(0,0,t.width,t.height)},ZP.prototype._dotSize=function(){return this.frame.clientWidth*this.dotSizeRatio},ZP.prototype._getLegendWidth=function(){var t;this.style===ZP.STYLE.DOTSIZE?t=this._dotSize()*this.dotSizeMaxFraction:t=this.style===ZP.STYLE.BARSIZE?this.xBarWidth:20;return t},ZP.prototype._redrawLegend=function(){if(!0===this.showLegend&&this.style!==ZP.STYLE.LINE&&this.style!==ZP.STYLE.BARSIZE){var t=this.style===ZP.STYLE.BARSIZE||this.style===ZP.STYLE.DOTSIZE,e=this.style===ZP.STYLE.DOTSIZE||this.style===ZP.STYLE.DOTCOLOR||this.style===ZP.STYLE.SURFACE||this.style===ZP.STYLE.BARCOLOR,r=Math.max(.25*this.frame.clientHeight,100),n=this.margin,i=this._getLegendWidth(),o=this.frame.clientWidth-this.margin,a=o-i,s=n+r,u=this._getContext();if(u.lineWidth=1,u.font="14px arial",!1===t){var c,l=r;for(c=0;c<l;c++){var h=1-(c-0)/(l-0),f=this._colormap(h,1);u.strokeStyle=f,u.beginPath(),u.moveTo(a,n+c),u.lineTo(o,n+c),u.stroke()}u.strokeStyle=this.axisColor,u.strokeRect(a,n,i,r)}else{var p;this.style===ZP.STYLE.DOTSIZE?p=i*(this.dotSizeMinFraction/this.dotSizeMaxFraction):(this.style,ZP.STYLE.BARSIZE),u.strokeStyle=this.axisColor,u.fillStyle=bf(this.dataColor),u.beginPath(),u.moveTo(a,n),u.lineTo(o,n),u.lineTo(a+p,s),u.lineTo(a,s),u.closePath(),bf(u).call(u),u.stroke()}var d=e?this.valueRange.min:this.zRange.min,v=e?this.valueRange.max:this.zRange.max,y=new I_(d,v,(v-d)/5,!0);for(y.start(!0);!y.end();){var g=s-(y.getCurrent()-d)/(v-d)*r,m=new M_(a-5,g),x=new M_(a,g);this._line(u,m,x),u.textAlign="right",u.textBaseline="middle",u.fillStyle=this.axisColor,u.fillText(y.getCurrent(),a-10,g),y.next()}u.textAlign="right",u.textBaseline="top";var b=this.legendLabel;u.fillText(b,o,s+this.margin)}},ZP.prototype._redrawFilter=function(){var t=this.dataGroup.dataFilter,e=Nh(this.frame);if(e.innerHTML="",t){var r=new D_(e,{visible:this.showAnimationControls});e.slider=r,e.style.padding="10px",r.setValues(Pf(t)),r.setPlayInterval(this.animationInterval);var n=this;r.setOnChangeCallback((function(){var t=n.dataGroup.dataFilter,e=r.getIndex();t.selectValue(e),n.dataPoints=t._getDataPoints(),n.redraw()}))}else e.slider=void 0},ZP.prototype._redrawSlider=function(){void 0!==Nh(this.frame).slider&&Nh(this.frame).slider.redraw()},ZP.prototype._redrawInfo=function(){var t=this.dataGroup.getInfo();if(void 0!==t){var e=this._getContext();e.font="14px arial",e.lineStyle="gray",e.fillStyle="gray",e.textAlign="left",e.textBaseline="top";var r=this.margin,n=this.margin;e.fillText(t,r,n)}},ZP.prototype._line=function(t,e,r,n){void 0!==n&&(t.strokeStyle=n),t.beginPath(),t.moveTo(e.x,e.y),t.lineTo(r.x,r.y),t.stroke()},ZP.prototype.drawAxisLabelX=function(t,e,r,n,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*n)>0?(t.textAlign="center",t.textBaseline="top",o.y+=i):Math.sin(2*n)<0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)},ZP.prototype.drawAxisLabelY=function(t,e,r,n,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*n)<0?(t.textAlign="center",t.textBaseline="top",o.y+=i):Math.sin(2*n)>0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)},ZP.prototype.drawAxisLabelZ=function(t,e,r,n){void 0===n&&(n=0);var i=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,i.x-n,i.y)},ZP.prototype.drawAxisLabelXRotate=function(t,e,r,n,i){var o=this._convert3Dto2D(e);Math.cos(2*n)>0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,0,0),t.restore()):Math.sin(2*n)<0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y))},ZP.prototype.drawAxisLabelYRotate=function(t,e,r,n,i){var o=this._convert3Dto2D(e);Math.cos(2*n)<0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,0,0),t.restore()):Math.sin(2*n)>0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y))},ZP.prototype.drawAxisLabelZRotate=function(t,e,r,n){void 0===n&&(n=0);var i=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,i.x-n,i.y)},ZP.prototype._line3d=function(t,e,r,n){var i=this._convert3Dto2D(e),o=this._convert3Dto2D(r);this._line(t,i,o,n)},ZP.prototype._redrawAxis=function(){var t,e,r,n,i,o,a,s,u,c,l=this._getContext();l.font=this.axisFontSize/this.camera.getArmLength()+"px "+this.axisFontType;var h,f,p,d=.025/this.scale.x,v=.025/this.scale.y,y=5/this.camera.getArmLength(),g=this.camera.getArmRotation().horizontal,m=new M_(Math.cos(g),Math.sin(g)),x=this.xRange,b=this.yRange,w=this.zRange;for(l.lineWidth=1,n=void 0===this.defaultXStep,(r=new I_(x.min,x.max,this.xStep,n)).start(!0);!r.end();){var _=r.getCurrent();if(this.showGrid?(t=new P_(_,b.min,w.min),e=new P_(_,b.max,w.min),this._line3d(l,t,e,this.gridColor)):this.showXAxis&&(t=new P_(_,b.min,w.min),e=new P_(_,b.min+d,w.min),this._line3d(l,t,e,this.axisColor),t=new P_(_,b.max,w.min),e=new P_(_,b.max-d,w.min),this._line3d(l,t,e,this.axisColor)),this.showXAxis){a=m.x>0?b.min:b.max,h=new P_(_,a,w.min);var S="  "+this.xValueLabel(_)+"  ";this._drawAxisLabelX.call(this,l,h,S,g,y)}r.next()}for(l.lineWidth=1,n=void 0===this.defaultYStep,(r=new I_(b.min,b.max,this.yStep,n)).start(!0);!r.end();){var T=r.getCurrent();if(this.showGrid?(t=new P_(x.min,T,w.min),e=new P_(x.max,T,w.min),this._line3d(l,t,e,this.gridColor)):this.showYAxis&&(t=new P_(x.min,T,w.min),e=new P_(x.min+v,T,w.min),this._line3d(l,t,e,this.axisColor),t=new P_(x.max,T,w.min),e=new P_(x.max-v,T,w.min),this._line3d(l,t,e,this.axisColor)),this.showYAxis){o=m.y>0?x.min:x.max,h=new P_(o,T,w.min);var E="  "+this.yValueLabel(T)+"  ";this._drawAxisLabelY.call(this,l,h,E,g,y)}r.next()}if(this.showZAxis){for(l.lineWidth=1,n=void 0===this.defaultZStep,(r=new I_(w.min,w.max,this.zStep,n)).start(!0),o=m.x>0?x.min:x.max,a=m.y<0?b.min:b.max;!r.end();){var k=r.getCurrent(),O=new P_(o,a,k),C=this._convert3Dto2D(O);e=new M_(C.x-y,C.y),this._line(l,C,e,this.axisColor);var A=this.zValueLabel(k)+" ";this._drawAxisLabelZ.call(this,l,O,A,5),r.next()}l.lineWidth=1,t=new P_(o,a,w.min),e=new P_(o,a,w.max),this._line3d(l,t,e,this.axisColor)}this.showXAxis&&(l.lineWidth=1,f=new P_(x.min,b.min,w.min),p=new P_(x.max,b.min,w.min),this._line3d(l,f,p,this.axisColor),f=new P_(x.min,b.max,w.min),p=new P_(x.max,b.max,w.min),this._line3d(l,f,p,this.axisColor));this.showYAxis&&(l.lineWidth=1,t=new P_(x.min,b.min,w.min),e=new P_(x.min,b.max,w.min),this._line3d(l,t,e,this.axisColor),t=new P_(x.max,b.min,w.min),e=new P_(x.max,b.max,w.min),this._line3d(l,t,e,this.axisColor));var L=this.xLabel;L.length>0&&this.showXAxis&&(c=.1/this.scale.y,o=(x.max+3*x.min)/4,a=m.x>0?b.min-c:b.max+c,i=new P_(o,a,w.min),this.drawAxisLabelX(l,i,L,g));var P=this.yLabel;P.length>0&&this.showYAxis&&(u=.1/this.scale.x,o=m.y>0?x.min-u:x.max+u,a=(b.max+3*b.min)/4,i=new P_(o,a,w.min),this.drawAxisLabelY(l,i,P,g));var M=this.zLabel;M.length>0&&this.showZAxis&&(30,o=m.x>0?x.min:x.max,a=m.y<0?b.min:b.max,s=(w.max+3*w.min)/4,i=new P_(o,a,s),this.drawAxisLabelZ(l,i,M,30))},ZP.prototype._getStrokeWidth=function(t){return void 0!==t?this.showPerspective?1/-t.trans.z*this.dataColor.strokeWidth:-this.eye.z/this.camera.getArmLength()*this.dataColor.strokeWidth:this.dataColor.strokeWidth},ZP.prototype._redrawBar=function(t,e,r,n,i,o){var a,s=this,u=e.point,c=this.zRange.min,l=[{point:new P_(u.x-r,u.y-n,u.z)},{point:new P_(u.x+r,u.y-n,u.z)},{point:new P_(u.x+r,u.y+n,u.z)},{point:new P_(u.x-r,u.y+n,u.z)}],h=[{point:new P_(u.x-r,u.y-n,c)},{point:new P_(u.x+r,u.y-n,c)},{point:new P_(u.x+r,u.y+n,c)},{point:new P_(u.x-r,u.y+n,c)}];Xf(l).call(l,(function(t){t.screen=s._convert3Dto2D(t.point)})),Xf(h).call(h,(function(t){t.screen=s._convert3Dto2D(t.point)}));var f=[{corners:l,center:P_.avg(h[0].point,h[2].point)},{corners:[l[0],l[1],h[1],h[0]],center:P_.avg(h[1].point,h[0].point)},{corners:[l[1],l[2],h[2],h[1]],center:P_.avg(h[2].point,h[1].point)},{corners:[l[2],l[3],h[3],h[2]],center:P_.avg(h[3].point,h[2].point)},{corners:[l[3],l[0],h[0],h[3]],center:P_.avg(h[0].point,h[3].point)}];e.surfaces=f;for(var p=0;p<f.length;p++){a=f[p];var d=this._convertPointToTranslation(a.center);a.dist=this.showPerspective?d.length():-d.z}gh(f).call(f,(function(t,e){var r=e.dist-t.dist;return r||(t.corners===l?1:e.corners===l?-1:0)})),t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=o,t.fillStyle=i;for(var v=2;v<f.length;v++)a=f[v],this._polygon(t,a.corners)},ZP.prototype._polygon=function(t,e,r,n){if(!(e.length<2)){void 0!==r&&(t.fillStyle=r),void 0!==n&&(t.strokeStyle=n),t.beginPath(),t.moveTo(e[0].screen.x,e[0].screen.y);for(var i=1;i<e.length;++i){var o=e[i];t.lineTo(o.screen.x,o.screen.y)}t.closePath(),bf(t).call(t),t.stroke()}},ZP.prototype._drawCircle=function(t,e,r,n,i){var o=this._calcRadius(e,i);t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=n,t.fillStyle=r,t.beginPath(),t.arc(e.screen.x,e.screen.y,o,0,2*Math.PI,!0),bf(t).call(t),t.stroke()},ZP.prototype._getColorsRegular=function(t){var e=(t.point.value-this.valueRange.min)*this.scale.value;return{fill:this._colormap(e,1),border:this._colormap(e,.8)}},ZP.prototype._getColorsColor=function(t){var e,r,n;if(t&&t.point&&t.point.data&&t.point.data.style&&(n=t.point.data.style),n&&"object"===Tl(n)&&bf(n)&&n.stroke)return{fill:bf(n),border:n.stroke};if("string"==typeof t.point.value)e=t.point.value,r=t.point.value;else{var i=(t.point.value-this.valueRange.min)*this.scale.value;e=this._colormap(i,1),r=this._colormap(i,.8)}return{fill:e,border:r}},ZP.prototype._getColorsSize=function(){return{fill:bf(this.dataColor),border:this.dataColor.stroke}},ZP.prototype._colormap=function(t){var e,r,n,i,o,a,s,u,c,l=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1,h=this.colormap;if(qf(h)){var f=h.length-1,p=Math.max(Math.floor(t*f),0),d=Math.min(p+1,f),v=t*f-p,y=h[p],g=h[d];e=y.r+v*(g.r-y.r),r=y.g+v*(g.g-y.g),n=y.b+v*(g.b-y.b)}else if("function"==typeof h){var m=h(t);e=m.r,r=m.g,n=m.b,i=m.a}else{var x=S_(240*(1-t)/360,1,1);e=x.r,r=x.g,n=x.b}return"number"!=typeof i||Jf(i)?ap(o=ap(a="RGB(".concat(Math.round(e*l),", ")).call(a,Math.round(r*l),", ")).call(o,Math.round(n*l),")"):ap(s=ap(u=ap(c="RGBA(".concat(Math.round(e*l),", ")).call(c,Math.round(r*l),", ")).call(u,Math.round(n*l),", ")).call(s,i,")")},ZP.prototype._calcRadius=function(t,e){var r;return void 0===e&&(e=this._dotSize()),(r=this.showPerspective?e/-t.trans.z:e*(-this.eye.z/this.camera.getArmLength()))<0&&(r=0),r},ZP.prototype._redrawBarGraphPoint=function(t,e){var r=this.xBarWidth/2,n=this.yBarWidth/2,i=this._getColorsRegular(e);this._redrawBar(t,e,r,n,bf(i),i.border)},ZP.prototype._redrawBarColorGraphPoint=function(t,e){var r=this.xBarWidth/2,n=this.yBarWidth/2,i=this._getColorsColor(e);this._redrawBar(t,e,r,n,bf(i),i.border)},ZP.prototype._redrawBarSizeGraphPoint=function(t,e){var r=(e.point.value-this.valueRange.min)/this.valueRange.range(),n=this.xBarWidth/2*(.8*r+.2),i=this.yBarWidth/2*(.8*r+.2),o=this._getColorsSize();this._redrawBar(t,e,n,i,bf(o),o.border)},ZP.prototype._redrawDotGraphPoint=function(t,e){var r=this._getColorsRegular(e);this._drawCircle(t,e,bf(r),r.border)},ZP.prototype._redrawDotLineGraphPoint=function(t,e){var r=this._convert3Dto2D(e.bottom);t.lineWidth=1,this._line(t,r,e.screen,this.gridColor),this._redrawDotGraphPoint(t,e)},ZP.prototype._redrawDotColorGraphPoint=function(t,e){var r=this._getColorsColor(e);this._drawCircle(t,e,bf(r),r.border)},ZP.prototype._redrawDotSizeGraphPoint=function(t,e){var r=this._dotSize(),n=(e.point.value-this.valueRange.min)/this.valueRange.range(),i=r*this.dotSizeMinFraction,o=i+(r*this.dotSizeMaxFraction-i)*n,a=this._getColorsSize();this._drawCircle(t,e,bf(a),a.border,o)},ZP.prototype._redrawSurfaceGraphPoint=function(t,e){var r=e.pointRight,n=e.pointTop,i=e.pointCross;if(void 0!==e&&void 0!==r&&void 0!==n&&void 0!==i){var o,a,s,u=!0;if(this.showGrayBottom||this.showShadow){var c=P_.subtract(i.trans,e.trans),l=P_.subtract(n.trans,r.trans),h=P_.crossProduct(c,l);if(this.showPerspective){var f=P_.avg(P_.avg(e.trans,i.trans),P_.avg(r.trans,n.trans));s=-P_.dotProduct(h.normalize(),f.normalize())}else s=h.z/h.length();u=s>0}if(u||!this.showGrayBottom){var p=((e.point.value+r.point.value+n.point.value+i.point.value)/4-this.valueRange.min)*this.scale.value,d=this.showShadow?(1+s)/2:1;o=this._colormap(p,d)}else o="gray";a=this.showSurfaceGrid?this.axisColor:o,t.lineWidth=this._getStrokeWidth(e);var v=[e,r,i,n];this._polygon(t,v,o,a)}},ZP.prototype._drawGridLine=function(t,e,r){if(void 0!==e&&void 0!==r){var n=((e.point.value+r.point.value)/2-this.valueRange.min)*this.scale.value;t.lineWidth=2*this._getStrokeWidth(e),t.strokeStyle=this._colormap(n,1),this._line(t,e.screen,r.screen)}},ZP.prototype._redrawGridGraphPoint=function(t,e){this._drawGridLine(t,e,e.pointRight),this._drawGridLine(t,e,e.pointTop)},ZP.prototype._redrawLineGraphPoint=function(t,e){void 0!==e.pointNext&&(t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=this.dataColor.stroke,this._line(t,e.screen,e.pointNext.screen))},ZP.prototype._redrawDataGraph=function(){var t,e=this._getContext();if(!(void 0===this.dataPoints||this.dataPoints.length<=0))for(this._calcTranslations(this.dataPoints),t=0;t<this.dataPoints.length;t++){var r=this.dataPoints[t];this._pointDrawingMethod.call(this,e,r)}},ZP.prototype._storeMousePosition=function(t){this.startMouseX=qP(t),this.startMouseY=HP(t),this._startCameraOffset=this.camera.getOffset()},ZP.prototype._onMouseDown=function(t){if(t=t||window.event,this.leftButtonDown&&this._onMouseUp(t),this.leftButtonDown=t.which?1===t.which:1===t.button,this.leftButtonDown||this.touchDown){this._storeMousePosition(t),this.startStart=new Date(this.start),this.startEnd=new Date(this.end),this.startArmRotation=this.camera.getArmRotation(),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},b_(document,"mousemove",e.onmousemove),b_(document,"mouseup",e.onmouseup),__(t)}},ZP.prototype._onMouseMove=function(t){this.moving=!0,t=t||window.event;var e=cf(qP(t))-this.startMouseX,r=cf(HP(t))-this.startMouseY;if(t&&!0===t.ctrlKey){var n=.5*this.frame.clientWidth,i=.5*this.frame.clientHeight,o=(this._startCameraOffset.x||0)-e/n*this.camera.armLength*.8,a=(this._startCameraOffset.y||0)+r/i*this.camera.armLength*.8;this.camera.setOffset(o,a),this._storeMousePosition(t)}else{var s=this.startArmRotation.horizontal+e/200,u=this.startArmRotation.vertical+r/200,c=Math.sin(4/360*2*Math.PI);Math.abs(Math.sin(s))<c&&(s=Math.round(s/Math.PI)*Math.PI-.001),Math.abs(Math.cos(s))<c&&(s=(Math.round(s/Math.PI-.5)+.5)*Math.PI-.001),Math.abs(Math.sin(u))<c&&(u=Math.round(u/Math.PI)*Math.PI),Math.abs(Math.cos(u))<c&&(u=(Math.round(u/Math.PI-.5)+.5)*Math.PI),this.camera.setArmRotation(s,u)}this.redraw();var l=this.getCameraPosition();this.emit("cameraPositionChange",l),__(t)},ZP.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",this.leftButtonDown=!1,w_(document,"mousemove",this.onmousemove),w_(document,"mouseup",this.onmouseup),__(t)},ZP.prototype._onClick=function(t){if(this.onclick_callback||this.hasListeners("click")){if(this.moving)this.moving=!1;else{var e=this.frame.getBoundingClientRect(),r=qP(t)-e.left,n=HP(t)-e.top,i=this._dataPointFromXY(r,n);i&&(this.onclick_callback&&this.onclick_callback(i.point.data),this.emit("click",i.point.data))}__(t)}},ZP.prototype._onTooltip=function(t){var e=this.tooltipDelay,r=this.frame.getBoundingClientRect(),n=qP(t)-r.left,i=HP(t)-r.top;if(this.showTooltip)if(this.tooltipTimeout&&clearTimeout(this.tooltipTimeout),this.leftButtonDown)this._hideTooltip();else if(this.tooltip&&this.tooltip.dataPoint){var o=this._dataPointFromXY(n,i);o!==this.tooltip.dataPoint&&(o?this._showTooltip(o):this._hideTooltip())}else{var a=this;this.tooltipTimeout=Ap((function(){a.tooltipTimeout=null;var t=a._dataPointFromXY(n,i);t&&a._showTooltip(t)}),e)}},ZP.prototype._onTouchStart=function(t){this.touchDown=!0;var e=this;this.ontouchmove=function(t){e._onTouchMove(t)},this.ontouchend=function(t){e._onTouchEnd(t)},b_(document,"touchmove",e.ontouchmove),b_(document,"touchend",e.ontouchend),this._onMouseDown(t)},ZP.prototype._onTouchMove=function(t){this._onMouseMove(t)},ZP.prototype._onTouchEnd=function(t){this.touchDown=!1,w_(document,"touchmove",this.ontouchmove),w_(document,"touchend",this.ontouchend),this._onMouseUp(t)},ZP.prototype._onWheel=function(t){if(t||(t=window.event),this.zoomable&&(!this.ctrlToZoom||t.ctrlKey)){var e=0;if(t.wheelDelta?e=t.wheelDelta/120:t.detail&&(e=-t.detail/3),e){var r=this.camera.getArmLength()*(1-e/10);this.camera.setArmLength(r),this.redraw(),this._hideTooltip()}var n=this.getCameraPosition();this.emit("cameraPositionChange",n),__(t)}},ZP.prototype._insideTriangle=function(t,e){var r=e[0],n=e[1],i=e[2];function o(t){return t>0?1:t<0?-1:0}var a=o((n.x-r.x)*(t.y-r.y)-(n.y-r.y)*(t.x-r.x)),s=o((i.x-n.x)*(t.y-n.y)-(i.y-n.y)*(t.x-n.x)),u=o((r.x-i.x)*(t.y-i.y)-(r.y-i.y)*(t.x-i.x));return!(0!=a&&0!=s&&a!=s||0!=s&&0!=u&&s!=u||0!=a&&0!=u&&a!=u)},ZP.prototype._dataPointFromXY=function(t,e){var r,n=new M_(t,e),i=null,o=null,a=null;if(this.style===ZP.STYLE.BAR||this.style===ZP.STYLE.BARCOLOR||this.style===ZP.STYLE.BARSIZE)for(r=this.dataPoints.length-1;r>=0;r--){var s=(i=this.dataPoints[r]).surfaces;if(s)for(var u=s.length-1;u>=0;u--){var c=s[u].corners,l=[c[0].screen,c[1].screen,c[2].screen],h=[c[2].screen,c[3].screen,c[0].screen];if(this._insideTriangle(n,l)||this._insideTriangle(n,h))return i}}else for(r=0;r<this.dataPoints.length;r++){var f=(i=this.dataPoints[r]).screen;if(f){var p=Math.abs(t-f.x),d=Math.abs(e-f.y),v=Math.sqrt(p*p+d*d);(null===a||v<a)&&v<100&&(a=v,o=i)}}return o},ZP.prototype.hasBars=function(t){return t==ZP.STYLE.BAR||t==ZP.STYLE.BARCOLOR||t==ZP.STYLE.BARSIZE},ZP.prototype._showTooltip=function(t){var e,r,n;this.tooltip?(e=this.tooltip.dom.content,r=this.tooltip.dom.line,n=this.tooltip.dom.dot):(e=document.createElement("div"),Zp(e.style,{},this.tooltipStyle.content),e.style.position="absolute",r=document.createElement("div"),Zp(r.style,{},this.tooltipStyle.line),r.style.position="absolute",n=document.createElement("div"),Zp(n.style,{},this.tooltipStyle.dot),n.style.position="absolute",this.tooltip={dataPoint:null,dom:{content:e,line:r,dot:n}}),this._hideTooltip(),this.tooltip.dataPoint=t,"function"==typeof this.showTooltip?e.innerHTML=this.showTooltip(t.point):e.innerHTML="<table><tr><td>"+this.xLabel+":</td><td>"+t.point.x+"</td></tr><tr><td>"+this.yLabel+":</td><td>"+t.point.y+"</td></tr><tr><td>"+this.zLabel+":</td><td>"+t.point.z+"</td></tr></table>",e.style.left="0",e.style.top="0",this.frame.appendChild(e),this.frame.appendChild(r),this.frame.appendChild(n);var i=e.offsetWidth,o=e.offsetHeight,a=r.offsetHeight,s=n.offsetWidth,u=n.offsetHeight,c=t.screen.x-i/2;c=Math.min(Math.max(c,10),this.frame.clientWidth-10-i),r.style.left=t.screen.x+"px",r.style.top=t.screen.y-a+"px",e.style.left=c+"px",e.style.top=t.screen.y-a-o+"px",n.style.left=t.screen.x-s/2+"px",n.style.top=t.screen.y-u/2+"px"},ZP.prototype._hideTooltip=function(){if(this.tooltip)for(var t in this.tooltip.dataPoint=null,this.tooltip.dom)if(Object.prototype.hasOwnProperty.call(this.tooltip.dom,t)){var e=this.tooltip.dom[t];e&&e.parentNode&&e.parentNode.removeChild(e)}},ZP.prototype.setCameraPosition=function(t){Q_(t,this),this.redraw()},ZP.prototype.setSize=function(t,e){this._setSize(t,e),this.redraw()};export{u_ as DELETE,FP as DataSet,zP as DataStream,NP as DataView,ZP as Graph3d,B_ as Graph3dCamera,XP as Graph3dFilter,M_ as Graph3dPoint2d,P_ as Graph3dPoint3d,D_ as Graph3dSlider,I_ as Graph3dStepNumber,IP as Queue,PP as createNewDataPipeFrom,BP as isDataSetLike,WP as isDataViewLike};
//# sourceMappingURL=vis-graph3d.min.js.map
