/**
 * vis-graph3d
 * https://visjs.github.io/vis-graph3d/
 *
 * Create interactive, animated 3d graphs. Surfaces, lines, dots and block styling out of the box.
 *
 * @version 6.0.3
 * @date    2023-03-21T17:15:34.624Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports):"function"==typeof define&&define.amd?define(["exports"],e):e((t="undefined"!=typeof globalThis?globalThis:t||self).vis=t.vis||{})}(this,(function(t){var e="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function r(t){return t&&t.__esModule&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t}var n={},i={get exports(){return n},set exports(t){n=t}},o={},a={get exports(){return o},set exports(t){o=t}},s=function(t){return t&&t.Math==Math&&t},u=s("object"==typeof globalThis&&globalThis)||s("object"==typeof window&&window)||s("object"==typeof self&&self)||s("object"==typeof e&&e)||function(){return this}()||Function("return this")(),c=function(t){try{return!!t()}catch(t){return!0}},l=!c((function(){var t=function(){}.bind();return"function"!=typeof t||t.hasOwnProperty("prototype")})),h=l,f=Function.prototype,p=f.apply,d=f.call,v="object"==typeof Reflect&&Reflect.apply||(h?d.bind(p):function(){return d.apply(p,arguments)}),y=l,g=Function.prototype,m=g.call,x=y&&g.bind.bind(m,m),b=y?x:function(t){return function(){return m.apply(t,arguments)}},w=b,_=w({}.toString),S=w("".slice),T=function(t){return S(_(t),8,-1)},E=T,k=b,O=function(t){if("Function"===E(t))return k(t)},C="object"==typeof document&&document.all,A={all:C,IS_HTMLDDA:void 0===C&&void 0!==C},L=A.all,P=A.IS_HTMLDDA?function(t){return"function"==typeof t||t===L}:function(t){return"function"==typeof t},D={},M=!c((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),R=l,I=Function.prototype.call,j=R?I.bind(I):function(){return I.apply(I,arguments)},z={},F={}.propertyIsEnumerable,N=Object.getOwnPropertyDescriptor,B=N&&!F.call({1:2},1);z.f=B?function(t){var e=N(this,t);return!!e&&e.enumerable}:F;var W,Y,G=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},X=c,V=T,U=Object,Z=b("".split),q=X((function(){return!U("z").propertyIsEnumerable(0)}))?function(t){return"String"==V(t)?Z(t,""):U(t)}:U,H=function(t){return null==t},$=H,K=TypeError,J=function(t){if($(t))throw K("Can't call method on "+t);return t},Q=q,tt=J,et=function(t){return Q(tt(t))},rt=P,nt=A.all,it=A.IS_HTMLDDA?function(t){return"object"==typeof t?null!==t:rt(t)||t===nt}:function(t){return"object"==typeof t?null!==t:rt(t)},ot={},at=ot,st=u,ut=P,ct=function(t){return ut(t)?t:void 0},lt=function(t,e){return arguments.length<2?ct(at[t])||ct(st[t]):at[t]&&at[t][e]||st[t]&&st[t][e]},ht=b({}.isPrototypeOf),ft="undefined"!=typeof navigator&&String(navigator.userAgent)||"",pt=u,dt=ft,vt=pt.process,yt=pt.Deno,gt=vt&&vt.versions||yt&&yt.version,mt=gt&&gt.v8;mt&&(Y=(W=mt.split("."))[0]>0&&W[0]<4?1:+(W[0]+W[1])),!Y&&dt&&(!(W=dt.match(/Edge\/(\d+)/))||W[1]>=74)&&(W=dt.match(/Chrome\/(\d+)/))&&(Y=+W[1]);var xt=Y,bt=xt,wt=c,_t=!!Object.getOwnPropertySymbols&&!wt((function(){var t=Symbol();return!String(t)||!(Object(t)instanceof Symbol)||!Symbol.sham&&bt&&bt<41})),St=_t&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,Tt=lt,Et=P,kt=ht,Ot=Object,Ct=St?function(t){return"symbol"==typeof t}:function(t){var e=Tt("Symbol");return Et(e)&&kt(e.prototype,Ot(t))},At=String,Lt=function(t){try{return At(t)}catch(t){return"Object"}},Pt=P,Dt=Lt,Mt=TypeError,Rt=function(t){if(Pt(t))return t;throw Mt(Dt(t)+" is not a function")},It=Rt,jt=H,zt=function(t,e){var r=t[e];return jt(r)?void 0:It(r)},Ft=j,Nt=P,Bt=it,Wt=TypeError,Yt={},Gt={get exports(){return Yt},set exports(t){Yt=t}},Xt=u,Vt=Object.defineProperty,Ut=function(t,e){try{Vt(Xt,t,{value:e,configurable:!0,writable:!0})}catch(r){Xt[t]=e}return e},Zt="__core-js_shared__",qt=u[Zt]||Ut(Zt,{}),Ht=qt;(Gt.exports=function(t,e){return Ht[t]||(Ht[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.29.0",mode:"pure",copyright:"© 2014-2023 Denis Pushkarev (zloirock.ru)",license:"https://github.com/zloirock/core-js/blob/v3.29.0/LICENSE",source:"https://github.com/zloirock/core-js"});var $t=J,Kt=Object,Jt=function(t){return Kt($t(t))},Qt=Jt,te=b({}.hasOwnProperty),ee=Object.hasOwn||function(t,e){return te(Qt(t),e)},re=b,ne=0,ie=Math.random(),oe=re(1..toString),ae=function(t){return"Symbol("+(void 0===t?"":t)+")_"+oe(++ne+ie,36)},se=Yt,ue=ee,ce=ae,le=_t,he=St,fe=u.Symbol,pe=se("wks"),de=he?fe.for||fe:fe&&fe.withoutSetter||ce,ve=function(t){return ue(pe,t)||(pe[t]=le&&ue(fe,t)?fe[t]:de("Symbol."+t)),pe[t]},ye=j,ge=it,me=Ct,xe=zt,be=function(t,e){var r,n;if("string"===e&&Nt(r=t.toString)&&!Bt(n=Ft(r,t)))return n;if(Nt(r=t.valueOf)&&!Bt(n=Ft(r,t)))return n;if("string"!==e&&Nt(r=t.toString)&&!Bt(n=Ft(r,t)))return n;throw Wt("Can't convert object to primitive value")},we=TypeError,_e=ve("toPrimitive"),Se=function(t,e){if(!ge(t)||me(t))return t;var r,n=xe(t,_e);if(n){if(void 0===e&&(e="default"),r=ye(n,t,e),!ge(r)||me(r))return r;throw we("Can't convert object to primitive value")}return void 0===e&&(e="number"),be(t,e)},Te=Ct,Ee=function(t){var e=Se(t,"string");return Te(e)?e:e+""},ke=it,Oe=u.document,Ce=ke(Oe)&&ke(Oe.createElement),Ae=function(t){return Ce?Oe.createElement(t):{}},Le=Ae,Pe=!M&&!c((function(){return 7!=Object.defineProperty(Le("div"),"a",{get:function(){return 7}}).a})),De=M,Me=j,Re=z,Ie=G,je=et,ze=Ee,Fe=ee,Ne=Pe,Be=Object.getOwnPropertyDescriptor;D.f=De?Be:function(t,e){if(t=je(t),e=ze(e),Ne)try{return Be(t,e)}catch(t){}if(Fe(t,e))return Ie(!Me(Re.f,t,e),t[e])};var We=c,Ye=P,Ge=/#|\.prototype\./,Xe=function(t,e){var r=Ue[Ve(t)];return r==qe||r!=Ze&&(Ye(e)?We(e):!!e)},Ve=Xe.normalize=function(t){return String(t).replace(Ge,".").toLowerCase()},Ue=Xe.data={},Ze=Xe.NATIVE="N",qe=Xe.POLYFILL="P",He=Xe,$e=Rt,Ke=l,Je=O(O.bind),Qe=function(t,e){return $e(t),void 0===e?t:Ke?Je(t,e):function(){return t.apply(e,arguments)}},tr={},er=M&&c((function(){return 42!=Object.defineProperty((function(){}),"prototype",{value:42,writable:!1}).prototype})),rr=it,nr=String,ir=TypeError,or=function(t){if(rr(t))return t;throw ir(nr(t)+" is not an object")},ar=M,sr=Pe,ur=er,cr=or,lr=Ee,hr=TypeError,fr=Object.defineProperty,pr=Object.getOwnPropertyDescriptor,dr="enumerable",vr="configurable",yr="writable";tr.f=ar?ur?function(t,e,r){if(cr(t),e=lr(e),cr(r),"function"==typeof t&&"prototype"===e&&"value"in r&&yr in r&&!r[yr]){var n=pr(t,e);n&&n[yr]&&(t[e]=r.value,r={configurable:vr in r?r[vr]:n[vr],enumerable:dr in r?r[dr]:n[dr],writable:!1})}return fr(t,e,r)}:fr:function(t,e,r){if(cr(t),e=lr(e),cr(r),sr)try{return fr(t,e,r)}catch(t){}if("get"in r||"set"in r)throw hr("Accessors not supported");return"value"in r&&(t[e]=r.value),t};var gr=tr,mr=G,xr=M?function(t,e,r){return gr.f(t,e,mr(1,r))}:function(t,e,r){return t[e]=r,t},br=u,wr=v,_r=O,Sr=P,Tr=D.f,Er=He,kr=ot,Or=Qe,Cr=xr,Ar=ee,Lr=function(t){var e=function(r,n,i){if(this instanceof e){switch(arguments.length){case 0:return new t;case 1:return new t(r);case 2:return new t(r,n)}return new t(r,n,i)}return wr(t,this,arguments)};return e.prototype=t.prototype,e},Pr=function(t,e){var r,n,i,o,a,s,u,c,l,h=t.target,f=t.global,p=t.stat,d=t.proto,v=f?br:p?br[h]:(br[h]||{}).prototype,y=f?kr:kr[h]||Cr(kr,h,{})[h],g=y.prototype;for(o in e)n=!(r=Er(f?o:h+(p?".":"#")+o,t.forced))&&v&&Ar(v,o),s=y[o],n&&(u=t.dontCallGetSet?(l=Tr(v,o))&&l.value:v[o]),a=n&&u?u:e[o],n&&typeof s==typeof a||(c=t.bind&&n?Or(a,br):t.wrap&&n?Lr(a):d&&Sr(a)?_r(a):a,(t.sham||a&&a.sham||s&&s.sham)&&Cr(c,"sham",!0),Cr(y,o,c),d&&(Ar(kr,i=h+"Prototype")||Cr(kr,i,{}),Cr(kr[i],o,a),t.real&&g&&(r||!g[o])&&Cr(g,o,a)))},Dr=T,Mr=Array.isArray||function(t){return"Array"==Dr(t)},Rr=Math.ceil,Ir=Math.floor,jr=Math.trunc||function(t){var e=+t;return(e>0?Ir:Rr)(e)},zr=function(t){var e=+t;return e!=e||0===e?0:jr(e)},Fr=zr,Nr=Math.min,Br=function(t){return t>0?Nr(Fr(t),9007199254740991):0},Wr=function(t){return Br(t.length)},Yr=TypeError,Gr=function(t){if(t>9007199254740991)throw Yr("Maximum allowed index exceeded");return t},Xr=Ee,Vr=tr,Ur=G,Zr=function(t,e,r){var n=Xr(e);n in t?Vr.f(t,n,Ur(0,r)):t[n]=r},qr={};qr[ve("toStringTag")]="z";var Hr="[object z]"===String(qr),$r=Hr,Kr=P,Jr=T,Qr=ve("toStringTag"),tn=Object,en="Arguments"==Jr(function(){return arguments}()),rn=$r?Jr:function(t){var e,r,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(r=function(t,e){try{return t[e]}catch(t){}}(e=tn(t),Qr))?r:en?Jr(e):"Object"==(n=Jr(e))&&Kr(e.callee)?"Arguments":n},nn=P,on=qt,an=b(Function.toString);nn(on.inspectSource)||(on.inspectSource=function(t){return an(t)});var sn=on.inspectSource,un=b,cn=c,ln=P,hn=rn,fn=sn,pn=function(){},dn=[],vn=lt("Reflect","construct"),yn=/^\s*(?:class|function)\b/,gn=un(yn.exec),mn=!yn.exec(pn),xn=function(t){if(!ln(t))return!1;try{return vn(pn,dn,t),!0}catch(t){return!1}},bn=function(t){if(!ln(t))return!1;switch(hn(t)){case"AsyncFunction":case"GeneratorFunction":case"AsyncGeneratorFunction":return!1}try{return mn||!!gn(yn,fn(t))}catch(t){return!0}};bn.sham=!0;var wn=!vn||cn((function(){var t;return xn(xn.call)||!xn(Object)||!xn((function(){t=!0}))||t}))?bn:xn,_n=Mr,Sn=wn,Tn=it,En=ve("species"),kn=Array,On=function(t){var e;return _n(t)&&(e=t.constructor,(Sn(e)&&(e===kn||_n(e.prototype))||Tn(e)&&null===(e=e[En]))&&(e=void 0)),void 0===e?kn:e},Cn=function(t,e){return new(On(t))(0===e?0:e)},An=c,Ln=xt,Pn=ve("species"),Dn=function(t){return Ln>=51||!An((function(){var e=[];return(e.constructor={})[Pn]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},Mn=Pr,Rn=c,In=Mr,jn=it,zn=Jt,Fn=Wr,Nn=Gr,Bn=Zr,Wn=Cn,Yn=Dn,Gn=xt,Xn=ve("isConcatSpreadable"),Vn=Gn>=51||!Rn((function(){var t=[];return t[Xn]=!1,t.concat()[0]!==t})),Un=function(t){if(!jn(t))return!1;var e=t[Xn];return void 0!==e?!!e:In(t)};Mn({target:"Array",proto:!0,arity:1,forced:!Vn||!Yn("concat")},{concat:function(t){var e,r,n,i,o,a=zn(this),s=Wn(a,0),u=0;for(e=-1,n=arguments.length;e<n;e++)if(Un(o=-1===e?a:arguments[e]))for(i=Fn(o),Nn(u+i),r=0;r<i;r++,u++)r in o&&Bn(s,u,o[r]);else Nn(u+1),Bn(s,u++,o);return s.length=u,s}});var Zn=rn,qn=String,Hn=function(t){if("Symbol"===Zn(t))throw TypeError("Cannot convert a Symbol value to a string");return qn(t)},$n={},Kn=zr,Jn=Math.max,Qn=Math.min,ti=function(t,e){var r=Kn(t);return r<0?Jn(r+e,0):Qn(r,e)},ei=et,ri=ti,ni=Wr,ii=function(t){return function(e,r,n){var i,o=ei(e),a=ni(o),s=ri(n,a);if(t&&r!=r){for(;a>s;)if((i=o[s++])!=i)return!0}else for(;a>s;s++)if((t||s in o)&&o[s]===r)return t||s||0;return!t&&-1}},oi={includes:ii(!0),indexOf:ii(!1)},ai={},si=ee,ui=et,ci=oi.indexOf,li=ai,hi=b([].push),fi=function(t,e){var r,n=ui(t),i=0,o=[];for(r in n)!si(li,r)&&si(n,r)&&hi(o,r);for(;e.length>i;)si(n,r=e[i++])&&(~ci(o,r)||hi(o,r));return o},pi=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],di=fi,vi=pi,yi=Object.keys||function(t){return di(t,vi)},gi=M,mi=er,xi=tr,bi=or,wi=et,_i=yi;$n.f=gi&&!mi?Object.defineProperties:function(t,e){bi(t);for(var r,n=wi(e),i=_i(e),o=i.length,a=0;o>a;)xi.f(t,r=i[a++],n[r]);return t};var Si,Ti=lt("document","documentElement"),Ei=ae,ki=Yt("keys"),Oi=function(t){return ki[t]||(ki[t]=Ei(t))},Ci=or,Ai=$n,Li=pi,Pi=ai,Di=Ti,Mi=Ae,Ri="prototype",Ii="script",ji=Oi("IE_PROTO"),zi=function(){},Fi=function(t){return"<"+Ii+">"+t+"</"+Ii+">"},Ni=function(t){t.write(Fi("")),t.close();var e=t.parentWindow.Object;return t=null,e},Bi=function(){try{Si=new ActiveXObject("htmlfile")}catch(t){}var t,e,r;Bi="undefined"!=typeof document?document.domain&&Si?Ni(Si):(e=Mi("iframe"),r="java"+Ii+":",e.style.display="none",Di.appendChild(e),e.src=String(r),(t=e.contentWindow.document).open(),t.write(Fi("document.F=Object")),t.close(),t.F):Ni(Si);for(var n=Li.length;n--;)delete Bi[Ri][Li[n]];return Bi()};Pi[ji]=!0;var Wi=Object.create||function(t,e){var r;return null!==t?(zi[Ri]=Ci(t),r=new zi,zi[Ri]=null,r[ji]=t):r=Bi(),void 0===e?r:Ai.f(r,e)},Yi={},Gi=fi,Xi=pi.concat("length","prototype");Yi.f=Object.getOwnPropertyNames||function(t){return Gi(t,Xi)};var Vi={},Ui=ti,Zi=Wr,qi=Zr,Hi=Array,$i=Math.max,Ki=function(t,e,r){for(var n=Zi(t),i=Ui(e,n),o=Ui(void 0===r?n:r,n),a=Hi($i(o-i,0)),s=0;i<o;i++,s++)qi(a,s,t[i]);return a.length=s,a},Ji=T,Qi=et,to=Yi.f,eo=Ki,ro="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[];Vi.f=function(t){return ro&&"Window"==Ji(t)?function(t){try{return to(t)}catch(t){return eo(ro)}}(t):to(Qi(t))};var no={};no.f=Object.getOwnPropertySymbols;var io=xr,oo=function(t,e,r,n){return n&&n.enumerable?t[e]=r:io(t,e,r),t},ao=tr,so=function(t,e,r){return ao.f(t,e,r)},uo={},co=ve;uo.f=co;var lo,ho,fo,po=ot,vo=ee,yo=uo,go=tr.f,mo=function(t){var e=po.Symbol||(po.Symbol={});vo(e,t)||go(e,t,{value:yo.f(t)})},xo=j,bo=lt,wo=ve,_o=oo,So=function(){var t=bo("Symbol"),e=t&&t.prototype,r=e&&e.valueOf,n=wo("toPrimitive");e&&!e[n]&&_o(e,n,(function(t){return xo(r,this)}),{arity:1})},To=rn,Eo=Hr?{}.toString:function(){return"[object "+To(this)+"]"},ko=Hr,Oo=tr.f,Co=xr,Ao=ee,Lo=Eo,Po=ve("toStringTag"),Do=function(t,e,r,n){if(t){var i=r?t:t.prototype;Ao(i,Po)||Oo(i,Po,{configurable:!0,value:e}),n&&!ko&&Co(i,"toString",Lo)}},Mo=P,Ro=u.WeakMap,Io=Mo(Ro)&&/native code/.test(String(Ro)),jo=u,zo=it,Fo=xr,No=ee,Bo=qt,Wo=Oi,Yo=ai,Go="Object already initialized",Xo=jo.TypeError,Vo=jo.WeakMap;if(Io||Bo.state){var Uo=Bo.state||(Bo.state=new Vo);Uo.get=Uo.get,Uo.has=Uo.has,Uo.set=Uo.set,lo=function(t,e){if(Uo.has(t))throw Xo(Go);return e.facade=t,Uo.set(t,e),e},ho=function(t){return Uo.get(t)||{}},fo=function(t){return Uo.has(t)}}else{var Zo=Wo("state");Yo[Zo]=!0,lo=function(t,e){if(No(t,Zo))throw Xo(Go);return e.facade=t,Fo(t,Zo,e),e},ho=function(t){return No(t,Zo)?t[Zo]:{}},fo=function(t){return No(t,Zo)}}var qo={set:lo,get:ho,has:fo,enforce:function(t){return fo(t)?ho(t):lo(t,{})},getterFor:function(t){return function(e){var r;if(!zo(e)||(r=ho(e)).type!==t)throw Xo("Incompatible receiver, "+t+" required");return r}}},Ho=Qe,$o=q,Ko=Jt,Jo=Wr,Qo=Cn,ta=b([].push),ea=function(t){var e=1==t,r=2==t,n=3==t,i=4==t,o=6==t,a=7==t,s=5==t||o;return function(u,c,l,h){for(var f,p,d=Ko(u),v=$o(d),y=Ho(c,l),g=Jo(v),m=0,x=h||Qo,b=e?x(u,g):r||a?x(u,0):void 0;g>m;m++)if((s||m in v)&&(p=y(f=v[m],m,d),t))if(e)b[m]=p;else if(p)switch(t){case 3:return!0;case 5:return f;case 6:return m;case 2:ta(b,f)}else switch(t){case 4:return!1;case 7:ta(b,f)}return o?-1:n||i?i:b}},ra={forEach:ea(0),map:ea(1),filter:ea(2),some:ea(3),every:ea(4),find:ea(5),findIndex:ea(6),filterReject:ea(7)},na=Pr,ia=u,oa=j,aa=b,sa=M,ua=_t,ca=c,la=ee,ha=ht,fa=or,pa=et,da=Ee,va=Hn,ya=G,ga=Wi,ma=yi,xa=Yi,ba=Vi,wa=no,_a=D,Sa=tr,Ta=$n,Ea=z,ka=oo,Oa=so,Ca=Yt,Aa=ai,La=ae,Pa=ve,Da=uo,Ma=mo,Ra=So,Ia=Do,ja=qo,za=ra.forEach,Fa=Oi("hidden"),Na="Symbol",Ba="prototype",Wa=ja.set,Ya=ja.getterFor(Na),Ga=Object[Ba],Xa=ia.Symbol,Va=Xa&&Xa[Ba],Ua=ia.TypeError,Za=ia.QObject,qa=_a.f,Ha=Sa.f,$a=ba.f,Ka=Ea.f,Ja=aa([].push),Qa=Ca("symbols"),ts=Ca("op-symbols"),es=Ca("wks"),rs=!Za||!Za[Ba]||!Za[Ba].findChild,ns=sa&&ca((function(){return 7!=ga(Ha({},"a",{get:function(){return Ha(this,"a",{value:7}).a}})).a}))?function(t,e,r){var n=qa(Ga,e);n&&delete Ga[e],Ha(t,e,r),n&&t!==Ga&&Ha(Ga,e,n)}:Ha,is=function(t,e){var r=Qa[t]=ga(Va);return Wa(r,{type:Na,tag:t,description:e}),sa||(r.description=e),r},os=function(t,e,r){t===Ga&&os(ts,e,r),fa(t);var n=da(e);return fa(r),la(Qa,n)?(r.enumerable?(la(t,Fa)&&t[Fa][n]&&(t[Fa][n]=!1),r=ga(r,{enumerable:ya(0,!1)})):(la(t,Fa)||Ha(t,Fa,ya(1,{})),t[Fa][n]=!0),ns(t,n,r)):Ha(t,n,r)},as=function(t,e){fa(t);var r=pa(e),n=ma(r).concat(ls(r));return za(n,(function(e){sa&&!oa(ss,r,e)||os(t,e,r[e])})),t},ss=function(t){var e=da(t),r=oa(Ka,this,e);return!(this===Ga&&la(Qa,e)&&!la(ts,e))&&(!(r||!la(this,e)||!la(Qa,e)||la(this,Fa)&&this[Fa][e])||r)},us=function(t,e){var r=pa(t),n=da(e);if(r!==Ga||!la(Qa,n)||la(ts,n)){var i=qa(r,n);return!i||!la(Qa,n)||la(r,Fa)&&r[Fa][n]||(i.enumerable=!0),i}},cs=function(t){var e=$a(pa(t)),r=[];return za(e,(function(t){la(Qa,t)||la(Aa,t)||Ja(r,t)})),r},ls=function(t){var e=t===Ga,r=$a(e?ts:pa(t)),n=[];return za(r,(function(t){!la(Qa,t)||e&&!la(Ga,t)||Ja(n,Qa[t])})),n};ua||(Xa=function(){if(ha(Va,this))throw Ua("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?va(arguments[0]):void 0,e=La(t),r=function(t){this===Ga&&oa(r,ts,t),la(this,Fa)&&la(this[Fa],e)&&(this[Fa][e]=!1),ns(this,e,ya(1,t))};return sa&&rs&&ns(Ga,e,{configurable:!0,set:r}),is(e,t)},ka(Va=Xa[Ba],"toString",(function(){return Ya(this).tag})),ka(Xa,"withoutSetter",(function(t){return is(La(t),t)})),Ea.f=ss,Sa.f=os,Ta.f=as,_a.f=us,xa.f=ba.f=cs,wa.f=ls,Da.f=function(t){return is(Pa(t),t)},sa&&Oa(Va,"description",{configurable:!0,get:function(){return Ya(this).description}})),na({global:!0,constructor:!0,wrap:!0,forced:!ua,sham:!ua},{Symbol:Xa}),za(ma(es),(function(t){Ma(t)})),na({target:Na,stat:!0,forced:!ua},{useSetter:function(){rs=!0},useSimple:function(){rs=!1}}),na({target:"Object",stat:!0,forced:!ua,sham:!sa},{create:function(t,e){return void 0===e?ga(t):as(ga(t),e)},defineProperty:os,defineProperties:as,getOwnPropertyDescriptor:us}),na({target:"Object",stat:!0,forced:!ua},{getOwnPropertyNames:cs}),Ra(),Ia(Xa,Na),Aa[Fa]=!0;var hs=_t&&!!Symbol.for&&!!Symbol.keyFor,fs=Pr,ps=lt,ds=ee,vs=Hn,ys=Yt,gs=hs,ms=ys("string-to-symbol-registry"),xs=ys("symbol-to-string-registry");fs({target:"Symbol",stat:!0,forced:!gs},{for:function(t){var e=vs(t);if(ds(ms,e))return ms[e];var r=ps("Symbol")(e);return ms[e]=r,xs[r]=e,r}});var bs=Pr,ws=ee,_s=Ct,Ss=Lt,Ts=hs,Es=Yt("symbol-to-string-registry");bs({target:"Symbol",stat:!0,forced:!Ts},{keyFor:function(t){if(!_s(t))throw TypeError(Ss(t)+" is not a symbol");if(ws(Es,t))return Es[t]}});var ks=b([].slice),Os=Mr,Cs=P,As=T,Ls=Hn,Ps=b([].push),Ds=Pr,Ms=lt,Rs=v,Is=j,js=b,zs=c,Fs=P,Ns=Ct,Bs=ks,Ws=function(t){if(Cs(t))return t;if(Os(t)){for(var e=t.length,r=[],n=0;n<e;n++){var i=t[n];"string"==typeof i?Ps(r,i):"number"!=typeof i&&"Number"!=As(i)&&"String"!=As(i)||Ps(r,Ls(i))}var o=r.length,a=!0;return function(t,e){if(a)return a=!1,e;if(Os(this))return e;for(var n=0;n<o;n++)if(r[n]===t)return e}}},Ys=_t,Gs=String,Xs=Ms("JSON","stringify"),Vs=js(/./.exec),Us=js("".charAt),Zs=js("".charCodeAt),qs=js("".replace),Hs=js(1..toString),$s=/[\uD800-\uDFFF]/g,Ks=/^[\uD800-\uDBFF]$/,Js=/^[\uDC00-\uDFFF]$/,Qs=!Ys||zs((function(){var t=Ms("Symbol")();return"[null]"!=Xs([t])||"{}"!=Xs({a:t})||"{}"!=Xs(Object(t))})),tu=zs((function(){return'"\\udf06\\ud834"'!==Xs("\udf06\ud834")||'"\\udead"'!==Xs("\udead")})),eu=function(t,e){var r=Bs(arguments),n=Ws(e);if(Fs(n)||void 0!==t&&!Ns(t))return r[1]=function(t,e){if(Fs(n)&&(e=Is(n,this,Gs(t),e)),!Ns(e))return e},Rs(Xs,null,r)},ru=function(t,e,r){var n=Us(r,e-1),i=Us(r,e+1);return Vs(Ks,t)&&!Vs(Js,i)||Vs(Js,t)&&!Vs(Ks,n)?"\\u"+Hs(Zs(t,0),16):t};Xs&&Ds({target:"JSON",stat:!0,arity:3,forced:Qs||tu},{stringify:function(t,e,r){var n=Bs(arguments),i=Rs(Qs?eu:Xs,null,n);return tu&&"string"==typeof i?qs(i,$s,ru):i}});var nu=no,iu=Jt;Pr({target:"Object",stat:!0,forced:!_t||c((function(){nu.f(1)}))},{getOwnPropertySymbols:function(t){var e=nu.f;return e?e(iu(t)):[]}}),mo("asyncIterator"),mo("hasInstance"),mo("isConcatSpreadable"),mo("iterator"),mo("match"),mo("matchAll"),mo("replace"),mo("search"),mo("species"),mo("split");var ou=So;mo("toPrimitive"),ou();var au=lt,su=Do;mo("toStringTag"),su(au("Symbol"),"Symbol"),mo("unscopables"),Do(u.JSON,"JSON",!0);var uu,cu,lu,hu=ot.Symbol,fu={},pu=M,du=ee,vu=Function.prototype,yu=pu&&Object.getOwnPropertyDescriptor,gu=du(vu,"name"),mu={EXISTS:gu,PROPER:gu&&"something"===function(){}.name,CONFIGURABLE:gu&&(!pu||pu&&yu(vu,"name").configurable)},xu=!c((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),bu=ee,wu=P,_u=Jt,Su=xu,Tu=Oi("IE_PROTO"),Eu=Object,ku=Eu.prototype,Ou=Su?Eu.getPrototypeOf:function(t){var e=_u(t);if(bu(e,Tu))return e[Tu];var r=e.constructor;return wu(r)&&e instanceof r?r.prototype:e instanceof Eu?ku:null},Cu=c,Au=P,Lu=it,Pu=Wi,Du=Ou,Mu=oo,Ru=ve("iterator"),Iu=!1;[].keys&&("next"in(lu=[].keys())?(cu=Du(Du(lu)))!==Object.prototype&&(uu=cu):Iu=!0);var ju=!Lu(uu)||Cu((function(){var t={};return uu[Ru].call(t)!==t}));Au((uu=ju?{}:Pu(uu))[Ru])||Mu(uu,Ru,(function(){return this}));var zu={IteratorPrototype:uu,BUGGY_SAFARI_ITERATORS:Iu},Fu=zu.IteratorPrototype,Nu=Wi,Bu=G,Wu=Do,Yu=fu,Gu=function(){return this},Xu=b,Vu=Rt,Uu=P,Zu=String,qu=TypeError,Hu=function(t,e,r){try{return Xu(Vu(Object.getOwnPropertyDescriptor(t,e)[r]))}catch(t){}},$u=or,Ku=function(t){if("object"==typeof t||Uu(t))return t;throw qu("Can't set "+Zu(t)+" as a prototype")},Ju=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,r={};try{(t=Hu(Object.prototype,"__proto__","set"))(r,[]),e=r instanceof Array}catch(t){}return function(r,n){return $u(r),Ku(n),e?t(r,n):r.__proto__=n,r}}():void 0),Qu=Pr,tc=j,ec=function(t,e,r,n){var i=e+" Iterator";return t.prototype=Nu(Fu,{next:Bu(+!n,r)}),Wu(t,i,!1,!0),Yu[i]=Gu,t},rc=Ou,nc=Do,ic=oo,oc=fu,ac=mu.PROPER,sc=zu.BUGGY_SAFARI_ITERATORS,uc=ve("iterator"),cc="keys",lc="values",hc="entries",fc=function(){return this},pc=function(t,e,r,n,i,o,a){ec(r,e,n);var s,u,c,l=function(t){if(t===i&&v)return v;if(!sc&&t in p)return p[t];switch(t){case cc:case lc:case hc:return function(){return new r(this,t)}}return function(){return new r(this)}},h=e+" Iterator",f=!1,p=t.prototype,d=p[uc]||p["@@iterator"]||i&&p[i],v=!sc&&d||l(i),y="Array"==e&&p.entries||d;if(y&&(s=rc(y.call(new t)))!==Object.prototype&&s.next&&(nc(s,h,!0,!0),oc[h]=fc),ac&&i==lc&&d&&d.name!==lc&&(f=!0,v=function(){return tc(d,this)}),i)if(u={values:l(lc),keys:o?v:l(cc),entries:l(hc)},a)for(c in u)(sc||f||!(c in p))&&ic(p,c,u[c]);else Qu({target:e,proto:!0,forced:sc||f},u);return a&&p[uc]!==v&&ic(p,uc,v,{name:i}),oc[e]=v,u},dc=function(t,e){return{value:t,done:e}},vc=et,yc=fu,gc=qo;tr.f;var mc=pc,xc=dc,bc="Array Iterator",wc=gc.set,_c=gc.getterFor(bc);mc(Array,"Array",(function(t,e){wc(this,{type:bc,target:vc(t),index:0,kind:e})}),(function(){var t=_c(this),e=t.target,r=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,xc(void 0,!0)):xc("keys"==r?n:"values"==r?e[n]:[n,e[n]],!1)}),"values"),yc.Arguments=yc.Array;var Sc={CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0},Tc=u,Ec=rn,kc=xr,Oc=fu,Cc=ve("toStringTag");for(var Ac in Sc){var Lc=Tc[Ac],Pc=Lc&&Lc.prototype;Pc&&Ec(Pc)!==Cc&&kc(Pc,Cc,Ac),Oc[Ac]=Oc.Array}var Dc=hu;mo("dispose");var Mc=Dc;mo("asyncDispose");var Rc=Pr,Ic=b,jc=lt("Symbol"),zc=jc.keyFor,Fc=Ic(jc.prototype.valueOf);Rc({target:"Symbol",stat:!0},{isRegistered:function(t){try{return void 0!==zc(Fc(t))}catch(t){return!1}}});for(var Nc=Pr,Bc=Yt,Wc=lt,Yc=b,Gc=Ct,Xc=ve,Vc=Wc("Symbol"),Uc=Vc.isWellKnown,Zc=Wc("Object","getOwnPropertyNames"),qc=Yc(Vc.prototype.valueOf),Hc=Bc("wks"),$c=0,Kc=Zc(Vc),Jc=Kc.length;$c<Jc;$c++)try{var Qc=Kc[$c];Gc(Vc[Qc])&&Xc(Qc)}catch(t){}Nc({target:"Symbol",stat:!0,forced:!0},{isWellKnown:function(t){if(Uc&&Uc(t))return!0;try{for(var e=qc(t),r=0,n=Zc(Hc),i=n.length;r<i;r++)if(Hc[n[r]]==e)return!0}catch(t){}return!1}}),mo("matcher"),mo("metadataKey"),mo("observable"),mo("metadata"),mo("patternMatch"),mo("replaceAll");var tl=Mc;!function(t){t.exports=tl}(a),function(t){t.exports=o}(i);var el=r(n),rl={},nl={get exports(){return rl},set exports(t){rl=t}},il={},ol={get exports(){return il},set exports(t){il=t}},al=b,sl=zr,ul=Hn,cl=J,ll=al("".charAt),hl=al("".charCodeAt),fl=al("".slice),pl=function(t){return function(e,r){var n,i,o=ul(cl(e)),a=sl(r),s=o.length;return a<0||a>=s?t?"":void 0:(n=hl(o,a))<55296||n>56319||a+1===s||(i=hl(o,a+1))<56320||i>57343?t?ll(o,a):n:t?fl(o,a,a+2):i-56320+(n-55296<<10)+65536}},dl={codeAt:pl(!1),charAt:pl(!0)}.charAt,vl=Hn,yl=qo,gl=pc,ml=dc,xl="String Iterator",bl=yl.set,wl=yl.getterFor(xl);gl(String,"String",(function(t){bl(this,{type:xl,string:vl(t),index:0})}),(function(){var t,e=wl(this),r=e.string,n=e.index;return n>=r.length?ml(void 0,!0):(t=dl(r,n),e.index+=t.length,ml(t,!1))}));var _l=uo.f("iterator"),Sl=_l;!function(t){t.exports=Sl}(ol),function(t){t.exports=il}(nl);var Tl=r(rl);function El(t){return El="function"==typeof el&&"symbol"==typeof Tl?function(t){return typeof t}:function(t){return t&&"function"==typeof el&&t.constructor===el&&t!==el.prototype?"symbol":typeof t},El(t)}var kl={},Ol={get exports(){return kl},set exports(t){kl=t}},Cl=Lt,Al=TypeError,Ll=function(t,e){if(!delete t[e])throw Al("Cannot delete property "+Cl(e)+" of "+Cl(t))},Pl=Ki,Dl=Math.floor,Ml=function(t,e){var r=t.length,n=Dl(r/2);return r<8?Rl(t,e):Il(t,Ml(Pl(t,0,n),e),Ml(Pl(t,n),e),e)},Rl=function(t,e){for(var r,n,i=t.length,o=1;o<i;){for(n=o,r=t[o];n&&e(t[n-1],r)>0;)t[n]=t[--n];n!==o++&&(t[n]=r)}return t},Il=function(t,e,r,n){for(var i=e.length,o=r.length,a=0,s=0;a<i||s<o;)t[a+s]=a<i&&s<o?n(e[a],r[s])<=0?e[a++]:r[s++]:a<i?e[a++]:r[s++];return t},jl=Ml,zl=c,Fl=function(t,e){var r=[][t];return!!r&&zl((function(){r.call(null,e||function(){return 1},1)}))},Nl=ft.match(/firefox\/(\d+)/i),Bl=!!Nl&&+Nl[1],Wl=/MSIE|Trident/.test(ft),Yl=ft.match(/AppleWebKit\/(\d+)\./),Gl=!!Yl&&+Yl[1],Xl=Pr,Vl=b,Ul=Rt,Zl=Jt,ql=Wr,Hl=Ll,$l=Hn,Kl=c,Jl=jl,Ql=Fl,th=Bl,eh=Wl,rh=xt,nh=Gl,ih=[],oh=Vl(ih.sort),ah=Vl(ih.push),sh=Kl((function(){ih.sort(void 0)})),uh=Kl((function(){ih.sort(null)})),ch=Ql("sort"),lh=!Kl((function(){if(rh)return rh<70;if(!(th&&th>3)){if(eh)return!0;if(nh)return nh<603;var t,e,r,n,i="";for(t=65;t<76;t++){switch(e=String.fromCharCode(t),t){case 66:case 69:case 70:case 72:r=3;break;case 68:case 71:r=4;break;default:r=2}for(n=0;n<47;n++)ih.push({k:e+n,v:r})}for(ih.sort((function(t,e){return e.v-t.v})),n=0;n<ih.length;n++)e=ih[n].k.charAt(0),i.charAt(i.length-1)!==e&&(i+=e);return"DGBEFHACIJK"!==i}}));Xl({target:"Array",proto:!0,forced:sh||!uh||!ch||!lh},{sort:function(t){void 0!==t&&Ul(t);var e=Zl(this);if(lh)return void 0===t?oh(e):oh(e,t);var r,n,i=[],o=ql(e);for(n=0;n<o;n++)n in e&&ah(i,e[n]);for(Jl(i,function(t){return function(e,r){return void 0===r?-1:void 0===e?1:void 0!==t?+t(e,r)||0:$l(e)>$l(r)?1:-1}}(t)),r=ql(i),n=0;n<r;)e[n]=i[n++];for(;n<o;)Hl(e,n++);return e}});var hh=ot,fh=function(t){return hh[t+"Prototype"]},ph=fh("Array").sort,dh=ht,vh=ph,yh=Array.prototype,gh=function(t){var e=t.sort;return t===yh||dh(yh,t)&&e===yh.sort?vh:e};!function(t){t.exports=gh}(Ol);var mh=r(kl),xh={},bh={get exports(){return xh},set exports(t){xh=t}},wh=Pr,_h=oi.indexOf,Sh=Fl,Th=O([].indexOf),Eh=!!Th&&1/Th([1],1,-0)<0;wh({target:"Array",proto:!0,forced:Eh||!Sh("indexOf")},{indexOf:function(t){var e=arguments.length>1?arguments[1]:void 0;return Eh?Th(this,t,e)||0:_h(this,t,e)}});var kh=fh("Array").indexOf,Oh=ht,Ch=kh,Ah=Array.prototype,Lh=function(t){var e=t.indexOf;return t===Ah||Oh(Ah,t)&&e===Ah.indexOf?Ch:e};!function(t){t.exports=Lh}(bh);var Ph=r(xh),Dh={},Mh={get exports(){return Dh},set exports(t){Dh=t}},Rh=ra.filter;Pr({target:"Array",proto:!0,forced:!Dn("filter")},{filter:function(t){return Rh(this,t,arguments.length>1?arguments[1]:void 0)}});var Ih=fh("Array").filter,jh=ht,zh=Ih,Fh=Array.prototype,Nh=function(t){var e=t.filter;return t===Fh||jh(Fh,t)&&e===Fh.filter?zh:e};!function(t){t.exports=Nh}(Mh);var Bh=r(Dh),Wh={},Yh={get exports(){return Wh},set exports(t){Wh=t}},Gh="\t\n\v\f\r                　\u2028\u2029\ufeff",Xh=J,Vh=Hn,Uh=Gh,Zh=b("".replace),qh=RegExp("^["+Uh+"]+"),Hh=RegExp("(^|[^"+Uh+"])["+Uh+"]+$"),$h=function(t){return function(e){var r=Vh(Xh(e));return 1&t&&(r=Zh(r,qh,"")),2&t&&(r=Zh(r,Hh,"$1")),r}},Kh={start:$h(1),end:$h(2),trim:$h(3)},Jh=u,Qh=c,tf=Hn,ef=Kh.trim,rf=Gh,nf=b("".charAt),of=Jh.parseFloat,af=Jh.Symbol,sf=af&&af.iterator,uf=1/of(rf+"-0")!=-1/0||sf&&!Qh((function(){of(Object(sf))}))?function(t){var e=ef(tf(t)),r=of(e);return 0===r&&"-"==nf(e,0)?-0:r}:of;Pr({global:!0,forced:parseFloat!=uf},{parseFloat:uf});var cf=ot.parseFloat;!function(t){t.exports=cf}(Yh);var lf=r(Wh),hf={},ff={get exports(){return hf},set exports(t){hf=t}},pf=Jt,df=ti,vf=Wr,yf=function(t){for(var e=pf(this),r=vf(e),n=arguments.length,i=df(n>1?arguments[1]:void 0,r),o=n>2?arguments[2]:void 0,a=void 0===o?r:df(o,r);a>i;)e[i++]=t;return e};Pr({target:"Array",proto:!0},{fill:yf});var gf=fh("Array").fill,mf=ht,xf=gf,bf=Array.prototype,wf=function(t){var e=t.fill;return t===bf||mf(bf,t)&&e===bf.fill?xf:e};!function(t){t.exports=wf}(ff);var _f=r(hf),Sf={},Tf={get exports(){return Sf},set exports(t){Sf=t}},Ef=fh("Array").values,kf=rn,Of=ee,Cf=ht,Af=Ef,Lf=Array.prototype,Pf={DOMTokenList:!0,NodeList:!0},Df=function(t){var e=t.values;return t===Lf||Cf(Lf,t)&&e===Lf.values||Of(Pf,kf(t))?Af:e};!function(t){t.exports=Df}(Tf);var Mf=r(Sf),Rf={},If={get exports(){return Rf},set exports(t){Rf=t}},jf=ra.forEach,zf=Fl("forEach")?[].forEach:function(t){return jf(this,t,arguments.length>1?arguments[1]:void 0)};Pr({target:"Array",proto:!0,forced:[].forEach!=zf},{forEach:zf});var Ff=fh("Array").forEach,Nf=rn,Bf=ee,Wf=ht,Yf=Ff,Gf=Array.prototype,Xf={DOMTokenList:!0,NodeList:!0},Vf=function(t){var e=t.forEach;return t===Gf||Wf(Gf,t)&&e===Gf.forEach||Bf(Xf,Nf(t))?Yf:e};!function(t){t.exports=Vf}(If);var Uf=r(Rf),Zf={},qf={get exports(){return Zf},set exports(t){Zf=t}};Pr({target:"Array",stat:!0},{isArray:Mr});var Hf=ot.Array.isArray;!function(t){t.exports=Hf}(qf);var $f=r(Zf),Kf={},Jf={get exports(){return Kf},set exports(t){Kf=t}};Pr({target:"Number",stat:!0},{isNaN:function(t){return t!=t}});var Qf=ot.Number.isNaN;!function(t){t.exports=Qf}(Jf);var tp=r(Kf),ep={},rp={get exports(){return ep},set exports(t){ep=t}},np=fh("Array").concat,ip=ht,op=np,ap=Array.prototype,sp=function(t){var e=t.concat;return t===ap||ip(ap,t)&&e===ap.concat?op:e};!function(t){t.exports=sp}(rp);var up=r(ep),cp={},lp={get exports(){return cp},set exports(t){cp=t}},hp="function"==typeof Bun&&Bun&&"string"==typeof Bun.version,fp=TypeError,pp=function(t,e){if(t<e)throw fp("Not enough arguments");return t},dp=u,vp=v,yp=P,gp=hp,mp=ft,xp=ks,bp=pp,wp=dp.Function,_p=/MSIE .\./.test(mp)||gp&&function(){var t=dp.Bun.version.split(".");return t.length<3||0==t[0]&&(t[1]<3||3==t[1]&&0==t[2])}(),Sp=function(t,e){var r=e?2:1;return _p?function(n,i){var o=bp(arguments.length,1)>r,a=yp(n)?n:wp(n),s=o?xp(arguments,r):[],u=o?function(){vp(a,this,s)}:a;return e?t(u,i):t(u)}:t},Tp=Pr,Ep=u,kp=Sp(Ep.setInterval,!0);Tp({global:!0,bind:!0,forced:Ep.setInterval!==kp},{setInterval:kp});var Op=Pr,Cp=u,Ap=Sp(Cp.setTimeout,!0);Op({global:!0,bind:!0,forced:Cp.setTimeout!==Ap},{setTimeout:Ap});var Lp=ot.setTimeout;!function(t){t.exports=Lp}(lp);var Pp=r(cp),Dp={},Mp={get exports(){return Dp},set exports(t){Dp=t}},Rp=M,Ip=b,jp=j,zp=c,Fp=yi,Np=no,Bp=z,Wp=Jt,Yp=q,Gp=Object.assign,Xp=Object.defineProperty,Vp=Ip([].concat),Up=!Gp||zp((function(){if(Rp&&1!==Gp({b:1},Gp(Xp({},"a",{enumerable:!0,get:function(){Xp(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},r=Symbol(),n="abcdefghijklmnopqrst";return t[r]=7,n.split("").forEach((function(t){e[t]=t})),7!=Gp({},t)[r]||Fp(Gp({},e)).join("")!=n}))?function(t,e){for(var r=Wp(t),n=arguments.length,i=1,o=Np.f,a=Bp.f;n>i;)for(var s,u=Yp(arguments[i++]),c=o?Vp(Fp(u),o(u)):Fp(u),l=c.length,h=0;l>h;)s=c[h++],Rp&&!jp(a,u,s)||(r[s]=u[s]);return r}:Gp,Zp=Up;Pr({target:"Object",stat:!0,arity:2,forced:Object.assign!==Zp},{assign:Zp});var qp=ot.Object.assign;!function(t){t.exports=qp}(Mp);var Hp=r(Dp),$p={};!function(t){function e(t){if(t)return function(t){for(var r in e.prototype)t[r]=e.prototype[r];return t}(t)}t.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function r(){this.off(t,r),e.apply(this,arguments)}return r.fn=e,this.on(t,r),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var r,n=this._callbacks["$"+t];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var i=0;i<n.length;i++)if((r=n[i])===e||r.fn===e){n.splice(i,1);break}return 0===n.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),r=this._callbacks["$"+t],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(r){n=0;for(var i=(r=r.slice(0)).length;n<i;++n)r[n].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}({get exports(){return $p},set exports(t){$p=t}});var Kp=$p,Jp={},Qp={get exports(){return Jp},set exports(t){Jp=t}},td=j,ed=or,rd=zt,nd=function(t,e,r){var n,i;ed(t);try{if(!(n=rd(t,"return"))){if("throw"===e)throw r;return r}n=td(n,t)}catch(t){i=!0,n=t}if("throw"===e)throw r;if(i)throw n;return ed(n),r},id=or,od=nd,ad=fu,sd=ve("iterator"),ud=Array.prototype,cd=function(t){return void 0!==t&&(ad.Array===t||ud[sd]===t)},ld=rn,hd=zt,fd=H,pd=fu,dd=ve("iterator"),vd=function(t){if(!fd(t))return hd(t,dd)||hd(t,"@@iterator")||pd[ld(t)]},yd=j,gd=Rt,md=or,xd=Lt,bd=vd,wd=TypeError,_d=function(t,e){var r=arguments.length<2?bd(t):e;if(gd(r))return md(yd(r,t));throw wd(xd(t)+" is not iterable")},Sd=Qe,Td=j,Ed=Jt,kd=function(t,e,r,n){try{return n?e(id(r)[0],r[1]):e(r)}catch(e){od(t,"throw",e)}},Od=cd,Cd=wn,Ad=Wr,Ld=Zr,Pd=_d,Dd=vd,Md=Array,Rd=ve("iterator"),Id=!1;try{var jd=0,zd={next:function(){return{done:!!jd++}},return:function(){Id=!0}};zd[Rd]=function(){return this},Array.from(zd,(function(){throw 2}))}catch(t){}var Fd=function(t,e){if(!e&&!Id)return!1;var r=!1;try{var n={};n[Rd]=function(){return{next:function(){return{done:r=!0}}}},t(n)}catch(t){}return r},Nd=function(t){var e=Ed(t),r=Cd(this),n=arguments.length,i=n>1?arguments[1]:void 0,o=void 0!==i;o&&(i=Sd(i,n>2?arguments[2]:void 0));var a,s,u,c,l,h,f=Dd(e),p=0;if(!f||this===Md&&Od(f))for(a=Ad(e),s=r?new this(a):Md(a);a>p;p++)h=o?i(e[p],p):e[p],Ld(s,p,h);else for(l=(c=Pd(e,f)).next,s=r?new this:[];!(u=Td(l,c)).done;p++)h=o?kd(c,i,[u.value,p],!0):u.value,Ld(s,p,h);return s.length=p,s};Pr({target:"Array",stat:!0,forced:!Fd((function(t){Array.from(t)}))},{from:Nd});var Bd=ot.Array.from;!function(t){t.exports=Bd}(Qp);var Wd=r(Jp),Yd={},Gd={get exports(){return Yd},set exports(t){Yd=t}},Xd={},Vd=vd;!function(t){t.exports=Vd}({get exports(){return Xd},set exports(t){Xd=t}}),function(t){t.exports=Xd}(Gd);var Ud=r(Yd),Zd={},qd={get exports(){return Zd},set exports(t){Zd=t}},Hd=ot.Object.getOwnPropertySymbols;!function(t){t.exports=Hd}(qd);var $d=r(Zd),Kd={},Jd={get exports(){return Kd},set exports(t){Kd=t}},Qd={},tv={get exports(){return Qd},set exports(t){Qd=t}},ev=Pr,rv=c,nv=et,iv=D.f,ov=M;ev({target:"Object",stat:!0,forced:!ov||rv((function(){iv(1)})),sham:!ov},{getOwnPropertyDescriptor:function(t,e){return iv(nv(t),e)}});var av=ot.Object,sv=tv.exports=function(t,e){return av.getOwnPropertyDescriptor(t,e)};av.getOwnPropertyDescriptor.sham&&(sv.sham=!0);var uv=Qd;!function(t){t.exports=uv}(Jd);var cv=r(Kd),lv={},hv={get exports(){return lv},set exports(t){lv=t}},fv=lt,pv=Yi,dv=no,vv=or,yv=b([].concat),gv=fv("Reflect","ownKeys")||function(t){var e=pv.f(vv(t)),r=dv.f;return r?yv(e,r(t)):e},mv=gv,xv=et,bv=D,wv=Zr;Pr({target:"Object",stat:!0,sham:!M},{getOwnPropertyDescriptors:function(t){for(var e,r,n=xv(t),i=bv.f,o=mv(n),a={},s=0;o.length>s;)void 0!==(r=i(n,e=o[s++]))&&wv(a,e,r);return a}});var _v=ot.Object.getOwnPropertyDescriptors;!function(t){t.exports=_v}(hv);var Sv=r(lv),Tv={},Ev={get exports(){return Tv},set exports(t){Tv=t}},kv={},Ov={get exports(){return kv},set exports(t){kv=t}},Cv=Pr,Av=M,Lv=$n.f;Cv({target:"Object",stat:!0,forced:Object.defineProperties!==Lv,sham:!Av},{defineProperties:Lv});var Pv=ot.Object,Dv=Ov.exports=function(t,e){return Pv.defineProperties(t,e)};Pv.defineProperties.sham&&(Dv.sham=!0);var Mv=kv;!function(t){t.exports=Mv}(Ev);var Rv=r(Tv),Iv={},jv={get exports(){return Iv},set exports(t){Iv=t}},zv={},Fv={get exports(){return zv},set exports(t){zv=t}},Nv=Pr,Bv=M,Wv=tr.f;Nv({target:"Object",stat:!0,forced:Object.defineProperty!==Wv,sham:!Bv},{defineProperty:Wv});var Yv=ot.Object,Gv=Fv.exports=function(t,e,r){return Yv.defineProperty(t,e,r)};Yv.defineProperty.sham&&(Gv.sham=!0);var Xv=zv;!function(t){t.exports=Xv}(jv);var Vv=r(Iv);function Uv(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}var Zv={},qv={get exports(){return Zv},set exports(t){Zv=t}},Hv={},$v=Xv;!function(t){t.exports=$v}({get exports(){return Hv},set exports(t){Hv=t}}),function(t){t.exports=Hv}(qv);var Kv=r(Zv),Jv={},Qv={get exports(){return Jv},set exports(t){Jv=t}},ty={},ey={get exports(){return ty},set exports(t){ty=t}},ry=uo.f("toPrimitive");!function(t){t.exports=ry}(ey),function(t){t.exports=ty}(Qv);var ny=r(Jv);function iy(t){var e=function(t,e){if("object"!==El(t)||null===t)return t;var r=t[ny];if(void 0!==r){var n=r.call(t,e||"default");if("object"!==El(n))return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===e?String:Number)(t)}(t,"string");return"symbol"===El(e)?e:String(e)}function oy(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Kv(t,iy(n.key),n)}}function ay(t,e,r){return e&&oy(t.prototype,e),r&&oy(t,r),Kv(t,"prototype",{writable:!1}),t}function sy(t,e,r){return(e=iy(e))in t?Kv(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t}var uy={},cy={get exports(){return uy},set exports(t){uy=t}},ly={},hy=Hf;!function(t){t.exports=hy}({get exports(){return ly},set exports(t){ly=t}}),function(t){t.exports=ly}(cy);var fy=r(uy);var py={},dy={get exports(){return py},set exports(t){py=t}},vy={},yy={get exports(){return vy},set exports(t){vy=t}},gy=Pr,my=Mr,xy=wn,by=it,wy=ti,_y=Wr,Sy=et,Ty=Zr,Ey=ve,ky=ks,Oy=Dn("slice"),Cy=Ey("species"),Ay=Array,Ly=Math.max;gy({target:"Array",proto:!0,forced:!Oy},{slice:function(t,e){var r,n,i,o=Sy(this),a=_y(o),s=wy(t,a),u=wy(void 0===e?a:e,a);if(my(o)&&(r=o.constructor,(xy(r)&&(r===Ay||my(r.prototype))||by(r)&&null===(r=r[Cy]))&&(r=void 0),r===Ay||void 0===r))return ky(o,s,u);for(n=new(void 0===r?Ay:r)(Ly(u-s,0)),i=0;s<u;s++,i++)s in o&&Ty(n,i,o[s]);return n.length=i,n}});var Py=fh("Array").slice,Dy=ht,My=Py,Ry=Array.prototype,Iy=function(t){var e=t.slice;return t===Ry||Dy(Ry,t)&&e===Ry.slice?My:e},jy=Iy;!function(t){t.exports=jy}(yy),function(t){t.exports=vy}(dy);var zy=r(py),Fy={},Ny={get exports(){return Fy},set exports(t){Fy=t}},By={},Wy=Bd;!function(t){t.exports=Wy}({get exports(){return By},set exports(t){By=t}}),function(t){t.exports=By}(Ny);var Yy=r(Fy);function Gy(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function Xy(t,e){var r;if(t){if("string"==typeof t)return Gy(t,e);var n=zy(r=Object.prototype.toString.call(t)).call(r,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?Yy(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Gy(t,e):void 0}}function Vy(t,e){return function(t){if(fy(t))return t}(t)||function(t,e){var r=null==t?null:void 0!==el&&Ud(t)||t["@@iterator"];if(null!=r){var n,i,o,a,s=[],u=!0,c=!1;try{if(o=(r=r.call(t)).next,0===e){if(Object(r)!==r)return;u=!1}else for(;!(u=(n=o.call(r)).done)&&(s.push(n.value),s.length!==e);u=!0);}catch(t){c=!0,i=t}finally{try{if(!u&&null!=r.return&&(a=r.return(),Object(a)!==a))return}finally{if(c)throw i}}return s}}(t,e)||Xy(t,e)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Uy(t){return function(t){if(fy(t))return Gy(t)}(t)||function(t){if(void 0!==el&&null!=Ud(t)||null!=t["@@iterator"])return Yy(t)}(t)||Xy(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Zy={};!function(t){t.exports=Dc}({get exports(){return Zy},set exports(t){Zy=t}});var qy=r(Zy),Hy={};!function(t){t.exports=Iy}({get exports(){return Hy},set exports(t){Hy=t}});var $y=r(Hy),Ky={},Jy={get exports(){return Ky},set exports(t){Ky=t}};Pr({target:"Reflect",stat:!0},{ownKeys:gv});var Qy=ot.Reflect.ownKeys;!function(t){t.exports=Qy}(Jy);var tg=r(Ky),eg={},rg={get exports(){return eg},set exports(t){eg=t}},ng=ra.map;Pr({target:"Array",proto:!0,forced:!Dn("map")},{map:function(t){return ng(this,t,arguments.length>1?arguments[1]:void 0)}});var ig=fh("Array").map,og=ht,ag=ig,sg=Array.prototype,ug=function(t){var e=t.map;return t===sg||og(sg,t)&&e===sg.map?ag:e};!function(t){t.exports=ug}(rg);var cg=r(eg),lg={},hg={get exports(){return lg},set exports(t){lg=t}},fg=Jt,pg=yi;Pr({target:"Object",stat:!0,forced:c((function(){pg(1)}))},{keys:function(t){return pg(fg(t))}});var dg=ot.Object.keys;!function(t){t.exports=dg}(hg);var vg=r(lg),yg={},gg={get exports(){return yg},set exports(t){yg=t}},mg=Pr,xg=Date,bg=b(xg.prototype.getTime);mg({target:"Date",stat:!0},{now:function(){return bg(new xg)}});var wg=ot.Date.now;!function(t){t.exports=wg}(gg);var _g={},Sg={get exports(){return _g},set exports(t){_g=t}},Tg=b,Eg=Rt,kg=it,Og=ee,Cg=ks,Ag=l,Lg=Function,Pg=Tg([].concat),Dg=Tg([].join),Mg={},Rg=function(t,e,r){if(!Og(Mg,e)){for(var n=[],i=0;i<e;i++)n[i]="a["+i+"]";Mg[e]=Lg("C,a","return new C("+Dg(n,",")+")")}return Mg[e](t,r)},Ig=Ag?Lg.bind:function(t){var e=Eg(this),r=e.prototype,n=Cg(arguments,1),i=function(){var r=Pg(n,Cg(arguments));return this instanceof i?Rg(e,r.length,r):e.apply(t,r)};return kg(r)&&(i.prototype=r),i},jg=Ig;Pr({target:"Function",proto:!0,forced:Function.bind!==jg},{bind:jg});var zg=fh("Function").bind,Fg=ht,Ng=zg,Bg=Function.prototype,Wg=function(t){var e=t.bind;return t===Bg||Fg(Bg,t)&&e===Bg.bind?Ng:e};!function(t){t.exports=Wg}(Sg);var Yg=r(_g),Gg={},Xg={get exports(){return Gg},set exports(t){Gg=t}},Vg=Pr,Ug=Mr,Zg=b([].reverse),qg=[1,2];Vg({target:"Array",proto:!0,forced:String(qg)===String(qg.reverse())},{reverse:function(){return Ug(this)&&(this.length=this.length),Zg(this)}});var Hg=fh("Array").reverse,$g=ht,Kg=Hg,Jg=Array.prototype,Qg=function(t){var e=t.reverse;return t===Jg||$g(Jg,t)&&e===Jg.reverse?Kg:e};!function(t){t.exports=Qg}(Xg);var tm=r(Gg),em={},rm={get exports(){return em},set exports(t){em=t}},nm=M,im=Mr,om=TypeError,am=Object.getOwnPropertyDescriptor,sm=nm&&!function(){if(void 0!==this)return!0;try{Object.defineProperty([],"length",{writable:!1}).length=1}catch(t){return t instanceof TypeError}}(),um=Pr,cm=Jt,lm=ti,hm=zr,fm=Wr,pm=sm?function(t,e){if(im(t)&&!am(t,"length").writable)throw om("Cannot set read only .length");return t.length=e}:function(t,e){return t.length=e},dm=Gr,vm=Cn,ym=Zr,gm=Ll,mm=Dn("splice"),xm=Math.max,bm=Math.min;um({target:"Array",proto:!0,forced:!mm},{splice:function(t,e){var r,n,i,o,a,s,u=cm(this),c=fm(u),l=lm(t,c),h=arguments.length;for(0===h?r=n=0:1===h?(r=0,n=c-l):(r=h-2,n=bm(xm(hm(e),0),c-l)),dm(c+r-n),i=vm(u,n),o=0;o<n;o++)(a=l+o)in u&&ym(i,o,u[a]);if(i.length=n,r<n){for(o=l;o<c-n;o++)s=o+r,(a=o+n)in u?u[s]=u[a]:gm(u,s);for(o=c;o>c-n+r;o--)gm(u,o-1)}else if(r>n)for(o=c-n;o>l;o--)s=o+r-1,(a=o+n-1)in u?u[s]=u[a]:gm(u,s);for(o=0;o<r;o++)u[o+l]=arguments[o+2];return pm(u,c-n+r),i}});var wm=fh("Array").splice,_m=ht,Sm=wm,Tm=Array.prototype,Em=function(t){var e=t.splice;return t===Tm||_m(Tm,t)&&e===Tm.splice?Sm:e};!function(t){t.exports=Em}(rm);var km=r(em),Om={},Cm={get exports(){return Om},set exports(t){Om=t}},Am=oi.includes;Pr({target:"Array",proto:!0,forced:c((function(){return!Array(1).includes()}))},{includes:function(t){return Am(this,t,arguments.length>1?arguments[1]:void 0)}});var Lm=fh("Array").includes,Pm=it,Dm=T,Mm=ve("match"),Rm=function(t){var e;return Pm(t)&&(void 0!==(e=t[Mm])?!!e:"RegExp"==Dm(t))},Im=TypeError,jm=ve("match"),zm=Pr,Fm=function(t){if(Rm(t))throw Im("The method doesn't accept regular expressions");return t},Nm=J,Bm=Hn,Wm=function(t){var e=/./;try{"/./"[t](e)}catch(r){try{return e[jm]=!1,"/./"[t](e)}catch(t){}}return!1},Ym=b("".indexOf);zm({target:"String",proto:!0,forced:!Wm("includes")},{includes:function(t){return!!~Ym(Bm(Nm(this)),Bm(Fm(t)),arguments.length>1?arguments[1]:void 0)}});var Gm=fh("String").includes,Xm=ht,Vm=Lm,Um=Gm,Zm=Array.prototype,qm=String.prototype,Hm=function(t){var e=t.includes;return t===Zm||Xm(Zm,t)&&e===Zm.includes?Vm:"string"==typeof t||t===qm||Xm(qm,t)&&e===qm.includes?Um:e};!function(t){t.exports=Hm}(Cm);var $m=r(Om),Km={},Jm={get exports(){return Km},set exports(t){Km=t}},Qm=Jt,tx=Ou,ex=xu;Pr({target:"Object",stat:!0,forced:c((function(){tx(1)})),sham:!ex},{getPrototypeOf:function(t){return tx(Qm(t))}});var rx=ot.Object.getPrototypeOf;!function(t){t.exports=rx}(Jm);var nx=r(Km),ix={},ox={get exports(){return ix},set exports(t){ix=t}},ax=M,sx=b,ux=yi,cx=et,lx=sx(z.f),hx=sx([].push),fx=function(t){return function(e){for(var r,n=cx(e),i=ux(n),o=i.length,a=0,s=[];o>a;)r=i[a++],ax&&!lx(n,r)||hx(s,t?[r,n[r]]:n[r]);return s}},px={entries:fx(!0),values:fx(!1)}.values;Pr({target:"Object",stat:!0},{values:function(t){return px(t)}});var dx=ot.Object.values;!function(t){t.exports=dx}(ox);var vx={},yx={get exports(){return vx},set exports(t){vx=t}},gx=u,mx=c,xx=b,bx=Hn,wx=Kh.trim,_x=Gh,Sx=gx.parseInt,Tx=gx.Symbol,Ex=Tx&&Tx.iterator,kx=/^[+-]?0x/i,Ox=xx(kx.exec),Cx=8!==Sx(_x+"08")||22!==Sx(_x+"0x16")||Ex&&!mx((function(){Sx(Object(Ex))}))?function(t,e){var r=wx(bx(t));return Sx(r,e>>>0||(Ox(kx,r)?16:10))}:Sx;Pr({global:!0,forced:parseInt!=Cx},{parseInt:Cx});var Ax=ot.parseInt;!function(t){t.exports=Ax}(yx);var Lx=r(vx),Px={},Dx={get exports(){return Px},set exports(t){Px=t}},Mx=mu.PROPER,Rx=c,Ix=Gh,jx=Kh.trim;Pr({target:"String",proto:!0,forced:function(t){return Rx((function(){return!!Ix[t]()||"​᠎"!=="​᠎"[t]()||Mx&&Ix[t].name!==t}))}("trim")},{trim:function(){return jx(this)}});var zx=fh("String").trim,Fx=ht,Nx=zx,Bx=String.prototype,Wx=function(t){var e=t.trim;return"string"==typeof t||t===Bx||Fx(Bx,t)&&e===Bx.trim?Nx:e};!function(t){t.exports=Wx}(Dx);var Yx={},Gx={get exports(){return Yx},set exports(t){Yx=t}};Pr({target:"Object",stat:!0,sham:!M},{create:Wi});var Xx=ot.Object,Vx=function(t,e){return Xx.create(t,e)};!function(t){t.exports=Vx}(Gx);var Ux=r(Yx),Zx={},qx={get exports(){return Zx},set exports(t){Zx=t}},Hx=ot,$x=v;Hx.JSON||(Hx.JSON={stringify:JSON.stringify});var Kx=function(t,e,r){return $x(Hx.JSON.stringify,null,arguments)},Jx=Kx;!function(t){t.exports=Jx}(qx);var Qx,tb=r(Zx);
/*! Hammer.JS - v2.0.17-rc - 2019-12-16
	 * http://naver.github.io/egjs
	 *
	 * Forked By Naver egjs
	 * Copyright (c) hammerjs
	 * Licensed under the MIT license */function eb(){return eb=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var r=arguments[e];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(t[n]=r[n])}return t},eb.apply(this,arguments)}function rb(t,e){t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t.__proto__=e}function nb(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}Qx="function"!=typeof Object.assign?function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),r=1;r<arguments.length;r++){var n=arguments[r];if(null!=n)for(var i in n)n.hasOwnProperty(i)&&(e[i]=n[i])}return e}:Object.assign;var ib,ob=Qx,ab=["","webkit","Moz","MS","ms","o"],sb="undefined"==typeof document?{style:{}}:document.createElement("div"),ub="function",cb=Math.round,lb=Math.abs,hb=Date.now;function fb(t,e){for(var r,n,i=e[0].toUpperCase()+e.slice(1),o=0;o<ab.length;){if((n=(r=ab[o])?r+i:e)in t)return n;o++}}ib="undefined"==typeof window?{}:window;var pb=fb(sb.style,"touchAction"),db=void 0!==pb;var vb="compute",yb="auto",gb="manipulation",mb="none",xb="pan-x",bb="pan-y",wb=function(){if(!db)return!1;var t={},e=ib.CSS&&ib.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(r){return t[r]=!e||ib.CSS.supports("touch-action",r)})),t}(),_b="ontouchstart"in ib,Sb=void 0!==fb(ib,"PointerEvent"),Tb=_b&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),Eb="touch",kb="mouse",Ob=25,Cb=1,Ab=2,Lb=4,Pb=8,Db=1,Mb=2,Rb=4,Ib=8,jb=16,zb=Mb|Rb,Fb=Ib|jb,Nb=zb|Fb,Bb=["x","y"],Wb=["clientX","clientY"];function Yb(t,e,r){var n;if(t)if(t.forEach)t.forEach(e,r);else if(void 0!==t.length)for(n=0;n<t.length;)e.call(r,t[n],n,t),n++;else for(n in t)t.hasOwnProperty(n)&&e.call(r,t[n],n,t)}function Gb(t,e){return typeof t===ub?t.apply(e&&e[0]||void 0,e):t}function Xb(t,e){return t.indexOf(e)>-1}var Vb=function(){function t(t,e){this.manager=t,this.set(e)}var e=t.prototype;return e.set=function(t){t===vb&&(t=this.compute()),db&&this.manager.element.style&&wb[t]&&(this.manager.element.style[pb]=t),this.actions=t.toLowerCase().trim()},e.update=function(){this.set(this.manager.options.touchAction)},e.compute=function(){var t=[];return Yb(this.manager.recognizers,(function(e){Gb(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(Xb(t,mb))return mb;var e=Xb(t,xb),r=Xb(t,bb);return e&&r?mb:e||r?e?xb:bb:Xb(t,gb)?gb:yb}(t.join(" "))},e.preventDefaults=function(t){var e=t.srcEvent,r=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var n=this.actions,i=Xb(n,mb)&&!wb[mb],o=Xb(n,bb)&&!wb[bb],a=Xb(n,xb)&&!wb[xb];if(i){var s=1===t.pointers.length,u=t.distance<2,c=t.deltaTime<250;if(s&&u&&c)return}if(!a||!o)return i||o&&r&zb||a&&r&Fb?this.preventSrc(e):void 0}},e.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},t}();function Ub(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1}function Zb(t){var e=t.length;if(1===e)return{x:cb(t[0].clientX),y:cb(t[0].clientY)};for(var r=0,n=0,i=0;i<e;)r+=t[i].clientX,n+=t[i].clientY,i++;return{x:cb(r/e),y:cb(n/e)}}function qb(t){for(var e=[],r=0;r<t.pointers.length;)e[r]={clientX:cb(t.pointers[r].clientX),clientY:cb(t.pointers[r].clientY)},r++;return{timeStamp:hb(),pointers:e,center:Zb(e),deltaX:t.deltaX,deltaY:t.deltaY}}function Hb(t,e,r){r||(r=Bb);var n=e[r[0]]-t[r[0]],i=e[r[1]]-t[r[1]];return Math.sqrt(n*n+i*i)}function $b(t,e,r){r||(r=Bb);var n=e[r[0]]-t[r[0]],i=e[r[1]]-t[r[1]];return 180*Math.atan2(i,n)/Math.PI}function Kb(t,e){return t===e?Db:lb(t)>=lb(e)?t<0?Mb:Rb:e<0?Ib:jb}function Jb(t,e,r){return{x:e/t||0,y:r/t||0}}function Qb(t,e){var r=t.session,n=e.pointers,i=n.length;r.firstInput||(r.firstInput=qb(e)),i>1&&!r.firstMultiple?r.firstMultiple=qb(e):1===i&&(r.firstMultiple=!1);var o=r.firstInput,a=r.firstMultiple,s=a?a.center:o.center,u=e.center=Zb(n);e.timeStamp=hb(),e.deltaTime=e.timeStamp-o.timeStamp,e.angle=$b(s,u),e.distance=Hb(s,u),function(t,e){var r=e.center,n=t.offsetDelta||{},i=t.prevDelta||{},o=t.prevInput||{};e.eventType!==Cb&&o.eventType!==Lb||(i=t.prevDelta={x:o.deltaX||0,y:o.deltaY||0},n=t.offsetDelta={x:r.x,y:r.y}),e.deltaX=i.x+(r.x-n.x),e.deltaY=i.y+(r.y-n.y)}(r,e),e.offsetDirection=Kb(e.deltaX,e.deltaY);var c,l,h=Jb(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=h.x,e.overallVelocityY=h.y,e.overallVelocity=lb(h.x)>lb(h.y)?h.x:h.y,e.scale=a?(c=a.pointers,Hb((l=n)[0],l[1],Wb)/Hb(c[0],c[1],Wb)):1,e.rotation=a?function(t,e){return $b(e[1],e[0],Wb)+$b(t[1],t[0],Wb)}(a.pointers,n):0,e.maxPointers=r.prevInput?e.pointers.length>r.prevInput.maxPointers?e.pointers.length:r.prevInput.maxPointers:e.pointers.length,function(t,e){var r,n,i,o,a=t.lastInterval||e,s=e.timeStamp-a.timeStamp;if(e.eventType!==Pb&&(s>Ob||void 0===a.velocity)){var u=e.deltaX-a.deltaX,c=e.deltaY-a.deltaY,l=Jb(s,u,c);n=l.x,i=l.y,r=lb(l.x)>lb(l.y)?l.x:l.y,o=Kb(u,c),t.lastInterval=e}else r=a.velocity,n=a.velocityX,i=a.velocityY,o=a.direction;e.velocity=r,e.velocityX=n,e.velocityY=i,e.direction=o}(r,e);var f,p=t.element,d=e.srcEvent;Ub(f=d.composedPath?d.composedPath()[0]:d.path?d.path[0]:d.target,p)&&(p=f),e.target=p}function tw(t,e,r){var n=r.pointers.length,i=r.changedPointers.length,o=e&Cb&&n-i==0,a=e&(Lb|Pb)&&n-i==0;r.isFirst=!!o,r.isFinal=!!a,o&&(t.session={}),r.eventType=e,Qb(t,r),t.emit("hammer.input",r),t.recognize(r),t.session.prevInput=r}function ew(t){return t.trim().split(/\s+/g)}function rw(t,e,r){Yb(ew(e),(function(e){t.addEventListener(e,r,!1)}))}function nw(t,e,r){Yb(ew(e),(function(e){t.removeEventListener(e,r,!1)}))}function iw(t){var e=t.ownerDocument||t;return e.defaultView||e.parentWindow||window}var ow=function(){function t(t,e){var r=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){Gb(t.options.enable,[t])&&r.handler(e)},this.init()}var e=t.prototype;return e.handler=function(){},e.init=function(){this.evEl&&rw(this.element,this.evEl,this.domHandler),this.evTarget&&rw(this.target,this.evTarget,this.domHandler),this.evWin&&rw(iw(this.element),this.evWin,this.domHandler)},e.destroy=function(){this.evEl&&nw(this.element,this.evEl,this.domHandler),this.evTarget&&nw(this.target,this.evTarget,this.domHandler),this.evWin&&nw(iw(this.element),this.evWin,this.domHandler)},t}();function aw(t,e,r){if(t.indexOf&&!r)return t.indexOf(e);for(var n=0;n<t.length;){if(r&&t[n][r]==e||!r&&t[n]===e)return n;n++}return-1}var sw={pointerdown:Cb,pointermove:Ab,pointerup:Lb,pointercancel:Pb,pointerout:Pb},uw={2:Eb,3:"pen",4:kb,5:"kinect"},cw="pointerdown",lw="pointermove pointerup pointercancel";ib.MSPointerEvent&&!ib.PointerEvent&&(cw="MSPointerDown",lw="MSPointerMove MSPointerUp MSPointerCancel");var hw=function(t){function e(){var r,n=e.prototype;return n.evEl=cw,n.evWin=lw,(r=t.apply(this,arguments)||this).store=r.manager.session.pointerEvents=[],r}return rb(e,t),e.prototype.handler=function(t){var e=this.store,r=!1,n=t.type.toLowerCase().replace("ms",""),i=sw[n],o=uw[t.pointerType]||t.pointerType,a=o===Eb,s=aw(e,t.pointerId,"pointerId");i&Cb&&(0===t.button||a)?s<0&&(e.push(t),s=e.length-1):i&(Lb|Pb)&&(r=!0),s<0||(e[s]=t,this.callback(this.manager,i,{pointers:e,changedPointers:[t],pointerType:o,srcEvent:t}),r&&e.splice(s,1))},e}(ow);function fw(t){return Array.prototype.slice.call(t,0)}function pw(t,e,r){for(var n=[],i=[],o=0;o<t.length;){var a=e?t[o][e]:t[o];aw(i,a)<0&&n.push(t[o]),i[o]=a,o++}return r&&(n=e?n.sort((function(t,r){return t[e]>r[e]})):n.sort()),n}var dw={touchstart:Cb,touchmove:Ab,touchend:Lb,touchcancel:Pb},vw="touchstart touchmove touchend touchcancel",yw=function(t){function e(){var r;return e.prototype.evTarget=vw,(r=t.apply(this,arguments)||this).targetIds={},r}return rb(e,t),e.prototype.handler=function(t){var e=dw[t.type],r=gw.call(this,t,e);r&&this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:Eb,srcEvent:t})},e}(ow);function gw(t,e){var r,n,i=fw(t.touches),o=this.targetIds;if(e&(Cb|Ab)&&1===i.length)return o[i[0].identifier]=!0,[i,i];var a=fw(t.changedTouches),s=[],u=this.target;if(n=i.filter((function(t){return Ub(t.target,u)})),e===Cb)for(r=0;r<n.length;)o[n[r].identifier]=!0,r++;for(r=0;r<a.length;)o[a[r].identifier]&&s.push(a[r]),e&(Lb|Pb)&&delete o[a[r].identifier],r++;return s.length?[pw(n.concat(s),"identifier",!0),s]:void 0}var mw={mousedown:Cb,mousemove:Ab,mouseup:Lb},xw="mousedown",bw="mousemove mouseup",ww=function(t){function e(){var r,n=e.prototype;return n.evEl=xw,n.evWin=bw,(r=t.apply(this,arguments)||this).pressed=!1,r}return rb(e,t),e.prototype.handler=function(t){var e=mw[t.type];e&Cb&&0===t.button&&(this.pressed=!0),e&Ab&&1!==t.which&&(e=Lb),this.pressed&&(e&Lb&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:kb,srcEvent:t}))},e}(ow),_w=2500,Sw=25;function Tw(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var r={x:e.clientX,y:e.clientY},n=this.lastTouches;this.lastTouches.push(r);setTimeout((function(){var t=n.indexOf(r);t>-1&&n.splice(t,1)}),_w)}}function Ew(t,e){t&Cb?(this.primaryTouch=e.changedPointers[0].identifier,Tw.call(this,e)):t&(Lb|Pb)&&Tw.call(this,e)}function kw(t){for(var e=t.srcEvent.clientX,r=t.srcEvent.clientY,n=0;n<this.lastTouches.length;n++){var i=this.lastTouches[n],o=Math.abs(e-i.x),a=Math.abs(r-i.y);if(o<=Sw&&a<=Sw)return!0}return!1}var Ow=function(){return function(t){function e(e,r){var n;return(n=t.call(this,e,r)||this).handler=function(t,e,r){var i=r.pointerType===Eb,o=r.pointerType===kb;if(!(o&&r.sourceCapabilities&&r.sourceCapabilities.firesTouchEvents)){if(i)Ew.call(nb(nb(n)),e,r);else if(o&&kw.call(nb(nb(n)),r))return;n.callback(t,e,r)}},n.touch=new yw(n.manager,n.handler),n.mouse=new ww(n.manager,n.handler),n.primaryTouch=null,n.lastTouches=[],n}return rb(e,t),e.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(ow)}();function Cw(t,e,r){return!!Array.isArray(t)&&(Yb(t,r[e],r),!0)}var Aw=1,Lw=2,Pw=4,Dw=8,Mw=Dw,Rw=16,Iw=32,jw=1;function zw(t,e){var r=e.manager;return r?r.get(t):t}function Fw(t){return t&Rw?"cancel":t&Dw?"end":t&Pw?"move":t&Lw?"start":""}var Nw=function(){function t(t){void 0===t&&(t={}),this.options=eb({enable:!0},t),this.id=jw++,this.manager=null,this.state=Aw,this.simultaneous={},this.requireFail=[]}var e=t.prototype;return e.set=function(t){return ob(this.options,t),this.manager&&this.manager.touchAction.update(),this},e.recognizeWith=function(t){if(Cw(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=zw(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},e.dropRecognizeWith=function(t){return Cw(t,"dropRecognizeWith",this)||(t=zw(t,this),delete this.simultaneous[t.id]),this},e.requireFailure=function(t){if(Cw(t,"requireFailure",this))return this;var e=this.requireFail;return-1===aw(e,t=zw(t,this))&&(e.push(t),t.requireFailure(this)),this},e.dropRequireFailure=function(t){if(Cw(t,"dropRequireFailure",this))return this;t=zw(t,this);var e=aw(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},e.hasRequireFailures=function(){return this.requireFail.length>0},e.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},e.emit=function(t){var e=this,r=this.state;function n(r){e.manager.emit(r,t)}r<Dw&&n(e.options.event+Fw(r)),n(e.options.event),t.additionalEvent&&n(t.additionalEvent),r>=Dw&&n(e.options.event+Fw(r))},e.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=Iw},e.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(this.requireFail[t].state&(Iw|Aw)))return!1;t++}return!0},e.recognize=function(t){var e=ob({},t);if(!Gb(this.options.enable,[this,e]))return this.reset(),void(this.state=Iw);this.state&(Mw|Rw|Iw)&&(this.state=Aw),this.state=this.process(e),this.state&(Lw|Pw|Dw|Rw)&&this.tryEmit(e)},e.process=function(t){},e.getTouchAction=function(){},e.reset=function(){},t}(),Bw=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,eb({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},e))||this).pTime=!1,r.pCenter=!1,r._timer=null,r._input=null,r.count=0,r}rb(e,t);var r=e.prototype;return r.getTouchAction=function(){return[gb]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,i=t.distance<r.threshold,o=t.deltaTime<r.time;if(this.reset(),t.eventType&Cb&&0===this.count)return this.failTimeout();if(i&&o&&n){if(t.eventType!==Lb)return this.failTimeout();var a=!this.pTime||t.timeStamp-this.pTime<r.interval,s=!this.pCenter||Hb(this.pCenter,t.center)<r.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,s&&a?this.count+=1:this.count=1,this._input=t,0===this.count%r.taps)return this.hasRequireFailures()?(this._timer=setTimeout((function(){e.state=Mw,e.tryEmit()}),r.interval),Lw):Mw}return Iw},r.failTimeout=function(){var t=this;return this._timer=setTimeout((function(){t.state=Iw}),this.options.interval),Iw},r.reset=function(){clearTimeout(this._timer)},r.emit=function(){this.state===Mw&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},e}(Nw),Ww=function(t){function e(e){return void 0===e&&(e={}),t.call(this,eb({pointers:1},e))||this}rb(e,t);var r=e.prototype;return r.attrTest=function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},r.process=function(t){var e=this.state,r=t.eventType,n=e&(Lw|Pw),i=this.attrTest(t);return n&&(r&Pb||!i)?e|Rw:n||i?r&Lb?e|Dw:e&Lw?e|Pw:Lw:Iw},e}(Nw);function Yw(t){return t===jb?"down":t===Ib?"up":t===Mb?"left":t===Rb?"right":""}var Gw=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,eb({event:"pan",threshold:10,pointers:1,direction:Nb},e))||this).pX=null,r.pY=null,r}rb(e,t);var r=e.prototype;return r.getTouchAction=function(){var t=this.options.direction,e=[];return t&zb&&e.push(bb),t&Fb&&e.push(xb),e},r.directionTest=function(t){var e=this.options,r=!0,n=t.distance,i=t.direction,o=t.deltaX,a=t.deltaY;return i&e.direction||(e.direction&zb?(i=0===o?Db:o<0?Mb:Rb,r=o!==this.pX,n=Math.abs(t.deltaX)):(i=0===a?Db:a<0?Ib:jb,r=a!==this.pY,n=Math.abs(t.deltaY))),t.direction=i,r&&n>e.threshold&&i&e.direction},r.attrTest=function(t){return Ww.prototype.attrTest.call(this,t)&&(this.state&Lw||!(this.state&Lw)&&this.directionTest(t))},r.emit=function(e){this.pX=e.deltaX,this.pY=e.deltaY;var r=Yw(e.direction);r&&(e.additionalEvent=this.options.event+r),t.prototype.emit.call(this,e)},e}(Ww),Xw=function(t){function e(e){return void 0===e&&(e={}),t.call(this,eb({event:"swipe",threshold:10,velocity:.3,direction:zb|Fb,pointers:1},e))||this}rb(e,t);var r=e.prototype;return r.getTouchAction=function(){return Gw.prototype.getTouchAction.call(this)},r.attrTest=function(e){var r,n=this.options.direction;return n&(zb|Fb)?r=e.overallVelocity:n&zb?r=e.overallVelocityX:n&Fb&&(r=e.overallVelocityY),t.prototype.attrTest.call(this,e)&&n&e.offsetDirection&&e.distance>this.options.threshold&&e.maxPointers===this.options.pointers&&lb(r)>this.options.velocity&&e.eventType&Lb},r.emit=function(t){var e=Yw(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)},e}(Ww),Vw=function(t){function e(e){return void 0===e&&(e={}),t.call(this,eb({event:"pinch",threshold:0,pointers:2},e))||this}rb(e,t);var r=e.prototype;return r.getTouchAction=function(){return[mb]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.scale-1)>this.options.threshold||this.state&Lw)},r.emit=function(e){if(1!==e.scale){var r=e.scale<1?"in":"out";e.additionalEvent=this.options.event+r}t.prototype.emit.call(this,e)},e}(Ww),Uw=function(t){function e(e){return void 0===e&&(e={}),t.call(this,eb({event:"rotate",threshold:0,pointers:2},e))||this}rb(e,t);var r=e.prototype;return r.getTouchAction=function(){return[mb]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.rotation)>this.options.threshold||this.state&Lw)},e}(Ww),Zw=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,eb({event:"press",pointers:1,time:251,threshold:9},e))||this)._timer=null,r._input=null,r}rb(e,t);var r=e.prototype;return r.getTouchAction=function(){return[yb]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,i=t.distance<r.threshold,o=t.deltaTime>r.time;if(this._input=t,!i||!n||t.eventType&(Lb|Pb)&&!o)this.reset();else if(t.eventType&Cb)this.reset(),this._timer=setTimeout((function(){e.state=Mw,e.tryEmit()}),r.time);else if(t.eventType&Lb)return Mw;return Iw},r.reset=function(){clearTimeout(this._timer)},r.emit=function(t){this.state===Mw&&(t&&t.eventType&Lb?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=hb(),this.manager.emit(this.options.event,this._input)))},e}(Nw),qw={domEvents:!1,touchAction:vb,enable:!0,inputTarget:null,inputClass:null,cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}},Hw=[[Uw,{enable:!1}],[Vw,{enable:!1},["rotate"]],[Xw,{direction:zb}],[Gw,{direction:zb},["swipe"]],[Bw],[Bw,{event:"doubletap",taps:2},["tap"]],[Zw]];function $w(t,e){var r,n=t.element;n.style&&(Yb(t.options.cssProps,(function(i,o){r=fb(n.style,o),e?(t.oldCssProps[r]=n.style[r],n.style[r]=i):n.style[r]=t.oldCssProps[r]||""})),e||(t.oldCssProps={}))}var Kw=function(){function t(t,e){var r,n=this;this.options=ob({},qw,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((r=this).options.inputClass||(Sb?hw:Tb?yw:_b?Ow:ww))(r,tw),this.touchAction=new Vb(this,this.options.touchAction),$w(this,!0),Yb(this.options.recognizers,(function(t){var e=n.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}var e=t.prototype;return e.set=function(t){return ob(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},e.stop=function(t){this.session.stopped=t?2:1},e.recognize=function(t){var e=this.session;if(!e.stopped){var r;this.touchAction.preventDefaults(t);var n=this.recognizers,i=e.curRecognizer;(!i||i&&i.state&Mw)&&(e.curRecognizer=null,i=null);for(var o=0;o<n.length;)r=n[o],2===e.stopped||i&&r!==i&&!r.canRecognizeWith(i)?r.reset():r.recognize(t),!i&&r.state&(Lw|Pw|Dw)&&(e.curRecognizer=r,i=r),o++}},e.get=function(t){if(t instanceof Nw)return t;for(var e=this.recognizers,r=0;r<e.length;r++)if(e[r].options.event===t)return e[r];return null},e.add=function(t){if(Cw(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},e.remove=function(t){if(Cw(t,"remove",this))return this;var e=this.get(t);if(t){var r=this.recognizers,n=aw(r,e);-1!==n&&(r.splice(n,1),this.touchAction.update())}return this},e.on=function(t,e){if(void 0===t||void 0===e)return this;var r=this.handlers;return Yb(ew(t),(function(t){r[t]=r[t]||[],r[t].push(e)})),this},e.off=function(t,e){if(void 0===t)return this;var r=this.handlers;return Yb(ew(t),(function(t){e?r[t]&&r[t].splice(aw(r[t],e),1):delete r[t]})),this},e.emit=function(t,e){this.options.domEvents&&function(t,e){var r=document.createEvent("Event");r.initEvent(t,!0,!0),r.gesture=e,e.target.dispatchEvent(r)}(t,e);var r=this.handlers[t]&&this.handlers[t].slice();if(r&&r.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var n=0;n<r.length;)r[n](e),n++}},e.destroy=function(){this.element&&$w(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},t}(),Jw={touchstart:Cb,touchmove:Ab,touchend:Lb,touchcancel:Pb},Qw="touchstart",t_="touchstart touchmove touchend touchcancel",e_=function(t){function e(){var r,n=e.prototype;return n.evTarget=Qw,n.evWin=t_,(r=t.apply(this,arguments)||this).started=!1,r}return rb(e,t),e.prototype.handler=function(t){var e=Jw[t.type];if(e===Cb&&(this.started=!0),this.started){var r=r_.call(this,t,e);e&(Lb|Pb)&&r[0].length-r[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:Eb,srcEvent:t})}},e}(ow);function r_(t,e){var r=fw(t.touches),n=fw(t.changedTouches);return e&(Lb|Pb)&&(r=pw(r.concat(n),"identifier",!0)),[r,n]}function n_(t,e,r){var n="DEPRECATED METHOD: "+e+"\n"+r+" AT \n";return function(){var e=new Error("get-stack-trace"),r=e&&e.stack?e.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",i=window.console&&(window.console.warn||window.console.log);return i&&i.call(window.console,n,r),t.apply(this,arguments)}}var i_=n_((function(t,e,r){for(var n=Object.keys(e),i=0;i<n.length;)(!r||r&&void 0===t[n[i]])&&(t[n[i]]=e[n[i]]),i++;return t}),"extend","Use `assign`."),o_=n_((function(t,e){return i_(t,e,!0)}),"merge","Use `assign`.");function a_(t,e,r){var n,i=e.prototype;(n=t.prototype=Object.create(i)).constructor=t,n._super=i,r&&ob(n,r)}function s_(t,e){return function(){return t.apply(e,arguments)}}var u_=function(){var t=function(t,e){return void 0===e&&(e={}),new Kw(t,eb({recognizers:Hw.concat()},e))};return t.VERSION="2.0.17-rc",t.DIRECTION_ALL=Nb,t.DIRECTION_DOWN=jb,t.DIRECTION_LEFT=Mb,t.DIRECTION_RIGHT=Rb,t.DIRECTION_UP=Ib,t.DIRECTION_HORIZONTAL=zb,t.DIRECTION_VERTICAL=Fb,t.DIRECTION_NONE=Db,t.DIRECTION_DOWN=jb,t.INPUT_START=Cb,t.INPUT_MOVE=Ab,t.INPUT_END=Lb,t.INPUT_CANCEL=Pb,t.STATE_POSSIBLE=Aw,t.STATE_BEGAN=Lw,t.STATE_CHANGED=Pw,t.STATE_ENDED=Dw,t.STATE_RECOGNIZED=Mw,t.STATE_CANCELLED=Rw,t.STATE_FAILED=Iw,t.Manager=Kw,t.Input=ow,t.TouchAction=Vb,t.TouchInput=yw,t.MouseInput=ww,t.PointerEventInput=hw,t.TouchMouseInput=Ow,t.SingleTouchInput=e_,t.Recognizer=Nw,t.AttrRecognizer=Ww,t.Tap=Bw,t.Pan=Gw,t.Swipe=Xw,t.Pinch=Vw,t.Rotate=Uw,t.Press=Zw,t.on=rw,t.off=nw,t.each=Yb,t.merge=o_,t.extend=i_,t.bindFn=s_,t.assign=ob,t.inherit=a_,t.bindFn=s_,t.prefixed=fb,t.toArray=fw,t.inArray=aw,t.uniqueArray=pw,t.splitStr=ew,t.boolOrFn=Gb,t.hasParent=Ub,t.addEventListeners=rw,t.removeEventListeners=nw,t.defaults=ob({},qw,{preset:Hw}),t}();function c_(t,e){var r=void 0!==qy&&Ud(t)||t["@@iterator"];if(!r){if($f(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return l_(t,e);var n=$y(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Wd(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return l_(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,s=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){s=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw o}}}}function l_(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}var h_=qy("DELETE");function f_(){var t=p_.apply(void 0,arguments);return v_(t),t}function p_(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];if(e.length<2)return e[0];var n;if(e.length>2)return p_.apply(void 0,up(n=[f_(e[0],e[1])]).call(n,Uy($y(e).call(e,2))));var i,o=e[0],a=e[1],s=c_(tg(a));try{for(s.s();!(i=s.n()).done;){var u=i.value;Object.prototype.propertyIsEnumerable.call(a,u)&&(a[u]===h_?delete o[u]:null===o[u]||null===a[u]||"object"!==El(o[u])||"object"!==El(a[u])||$f(o[u])||$f(a[u])?o[u]=d_(a[u]):o[u]=p_(o[u],a[u]))}}catch(t){s.e(t)}finally{s.f()}return o}function d_(t){return $f(t)?cg(t).call(t,(function(t){return d_(t)})):"object"===El(t)&&null!==t?p_({},t):t}function v_(t){for(var e=0,r=vg(t);e<r.length;e++){var n=r[e];t[n]===h_?delete t[n]:"object"===El(t[n])&&null!==t[n]&&v_(t[n])}}var y_="undefined"!=typeof window?window.Hammer||u_:function(){return function(){var t=function(){};return{on:t,off:t,destroy:t,emit:t,get:function(){return{set:t}}}}()};function g_(t){var e,r=this;this._cleanupQueue=[],this.active=!1,this._dom={container:t,overlay:document.createElement("div")},this._dom.overlay.classList.add("vis-overlay"),this._dom.container.appendChild(this._dom.overlay),this._cleanupQueue.push((function(){r._dom.overlay.parentNode.removeChild(r._dom.overlay)}));var n=y_(this._dom.overlay);n.on("tap",Yg(e=this._onTapOverlay).call(e,this)),this._cleanupQueue.push((function(){n.destroy()}));var i=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];Uf(i).call(i,(function(t){n.on(t,(function(t){t.srcEvent.stopPropagation()}))})),document&&document.body&&(this._onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||r.deactivate()},document.body.addEventListener("click",this._onClick),this._cleanupQueue.push((function(){document.body.removeEventListener("click",r._onClick)}))),this._escListener=function(t){("key"in t?"Escape"===t.key:27===t.keyCode)&&r.deactivate()}}Kp(g_.prototype),g_.current=null,g_.prototype.destroy=function(){var t,e;this.deactivate();var r,n=c_(tm(t=km(e=this._cleanupQueue).call(e,0)).call(t));try{for(n.s();!(r=n.n()).done;){(0,r.value)()}}catch(t){n.e(t)}finally{n.f()}},g_.prototype.activate=function(){g_.current&&g_.current.deactivate(),g_.current=this,this.active=!0,this._dom.overlay.style.display="none",this._dom.container.classList.add("vis-active"),this.emit("change"),this.emit("activate"),document.body.addEventListener("keydown",this._escListener)},g_.prototype.deactivate=function(){this.active=!1,this._dom.overlay.style.display="block",this._dom.container.classList.remove("vis-active"),document.body.removeEventListener("keydown",this._escListener),this.emit("change"),this.emit("deactivate")},g_.prototype._onTapOverlay=function(t){this.activate(),t.srcEvent.stopPropagation()};var m_=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,x_=/^#?([a-f\d])([a-f\d])([a-f\d])$/i;function b_(t,e,r,n){var i=!1;!0===n&&(i=null===e[r]&&void 0!==t[r]),i?delete t[r]:t[r]=e[r]}function w_(t,e){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var i in e)if(Object.prototype.hasOwnProperty.call(e,i)||!0===r)if("object"===El(e[i])&&null!==e[i]&&nx(e[i])===Object.prototype)void 0===t[i]?t[i]=w_({},e[i],r):"object"===El(t[i])&&null!==t[i]&&nx(t[i])===Object.prototype?w_(t[i],e[i],r):b_(t,e,i,n);else if($f(e[i])){var o;t[i]=$y(o=e[i]).call(o)}else b_(t,e,i,n);return t}function __(t,e){var r;return up(r=[]).call(r,Uy(t),[e])}function S_(t,e,r,n){var i;t.addEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&$m(i=navigator.userAgent).call(i,"Firefox")&&(e="DOMMouseScroll"),t.addEventListener(e,r,n)):t.attachEvent("on"+e,r)}function T_(t,e,r,n){var i;t.removeEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&$m(i=navigator.userAgent).call(i,"Firefox")&&(e="DOMMouseScroll"),t.removeEventListener(e,r,n)):t.detachEvent("on"+e,r)}function E_(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)}function k_(t,e,r){var n,i,o,a=Math.floor(6*t),s=6*t-a,u=r*(1-e),c=r*(1-s*e),l=r*(1-(1-s)*e);switch(a%6){case 0:n=r,i=l,o=u;break;case 1:n=c,i=r,o=u;break;case 2:n=u,i=r,o=l;break;case 3:n=u,i=c,o=r;break;case 4:n=l,i=u,o=r;break;case 5:n=r,i=u,o=c}return{r:Math.floor(255*n),g:Math.floor(255*i),b:Math.floor(255*o)}}var O_,C_=!1,A_="background: #FFeeee; color: #dd0000",L_=function(){function t(){Uv(this,t)}return ay(t,null,[{key:"validate",value:function(e,r,n){C_=!1,O_=r;var i=r;return void 0!==n&&(i=r[n]),t.parse(e,i,[]),C_}},{key:"parse",value:function(e,r,n){for(var i in e)Object.prototype.hasOwnProperty.call(e,i)&&t.check(i,e,r,n)}},{key:"check",value:function(e,r,n,i){if(void 0!==n[e]||void 0!==n.__any__){var o=e,a=!0;void 0===n[e]&&void 0!==n.__any__&&(o="__any__",a="object"===t.getType(r[e]));var s=n[o];a&&void 0!==s.__type__&&(s=s.__type__),t.checkFields(e,r,n,o,s,i)}else t.getSuggestion(e,n,i)}},{key:"checkFields",value:function(e,r,n,i,o,a){var s=function(r){console.error("%c"+r+t.printLocation(a,e),A_)},u=t.getType(r[e]),c=o[u];void 0!==c?"array"===t.getType(c)&&-1===Ph(c).call(c,r[e])?(s('Invalid option detected in "'+e+'". Allowed values are:'+t.print(c)+' not "'+r[e]+'". '),C_=!0):"object"===u&&"__any__"!==i&&(a=__(a,e),t.parse(r[e],n[i],a)):void 0===o.any&&(s('Invalid type received for "'+e+'". Expected: '+t.print(vg(o))+". Received ["+u+'] "'+r[e]+'"'),C_=!0)}},{key:"getType",value:function(t){var e=El(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":$f(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,r,n){var i,o=t.findInOptions(e,r,n,!1),a=t.findInOptions(e,O_,[],!0);i=void 0!==o.indexMatch?" in "+t.printLocation(o.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+o.indexMatch+'"?\n\n':a.distance<=4&&o.distance>a.distance?" in "+t.printLocation(o.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(a.path,a.closestMatch,""):o.distance<=8?'. Did you mean "'+o.closestMatch+'"?'+t.printLocation(o.path,e):". Did you mean one of these: "+t.print(vg(r))+t.printLocation(n,e),console.error('%cUnknown option detected: "'+e+'"'+i,A_),C_=!0}},{key:"findInOptions",value:function(e,r,n){var i,o=arguments.length>3&&void 0!==arguments[3]&&arguments[3],a=1e9,s="",u=[],c=e.toLowerCase(),l=void 0;for(var h in r){var f=void 0;if(void 0!==r[h].__type__&&!0===o){var p=t.findInOptions(e,r[h],__(n,h));a>p.distance&&(s=p.closestMatch,u=p.path,a=p.distance,l=p.indexMatch)}else{var d;-1!==Ph(d=h.toLowerCase()).call(d,c)&&(l=h),a>(f=t.levenshteinDistance(e,h))&&(s=h,u=$y(i=n).call(i),a=f)}}return{closestMatch:s,path:u,distance:a,indexMatch:l}}},{key:"printLocation",value:function(t,e){for(var r="\n\n"+(arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n")+"options = {\n",n=0;n<t.length;n++){for(var i=0;i<n+1;i++)r+="  ";r+=t[n]+": {\n"}for(var o=0;o<t.length+1;o++)r+="  ";r+=e+"\n";for(var a=0;a<t.length+1;a++){for(var s=0;s<t.length-a;s++)r+="  ";r+="}\n"}return r+"\n\n"}},{key:"print",value:function(t){return tb(t).replace(/(")|(\[)|(\])|(,"__type__")/g,"").replace(/(,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var r,n,i=[];for(r=0;r<=e.length;r++)i[r]=[r];for(n=0;n<=t.length;n++)i[0][n]=n;for(r=1;r<=e.length;r++)for(n=1;n<=t.length;n++)e.charAt(r-1)==t.charAt(n-1)?i[r][n]=i[r-1][n-1]:i[r][n]=Math.min(i[r-1][n-1]+1,Math.min(i[r][n-1]+1,i[r-1][n]+1));return i[e.length][t.length]}}]),t}(),P_=A_,D_=L_;function M_(t,e,r){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0,this.z=void 0!==r?r:0}M_.subtract=function(t,e){var r=new M_;return r.x=t.x-e.x,r.y=t.y-e.y,r.z=t.z-e.z,r},M_.add=function(t,e){var r=new M_;return r.x=t.x+e.x,r.y=t.y+e.y,r.z=t.z+e.z,r},M_.avg=function(t,e){return new M_((t.x+e.x)/2,(t.y+e.y)/2,(t.z+e.z)/2)},M_.scalarProduct=function(t,e){return new M_(t.x*e,t.y*e,t.z*e)},M_.dotProduct=function(t,e){return t.x*e.x+t.y*e.y+t.z*e.z},M_.crossProduct=function(t,e){var r=new M_;return r.x=t.y*e.z-t.z*e.y,r.y=t.z*e.x-t.x*e.z,r.z=t.x*e.y-t.y*e.x,r},M_.prototype.length=function(){return Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z)},M_.prototype.normalize=function(){return M_.scalarProduct(this,1/this.length())};var R_=M_;var I_=function(t,e){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0};function j_(t,e){if(void 0===t)throw new Error("No container element defined");if(this.container=t,this.visible=!e||null==e.visible||e.visible,this.visible){this.frame=document.createElement("DIV"),this.frame.style.width="100%",this.frame.style.position="relative",this.container.appendChild(this.frame),this.frame.prev=document.createElement("INPUT"),this.frame.prev.type="BUTTON",this.frame.prev.value="Prev",this.frame.appendChild(this.frame.prev),this.frame.play=document.createElement("INPUT"),this.frame.play.type="BUTTON",this.frame.play.value="Play",this.frame.appendChild(this.frame.play),this.frame.next=document.createElement("INPUT"),this.frame.next.type="BUTTON",this.frame.next.value="Next",this.frame.appendChild(this.frame.next),this.frame.bar=document.createElement("INPUT"),this.frame.bar.type="BUTTON",this.frame.bar.style.position="absolute",this.frame.bar.style.border="1px solid red",this.frame.bar.style.width="100px",this.frame.bar.style.height="6px",this.frame.bar.style.borderRadius="2px",this.frame.bar.style.MozBorderRadius="2px",this.frame.bar.style.border="1px solid #7F7F7F",this.frame.bar.style.backgroundColor="#E5E5E5",this.frame.appendChild(this.frame.bar),this.frame.slide=document.createElement("INPUT"),this.frame.slide.type="BUTTON",this.frame.slide.style.margin="0px",this.frame.slide.value=" ",this.frame.slide.style.position="relative",this.frame.slide.style.left="-100px",this.frame.appendChild(this.frame.slide);var r=this;this.frame.slide.onmousedown=function(t){r._onMouseDown(t)},this.frame.prev.onclick=function(t){r.prev(t)},this.frame.play.onclick=function(t){r.togglePlay(t)},this.frame.next.onclick=function(t){r.next(t)}}this.onChangeCallback=void 0,this.values=[],this.index=void 0,this.playTimeout=void 0,this.playInterval=1e3,this.playLoop=!0}function z_(t,e,r,n){this._start=0,this._end=0,this._step=1,this.prettyStep=!0,this.precision=5,this._current=0,this.setRange(t,e,r,n)}j_.prototype.prev=function(){var t=this.getIndex();t>0&&(t--,this.setIndex(t))},j_.prototype.next=function(){var t=this.getIndex();t<Mf(this).length-1&&(t++,this.setIndex(t))},j_.prototype.playNext=function(){var t=new Date,e=this.getIndex();e<Mf(this).length-1?(e++,this.setIndex(e)):this.playLoop&&(e=0,this.setIndex(e));var r=new Date-t,n=Math.max(this.playInterval-r,0),i=this;this.playTimeout=Pp((function(){i.playNext()}),n)},j_.prototype.togglePlay=function(){void 0===this.playTimeout?this.play():this.stop()},j_.prototype.play=function(){this.playTimeout||(this.playNext(),this.frame&&(this.frame.play.value="Stop"))},j_.prototype.stop=function(){clearInterval(this.playTimeout),this.playTimeout=void 0,this.frame&&(this.frame.play.value="Play")},j_.prototype.setOnChangeCallback=function(t){this.onChangeCallback=t},j_.prototype.setPlayInterval=function(t){this.playInterval=t},j_.prototype.getPlayInterval=function(){return this.playInterval},j_.prototype.setPlayLoop=function(t){this.playLoop=t},j_.prototype.onChange=function(){void 0!==this.onChangeCallback&&this.onChangeCallback()},j_.prototype.redraw=function(){if(this.frame){this.frame.bar.style.top=this.frame.clientHeight/2-this.frame.bar.offsetHeight/2+"px",this.frame.bar.style.width=this.frame.clientWidth-this.frame.prev.clientWidth-this.frame.play.clientWidth-this.frame.next.clientWidth-30+"px";var t=this.indexToLeft(this.index);this.frame.slide.style.left=t+"px"}},j_.prototype.setValues=function(t){this.values=t,Mf(this).length>0?this.setIndex(0):this.index=void 0},j_.prototype.setIndex=function(t){if(!(t<Mf(this).length))throw new Error("Index out of range");this.index=t,this.redraw(),this.onChange()},j_.prototype.getIndex=function(){return this.index},j_.prototype.get=function(){return Mf(this)[this.index]},j_.prototype._onMouseDown=function(t){if(t.which?1===t.which:1===t.button){this.startClientX=t.clientX,this.startSlideX=lf(this.frame.slide.style.left),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},S_(document,"mousemove",this.onmousemove),S_(document,"mouseup",this.onmouseup),E_(t)}},j_.prototype.leftToIndex=function(t){var e=lf(this.frame.bar.style.width)-this.frame.slide.clientWidth-10,r=t-3,n=Math.round(r/e*(Mf(this).length-1));return n<0&&(n=0),n>Mf(this).length-1&&(n=Mf(this).length-1),n},j_.prototype.indexToLeft=function(t){var e=lf(this.frame.bar.style.width)-this.frame.slide.clientWidth-10;return t/(Mf(this).length-1)*e+3},j_.prototype._onMouseMove=function(t){var e=t.clientX-this.startClientX,r=this.startSlideX+e,n=this.leftToIndex(r);this.setIndex(n),E_()},j_.prototype._onMouseUp=function(){this.frame.style.cursor="auto",T_(document,"mousemove",this.onmousemove),T_(document,"mouseup",this.onmouseup),E_()},z_.prototype.isNumeric=function(t){return!isNaN(lf(t))&&isFinite(t)},z_.prototype.setRange=function(t,e,r,n){if(!this.isNumeric(t))throw new Error("Parameter 'start' is not numeric; value: "+t);if(!this.isNumeric(e))throw new Error("Parameter 'end' is not numeric; value: "+t);if(!this.isNumeric(r))throw new Error("Parameter 'step' is not numeric; value: "+t);this._start=t||0,this._end=e||0,this.setStep(r,n)},z_.prototype.setStep=function(t,e){void 0===t||t<=0||(void 0!==e&&(this.prettyStep=e),!0===this.prettyStep?this._step=z_.calculatePrettyStep(t):this._step=t)},z_.calculatePrettyStep=function(t){var e=function(t){return Math.log(t)/Math.LN10},r=Math.pow(10,Math.round(e(t))),n=2*Math.pow(10,Math.round(e(t/2))),i=5*Math.pow(10,Math.round(e(t/5))),o=r;return Math.abs(n-t)<=Math.abs(o-t)&&(o=n),Math.abs(i-t)<=Math.abs(o-t)&&(o=i),o<=0&&(o=1),o},z_.prototype.getCurrent=function(){return lf(this._current.toPrecision(this.precision))},z_.prototype.getStep=function(){return this._step},z_.prototype.start=function(t){void 0===t&&(t=!1),this._current=this._start-this._start%this._step,t&&this.getCurrent()<this._start&&this.next()},z_.prototype.next=function(){this._current+=this._step},z_.prototype.end=function(){return this._current>this._end};var F_=z_,N_={},B_={get exports(){return N_},set exports(t){N_=t}};Pr({target:"Math",stat:!0},{sign:Math.sign||function(t){var e=+t;return 0==e||e!=e?e:e<0?-1:1}});var W_=ot.Math.sign;!function(t){t.exports=W_}(B_);var Y_=r(N_);function G_(){this.armLocation=new R_,this.armRotation={},this.armRotation.horizontal=0,this.armRotation.vertical=0,this.armLength=1.7,this.cameraOffset=new R_,this.offsetMultiplier=.6,this.cameraLocation=new R_,this.cameraRotation=new R_(.5*Math.PI,0,0),this.calculateCameraOrientation()}G_.prototype.setOffset=function(t,e){var r=Math.abs,n=Y_,i=this.offsetMultiplier,o=this.armLength*i;r(t)>o&&(t=n(t)*o),r(e)>o&&(e=n(e)*o),this.cameraOffset.x=t,this.cameraOffset.y=e,this.calculateCameraOrientation()},G_.prototype.getOffset=function(){return this.cameraOffset},G_.prototype.setArmLocation=function(t,e,r){this.armLocation.x=t,this.armLocation.y=e,this.armLocation.z=r,this.calculateCameraOrientation()},G_.prototype.setArmRotation=function(t,e){void 0!==t&&(this.armRotation.horizontal=t),void 0!==e&&(this.armRotation.vertical=e,this.armRotation.vertical<0&&(this.armRotation.vertical=0),this.armRotation.vertical>.5*Math.PI&&(this.armRotation.vertical=.5*Math.PI)),void 0===t&&void 0===e||this.calculateCameraOrientation()},G_.prototype.getArmRotation=function(){var t={};return t.horizontal=this.armRotation.horizontal,t.vertical=this.armRotation.vertical,t},G_.prototype.setArmLength=function(t){void 0!==t&&(this.armLength=t,this.armLength<.71&&(this.armLength=.71),this.armLength>5&&(this.armLength=5),this.setOffset(this.cameraOffset.x,this.cameraOffset.y),this.calculateCameraOrientation())},G_.prototype.getArmLength=function(){return this.armLength},G_.prototype.getCameraLocation=function(){return this.cameraLocation},G_.prototype.getCameraRotation=function(){return this.cameraRotation},G_.prototype.calculateCameraOrientation=function(){this.cameraLocation.x=this.armLocation.x-this.armLength*Math.sin(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.y=this.armLocation.y-this.armLength*Math.cos(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.z=this.armLocation.z+this.armLength*Math.sin(this.armRotation.vertical),this.cameraRotation.x=Math.PI/2-this.armRotation.vertical,this.cameraRotation.y=0,this.cameraRotation.z=-this.armRotation.horizontal;var t=this.cameraRotation.x,e=this.cameraRotation.z,r=this.cameraOffset.x,n=this.cameraOffset.y,i=Math.sin,o=Math.cos;this.cameraLocation.x=this.cameraLocation.x+r*o(e)+n*-i(e)*o(t),this.cameraLocation.y=this.cameraLocation.y+r*i(e)+n*o(e)*o(t),this.cameraLocation.z=this.cameraLocation.z+n*i(t)};var X_={BAR:0,BARCOLOR:1,BARSIZE:2,DOT:3,DOTLINE:4,DOTCOLOR:5,DOTSIZE:6,GRID:7,LINE:8,SURFACE:9},V_={dot:X_.DOT,"dot-line":X_.DOTLINE,"dot-color":X_.DOTCOLOR,"dot-size":X_.DOTSIZE,line:X_.LINE,grid:X_.GRID,surface:X_.SURFACE,bar:X_.BAR,"bar-color":X_.BARCOLOR,"bar-size":X_.BARSIZE},U_=["width","height","filterLabel","legendLabel","xLabel","yLabel","zLabel","xValueLabel","yValueLabel","zValueLabel","showXAxis","showYAxis","showZAxis","showGrayBottom","showGrid","showPerspective","showShadow","showSurfaceGrid","keepAspectRatio","rotateAxisLabels","verticalRatio","dotSizeRatio","dotSizeMinFraction","dotSizeMaxFraction","showAnimationControls","animationInterval","animationPreload","animationAutoStart","axisColor","axisFontSize","axisFontType","gridColor","xCenter","yCenter","zoomable","tooltipDelay","ctrlToZoom"],Z_=["xBarWidth","yBarWidth","valueMin","valueMax","xMin","xMax","xStep","yMin","yMax","yStep","zMin","zMax","zStep"],q_=void 0;function H_(t){for(var e in t)if(Object.prototype.hasOwnProperty.call(t,e))return!1;return!0}function $_(t,e){return void 0===t||""===t?e:t+(void 0===(r=e)||""===r||"string"!=typeof r?r:r.charAt(0).toUpperCase()+$y(r).call(r,1));var r}function K_(t,e,r,n){for(var i,o=0;o<r.length;++o)e[$_(n,i=r[o])]=t[i]}function J_(t,e,r,n){for(var i,o=0;o<r.length;++o)void 0!==t[i=r[o]]&&(e[$_(n,i)]=t[i])}function Q_(t,e){if(void 0!==t.backgroundColor&&function(t,e){var r="white",n="gray",i=1;if("string"==typeof t)r=t,n="none",i=0;else{if("object"!==El(t))throw new Error("Unsupported type of backgroundColor");void 0!==_f(t)&&(r=_f(t)),void 0!==t.stroke&&(n=t.stroke),void 0!==t.strokeWidth&&(i=t.strokeWidth)}e.frame.style.backgroundColor=r,e.frame.style.borderColor=n,e.frame.style.borderWidth=i+"px",e.frame.style.borderStyle="solid"}(t.backgroundColor,e),function(t,e){if(void 0===t)return;void 0===e.dataColor&&(e.dataColor={});"string"==typeof t?(e.dataColor.fill=t,e.dataColor.stroke=t):(_f(t)&&(e.dataColor.fill=_f(t)),t.stroke&&(e.dataColor.stroke=t.stroke),void 0!==t.strokeWidth&&(e.dataColor.strokeWidth=t.strokeWidth))}(t.dataColor,e),function(t,e){if(void 0===t)return;var r;if("string"==typeof t){if(r=function(t){var e=V_[t];if(void 0===e)return-1;return e}(t),-1===r)throw new Error("Style '"+t+"' is invalid")}else{if(!function(t){var e=!1;for(var r in X_)if(X_[r]===t){e=!0;break}return e}(t))throw new Error("Style '"+t+"' is invalid");r=t}e.style=r}(t.style,e),void 0!==t.surfaceColors){if(console.warn("`options.surfaceColors` is deprecated and may be removed in a future version. Please use `options.colormap` instead. Note that the `colormap` option uses the inverse array ordering (running from vMin to vMax)."),void 0!==t.colormap)throw new Error("The `colormap` and `surfaceColors` options are mutually exclusive.");"surface"!==e.style?console.warn("Ignoring `surfaceColors` in graph style `"+e.style+"` for backward compatibility (only effective in `surface` plots)."):function(t,e){if(void 0===t||!0===t)return;if(!1===t)return void(e.surfaceColors=void 0);void 0===e.surfaceColors&&(e.surfaceColors={});var r;if($f(t))r=tS(t);else{if("object"!==El(t))throw new Error("Unsupported type of surfaceColors");r=eS(t.hue)}tm(r).call(r),e.colormap=r}(t.surfaceColors,e)}else!function(t,e){if(void 0===t)return;var r;if($f(t))r=tS(t);else if("object"===El(t))r=eS(t.hue);else{if("function"!=typeof t)throw new Error("Unsupported type of colormap");r=t}e.colormap=r}(t.colormap,e);!function(t,e){if(void 0===t){if(void 0===q_.showLegend){var r=e.style===X_.DOTCOLOR||e.style===X_.DOTSIZE;e.showLegend=r}}else e.showLegend=t}(t.showLegend,e),rS(t.cameraPosition,e),void 0!==t.tooltip&&(e.showTooltip=t.tooltip),null!=t.onclick&&(e.onclick_callback=t.onclick,console.warn("`options.onclick` is deprecated and may be removed in a future version. Please use `Graph3d.on('click', handler)` instead.")),void 0!==t.tooltipStyle&&function(t,e,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if($f(r))throw new TypeError("Arrays are not supported by deepExtend");for(var i=0;i<t.length;i++){var o=t[i];if(Object.prototype.hasOwnProperty.call(r,o))if(r[o]&&r[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?w_(e[o],r[o],!1,n):b_(e,r,o,n);else{if($f(r[o]))throw new TypeError("Arrays are not supported by deepExtend");b_(e,r,o,n)}}}(["tooltipStyle"],e,t)}function tS(t){if(t.length<2)throw new Error("Colormap array length must be 2 or above.");return cg(t).call(t,(function(t){if(!function(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}(t))throw new Error("Invalid hex color code supplied to colormap.");return function(t){var e;switch(t.length){case 3:case 4:return(e=x_.exec(t))?{r:Lx(e[1]+e[1],16),g:Lx(e[2]+e[2],16),b:Lx(e[3]+e[3],16)}:null;case 6:case 7:return(e=m_.exec(t))?{r:Lx(e[1],16),g:Lx(e[2],16),b:Lx(e[3],16)}:null;default:return null}}(t)}))}function eS(t){if(void 0===t)throw new Error("Unsupported type of colormap");if(!(t.saturation>=0&&t.saturation<=100))throw new Error("Saturation is out of bounds. Expected range is 0-100.");if(!(t.brightness>=0&&t.brightness<=100))throw new Error("Brightness is out of bounds. Expected range is 0-100.");if(!(t.colorStops>=2))throw new Error("colorStops is out of bounds. Expected 2 or above.");for(var e=(t.end-t.start)/(t.colorStops-1),r=[],n=0;n<t.colorStops;++n){var i=(t.start+e*n)%360/360;r.push(k_(i<0?i+1:i,t.saturation/100,t.brightness/100))}return r}function rS(t,e){var r=t;void 0!==r&&(void 0===e.camera&&(e.camera=new G_),e.camera.setArmRotation(r.horizontal,r.vertical),e.camera.setArmLength(r.distance))}var nS="string",iS="boolean",oS="number",aS="object",sS="array",uS={fill:{string:nS},stroke:{string:nS},strokeWidth:{number:oS},__type__:{string:nS,object:aS,undefined:"undefined"}},cS={animationAutoStart:{boolean:iS,undefined:"undefined"},animationInterval:{number:oS},animationPreload:{boolean:iS},axisColor:{string:nS},axisFontSize:{number:oS},axisFontType:{string:nS},backgroundColor:uS,xBarWidth:{number:oS,undefined:"undefined"},yBarWidth:{number:oS,undefined:"undefined"},cameraPosition:{distance:{number:oS},horizontal:{number:oS},vertical:{number:oS},__type__:{object:aS}},zoomable:{boolean:iS},ctrlToZoom:{boolean:iS},xCenter:{string:nS},yCenter:{string:nS},colormap:{hue:{start:{number:oS},end:{number:oS},saturation:{number:oS},brightness:{number:oS},colorStops:{number:oS},__type__:{object:aS}},__type__:{array:sS,object:aS,function:"function",undefined:"undefined"}},dataColor:uS,dotSizeMinFraction:{number:oS},dotSizeMaxFraction:{number:oS},dotSizeRatio:{number:oS},filterLabel:{string:nS},gridColor:{string:nS},onclick:{function:"function"},keepAspectRatio:{boolean:iS},xLabel:{string:nS},yLabel:{string:nS},zLabel:{string:nS},legendLabel:{string:nS},xMin:{number:oS,undefined:"undefined"},yMin:{number:oS,undefined:"undefined"},zMin:{number:oS,undefined:"undefined"},xMax:{number:oS,undefined:"undefined"},yMax:{number:oS,undefined:"undefined"},zMax:{number:oS,undefined:"undefined"},showAnimationControls:{boolean:iS,undefined:"undefined"},showGrayBottom:{boolean:iS},showGrid:{boolean:iS},showLegend:{boolean:iS,undefined:"undefined"},showPerspective:{boolean:iS},showShadow:{boolean:iS},showSurfaceGrid:{boolean:iS},showXAxis:{boolean:iS},showYAxis:{boolean:iS},showZAxis:{boolean:iS},rotateAxisLabels:{boolean:iS},surfaceColors:{hue:{start:{number:oS},end:{number:oS},saturation:{number:oS},brightness:{number:oS},colorStops:{number:oS},__type__:{object:aS}},__type__:{boolean:iS,array:sS,object:aS,undefined:"undefined"}},xStep:{number:oS,undefined:"undefined"},yStep:{number:oS,undefined:"undefined"},zStep:{number:oS,undefined:"undefined"},style:{number:oS,string:["bar","bar-color","bar-size","dot","dot-line","dot-color","dot-size","line","grid","surface"]},tooltip:{boolean:iS,function:"function"},tooltipDelay:{number:oS},tooltipStyle:{content:{color:{string:nS},background:{string:nS},border:{string:nS},borderRadius:{string:nS},boxShadow:{string:nS},padding:{string:nS},__type__:{object:aS}},line:{borderLeft:{string:nS},height:{string:nS},width:{string:nS},pointerEvents:{string:nS},__type__:{object:aS}},dot:{border:{string:nS},borderRadius:{string:nS},height:{string:nS},width:{string:nS},pointerEvents:{string:nS},__type__:{object:aS}},__type__:{object:aS}},xValueLabel:{function:"function"},yValueLabel:{function:"function"},zValueLabel:{function:"function"},valueMax:{number:oS,undefined:"undefined"},valueMin:{number:oS,undefined:"undefined"},verticalRatio:{number:oS},height:{string:nS},width:{string:nS},__type__:{object:aS}};function lS(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var hS={},fS={get exports(){return hS},set exports(t){hS=t}},pS={},dS=Vx;!function(t){t.exports=dS}({get exports(){return pS},set exports(t){pS=t}}),function(t){t.exports=pS}(fS);var vS=r(hS),yS={},gS={get exports(){return yS},set exports(t){yS=t}},mS={},xS={get exports(){return mS},set exports(t){mS=t}};Pr({target:"Object",stat:!0},{setPrototypeOf:Ju});var bS=ot.Object.setPrototypeOf;!function(t){t.exports=bS}(xS),function(t){t.exports=mS}(gS);var wS=r(yS),_S={},SS={get exports(){return _S},set exports(t){_S=t}},TS={},ES=Wg;!function(t){t.exports=ES}({get exports(){return TS},set exports(t){TS=t}}),function(t){t.exports=TS}(SS);var kS=r(_S);function OS(t,e){var r;return OS=wS?kS(r=wS).call(r):function(t,e){return t.__proto__=e,t},OS(t,e)}function CS(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=vS(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),Kv(t,"prototype",{writable:!1}),e&&OS(t,e)}var AS={},LS={get exports(){return AS},set exports(t){AS=t}},PS={},DS=rx;!function(t){t.exports=DS}({get exports(){return PS},set exports(t){PS=t}}),function(t){t.exports=PS}(LS);var MS=r(AS);function RS(t){var e;return RS=wS?kS(e=MS).call(e):function(t){return t.__proto__||MS(t)},RS(t)}var IS={},jS={get exports(){return IS},set exports(t){IS=t}},zS={};!function(t){var e=n,r=rl;function i(n){return t.exports=i="function"==typeof e&&"symbol"==typeof r?function(t){return typeof t}:function(t){return t&&"function"==typeof e&&t.constructor===e&&t!==e.prototype?"symbol":typeof t},t.exports.__esModule=!0,t.exports.default=t.exports,i(n)}t.exports=i,t.exports.__esModule=!0,t.exports.default=t.exports}({get exports(){return zS},set exports(t){zS=t}});var FS={},NS={get exports(){return FS},set exports(t){FS=t}},BS={},WS=Vf;!function(t){t.exports=WS}({get exports(){return BS},set exports(t){BS=t}}),function(t){t.exports=BS}(NS);var YS={},GS={get exports(){return YS},set exports(t){YS=t}},XS={},VS={get exports(){return XS},set exports(t){XS=t}},US=ee,ZS=gv,qS=D,HS=tr,$S=it,KS=xr,JS=Error,QS=b("".replace),tT=String(JS("zxcasd").stack),eT=/\n\s*at [^:]*:[^\n]*/,rT=eT.test(tT),nT=G,iT=!c((function(){var t=Error("a");return!("stack"in t)||(Object.defineProperty(t,"stack",nT(1,7)),7!==t.stack)})),oT=xr,aT=function(t,e){if(rT&&"string"==typeof t&&!JS.prepareStackTrace)for(;e--;)t=QS(t,eT,"");return t},sT=iT,uT=Error.captureStackTrace,cT=Qe,lT=j,hT=or,fT=Lt,pT=cd,dT=Wr,vT=ht,yT=_d,gT=vd,mT=nd,xT=TypeError,bT=function(t,e){this.stopped=t,this.result=e},wT=bT.prototype,_T=function(t,e,r){var n,i,o,a,s,u,c,l=r&&r.that,h=!(!r||!r.AS_ENTRIES),f=!(!r||!r.IS_RECORD),p=!(!r||!r.IS_ITERATOR),d=!(!r||!r.INTERRUPTED),v=cT(e,l),y=function(t){return n&&mT(n,"normal",t),new bT(!0,t)},g=function(t){return h?(hT(t),d?v(t[0],t[1],y):v(t[0],t[1])):d?v(t,y):v(t)};if(f)n=t.iterator;else if(p)n=t;else{if(!(i=gT(t)))throw xT(fT(t)+" is not iterable");if(pT(i)){for(o=0,a=dT(t);a>o;o++)if((s=g(t[o]))&&vT(wT,s))return s;return new bT(!1)}n=yT(t,i)}for(u=f?t.next:n.next;!(c=lT(u,n)).done;){try{s=g(c.value)}catch(t){mT(n,"throw",t)}if("object"==typeof s&&s&&vT(wT,s))return s}return new bT(!1)},ST=Hn,TT=Pr,ET=ht,kT=Ou,OT=Ju,CT=function(t,e,r){for(var n=ZS(e),i=HS.f,o=qS.f,a=0;a<n.length;a++){var s=n[a];US(t,s)||r&&US(r,s)||i(t,s,o(e,s))}},AT=Wi,LT=xr,PT=G,DT=function(t,e){$S(e)&&"cause"in e&&KS(t,"cause",e.cause)},MT=function(t,e,r,n){sT&&(uT?uT(t,e):oT(t,"stack",aT(r,n)))},RT=_T,IT=function(t,e){return void 0===t?arguments.length<2?"":e:ST(t)},jT=ve("toStringTag"),zT=Error,FT=[].push,NT=function(t,e){var r,n=ET(BT,this);OT?r=OT(zT(),n?kT(this):BT):(r=n?this:AT(BT),LT(r,jT,"Error")),void 0!==e&&LT(r,"message",IT(e)),MT(r,NT,r.stack,1),arguments.length>2&&DT(r,arguments[2]);var i=[];return RT(t,FT,{that:i}),LT(r,"errors",i),r};OT?OT(NT,zT):CT(NT,zT,{name:!0});var BT=NT.prototype=AT(zT.prototype,{constructor:PT(1,NT),message:PT(1,""),name:PT(1,"AggregateError")});TT({global:!0,constructor:!0,arity:2},{AggregateError:NT});var WT,YT,GT,XT,VT="undefined"!=typeof process&&"process"==T(process),UT=lt,ZT=so,qT=M,HT=ve("species"),$T=function(t){var e=UT(t);qT&&e&&!e[HT]&&ZT(e,HT,{configurable:!0,get:function(){return this}})},KT=ht,JT=TypeError,QT=function(t,e){if(KT(e,t))return t;throw JT("Incorrect invocation")},tE=wn,eE=Lt,rE=TypeError,nE=function(t){if(tE(t))return t;throw rE(eE(t)+" is not a constructor")},iE=or,oE=nE,aE=H,sE=ve("species"),uE=function(t,e){var r,n=iE(t).constructor;return void 0===n||aE(r=iE(n)[sE])?e:oE(r)},cE=/(?:ipad|iphone|ipod).*applewebkit/i.test(ft),lE=u,hE=v,fE=Qe,pE=P,dE=ee,vE=c,yE=Ti,gE=ks,mE=Ae,xE=pp,bE=cE,wE=VT,_E=lE.setImmediate,SE=lE.clearImmediate,TE=lE.process,EE=lE.Dispatch,kE=lE.Function,OE=lE.MessageChannel,CE=lE.String,AE=0,LE={},PE="onreadystatechange";vE((function(){WT=lE.location}));var DE=function(t){if(dE(LE,t)){var e=LE[t];delete LE[t],e()}},ME=function(t){return function(){DE(t)}},RE=function(t){DE(t.data)},IE=function(t){lE.postMessage(CE(t),WT.protocol+"//"+WT.host)};_E&&SE||(_E=function(t){xE(arguments.length,1);var e=pE(t)?t:kE(t),r=gE(arguments,1);return LE[++AE]=function(){hE(e,void 0,r)},YT(AE),AE},SE=function(t){delete LE[t]},wE?YT=function(t){TE.nextTick(ME(t))}:EE&&EE.now?YT=function(t){EE.now(ME(t))}:OE&&!bE?(XT=(GT=new OE).port2,GT.port1.onmessage=RE,YT=fE(XT.postMessage,XT)):lE.addEventListener&&pE(lE.postMessage)&&!lE.importScripts&&WT&&"file:"!==WT.protocol&&!vE(IE)?(YT=IE,lE.addEventListener("message",RE,!1)):YT=PE in mE("script")?function(t){yE.appendChild(mE("script"))[PE]=function(){yE.removeChild(this),DE(t)}}:function(t){setTimeout(ME(t),0)});var jE={set:_E,clear:SE},zE=function(){this.head=null,this.tail=null};zE.prototype={add:function(t){var e={item:t,next:null},r=this.tail;r?r.next=e:this.head=e,this.tail=e},get:function(){var t=this.head;if(t)return null===(this.head=t.next)&&(this.tail=null),t.item}};var FE,NE,BE,WE,YE,GE=zE,XE=/ipad|iphone|ipod/i.test(ft)&&"undefined"!=typeof Pebble,VE=/web0s(?!.*chrome)/i.test(ft),UE=u,ZE=Qe,qE=D.f,HE=jE.set,$E=GE,KE=cE,JE=XE,QE=VE,tk=VT,ek=UE.MutationObserver||UE.WebKitMutationObserver,rk=UE.document,nk=UE.process,ik=UE.Promise,ok=qE(UE,"queueMicrotask"),ak=ok&&ok.value;if(!ak){var sk=new $E,uk=function(){var t,e;for(tk&&(t=nk.domain)&&t.exit();e=sk.get();)try{e()}catch(t){throw sk.head&&FE(),t}t&&t.enter()};KE||tk||QE||!ek||!rk?!JE&&ik&&ik.resolve?((WE=ik.resolve(void 0)).constructor=ik,YE=ZE(WE.then,WE),FE=function(){YE(uk)}):tk?FE=function(){nk.nextTick(uk)}:(HE=ZE(HE,UE),FE=function(){HE(uk)}):(NE=!0,BE=rk.createTextNode(""),new ek(uk).observe(BE,{characterData:!0}),FE=function(){BE.data=NE=!NE}),ak=function(t){sk.head||FE(),sk.add(t)}}var ck=ak,lk=function(t){try{return{error:!1,value:t()}}catch(t){return{error:!0,value:t}}},hk=u.Promise,fk="object"==typeof Deno&&Deno&&"object"==typeof Deno.version,pk=!fk&&!VT&&"object"==typeof window&&"object"==typeof document,dk=u,vk=hk,yk=P,gk=He,mk=sn,xk=ve,bk=pk,wk=fk,_k=xt,Sk=vk&&vk.prototype,Tk=xk("species"),Ek=!1,kk=yk(dk.PromiseRejectionEvent),Ok=gk("Promise",(function(){var t=mk(vk),e=t!==String(vk);if(!e&&66===_k)return!0;if(!Sk.catch||!Sk.finally)return!0;if(!_k||_k<51||!/native code/.test(t)){var r=new vk((function(t){t(1)})),n=function(t){t((function(){}),(function(){}))};if((r.constructor={})[Tk]=n,!(Ek=r.then((function(){}))instanceof n))return!0}return!e&&(bk||wk)&&!kk})),Ck={CONSTRUCTOR:Ok,REJECTION_EVENT:kk,SUBCLASSING:Ek},Ak={},Lk=Rt,Pk=TypeError,Dk=function(t){var e,r;this.promise=new t((function(t,n){if(void 0!==e||void 0!==r)throw Pk("Bad Promise constructor");e=t,r=n})),this.resolve=Lk(e),this.reject=Lk(r)};Ak.f=function(t){return new Dk(t)};var Mk,Rk,Ik=Pr,jk=VT,zk=u,Fk=j,Nk=oo,Bk=Do,Wk=$T,Yk=Rt,Gk=P,Xk=it,Vk=QT,Uk=uE,Zk=jE.set,qk=ck,Hk=function(t,e){try{1==arguments.length?console.error(t):console.error(t,e)}catch(t){}},$k=lk,Kk=GE,Jk=qo,Qk=hk,tO=Ak,eO="Promise",rO=Ck.CONSTRUCTOR,nO=Ck.REJECTION_EVENT,iO=Jk.getterFor(eO),oO=Jk.set,aO=Qk&&Qk.prototype,sO=Qk,uO=aO,cO=zk.TypeError,lO=zk.document,hO=zk.process,fO=tO.f,pO=fO,dO=!!(lO&&lO.createEvent&&zk.dispatchEvent),vO="unhandledrejection",yO=function(t){var e;return!(!Xk(t)||!Gk(e=t.then))&&e},gO=function(t,e){var r,n,i,o=e.value,a=1==e.state,s=a?t.ok:t.fail,u=t.resolve,c=t.reject,l=t.domain;try{s?(a||(2===e.rejection&&_O(e),e.rejection=1),!0===s?r=o:(l&&l.enter(),r=s(o),l&&(l.exit(),i=!0)),r===t.promise?c(cO("Promise-chain cycle")):(n=yO(r))?Fk(n,r,u,c):u(r)):c(o)}catch(t){l&&!i&&l.exit(),c(t)}},mO=function(t,e){t.notified||(t.notified=!0,qk((function(){for(var r,n=t.reactions;r=n.get();)gO(r,t);t.notified=!1,e&&!t.rejection&&bO(t)})))},xO=function(t,e,r){var n,i;dO?((n=lO.createEvent("Event")).promise=e,n.reason=r,n.initEvent(t,!1,!0),zk.dispatchEvent(n)):n={promise:e,reason:r},!nO&&(i=zk["on"+t])?i(n):t===vO&&Hk("Unhandled promise rejection",r)},bO=function(t){Fk(Zk,zk,(function(){var e,r=t.facade,n=t.value;if(wO(t)&&(e=$k((function(){jk?hO.emit("unhandledRejection",n,r):xO(vO,r,n)})),t.rejection=jk||wO(t)?2:1,e.error))throw e.value}))},wO=function(t){return 1!==t.rejection&&!t.parent},_O=function(t){Fk(Zk,zk,(function(){var e=t.facade;jk?hO.emit("rejectionHandled",e):xO("rejectionhandled",e,t.value)}))},SO=function(t,e,r){return function(n){t(e,n,r)}},TO=function(t,e,r){t.done||(t.done=!0,r&&(t=r),t.value=e,t.state=2,mO(t,!0))},EO=function(t,e,r){if(!t.done){t.done=!0,r&&(t=r);try{if(t.facade===e)throw cO("Promise can't be resolved itself");var n=yO(e);n?qk((function(){var r={done:!1};try{Fk(n,e,SO(EO,r,t),SO(TO,r,t))}catch(e){TO(r,e,t)}})):(t.value=e,t.state=1,mO(t,!1))}catch(e){TO({done:!1},e,t)}}};rO&&(uO=(sO=function(t){Vk(this,uO),Yk(t),Fk(Mk,this);var e=iO(this);try{t(SO(EO,e),SO(TO,e))}catch(t){TO(e,t)}}).prototype,(Mk=function(t){oO(this,{type:eO,done:!1,notified:!1,parent:!1,reactions:new Kk,rejection:!1,state:0,value:void 0})}).prototype=Nk(uO,"then",(function(t,e){var r=iO(this),n=fO(Uk(this,sO));return r.parent=!0,n.ok=!Gk(t)||t,n.fail=Gk(e)&&e,n.domain=jk?hO.domain:void 0,0==r.state?r.reactions.add(n):qk((function(){gO(n,r)})),n.promise})),Rk=function(){var t=new Mk,e=iO(t);this.promise=t,this.resolve=SO(EO,e),this.reject=SO(TO,e)},tO.f=fO=function(t){return t===sO||undefined===t?new Rk(t):pO(t)}),Ik({global:!0,constructor:!0,wrap:!0,forced:rO},{Promise:sO}),Bk(sO,eO,!1,!0),Wk(eO);var kO=hk,OO=Ck.CONSTRUCTOR||!Fd((function(t){kO.all(t).then(void 0,(function(){}))})),CO=j,AO=Rt,LO=Ak,PO=lk,DO=_T;Pr({target:"Promise",stat:!0,forced:OO},{all:function(t){var e=this,r=LO.f(e),n=r.resolve,i=r.reject,o=PO((function(){var r=AO(e.resolve),o=[],a=0,s=1;DO(t,(function(t){var u=a++,c=!1;s++,CO(r,e,t).then((function(t){c||(c=!0,o[u]=t,--s||n(o))}),i)})),--s||n(o)}));return o.error&&i(o.value),r.promise}});var MO=Pr,RO=Ck.CONSTRUCTOR;hk&&hk.prototype,MO({target:"Promise",proto:!0,forced:RO,real:!0},{catch:function(t){return this.then(void 0,t)}});var IO=j,jO=Rt,zO=Ak,FO=lk,NO=_T;Pr({target:"Promise",stat:!0,forced:OO},{race:function(t){var e=this,r=zO.f(e),n=r.reject,i=FO((function(){var i=jO(e.resolve);NO(t,(function(t){IO(i,e,t).then(r.resolve,n)}))}));return i.error&&n(i.value),r.promise}});var BO=j,WO=Ak;Pr({target:"Promise",stat:!0,forced:Ck.CONSTRUCTOR},{reject:function(t){var e=WO.f(this);return BO(e.reject,void 0,t),e.promise}});var YO=or,GO=it,XO=Ak,VO=function(t,e){if(YO(t),GO(e)&&e.constructor===t)return e;var r=XO.f(t);return(0,r.resolve)(e),r.promise},UO=Pr,ZO=hk,qO=Ck.CONSTRUCTOR,HO=VO,$O=lt("Promise"),KO=!qO;UO({target:"Promise",stat:!0,forced:true},{resolve:function(t){return HO(KO&&this===$O?ZO:this,t)}});var JO=j,QO=Rt,tC=Ak,eC=lk,rC=_T;Pr({target:"Promise",stat:!0,forced:OO},{allSettled:function(t){var e=this,r=tC.f(e),n=r.resolve,i=r.reject,o=eC((function(){var r=QO(e.resolve),i=[],o=0,a=1;rC(t,(function(t){var s=o++,u=!1;a++,JO(r,e,t).then((function(t){u||(u=!0,i[s]={status:"fulfilled",value:t},--a||n(i))}),(function(t){u||(u=!0,i[s]={status:"rejected",reason:t},--a||n(i))}))})),--a||n(i)}));return o.error&&i(o.value),r.promise}});var nC=j,iC=Rt,oC=lt,aC=Ak,sC=lk,uC=_T,cC="No one promise resolved";Pr({target:"Promise",stat:!0,forced:OO},{any:function(t){var e=this,r=oC("AggregateError"),n=aC.f(e),i=n.resolve,o=n.reject,a=sC((function(){var n=iC(e.resolve),a=[],s=0,u=1,c=!1;uC(t,(function(t){var l=s++,h=!1;u++,nC(n,e,t).then((function(t){h||c||(c=!0,i(t))}),(function(t){h||c||(h=!0,a[l]=t,--u||o(new r(a,cC)))}))})),--u||o(new r(a,cC))}));return a.error&&o(a.value),n.promise}});var lC=Pr,hC=hk,fC=c,pC=lt,dC=P,vC=uE,yC=VO,gC=hC&&hC.prototype;lC({target:"Promise",proto:!0,real:!0,forced:!!hC&&fC((function(){gC.finally.call({then:function(){}},(function(){}))}))},{finally:function(t){var e=vC(this,pC("Promise")),r=dC(t);return this.then(r?function(r){return yC(e,t()).then((function(){return r}))}:t,r?function(r){return yC(e,t()).then((function(){throw r}))}:t)}});var mC=ot.Promise,xC=Ak,bC=lk;Pr({target:"Promise",stat:!0,forced:!0},{try:function(t){var e=xC.f(this),r=bC(t);return(r.error?e.reject:e.resolve)(r.value),e.promise}});var wC=mC;!function(t){t.exports=wC}(VS),function(t){t.exports=XS}(GS);var _C={},SC={get exports(){return _C},set exports(t){_C=t}},TC={},EC=Qg;!function(t){t.exports=EC}({get exports(){return TC},set exports(t){TC=t}}),function(t){t.exports=TC}(SC),function(t){var e=zS.default,r=Zv,i=n,o=hS,a=AS,s=FS,u=yS,c=YS,l=_C,h=py;function f(){t.exports=f=function(){return n},t.exports.__esModule=!0,t.exports.default=t.exports;var n={},p=Object.prototype,d=p.hasOwnProperty,v=r||function(t,e,r){t[e]=r.value},y="function"==typeof i?i:{},g=y.iterator||"@@iterator",m=y.asyncIterator||"@@asyncIterator",x=y.toStringTag||"@@toStringTag";function b(t,e,n){return r(t,e,{value:n,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{b({},"")}catch(t){b=function(t,e,r){return t[e]=r}}function w(t,e,r,n){var i=e&&e.prototype instanceof T?e:T,a=o(i.prototype),s=new j(n||[]);return v(a,"_invoke",{value:D(t,r,s)}),a}function _(t,e,r){try{return{type:"normal",arg:t.call(e,r)}}catch(t){return{type:"throw",arg:t}}}n.wrap=w;var S={};function T(){}function E(){}function k(){}var O={};b(O,g,(function(){return this}));var C=a&&a(a(z([])));C&&C!==p&&d.call(C,g)&&(O=C);var A=k.prototype=T.prototype=o(O);function L(t){var e;s(e=["next","throw","return"]).call(e,(function(e){b(t,e,(function(t){return this._invoke(e,t)}))}))}function P(t,r){function n(i,o,a,s){var u=_(t[i],t,o);if("throw"!==u.type){var c=u.arg,l=c.value;return l&&"object"==e(l)&&d.call(l,"__await")?r.resolve(l.__await).then((function(t){n("next",t,a,s)}),(function(t){n("throw",t,a,s)})):r.resolve(l).then((function(t){c.value=t,a(c)}),(function(t){return n("throw",t,a,s)}))}s(u.arg)}var i;v(this,"_invoke",{value:function(t,e){function o(){return new r((function(r,i){n(t,e,r,i)}))}return i=i?i.then(o,o):o()}})}function D(t,e,r){var n="suspendedStart";return function(i,o){if("executing"===n)throw new Error("Generator is already running");if("completed"===n){if("throw"===i)throw o;return F()}for(r.method=i,r.arg=o;;){var a=r.delegate;if(a){var s=M(a,r);if(s){if(s===S)continue;return s}}if("next"===r.method)r.sent=r._sent=r.arg;else if("throw"===r.method){if("suspendedStart"===n)throw n="completed",r.arg;r.dispatchException(r.arg)}else"return"===r.method&&r.abrupt("return",r.arg);n="executing";var u=_(t,e,r);if("normal"===u.type){if(n=r.done?"completed":"suspendedYield",u.arg===S)continue;return{value:u.arg,done:r.done}}"throw"===u.type&&(n="completed",r.method="throw",r.arg=u.arg)}}}function M(t,e){var r=e.method,n=t.iterator[r];if(void 0===n)return e.delegate=null,"throw"===r&&t.iterator.return&&(e.method="return",e.arg=void 0,M(t,e),"throw"===e.method)||"return"!==r&&(e.method="throw",e.arg=new TypeError("The iterator does not provide a '"+r+"' method")),S;var i=_(n,t.iterator,e.arg);if("throw"===i.type)return e.method="throw",e.arg=i.arg,e.delegate=null,S;var o=i.arg;return o?o.done?(e[t.resultName]=o.value,e.next=t.nextLoc,"return"!==e.method&&(e.method="next",e.arg=void 0),e.delegate=null,S):o:(e.method="throw",e.arg=new TypeError("iterator result is not an object"),e.delegate=null,S)}function R(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function I(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function j(t){this.tryEntries=[{tryLoc:"root"}],s(t).call(t,R,this),this.reset(!0)}function z(t){if(t){var e=t[g];if(e)return e.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var r=-1,n=function e(){for(;++r<t.length;)if(d.call(t,r))return e.value=t[r],e.done=!1,e;return e.value=void 0,e.done=!0,e};return n.next=n}}return{next:F}}function F(){return{value:void 0,done:!0}}return E.prototype=k,v(A,"constructor",{value:k,configurable:!0}),v(k,"constructor",{value:E,configurable:!0}),E.displayName=b(k,x,"GeneratorFunction"),n.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===E||"GeneratorFunction"===(e.displayName||e.name))},n.mark=function(t){return u?u(t,k):(t.__proto__=k,b(t,x,"GeneratorFunction")),t.prototype=o(A),t},n.awrap=function(t){return{__await:t}},L(P.prototype),b(P.prototype,m,(function(){return this})),n.AsyncIterator=P,n.async=function(t,e,r,i,o){void 0===o&&(o=c);var a=new P(w(t,e,r,i),o);return n.isGeneratorFunction(e)?a:a.next().then((function(t){return t.done?t.value:a.next()}))},L(A),b(A,x,"Generator"),b(A,g,(function(){return this})),b(A,"toString",(function(){return"[object Generator]"})),n.keys=function(t){var e=Object(t),r=[];for(var n in e)r.push(n);return l(r).call(r),function t(){for(;r.length;){var n=r.pop();if(n in e)return t.value=n,t.done=!1,t}return t.done=!0,t}},n.values=z,j.prototype={constructor:j,reset:function(t){var e;if(this.prev=0,this.next=0,this.sent=this._sent=void 0,this.done=!1,this.delegate=null,this.method="next",this.arg=void 0,s(e=this.tryEntries).call(e,I),!t)for(var r in this)"t"===r.charAt(0)&&d.call(this,r)&&!isNaN(+h(r).call(r,1))&&(this[r]=void 0)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var e=this;function r(r,n){return o.type="throw",o.arg=t,e.next=r,n&&(e.method="next",e.arg=void 0),!!n}for(var n=this.tryEntries.length-1;n>=0;--n){var i=this.tryEntries[n],o=i.completion;if("root"===i.tryLoc)return r("end");if(i.tryLoc<=this.prev){var a=d.call(i,"catchLoc"),s=d.call(i,"finallyLoc");if(a&&s){if(this.prev<i.catchLoc)return r(i.catchLoc,!0);if(this.prev<i.finallyLoc)return r(i.finallyLoc)}else if(a){if(this.prev<i.catchLoc)return r(i.catchLoc,!0)}else{if(!s)throw new Error("try statement without catch or finally");if(this.prev<i.finallyLoc)return r(i.finallyLoc)}}}},abrupt:function(t,e){for(var r=this.tryEntries.length-1;r>=0;--r){var n=this.tryEntries[r];if(n.tryLoc<=this.prev&&d.call(n,"finallyLoc")&&this.prev<n.finallyLoc){var i=n;break}}i&&("break"===t||"continue"===t)&&i.tryLoc<=e&&e<=i.finallyLoc&&(i=null);var o=i?i.completion:{};return o.type=t,o.arg=e,i?(this.method="next",this.next=i.finallyLoc,S):this.complete(o)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),S},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.finallyLoc===t)return this.complete(r.completion,r.afterLoc),I(r),S}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.tryLoc===t){var n=r.completion;if("throw"===n.type){var i=n.arg;I(r)}return i}}throw new Error("illegal catch attempt")},delegateYield:function(t,e,r){return this.delegate={iterator:z(t),resultName:e,nextLoc:r},"next"===this.method&&(this.arg=void 0),S}},n}t.exports=f,t.exports.__esModule=!0,t.exports.default=t.exports}(jS);var kC=IS(),OC=kC;try{regeneratorRuntime=kC}catch(t){"object"==typeof globalThis?globalThis.regeneratorRuntime=kC:Function("r","regeneratorRuntime = r")(kC)}var CC={},AC={get exports(){return CC},set exports(t){CC=t}},LC=Rt,PC=Jt,DC=q,MC=Wr,RC=TypeError,IC=function(t){return function(e,r,n,i){LC(r);var o=PC(e),a=DC(o),s=MC(o),u=t?s-1:0,c=t?-1:1;if(n<2)for(;;){if(u in a){i=a[u],u+=c;break}if(u+=c,t?u<0:s<=u)throw RC("Reduce of empty array with no initial value")}for(;t?u>=0:s>u;u+=c)u in a&&(i=r(i,a[u],u,o));return i}},jC={left:IC(!1),right:IC(!0)}.left;Pr({target:"Array",proto:!0,forced:!VT&&xt>79&&xt<83||!Fl("reduce")},{reduce:function(t){var e=arguments.length;return jC(this,t,e,e>1?arguments[1]:void 0)}});var zC=fh("Array").reduce,FC=ht,NC=zC,BC=Array.prototype,WC=function(t){var e=t.reduce;return t===BC||FC(BC,t)&&e===BC.reduce?NC:e};!function(t){t.exports=WC}(AC);var YC=r(CC),GC={},XC={get exports(){return GC},set exports(t){GC=t}},VC=Mr,UC=Wr,ZC=Gr,qC=Qe,HC=function(t,e,r,n,i,o,a,s){for(var u,c,l=i,h=0,f=!!a&&qC(a,s);h<n;)h in r&&(u=f?f(r[h],h,e):r[h],o>0&&VC(u)?(c=UC(u),l=HC(t,e,u,c,l,o-1)-1):(ZC(l+1),t[l]=u),l++),h++;return l},$C=HC,KC=Rt,JC=Jt,QC=Wr,tA=Cn;Pr({target:"Array",proto:!0},{flatMap:function(t){var e,r=JC(this),n=QC(r);return KC(t),(e=tA(r,0)).length=$C(e,r,r,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var eA=fh("Array").flatMap,rA=ht,nA=eA,iA=Array.prototype,oA=function(t){var e=t.flatMap;return t===iA||rA(iA,t)&&e===iA.flatMap?nA:e};!function(t){t.exports=oA}(XC);var aA=r(GC),sA={},uA={get exports(){return sA},set exports(t){sA=t}},cA={},lA={get exports(){return cA},set exports(t){cA=t}},hA=c((function(){if("function"==typeof ArrayBuffer){var t=new ArrayBuffer(8);Object.isExtensible(t)&&Object.defineProperty(t,"a",{value:8})}})),fA=c,pA=it,dA=T,vA=hA,yA=Object.isExtensible,gA=fA((function(){yA(1)}))||vA?function(t){return!!pA(t)&&((!vA||"ArrayBuffer"!=dA(t))&&(!yA||yA(t)))}:yA,mA=!c((function(){return Object.isExtensible(Object.preventExtensions({}))})),xA=Pr,bA=b,wA=ai,_A=it,SA=ee,TA=tr.f,EA=Yi,kA=Vi,OA=gA,CA=mA,AA=!1,LA=ae("meta"),PA=0,DA=function(t){TA(t,LA,{value:{objectID:"O"+PA++,weakData:{}}})},MA=lA.exports={enable:function(){MA.enable=function(){},AA=!0;var t=EA.f,e=bA([].splice),r={};r[LA]=1,t(r).length&&(EA.f=function(r){for(var n=t(r),i=0,o=n.length;i<o;i++)if(n[i]===LA){e(n,i,1);break}return n},xA({target:"Object",stat:!0,forced:!0},{getOwnPropertyNames:kA.f}))},fastKey:function(t,e){if(!_A(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!SA(t,LA)){if(!OA(t))return"F";if(!e)return"E";DA(t)}return t[LA].objectID},getWeakData:function(t,e){if(!SA(t,LA)){if(!OA(t))return!0;if(!e)return!1;DA(t)}return t[LA].weakData},onFreeze:function(t){return CA&&AA&&OA(t)&&!SA(t,LA)&&DA(t),t}};wA[LA]=!0;var RA=Pr,IA=u,jA=cA,zA=c,FA=xr,NA=_T,BA=QT,WA=P,YA=it,GA=Do,XA=tr.f,VA=ra.forEach,UA=M,ZA=qo.set,qA=qo.getterFor,HA=function(t,e,r){var n,i=-1!==t.indexOf("Map"),o=-1!==t.indexOf("Weak"),a=i?"set":"add",s=IA[t],u=s&&s.prototype,c={};if(UA&&WA(s)&&(o||u.forEach&&!zA((function(){(new s).entries().next()})))){var l=(n=e((function(e,r){ZA(BA(e,l),{type:t,collection:new s}),null!=r&&NA(r,e[a],{that:e,AS_ENTRIES:i})}))).prototype,h=qA(t);VA(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in u)||o&&"clear"==t||FA(l,t,(function(r,n){var i=h(this).collection;if(!e&&o&&!YA(r))return"get"==t&&void 0;var a=i[t](0===r?0:r,n);return e?this:a}))})),o||XA(l,"size",{configurable:!0,get:function(){return h(this).collection.size}})}else n=r.getConstructor(e,t,i,a),jA.enable();return GA(n,t,!1,!0),c[t]=n,RA({global:!0,forced:!0},c),o||r.setStrong(n,t,i),n},$A=oo,KA=Wi,JA=so,QA=function(t,e,r){for(var n in e)r&&r.unsafe&&t[n]?t[n]=e[n]:$A(t,n,e[n],r);return t},tL=Qe,eL=QT,rL=H,nL=_T,iL=pc,oL=dc,aL=$T,sL=M,uL=cA.fastKey,cL=qo.set,lL=qo.getterFor,hL={getConstructor:function(t,e,r,n){var i=t((function(t,i){eL(t,o),cL(t,{type:e,index:KA(null),first:void 0,last:void 0,size:0}),sL||(t.size=0),rL(i)||nL(i,t[n],{that:t,AS_ENTRIES:r})})),o=i.prototype,a=lL(e),s=function(t,e,r){var n,i,o=a(t),s=u(t,e);return s?s.value=r:(o.last=s={index:i=uL(e,!0),key:e,value:r,previous:n=o.last,next:void 0,removed:!1},o.first||(o.first=s),n&&(n.next=s),sL?o.size++:t.size++,"F"!==i&&(o.index[i]=s)),t},u=function(t,e){var r,n=a(t),i=uL(e);if("F"!==i)return n.index[i];for(r=n.first;r;r=r.next)if(r.key==e)return r};return QA(o,{clear:function(){for(var t=a(this),e=t.index,r=t.first;r;)r.removed=!0,r.previous&&(r.previous=r.previous.next=void 0),delete e[r.index],r=r.next;t.first=t.last=void 0,sL?t.size=0:this.size=0},delete:function(t){var e=this,r=a(e),n=u(e,t);if(n){var i=n.next,o=n.previous;delete r.index[n.index],n.removed=!0,o&&(o.next=i),i&&(i.previous=o),r.first==n&&(r.first=i),r.last==n&&(r.last=o),sL?r.size--:e.size--}return!!n},forEach:function(t){for(var e,r=a(this),n=tL(t,arguments.length>1?arguments[1]:void 0);e=e?e.next:r.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!u(this,t)}}),QA(o,r?{get:function(t){var e=u(this,t);return e&&e.value},set:function(t,e){return s(this,0===t?0:t,e)}}:{add:function(t){return s(this,t=0===t?0:t,t)}}),sL&&JA(o,"size",{configurable:!0,get:function(){return a(this).size}}),i},setStrong:function(t,e,r){var n=e+" Iterator",i=lL(e),o=lL(n);iL(t,e,(function(t,e){cL(this,{type:n,target:t,state:i(t),kind:e,last:void 0})}),(function(){for(var t=o(this),e=t.kind,r=t.last;r&&r.removed;)r=r.previous;return t.target&&(t.last=r=r?r.next:t.state.first)?oL("keys"==e?r.key:"values"==e?r.value:[r.key,r.value],!1):(t.target=void 0,oL(void 0,!0))}),r?"entries":"values",!r,!0),aL(e)}};HA("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),hL);var fL=ot.Map;!function(t){t.exports=fL}(uA);var pL=r(sA),dL={},vL={get exports(){return dL},set exports(t){dL=t}};HA("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),hL);var yL=ot.Set;!function(t){t.exports=yL}(vL);var gL=r(dL),mL={};!function(t){t.exports=_l}({get exports(){return mL},set exports(t){mL=t}});var xL=r(mL),bL={},wL={get exports(){return bL},set exports(t){bL=t}},_L={},SL=_d;!function(t){t.exports=SL}({get exports(){return _L},set exports(t){_L=t}}),function(t){t.exports=_L}(wL);var TL=r(bL),EL={},kL={get exports(){return EL},set exports(t){EL=t}},OL=ra.some;Pr({target:"Array",proto:!0,forced:!Fl("some")},{some:function(t){return OL(this,t,arguments.length>1?arguments[1]:void 0)}});var CL=fh("Array").some,AL=ht,LL=CL,PL=Array.prototype,DL=function(t){var e=t.some;return t===PL||AL(PL,t)&&e===PL.some?LL:e};!function(t){t.exports=DL}(kL);var ML=r(EL),RL={},IL={get exports(){return RL},set exports(t){RL=t}},jL=fh("Array").keys,zL=rn,FL=ee,NL=ht,BL=jL,WL=Array.prototype,YL={DOMTokenList:!0,NodeList:!0},GL=function(t){var e=t.keys;return t===WL||NL(WL,t)&&e===WL.keys||FL(YL,zL(t))?BL:e};!function(t){t.exports=GL}(IL);var XL=r(RL),VL={},UL={get exports(){return VL},set exports(t){VL=t}},ZL=fh("Array").entries,qL=rn,HL=ee,$L=ht,KL=ZL,JL=Array.prototype,QL={DOMTokenList:!0,NodeList:!0},tP=function(t){var e=t.entries;return t===JL||$L(JL,t)&&e===JL.entries||HL(QL,qL(t))?KL:e};!function(t){t.exports=tP}(UL);var eP=r(VL),rP={},nP={get exports(){return rP},set exports(t){rP=t}},iP=Pr,oP=v,aP=Ig,sP=nE,uP=or,cP=it,lP=Wi,hP=c,fP=lt("Reflect","construct"),pP=Object.prototype,dP=[].push,vP=hP((function(){function t(){}return!(fP((function(){}),[],t)instanceof t)})),yP=!hP((function(){fP((function(){}))})),gP=vP||yP;iP({target:"Reflect",stat:!0,forced:gP,sham:gP},{construct:function(t,e){sP(t),uP(e);var r=arguments.length<3?t:sP(arguments[2]);if(yP&&!vP)return fP(t,e,r);if(t==r){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return oP(dP,n,e),new(oP(aP,t,n))}var i=r.prototype,o=lP(cP(i)?i:pP),a=oP(t,o,e);return cP(a)?a:o}});var mP=ot.Reflect.construct;!function(t){t.exports=mP}(nP);var xP,bP=r(rP),wP=new Uint8Array(16);function _P(){if(!xP&&!(xP="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto)))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return xP(wP)}var SP=/^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;for(var TP,EP=[],kP=0;kP<256;++kP)EP.push((kP+256).toString(16).substr(1));function OP(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=(EP[t[e+0]]+EP[t[e+1]]+EP[t[e+2]]+EP[t[e+3]]+"-"+EP[t[e+4]]+EP[t[e+5]]+"-"+EP[t[e+6]]+EP[t[e+7]]+"-"+EP[t[e+8]]+EP[t[e+9]]+"-"+EP[t[e+10]]+EP[t[e+11]]+EP[t[e+12]]+EP[t[e+13]]+EP[t[e+14]]+EP[t[e+15]]).toLowerCase();if(!function(t){return"string"==typeof t&&SP.test(t)}(r))throw TypeError("Stringified UUID is invalid");return r}function CP(t,e,r){var n=(t=t||{}).random||(t.rng||_P)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,e){r=r||0;for(var i=0;i<16;++i)e[r+i]=n[i];return e}return OP(n)}function AP(t,e){var r=vg(t);if($d){var n=$d(t);e&&(n=Bh(n).call(n,(function(e){return cv(t,e).enumerable}))),r.push.apply(r,n)}return r}function LP(t){for(var e=1;e<arguments.length;e++){var r,n,i=null!=arguments[e]?arguments[e]:{};e%2?Uf(r=AP(Object(i),!0)).call(r,(function(e){sy(t,e,i[e])})):Sv?Rv(t,Sv(i)):Uf(n=AP(Object(i))).call(n,(function(e){Vv(t,e,cv(i,e))}))}return t}function PP(t){var e=function(){if("undefined"==typeof Reflect||!bP)return!1;if(bP.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(bP(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=RS(t);if(e){var i=RS(this).constructor;r=bP(n,arguments,i)}else r=n.apply(this,arguments);return function(t,e){if(e&&("object"===El(e)||"function"==typeof e))return e;if(void 0!==e)throw new TypeError("Derived constructors may only return object or undefined");return lS(t)}(this,r)}}function DP(t,e){var r=void 0!==qy&&Ud(t)||t["@@iterator"];if(!r){if($f(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return MP(t,e);var n=$y(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Wd(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return MP(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,s=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){s=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw o}}}}function MP(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}var RP=function(){function t(e,r,n){var i,o,a;Uv(this,t),sy(this,"_source",void 0),sy(this,"_transformers",void 0),sy(this,"_target",void 0),sy(this,"_listeners",{add:Yg(i=this._add).call(i,this),remove:Yg(o=this._remove).call(o,this),update:Yg(a=this._update).call(a,this)}),this._source=e,this._transformers=r,this._target=n}return ay(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return YC(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),IP=function(){function t(e){Uv(this,t),sy(this,"_source",void 0),sy(this,"_transformers",[]),this._source=e}return ay(t,[{key:"filter",value:function(t){return this._transformers.push((function(e){return Bh(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return cg(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return aA(e).call(e,t)})),this}},{key:"to",value:function(t){return new RP(this._source,this._transformers,t)}}]),t}();function jP(t){return"string"==typeof t||"number"==typeof t}var zP=function(){function t(e){Uv(this,t),sy(this,"delay",void 0),sy(this,"max",void 0),sy(this,"_queue",[]),sy(this,"_timeout",null),sy(this,"_extended",null),this.delay=null,this.max=1/0,this.setOptions(e)}return ay(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,r=0;r<e.length;r++){var n=e[r];n.original?t[n.name]=n.original:delete t[n.name]}this._extended=null}}},{key:"replace",value:function(t,e){var r=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];r.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=Pp((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;Uf(t=km(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,r){var n=new t(r);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){n.flush()};var i=[{name:"flush",original:void 0}];if(r&&r.replace)for(var o=0;o<r.replace.length;o++){var a=r.replace[o];i.push({name:a,original:e[a]}),n.replace(e,a)}return n._extended={object:e,methods:i},n}}]),t}(),FP=function(){function t(){Uv(this,t),sy(this,"_subscribers",{"*":[],add:[],remove:[],update:[]}),sy(this,"subscribe",t.prototype.on),sy(this,"unsubscribe",t.prototype.off)}return ay(t,[{key:"_trigger",value:function(t,e,r){var n,i;if("*"===t)throw new Error("Cannot trigger event *");Uf(n=up(i=[]).call(i,Uy(this._subscribers[t]),Uy(this._subscribers["*"]))).call(n,(function(n){n(t,e,null!=r?r:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var r;this._subscribers[t]=Bh(r=this._subscribers[t]).call(r,(function(t){return t!==e}))}}]),t}();TP=xL;var NP=function(){function t(e){Uv(this,t),sy(this,"_pairs",void 0),this._pairs=e}return ay(t,[{key:TP,value:OC.mark((function t(){var e,r,n,i,o;return OC.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=DP(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Vy(r.value,2),i=n[0],o=n[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:OC.mark((function t(){var e,r,n,i,o;return OC.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=DP(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Vy(r.value,2),i=n[0],o=n[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:OC.mark((function t(){var e,r,n,i;return OC.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=DP(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Vy(r.value,1),i=n[0],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:OC.mark((function t(){var e,r,n,i;return OC.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=DP(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Vy(r.value,2),i=n[1],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return cg(t=Uy(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return cg(t=Uy(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return Uy(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=Ux(null),r=DP(this._pairs);try{for(r.s();!(t=r.n()).done;){var n=Vy(t.value,2),i=n[0],o=n[1];e[i]=o}}catch(t){r.e(t)}finally{r.f()}return e}},{key:"toMap",value:function(){return new pL(this._pairs)}},{key:"toIdSet",value:function(){return new gL(this.toIdArray())}},{key:"toItemSet",value:function(){return new gL(this.toItemArray())}},{key:"cache",value:function(){return new t(Uy(this._pairs))}},{key:"distinct",value:function(t){var e,r=new gL,n=DP(this._pairs);try{for(n.s();!(e=n.n()).done;){var i=Vy(e.value,2),o=i[0],a=i[1];r.add(t(a,o))}}catch(t){n.e(t)}finally{n.f()}return r}},{key:"filter",value:function(e){var r=this._pairs;return new t(sy({},xL,OC.mark((function t(){var n,i,o,a,s;return OC.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=DP(r),t.prev=1,n.s();case 3:if((i=n.n()).done){t.next=10;break}if(o=Vy(i.value,2),a=o[0],s=o[1],!e(s,a)){t.next=8;break}return t.next=8,[a,s];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),n.e(t.t0);case 15:return t.prev=15,n.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,r=DP(this._pairs);try{for(r.s();!(e=r.n()).done;){var n=Vy(e.value,2),i=n[0];t(n[1],i)}}catch(t){r.e(t)}finally{r.f()}}},{key:"map",value:function(e){var r=this._pairs;return new t(sy({},xL,OC.mark((function t(){var n,i,o,a,s;return OC.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=DP(r),t.prev=1,n.s();case 3:if((i=n.n()).done){t.next=9;break}return o=Vy(i.value,2),a=o[0],s=o[1],t.next=7,[a,e(s,a)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),n.e(t.t0);case 14:return t.prev=14,n.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=TL(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],i=t(r.value[1],r.value[0]);!(r=e.next()).done;){var o=Vy(r.value,2),a=o[0],s=o[1],u=t(s,a);u>i&&(i=u,n=s)}return n}},{key:"min",value:function(t){var e=TL(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],i=t(r.value[1],r.value[0]);!(r=e.next()).done;){var o=Vy(r.value,2),a=o[0],s=o[1],u=t(s,a);u<i&&(i=u,n=s)}return n}},{key:"reduce",value:function(t,e){var r,n=DP(this._pairs);try{for(n.s();!(r=n.n()).done;){var i=Vy(r.value,2),o=i[0];e=t(e,i[1],o)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(e){var r=this;return new t(sy({},xL,(function(){var t;return TL(mh(t=Uy(r._pairs)).call(t,(function(t,r){var n=Vy(t,2),i=n[0],o=n[1],a=Vy(r,2),s=a[0],u=a[1];return e(o,u,i,s)})))})))}}]),t}();var BP=function(t){CS(r,t);var e=PP(r);function r(t,n){var i;return Uv(this,r),sy(lS(i=e.call(this)),"flush",void 0),sy(lS(i),"length",void 0),sy(lS(i),"_options",void 0),sy(lS(i),"_data",void 0),sy(lS(i),"_idProp",void 0),sy(lS(i),"_queue",null),t&&!$f(t)&&(n=t,t=[]),i._options=n||{},i._data=new pL,i.length=0,i._idProp=i._options.fieldId||"id",t&&t.length&&i.add(t),i.setOptions(n),i}return ay(r,[{key:"idProp",get:function(){return this._idProp}},{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),this._queue=null):(this._queue||(this._queue=zP.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===El(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var r,n=this,i=[];if($f(t)){var o=cg(t).call(t,(function(t){return t[n._idProp]}));if(ML(o).call(o,(function(t){return n._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var a=0,s=t.length;a<s;a++)r=this._addItem(t[a]),i.push(r)}else{if(!t||"object"!==El(t))throw new Error("Unknown dataType");r=this._addItem(t),i.push(r)}return i.length&&this._trigger("add",{items:i},e),i}},{key:"update",value:function(t,e){var r=this,n=[],i=[],o=[],a=[],s=this._idProp,u=function(t){var e=t[s];if(null!=e&&r._data.has(e)){var u=t,c=Hp({},r._data.get(e)),l=r._updateItem(u);i.push(l),a.push(u),o.push(c)}else{var h=r._addItem(t);n.push(h)}};if($f(t))for(var c=0,l=t.length;c<l;c++)t[c]&&"object"===El(t[c])?u(t[c]):console.warn("Ignoring input item, which is not an object at index "+c);else{if(!t||"object"!==El(t))throw new Error("Unknown dataType");u(t)}if(n.length&&this._trigger("add",{items:n},e),i.length){var h={items:i,oldData:o,data:a};this._trigger("update",h,e)}return up(n).call(n,i)}},{key:"updateOnly",value:function(t,e){var r,n=this;$f(t)||(t=[t]);var i=cg(r=cg(t).call(t,(function(t){var e=n._data.get(t[n._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(r,(function(t){var e=t.oldData,r=t.update,i=e[n._idProp],o=function(t){for(var e,r=arguments.length,n=new Array(r>1?r-1:0),i=1;i<r;i++)n[i-1]=arguments[i];return f_.apply(void 0,up(e=[{},t]).call(e,n))}(e,r);return n._data.set(i,o),{id:i,oldData:e,updatedData:o}}));if(i.length){var o={items:cg(i).call(i,(function(t){return t.id})),oldData:cg(i).call(i,(function(t){return t.oldData})),data:cg(i).call(i,(function(t){return t.updatedData}))};return this._trigger("update",o,e),o.items}return[]}},{key:"get",value:function(t,e){var r=void 0,n=void 0,i=void 0;jP(t)?(r=t,i=e):$f(t)?(n=t,i=e):i=t;var o,a=i&&"Object"===i.returnType?"Object":"Array",s=i&&Bh(i),u=[],c=void 0,l=void 0,h=void 0;if(null!=r)(c=this._data.get(r))&&s&&!s(c)&&(c=void 0);else if(null!=n)for(var f=0,p=n.length;f<p;f++)null==(c=this._data.get(n[f]))||s&&!s(c)||u.push(c);else for(var d,v=0,y=(l=Uy(XL(d=this._data).call(d))).length;v<y;v++)h=l[v],null==(c=this._data.get(h))||s&&!s(c)||u.push(c);if(i&&i.order&&null==r&&this._sort(u,i.order),i&&i.fields){var g=i.fields;if(null!=r&&null!=c)c=this._filterFields(c,g);else for(var m=0,x=u.length;m<x;m++)u[m]=this._filterFields(u[m],g)}if("Object"==a){for(var b={},w=0,_=u.length;w<_;w++){var S=u[w];b[S[this._idProp]]=S}return b}return null!=r?null!==(o=c)&&void 0!==o?o:null:u}},{key:"getIds",value:function(t){var e=this._data,r=t&&Bh(t),n=t&&t.order,i=Uy(XL(e).call(e)),o=[];if(r)if(n){for(var a=[],s=0,u=i.length;s<u;s++){var c=i[s],l=this._data.get(c);null!=l&&r(l)&&a.push(l)}this._sort(a,n);for(var h=0,f=a.length;h<f;h++)o.push(a[h][this._idProp])}else for(var p=0,d=i.length;p<d;p++){var v=i[p],y=this._data.get(v);null!=y&&r(y)&&o.push(y[this._idProp])}else if(n){for(var g=[],m=0,x=i.length;m<x;m++){var b=i[m];g.push(e.get(b))}this._sort(g,n);for(var w=0,_=g.length;w<_;w++)o.push(g[w][this._idProp])}else for(var S=0,T=i.length;S<T;S++){var E=i[S],k=e.get(E);null!=k&&o.push(k[this._idProp])}return o}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var r=e&&Bh(e),n=this._data,i=Uy(XL(n).call(n));if(e&&e.order)for(var o=this.get(e),a=0,s=o.length;a<s;a++){var u=o[a];t(u,u[this._idProp])}else for(var c=0,l=i.length;c<l;c++){var h=i[c],f=this._data.get(h);null==f||r&&!r(f)||t(f,h)}}},{key:"map",value:function(t,e){for(var r=e&&Bh(e),n=[],i=this._data,o=Uy(XL(i).call(i)),a=0,s=o.length;a<s;a++){var u=o[a],c=this._data.get(u);null==c||r&&!r(c)||n.push(t(c,u))}return e&&e.order&&this._sort(n,e.order),n}},{key:"_filterFields",value:function(t,e){var r;return t?YC(r=$f(e)?e:vg(e)).call(r,(function(e,r){return e[r]=t[r],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var r=e;mh(t).call(t,(function(t,e){var n=t[r],i=e[r];return n>i?1:n<i?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");mh(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var r=[],n=[],i=$f(t)?t:[t],o=0,a=i.length;o<a;o++){var s=this._remove(i[o]);if(s){var u=s[this._idProp];null!=u&&(r.push(u),n.push(s))}}return r.length&&this._trigger("remove",{items:r,oldData:n},e),r}},{key:"_remove",value:function(t){var e;if(jP(t)?e=t:t&&"object"===El(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var r=this._data.get(e)||null;return this._data.delete(e),--this.length,r}return null}},{key:"clear",value:function(t){for(var e,r=Uy(XL(e=this._data).call(e)),n=[],i=0,o=r.length;i<o;i++)n.push(this._data.get(r[i]));return this._data.clear(),this.length=0,this._trigger("remove",{items:r,oldData:n},t),r}},{key:"max",value:function(t){var e,r,n=null,i=null,o=DP(Mf(e=this._data).call(e));try{for(o.s();!(r=o.n()).done;){var a=r.value,s=a[t];"number"==typeof s&&(null==i||s>i)&&(n=a,i=s)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"min",value:function(t){var e,r,n=null,i=null,o=DP(Mf(e=this._data).call(e));try{for(o.s();!(r=o.n()).done;){var a=r.value,s=a[t];"number"==typeof s&&(null==i||s<i)&&(n=a,i=s)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"distinct",value:function(t){for(var e=this._data,r=Uy(XL(e).call(e)),n=[],i=0,o=0,a=r.length;o<a;o++){for(var s=r[o],u=e.get(s)[t],c=!1,l=0;l<i;l++)if(n[l]==u){c=!0;break}c||void 0===u||(n[i]=u,i++)}return n}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=CP()),t}(t,this._idProp),r=e[this._idProp];if(this._data.has(r))throw new Error("Cannot add item: item with id "+r+" already exists");return this._data.set(r,e),++this.length,r}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+tb(t)+")");var r=this._data.get(e);if(!r)throw new Error("Cannot update item: no item with id "+e+" found");return this._data.set(e,LP(LP({},r),t)),e}},{key:"stream",value:function(t){if(t){var e=this._data;return new NP(sy({},xL,OC.mark((function r(){var n,i,o,a;return OC.wrap((function(r){for(;;)switch(r.prev=r.next){case 0:n=DP(t),r.prev=1,n.s();case 3:if((i=n.n()).done){r.next=11;break}if(o=i.value,null==(a=e.get(o))){r.next=9;break}return r.next=9,[o,a];case 9:r.next=3;break;case 11:r.next=16;break;case 13:r.prev=13,r.t0=r.catch(1),n.e(r.t0);case 16:return r.prev=16,n.f(),r.finish(16);case 19:case"end":return r.stop()}}),r,null,[[1,13,16,19]])}))))}var r;return new NP(sy({},xL,Yg(r=eP(this._data)).call(r,this._data)))}}]),r}(FP),WP=function(t){CS(r,t);var e=PP(r);function r(t,n){var i,o;return Uv(this,r),sy(lS(o=e.call(this)),"length",0),sy(lS(o),"_listener",void 0),sy(lS(o),"_data",void 0),sy(lS(o),"_ids",new gL),sy(lS(o),"_options",void 0),o._options=n||{},o._listener=Yg(i=o._onEvent).call(i,lS(o)),o.setData(t),o}return ay(r,[{key:"idProp",get:function(){return this.getDataSet().idProp}},{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:Bh(this._options)}),r=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:r})}if(null!=t){this._data=t;for(var n=this._data.getIds({filter:Bh(this._options)}),i=0,o=n.length;i<o;i++){var a=n[i];this._ids.add(a)}this.length=n.length,this._trigger("add",{items:n})}else this._data=new BP;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:Bh(this._options)}),e=Uy(this._ids),r={},n=[],i=[],o=[],a=0,s=t.length;a<s;a++){var u=t[a];r[u]=!0,this._ids.has(u)||(n.push(u),this._ids.add(u))}for(var c=0,l=e.length;c<l;c++){var h=e[c],f=this._data.get(h);null==f?console.error("If you see this, report it please."):r[h]||(i.push(h),o.push(f),this._ids.delete(h))}this.length+=n.length-i.length,n.length&&this._trigger("add",{items:n}),i.length&&this._trigger("remove",{items:i,oldData:o})}},{key:"get",value:function(t,e){if(null==this._data)return null;var r,n=null;jP(t)||$f(t)?(n=t,r=e):r=t;var i=Hp({},this._options,r),o=Bh(this._options),a=r&&Bh(r);return o&&a&&(i.filter=function(t){return o(t)&&a(t)}),null==n?this._data.get(i):this._data.get(n,i)}},{key:"getIds",value:function(t){if(this._data.length){var e,r=Bh(this._options),n=null!=t?Bh(t):null;return e=n?r?function(t){return r(t)&&n(t)}:n:r,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var r,n,i=Bh(this._options),o=e&&Bh(e);n=o?i?function(t){return i(t)&&o(t)}:o:i,Uf(r=this._data).call(r,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var r,n,i=Bh(this._options),o=e&&Bh(e);return n=o?i?function(t){return i(t)&&o(t)}:o:i,cg(r=this._data).call(r,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||sy({},xL,Yg(e=XL(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;null!==(t=this._data)&&void 0!==t&&t.off&&this._data.off("*",this._listener);var e,n="This data view has already been disposed of.",i={get:function(){throw new Error(n)},set:function(){throw new Error(n)},configurable:!1},o=DP(tg(r.prototype));try{for(o.s();!(e=o.n()).done;){var a=e.value;Vv(this,a,i)}}catch(t){o.e(t)}finally{o.f()}}},{key:"_onEvent",value:function(t,e,r){if(e&&e.items&&this._data){var n=e.items,i=[],o=[],a=[],s=[],u=[],c=[];switch(t){case"add":for(var l=0,h=n.length;l<h;l++){var f=n[l];this.get(f)&&(this._ids.add(f),i.push(f))}break;case"update":for(var p=0,d=n.length;p<d;p++){var v=n[p];this.get(v)?this._ids.has(v)?(o.push(v),u.push(e.data[p]),s.push(e.oldData[p])):(this._ids.add(v),i.push(v)):this._ids.has(v)&&(this._ids.delete(v),a.push(v),c.push(e.oldData[p]))}break;case"remove":for(var y=0,g=n.length;y<g;y++){var m=n[y];this._ids.has(m)&&(this._ids.delete(m),a.push(m),c.push(e.oldData[y]))}}this.length+=i.length-a.length,i.length&&this._trigger("add",{items:i},r),o.length&&this._trigger("update",{items:o,oldData:s,data:u},r),a.length&&this._trigger("remove",{items:a,oldData:c},r)}}}]),r}(FP);function YP(t,e){return"object"===El(e)&&null!==e&&t===e.idProp&&"function"==typeof e.add&&"function"==typeof e.clear&&"function"==typeof e.distinct&&"function"==typeof Uf(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof cg(e)&&"function"==typeof e.max&&"function"==typeof e.min&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.remove&&"function"==typeof e.setOptions&&"function"==typeof e.stream&&"function"==typeof e.update&&"function"==typeof e.updateOnly}function GP(){this.min=void 0,this.max=void 0}GP.prototype.adjust=function(t){void 0!==t&&((void 0===this.min||this.min>t)&&(this.min=t),(void 0===this.max||this.max<t)&&(this.max=t))},GP.prototype.combine=function(t){this.add(t.min),this.add(t.max)},GP.prototype.expand=function(t){if(void 0!==t){var e=this.min-t,r=this.max+t;if(e>r)throw new Error("Passed expansion value makes range invalid");this.min=e,this.max=r}},GP.prototype.range=function(){return this.max-this.min},GP.prototype.center=function(){return(this.min+this.max)/2};var XP=GP;function VP(t,e,r){this.dataGroup=t,this.column=e,this.graph=r,this.index=void 0,this.value=void 0,this.values=t.getDistinctValues(this.column),Mf(this).length>0&&this.selectValue(0),this.dataPoints=[],this.loaded=!1,this.onLoadCallback=void 0,r.animationPreload?(this.loaded=!1,this.loadInBackground()):this.loaded=!0}function UP(){this.dataTable=null}VP.prototype.isLoaded=function(){return this.loaded},VP.prototype.getLoadedProgress=function(){for(var t=Mf(this).length,e=0;this.dataPoints[e];)e++;return Math.round(e/t*100)},VP.prototype.getLabel=function(){return this.graph.filterLabel},VP.prototype.getColumn=function(){return this.column},VP.prototype.getSelectedValue=function(){if(void 0!==this.index)return Mf(this)[this.index]},VP.prototype.getValues=function(){return Mf(this)},VP.prototype.getValue=function(t){if(t>=Mf(this).length)throw new Error("Index out of range");return Mf(this)[t]},VP.prototype._getDataPoints=function(t){if(void 0===t&&(t=this.index),void 0===t)return[];var e;if(this.dataPoints[t])e=this.dataPoints[t];else{var r={};r.column=this.column,r.value=Mf(this)[t];var n=new WP(this.dataGroup.getDataSet(),{filter:function(t){return t[r.column]==r.value}}).get();e=this.dataGroup._getDataPoints(n),this.dataPoints[t]=e}return e},VP.prototype.setOnLoadCallback=function(t){this.onLoadCallback=t},VP.prototype.selectValue=function(t){if(t>=Mf(this).length)throw new Error("Index out of range");this.index=t,this.value=Mf(this)[t]},VP.prototype.loadInBackground=function(t){void 0===t&&(t=0);var e=this.graph.frame;if(t<Mf(this).length){void 0===e.progress&&(e.progress=document.createElement("DIV"),e.progress.style.position="absolute",e.progress.style.color="gray",e.appendChild(e.progress));var r=this.getLoadedProgress();e.progress.innerHTML="Loading animation... "+r+"%",e.progress.style.bottom="60px",e.progress.style.left="10px";var n=this;Pp((function(){n.loadInBackground(t+1)}),10),this.loaded=!1}else this.loaded=!0,void 0!==e.progress&&(e.removeChild(e.progress),e.progress=void 0),this.onLoadCallback&&this.onLoadCallback()},UP.prototype.initializeData=function(t,e,r){if(void 0!==e){var n;if($f(e)&&(e=new BP(e)),!(e instanceof BP||e instanceof WP))throw new Error("Array, DataSet, or DataView expected");if(0!=(n=e.get()).length){this.style=r,this.dataSet&&this.dataSet.off("*",this._onChange),this.dataSet=e,this.dataTable=n;var i=this;this._onChange=function(){t.setData(i.dataSet)},this.dataSet.on("*",this._onChange),this.colX="x",this.colY="y",this.colZ="z";var o=t.hasBars(r);if(o&&(void 0!==t.defaultXBarWidth?this.xBarWidth=t.defaultXBarWidth:this.xBarWidth=this.getSmallestDifference(n,this.colX)||1,void 0!==t.defaultYBarWidth?this.yBarWidth=t.defaultYBarWidth:this.yBarWidth=this.getSmallestDifference(n,this.colY)||1),this._initializeRange(n,this.colX,t,o),this._initializeRange(n,this.colY,t,o),this._initializeRange(n,this.colZ,t,!1),Object.prototype.hasOwnProperty.call(n[0],"style")){this.colValue="style";var a=this.getColumnRange(n,this.colValue);this._setRangeDefaults(a,t.defaultValueMin,t.defaultValueMax),this.valueRange=a}else this.colValue="z",this.valueRange=this.zRange;var s=this.getDataTable();return Object.prototype.hasOwnProperty.call(s[0],"filter")&&void 0===this.dataFilter&&(this.dataFilter=new VP(this,"filter",t),this.dataFilter.setOnLoadCallback((function(){t.redraw()}))),this.dataFilter?this.dataFilter._getDataPoints():this._getDataPoints(this.getDataTable())}}},UP.prototype._collectRangeSettings=function(t,e){var r;if(-1==Ph(r=["x","y","z"]).call(r,t))throw new Error("Column '"+t+"' invalid");var n=t.toUpperCase();return{barWidth:this[t+"BarWidth"],min:e["default"+n+"Min"],max:e["default"+n+"Max"],step:e["default"+n+"Step"],range_label:t+"Range",step_label:t+"Step"}},UP.prototype._initializeRange=function(t,e,r,n){var i=this._collectRangeSettings(e,r),o=this.getColumnRange(t,e);n&&"z"!=e&&o.expand(i.barWidth/2),this._setRangeDefaults(o,i.min,i.max),this[i.range_label]=o,this[i.step_label]=void 0!==i.step?i.step:o.range()/5},UP.prototype.getDistinctValues=function(t,e){void 0===e&&(e=this.dataTable);for(var r=[],n=0;n<e.length;n++){var i=e[n][t]||0;-1===Ph(r).call(r,i)&&r.push(i)}return mh(r).call(r,(function(t,e){return t-e}))},UP.prototype.getSmallestDifference=function(t,e){for(var r=this.getDistinctValues(t,e),n=null,i=1;i<r.length;i++){var o=r[i]-r[i-1];(null==n||n>o)&&(n=o)}return n},UP.prototype.getColumnRange=function(t,e){for(var r=new XP,n=0;n<t.length;n++){var i=t[n][e];r.adjust(i)}return r},UP.prototype.getNumberOfRows=function(){return this.dataTable.length},UP.prototype._setRangeDefaults=function(t,e,r){void 0!==e&&(t.min=e),void 0!==r&&(t.max=r),t.max<=t.min&&(t.max=t.min+1)},UP.prototype.getDataTable=function(){return this.dataTable},UP.prototype.getDataSet=function(){return this.dataSet},UP.prototype.getDataPoints=function(t){for(var e=[],r=0;r<t.length;r++){var n=new R_;n.x=t[r][this.colX]||0,n.y=t[r][this.colY]||0,n.z=t[r][this.colZ]||0,n.data=t[r],n.value=t[r][this.colValue]||0;var i={};i.point=n,i.bottom=new R_(n.x,n.y,this.zRange.min),i.trans=void 0,i.screen=void 0,e.push(i)}return e},UP.prototype.initDataAsMatrix=function(t){var e,r,n,i,o=this.getDistinctValues(this.colX,t),a=this.getDistinctValues(this.colY,t),s=this.getDataPoints(t),u=[];for(n=0;n<s.length;n++){i=s[n];var c=Ph(o).call(o,i.point.x),l=Ph(a).call(a,i.point.y);void 0===u[c]&&(u[c]=[]),u[c][l]=i}for(e=0;e<u.length;e++)for(r=0;r<u[e].length;r++)u[e][r]&&(u[e][r].pointRight=e<u.length-1?u[e+1][r]:void 0,u[e][r].pointTop=r<u[e].length-1?u[e][r+1]:void 0,u[e][r].pointCross=e<u.length-1&&r<u[e].length-1?u[e+1][r+1]:void 0);return s},UP.prototype.getInfo=function(){var t=this.dataFilter;if(t)return t.getLabel()+": "+t.getSelectedValue()},UP.prototype.reload=function(){this.dataTable&&this.setData(this.dataTable)},UP.prototype._getDataPoints=function(t){var e=[];if(this.style===X_.GRID||this.style===X_.SURFACE)e=this.initDataAsMatrix(t);else if(e=this.getDataPoints(t),this.style===X_.LINE)for(var r=0;r<e.length;r++)r>0&&(e[r-1].pointNext=e[r]);return e},qP.STYLE=X_;var ZP=void 0;function qP(t,e,r){if(!(this instanceof qP))throw new SyntaxError("Constructor must be called with the new operator");this.containerElement=t,this.dataGroup=new UP,this.dataPoints=null,this.create(),function(t,e){if(void 0===t||H_(t))throw new Error("No DEFAULTS passed");if(void 0===e)throw new Error("No dst passed");q_=t,K_(t,e,U_),K_(t,e,Z_,"default"),Q_(t,e),e.margin=10,e.showTooltip=!1,e.onclick_callback=null,e.eye=new R_(0,0,-1)}(qP.DEFAULTS,this),this.colX=void 0,this.colY=void 0,this.colZ=void 0,this.colValue=void 0,this.setOptions(r),this.setData(e)}function HP(t){return"clientX"in t?t.clientX:t.targetTouches[0]&&t.targetTouches[0].clientX||0}function $P(t){return"clientY"in t?t.clientY:t.targetTouches[0]&&t.targetTouches[0].clientY||0}qP.DEFAULTS={width:"400px",height:"400px",filterLabel:"time",legendLabel:"value",xLabel:"x",yLabel:"y",zLabel:"z",xValueLabel:function(t){return t},yValueLabel:function(t){return t},zValueLabel:function(t){return t},showXAxis:!0,showYAxis:!0,showZAxis:!0,showGrayBottom:!1,showGrid:!0,showPerspective:!0,showShadow:!1,showSurfaceGrid:!0,keepAspectRatio:!0,rotateAxisLabels:!0,verticalRatio:.5,dotSizeRatio:.02,dotSizeMinFraction:.5,dotSizeMaxFraction:2.5,showAnimationControls:ZP,animationInterval:1e3,animationPreload:!1,animationAutoStart:ZP,axisFontSize:14,axisFontType:"arial",axisColor:"#4D4D4D",gridColor:"#D3D3D3",xCenter:"55%",yCenter:"50%",style:qP.STYLE.DOT,tooltip:!1,tooltipDelay:300,tooltipStyle:{content:{padding:"10px",border:"1px solid #4d4d4d",color:"#1a1a1a",background:"rgba(255,255,255,0.7)",borderRadius:"2px",boxShadow:"5px 5px 10px rgba(128,128,128,0.5)"},line:{height:"40px",width:"0",borderLeft:"1px solid #4d4d4d",pointerEvents:"none"},dot:{height:"0",width:"0",border:"5px solid #4d4d4d",borderRadius:"5px",pointerEvents:"none"}},dataColor:{fill:"#7DC1FF",stroke:"#3267D2",strokeWidth:1},surfaceColors:ZP,colormap:ZP,cameraPosition:{horizontal:1,vertical:.5,distance:1.7},zoomable:!0,ctrlToZoom:!1,showLegend:ZP,backgroundColor:ZP,xBarWidth:ZP,yBarWidth:ZP,valueMin:ZP,valueMax:ZP,xMin:ZP,xMax:ZP,xStep:ZP,yMin:ZP,yMax:ZP,yStep:ZP,zMin:ZP,zMax:ZP,zStep:ZP},Kp(qP.prototype),qP.prototype._setScale=function(){this.scale=new R_(1/this.xRange.range(),1/this.yRange.range(),1/this.zRange.range()),this.keepAspectRatio&&(this.scale.x<this.scale.y?this.scale.y=this.scale.x:this.scale.x=this.scale.y),this.scale.z*=this.verticalRatio,void 0!==this.valueRange&&(this.scale.value=1/this.valueRange.range());var t=this.xRange.center()*this.scale.x,e=this.yRange.center()*this.scale.y,r=this.zRange.center()*this.scale.z;this.camera.setArmLocation(t,e,r)},qP.prototype._convert3Dto2D=function(t){var e=this._convertPointToTranslation(t);return this._convertTranslationToScreen(e)},qP.prototype._convertPointToTranslation=function(t){var e=this.camera.getCameraLocation(),r=this.camera.getCameraRotation(),n=t.x*this.scale.x,i=t.y*this.scale.y,o=t.z*this.scale.z,a=e.x,s=e.y,u=e.z,c=Math.sin(r.x),l=Math.cos(r.x),h=Math.sin(r.y),f=Math.cos(r.y),p=Math.sin(r.z),d=Math.cos(r.z);return new R_(f*(p*(i-s)+d*(n-a))-h*(o-u),c*(f*(o-u)+h*(p*(i-s)+d*(n-a)))+l*(d*(i-s)-p*(n-a)),l*(f*(o-u)+h*(p*(i-s)+d*(n-a)))-c*(d*(i-s)-p*(n-a)))},qP.prototype._convertTranslationToScreen=function(t){var e,r,n=this.eye.x,i=this.eye.y,o=this.eye.z,a=t.x,s=t.y,u=t.z;return this.showPerspective?(e=o/u*(a-n),r=o/u*(s-i)):(e=a*(-o/this.camera.getArmLength()),r=s*(-o/this.camera.getArmLength())),new I_(this.currentXCenter+e*this.frame.canvas.clientWidth,this.currentYCenter-r*this.frame.canvas.clientWidth)},qP.prototype._calcTranslations=function(t){for(var e=0;e<t.length;e++){var r=t[e];r.trans=this._convertPointToTranslation(r.point),r.screen=this._convertTranslationToScreen(r.trans);var n=this._convertPointToTranslation(r.bottom);r.dist=this.showPerspective?n.length():-n.z}mh(t).call(t,(function(t,e){return e.dist-t.dist}))},qP.prototype._initializeRanges=function(){var t=this.dataGroup;this.xRange=t.xRange,this.yRange=t.yRange,this.zRange=t.zRange,this.valueRange=t.valueRange,this.xStep=t.xStep,this.yStep=t.yStep,this.zStep=t.zStep,this.xBarWidth=t.xBarWidth,this.yBarWidth=t.yBarWidth,this.colX=t.colX,this.colY=t.colY,this.colZ=t.colZ,this.colValue=t.colValue,this._setScale()},qP.prototype.getDataPoints=function(t){for(var e=[],r=0;r<t.length;r++){var n=new R_;n.x=t[r][this.colX]||0,n.y=t[r][this.colY]||0,n.z=t[r][this.colZ]||0,n.data=t[r],n.value=t[r][this.colValue]||0;var i={};i.point=n,i.bottom=new R_(n.x,n.y,this.zRange.min),i.trans=void 0,i.screen=void 0,e.push(i)}return e},qP.prototype._getDataPoints=function(t){var e,r,n,i,o=[];if(this.style===qP.STYLE.GRID||this.style===qP.STYLE.SURFACE){var a=this.dataGroup.getDistinctValues(this.colX,t),s=this.dataGroup.getDistinctValues(this.colY,t);o=this.getDataPoints(t);var u=[];for(n=0;n<o.length;n++){i=o[n];var c=Ph(a).call(a,i.point.x),l=Ph(s).call(s,i.point.y);void 0===u[c]&&(u[c]=[]),u[c][l]=i}for(e=0;e<u.length;e++)for(r=0;r<u[e].length;r++)u[e][r]&&(u[e][r].pointRight=e<u.length-1?u[e+1][r]:void 0,u[e][r].pointTop=r<u[e].length-1?u[e][r+1]:void 0,u[e][r].pointCross=e<u.length-1&&r<u[e].length-1?u[e+1][r+1]:void 0)}else if(o=this.getDataPoints(t),this.style===qP.STYLE.LINE)for(n=0;n<o.length;n++)n>0&&(o[n-1].pointNext=o[n]);return o},qP.prototype.create=function(){for(;this.containerElement.hasChildNodes();)this.containerElement.removeChild(this.containerElement.firstChild);this.frame=document.createElement("div"),this.frame.style.position="relative",this.frame.style.overflow="hidden",this.frame.canvas=document.createElement("canvas"),this.frame.canvas.style.position="relative",this.frame.appendChild(this.frame.canvas);var t=document.createElement("DIV");t.style.color="red",t.style.fontWeight="bold",t.style.padding="10px",t.innerHTML="Error: your browser does not support HTML canvas",this.frame.canvas.appendChild(t),this.frame.filter=document.createElement("div"),Bh(this.frame).style.position="absolute",Bh(this.frame).style.bottom="0px",Bh(this.frame).style.left="0px",Bh(this.frame).style.width="100%",this.frame.appendChild(Bh(this.frame));var e=this;S_(this.frame.canvas,"mousedown",(function(t){e._onMouseDown(t)})),S_(this.frame.canvas,"touchstart",(function(t){e._onTouchStart(t)})),S_(this.frame.canvas,"mousewheel",(function(t){e._onWheel(t)})),S_(this.frame.canvas,"mousemove",(function(t){e._onTooltip(t)})),S_(this.frame.canvas,"click",(function(t){e._onClick(t)})),this.containerElement.appendChild(this.frame)},qP.prototype._setSize=function(t,e){this.frame.style.width=t,this.frame.style.height=e,this._resizeCanvas()},qP.prototype._resizeCanvas=function(){this.frame.canvas.style.width="100%",this.frame.canvas.style.height="100%",this.frame.canvas.width=this.frame.canvas.clientWidth,this.frame.canvas.height=this.frame.canvas.clientHeight,Bh(this.frame).style.width=this.frame.canvas.clientWidth-20+"px"},qP.prototype.animationStart=function(){if(this.animationAutoStart&&this.dataGroup.dataFilter){if(!Bh(this.frame)||!Bh(this.frame).slider)throw new Error("No animation available");Bh(this.frame).slider.play()}},qP.prototype.animationStop=function(){Bh(this.frame)&&Bh(this.frame).slider&&Bh(this.frame).slider.stop()},qP.prototype._resizeCenter=function(){"%"===this.xCenter.charAt(this.xCenter.length-1)?this.currentXCenter=lf(this.xCenter)/100*this.frame.canvas.clientWidth:this.currentXCenter=lf(this.xCenter),"%"===this.yCenter.charAt(this.yCenter.length-1)?this.currentYCenter=lf(this.yCenter)/100*(this.frame.canvas.clientHeight-Bh(this.frame).clientHeight):this.currentYCenter=lf(this.yCenter)},qP.prototype.getCameraPosition=function(){var t=this.camera.getArmRotation();return t.distance=this.camera.getArmLength(),t},qP.prototype._readData=function(t){this.dataPoints=this.dataGroup.initializeData(this,t,this.style),this._initializeRanges(),this._redrawFilter()},qP.prototype.setData=function(t){null!=t&&(this._readData(t),this.redraw(),this.animationStart())},qP.prototype.setOptions=function(t){void 0!==t&&(!0===D_.validate(t,cS)&&console.error("%cErrors have been found in the supplied options object.",P_),this.animationStop(),function(t,e){if(void 0!==t){if(void 0===e)throw new Error("No dst passed");if(void 0===q_||H_(q_))throw new Error("DEFAULTS not set for module Settings");J_(t,e,U_),J_(t,e,Z_,"default"),Q_(t,e)}}(t,this),this.setPointDrawingMethod(),this._setSize(this.width,this.height),this.setAxisLabelMethod(),this.setData(this.dataGroup.getDataTable()),this.animationStart())},qP.prototype.setPointDrawingMethod=function(){var t=void 0;switch(this.style){case qP.STYLE.BAR:t=this._redrawBarGraphPoint;break;case qP.STYLE.BARCOLOR:t=this._redrawBarColorGraphPoint;break;case qP.STYLE.BARSIZE:t=this._redrawBarSizeGraphPoint;break;case qP.STYLE.DOT:t=this._redrawDotGraphPoint;break;case qP.STYLE.DOTLINE:t=this._redrawDotLineGraphPoint;break;case qP.STYLE.DOTCOLOR:t=this._redrawDotColorGraphPoint;break;case qP.STYLE.DOTSIZE:t=this._redrawDotSizeGraphPoint;break;case qP.STYLE.SURFACE:t=this._redrawSurfaceGraphPoint;break;case qP.STYLE.GRID:t=this._redrawGridGraphPoint;break;case qP.STYLE.LINE:t=this._redrawLineGraphPoint;break;default:throw new Error("Can not determine point drawing method for graph style '"+this.style+"'")}this._pointDrawingMethod=t},qP.prototype.setAxisLabelMethod=function(){this.rotateAxisLabels?(this._drawAxisLabelX=this.drawAxisLabelXRotate,this._drawAxisLabelY=this.drawAxisLabelYRotate,this._drawAxisLabelZ=this.drawAxisLabelZRotate):(this._drawAxisLabelX=this.drawAxisLabelX,this._drawAxisLabelY=this.drawAxisLabelY,this._drawAxisLabelZ=this.drawAxisLabelZ)},qP.prototype.redraw=function(){if(void 0===this.dataPoints)throw new Error("Graph data not initialized");this._resizeCanvas(),this._resizeCenter(),this._redrawSlider(),this._redrawClear(),this._redrawAxis(),this._redrawDataGraph(),this._redrawInfo(),this._redrawLegend()},qP.prototype._getContext=function(){var t=this.frame.canvas.getContext("2d");return t.lineJoin="round",t.lineCap="round",t},qP.prototype._redrawClear=function(){var t=this.frame.canvas;t.getContext("2d").clearRect(0,0,t.width,t.height)},qP.prototype._dotSize=function(){return this.frame.clientWidth*this.dotSizeRatio},qP.prototype._getLegendWidth=function(){var t;this.style===qP.STYLE.DOTSIZE?t=this._dotSize()*this.dotSizeMaxFraction:t=this.style===qP.STYLE.BARSIZE?this.xBarWidth:20;return t},qP.prototype._redrawLegend=function(){if(!0===this.showLegend&&this.style!==qP.STYLE.LINE&&this.style!==qP.STYLE.BARSIZE){var t=this.style===qP.STYLE.BARSIZE||this.style===qP.STYLE.DOTSIZE,e=this.style===qP.STYLE.DOTSIZE||this.style===qP.STYLE.DOTCOLOR||this.style===qP.STYLE.SURFACE||this.style===qP.STYLE.BARCOLOR,r=Math.max(.25*this.frame.clientHeight,100),n=this.margin,i=this._getLegendWidth(),o=this.frame.clientWidth-this.margin,a=o-i,s=n+r,u=this._getContext();if(u.lineWidth=1,u.font="14px arial",!1===t){var c,l=r;for(c=0;c<l;c++){var h=1-(c-0)/(l-0),f=this._colormap(h,1);u.strokeStyle=f,u.beginPath(),u.moveTo(a,n+c),u.lineTo(o,n+c),u.stroke()}u.strokeStyle=this.axisColor,u.strokeRect(a,n,i,r)}else{var p;this.style===qP.STYLE.DOTSIZE?p=i*(this.dotSizeMinFraction/this.dotSizeMaxFraction):(this.style,qP.STYLE.BARSIZE),u.strokeStyle=this.axisColor,u.fillStyle=_f(this.dataColor),u.beginPath(),u.moveTo(a,n),u.lineTo(o,n),u.lineTo(a+p,s),u.lineTo(a,s),u.closePath(),_f(u).call(u),u.stroke()}var d=e?this.valueRange.min:this.zRange.min,v=e?this.valueRange.max:this.zRange.max,y=new F_(d,v,(v-d)/5,!0);for(y.start(!0);!y.end();){var g=s-(y.getCurrent()-d)/(v-d)*r,m=new I_(a-5,g),x=new I_(a,g);this._line(u,m,x),u.textAlign="right",u.textBaseline="middle",u.fillStyle=this.axisColor,u.fillText(y.getCurrent(),a-10,g),y.next()}u.textAlign="right",u.textBaseline="top";var b=this.legendLabel;u.fillText(b,o,s+this.margin)}},qP.prototype._redrawFilter=function(){var t=this.dataGroup.dataFilter,e=Bh(this.frame);if(e.innerHTML="",t){var r=new j_(e,{visible:this.showAnimationControls});e.slider=r,e.style.padding="10px",r.setValues(Mf(t)),r.setPlayInterval(this.animationInterval);var n=this;r.setOnChangeCallback((function(){var t=n.dataGroup.dataFilter,e=r.getIndex();t.selectValue(e),n.dataPoints=t._getDataPoints(),n.redraw()}))}else e.slider=void 0},qP.prototype._redrawSlider=function(){void 0!==Bh(this.frame).slider&&Bh(this.frame).slider.redraw()},qP.prototype._redrawInfo=function(){var t=this.dataGroup.getInfo();if(void 0!==t){var e=this._getContext();e.font="14px arial",e.lineStyle="gray",e.fillStyle="gray",e.textAlign="left",e.textBaseline="top";var r=this.margin,n=this.margin;e.fillText(t,r,n)}},qP.prototype._line=function(t,e,r,n){void 0!==n&&(t.strokeStyle=n),t.beginPath(),t.moveTo(e.x,e.y),t.lineTo(r.x,r.y),t.stroke()},qP.prototype.drawAxisLabelX=function(t,e,r,n,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*n)>0?(t.textAlign="center",t.textBaseline="top",o.y+=i):Math.sin(2*n)<0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)},qP.prototype.drawAxisLabelY=function(t,e,r,n,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*n)<0?(t.textAlign="center",t.textBaseline="top",o.y+=i):Math.sin(2*n)>0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)},qP.prototype.drawAxisLabelZ=function(t,e,r,n){void 0===n&&(n=0);var i=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,i.x-n,i.y)},qP.prototype.drawAxisLabelXRotate=function(t,e,r,n,i){var o=this._convert3Dto2D(e);Math.cos(2*n)>0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,0,0),t.restore()):Math.sin(2*n)<0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y))},qP.prototype.drawAxisLabelYRotate=function(t,e,r,n,i){var o=this._convert3Dto2D(e);Math.cos(2*n)<0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,0,0),t.restore()):Math.sin(2*n)>0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y))},qP.prototype.drawAxisLabelZRotate=function(t,e,r,n){void 0===n&&(n=0);var i=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,i.x-n,i.y)},qP.prototype._line3d=function(t,e,r,n){var i=this._convert3Dto2D(e),o=this._convert3Dto2D(r);this._line(t,i,o,n)},qP.prototype._redrawAxis=function(){var t,e,r,n,i,o,a,s,u,c,l=this._getContext();l.font=this.axisFontSize/this.camera.getArmLength()+"px "+this.axisFontType;var h,f,p,d=.025/this.scale.x,v=.025/this.scale.y,y=5/this.camera.getArmLength(),g=this.camera.getArmRotation().horizontal,m=new I_(Math.cos(g),Math.sin(g)),x=this.xRange,b=this.yRange,w=this.zRange;for(l.lineWidth=1,n=void 0===this.defaultXStep,(r=new F_(x.min,x.max,this.xStep,n)).start(!0);!r.end();){var _=r.getCurrent();if(this.showGrid?(t=new R_(_,b.min,w.min),e=new R_(_,b.max,w.min),this._line3d(l,t,e,this.gridColor)):this.showXAxis&&(t=new R_(_,b.min,w.min),e=new R_(_,b.min+d,w.min),this._line3d(l,t,e,this.axisColor),t=new R_(_,b.max,w.min),e=new R_(_,b.max-d,w.min),this._line3d(l,t,e,this.axisColor)),this.showXAxis){a=m.x>0?b.min:b.max,h=new R_(_,a,w.min);var S="  "+this.xValueLabel(_)+"  ";this._drawAxisLabelX.call(this,l,h,S,g,y)}r.next()}for(l.lineWidth=1,n=void 0===this.defaultYStep,(r=new F_(b.min,b.max,this.yStep,n)).start(!0);!r.end();){var T=r.getCurrent();if(this.showGrid?(t=new R_(x.min,T,w.min),e=new R_(x.max,T,w.min),this._line3d(l,t,e,this.gridColor)):this.showYAxis&&(t=new R_(x.min,T,w.min),e=new R_(x.min+v,T,w.min),this._line3d(l,t,e,this.axisColor),t=new R_(x.max,T,w.min),e=new R_(x.max-v,T,w.min),this._line3d(l,t,e,this.axisColor)),this.showYAxis){o=m.y>0?x.min:x.max,h=new R_(o,T,w.min);var E="  "+this.yValueLabel(T)+"  ";this._drawAxisLabelY.call(this,l,h,E,g,y)}r.next()}if(this.showZAxis){for(l.lineWidth=1,n=void 0===this.defaultZStep,(r=new F_(w.min,w.max,this.zStep,n)).start(!0),o=m.x>0?x.min:x.max,a=m.y<0?b.min:b.max;!r.end();){var k=r.getCurrent(),O=new R_(o,a,k),C=this._convert3Dto2D(O);e=new I_(C.x-y,C.y),this._line(l,C,e,this.axisColor);var A=this.zValueLabel(k)+" ";this._drawAxisLabelZ.call(this,l,O,A,5),r.next()}l.lineWidth=1,t=new R_(o,a,w.min),e=new R_(o,a,w.max),this._line3d(l,t,e,this.axisColor)}this.showXAxis&&(l.lineWidth=1,f=new R_(x.min,b.min,w.min),p=new R_(x.max,b.min,w.min),this._line3d(l,f,p,this.axisColor),f=new R_(x.min,b.max,w.min),p=new R_(x.max,b.max,w.min),this._line3d(l,f,p,this.axisColor));this.showYAxis&&(l.lineWidth=1,t=new R_(x.min,b.min,w.min),e=new R_(x.min,b.max,w.min),this._line3d(l,t,e,this.axisColor),t=new R_(x.max,b.min,w.min),e=new R_(x.max,b.max,w.min),this._line3d(l,t,e,this.axisColor));var L=this.xLabel;L.length>0&&this.showXAxis&&(c=.1/this.scale.y,o=(x.max+3*x.min)/4,a=m.x>0?b.min-c:b.max+c,i=new R_(o,a,w.min),this.drawAxisLabelX(l,i,L,g));var P=this.yLabel;P.length>0&&this.showYAxis&&(u=.1/this.scale.x,o=m.y>0?x.min-u:x.max+u,a=(b.max+3*b.min)/4,i=new R_(o,a,w.min),this.drawAxisLabelY(l,i,P,g));var D=this.zLabel;D.length>0&&this.showZAxis&&(30,o=m.x>0?x.min:x.max,a=m.y<0?b.min:b.max,s=(w.max+3*w.min)/4,i=new R_(o,a,s),this.drawAxisLabelZ(l,i,D,30))},qP.prototype._getStrokeWidth=function(t){return void 0!==t?this.showPerspective?1/-t.trans.z*this.dataColor.strokeWidth:-this.eye.z/this.camera.getArmLength()*this.dataColor.strokeWidth:this.dataColor.strokeWidth},qP.prototype._redrawBar=function(t,e,r,n,i,o){var a,s=this,u=e.point,c=this.zRange.min,l=[{point:new R_(u.x-r,u.y-n,u.z)},{point:new R_(u.x+r,u.y-n,u.z)},{point:new R_(u.x+r,u.y+n,u.z)},{point:new R_(u.x-r,u.y+n,u.z)}],h=[{point:new R_(u.x-r,u.y-n,c)},{point:new R_(u.x+r,u.y-n,c)},{point:new R_(u.x+r,u.y+n,c)},{point:new R_(u.x-r,u.y+n,c)}];Uf(l).call(l,(function(t){t.screen=s._convert3Dto2D(t.point)})),Uf(h).call(h,(function(t){t.screen=s._convert3Dto2D(t.point)}));var f=[{corners:l,center:R_.avg(h[0].point,h[2].point)},{corners:[l[0],l[1],h[1],h[0]],center:R_.avg(h[1].point,h[0].point)},{corners:[l[1],l[2],h[2],h[1]],center:R_.avg(h[2].point,h[1].point)},{corners:[l[2],l[3],h[3],h[2]],center:R_.avg(h[3].point,h[2].point)},{corners:[l[3],l[0],h[0],h[3]],center:R_.avg(h[0].point,h[3].point)}];e.surfaces=f;for(var p=0;p<f.length;p++){a=f[p];var d=this._convertPointToTranslation(a.center);a.dist=this.showPerspective?d.length():-d.z}mh(f).call(f,(function(t,e){var r=e.dist-t.dist;return r||(t.corners===l?1:e.corners===l?-1:0)})),t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=o,t.fillStyle=i;for(var v=2;v<f.length;v++)a=f[v],this._polygon(t,a.corners)},qP.prototype._polygon=function(t,e,r,n){if(!(e.length<2)){void 0!==r&&(t.fillStyle=r),void 0!==n&&(t.strokeStyle=n),t.beginPath(),t.moveTo(e[0].screen.x,e[0].screen.y);for(var i=1;i<e.length;++i){var o=e[i];t.lineTo(o.screen.x,o.screen.y)}t.closePath(),_f(t).call(t),t.stroke()}},qP.prototype._drawCircle=function(t,e,r,n,i){var o=this._calcRadius(e,i);t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=n,t.fillStyle=r,t.beginPath(),t.arc(e.screen.x,e.screen.y,o,0,2*Math.PI,!0),_f(t).call(t),t.stroke()},qP.prototype._getColorsRegular=function(t){var e=(t.point.value-this.valueRange.min)*this.scale.value;return{fill:this._colormap(e,1),border:this._colormap(e,.8)}},qP.prototype._getColorsColor=function(t){var e,r,n;if(t&&t.point&&t.point.data&&t.point.data.style&&(n=t.point.data.style),n&&"object"===El(n)&&_f(n)&&n.stroke)return{fill:_f(n),border:n.stroke};if("string"==typeof t.point.value)e=t.point.value,r=t.point.value;else{var i=(t.point.value-this.valueRange.min)*this.scale.value;e=this._colormap(i,1),r=this._colormap(i,.8)}return{fill:e,border:r}},qP.prototype._getColorsSize=function(){return{fill:_f(this.dataColor),border:this.dataColor.stroke}},qP.prototype._colormap=function(t){var e,r,n,i,o,a,s,u,c,l=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1,h=this.colormap;if($f(h)){var f=h.length-1,p=Math.max(Math.floor(t*f),0),d=Math.min(p+1,f),v=t*f-p,y=h[p],g=h[d];e=y.r+v*(g.r-y.r),r=y.g+v*(g.g-y.g),n=y.b+v*(g.b-y.b)}else if("function"==typeof h){var m=h(t);e=m.r,r=m.g,n=m.b,i=m.a}else{var x=k_(240*(1-t)/360,1,1);e=x.r,r=x.g,n=x.b}return"number"!=typeof i||tp(i)?up(o=up(a="RGB(".concat(Math.round(e*l),", ")).call(a,Math.round(r*l),", ")).call(o,Math.round(n*l),")"):up(s=up(u=up(c="RGBA(".concat(Math.round(e*l),", ")).call(c,Math.round(r*l),", ")).call(u,Math.round(n*l),", ")).call(s,i,")")},qP.prototype._calcRadius=function(t,e){var r;return void 0===e&&(e=this._dotSize()),(r=this.showPerspective?e/-t.trans.z:e*(-this.eye.z/this.camera.getArmLength()))<0&&(r=0),r},qP.prototype._redrawBarGraphPoint=function(t,e){var r=this.xBarWidth/2,n=this.yBarWidth/2,i=this._getColorsRegular(e);this._redrawBar(t,e,r,n,_f(i),i.border)},qP.prototype._redrawBarColorGraphPoint=function(t,e){var r=this.xBarWidth/2,n=this.yBarWidth/2,i=this._getColorsColor(e);this._redrawBar(t,e,r,n,_f(i),i.border)},qP.prototype._redrawBarSizeGraphPoint=function(t,e){var r=(e.point.value-this.valueRange.min)/this.valueRange.range(),n=this.xBarWidth/2*(.8*r+.2),i=this.yBarWidth/2*(.8*r+.2),o=this._getColorsSize();this._redrawBar(t,e,n,i,_f(o),o.border)},qP.prototype._redrawDotGraphPoint=function(t,e){var r=this._getColorsRegular(e);this._drawCircle(t,e,_f(r),r.border)},qP.prototype._redrawDotLineGraphPoint=function(t,e){var r=this._convert3Dto2D(e.bottom);t.lineWidth=1,this._line(t,r,e.screen,this.gridColor),this._redrawDotGraphPoint(t,e)},qP.prototype._redrawDotColorGraphPoint=function(t,e){var r=this._getColorsColor(e);this._drawCircle(t,e,_f(r),r.border)},qP.prototype._redrawDotSizeGraphPoint=function(t,e){var r=this._dotSize(),n=(e.point.value-this.valueRange.min)/this.valueRange.range(),i=r*this.dotSizeMinFraction,o=i+(r*this.dotSizeMaxFraction-i)*n,a=this._getColorsSize();this._drawCircle(t,e,_f(a),a.border,o)},qP.prototype._redrawSurfaceGraphPoint=function(t,e){var r=e.pointRight,n=e.pointTop,i=e.pointCross;if(void 0!==e&&void 0!==r&&void 0!==n&&void 0!==i){var o,a,s,u=!0;if(this.showGrayBottom||this.showShadow){var c=R_.subtract(i.trans,e.trans),l=R_.subtract(n.trans,r.trans),h=R_.crossProduct(c,l);if(this.showPerspective){var f=R_.avg(R_.avg(e.trans,i.trans),R_.avg(r.trans,n.trans));s=-R_.dotProduct(h.normalize(),f.normalize())}else s=h.z/h.length();u=s>0}if(u||!this.showGrayBottom){var p=((e.point.value+r.point.value+n.point.value+i.point.value)/4-this.valueRange.min)*this.scale.value,d=this.showShadow?(1+s)/2:1;o=this._colormap(p,d)}else o="gray";a=this.showSurfaceGrid?this.axisColor:o,t.lineWidth=this._getStrokeWidth(e);var v=[e,r,i,n];this._polygon(t,v,o,a)}},qP.prototype._drawGridLine=function(t,e,r){if(void 0!==e&&void 0!==r){var n=((e.point.value+r.point.value)/2-this.valueRange.min)*this.scale.value;t.lineWidth=2*this._getStrokeWidth(e),t.strokeStyle=this._colormap(n,1),this._line(t,e.screen,r.screen)}},qP.prototype._redrawGridGraphPoint=function(t,e){this._drawGridLine(t,e,e.pointRight),this._drawGridLine(t,e,e.pointTop)},qP.prototype._redrawLineGraphPoint=function(t,e){void 0!==e.pointNext&&(t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=this.dataColor.stroke,this._line(t,e.screen,e.pointNext.screen))},qP.prototype._redrawDataGraph=function(){var t,e=this._getContext();if(!(void 0===this.dataPoints||this.dataPoints.length<=0))for(this._calcTranslations(this.dataPoints),t=0;t<this.dataPoints.length;t++){var r=this.dataPoints[t];this._pointDrawingMethod.call(this,e,r)}},qP.prototype._storeMousePosition=function(t){this.startMouseX=HP(t),this.startMouseY=$P(t),this._startCameraOffset=this.camera.getOffset()},qP.prototype._onMouseDown=function(t){if(t=t||window.event,this.leftButtonDown&&this._onMouseUp(t),this.leftButtonDown=t.which?1===t.which:1===t.button,this.leftButtonDown||this.touchDown){this._storeMousePosition(t),this.startStart=new Date(this.start),this.startEnd=new Date(this.end),this.startArmRotation=this.camera.getArmRotation(),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},S_(document,"mousemove",e.onmousemove),S_(document,"mouseup",e.onmouseup),E_(t)}},qP.prototype._onMouseMove=function(t){this.moving=!0,t=t||window.event;var e=lf(HP(t))-this.startMouseX,r=lf($P(t))-this.startMouseY;if(t&&!0===t.ctrlKey){var n=.5*this.frame.clientWidth,i=.5*this.frame.clientHeight,o=(this._startCameraOffset.x||0)-e/n*this.camera.armLength*.8,a=(this._startCameraOffset.y||0)+r/i*this.camera.armLength*.8;this.camera.setOffset(o,a),this._storeMousePosition(t)}else{var s=this.startArmRotation.horizontal+e/200,u=this.startArmRotation.vertical+r/200,c=Math.sin(4/360*2*Math.PI);Math.abs(Math.sin(s))<c&&(s=Math.round(s/Math.PI)*Math.PI-.001),Math.abs(Math.cos(s))<c&&(s=(Math.round(s/Math.PI-.5)+.5)*Math.PI-.001),Math.abs(Math.sin(u))<c&&(u=Math.round(u/Math.PI)*Math.PI),Math.abs(Math.cos(u))<c&&(u=(Math.round(u/Math.PI-.5)+.5)*Math.PI),this.camera.setArmRotation(s,u)}this.redraw();var l=this.getCameraPosition();this.emit("cameraPositionChange",l),E_(t)},qP.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",this.leftButtonDown=!1,T_(document,"mousemove",this.onmousemove),T_(document,"mouseup",this.onmouseup),E_(t)},qP.prototype._onClick=function(t){if(this.onclick_callback||this.hasListeners("click")){if(this.moving)this.moving=!1;else{var e=this.frame.getBoundingClientRect(),r=HP(t)-e.left,n=$P(t)-e.top,i=this._dataPointFromXY(r,n);i&&(this.onclick_callback&&this.onclick_callback(i.point.data),this.emit("click",i.point.data))}E_(t)}},qP.prototype._onTooltip=function(t){var e=this.tooltipDelay,r=this.frame.getBoundingClientRect(),n=HP(t)-r.left,i=$P(t)-r.top;if(this.showTooltip)if(this.tooltipTimeout&&clearTimeout(this.tooltipTimeout),this.leftButtonDown)this._hideTooltip();else if(this.tooltip&&this.tooltip.dataPoint){var o=this._dataPointFromXY(n,i);o!==this.tooltip.dataPoint&&(o?this._showTooltip(o):this._hideTooltip())}else{var a=this;this.tooltipTimeout=Pp((function(){a.tooltipTimeout=null;var t=a._dataPointFromXY(n,i);t&&a._showTooltip(t)}),e)}},qP.prototype._onTouchStart=function(t){this.touchDown=!0;var e=this;this.ontouchmove=function(t){e._onTouchMove(t)},this.ontouchend=function(t){e._onTouchEnd(t)},S_(document,"touchmove",e.ontouchmove),S_(document,"touchend",e.ontouchend),this._onMouseDown(t)},qP.prototype._onTouchMove=function(t){this._onMouseMove(t)},qP.prototype._onTouchEnd=function(t){this.touchDown=!1,T_(document,"touchmove",this.ontouchmove),T_(document,"touchend",this.ontouchend),this._onMouseUp(t)},qP.prototype._onWheel=function(t){if(t||(t=window.event),this.zoomable&&(!this.ctrlToZoom||t.ctrlKey)){var e=0;if(t.wheelDelta?e=t.wheelDelta/120:t.detail&&(e=-t.detail/3),e){var r=this.camera.getArmLength()*(1-e/10);this.camera.setArmLength(r),this.redraw(),this._hideTooltip()}var n=this.getCameraPosition();this.emit("cameraPositionChange",n),E_(t)}},qP.prototype._insideTriangle=function(t,e){var r=e[0],n=e[1],i=e[2];function o(t){return t>0?1:t<0?-1:0}var a=o((n.x-r.x)*(t.y-r.y)-(n.y-r.y)*(t.x-r.x)),s=o((i.x-n.x)*(t.y-n.y)-(i.y-n.y)*(t.x-n.x)),u=o((r.x-i.x)*(t.y-i.y)-(r.y-i.y)*(t.x-i.x));return!(0!=a&&0!=s&&a!=s||0!=s&&0!=u&&s!=u||0!=a&&0!=u&&a!=u)},qP.prototype._dataPointFromXY=function(t,e){var r,n=new I_(t,e),i=null,o=null,a=null;if(this.style===qP.STYLE.BAR||this.style===qP.STYLE.BARCOLOR||this.style===qP.STYLE.BARSIZE)for(r=this.dataPoints.length-1;r>=0;r--){var s=(i=this.dataPoints[r]).surfaces;if(s)for(var u=s.length-1;u>=0;u--){var c=s[u].corners,l=[c[0].screen,c[1].screen,c[2].screen],h=[c[2].screen,c[3].screen,c[0].screen];if(this._insideTriangle(n,l)||this._insideTriangle(n,h))return i}}else for(r=0;r<this.dataPoints.length;r++){var f=(i=this.dataPoints[r]).screen;if(f){var p=Math.abs(t-f.x),d=Math.abs(e-f.y),v=Math.sqrt(p*p+d*d);(null===a||v<a)&&v<100&&(a=v,o=i)}}return o},qP.prototype.hasBars=function(t){return t==qP.STYLE.BAR||t==qP.STYLE.BARCOLOR||t==qP.STYLE.BARSIZE},qP.prototype._showTooltip=function(t){var e,r,n;this.tooltip?(e=this.tooltip.dom.content,r=this.tooltip.dom.line,n=this.tooltip.dom.dot):(e=document.createElement("div"),Hp(e.style,{},this.tooltipStyle.content),e.style.position="absolute",r=document.createElement("div"),Hp(r.style,{},this.tooltipStyle.line),r.style.position="absolute",n=document.createElement("div"),Hp(n.style,{},this.tooltipStyle.dot),n.style.position="absolute",this.tooltip={dataPoint:null,dom:{content:e,line:r,dot:n}}),this._hideTooltip(),this.tooltip.dataPoint=t,"function"==typeof this.showTooltip?e.innerHTML=this.showTooltip(t.point):e.innerHTML="<table><tr><td>"+this.xLabel+":</td><td>"+t.point.x+"</td></tr><tr><td>"+this.yLabel+":</td><td>"+t.point.y+"</td></tr><tr><td>"+this.zLabel+":</td><td>"+t.point.z+"</td></tr></table>",e.style.left="0",e.style.top="0",this.frame.appendChild(e),this.frame.appendChild(r),this.frame.appendChild(n);var i=e.offsetWidth,o=e.offsetHeight,a=r.offsetHeight,s=n.offsetWidth,u=n.offsetHeight,c=t.screen.x-i/2;c=Math.min(Math.max(c,10),this.frame.clientWidth-10-i),r.style.left=t.screen.x+"px",r.style.top=t.screen.y-a+"px",e.style.left=c+"px",e.style.top=t.screen.y-a-o+"px",n.style.left=t.screen.x-s/2+"px",n.style.top=t.screen.y-u/2+"px"},qP.prototype._hideTooltip=function(){if(this.tooltip)for(var t in this.tooltip.dataPoint=null,this.tooltip.dom)if(Object.prototype.hasOwnProperty.call(this.tooltip.dom,t)){var e=this.tooltip.dom[t];e&&e.parentNode&&e.parentNode.removeChild(e)}},qP.prototype.setCameraPosition=function(t){rS(t,this),this.redraw()},qP.prototype.setSize=function(t,e){this._setSize(t,e),this.redraw()},t.DELETE=h_,t.DataSet=BP,t.DataStream=NP,t.DataView=WP,t.Graph3d=qP,t.Graph3dCamera=G_,t.Graph3dFilter=VP,t.Graph3dPoint2d=I_,t.Graph3dPoint3d=R_,t.Graph3dSlider=j_,t.Graph3dStepNumber=F_,t.Queue=zP,t.createNewDataPipeFrom=function(t){return new IP(t)},t.isDataSetLike=YP,t.isDataViewLike=function(t,e){return"object"===El(e)&&null!==e&&t===e.idProp&&"function"==typeof Uf(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof cg(e)&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.stream&&YP(t,e.getDataSet())}}));
//# sourceMappingURL=vis-graph3d.min.js.map
